--[[
	Este LUA de API es del sistema tiene que estar siempre por cada Widget.
	Debe definir siempre la funcion Initialize.
	La misma se utiliza cuando se esta haciendo el Load del iFrame (iniciado el Widget).
	Su implementacion NO es obligatoria, pero si no se implementa debe retornar una tabla vacia.
]]--

local m_moduleLocation = select(2, ...)
local _, m_widgetId = m_moduleLocation:match("(.*/)(.*)") -- sample
module(..., package.seeall)

LogInfo("[INTEGRATIONS.%s.api] Starting API Module .... ", m_widgetId)

--[[
	Requerida.
	Siempre debe retornar una tabla.
	Su implementacion NO es obligatoria.

	Los datos que se retornen aca llegaran al lado del cliente (JavaScript) y quedaran disponibles en el objeto: "window.occIntegrations.initialData.widgetExtraData"

	Ejemplo aca podriamos obtener cierta inforamcion y retornarla hacia el lado del cliente.
]]--
local function Initialize (urlParameters)
	LogInfo("[INTEGRATIONS.%s.api] Initialize API . urlParameters: %s.", m_widgetId, urlParameters)

	local initialData = {
		dataEjemplo1 = "nombre1111",
		otrosEjemplos = {
			name = "nombre1111",
			list1 = {
				{number = 1},
				{number = 2}
			},
			list2 = {
				{number = 1},
				{number = 2}
			}
		}
	}

	return initialData
end

return {
	Initialize = Initialize
}
