local ir = require "lua_iragentlink"
local utils = require "shared.apps.utils"
local api_utils = require "api.utils"
require "uuid"
local repositoryController = require("apps.repository")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local function Start (web, request)
	request.head.to = {}
	table.insert(request.head.to, request.account_name)
	request.head.fromName = request.head.fromName ~= "" and request.head.fromName or request.head.fromEMail
	request.head.cc = request.head.cc or {}
	request.head.bcc = {}
	request.head.emailHeader = ""
	request.head.date = ""
	request.head.Id = request.interactionId .. request.account
	local content = "[{\"type\":\"text/html\",\"content\":\"" .. request.body .. "\"}]"
	local body = {
		content_type="text/html", 
		content=content
	}	
	
	--send to ir
	local vcc = inconcert.authUser.virtualContactCenter
	local campaignAtVCC = utils.AppendVcc(request.campaign, vcc)
	local irLink = ir.IRAgentLink(inconcert.environment.apps.agent.cluster)
	local result = irLink:NewMail({
		interactionID	= request.interactionId,
		account			= request.account,
		campaignAtVCC	= campaignAtVCC,
		head			= request.head,
		body			= body,
		attachments		= request.attachments
	})
	local status, reason = api_utils.getHttpStatus(result)
	if status ~= 200 then
		LogError("[API:mail:Start] %s - %s", json.encode(request), reason)
		if web.request and web.request.attachments and #web.request.attachments > 0 then
			repositoryController.deleteMultipleFiles(web.request.attachments)
		end
		return api_utils.replyError(web, status, reason)
	end
	LogInfo("[API:mail:Start] %s - started with interactionId %s", json.encode(request), request.interactionId)
	return api_utils.replyOk(web, { interactionId = interactionId })
end


--[[----------------------------------------------------------------------
	Mapeo de funciones que quedan disponibles en módulo para luego ser utilizadas en el mapeo de funciones con las urls (/definition/ARCHIVO.lua función "urlLinkedFunction")
--------------------------------------------------------------------------]]
_M.Start = Start
-------------------------------------------------------------------------

function MapUris (m, authFilter, prefix)
	local f = authFilter
	local p = prefix
	local Log = require("apps.agent.requestFilters").LogRequest
	local jsonValidator = utils.JsonValidator
	local vr = utils.JsonValidatorReply
	local r = utils.JsonReply
	-- mapeo de URLs dinamicas (definidas en \api\definition\full.lua)
	local replyPostFn = Log .. f .. vr
	--local replyGetFn = Log .. f .. r
	local apiType = "mail"
	api_utils:MapDynamicURIs(apiType, m, _M, replyPostFn, nil, function(web, success)
		LogInfo("[API.mail:MapUris] callback ...")
		if success then
			return
		end
		-- error
		if web.request and web.request.attachments and #web.request.attachments > 0 then
			repositoryController.deleteMultipleFiles(web.request.attachments)
		end
	end)
	--
	m_htmlRender = htmlRender
end
