local ir = require "lua_iragentlink"
local utils = require "shared.apps.utils"
local api_utils = require "api.utils"
require "uuid"

module(..., package.seeall, inconcert.orbit.application.Decorate)

local function Start (web, request)
	local data = {
		contact = request.contact,
		__SID = request.reportingGroup,
		data = {
			api = {
				__SID = request.reportingGroup,
				fields = request.reportingData
			},
			contactform = {
				__SID = request.reportingGroup,
				fields = request.agentData
			}
		}
	}
	
	--send to ir
	local vcc = inconcert.authUser.virtualContactCenter
	local campaignAtVCC = utils.AppendVcc(request.campaign, vcc)
	local irLink = ir.IRAgentLink(inconcert.environment.apps.agent.cluster)
	local result = irLink:NewWebContact({
		campaignAtVCC	= campaignAtVCC,
		account			= request.account,
		interactionID	= request.interactionId,
		data			= data,
	})
	local status, reason = api_utils.getHttpStatus(result)
	if status ~= 200 then
		LogError("[API:webcontact:Start] %s - %s", json.encode(request), reason)
		return api_utils.replyError(web, status, reason)
	end
	LogInfo("[API:webcontact:Start] %s - started with interactionId %s", json.encode(request), request.interactionId)
	return api_utils.replyOk(web, { interactionId = interactionId })
end

--[[----------------------------------------------------------------------
	Mapeo de funciones que quedan disponibles en módulo para luego ser utilizadas en el mapeo de funciones con las urls (/definition/ARCHIVO.lua función "urlLinkedFunction")
--------------------------------------------------------------------------]]
_M.Start = Start
-------------------------------------------------------------------------

function MapUris (m, authFilter, prefix)
	local f = authFilter
	local p = prefix
	local Log = require("apps.agent.requestFilters").LogRequest
	local jsonValidator = utils.JsonValidator
	local vr = utils.JsonValidatorReply
	local r = utils.JsonReply
	-- mapeo de URLs dinamicas (definidas en \api\definition\full.lua)
	local replyPostFn = Log .. f .. vr
	--local replyGetFn = Log .. f .. r
	local apiType = "webcontact"
	api_utils:MapDynamicURIs(apiType, m, _M, replyPostFn)
	--
	m_htmlRender = htmlRender
end
