module((...), package.seeall)

--[[
	Aca definimos todos los tipos (interaction, user, vcc, etc) que incluirá el API.
	el valor del atributo "id" debe existir y coincidir con el nombre del archivo en "/definition/NOMBRE DE ARCHIVO.LUA"
]]-- 
local m_apiFullDefinition = {
	info = {
	
	},
	items = {
		{
			id = "batch_management", -- "/definition/batch_management.LUA"
			definition = {}
		},
		{
			id = "campaigns",
			definition = {}
		},
		{
			id = "groups",
			definition = {}
		},
		{
			id = "interactions",
			definition = {}
		},
		{
			id = "mail",
			definition = {}
		},
		{
			id = "reports",
			definition = {}
		},
		{
			id = "repository",
			definition = {}
		},
		{
			id = "users",
			definition = {}
		},
		{
			id = "vcc",
			definition = {}
		},
		{
			id = "webcontact",
			definition = {}
		},
		{
			id = "whatsapp",
			definition = {}
		},
		{
			id = "outbound_engine_process",
			definition = {}
		},
		{
			id = "outbound_engine_batch",
			definition = {}
		},
		{
			id = "outbound_engine_contact",
			definition = {}
		},
	}
}

local function Load ()
	for _, item in ipairs(m_apiFullDefinition.items) do
		local moduleName = "api.definition." .. item.id
		--LogDebug("-> moduleName: '%s'", moduleName)
		local module = require(moduleName)
		--LogDebug("-> module: '%s'", module)
		local apiTypeDefintion = module.Get()
		item.definition = apiTypeDefintion
	end
end
Load()

function GetFullApi ()
	local apiFullDefinition = m_apiFullDefinition
	return apiFullDefinition
end

function GetApiType (apiType)
	assert(type(apiType) == "string", "Invalid API Type " .. type(apiType))
	apiType = apiType:lower()
	local apiFullDefinition = GetFullApi()
	local apiTypeDefintion
	for _, def in ipairs(apiFullDefinition.items) do
		if def.id == apiType then
			apiTypeDefintion = def
			break
		end
	end
	assert(apiTypeDefintion, string.format("API type %s definition does not exist", apiType))
	return apiTypeDefintion
end

function GetJson (apiType)
	local apiFullDefinition = GetFullApi()
	return json.encode(apiFullDefinition)
end