local api_utils = require "api.utils"

module((...), package.seeall)

local m_apiDefaultConfig = api_utils.GetApiURLsDefaultConfig()
local entityType = "groups"
local baseUri = string.format("/%s/", entityType)

local m_apiDefinition = {
	info = {
		name = entityType
	},
	items = {
		{
		--[[
		Get Group Export Information
		url: /groups/get_export_info/ 
		method: GET
			]]--
			entityType = entityType,
			id = "8ad0e250-8f71-4e65-80b9-bf838db73980",
			name = "GetGroupsExportInfo",
			description = "Get Groups Export Information",
			url = baseUri .. "get_export_info/",
			method = "GET",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.read,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "low", -- low, medium_light, medium, high
				urlLinkedFunction = "GetGroupsExportInfo"
			}
		},
	}
}

------------------------------------------------
--[[
	Get Group Permission NNNNNNNNNNNNN
		url: /groups/get/ 
		method: GET
]]--
local definition =	{
	entityType = entityType,
	id = "8ad0e250-8f71-4e65-80b9-bf838db73979",
	name = "GetGroupPermission",
	description = "Get group permissions definitions",
	url = baseUri .. "get/(.+)",
	method = "GET",
	header = {
		Authorization = "....",
		["Content-Type"] = "application/json"
	},
	body = {},
	response = {},
	responseErrors = {},
	config = {
		urlLinkedFunction = "Get",
		permission = m_apiDefaultConfig.permissions.read,
		rateLimits = api_utils.GetApiURLRateLimit,
		resourceType = "low", -- low, medium_light, medium, high
		filters    = api_utils.GetApiURLFilters,
		paged      = api_utils.GetApiURLPaged
	}
}

table.insert(m_apiDefinition.items, definition)
------------------------------------------------


function Get ()
	local m_apiDefinition = m_apiDefinition
	return m_apiDefinition
end