local api_utils = require "api.utils"

module((...), package.seeall)

local m_apiDefaultConfig = api_utils.GetApiURLsDefaultConfig()
local entityType = "outbound_engine_process"
local baseUri = "/outbound_engine/process/"

local m_apiDefinition = {
	info = {
		name = entityType
	},
	items = {

		--[[
			Get Process
				url: /outbound_engine/process/get/processid@vcc
				method: GET
		]]--
		{
			entityType = entityType,
			id = "fc06c65d-c96b-4b25-ab35-f45fa67d641f",
			name = "GetProcess",
			description = "Get Process Information",
			url = baseUri .. "get/(.+)",
			method = "GET",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.read,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "low", -- low, medium_light, medium, high
				urlLinkedFunction = "Get"
			}
		},


		--[[
			Start Process
				url: /outbound_engine/process/start/processid@vcc
				method: POST
		]]--
		{
			entityType = entityType,
			id = "294351a3-2f2c-4250-a3c5-8bf54b70afed",
			name = "StartProcess",
			description = "Start a process",
			url = baseUri .. "start/(.+)",
			method = "POST",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.write,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "medium", -- low, medium_light, medium, high
				urlLinkedFunction = "Start"
			}
		},


		--[[
			Stop Process
				url: /outbound_engine/process/stop/processid@vcc
				method: POST
		]]--
		{
			entityType = entityType,
			id = "fe312217-7c33-445b-810c-851d03092c5e",
			name = "StopProcess",
			description = "Stop a process",
			url = baseUri .. "stop/(.+)",
			method = "POST",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.write,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "medium", -- low, medium_light, medium, high
				urlLinkedFunction = "Stop"
			}
		},
	}
}

-- ---------------------------------------------

function Get ()
	local m_apiDefinition = m_apiDefinition
	return m_apiDefinition
end