local api_utils = require "api.utils"

module((...), package.seeall)

local m_apiDefaultConfig = api_utils.GetApiURLsDefaultConfig()
local entityType = "vcc"
local baseUri = string.format("/%s/", entityType)

local m_apiDefinition = {
	info = {
		name = entityType
	},
	items = {
		{
			entityType = entityType,
			id = "GetStates",
			name = "GetStates",
			description = "Get States by Vcc",
			url = baseUri .. "get/states/",
			method = "GET",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.read,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "low", -- low, medium_light, medium, high
				urlLinkedFunction = "GetStates"
			}
		},
		{
			entityType = entityType,
			id = "GetChannels",
			name = "GetChannels",
			description = "Get Channels by Vcc",
			url = baseUri .. "get/channels/",
			method = "GET",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.read,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "low", -- low, medium_light, medium, high
				urlLinkedFunction = "GetChannels"
			}
		},
		{
			entityType = entityType,
			id = "GetAvailableAgents",
			name = "GetAvailableAgents",
			description = "Get available agents by Vcc & Campaign",
			url = baseUri .. "get/available_agents/",
			method = "GET",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.read,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "high", -- low, medium_light, medium, high
				urlLinkedFunction = "GetAvailableAgents"
			}
		}
	}
}

------------------------------------------------
--[[
	Get VCC NNNNNNNNNNNNN
		url: /vcc/get/ 
		method: GET
]]--
local definition = {
	entityType = entityType,
	id = "6b07454b-7db7-4031-a353-9f53dd50caa4",
	name = "LoadCurrentVcc",
	description = "Load Current Vcc Information",
	url = baseUri .. "get/",
	method = "GET",
		header = {
		Authorization = "....",
		["Content-Type"] = "application/json"
	},
	body = {},
	response = {},
	responseErrors = {},
	config = {
		resourceType = "low", -- low, medium_light, medium, high
		urlLinkedFunction = "Get",
		permission = m_apiDefaultConfig.permissions.read,
		rateLimits = api_utils.GetApiURLRateLimit
	}
}

table.insert(m_apiDefinition.items, definition)
------------------------------------------------

function Get ()
	local m_apiDefinition = m_apiDefinition
	return m_apiDefinition
end
