module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_helpers = require "helpers"
local m_datasource

function GetName()
	return "Databases"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function GetDatabases (databaseId, keyspace, vcc)
	local databases = utils.GetAllColumns({
		keyspace = keyspace or "Agent",
		columnFamily = "Databases",
		startKey = databaseId or "",
		endKey = databaseId or "",
	}) or {}
	--LogInfo("[ADMINISTRATION.DATABASES:GetDatabases] vcc %s, databaseId %s, databases %s",vcc,databaseId, json.encode(databases))

	if databaseId then
		return databases[databaseId] and next(databases[databaseId]) and databases[databaseId] or {}
	end
	local retDatabases = {}
	for dbId, database in pairs(databases) do
		if next(database) then
			if vcc then
				local split = m_helpers.utils.SplitString(dbId, "_")
				if #split > 0 and  split[1] == vcc then
					retDatabases[database.Id] = database
				end
			else
				retDatabases[dbId] = database
			end
		end
	end
	
	--LogInfo("[ADMINISTRATION.DATABASES:GetDatabases] retDatabases %s", json.encode(retDatabases))

	return retDatabases
end

function SaveDatabase (databases, keyspace)
	utils.SaveRows {
		keyspace = keyspace or "Agent",
		columnFamily = "Databases",
		rows = databases
	}
end

function DeleteDatabase (databases, keyspace)

	utils.RemoveColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "Databases",
		rows = databases
	}
end