module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName ()
	return "Packages"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

local function GetDatasource()
	if m_datasource then
		return m_datasource
	end
	local connections = utils.GetConnections()
	return connections
end

function GetPackage ( package_id, ks_provisioning )
	local package = utils.GetAllColumns {
		keyspace = ks_provisioning or "Provisioning",
		columnFamily = "Packages",
		key = package_id
	}
	if package then
		package.id = package_id
	end

	return package
end

function GetPackages (vcc, interaction_type, ks_provisioning)
	local packages = {}
	local key = "VCC:" .. vcc

	local release = false
	if not ks_provisioning then
		ks_provisioning = GetDatasource().cassandra:CassandraConnection("Provisioning")
		release = true
	end

	local vcc_packages = utils.GetAllColumns {
		keyspace = ks_provisioning,
		columnFamily = "VCCPackages",
		key = key
	}

	if vcc_packages then
		for package_id, packageCampaigns in pairs( vcc_packages ) do
			packages[package_id] = GetPackage(package_id, ks_provisioning)
			packages[package_id].campaigns = packageCampaigns
		end
	end

	if release then
		ks_provisioning:Close()
	end

	return packages
end

