/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global $, inConcert, XSLTProcessor*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// Grammars Management
	function AdminAsrGrammarsMng(params)
	{
		if (!params) {
			throw("AdminAsrGrammarsMng - 'params' is required");
		}
		if (!params.owner) {
			throw("AdminAsrGrammarsMng - 'params.owner' is required");
		}
		if (!params.prefix) {
			throw("AdminAsrGrammarsMng - 'params.prefix' is required");
		}
		if (!params.container_id) {
			throw("AdminAsrGrammarsMng - 'params.container_id' is required");
		}

		this.owner = params.owner;
		this.owner_name = params.owner_name || "";
		this.prefix = params.prefix + "_";
		this.container_id = params.container_id;

		this.m_grid_grammars = null;

		return true;
	}

	if (typeof inConcert.AdminAsrGrammarsMng !== "function") {
		inConcert.AdminAsrGrammarsMng = AdminAsrGrammarsMng;
	}

	AdminAsrGrammarsMng.prototype.initialize = function()
	{
		this.__make_popup_html();
		this.__init_grammars();
		this.__init_grid();
	};

	AdminAsrGrammarsMng.prototype.get_grid_dom_id = function()
	{
		return this.prefix + "list";
	};

	AdminAsrGrammarsMng.prototype.__make_popup_html = function()
	{
		let html = '' +
		'<div id="' + this.prefix + 'new_container">' +
			'<div class="row">' + 
				'<div class="col-12">' +
					'<div class="card-header d-flex flex-row justify-content-between">' +
						'<h5>' + "<%=_T([[Grammar Configuration]])%>" + 
						' <span class="fa fa-question-circle" title="' + "<%=_T([[You can configure grammars for an ASR or TTS/ASR Provider Type Profile.]])%>" + '"></span>' + 
						' <i id="' + this.prefix + 'new_list_validation" class="formFieldValidation formFieldError" hidden></i>' +
						'</h5>' +
						'<button id="' + this.prefix + 'new" class="pageButtonGeneric buttonColorWhite pageButtonNew mt-1 mb-4">' +
							'<i class="far fa-plus"></i>' +
							"<%=_T([[Add Grammar]])%>" +
						'</button>' +
					'</div>' +
				'</div>' +
			'</div>' +
		'</div>' +
		'<div id="' + this.prefix + 'container" class="row">' +
			'<div class="col-12">' +
				'<div id="' + this.prefix + 'not_results_found" class="inlineMessagesContainer messageInfo mt-0" style="display:none"></div>' +
				'<table id="' + this.get_grid_dom_id() + '" cellpadding="0" cellspacing="0" border="0" class="viewGrid mt-0 mb-3">' +
					'<thead class="viewGridHeader"></thead>' +
					'<tbody class="viewGridBody"></tbody>' +
				'</table>' +
				'<div class="mb-2" id="' + this.prefix + 'paginator"></div>' +
			'</div>' +
		'</div>' +
		'<hr />' +
		// popup
		'<div id="' + this.prefix + 'popup" class="internalPopUpContainer formPopUp popUp720w" style="display:none;">' +
			'<div class="internalPopUpOverlay"></div>' +
			'<div class="internalPopUp">' +

				// waiting
				'<div id="' + this.prefix + 'popup_waiting" class="popupWaitingContainer" style="display:none;">' +
					'<div waiting_message="true" class="popupWaitingMessage"></div>' +
					'<div class="popupWaitingAnimation"></div>' +
					'<div class="popupWaitingOverlay"></div>' +
				'</div>' +

				// title
				'<div class="internalPopUpTitle">'+
					'<span id="' + this.prefix + 'popup_title"></span>'+
					'<button  id="' + this.prefix + 'popup_close_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>'+
				'</div>'+

				'<div class="internalPopUpMiddle pageFormContainer">' +
					// error
					'<div id="' + this.prefix + 'popup_message" class="genericFormMessagesContainer messageError" style="display:none;">' +
						'<label class="messageText"></label>' +
					'</div>' +

					'<div class="card">' +
						'<div class="card-block">' +
							'<div class="row">' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_grammar_id" class="required"><%=_T([[Id]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_grammar_id" class="form-control" type="text" placeholder="' + '<%=_T("Enter identifier")%>' + '..."></input>' +
										'<i id="' + this.prefix + 'popup_grammar_id_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_type" class="required"><%=_T([[Type]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_type" class="form-control" type="text" placeholder="' + '<%=_T("Enter type")%>' + '..."></input>' +
										'<i id="' + this.prefix + 'popup_type_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +		
								'</div>' +
							'</div>' +
							'<div class="row">' +
								'<div class="col-12">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_grammar" class="required"><%=_T([[Grammar]])%><%=_T([[:]])%></label>' +
										'<textarea id="' + this.prefix + 'popup_grammar" class="form-control rowsBased" rows="5"></textarea>' +
										'<i id="' + this.prefix + 'popup_grammar_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +	
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
				'</div>' +

				// MODAL FOOTER BUTTONS
				'<div class="internalPopUpButtons">' +
					'<button id="' + this.prefix + 'popup_create"  class="pageButtonGeneric buttonColorBlue float-right">' + "<%=_T([[Confirm]])%>" + '</button>' +
					'<button id="' + this.prefix + 'popup_create_and_continue"  class="pageButtonGeneric buttonColorBlue float-right">' + "<%=_T([[Confirm & continue]])%>" + '</button>' +
					'<button id="' + this.prefix + 'popup_close"  class="pageButtonGeneric buttonColorWhite float-right">' + "<%=_T([[Cancel]])%>" + '</button>' +
				'</div>' +
			'</div>' +
		'</div>';

		const $container = $("#" + this.container_id);
		$container.html(html);
	};

	AdminAsrGrammarsMng.prototype.__init_grid = function()
	{
		const self = this;
		
		var must_show_button = function(row)
		{
			let show = true;
			let values_to_exclude = {type: "builtin"}; // PREBUILT
			for (let name in values_to_exclude) {
				if (values_to_exclude.hasOwnProperty(name)) {
					let value = values_to_exclude[name];
					if (row[name] === value) {
						show = false;
						break;
					}
				}
			}
			return show;
		};
		
		this.m_grid_grammars = new inConcert.conf_form_paginator({
			owner: this.owner,
			frm: this.owner,
			row_id: "id",
			display_name: "id",
			rows_per_page: 10,
			show_at_least: 9,
			paginator_type: "ALL_ROWS_CLIENT_SIDE",
			without_paginator: false,
			loading_waiting_msg: "<%=_T('Please wait, loading Grammars ...')%>",
			canEdit: function(row) {
				return must_show_button(row);
			},
			ids: {
				paginator: this.prefix + "paginator",
				grid: this.get_grid_dom_id(),
				not_results_found: this.prefix + "not_results_found",
				container_new_btn: this.prefix + "new_container",
				new_item: this.prefix + "new",
			//popup0
				popup: this.prefix + "popup",
				popup_msg: this.prefix + "popup_message",
				popup_create: this.prefix + "popup_create",
				popup_create_and_continue: this.prefix + "popup_create_and_continue",
				popup_title: this.prefix + "popup_title",
				popup_close: this.prefix + "popup_close",
				popup_close_times: this.prefix + "popup_close_times",
				popup_input_id: this.prefix + "popup_question",
				popup_waiting: this.prefix + "popup_waiting"
			},
			strings: {
				not_results_found: "<%=_T('No Grammars found.')%>",
				can_remove       : "<%=_T('Do you want to delete Grammar: {0} ?')%>"
			},
			columns: [
				{id: "_number"           , name: "", type: "counter"                            },
				{id: "id"                , name: "<%=_T('Id')%>"                                },
				{id: "type"              , name: "<%=_T('Type')%>"                              },
				{id: "grammar"           , name: "<%=_T('Grammar')%>"                           },
				{
					id: "_action",
					name: "",
					system_action: {
						edit: {
							must_show: function(row) {
								return must_show_button(row);
							}
						},
						erase: {
							must_show: function(row) {
								return must_show_button(row);
							}
						}
					}
				}
			],
			callbacks: {
				save: function(callback, must_create_and_contiune, current_popup) {
					callback = callback || $.noop;
					self.add_or_update_row(callback, must_create_and_contiune, current_popup);
				},
				edit: function(row_data) {
					self.on_open_popup(row_data);
				},
				on_removed_row: function(/*row, callback = $.noop*/) {},
 				on_closed_popup: function() {
 					self.on_closed_popup();
 				}
			},
			validate: {
				required_msg: "<%=_T('Must add at least one Grammar.')%>",
				required: false
			}
		});
	};

	AdminAsrGrammarsMng.prototype.start_grid_validation = function()
	{
		let response = {
			success: true
		};
		let success = this.m_grid_grammars.start_validation().success;
		if (!success) {
			response.success = false;
			response.message = this.m_grid_grammars.get_validation_message_err("required");
		}
		return response;
	};

	AdminAsrGrammarsMng.prototype.on_closed_popup = function(/*current_popup*/)
	{
		this.m_is_new_grammar = null;
		this.m_current_grammar = null;
	};

	AdminAsrGrammarsMng.prototype.add_or_update_row = function(callback/*, _, current_popup*/)
	{
		callback = callback || $.noop;

		const self = this;

		this.validate_grammar_to_add_or_update(function(response)
		{
			if (!response.success) {
				callback(false);
				return;
			}
			let msg_response = {
				msg : "",
				type: "Info"
			};
	
			if (self.m_is_new_grammar) {
				msg_response.msg = "<%=_T('Grammar was successfully added.')%>";
				let must_add_many = false;
				callback(true, response.item, msg_response, must_add_many);
			}
			else {
				msg_response.msg = "<%=_T('Grammar was successfully updated.')%>";
				self.m_current_grammar = inConcert.Utils.cloneObject(response.item);
				callback(true, self.m_current_grammar, msg_response);
			}
	
			self.clean_up_controls_grammar();
		});
	};

	AdminAsrGrammarsMng.prototype.clean_up_controls_grammar = function()
	{
		const $grammar_id = $("#" + this.prefix + "popup_grammar_id");
		const $type = $("#" + this.prefix + "popup_type");
		const $grammar = $("#" + this.prefix + "popup_grammar");

		this.owner.readonly_control($grammar, false, true);

		$grammar_id.val("").focus();
		// clean 
		$type.val("custom");
		$grammar.val("");
	};

	AdminAsrGrammarsMng.prototype.on_open_popup = function(item)
	{
		const $title = $("#" + this.prefix + "popup_title");
		this.m_is_new_grammar = item ? false: true;
		this.m_current_grammar = item;

		this.clean_up_controls_grammar();

		const $grammar_id = $("#" + this.prefix + "popup_grammar_id");
		const $type = $("#" + this.prefix + "popup_type");
		const $grammar = $("#" + this.prefix + "popup_grammar");
	
		this.owner.readonly_control($type, true);
		
		if (this.m_is_new_grammar) {
			$title.text("<%=_T('New Custom Grammar')%>");
			this.owner.readonly_control($grammar_id, false);
			$type.val("custom");
			
			return;
		}
		// editando
		$title.text("<%=_T('Update Custom Grammar')%>");
		
		$grammar_id.val(item.id);
		$type.val(item.type);
		
		//Separamos las posibles grammars, separadas por coma, incluidas en item.grammar
		var grammarsArray = item.grammar.split(",");
		item.grammar = "";
		for (var i = 0; i < grammarsArray.length; i++) {
			if(grammarsArray[i].charAt(0) === "<"){	// Si es XML para mostrarlo lo 'embellecemos'
				grammarsArray[i] = prettifyXml(grammarsArray[i]);
			}
			if(item.grammar !== "") {
				item.grammar += ",";
			}
			item.grammar += grammarsArray[i];
		}
		
		$grammar.val(item.grammar);
		
		this.owner.readonly_control($grammar_id, true);
	};

	AdminAsrGrammarsMng.prototype.validate_grammar_to_add_or_update = function(callback = $.noop)
	{
		const self = this;

		this.hide_all_errors();
		let response = {success: false, $ctrl: null, item: null, msg: "<%=_T('Unable to Add Grammar.')%>"};

		let item = {};
		let is_new = false;
		if (this.m_current_grammar) {
			item = this.m_current_grammar;
		}
		else {
			is_new = true;
		}

		const $grammar_id = $("#" + this.prefix + "popup_grammar_id");
		let grammar_id = $grammar_id.val();

		const $type = $("#" + this.prefix + "popup_type");
		let type = $type.val();

		const $grammar = $("#" + this.prefix + "popup_grammar");
		let grammar = $grammar.val();

		let current_all_grammar = this.m_grid_grammars.get_items();
		let current_all_grammar_map = inConcert.Utils.arrayToMap(current_all_grammar || [],
			function(sch) {
				return sch;
			},
			function(sch) {
				// el ID
				return sch.id;
			}
		);
		
		let validation_result;
		
		if (is_new) {
			// GRAMMAR ID validation -----
			//
			// Required validation
			let validation_result = inConcert.Utils.validate(grammar_id, "required");
			if (!validation_result.success) {
				// valida que el grammar_id tenga al menos un caracter
				response.msg = "<%=_T('Id is required.')%>";
				response.$ctrl = $grammar_id;
				this.show_ctrl_err(response);
				return callback(response);
			}

			// Already exist id validation
			var show_already_id_error = function() {
				response.msg = "<%=_T('Grammar Id already exist.')%>";
				response.$ctrl = $grammar_id;
				self.show_ctrl_err(response);
				return response;
			};
			const already_id = current_all_grammar_map[grammar_id];
			if (already_id) {
				return callback(show_already_id_error());
			}
		}
		
		// TYPE validation -----
		//
		// Required validation
		validation_result = inConcert.Utils.validate(type, "required");
		if (!validation_result.success) {
			// valida que el type tenga al menos un caracter
			response.msg = "<%=_T('Type is required.')%>";
			response.$ctrl = $type;
			this.show_ctrl_err(response);
			return callback(response);
		}
		
		// GRAMMAR validation -----
		//
		// Required validation
		validation_result = inConcert.Utils.validate(grammar, "required");
		if (!validation_result.success) {
			// valida que el type tenga al menos un caracter
			response.msg = "<%=_T('Grammar is required.')%>";
			response.$ctrl = $grammar;
			this.show_ctrl_err(response);
			return callback(response);
		}
		
		//Al guardar eliminamos tabs y linebreaks, para que no se vea mal en la lista de grammars
		grammar = grammar.replace(/(\r\n|\n|\r|\t)/gm, "");
		if(grammar.charAt(0) === "<"){
			//Sustituimos la doble comilla por comilla simple, ya que en caso contrario el parser de UniMRCP da error_id
			grammar = grammar.replaceAll("\"", "'");
			//Separamos posibles grammars en cada grammar
			var grammarsArray = grammar.split(",");
			//Comprobamos que cada grammar sea un XML correcto
			for (var i = 0; i < grammarsArray.length; i++) {
				var xmlGrammar;
				try {
					xmlGrammar = $.parseXML(grammarsArray[i]);
				} catch (err) {
					response.msg = "<%=_T('XML Grammar is invalid.')%>";
					response.$ctrl = $grammar;
					self.show_ctrl_err(response);
					return callback(response);
				}
			}
		}
		
		const row_grammar = self.make_row_grammar(item, grammar_id, type, grammar);
		
		response.success = true;
		response.msg = "";
		response.item = row_grammar;

		callback(response);
	};

	AdminAsrGrammarsMng.prototype.hide_all_errors = function()
	{
		this.m_grid_grammars.hide_popup_msg();
	};

	AdminAsrGrammarsMng.prototype.show_ctrl_err = function(err_info)
	{
		if (!err_info) {
			return;
		}
		const $control = err_info.$ctrl;
		if ($control) {
			const error_id = $control.attr("id") + "_validation";
			const $error_indicator = $("#" + error_id);
			if ($error_indicator) {
				$error_indicator.show();
			}
			$control.focus();
		}
		this.m_grid_grammars.show_popup_msg(err_info.msg, "Error"); //, ERROR_TIMEOUT_MS);
	};

	AdminAsrGrammarsMng.prototype.dispose = function()
	{
		//TODO: implementar, si es necesario
	};

	AdminAsrGrammarsMng.prototype.make_row_grammar = function(current_row_item, grammar_id, type, grammar)
	{
		let row_item = current_row_item || {};

		row_item.id             = grammar_id;
		row_item.type           = type;
		row_item.grammar        = grammar;

		return row_item;
	};

	AdminAsrGrammarsMng.prototype.set = function(entity)
	{
		const self = this;
		let grammars_info = [];

		if (!entity || !(Array.isArray(entity.grammars) && entity.grammars.length)) {
			this.m_grid_grammars.initialize($.noop, grammars_info);
			return;
		}

		var add_grammar = function(grammar_id, type, grammar) {
			const row_grammar = self.make_row_grammar(null, grammar_id, type, grammar);
			grammars_info.push(row_grammar);
		};

		entity.grammars.forEach(grammar => add_grammar(grammar.id, grammar.type, grammar.grammar));
		
		this.m_grid_grammars.initialize($.noop, grammars_info);
	};

	AdminAsrGrammarsMng.prototype.empty_controls = function()
	{
		this.m_grid_grammars.remove_all_rows();
	};

	AdminAsrGrammarsMng.prototype.set_events = function()
	{
		this.m_grid_grammars.set_events();
	};

	AdminAsrGrammarsMng.prototype.popup_show_ctrl_err = function(_, $ctrl/*, $popup_msg*/)
	{
		if ($ctrl) {
			const error_id = $ctrl.attr("id") + "_validation";
			const $error_indicator = $("#" + error_id);
			if ($error_indicator) {
				$error_indicator.show();
			}
			$ctrl.focus();
		}
	};

	AdminAsrGrammarsMng.prototype.__init_grammars = function()
	{
		$("body").removeClass("popupDisplay").addClass("popupDisplay");
	};
	
	AdminAsrGrammarsMng.prototype.get = function()
	{
		return this.m_grid_grammars.get_items();
	};
	
	function prettifyXml(sourceXml)
	{
		const xmlDoc = new DOMParser().parseFromString(sourceXml, 'application/xml');
		const xsltDoc = new DOMParser().parseFromString([
			// describes how we want to modify the XML - indent everything
			'<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform">',
			'  <xsl:strip-space elements="*"/>',
			'  <xsl:template match="para[content-style][not(text())]">', // change to just text() to strip space in text nodes
			'    <xsl:value-of select="normalize-space(.)"/>',
			'  </xsl:template>',
			'  <xsl:template match="node()|@*">',
			'    <xsl:copy><xsl:apply-templates select="node()|@*"/></xsl:copy>',
			'  </xsl:template>',
			'  <xsl:output indent="yes"/>',
			'</xsl:stylesheet>',
		].join('\n'), 'application/xml');

		const xsltProcessor = new XSLTProcessor();
		xsltProcessor.importStylesheet(xsltDoc);
		const resultDoc = xsltProcessor.transformToDocument(xmlDoc);
		return '<?xml version="' + xmlDoc.xmlVersion + '"?>\n' + new XMLSerializer().serializeToString(resultDoc);
	}

}());
