/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */
/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

//	"use strict";

	//---------------------------------------------------------------------
	// form audit class
	function adm_form_audit( params )
	{
		let success = adm_form_audit.uber.constructor.call(this, params);
		if ( !success ) {
			return;
		}
		this.view_title     = "<%=_T('Audit')%>";
		this.update_title   = "<%=_T('Audit')%>";
		this.html_file_name = "/inconcert/apps/administration/audit/frm/render/";
		return true;
	}

	inConcert.Utils.inherit( adm_form_audit, inConcert.conf_form );

	if ( typeof inConcert.adm_form_audit !== "function" ) {
		inConcert.adm_form_audit = adm_form_audit;
	}

	adm_form_audit.prototype.set = function(success, row)
	{
		if (!success) {
			return;
		}
		const beforeFields = row.beforeFields || {};
		const currentFields = row.currentFields || {};

		/* global jsondiffpatch */
		const instanceJsonDiff = jsondiffpatch.create({
				arrays: {
					includeValueOnMove:true,
					detectMove:true
				}
  			});

		var delta = instanceJsonDiff.diff(beforeFields, currentFields);
          
		// beautiful html diff
		let jsonHtmlDiff = jsondiffpatch.formatters.html.format(delta, beforeFields);
		$("#adm_form_audit_diff_before").html(jsonHtmlDiff);
		$("#adm_form_audit_diff_after").html(jsonHtmlDiff);
		jsondiffpatch.formatters.html.hideUnchanged();
	};

	adm_form_audit.prototype.build_header_custom_buttons = function(){
		const html_buttons = "<button id='adm_form_audit_back_to_list_btn' class='butBackToDashboardArrow btnDropdownStates'><i class='fas fa-chevron-left'></i></button>";
		adm_form_audit.uber.build_header_custom_buttons.call(this, html_buttons);
		this.show_custom_actions();
		this.hide_header_system_actions();
	};

	adm_form_audit.prototype.set_events = function()
	{
		const self = this;
		const $buttons_custom_actions = this.dashboard.$get_dom_element_by_id("form_custom_buttons");
		let event_selector = "[id='adm_form_audit_back_to_list_btn']";
		$buttons_custom_actions
			.off("click", event_selector)
			.on("click", event_selector, function() {
				self.hide_custom_actions();
				self.show_header_system_actions();
				self.close();
			});
	};
}());
