/*  jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	const format = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// form campaigns class - canned messages section
	function adm_form_campaigns_section_canned_messages(params)
	{
		const self = this;
		const success = adm_form_campaigns_section_canned_messages.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.view_action_id    = "view_campaigns_canned";  // view action id de permisos
		this.save_action_id    = "save_campaign_canned";   // save action id de permisos
		this.erase_action_id   = "delete_campaign_canned"; // delete action id de permisos
		this.has_perm_to_save  = null;
		this.has_perm_to_erase = null;

		// selectors - row
		this.selector_row_name    = "td[col_info] > div label[col_name]";
		this.selector_row_group   = "td[col_info] > div label[col_group]";
		this.selector_row_format  = "td[col_info] > div label[col_format]";
		this.selector_row_message = "td[col_info] div label[col_message]";

		this.$row_editing = null; // Aca se encuentra el row html de jquery que se esta editando
		// aca se mantiene la lista de grupos existentes, con los ids de canneds.
		// la misma es utilizada para actualizar la table (html). Cuando un grupo cambia de nombre, etc
		/*
		 *     this.canned_groups = {
		 *        "grupo1": {"id1": true, "id2": true},
		 *        "grupo2": {"id3": true, "id4": true},
		 *      };
		 */
		this.canned_groups       = {}; // todos los canneds agrupados por type     (utilizado para la busqueda de grupos y para la carga del cbo)
		this.all_canned_messages = {}; // todos los canneds messages de la campana (utilizado para la busqueda general)
		this.canned_list_to_save = {}; // los added/updated canneds que se agregan en el popup y se deben guardar al cerrar el mismo. TODO: Cambiar !! feo muy feo, pero de momento no encontre otra forma para hacerlo rapido y sin romper todo lo que esta armado.

		// El tipo de formato en el cual se puede insertar el Canned (html/textplain).
		this.m_format_list = {
			["HTML"]      : {id: "HTML"      , desc: "<%=_T('Format HTML')%>"},
			["TEXT PLAIN"]: {id: "TEXT PLAIN", desc: "<%=_T('Text Plain')%>" }
		};
		// DOM IDs
		this.dom_id_plain_msg_container = "adm_form_campaign_canned_messages_popup_plain_msg_container";
		this.dom_id_plain_msg           = "adm_form_campaign_canned_messages_popup_plain_msg";
		this.dom_id_html_msg_container  = "adm_form_campaign_canned_messages_popup_html_msg_container";
		this.dom_id_html_msg            = "adm_form_campaign_canned_messages_popup_html_msg";
		// MAIL insance
		let owner = {
			show_status_message: function(message) {
				const $message = $("#" + self.dom_id_html_msg);
				self.show_error_validation_message(message, $message);
			},
			is_readonly: function() {
				return false;
			}
		};
		this.html_editor = new inConcert.MailManagement({
			owner: owner,
			auto_init: false,
			ids: {
				body     : this.dom_id_html_msg,
				container: this.dom_id_html_msg_container
			}
		});

		this.m_messageTimeout = null;
		return true;
	}

	inConcert.Utils.inherit( adm_form_campaigns_section_canned_messages, inConcert.conf_form_section );

	if (typeof inConcert.adm_form_campaigns_section_canned_messages !== 'function') {
		inConcert.adm_form_campaigns_section_canned_messages = adm_form_campaigns_section_canned_messages;
	}

	adm_form_campaigns_section_canned_messages.prototype.dispose = function()
	{
		this.has_perm_to_save  = null;
		this.has_perm_to_erase = null;
	};

	// Alta en el hash de todos los canneds
	adm_form_campaigns_section_canned_messages.prototype.add_canned_to_full_list = function(canned_id, canned)
	{
		this.all_canned_messages[canned_id] = canned;
	};

	// Actualiza en el hash de todos los canneds
	adm_form_campaigns_section_canned_messages.prototype.update_canned_on_full_list = function(canned_id, canned)
	{
		if (!this.all_canned_messages.hasOwnProperty(canned_id)) {
			return;
		}
		this.all_canned_messages[canned_id] = canned;
	};

	// Baja en el hash todos los canneds
	adm_form_campaigns_section_canned_messages.prototype.erase_canned_on_full_list = function(canned_id)
	{
		if (!this.all_canned_messages.hasOwnProperty(canned_id)) {
			return;
		}
		delete this.all_canned_messages[canned_id];
	};

	adm_form_campaigns_section_canned_messages.prototype.get_canned_from_full_list = function(canned_id)
	{
		if (!canned_id) {
			return {};
		}
		return this.all_canned_messages[canned_id];
	};

	// Alta en el hash canned agrupados x categoria
	adm_form_campaigns_section_canned_messages.prototype.add_grouped_canned_list = function(group, canned_id)
	{
		group = (group || "").toLowerCase();
		this.canned_groups[group] = this.canned_groups[group] || {};
		if (canned_id) {
			this.canned_groups[group][canned_id] = true;
		}
	};

	// Baja en el hash canned agrupados x categoria
	adm_form_campaigns_section_canned_messages.prototype.erase_grouped_canned_list = function(group, canned_id)
	{
		group = (group || "").toLowerCase();
		if (!this.canned_groups.hasOwnProperty(group)) {
			return;
		}
		if (!this.canned_groups[group].hasOwnProperty(canned_id)) {
			return;
		}
		delete this.canned_groups[group][canned_id];
	};

	// Alta en el hash canned que se han modificado en el popup y se enviaran a guardar al server.
	adm_form_campaigns_section_canned_messages.prototype.update_canned_list_to_save = function( canned, is_new)
	{
		this.canned_list_to_save = this.canned_list_to_save || {};
		this.canned_list_to_save[canned.canned_id] = { is_new: is_new || false, canned: canned };
	};

	// Vacia el hash que mantiene la lista de canneds a guardar en el server.
	adm_form_campaigns_section_canned_messages.prototype.empty_canned_list_to_save = function()
	{
		this.canned_list_to_save = {};
	};

	// Valida si el hash de canneds a guardar se encuentra vacio.
	adm_form_campaigns_section_canned_messages.prototype.is_empty_canned_list_to_save = function()
	{
		return $.isEmptyObject(this.canned_list_to_save);
	};

	// Valida si el hash de canneds a guardar se encuentra vacio.
	adm_form_campaigns_section_canned_messages.prototype.$get_row = function(canned_id)
	{
		if ( typeof canned_id !== "string" ) {
			canned_id = "";
		}
		return $("#adm_form_campaign_canned_messages_list tbody tr[row_data][canned_id='" + canned_id + "']");
	};

	adm_form_campaigns_section_canned_messages.prototype.add_group_to_combo = function(item, selected)
	{
		if (!$.isPlainObject(item)) {
			return;
		}
		var group = (item.group || "").toLowerCase();
		if (!this.canned_groups.hasOwnProperty(group)) {
			var $popup_combo  = $("#adm_form_campaign_canned_messages_popup_group");
			var $search_combo = $("#adm_form_campaign_canned_messages_filter_groups");

			selected = selected || false;
			this.frm.combo_add_value($popup_combo,  group, item.group, selected, "item", item);
			selected = false;
			this.frm.combo_add_value($search_combo, group, item.group, selected, "item", item);
		}
	};

	adm_form_campaigns_section_canned_messages.prototype.update_group_combo = function(item)
	{
		if (!$.isPlainObject(item)) {
			return;
		}
		var $popup_combo  = $("#adm_form_campaign_canned_messages_popup_group");
		var $search_combo = $("#adm_form_campaign_canned_messages_filter_groups");
		var old_group = $popup_combo.val().toLowerCase();
		var canned_list = this.canned_groups[old_group] || {};
		if (this.canned_groups.hasOwnProperty(old_group)) {
			delete this.canned_groups[old_group];
		}
		var group = (item.group || "").toLowerCase();
		this.canned_groups[group] = canned_list;

		this.frm.combo_update_value($popup_combo, group, item.group, old_group, "item", item);
		this.frm.combo_update_value($search_combo, group, item.group, old_group, "item", item);
	};

	// agrega un row ordenado alfabeticamente
	adm_form_campaigns_section_canned_messages.prototype.add_sorted_row = function(new_group, new_name, $new_row)
	{
		var self = this;
		var $tbody = $("#adm_form_campaign_canned_messages_list tbody");
		var new_sorted_key = this.make_sorted_key(new_group, new_name);
		var added = false;
		$tbody.find("tr").each(function( _, row )
		{
			var $row = $(row);
			var canned_id = $row.attr("canned_id");
			var canned_data = self.get_canned_from_full_list(canned_id);
			var current_sorted_key = self.make_sorted_key(canned_data.group, canned_data.name);
			if (new_sorted_key < current_sorted_key) {
				$row.before($new_row);
				added = true;
				return false; // break
			}
		});
		if (!added) {
			$tbody.append($new_row);
		}
	};

	adm_form_campaigns_section_canned_messages.prototype.filter_row = function($row, canned)
	{
		// (filter) - valido si los nuevos valores del row matchean con el filtro
		var $search_combo = $("#adm_form_campaign_canned_messages_filter_groups");
		var filter_group = $search_combo.val() || "";
		if (filter_group.length > 0 && filter_group.toUpperCase() !== canned.group.toUpperCase()) {
		// si en el combo de filtro de categoria, existe una seleccionada, y ha cambiado de categoria, esconde la row.
			$row.hide();
			return;
		}
		var search_text = $("#adm_form_campaign_canned_messages_filter_text").val();
		if (search_text.length === 0) {
		// si no hay texto buscado en el filtro, no filtro la row
			return;
		}
		var search_regexp = this.make_search_regexp(search_text);
		var text_to_search = this.canned_remove_special_chars(canned);
		if (text_to_search.search(search_regexp) === -1) {
		// si el mensaje o el name ha cambiado, y no matchea con el filtro, escondo la row.
			$row.hide();
			return;
		}
	};

	adm_form_campaigns_section_canned_messages.prototype.has_permission_to_delete = function()
	{
		if ( this.has_perm_to_erase !== null ) {
			return this.has_perm_to_erase;
		}
		this.has_perm_to_erase = adm_form_campaigns_section_canned_messages.uber.has_permission_to_delete.call( this );
		return this.has_perm_to_erase;
	};

	adm_form_campaigns_section_canned_messages.prototype.__get_canned_plain_message = function(canned)
	{
		if (typeof canned !== "object") {
			return "";
		}
		var plain_message = canned.plain_message;
		if (!plain_message) {
			plain_message = inConcert.Utils.htmlBodyToPlainText(canned.message || "");
			plain_message = inConcert.Utils.html2text(plain_message);
		}
		plain_message = inConcert.Utils.truncateWord(plain_message, 300);
		return plain_message;
	};

	adm_form_campaigns_section_canned_messages.prototype.__get_format_type = function(canned) {
		return this.m_format_list[canned.format] || this.m_format_list["TEXT PLAIN"];
	};

	adm_form_campaigns_section_canned_messages.prototype.add_row = function(canned, is_new)
	{
		if (!$.isPlainObject(canned)) {
			return;
		}
		var self = this;
		var canned_id = canned.canned_id || inConcert.Utils.generateGuid();
		var name      = canned.name      || "";
		var group     = canned.group     || "";
		var plain_message = this.__get_canned_plain_message(canned);

		var $tbody = $("#adm_form_campaign_canned_messages_list tbody");
		var $row = $tbody.find("tr[canned_id='" + canned_id + "']");
		var already_canned = $row.length > 0;
		if ( already_canned ) {
		// si el canned a agregar ya existe en la lista de la gui me voy
			return;
		}

		var get_actions = function()
		{
			var has_perm_to_save  = self.has_permission_to_save();
			var has_perm_to_erase = self.has_permission_to_delete();

			if ( !has_perm_to_save && ! has_perm_to_erase ) {
				return "";
			}
			var save_html  = "";
			if ( has_perm_to_save ) {
				save_html = 
				"<button action_edit='true' class='buttonColorGray gridActionButton edit' title='"+ "<%=_T('Edit')%>" + "'>" +
					"<i class='buttons-icons-edit'></i>" +
					"<%=_T('Edit')%>" +
				"</button>";
			}
			var erase_html  = "";
			if ( has_perm_to_erase ) {
				erase_html = 
				"<button action_del='true'  class='buttonColorGray gridActionButton delete' title='"+ "<%=_T('Delete')%>" + "'>" +
					"<i class='buttons-icons-delete'></i>" +
					"<%=_T('Delete')%>" +
				"</button>";
			}

			return "".concat(
				"<td col_actions='true' class='cannedMessagesActionsColumn'>",
					save_html,
					erase_html,
				"</td>");
		};

		var $row_html = $("".concat(
			"<tr row_data='true' canned_id='", canned_id, "'>",
				"<td col_info='true' class='cannedMessagesDataColumn'>",
					"<div class='d-flex flex-row'>",
						"<label col_group='true'  class='cannedMessagesGroup'>", group, "</label>",
						"<label col_format='true' class='cannedMessagesFormat'>", this.__get_format_type(canned).desc, "</label>",
						"<label col_name='true'   class='cannedMessagesName'>", name, "</label>",
					"</div>",
					"<div class='cannedMessagesData'>",
						"<label col_message='true'>", plain_message, "</label>",
					"</div>",
				"</td>",
				get_actions(),
			"</tr>")
		);

		if (!is_new) {
			$tbody.append($row_html);
		}
		else {
			this.add_sorted_row(group, name, $row_html); // agregar ordenada
			this.filter_row($row_html, canned); // filtra la row si existe filtro aplicado
		}
		// add canned in full hash
		this.add_canned_to_full_list(canned_id, canned);
		// add gropued canned
		this.add_grouped_canned_list(group, canned_id);
		// update message found
		this.show_or_hide_not_results_found();
	};

	adm_form_campaigns_section_canned_messages.prototype.update_row = function(new_row_data)
	{
		if ( !$.isPlainObject( new_row_data ) ) {
			return;
		}
		var $current_row = this.$get_row( new_row_data.canned_id );
		// name
		var $name = $( $current_row.find( this.selector_row_name ) );
		var old_name = $name.text().toLowerCase();
		var new_name = ( new_row_data.name || "" ).toLowerCase();

		// group
		var $group = $( $current_row.find( this.selector_row_group ) );
		var old_group = $group.text().toLowerCase();
		var new_group = ( new_row_data.group || "" ).toLowerCase();
		var canned_id = new_row_data.canned_id;

		if ( old_group !== new_group ) {
			this.erase_grouped_canned_list( old_group, canned_id );
			this.add_grouped_canned_list( new_group, canned_id );
		}
		// actualiza la lista completa de canneds
		this.update_canned_on_full_list( new_row_data.canned_id, new_row_data );

		$name.text( new_row_data.name );
		$group.text( new_row_data.group );
		// format
		var $format = $( $current_row.find( this.selector_row_format ) );
		let format_type = this.__get_format_type(new_row_data);
		$format.text( format_type.desc );

		// message
		var $message = $( $current_row.find( this.selector_row_message ) );
		var plain_message = this.__get_canned_plain_message(new_row_data);
		$message.html(plain_message);

		// filtra la row
		this.filter_row( $current_row, new_row_data );

		if ( ( old_group !== new_group ) || ( old_name !== new_name ) ) {
			// si el grupo o el name cambio, tengo que cambiarlo de posicion dentro de la table (alfabeticamente)
			var $row = $current_row;
			this.$row_editing.remove();
			this.add_sorted_row( new_group, new_name, $row );
		}
		this.show_or_hide_not_results_found();
	};

	adm_form_campaigns_section_canned_messages.prototype.make_sorted_key = function(group, name)
	{
		group = group || "";
		name = name || "";
		return (group + " - " + name).toLowerCase();
	};

	adm_form_campaigns_section_canned_messages.prototype.show_not_results_found = function( message )
	{
		$("#adm_form_campaign_canned_messages_not_results_found")
			.text( message || "<%=_T('No canned messages found.')%>" )
			.show();

		$("#adm_form_campaign_canned_messages_list").hide();
	};

	adm_form_campaigns_section_canned_messages.prototype.hide_not_results_found = function()
	{
		$("#adm_form_campaign_canned_messages_list").show();
		$("#adm_form_campaign_canned_messages_not_results_found").hide();
	};

	adm_form_campaigns_section_canned_messages.prototype.show_or_hide_not_results_found = function()
	{
		var count;
		if ( this.has_applied_filter() ) {
			count = $("#adm_form_campaign_canned_messages_list tbody tr[row_data]")
						.filter(function() {
							return $(this).css("display") !== "none";
						}).length;
		}
		else {
			count = Object.keys( this.all_canned_messages || {} ).length;
		}
		if ( count > 0 ) {
			this.hide_not_results_found();
		}
		else {
			this.show_not_results_found();
		}
	};

	adm_form_campaigns_section_canned_messages.prototype.has_applied_filter = function()
	{
		var filter_group = $("#adm_form_campaign_canned_messages_filter_groups").val() || "";
		if ( filter_group.length > 0 ) {
			return true;
		}
		var search_text = $("#adm_form_campaign_canned_messages_filter_text").val();
		if ( search_text.length > 0 ) {
			return true;
		}
		return false;
	};

	adm_form_campaigns_section_canned_messages.prototype.load_messages = function(canned_messages)
	{
		var self = this;

		$("#adm_form_campaign_canned_messages_list tbody").html("");
		var $popup_combo  = $("#adm_form_campaign_canned_messages_popup_group");
		var $search_combo = $("#adm_form_campaign_canned_messages_filter_groups");

		$popup_combo.html("");
		$search_combo.html("");

		this.all_canned_messages = {};
		this.canned_groups = {};

		if (!$.isPlainObject(canned_messages)) {
			this.show_or_hide_not_results_found();
			return;
		}

		var sorted_canned = inConcert.Utils.hash_to_sorted_array(canned_messages,
			function(canned_message) {
				return self.make_sorted_key(canned_message.group, canned_message.name);
			}) || {};

		if ( sorted_canned.length > 0 ) {
			$.each(sorted_canned, function( _, item )
			{
				item.canned_id = item.Id;
				delete item.Id; // la funcion hash to sorted array, mete el id, lo pelo porque aca no lo necesito.
				self.add_group_to_combo(item);
				self.add_row(item);
			});
		}
		else {
			this.frm.combo_add_value($popup_combo, "", "", true);
			this.frm.combo_add_value($search_combo, "", "", true);
		}
		this.show_or_hide_not_results_found();
		inConcert.Utils.sortOptions("adm_form_campaign_canned_messages_popup_group");
		this.enable_or_disable_groups();
		this.frm.dashboard.hide_waiting();
	};

	adm_form_campaigns_section_canned_messages.prototype.enable_or_disable_groups = function()
	{
		var $popup_group_edit = $("#adm_form_campaign_canned_messages_group_edit"); // el boton de editar el grupo seleccionado.
		var $popup_combo      = $("#adm_form_campaign_canned_messages_popup_group");
		var $search_combo     = $("#adm_form_campaign_canned_messages_filter_groups");

		var groups_length = $search_combo.find( "option" ).length;
		var is_empty = groups_length <= 1;

		if ( is_empty ) {
			$popup_group_edit.prop( "disabled", true );
			this.frm.readonly_control( $popup_combo  , true /*disable*/ , false /*required*/ );
			this.frm.readonly_control( $search_combo , true /*disable*/ , false /*required*/ );
		}
		else {
			$popup_group_edit.prop( "disabled", false );
			this.frm.readonly_control( $popup_combo  , false /*disable*/, false /*required*/ );
			this.frm.readonly_control( $search_combo , false /*disable*/, false /*required*/ );
		}
	};

	adm_form_campaigns_section_canned_messages.prototype.after_save_canned_messages = function(success, message_error)
	{
		var self = this;
		var canned_list = this.canned_list_to_save;

		if (success) {
			if (this.$row_editing) {
			// update actual
				$.each(canned_list, function( _, canned_info )
				{
					self.update_row( canned_info.canned );
				});
			}
			else {
			// add all new
				var is_new = true;
				$.each(canned_list, function( _, canned_info )
				{
					if ( canned_info.is_new ) {
						self.add_row( canned_info.canned, is_new );
					}
					else {
						self.update_row( canned_info.canned );
					}
				});
			}
			this.empty_canned_list_to_save();
			this.$row_editing = null;
			var message = "<%=_T('Canned messages have been saved successfully.')%>";
			this.frm.show_status_message(
				message ,                /* mensaje          */
				"Info"  ,                /* tipo de mensaje  */
				3000                     /* timeout ms       */);
		}
		else {
			this.frm.show_status_message(
				message_error,           /* mensaje                                            */
				"Error",                 /* tipo de mensaje                                    */
				false,                   /* timeout ms (false = inifito)                       */
				false,                   /* scroll to top (false = no se mueve)                */
				{                        /* muestra la accion personaliza (en este caso retry) */
					message: "<%=_T('Retry')%>",
					callback: function(){
						self.save_canned_messages();
					}
				}
			);
		}
	};

	adm_form_campaigns_section_canned_messages.prototype.save_canned_messages = function()
	{
		var self = this;
		self.hide_message_popup();

		var canned_list = this.canned_list_to_save;
		if ( $.isEmptyObject( canned_list ) ) {
			return;
		}
		self.saving = true;

		this.frm.dashboard.show_waiting("<%=_T('Please wait until canned messages are saved.')%>");
		// lo meto dentro de un timeout minimo, para que se pueda ver el waiting, ya que si la grilla tiene muchos registros
		//	parece que queda la pantalla congelada, porque no da el tiempo para que se vea el waiting
		window.setTimeout(function()
		{
			var canned_messages = [];
			$.each(canned_list, function(canned_id, canned_info)
			{
				var canned = canned_info.canned;
				canned.canned_id = canned.canned_id || canned_id;
				canned_messages.push(canned);
			});

			self.frm.campaign.saveCannedMessages(canned_messages, function(error)
			{
				var success = !error;
				var message_error;
				if ( !success ) {
					if (typeof error === "object") {
						error = ( error.result || "").toUpperCase();
					}
					switch (error)
					{
						case "INVALID_REQUEST":
							message_error = "<%=_T('Invalid request.')%>";
							break;

						case "CAMPAIGN_DOES_NOT_EXIST":
							message_error = "<%=_T('Unable to save campaign canned messages, campaign does not exist...')%>";
							break;

						case "FORBIDDEN":
							message_error = "<%=_T('You dont have permissions for save campaign canned messages.')%>";
							break;

						default:
							message_error = "<%=_T('Failed to save canned messages, please try again in a few minutes...')%>";
					}
				}
				self.after_save_canned_messages( success, message_error );
				self.saving = false;
			});
		}, 50);
	};

	adm_form_campaigns_section_canned_messages.prototype.remove_canned_messages = function(canned_messages, callback)
	{
		var self = this;
		callback = callback || $.noop;

		if ( !$.isArray( canned_messages ) || canned_messages.length === 0 ) {
			callback(false);
			return;
		}

		this.frm.dashboard.show_waiting("<%=_T('Please wait until canned messages are deleted.')%>");
		// lo meto dentro de un timeout minimo, para que se pueda ver el waiting, ya que si la grilla tiene muchos registros
		//	parece que queda la pantalla congelada, porque no da el tiempo para que se vea el waiting
		window.setTimeout(function()
		{
			self.frm.campaign.deleteCannedMessages(canned_messages, function(error)
			{
				var success = !error;
				var message, type, timeout_ms;
				if ( success ) {
					message = "<%=_T('Canned messages have been deleted successfully.')%>";
					type = "Info";
					timeout_ms = 3000;
				}
				else {
					if (typeof error === "object") {
						error = ( error.result || "").toUpperCase();
					}
					switch (error)
					{
						case "INVALID_REQUEST":
							message = "<%=_T('Invalid request.')%>";
							break;
						case "CAMPAIGN_DOES_NOT_EXIST":
							message = "<%=_T('Unable to delete campaign canned messages, campaign does not exist...')%>";
							break;

						case "FORBIDDEN":
							message = "<%=_T('You dont have permissions for delete campaign canned messages.')%>";
							break;

						default:
							message = "<%=_T('Failed to delete canned messages, please try again in a few minutes...')%>";
					}
					type = "Error";
					timeout_ms = false; // infinito
				}

				self.frm.show_status_message(
					message,                           /* mensaje          */
					type,                              /* tipo de mensaje  */
					timeout_ms                         /* timeout ms       */);
				callback( success );
			});
		}, 50);
	};

	adm_form_campaigns_section_canned_messages.prototype.build_header_custom_buttons = function()
	{
		const html_buttons =
			"<button id='adm_form_campaign_canned_messages_new' class='pageButtonGeneric buttonColorPrimary pageButtonNew'>" + "<%=_T('Create template')%>"  + "</button>";
		adm_form_campaigns_section_canned_messages.uber.build_header_custom_buttons.call(this, html_buttons);
	};

	adm_form_campaigns_section_canned_messages.prototype.show_error_validation_message = function(message_error, $control)
	{
		const self = this;
		if (this.m_messageTimeout) {
			window.clearTimeout(this.m_messageTimeout);
			this.m_messageTimeout = null;
		}
		const $message_error = $("#adm_form_campaign_canned_messages_popup_message");
		const hide = function() {
			$message_error.hide();
			$("#adm_form_campaign_canned_messages_popup .formFieldValidation").hide();
			self.m_messageTimeout = null;
		};
		hide();
		$message_error.text(message_error).show();
		let error_id = $control.attr("id") + "_validation";
		const $error_indicator = $("#" + error_id);
		if ($error_indicator) {
			$error_indicator.show();
		}
		if ($control) {
			$control.focus();
		}
		this.m_messageTimeout = window.setTimeout(function() {
			hide();
		}, 5000);
	};

	adm_form_campaigns_section_canned_messages.prototype.validate_message = function(canned_info)
	{
		const self = this;

		var $name = $("#adm_form_campaign_canned_messages_popup_name");
		var name = canned_info.name;
		var message;
		if (name.trim().length === 0) {
			// valida que el name tenga al menos un caracter
			message = "<%=_T('Name is required.')%>";
			this.show_error_validation_message(message, $name);
			return false;
		}

		var $rows = $("#adm_form_campaign_canned_messages_list tbody tr");
		var already = function()
		{
			var edit_canned_id;
			if (self.$row_editing) {
				edit_canned_id = self.$row_editing.attr("canned_id");
			}
			var already_exist = false;
			$rows.each(function( _, row )
			{
				var $row = $(row);
				if (edit_canned_id !== undefined) {
				// si estoy editando, no valido sobre el mismo row.
					var row_canned_id = $row.attr("canned_id");
					if (row_canned_id === edit_canned_id) {
						return true; // continue
					}
				}
				var current_name = $row.find( self.selector_row_name ).text();
				already_exist = current_name.trim().toLowerCase() === name.trim().toLowerCase();
				if (already_exist) {
					message = "<%=_T('Name already exists.')%>";
					self.show_error_validation_message(message, $name);
					return false; // break
				}
			});
			return already_exist;
		};

		// valida que si estoy agregando un nuevo mensaje, el mismo ya no exista.
		if (already()) {
			return false;
		}

		let format_type = this.get_current_format();
		if (!format_type || format_type.trim().length === 0) {
			// valida que el name tenga al menos un caracter
			message = "<%=_T('Format type is required.')%>";
			this.show_error_validation_message(message, $("#adm_form_campaign_canned_messages_popup_add_in_format"));
			return false;
		}

		if (format_type === "HTML") {
			let html_validation;
			this.html_editor.validate(function(response) {
				html_validation = response;
			});
			if (!html_validation.success) {
				// valida que el message tenga al menos un caracter
				const $message = $("#" + this.dom_id_html_msg);
				message = html_validation.message || "<%=_T('Message is required.')%>";
				this.show_error_validation_message(message, $message);
				return false;
			}
		}
		else {
			const $plain_msg = $("#" + this.dom_id_plain_msg);
			if (canned_info.plain_message.trim().length === 0) {
				// valida que el name tenga al menos un caracter
				message = "<%=_T('Message is required.')%>";
				this.show_error_validation_message(message, $plain_msg);
				return false;
			}
		}

		// validation successfully
		return true;
	};

	adm_form_campaigns_section_canned_messages.prototype.get_current_format = function()
	{
		let format_type = $("#adm_form_campaign_canned_messages_popup_add_in_format").val();
		return format_type;
	};

	adm_form_campaigns_section_canned_messages.prototype.change_format = function(format_type)
	{
		const $plain_container = $("#" + this.dom_id_plain_msg_container);
		const $html_container = $("#" + this.dom_id_html_msg_container);
		if (format_type === "TEXT PLAIN") {
			$html_container.hide();
			$plain_container.show();
			return;
		}
		$plain_container.hide();
		$html_container.show();
	};

	adm_form_campaigns_section_canned_messages.prototype.edit_group = function(is_new)
	{
		$("#adm_form_campaign_canned_messages_group_edit_actions").hide();
		$("#adm_form_campaign_canned_messages_group_save_actions").show();
		var disabled = true;
		this.frm.readonly_control($("#adm_form_campaign_canned_messages_popup_group"), !disabled);
		this.frm.readonly_control($("#adm_form_campaign_canned_messages_popup_name"), disabled);
		this.frm.readonly_control($("#adm_form_campaign_canned_messages_popup_add_in_format"), disabled);
		this.html_editor.readonly();
		this.frm.readonly_control($("#" + this.dom_id_plain_msg), disabled);
		$("#adm_form_campaign_canned_messages_popup_create").prop("disabled", disabled);
		$("#adm_form_campaign_canned_messages_popup_create_and_continue").prop("disabled", disabled);
		var current_group = "";
		var $input_group = $("#adm_form_campaign_canned_messages_popup_group_input");
		if (!is_new) {
			current_group = $("#adm_form_campaign_canned_messages_popup_group option:selected").text();
			$( "#adm_form_campaign_canned_messages_group_cancel" ).find( ".far" ).removeClass( "fa-minus-circle" ).addClass("fa-times-circle");
		} else {
			$( "#adm_form_campaign_canned_messages_group_cancel" ).find( ".far" ).removeClass( "fa-times-circle" ).addClass("fa-minus-circle");
		}
		$input_group.val(current_group).focus();
	};

	adm_form_campaigns_section_canned_messages.prototype.hide_edition_group = function(saved)
	{
		$("#adm_form_campaign_canned_messages_group_edit_actions").show();
		$("#adm_form_campaign_canned_messages_group_save_actions").hide();
		var disabled = false;
		var required = true;
		this.enable_or_disable_groups();
		this.frm.readonly_control($("#adm_form_campaign_canned_messages_popup_name"), disabled, required);
		this.frm.readonly_control($("#adm_form_campaign_canned_messages_popup_add_in_format"), disabled);
		this.html_editor.editable();
		this.frm.readonly_control($("#" + this.dom_id_plain_msg), disabled);
		$("#adm_form_campaign_canned_messages_popup_create").prop("disabled", disabled);
		$("#adm_form_campaign_canned_messages_popup_create_and_continue").prop("disabled", disabled);
		if ( saved ) {
			$("#adm_form_campaign_canned_messages_popup_name").focus();
		}
	};

	//------------------------------
	// Esta funcion actualiza todos los rows que pertenezcan al grupo modificado.
	// Como no es relacionada y/o no existe una CF exclusiva para los grupos, tengo que
	// salir a tocar todos los rows para que luego se actualice el server.
	adm_form_campaigns_section_canned_messages.prototype.update_rows_canned_groups = function(group_name)
	{
		var self = this;
		var group = (group_name || "").toLowerCase();
		var groups_list = this.canned_groups[group] || {};
		$.each(groups_list, function(canned_id)
		{
			var $row = self.$get_row( canned_id );
			$row.find( self.selector_row_group ).text( group_name );
			if ( self.all_canned_messages.hasOwnProperty( canned_id ) ) {
				var canned = self.all_canned_messages[ canned_id ];
				var cloned_canned = inConcert.Utils.cloneObject( canned );
				cloned_canned.group = group_name;
				self.update_canned_list_to_save( cloned_canned );
			}
		});
	};

	adm_form_campaigns_section_canned_messages.prototype.save_group = function(is_new)
	{
		var $input_group = $("#adm_form_campaign_canned_messages_popup_group_input");
		var group = $input_group.val();
		var saved = false;
		if (group.trim().length > 0) {
			saved = true;
			var $popup_combo  = $("#adm_form_campaign_canned_messages_popup_group");
			if (is_new) {
				var selected = true;
				this.add_group_to_combo( { group: group }, selected );
				$popup_combo.trigger("change");
			}
			else {
				var canned_id;
				if (this.$row_editing) {
					canned_id = this.$row_editing.attr("canned_id");
				}
				this.update_group_combo({
					group: group,
					canned_id: canned_id
				});
				// Actualizo todos los rows que pertenezcan al grupo modificado.
				// Como no es relacionada y/o no existe una CF exclusiva para los grupos, tengo que
				// salir a tocar todos los rows para que luego se actualice el server.
				this.update_rows_canned_groups(group);
			}
		}
		this.hide_edition_group(saved);
	};

	adm_form_campaigns_section_canned_messages.prototype.add_or_update_message = function(has_continue)
	{
		let canned_info = {
			canned_id: null,
			group    : $("#adm_form_campaign_canned_messages_popup_group option:selected").text(),
			name     : $("#adm_form_campaign_canned_messages_popup_name").val(),
			format   : this.get_current_format()
		};

		const $plain_msg = $("#" + this.dom_id_plain_msg);
		if (canned_info.format === "HTML") {
			let html = this.html_editor.get();
			html = inConcert.Utils.html_remove_malicious_code(html);
			canned_info.message = html;
			canned_info.plain_message = this.html_editor.get_plain_text();
		}
		else {
			let plain_text = $plain_msg.val();
			canned_info.message = plain_text;
			canned_info.plain_message = plain_text;
		}

		// validate
		if (!this.validate_message(canned_info)) {
			return;
		}

		$("#adm_form_campaign_canned_messages_popup_message").hide();
		$("#adm_form_campaign_canned_messages_popup .formFieldValidation").hide();

		var is_new = !this.$row_editing;
		if ( is_new ) {
		// add new
			// cuando es nuevo, el id se genera en la funcion.
			canned_info.canned_id = inConcert.Utils.generateGuid();
		}
		else {
		// update actual
			canned_info.canned_id = this.$row_editing.attr("canned_id");
		}
		// actualiza la lista de canneds que se guardaran al salir del popup
		this.update_canned_list_to_save( canned_info, is_new);

		$("#adm_form_campaign_canned_messages_popup_name").val("");
		this.html_editor.set("");
		$plain_msg.val("");

		if (!has_continue) {
			$("#adm_form_campaign_canned_messages_popup_group").val("");
			this.save_canned_messages();
			return;
		}
		$("#adm_form_campaign_canned_messages_popup_name").focus();
	};

	adm_form_campaigns_section_canned_messages.prototype.show_message_popup = function()
	{
		this.frm.hide_messages();

		this.empty_canned_list_to_save();
		let name = "", message = "";
		let canned_id, canned_data;
		if ( !this.has_permission_to_section() || !this.has_permission_to_save() ) {
			if ( !this.$row_editing ) {
				message =  "<%=_T('Unable to view canned message: You dont have permissions for this action.')%>";
			}
			else {
				canned_id = this.$row_editing.attr("canned_id");
				canned_data = this.get_canned_from_full_list(canned_id);
				name = canned_data.name;
				message = format( "<%=_T('Unable to view {0} canned message: You dont have permissions for this action.')%>", name );
			}
			this.$row_editing = null;
			this.frm.show_status_message( message, "Error", 5000 );
			return;
		}

		$("#adm_form_campaign_canned_messages_popup_message").hide();
		$("#adm_form_campaign_canned_messages_popup .formFieldValidation").hide();
		$("#adm_form_campaign_canned_messages_popup").show();

		let group = "", title = "", format_type = "HTML";
		let is_new_message = !this.$row_editing;
		if (is_new_message) {
		// si presione el boton para crear uno nuevo
			$("#adm_form_campaign_canned_messages_popup_create").val("<%=_T('Create')%>");
			$("#adm_form_campaign_canned_messages_popup_create_and_continue").show();
			group = $("#adm_form_campaign_canned_messages_filter_groups").val() || "";
			title = "<%=_T('New canned message')%>";
		}
		else {
		// si presione el boton para editar
			$("#adm_form_campaign_canned_messages_popup_create").val("<%=_T('Update')%>");
			$("#adm_form_campaign_canned_messages_popup_create_and_continue").hide();
			canned_id = this.$row_editing.attr("canned_id");
			canned_data = this.get_canned_from_full_list(canned_id);
			name = canned_data.name;
			group = canned_data.group.toLowerCase();
			format_type = canned_data.format || "HTML";
			title = "<%=_T('Update canned message')%>";
		}

		$("#adm_form_campaign_canned_messages_popup_title").text( title );
		$("#adm_form_campaign_canned_messages_popup_group").val( group ).trigger("change");
		$("#adm_form_campaign_canned_messages_popup_add_in_format").val( format_type ).trigger("change");
		const $plain_msg = $("#" + this.dom_id_plain_msg);

		if (format_type === "HTML") {
			let html_message = is_new_message ? "" : canned_data.message;
			this.html_editor.set(html_message);
			$plain_msg.val("");
		}
		else {
			let plain_message = is_new_message ? "" : canned_data.plain_message;
			$plain_msg.val(plain_message);
			this.html_editor.set("");
		}

		$("#adm_form_campaign_canned_messages_popup_name").focus().val( name );
	};

	adm_form_campaigns_section_canned_messages.prototype.hide_message_popup = function()
	{
		$("#adm_form_campaign_canned_messages_popup").hide();
		this.hide_edition_group();
		if ( this.is_empty_canned_list_to_save() ) {
			this.$row_editing = null;
		}
	};

	adm_form_campaigns_section_canned_messages.prototype.set_events_popup = function()
	{
		var self = this;
		// new message event
		var event_selector = "#adm_form_campaign_canned_messages_new";
		var $header_buttons = this.frm.dashboard.$get_dom_element_by_id( "form_custom_buttons" ); //conf_form_custom_buttons
		$header_buttons
			.off("click", event_selector)
			.on("click", event_selector, function() {
				self.show_message_popup();
			});

		$("#adm_form_campaign_canned_messages_popup_create")
			.off("click")
			.on("click", function() {
				var has_continue = false;
				self.add_or_update_message(has_continue);
			});
		$("#adm_form_campaign_canned_messages_popup_create_and_continue")
			.off("click")
			.on("click", function() {
				var has_continue = true;
				self.add_or_update_message(has_continue);
			});
		$("#adm_form_campaign_canned_messages_popup_close")
			.off("click")
			.on("click", function() {
				self.hide_message_popup();
				if ( !self.is_empty_canned_list_to_save() ) {
					self.save_canned_messages();
				}
			});

		$("#adm_form_campaign_canned_messages_popup_close_times")
			.off("click")
			.on("click", function() {
				self.hide_message_popup();
				if ( !self.is_empty_canned_list_to_save() ) {
					self.save_canned_messages();
				}
			});

		var $edit_group = $("#adm_form_campaign_canned_messages_group_edit");
		$("#adm_form_campaign_canned_messages_popup_group")
			.off("change")
			.on("change", function() {
				var group = $(this).val();
				if ( typeof group === "string" ) {
					var disabled = group.trim().length === 0;
					$edit_group.prop("disabled", disabled);
				}
			});

		// groups (combo categoria)
		var is_new_group;
		$("#adm_form_campaign_canned_messages_group_new")
			.off("click")
			.on("click", function()
			{
				is_new_group = true;
				self.edit_group(is_new_group);
			});

		// 
		$("#adm_form_campaign_canned_messages_popup_add_in_format")
			.off("change")
			.on("change", function() {
				let format_type = $(this).val();
				self.change_format(format_type);
			}
		);

		$edit_group
			.off("click")
			.on("click", function()
			{
				is_new_group = false;
				self.edit_group(is_new_group);
			});

		$("#adm_form_campaign_canned_messages_group_save")
			.off("click")
			.on("click", function()
			{
				self.save_group(is_new_group);
			});
		$("#adm_form_campaign_canned_messages_group_cancel")
			.off("click")
			.on("click", function()
			{
				self.hide_edition_group();
			});

		this.html_editor.set_events();
	};

	adm_form_campaigns_section_canned_messages.prototype.make_search_regexp = function(word)
	{
		if (typeof word !== "string") {
			return "";
		}
		var search_pattern = inConcert.Utils.removeSpecialChars(word);
		return new RegExp(search_pattern.replace(/[^\w\s]/gi, ""), "i");
	};

	adm_form_campaigns_section_canned_messages.prototype.canned_remove_special_chars = function(canned)
	{
		if (typeof canned !== "object") {
			return "";
		}
		var message = (canned.message || "") + (canned.name || "");
		return inConcert.Utils.removeSpecialChars(message);
	};

	adm_form_campaigns_section_canned_messages.prototype.set_events_search = function()
	{
		var self = this;
		var $search_text     = $("#adm_form_campaign_canned_messages_filter_text");
		var $search_start    = $("#adm_form_campaign_canned_messages_filter_start");
		var $search_reset    = $("#adm_form_campaign_canned_messages_filter_reset");
		var $search_groups   = $("#adm_form_campaign_canned_messages_filter_groups");

		var search = function()
		{
			// hide previous results
			$("#adm_form_campaign_canned_messages_list tbody tr[row_data]").hide();
			var list;
			var current_group = $search_groups.val() || "";
			if (current_group.length === 0) {
				list = self.all_canned_messages; // all canned messages
			}
			else {
				list = self.canned_groups[current_group]; // group canneds (solo id)
			}
			var search_regexp = self.make_search_regexp($search_text.val());
			$.each(list || {}, function(canned_id, canned)
			{
				if (typeof canned === "boolean") {
					// si la lista viene por grupo, viene solo el id, y tengo que obtener el objeto
					canned = self.all_canned_messages[canned_id];
					if (typeof canned !== "object") {
						return true; // continue
					}
				}
				var text_to_search = self.canned_remove_special_chars(canned);
				if (text_to_search.search(search_regexp) !== -1) {
					var $row = self.$get_row( canned_id );
					$row.toggle();
				}
			});
			var disabled_reset_button = $search_text.val().length === 0 && current_group.length === 0;
			$search_reset.prop("disabled", disabled_reset_button);
			self.show_or_hide_not_results_found();
		};

		var reset_search = function()
		{
			$search_text.val("").focus();
			$search_start.prop("disabled", true);
			if ($search_groups.val() === "") {
				$search_reset.prop("disabled", true);
				$("#adm_form_campaign_canned_messages_list tbody tr[row_data]").show();
				self.show_or_hide_not_results_found();
			}
			else {
				search();
			}
		};

		$search_groups
			.off("change")
			.on("change", function() {
				// el search se realiza en el timeout, porque sino la opcion del combo queda colgada mientras se realiza la busqueda
				var elapsed_time_ms = 15;
				window.setTimeout(function()
				{
					search();
				}, elapsed_time_ms);
			});

		// bind filter click button
		$search_start
			.off("click")
			.on("click", function () {
				search();
			});

		//reset button click handler
		$search_reset
			.off('click')
			.on('click', function () {
				$search_groups.val("");
				reset_search();
			});

		var search_timeout;
		$search_text.keyup(function (event)
		{
			if (search_timeout) {
				window.clearTimeout(search_timeout);
				search_timeout = undefined;
			}
			if ($search_text.val()) {
				if (event.keyCode === 27) { //Escape reset search
					reset_search();
					return;
				}
				// se encuentra en un timeout de 500 ms, para que no realice la busqueda mientras escribis.
				var elapsed_time_ms = 500;
				search_timeout = window.setTimeout(function() {
					window.clearTimeout(search_timeout);
					search_timeout = undefined;
					search();
					$search_start.prop("disabled", false);
				}, elapsed_time_ms);
			} else {
				if (event.keyCode === 8 || event.keyCode === 46) { // backspace and no text, reset search.
					reset_search();
					return;
				}
				$search_start.prop("disabled", true);
			}
		});
	};

	adm_form_campaigns_section_canned_messages.prototype.set_events = function()
	{
		var self = this;
		this.set_events_search();

		var $tbody = $("#adm_form_campaign_canned_messages_list tbody");
		var rows_event_selector = "tr[row_data]";
		var event_selector;

		// boton delete de la lista de parametros
		event_selector =  rows_event_selector + " button[action_del]";
		$tbody
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				self.frm.hide_messages();
				self.empty_canned_list_to_save();
				self.$row_editing = null;
				var $row = $(this).parent().parent();
				var canned_id = $row.attr("canned_id");
				var canned = self.get_canned_from_full_list(canned_id);
				var message = format(
					"<%=_T('Do you want to delete message id {0} ?')%>",
					canned.name);

				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					$.inconcertPopup.ButtonSets.BS_YESNO,
					function(response) {
						if (response.toLowerCase() !== "yes") {
							return;
						}
						var canneds_list = [];
						canneds_list.push(canned.canned_id);
						// envia a remover al server
						self.remove_canned_messages(
							canneds_list,
							function(success) {
								if (!success) {
									return;
								}
								// elimino del hash de canneds
								self.erase_canned_on_full_list(canned.canned_id);
								// elimino del hash de canneds agrupados x categoria
								self.erase_grouped_canned_list(canned.group, canned.canned_id);
								$row.fadeOut("slow", function() {
									$row.remove();
									self.show_or_hide_not_results_found();
								});
							});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});


		// doble click sobre la row edita la misma
		$tbody
			.off("dblclick", rows_event_selector)
			.on("dblclick", rows_event_selector, function(event) {
				event.stopPropagation();
				self.$row_editing = $(this);
				self.show_message_popup();
			});

		// boton edit de la lista de parametros
		event_selector = rows_event_selector + " button[action_edit]";
		$tbody
			.off("click", event_selector)
			.on("click", event_selector, function() {
				self.$row_editing = $(this).parent().parent();
				self.show_message_popup();
			});


		this.set_events_popup();
	};

	adm_form_campaigns_section_canned_messages.prototype.load_campaign_canned_messages = function()
	{
		var self = this;
		this.frm.dashboard.show_waiting("<%=_T('Loading campaign canned messages.')%>");

		this.frm.campaign.getCannedMessages(function(canned_messages, error)
		{
			if (error) {
				var message_type = "Error";
				var timeout_ms = false; // infinite
				self.frm.show_status_message("<%=_T('Error retrieving campaign canned messages.')%>", message_type, timeout_ms);
				return;
			}
			self.load_messages(canned_messages);
			self.frm.dashboard.hide_waiting();
		});
	};

	adm_form_campaigns_section_canned_messages.prototype.initialize = function()
	{
		this.has_perm_to_save  = null;
		this.has_perm_to_erase = null;
		this.html_editor.initialize();
		this.load_campaign_canned_messages();

		const $add_in_format = $("#adm_form_campaign_canned_messages_popup_add_in_format");
		this.fill_combo($add_in_format, false, this.m_format_list, "id", "desc", true);
		$add_in_format.trigger("change");
	};

	adm_form_campaigns_section_canned_messages.prototype.set = function()
	{
		this.initialize();
	};

	adm_form_campaigns_section_canned_messages.prototype.on_show = function()
	{
		adm_form_campaigns_section_canned_messages.uber.on_show.call(this, {show: false});
		this.frm.dashboard.$get_dom_element_by_id("form_buttons_actions").hide();
		$("#adm_form_campaign_canned_messages_buttons").show();
	};

	adm_form_campaigns_section_canned_messages.prototype.on_hide = function()
	{
		adm_form_campaigns_section_canned_messages.uber.on_hide.call( this );
		this.hide_message_popup();
	};

	adm_form_campaigns_section_canned_messages.prototype.editable = function()
	{
		adm_form_campaigns_section_canned_messages.uber.editable.call( this );
	};

	adm_form_campaigns_section_canned_messages.prototype.readonly = function() {
		adm_form_campaigns_section_canned_messages.uber.readonly.call( this );
		this.html_editor.readonly();
		this.frm.readonly_control($("#" + this.dom_id_plain_msg), true);
	};
}());
