/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global $, inConcert, dhtmlXTreeObject*/
/*
Ha
*/
// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	var format = inConcert.Utils.format;
	var ROOT_RESULT_ID = "0";
	var SON_BRANCH = 0;
	var SIBLING_BRANCH = 1;
	const _T = inConcert.i18n.getString;
	
	//---------------------------------------------------------------------
	// form campaigns class - dispositions section
	function adm_form_campaigns_section_dispositions(params)
	{
		var success = adm_form_campaigns_section_dispositions.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		this.view_action_id = "view_campaigns_dispositions";  // view action id de permisos
		this.save_action_id = "save_campaign_dispositions"; // action id de permisos

		this.plain_results = {}; // agrega todos los resultados del tree en modo plano ordenado por su id
		this.codes_not_result_found  = "adm_form_campaign_dispositions_not_results_found";
		this.tree_results  = "adm_form_campaign_dispositions_tree_results_container";
		return true;
	}

	inConcert.Utils.inherit( adm_form_campaigns_section_dispositions, inConcert.conf_form_section );

	if (typeof inConcert.adm_form_campaigns_section_dispositions !== "function") {
		inConcert.adm_form_campaigns_section_dispositions = adm_form_campaigns_section_dispositions;
	}

	/*
	 *
	 */
	adm_form_campaigns_section_dispositions.prototype.hide_popup_errors = function()
	{
		$("#adm_form_campaign_dispositions_msg_error").hide();
		$("#adm_form_campaign_dispositions_popup_edit > .formFieldValidation").hide();
		this.frm.hide_messages();
	};

	/*
	 * retrieve markup of the result name of the tree
	 */
	adm_form_campaigns_section_dispositions.prototype.get_markup_result_name = function(name, result_id, parent_id)
	{
		var html_result = "".concat(
			"<div class='dispositionNameBox' dispositionName='", name, "'>", name, "</div>",
			"<div class='resultButtonContainer' result_id='", result_id, "' parent_id='", parent_id, "'>",
				"{0}", // los buttons
			"</div>");

		var html_buttons = "";

		if ( this.has_permission_to_section() ) {
			if ( this.is_readonly()) {
				html_buttons = "<button class='buttonColorGray gridActionButton view' title='"+ "<%=_T('View')%>" + "'>" + "<i class='buttons-icons-view'></i>" + "<%=_T('View')%>" + "</button>";
			}
			else {
				html_buttons = "".concat(
					"<span class='action-buttons-separator'></span>" +
					"<button class='buttonColorGray gridActionButton delete' title='"+ "<%=_T('Delete')%>" + "'>" + "<i class='buttons-icons-delete'></i>" + "<%=_T('Delete')%>" + "</button>" +
					"<button class='buttonColorGray gridActionButton edit' title='"+ "<%=_T('Edit')%>" + "'>" + "<i class='buttons-icons-edit'></i>" + "<%=_T('Edit')%>" + "</button>" +
					"<button class='buttonColorGray gridActionButton new' title='"+ "<%=_T('New')%>" + "'>" + "<i class='buttons-icons-add'></i>" + "<%=_T('New')%>" + "</button>");
			}
		}

		html_result = format( html_result, html_buttons );

		return html_result;
	};

	/*
	 * add child result to tree
	 */
	adm_form_campaigns_section_dispositions.prototype.add_child_result_to_tree = function(result, result_id, parent_id)
	{
		var name = this.get_markup_result_name(result.name, result_id, parent_id);
		// The SELECT parameter remains selected the added element.
		this.tree.insertNewChild(parent_id, result_id, name, 0, 0, 0, 0, "SELECT");
		this.tree.setUserData(result_id, "result", JSON.stringify(result));

		this.plain_results[result_id] = result;
		this.show_or_hide_not_results_found();
	};

	/*
	 * add sibling result to tree
	 */
	adm_form_campaigns_section_dispositions.prototype.add_sibling_result_to_tree = function(result, result_id, parent_id)
	{
		var name = this.get_markup_result_name(result.name, result_id, parent_id);
		// The SELECT parameter remains selected the added element.
		this.tree.insertNewNext( parent_id, result_id, name, 0, 0, 0, 0, "SELECT");
		this.tree.setUserData(result_id, "result", JSON.stringify(result));

		this.plain_results[result_id] = result;
	};

	/*
	 * fill the tree with all results
	 */
	adm_form_campaigns_section_dispositions.prototype.fill_tree = function(dispositions_codes)
	{
		/* Sample of the expected results on the json structure
		 *
			[
				{
					name: "No Compro",
					isGoal: false,
					needReschedule :true
				},
				{
					name: "No compro porque ha fallecido!!",
					isGoal: false
				},
				{
					name: "Compro",
					childs: [
						{
							name: "Efectivo",
							isGoal: true
						},
						{
							name: "Tarjeta",
							childs: [
								{name: "Visa",         isGoal: false},
								{name: "Master",       isGoal: false}
							]
						}
					]
				}
			]
		 */
		var self = this;
		if (!dispositions_codes) {
			return;
		}
		if ( this.tree_state !== "unloaded" ) {
			return;
		}
		this.tree_state = "loading";
		dispositions_codes = $.isArray(dispositions_codes) ? dispositions_codes : JSON.parse(dispositions_codes);
		this.tree.deleteChildItems(ROOT_RESULT_ID);

		var can_continue = function()
		{
			if ( !self.closed ) {
				return true;
			}
			// si se ha cerrado la ventana del frm de campana no continuo con la carga
			//console.log("abort !!! abm fill dispositions: Me voy -> self.closed: " + self.closed);
			self.hide_waiting();
			self.tree_state = "canceled";
			return false;
		};

		// recursive function that adds results on the tree
		var timeout_counter = 0;
		var pending_childs = 0;
		var total_added = 0;

		var fill = function(dispositions, parent_id)
		{
			// Lo agrego dentro de la funcion foreach_timeout para que el navegador no quede colgado.
			// Como los timeout se tiran por cada invocacion a funcion recursiva del tree, tengo
			//   un contador "timeout_counter", que se va incrementando en cada invocacion a la funcion
			//   y va decrementando cuando el loop timeout culmina para cada invocacion.
			// Entonces con esto, cuando el contador quede en cero nuevamente, ahi ya termino la carga total del tree.
			if ( !can_continue() ) { return; }
			timeout_counter++;
			inConcert.Utils.foreach_timeout(
			{
				rows : dispositions,
				max_append_per_loop: 200,
				pause_between_loop_ms: 1,
				append_fn : function( result, added )
				{
					if ( !can_continue() ) { return { cancel: true }; }
					total_added++;
					var result_id = inConcert.Utils.generateGuid();
					var first_child = added;
					if (first_child === SON_BRANCH) {
						self.add_child_result_to_tree(result, result_id, parent_id);
					}
					else {
						self.add_sibling_result_to_tree(result, result_id, parent_id);
					}
					//console.log("1 append_fn abm fill dispositions: " + result_id);
					parent_id = result_id;
					if (result.childs) {
						// Al loop que carga los childs los agrego en un timeout, e incremento la variable de pending en 1.
						// recien cargo los childs cuando termino la carga de la rama actual (timeout_counter <= 0), o sea el padre.
						// La carga de cada rama child se realiza de forma independiente, es decir, hasta que no termine una, no comienza con la otra.
						var pending_fn = function() {
							window.setTimeout(function() {
								if (timeout_counter <= 0) {
									//console.log("2.1 append_fn abm fill dispositions voy por los hijos: " + result_id + ", pending_childs: " + pending_childs);
									pending_childs--;
									fill(result.childs, result_id);
								}
								else {
									pending_fn();
								}
							});
						};
						pending_childs++;
						//console.log("2 append_fn abm fill dispositions voy por los hijos: " + result_id + ", pending_childs: " + pending_childs + ", timeout_counter: " + timeout_counter);
						pending_fn();
					}
				},
				waiting_fn : function(/*message*/)
				{
					var waiting_message = format("<%=_T('Please wait, adding {0} dispositions.')%>", total_added);
					self.show_waiting( waiting_message );
				},
				complete_fn : function()
				{
					//console.log("3 complete_fn - timeout_counter " + timeout_counter);
					if ( !can_continue() ) { return; }
					timeout_counter--;
					//console.log("3.1 complete_fn - pending_childs: " + pending_childs + ", timeout_counter: " + timeout_counter);
					if ( timeout_counter <= 0 && pending_childs <= 0 ) {
						//console.log("4 complete_fn - abm ENDDDDDDDDDDD ");
						// aca termino la carga total del tree
						self.tree.closeAllItems(ROOT_RESULT_ID);
						self.hide_waiting();
						self.tree_state = "loaded";
					}
				}
			});
		};
		fill(dispositions_codes, ROOT_RESULT_ID); // start fill
	};

	/*
	 * retrieves the results of the tree, and builds the list to be stored on the campaign.
	 */
	adm_form_campaigns_section_dispositions.prototype.get_tree_dispositions = function()
	{
		var self = this;

		// recursive function tha adds dispositions on the list
		var __MakeTree = function (current_result_id, dispositions)
		{
			var result_ids = self.tree.getSubItems(current_result_id).split(self.tree.dlmtr);
			if (!result_ids || (result_ids.length === 1 && result_ids[0].length === 0)) {
				return dispositions;
			}
			for (var ri = 0; ri < result_ids.length; ri++) {
				var result_id = result_ids[ri];
				var result = self.tree._getUserData(result_id);
				var number_of_childs = self.tree.hasChildren(result_id);
				if (number_of_childs > 0) {
					result = {
						name  : result.name,
						childs: __MakeTree(result_id, [])
					};
				}
				else {
					result.childs = null;
				}
				dispositions.push(result);
			}
			return dispositions;
		};

		var tree_dispositions = {
			dispositions: __MakeTree(ROOT_RESULT_ID, []) // start making tree
		};
		//tree_dispositions.levels = levels;

		return tree_dispositions;
	};

	adm_form_campaigns_section_dispositions.prototype.can_save_results = function(tree_dispositions)
	{
		var message, message_type, timeout_ms;

		if (this.saving) {
			//Esta validacion es para que no me puedan enviar mas de un request al mismo tiempo.
			message = "<%=_T('Another request is being saved, please wait until finish.')%>";
			message_type = "Info";
			timeout_ms = 2000;
			this.frm.show_status_message(message, message_type, timeout_ms);
			return false;
		}

		if (this.isAllegro()) {
			var resp = {overflowed: false, levels: 0, disposition: null};
			var allegro_supported_levels = 4;
			var __CountTreeLevels;

			__CountTreeLevels = function(list, levels)
			{
				if (!$.isArray(list)) {
					return resp;
				}
				levels++;
				if (levels > allegro_supported_levels) {
					resp.overflowed = true;
					resp.levels = levels;
					return resp;
				}
				for (var i = 0; i < list.length; i++) {
					var disposition = list[i];
					if ($.isArray(disposition.childs) && disposition.childs.length > 0) {
						resp = __CountTreeLevels(disposition.childs, levels);
						if (resp.overflowed) {
							if (!resp.disposition) {
								resp.disposition = disposition;
							}
							break;
						}
					}
				}
				return resp;
			};
			resp = __CountTreeLevels(tree_dispositions.dispositions, 0);

			if (resp.overflowed) {
				var disposition_name = resp.disposition ? resp.disposition.name : "";
				message = format("<%=_T('Unable to save dispositions with tree of {0} levels. Allegro tree dispositions supports {1} levels. Overflowed in branch of disposition: ({2})')%>", resp.levels, allegro_supported_levels, disposition_name);
				message_type = "Error";
				timeout_ms = false; // infinite
				this.frm.show_status_message(message, message_type, timeout_ms);
				return false;
			}
		}
		return true;
	};

	/*
	 * save results on campaign
	 */
	adm_form_campaigns_section_dispositions.prototype.save_results = function()
	{
		var self = this;

		var tree_dispositions = this.get_tree_dispositions();
		this.frm.hide_messages();
		if (!this.can_save_results(tree_dispositions)) {
			return;
		}

		var encoded_dispositions = JSON.stringify(tree_dispositions.dispositions);
		this.frm.dashboard.show_waiting("<%=_T('Please wait until disposition codes are saved.')%>");
		this.saving = true;

		this.frm.campaign.saveDispositionCodes(encoded_dispositions, function(error)
		{
			var message, message_type, timeout_ms;
			if (!error) {
				self.frm.campaign.dispositionCodes = encoded_dispositions;
				message = "<%=_T('Disposition codes have been saved successfully.')%>";
				message_type = "Info";
				timeout_ms = null; // default time
			}
			else {
				if (typeof error === "object") {
					error = ( error.result || "").toUpperCase();
				}
				switch (error)
				{
					case "ALLEGRO_INTEGRATION_ERROR":
						message = "<%=_T('Unable save campaign disposition codes. Allegro integration error.')%>";
						break;
					case "FORBIDDEN":
						message = "<%=_T('You dont have permissions for save dispositions.')%>";
						break;
					case "INVALID_REQUEST":
						message = "<%=_T('Invalid request.')%>";
						break;
					case "UNABLE_TO_SAVE":
						message = "<%=_T('Unable to save campaign disposition codes, please try again in a few minutes...')%>";
						break;
					default:
						message = "<%=_T('Failed to save disposition codes, please try again in a few minutes...')%>";
				}
				message_type = "Error";
				timeout_ms = false; // infinite
			}
			self.saving = false;
			self.frm.show_status_message(message, message_type, timeout_ms);
		});
	};

	adm_form_campaigns_section_dispositions.prototype.__can_configure_finalization_mail = function()
	{
		if (this.frm.campaign.has_accounts_of_proxy("mail") || this.frm.campaign.has_accounts_of_proxy("whatsapp") ||
			this.frm.campaign.has_accounts_of_proxy("facebook") || this.frm.campaign.has_accounts_of_proxy("instagram") || this.frm.campaign.has_accounts_of_proxy("twitter") ) {
			return true;
		}
		return false;
	};

	adm_form_campaigns_section_dispositions.prototype.__can_configure_reopen = function()
	{
		if (this.frm.campaign.has_async_accounts()) {
			return true;
		}
		return false;
	};

	adm_form_campaigns_section_dispositions.prototype.__can_configure_dial_code = function()
	{
		if (this.isAllegro()) {
			// VCCs con Allegro
			return true;
		}
		// VCCs Nativos
		if (!this.frm.campaign) {
			return false;
		}
		let OEConfig = this.frm.campaign.getOEConfig();
		if (!OEConfig) {
			return false;
		}
		// si
		return true;
	};

	/*
	 *	retrieve results from popup controls
	 */
	adm_form_campaigns_section_dispositions.prototype.get_result_from_controls = function(current_branch, current_result_id)
	{
		/*
			{
				name:               "No Compro",  (required)
				isGoal:              false,       (required)
				needReschedule :     true,        (required)
			}
		 */
		var result = {
			name: $("#adm_form_campaign_dispositions_result_name").val().trim()
		};
		// si se esta actualizando y es categoria (tiene hijos), unicamente retorna la descripcion del resultado.
		if (current_branch === null && this.tree.hasChildren(current_result_id) > 0) {
			return result;
		}
		result.isGoal = $("#adm_form_campaign_dispositions_is_goal").prop("checked");
		result.needReschedule = $("#adm_form_campaign_dispositions_need_rescheduled").prop("checked");
		result.cleanupLabels = $("#adm_form_campaign_dispositions_cleanup_labels").prop("checked");

		result.isDefaultForWrapUp =	$("#adm_form_campaign_dispositions_is_default_for_wrapup").prop("checked");
		
		if (this.__can_configure_finalization_mail()) {
			result.finalizationMessage = {
				enabled: $("#adm_form_campaign_dispositions_finalization").prop("checked")
			};
		}

		if (this.__can_configure_reopen()) {
			result.reopen = {
				enabled: !$("#adm_form_campaign_dispositions_can_not_reopen").prop("checked")
			};
			result.reopen.allowNewMessagesUntilDaysAfterClosing = !result.reopen.enabled && $("#adm_form_campaign_dispositions_allowNewMessagesAfterClosing_yes").prop("checked") ? Number($("#adm_form_campaign_dispositions_allowNewMessagesUntilDaysAfterClosing").val()) : 0;
		}

		if (this.isAllegro()) {
			result.code = $("#adm_form_campaign_dispositions_code").val();
			result.isUseFul = $("#adm_form_campaign_dispositions_is_useful").prop("checked");
			if ($("#adm_form_campaign_dispositions_dialer_connection_code").prop("checked")) {
				result.contactCode = $("#adm_form_campaign_dispositions_contact_result").val();
			}
		}
		else {
			if (this.__can_configure_dial_code()) {
				if ($("#adm_form_campaign_dispositions_dialer_connection_code").prop("checked")) {
					result.contactCode = $("#adm_form_campaign_dispositions_contact_result").val();
				}
			}
		}
		return result;
	};

	/*
	 * valid results on the popup controls
	 */
	adm_form_campaigns_section_dispositions.prototype.validate_results = function(result, current_branch, current_result_id)
	{
		var self = this;

		var $custom_message_container = $("#adm_form_campaign_dispositions_msg_error");
		var timeout_ms = false; // infinite

		var show_field_error = function(control_id, message)
		{
			$("#" + control_id + "_validation").show();
			$("#" + control_id).focus();
			var message_type = "Error";
			var scrolling = false;
			var show_custom_button = false;

			self.frm.show_status_message(message, message_type, timeout_ms, scrolling, show_custom_button, $custom_message_container);
		};

		this.hide_popup_errors();
		if (!result) {
			var message_type = "Error";
			this.frm.show_status_message("<%=_T('Error building the result.')%>", message_type);
			return false;
		}
		// validate result name.
		if (result.name.length === 0) {
			show_field_error("adm_form_campaign_dispositions_result_name", "<%=_T('Please enter the Result Name.')%>");
			return false;
		} 

		let validation_result = inConcert.Utils.validate(result.name, "id_with_spaces_customs_characters");
		if ( !validation_result.success ) {
			// valida que el name tenga al menos un caracter
			show_field_error("adm_form_campaign_dispositions_result_name", "<%=_T('Only letters, spaces, numbers and dashes are allowed in the Name.')%>");
			return false;
		}

		validation_result = inConcert.Utils.validate(result.name, "html_malicious_code");
		if ( !validation_result.success ) {
			// valida codigo malicioso
			show_field_error("adm_form_campaign_dispositions_result_name", "<%=_T('Possible malicious code in the field value.')%>");
			return false;
		}

		var already_exists = function() {
			var parent_id;

			if (current_branch === null) { // editing
				parent_id = self.tree.getParentId(current_result_id) || "0";
			} else { // new
				parent_id = current_result_id;
			}

			var sibling_ids = self.tree.getSubItems(parent_id).split(self.tree.dlmtr);
			sibling_ids = sibling_ids.length === 1 && sibling_ids[0] === "" ? [] : sibling_ids;

			for (var sibling_id_index = 0; sibling_id_index < sibling_ids.length; sibling_id_index++) {
				var sibling_result_name = JSON.parse(self.tree.getUserData(sibling_ids[sibling_id_index], "result")).name;

				if (sibling_result_name && result.name) {
					if (sibling_result_name.length === result.name.length && sibling_result_name.search(new RegExp(result.name, "i")) === 0) {
						return true;
					}
				}
			}
			return false;
		};

		var current_result;
		var is_new_result = current_branch !== null;

		if (is_new_result) {
		// si se va a agregar un nuevo resultado
			if (already_exists()) {
				show_field_error("adm_form_campaign_dispositions_result_name", "<%=_T('Unable to create result. Already exists result name.')%>");
				return false;
			}
		}
		else {
		// si se esta editando un resultado y se le esta cambiando el nombre, valida que este nombre nuevo ya no exista
			current_result = this.tree._getUserData(current_result_id);

			if ((current_result && current_result.name) && result.name) {
				if ((current_result.name.length !== result.name.length) || (current_result.name.search(new RegExp(result.name, "i"))) !== 0) {
					if (already_exists()) {
						show_field_error("adm_form_campaign_dispositions_result_name", "<%=_T('Unable to update result. Already exists result name.')%>");
						return false;
					}
				}
			}
		}

		//si tiene resultados (hijos), es categoria y unicamente se valida el nombre.
		if (current_branch === null && this.tree.hasChildren(current_result_id) > 0) {
			return true;
		}

		if (this.isAllegro()) {
			const $dispositions_code = $("#adm_form_campaign_dispositions_code");
			let msg_err = "<%=_T('Please enter the Result Code.')%>";
			let options, callback_err;

			if (!this.frm.validate_field($dispositions_code, "required", msg_err, options, callback_err, timeout_ms, $custom_message_container)) {
				return false;
			}

			msg_err = "<%=_T('Result Code is not a number.')%>";
			if (!this.frm.validate_field($dispositions_code, "digits", msg_err, options, callback_err, timeout_ms, $custom_message_container)) {
				return false;
			}

			let range = {between: {from: 0, to: 1000}};
			msg_err = format("<%=_T('Result Code value out of range. Please enter Result Code value between {0} and {1}.')%>", range.between.from, range.between.to );
			if (!this.frm.validate_field($dispositions_code, "range", msg_err, range, callback_err, timeout_ms, $custom_message_container)) {
				return false;
			}

			const already_exists_code = function()
			{
				let already = false;
				$.each( self.plain_results || {}, function( _, res_info )
				{
					if ( res_info.code === result.code ) {
						already = true;
						return false; //break
					}
				});
				return already;
			};

			if (is_new_result) {
			// si se va a agregar un nuevo resultado
				if (already_exists_code()) {
					show_field_error("adm_form_campaign_dispositions_code", "<%=_T('Unable to create result. Already exists Result Code.')%>");
					return false;
				}
			}
			else {
			// si se esta editando un resultado y se le esta cambiando el codigo, valida que este codigo nuevo ya no exista
				current_result = self.tree._getUserData(current_result_id);

				if ((current_result && current_result.code) && result.code) {
					if ((current_result.code.length !== result.code.length) || (current_result.code.search(new RegExp(result.code, "i"))) !== 0) {
						if (already_exists_code()) {
							show_field_error("adm_form_campaign_dispositions_code", "<%=_T('Unable to update result. Already exists Result Code.')%>");
							return false;
						}
					}
				}
			}
		}

		if (this.__can_configure_dial_code()) {
			if (typeof(result.contactCode) === "string" && result.contactCode.length === 0) {
				show_field_error("adm_form_campaign_dispositions_contact_result", "<%=_T('Please select the Contact Result Code.')%>");
				return false;
			}
		}

		return true;
	};

	/*
	 * get the last sub result id
	 */
	adm_form_campaigns_section_dispositions.prototype.get_last_sub_resultId = function(result_id)
	{
		if (!result_id) {
			return false;
		}
		var result_ids = this.tree.getSubItems(result_id).split(this.tree.dlmtr);
		if (!result_ids) {
			return false;
		}
		return result_ids[result_ids.length - 1];
	};

	/*
	 *	create and add result to the tree
	 */
	adm_form_campaigns_section_dispositions.prototype.create_result = function(self, result, current_result_id, current_branch)
	{
		var result_id = inConcert.Utils.generateGuid();
		var parent_node_id;
		if (current_branch === SIBLING_BRANCH) {
			// crea un hermano
			var parent_id = current_result_id;
			parent_node_id = self.get_last_sub_resultId(parent_id);
			if (parent_node_id === false) {
				return false;
			}
			self.add_sibling_result_to_tree(result, result_id, parent_node_id);
		}
		else {
			// crea un hijo
			parent_node_id = current_result_id;
			self.add_child_result_to_tree(result, result_id, parent_node_id);
		}
		if (result.isDefaultForWrapUp) {
			self.__off_all_check_auto_wrapup(self, result_id);
		}
		return true;
	};

	/*
	 *	update result on the tree
	 */
	adm_form_campaigns_section_dispositions.prototype.update_result = function(self, result, result_id)
	{
		var parent_id = self.tree.getParentId(result_id);
		var name = self.get_markup_result_name(result.name, result_id, parent_id);
		self.tree.setItemText(result_id, name);
		self.tree.setUserData(result_id, "result", JSON.stringify(result));

		let isDefaultForWrapUp = !self.plain_results[result_id].isDefaultForWrapUp && !self.plain_results[result_id].childs;
		self.plain_results[result_id] = result;

		if (isDefaultForWrapUp && result.isDefaultForWrapUp) {
			self.__off_all_check_auto_wrapup(self, result_id);
		}
		
		return true;
	};

	/*
	 * empty popup controls
	 */
	adm_form_campaigns_section_dispositions.prototype.clean_popup_controls = function()
	{
		$("#adm_form_campaign_dispositions_result_name").val("");
		$("#adm_form_campaign_dispositions_is_goal").prop("checked", false);
		$("#adm_form_campaign_dispositions_need_rescheduled").prop("checked", false);
		$("#adm_form_campaign_dispositions_is_default_for_wrapup").prop("checked", false);
		$("#adm_form_campaign_dispositions_cleanup_labels").prop("checked", false);
		if (this.__can_configure_finalization_mail()) {
			$("#adm_form_campaign_dispositions_finalization").prop("checked", false);
		}
		if (this.__can_configure_reopen()) {
			$("#adm_form_campaign_dispositions_can_not_reopen").prop("checked", false).trigger("change");
		}
		if (this.isAllegro()) {
			// VCCs integracion con Allegro
			$("#adm_form_campaign_dispositions_code").val("");
			$("#adm_form_campaign_dispositions_is_useful").prop("checked", false);
			$("#adm_form_campaign_dispositions_dialer_connection_code").prop("checked", false).trigger("change");
			$("#adm_form_campaign_dispositions_contact_result").val("");
		}
		else {
			// VCCs Nativos
			if (this.__can_configure_dial_code()) {
				$("#adm_form_campaign_dispositions_dialer_connection_code").prop("checked", false).trigger("change");
				$("#adm_form_campaign_dispositions_contact_result").val("");
			}
		}
	};

	/*
	 * update popup controls with result
	 */
	adm_form_campaigns_section_dispositions.prototype.update_popup_controls_with_result = function(result_id)
	{
		let result = this.tree._getUserData(result_id);
		if (!result) {
			return;
		}
		$("#adm_form_campaign_dispositions_result_name").val(result.name);
		//si tiene resultados (hijos), es categoria y unicamente debe visualizar la descripcion.
		if (this.tree.hasChildren(result_id) > 0) {
			return "CATEGORY_UPDATE";
		}
		$("#adm_form_campaign_dispositions_is_goal").prop("checked", result.isGoal || false);
		$("#adm_form_campaign_dispositions_need_rescheduled").prop("checked", result.needReschedule || false);
		$("#adm_form_campaign_dispositions_is_default_for_wrapup").prop("checked", ( result.isDefaultForWrapUp && (this.__isAutoWrapupTimeout() || this.__isChannelWithDefaultDisp())));
		$("#adm_form_campaign_dispositions_cleanup_labels").prop("checked", result.cleanupLabels || false);
		if (this.__can_configure_finalization_mail()) {
			$("#adm_form_campaign_dispositions_finalization").prop("checked", (result.finalizationMessage && result.finalizationMessage.enabled) || false);
		}
		if (this.__can_configure_reopen()) {
			$("#adm_form_campaign_dispositions_can_not_reopen").prop("checked", (result.reopen && !result.reopen.enabled) || false).trigger("change");
			if(result.reopen && result.reopen.allowNewMessagesUntilDaysAfterClosing && result.reopen.allowNewMessagesUntilDaysAfterClosing !== 0) {
				$("#adm_form_campaign_dispositions_allowNewMessagesAfterClosing_yes").trigger("click");
			}
			else {
				$("#adm_form_campaign_dispositions_allowNewMessagesAfterClosing_no").trigger("click");
			}
			$("#adm_form_campaign_dispositions_allowNewMessagesUntilDaysAfterClosing").val((result.reopen && result.reopen.allowNewMessagesUntilDaysAfterClosing) || 1);
		}
		const $dialer_connection_code = $("#adm_form_campaign_dispositions_dialer_connection_code");
		if (this.isAllegro()) {
			$("#adm_form_campaign_dispositions_code").val(result.code);
			$("#adm_form_campaign_dispositions_is_useful").prop("checked", result.isUseFul || false);
			if (result.contactCode) {
				$dialer_connection_code.prop("checked", true).trigger("change");
				$("#adm_form_campaign_dispositions_contact_result").val(result.contactCode);
			}
			else {
				$dialer_connection_code.prop("checked", false).trigger("change");
				$("#adm_form_campaign_dispositions_contact_result").val("");
			}
		}
		else {
			if (this.__can_configure_dial_code()) {
				if (result.contactCode) {
					$dialer_connection_code.prop("checked", true).trigger("change");
					$("#adm_form_campaign_dispositions_contact_result").val(result.contactCode);
				}
				else {
					$dialer_connection_code.prop("checked", false).trigger("change");
					$("#adm_form_campaign_dispositions_contact_result").val("");
				}
			}
		}
		return "RESULT_UPDATE";
	};

	/*
	 * show breadcrumbs on the popup
	 */
	adm_form_campaigns_section_dispositions.prototype.show_bread_crumbs = function(current_result_id)
	{
		var self = this;
		// funcion recursiva que obtiene el breadcrumbs a insertar en titulo del popup.
		var get_bread_crumbs = function(result_id) {
			if (result_id.toString() === ROOT_RESULT_ID) {
				return "";
			}
			var result = self.tree._getUserData(result_id);
			var parent_id = self.tree.getParentId(result_id);
			var bread_crumbs = get_bread_crumbs(parent_id);
			if (current_result_id === result_id) {
				// el current result no debe ser incluido en el bread crumbs
				return bread_crumbs;
			}
			return bread_crumbs + result.name + " > ";
		};
		var bread_crumbs = get_bread_crumbs(current_result_id);
		// largo maximo del bread crubms a mostrar en el titulo
		var truncate_bread_crumbs = function() {
			if (bread_crumbs.length === 0) {
				return "";
			}
			var max_length = 50;
			if (bread_crumbs.length > max_length) {
				bread_crumbs = "... " + bread_crumbs.substring(bread_crumbs.length - max_length);
			}
			return "' " + bread_crumbs + "'";
		};
		$("#adm_form_campaign_dispositions_bread_crumbs").text(truncate_bread_crumbs());
		// TODO: Habilitar el tooltip al breadcrumbs cuando se le pueda aplicar una clase acorde a su tamano.
		//$("#adm_form_campaign_dispositions_bread_crumbs").inconcert_tooltip({message: bread_crumbs});
	};

	/*
	 * displays the result on popup controls
	 */
	adm_form_campaigns_section_dispositions.prototype.show_result_popup = function( current_branch, current_result_id, on_save, is_new )
	{
		const self = this;
		let timeout_ms = false; //infinite
		if ( !this.has_permission_to_section() ) {
			const msg_err = is_new ?
				"<%=_T('Unable to create disposition: You dont have permissions for this action.')%>" :
				format( "<%=_T('Unable to view {0} disposition: You dont have permissions for this action.')%>", current_result_id || "" );
			this.frm.show_status_message( msg_err, "Error", timeout_ms );
			return;
		}

		const is_allegro_campaign = this.isAllegro();
		const can_configure_finalization_mail = this.__can_configure_finalization_mail();
		const can_configure_reopen = this.__can_configure_reopen();
		const can_show_connection_code = is_allegro_campaign || true; //this.__can_configure_reopen();

		const can_show_field = function($element)
		{
			const result_extra_data = $element.attr("result_extra_data");

			if (result_extra_data === "both") {
				const element_for_finalization = $element.attr("finalization");
				if (element_for_finalization) {
					if (can_configure_finalization_mail) {
						return true; // lo visualiza
					}
				}
				else {
					const element_for_reopen = $element.attr("reopen");
					if (element_for_reopen) {
						if (can_configure_reopen) {
							return true; // lo visualiza
						}
					}
					else {
						if (self.__can_configure_dial_code()) {
							const element_for_connection_code = $element.attr("connection_code");
							if (element_for_connection_code) {
								if (can_show_connection_code) {
									return true; // lo visualiza
								}
							}
						}
					}
				}
			}
			else if (result_extra_data === "allegro") {
				if (is_allegro_campaign) {
					$("#if_is_allegro_col6").removeClass("col-12");
					$("#if_is_allegro_col6").addClass("col-6");

					return true; // lo visualiza
				}
				else {
					$("#if_is_allegro_col6").removeClass("col-6");
					$("#if_is_allegro_col6").addClass("col-12");

					return false; // NO lo visualiza
				}
			}
			else if (result_extra_data === "omnichannel") {
				return true; // lo visualiza
			}

			// NO lo visualiza
			return false;
		};

		const __on_ready = function( success, msg_err )
		{
			if (!success) {
				self.frm.show_status_message(msg_err, "Error", timeout_ms);
				return;
			}
			self.show_or_hide_required_message(true);
			const $result_popup = $("#adm_form_campaign_dispositions_popup_edit");

			// esta funcion diferencia el popup de categorias con el de resultados.
			const show_result_or_category = function() {
				if (current_branch !== null || current_result_id === ROOT_RESULT_ID || self.tree.hasChildren(current_result_id) === 0) {
					// Es resultado si:
						// se esta creando un resultado,
						// o si es el resultado raiz,
						// o si esta actualizando y no tiene ningun hijo
					$("#adm_form_campaign_dispositions_popup_edit").find("div[result_extra_data]").each(function(_, element)
					{
						const $element = $(element);
						const must_show = can_show_field($element);
						if (must_show) {
							$element.show();
						}
						else {
							$element.hide();
						}
					});
				}
				else {
					// Es categoria si:
					// esta actualizando y tiene hijos
					$("#adm_form_campaign_dispositions_popup_edit .formExtraDataRow[result_extra_data]").hide();
					$("#if_is_allegro_col6").removeClass("col-6");
					$("#if_is_allegro_col6").addClass("col-12");
				}
			};
			//  - Si el parametro << current_branch >> no es NULL, se esta creando un resultado.
			// - Si el mismo es NULL, se esta actualizando un resultado o categoria.
			//
			// Y segun esto se deben visualizar/ocultar diferentes controles como tambien actualizarlos.
			//
			const is_new_result = current_branch !== null;
			if (is_new_result) {
				// se crean unicamente resultados.
				//
				if (SON_BRANCH === current_branch && ROOT_RESULT_ID !== current_result_id && self.tree.hasChildren(current_result_id) === 0) {
					// si esta agregando hijos, y es el primer hijo, los valores se heredan del padre menos sus nombre.
					// y en el caso de allegro tampoco se hereda el codigo.
					self.update_popup_controls_with_result(current_result_id);
					$("#adm_form_campaign_dispositions_result_name").val("");
					if (self.isAllegro()) {
						$("#adm_form_campaign_dispositions_code").val("");
					}
				}
				else {
					// deja en blanco todos lo controles
					self.clean_popup_controls();
				}
				$("#adm_form_campaign_dispositions_popup_title").text("<%=_T('Add Result')%>");
				$("#adm_form_campaign_dispositions_create_result").show();
				$("#adm_form_campaign_dispositions_create_and_continue_result").show();
				$("#adm_form_campaign_dispositions_update_result").hide();

				if (self.isAllegro()) {
					$("#adm_form_campaign_dispositions_popup_edit").removeClass("popUp520w").addClass("popUp940w");
					$(".formCheckboxesRow").find(".col-12")
							.addClass("col-4")
							.removeClass("col-12");
				} else {
					$("#adm_form_campaign_dispositions_popup_edit").removeClass("popUp940w").addClass("popUp520w");
					$(".formCheckboxesRow").find(".col-4")
						.addClass("col-12")
						.removeClass("col-4");
				}

				$("#adm_form_campaign_dispositions_allowNewMessagesAfterClosing_no").trigger("click");
			}
			else {
				// se actualizan tanto las categorias como los resultados.
				let popup_title = "<%=_T('Update Result')%>";

				if (self.isAllegro()) {
					$("#adm_form_campaign_dispositions_popup_edit").removeClass("popUp520w").addClass("popUp940w");
					$(".formCheckboxesRow").find(".col-12")
							.addClass("col-4")
							.removeClass("col-12");
				} else {
					$("#adm_form_campaign_dispositions_popup_edit").removeClass("popUp940w").addClass("popUp520w");
					$(".formCheckboxesRow").find(".col-4")
						.addClass("col-12")
						.removeClass("col-4");
				}

				if (self.update_popup_controls_with_result(current_result_id) === "CATEGORY_UPDATE") {
					popup_title = "<%=_T('Update category')%>";
					$("#adm_form_campaign_dispositions_popup_edit").removeClass("popUp940w").addClass("popUp520w");
					$(".formCheckboxesRow").find(".col-4")
						.addClass("col-12")
						.removeClass("col-4");
				}
				$("#adm_form_campaign_dispositions_popup_title").text(popup_title);
				$("#adm_form_campaign_dispositions_create_result").hide();
				$("#adm_form_campaign_dispositions_create_and_continue_result").hide();
				const $update_button = $("#adm_form_campaign_dispositions_update_result");
				if (self.is_readonly()) {
					$update_button.hide();
				}
				else {
					$update_button.show();
				}
			}

			show_result_or_category();
			self.show_bread_crumbs(current_result_id);
			self.hide_popup_errors();
			const isShowCheck = is_new_result || self.tree.hasChildren(current_result_id) === 0;
			self.__showCheckDefaultDispForAutoWrapupTimeout(isShowCheck);

			$result_popup.show();
			$("#adm_form_campaign_dispositions_result_name").focus();
		};

		// eventos del popup
		this.set_events_popup(function() {
			const result = self.get_result_from_controls(current_branch, current_result_id);
			if (!self.validate_results(result, current_branch, current_result_id)) {
				return false;
			}
			return on_save(self, result, current_result_id, current_branch);
		});

		// realizo los request y carga de los combos y despues procedo a visualizar el popup.
		this.__load_popup_data(__on_ready);
	};

	adm_form_campaigns_section_dispositions.prototype.show_tree_panel = function()
	{
		this.show_or_hide_required_message(false);
		this.frm.hide_messages();
		$("#adm_form_campaign_dispositions_popup_edit").hide();
		$("#adm_form_campaign_dispositions_tree_panel").show();
	};

	adm_form_campaigns_section_dispositions.prototype.__isAutoWrapupTimeout = function()
	{
		//-1 Verifico auto wrap up automatico
		if (this.frm.campaign.getThreshold("CHAT", "AutoWrapupTimeout"))
		{
			return true;
		}
		
		return false;
	};

	adm_form_campaigns_section_dispositions.prototype.__isChannelWithDefaultDisp = function()
	{
		if (this.frm.campaign.CheckInteractionType("MAIL"))
		{
			return true;
		}

		if (this.frm.campaign.CheckInteractionType("INSTAGRAM"))
		{
			return true;
		}

		if (this.frm.campaign.CheckInteractionType("FACEBOOK"))
		{
			return true;
		}

		if (this.frm.campaign.CheckInteractionType("WHATSAPP"))
		{
			return true;
		}

		if (this.frm.campaign.CheckInteractionType("YOUTUBE"))
		{
			return true;
		}

		if (this.frm.campaign.CheckInteractionType("SMS"))
		{
			return true;
		}
		
		return false;
	};

	adm_form_campaigns_section_dispositions.prototype.__showCheckDefaultDispForAutoWrapupTimeout = function(show)
	{
		const $check = $("#adm_form_campaign_dispositions_is_default_for_wrapup_container");
		if( show && (this.__isAutoWrapupTimeout() || this.__isChannelWithDefaultDisp()) ){
			$check.show();
		}
		else {
			$check.hide();
		}
	};

	adm_form_campaigns_section_dispositions.prototype.__off_all_check_auto_wrapup = function(self, current_result_id)
	{
		for (const id in self.plain_results) {
			if (self.plain_results.hasOwnProperty(id) && id !== current_result_id) {
				self.plain_results[id].isDefaultForWrapUp = false;
				self.tree.setUserData(id, "result", JSON.stringify(self.plain_results[id]));				
			}
		}
	};

	/*
	 * remove the tree result
	 */
	adm_form_campaigns_section_dispositions.prototype.delete_result = function( result_id )
	{
		var self = this;
		this.frm.hide_messages();
		var result = this.tree._getUserData(result_id);
		var childs = this.tree.getAllSubItems(result_id).split(this.tree.dlmtr);
		var is_result = (childs.length === 1 && childs[0].length === 0) ? true : false;
		var message = function() {
			var message = is_result ?
				"<%=_T('Do you want to delete disposition {0} ?')%>" :
				"<%=_T('Do you want to delete category {0} ?')%>";
			return format(message, result.name);
		}();

		jQuery.inconcertPopup.Show(
			"<%=_T('Confirm')%>",
			message,
			jQuery.inconcertPopup.ButtonSets.BS_YESNO,
			function(response) {

				if (response.toLowerCase() !== "yes") {
					return;
				}
				if ( !self.has_permission_to_section() || !self.has_permission_to_save() ) {
					var result = self.tree._getUserData( result_id );
					var message = format( "<%=_T('Unable to delete {0} disposition: You dont have permissions for this action.')%>", result.name || "" );
					self.frm.show_status_message( message, "Error", 5000 );
					return;
				}
				self.tree.deleteItem(result_id);
				delete self.plain_results[result_id];
				self.show_or_hide_not_results_found();
			},
			undefined,
			{
				popup_id        : "conf_inconcertPopup",
				container_class : "confirmationPopUp",
				overlay_class   : "confirmationOverlay"
			}
		);
	};

	/*
	 * Realiza la carga de los combos y lista mediante request al server.
	 */
	adm_form_campaigns_section_dispositions.prototype.__load_popup_data = function(callback = $.noop)
	{
		const self = this;

		if (this.isAllegro()) {
			// VCCs con Allegro
			const allegro_api = inConcert.app.getAllegroAPI();
			allegro_api.loadDialerContactResults(function(success, list) {
				if (!success) {
					const msg_err = "<%=_T('Error retrieving inconcert allegro dialer contact results.')%>";
					callback( false, msg_err );
					return;
				}
				const __get_descr = function( _, row ) { return _T(row.DisplayName) || _T(row.Name); };

				self.frm.fill_combo( $( "#adm_form_campaign_dispositions_contact_result" ),
					true,         // blank first item
					list,
					"Value",     // id
					__get_descr, // desc
					true         // sorted
				);
				callback( true );
			});
			return;
		}
		else {
			// VCC Nativos.
			const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
			let channel = "CALL";
			outbound_engine_api.systemRulesLoadResponsesByChannel(function(success, list) {
				if (!success) {
					const msg_err = "<%=_T('Error retrieving inconcert dialer contact results.')%>";
					callback(false, msg_err);
					return;
				}

				let contactsResults = [];
				list.forEach(action_result => {
					if (channel === "ANY" || action_result.channels[channel]) {
						contactsResults.push(action_result);
					}
				});

				self.frm.fill_combo( $( "#adm_form_campaign_dispositions_contact_result" ),
					true,         // blank first item
					contactsResults,
					"id",     // id
					function( _, row ) { return row.name || _T(row.id); }, // desc
					true         // sorted
				);
				callback( true );
			});
		}
	};

	/*
	 * initialize all popup events
	 */
	adm_form_campaigns_section_dispositions.prototype.set_events_popup = function(on_save)
	{
		var self = this;

		$("#adm_form_campaign_dispositions_create_result")
			.off("click")
			.on("click", function() {
				if (on_save()) {
					self.show_tree_panel();
				}
			}
		);
		$("#adm_form_campaign_dispositions_create_and_continue_result")
			.off("click")
			.on("click", function() {
				if (on_save()) {
					$("#adm_form_campaign_dispositions_result_name").val("").focus();
				}
			}
		);
		$("#adm_form_campaign_dispositions_update_result")
			.off("click")
			.on("click", function() {
				if (on_save()) {
					self.show_tree_panel();
				}
			}
		);
		$("#adm_form_campaign_dispositions_cancel_result")
			.off("click")
			.on("click", function() {
				self.show_tree_panel();
			});

		$("#adm_form_campaign_dispositions_cancel_result_times")
			.off("click")
			.on("click", function() {
				self.show_tree_panel();
			});
			
		$("#adm_form_campaign_dispositions_result_name")
			.off("keyup")
			.on("keyup", function(e) {
				if (e.keyCode !== 13) {
					return;
				}
				var $cmd_update = $("#adm_form_campaign_dispositions_update_result");
				var $cmd_create_and_continue = $("#adm_form_campaign_dispositions_create_and_continue_result");
				if ($cmd_create_and_continue.is(":visible")) {
					$cmd_create_and_continue.trigger("click");
				}
				else {
					$cmd_update.trigger("click");
				}
			});
		$("#adm_form_campaign_dispositions_dialer_connection_code")
			.off("change")
			.on("change", function() {
				var is_checked = $(this).prop("checked");
				var $contact_result_panel = $("#adm_form_campaign_dispositions_contact_result_panel");
				var $contact_result = $("#adm_form_campaign_dispositions_contact_result");
				if (is_checked) {
					$contact_result_panel.show();
					$contact_result.focus();
				}
				else {
					$contact_result_panel.hide();
				}
			});
		$("#adm_form_campaign_dispositions_can_not_reopen")
			.off("change")
			.on("change", function() {
				var is_checked = $(this).prop("checked");
				$("#adm_form_campaign_dispositions_allowNewMessagesAfterClosing_container").toggle(is_checked);
			});
		$("#adm_form_campaign_dispositions_allowNewMessagesAfterClosing_no")
			.off("click")
			.on("click", function() {	
				self.on_changed_allowNewMessagesAfterClosing($(this).val());
			});	
		$("#adm_form_campaign_dispositions_allowNewMessagesAfterClosing_yes")
			.off("click")
			.on("click", function() {	
				self.on_changed_allowNewMessagesAfterClosing($(this).val());
			});
	};

	/*
	 * initialize all form events
	 */
	adm_form_campaigns_section_dispositions.prototype.set_events_form = function()
	{
		var self = this;
		/////////
		var $tree = $("#adm_form_campaign_dispositions_tree_results");
		var event_selector = ".gridActionButton.edit";
		$tree
			.off("click", event_selector)
			.on("click", event_selector, function() {
				var current_result_id = self.tree.getSelectedItemId();
				var on_save = self.update_result;
				self.show_result_popup( null, current_result_id, on_save );
			}
		);

		event_selector = ".gridActionButton.new";
		$tree
			.off("click", event_selector)
			.on("click", event_selector, function() {
				var current_result_id = $(this).parent().attr("result_id");
				if (!current_result_id) {
					throw("Result id does not exist on tree markup!!");
				}
				var on_save = self.create_result;
				self.show_result_popup( SON_BRANCH, current_result_id, on_save, true /* is_new */ );
			}
		);

		event_selector = ".gridActionButton.delete";
		$tree
			.off("click", event_selector)
			.on("click", event_selector, function() {
				var result_id = $(this).parent().attr("result_id");
				if (!result_id) {
					throw("Result id does not exist on tree markup!!");
				}
				self.delete_result(result_id);
			}
		);

		var $cancel = $("#adm_form_campaign_dispositions_cancel");
		$cancel
			.off("click")
			.on("click", function() {
				self.frm.close();
			}
		);

		if (this.is_readonly()) {
			$cancel.attr("value", "<%=_T('Close')%>");
			return;
		}

		$("#adm_form_campaign_dispositions_save")
			.off("click")
			.on("click", function() {
				self.save_results();
			}
		);

		$("#adm_form_campaign_dispositions_popup_new_result")
			.off("click")
			.on("click", function() {
				// si el nodo raiz tiene hijos (resultados o categorias), agrega en la rama hijos, sino en la rama hermanos
				var current_branch = self.tree.hasChildren(ROOT_RESULT_ID) === 0 ? SON_BRANCH : SIBLING_BRANCH;
				var on_save = self.create_result;
				self.show_result_popup( current_branch, ROOT_RESULT_ID, on_save, true /* is_new */ );
			}
		);
	};

	/*
	 *	initilize window
	 */
	adm_form_campaigns_section_dispositions.prototype.initialize = function( force )
	{
		var self = this;

		this.closed = false;
		if ( force ) {
			this.tree = null;
			$( "#adm_form_campaign_dispositions_tree_results" ).html("");
		}
		else {
			if ( this.tree ) {
				return;
			}
		}
		this.tree_state = "unloaded";
		this.saving = false; // flag utilizada para no enviar mas de un request de save, si se encuentra uno en curso.
		// initialize tree
		var image_paths = function() {
			var skin_names = {
				skinDark  : "dark",
				skinLight : "light",
				skinNew   : "new"
			};
			var current_skin = inConcert.app.getMainWindow().getCurrentSkin() || "";
			var skin_name = skin_names[current_skin] || skin_names.skinLight;
			return "/inconcert/apps/agent/images/" + skin_name + "/tree/2023/";
		}();
		this.tree = new dhtmlXTreeObject("adm_form_campaign_dispositions_tree_results", "100%", "100%", 0);
		this.tree.setImagePath(image_paths);
		this.tree.setStdImages("csh_books/leaf.svg","csh_books/folderOpen.svg","csh_books/folderClosed.svg");
		this.tree.setImageArrays("plus", "plus2.svg","plus3.svg","plus4.svg","plus.svg","plus5.svg");
		this.tree.setImageArrays("minus", "minus2.svg","minus3.svg","minus4.svg","minus.svg","minus5.svg");
		this.tree.setLinesImages("line2.svg", "line3.svg","line4.svg","blank.svg","blank.svg","line1.svg");

		this.tree.enableDragAndDrop(true);
		this.tree.enableHighlighting(true);
		this.tree.setOnDblClickHandler(function(result_id) {
			var on_save = self.update_result;
			self.show_result_popup( null, result_id, on_save );
		});
		this.tree.setDragHandler(function(/*sourceId, targetId*/) {
			return true;
		});
		this.tree._getUserData = function(result_id) {
			return JSON.parse(this.getUserData(result_id, "result"));
		};
		//initialize events
		this.set_events_form();

		if (!this.isAllegro()) {
			$("#adm_form_campaign_dispositions_popup_edit").find("div[result_extra_data]").hide();
		}

		this.clean_popup_controls();

		//initialize tooltips
		/*
		 * TODO: habilitar cuando se solucione problema de los tooltips
		 * que no se posicionan correctamente dentro de un scroll
		 * (mas especificamente dentro del scroll del tree de dhtmlx)
		 *
		 *
		$(".butResultAdd[tooltip]").inconcert_tooltip();
		$(".butResultEdit[tooltip]").inconcert_tooltip();
		$(".butResultDelete[tooltip]").inconcert_tooltip();
		*/

		this.show_or_hide_not_results_found();
	};

	adm_form_campaigns_section_dispositions.prototype.set = function(_)
	{
		this.initialize();
	};

	adm_form_campaigns_section_dispositions.prototype.dispose = function()
	{
		if ( this.tree ) {
			this.tree.deleteChildItems(ROOT_RESULT_ID);
			this.tree.destructor();
			this.tree = null;
		}
		this.plain_results = {};
		this.closed = true;
	};

	adm_form_campaigns_section_dispositions.prototype.editable = function()
	{
		adm_form_campaigns_section_dispositions.uber.editable.call( this );

		$("#adm_form_campaign_dispositions_save")
			.prop("disabled", false)
			.show();

		$("#adm_form_campaign_dispositions_tree_panel > .addResultContainer")
			.prop("disabled", false)
			.show();
	};

	adm_form_campaigns_section_dispositions.prototype.readonly = function()
	{
		adm_form_campaigns_section_dispositions.uber.readonly.call( this );

		$("#adm_form_campaign_dispositions_save")
			.prop("disabled", true)
			.hide();

		$("#adm_form_campaign_dispositions_tree_panel > .addResultContainer")
			.prop("disabled", true)
			.hide();
	};

	adm_form_campaigns_section_dispositions.prototype.on_show = function()
	{
		adm_form_campaigns_section_dispositions.uber.on_show.call(this, {show: false});

		this.fill_tree(this.frm.campaign.dispositionCodes);

		this.frm.dashboard.$get_dom_element_by_id("form_buttons_actions").hide();

		var has_perm_to_section_previous_state = this.has_permission_to_section();
		var has_perm_to_save_previous_state = this.has_permission_to_save();

		if ( this.has_perm_to_section_previous_state === undefined || this.has_perm_to_save_previous_state === undefined ) {
			this.has_perm_to_section_previous_state = has_perm_to_section_previous_state;
			this.has_perm_to_save_previous_state = has_perm_to_save_previous_state;
		}
		else {
			if ( this.has_perm_to_section_previous_state !== has_perm_to_section_previous_state || this.has_perm_to_save_previous_state !== has_perm_to_save_previous_state ) {
				this.initialize( true /* force */ ); // inicializo el tree en el nuevo estado
				this.has_perm_to_section_previous_state = has_perm_to_section_previous_state;
				this.has_perm_to_save_previous_state = has_perm_to_save_previous_state;
			}
		}

		var is_readonly = this.is_readonly();
		if ( is_readonly ) {
			this.readonly();
		}
		else {
			this.editable();
		}
	};

	adm_form_campaigns_section_dispositions.prototype.show_not_results_found = function( message )
	{
		$("#" + this.codes_not_result_found)
			.text( message || "<%=_T('No disposition codes found.')%>" )
			.show();

		$("#" + this.tree_results).hide();
	};

	adm_form_campaigns_section_dispositions.prototype.hide_not_results_found = function()
	{
		$("#" + this.tree_results).show();
		$("#" + this.codes_not_result_found).hide();
	};

	adm_form_campaigns_section_dispositions.prototype.show_or_hide_not_results_found = function()
	{
		if ( !this.tree || !this.tree.htmlNode || this.tree.htmlNode.childsCount === 0) {
			this.show_not_results_found();
			return;
		}
		this.hide_not_results_found();
	};

	adm_form_campaigns_section_dispositions.prototype.on_changed_allowNewMessagesAfterClosing = function(selectedOption)
	{
		$("#adm_form_campaign_dispositions_allowNewMessagesUntilDaysAfterClosing_days_container").toggle(selectedOption === "1");
	};
}());
