/*jshint quotmark:false*/
/*global inConcert */
/*
Ha
*/
// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	//---------------------------------------------------------------------
	// form campaigns class - schedule section
	function adm_form_campaigns_section_schedule( params )
	{
		var self = this;

		var success = adm_form_campaigns_section_schedule.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.view_action_id = "view_campaigns_schedule";  // view action id de permisos
		this.save_action_id = "save_campaign_schedule"; // action id de permisos

		this.schedule_hnd = new inConcert.conf_form_schedule({
			frm         : this.frm,
			owner       : this,
			prefix      : "adm_form_campaign_schedule",
			container_id: "adm_form_campaign_schedule_container",
			callbacks: {
				can_configure_special_days: function() {
					if (!self.frm.campaign) {
						return false;
					}
					//return self.frm.campaign.isAllegro();
					return true;
				},
				save: function(scheduler, callback) {
					self.save_scheduler(scheduler, callback);
				}
			}
		});

		return true;
	}

	inConcert.Utils.inherit( adm_form_campaigns_section_schedule, inConcert.conf_form_section );

	if ( typeof inConcert.adm_form_campaigns_section_schedule !== "function" ) {
		inConcert.adm_form_campaigns_section_schedule = adm_form_campaigns_section_schedule;
	}

	adm_form_campaigns_section_schedule.prototype.save_scheduler = function(scheduler, callback)
	{
		var self = this;
		this.frm.campaign.saveScheduler(scheduler, function(success, error) {
			self.frm.campaign.scheduler = scheduler;
			callback(success, error);
		});
	};

	adm_form_campaigns_section_schedule.prototype.set_events = function()
	{
		this.schedule_hnd.initialize();
	};

	adm_form_campaigns_section_schedule.prototype.set = function( /*campaign*/ )
	{
		this.schedule_hnd.set(this.frm.campaign.scheduler);
	};

	adm_form_campaigns_section_schedule.prototype.editable = function()
	{
		// La siguiente linea de codigo la dejo comentada, solo como referencia, ya que especificamente en esta seccion no se utiliza ( de momento )
		//   las propias acciones de editable la realiza la funcion de propia clase.
		//
		// adm_form_campaigns_section_schedule.uber.editable.call( this );
		this.schedule_hnd.editable();
	};

	adm_form_campaigns_section_schedule.prototype.readonly = function()
	{
		// La siguiente linea de codigo la dejo comentada, solo como referencia, ya que especificamente en esta seccion no se utiliza ( de momento )
		//   las propias acciones de readonly la realiza la funcion de propia clase.
		//
		// adm_form_campaigns_section_schedule.uber.readonly.call( this );
		this.schedule_hnd.readonly();
	};

	adm_form_campaigns_section_schedule.prototype.on_show = function()
	{
		adm_form_campaigns_section_schedule.uber.on_show.call(this, {show: false});
		this.frm.dashboard.$get_dom_element_by_id("form_buttons_actions").hide();

		var is_readonly = this.is_readonly();
		if ( is_readonly ) {
			this.readonly();
		}
		else {
			this.editable();
		}
	};

	adm_form_campaigns_section_schedule.prototype.on_hide = function()
	{
		adm_form_campaigns_section_schedule.uber.on_hide.call( this );
		this.schedule_hnd.on_owner_hide();
	};

	adm_form_campaigns_section_schedule.prototype.dispose = function()
	{
		this.schedule_hnd.on_owner_hide();
	};

}());
