/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */
/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

//	"use strict";

	//---------------------------------------------------------------------
	// form channels class
	function adm_form_channels( params )
	{
		var success = adm_form_channels.uber.constructor.call( this, params );
		if ( !success ) {
			return;
		}

		this.view_title        = "<%=_T('Attention Capability')%>";
		this.update_title      = "<%=_T('Update Attention Capability')%>";
		this.update_ok_message = "<%=_T('Attention Capability was successfully updated.')%>";

		this.html_file_name    = "/inconcert/apps/administration/channels/frm/render/";
		this.save_uri          = "/inconcert/apps/administration/channels/save/";
		this.get_uri           = "/inconcert/apps/administration/channels/get/";

		this.capability_handle = new inConcert.adm_capability_handle({
			override_type : "NONE",
			container_id  : "adm_form_channels_capability_config",
			prefix_id     : "adm_form_channels_",
			parent_frm    : this,
			parent_type   : "FORM",
			proxies       : {
				CALL      : true,
				VOICEMAIL : true,
				WEBCONTACT: true,
				FACEBOOK  : true,
				INSTAGRAM : true,
				YOUTUBE	  : true,
				APPSTORE  : true,
				GOOGLEPLAY: true,
				RCS       : true,
				IM        : true,
				MAIL      : true,
				TWITTER   : true,
				CHAT      : true,
				SMS       : true,
				WHATSAPP  : true
			}
		});

		return true;
	}

	inConcert.Utils.inherit( adm_form_channels, inConcert.conf_form );

	if ( typeof inConcert.adm_form_channels !== "function" ) {
		inConcert.adm_form_channels = adm_form_channels;
	}

	adm_form_channels.prototype.initialize = function()
	{
		this.capability_handle.initialize();
	};

	adm_form_channels.prototype.get = function()
	{
		return this.capability_handle.get();
	};

	adm_form_channels.prototype.set = function( success, channels )
	{
// TODO: #4636 - Esto no debe de estar aca!!.
//   Este set events, NO se tiene que invocar aca; a esto lo realiza de forma automatica
//   la clase base "conf_form", pero si ahora no lo realizo asi, tengo un problema en el formulario de campanas.
//   Entonces, hasta que esto se encuentre en el ultimo build de mcwarren queda aca, y lo arreglo ahi,
//   en el ultimo build de mcwarren.
//   Como esta se esta tocando en el build 1962, el ultimo congelado a la fecha, prefiero tocar puntal y que esto funcione, para lo que se necesita, y luego que este en mcwarren, revisar y arreglar correctamente.
//   Revisar en "conf_form.prototype.ready", donde se realiza el set(..) del frm.

		this.capability_handle.set( success, channels );
		this.disable_restore_button( true );
		return true;
	};

	adm_form_channels.prototype.uri_get_entity = function()
	{
		return inConcert.app.getBaseDomain() + this.get_uri;
	};

	adm_form_channels.prototype.get_validation_def = function()
	{
		return this.capability_handle.get_validation_def();
	};

	adm_form_channels.prototype.ready_for_update = function()
	{
		adm_form_channels.uber.ready_for_update.call(this);
		const $restore = $("#adm_form_channels_capability_config_restore");
		$restore.show();
	};

	adm_form_channels.prototype.ready_for_save = function()
	{
		adm_form_channels.uber.ready_for_save.call(this);
		if (this.instance_config?.show_view_readonly !== false) {
			return this.no_close();
		}

		const _class = "edit-mode-channels-container";
		$("#adm_form_channels_capability_container").removeClass(_class).addClass(_class);
	};

	adm_form_channels.prototype.save_execute = function( after_save, entity /*, hash_id */ )
	{
		var self = this;

		var callback = function( success, response )
		{
			var err;
			if ( !success ) {
				err = response;
			}
			self.on_saved( success, entity, after_save, err );
		};

		delete entity.isNew;
		var api = this.dashboard.get_api();
		api.save({
			uri     : inConcert.app.getBaseDomain() + this.save_uri,
			data    : entity,
			callback: callback
		});
	};

	adm_form_channels.prototype.on_saved = function( success, entity, after_save, err )
	{
		adm_form_channels.uber.on_saved.call( this, success, entity, after_save, err ); //invokes the base class method
		this.disable_restore_button( true );
		this.dashboard.hide_waiting();
	};

	adm_form_channels.prototype.disable_restore_button = function( disabled )
	{
		const $restore = $("#adm_form_channels_capability_config_restore");
		$restore.prop( "disabled", disabled );
	};

	adm_form_channels.prototype.restore_values = function()
	{
		if ( this.is_readonly() ) {
			return;
		}
		// restore values
		var old_values = this.capability_handle.get_old_values();
		var success = this.capability_handle.set( true, old_values );
		if ( success ) {
			this.disable_restore_button( true );
		}
	};

	adm_form_channels.prototype.no_close = function()
	{
		//this.restore_values();
		this.readonly();
		this.set_title(this.view_title);
		$("#adm_form_channels_capability_config_edit").show();
		$("#adm_form_channels_capability_config_restore").hide();
		this.capability_handle.readonly();
		$("#adm_form_channels_capability_container").removeClass("edit-mode-channels-container");
	};

	adm_form_channels.prototype.build_footer_custom_buttons = function()
	{
		const html_buttons = '<button id="adm_form_channels_capability_config_edit" class="pageButtonGeneric pageButtonNew buttonColorOrange" type="button" hidden style="display: none;"><i class="fal fa-pencil"></i><%=_T("Edit")%></button>' +
		'<button id="adm_form_channels_capability_config_restore" class="buttonToggle buttonToggleOutlined" type="button" hidden style="display: none;" title="<%=_T("Undo changes")%>" disabled><i class="far fa-undo"></i></button>';
		adm_form_channels.uber.build_footer_custom_buttons.call(this, html_buttons);
	};

	adm_form_channels.prototype.readonly = function()
	{
		adm_form_channels.uber.readonly.call(this); //invokes the base class method
		$("#adm_form_channels_capability_config_restore").hide();
	};

	adm_form_channels.prototype.set_events = function()
	{
		const self = this;
		adm_form_channels.uber.set_events.call(this); //invokes the base class method

		$("#adm_form_channels_capability_config_edit")
			.off("click")
			.on("click", function() {
				self.set_readonly(false);
				self.reopen_view({
					extra_parameters:{
						show_view_readonly: false
					}
				});
			});

		$("#adm_form_channels_capability_config_restore")
			.off("click")
			.on("click", function() {
				self.restore_values();
			});
	};

}());
