/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

    const format = inConcert.Utils.format;

	var templates =  {
		popup_create: ("").concat(
			'<div class="internalPopUpContainer formPopUp">',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					"<div id='adm_form_databases_create_panel_waiting' class='internalWaitingContainer' style='display:none;'>",
						"<div waiting_message='true' class='internalWaitingMessage'></div>",
						"<div class='internalWaitingAnimation'></div>",
						"<div class='internalWaitingOverlay'></div>",
					"</div>",
					// title
					'<div class="internalPopUpTitle">',
						'<span><%=_T("New Database")%></span>',
						'<button id="adm_form_databases_create_panel_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					//
					'<div class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div id="adm_form_databases_create_panel_error_message" class="genericFormMessagesContainer messageError" style="display:none;"></div>',
						// text inputs
						'<div class="card no-card">',
							'<div class="card-block">',
								'<div id="adm_form_databases_create_panel_basic">',
									'<div class="row">',
										'<div class="col-6">',
											'<div class="form-group">',
												'<label for="adm_form_databases_create_panel_name" class="required"> <%=_T("Name")%><%=_T(":")%></label>',
												'<input id="adm_form_databases_create_panel_name" class="form-control" type="text" placeholder="', '<%=_T("Enter name")%>...', '" />',
												'<i id="adm_form_databases_create_panel_name_validation" class="formFieldValidation formFieldError" hidden></i>',
											'</div>',
										'</div>',
										'<div class="col-6">',
											'<div class="form-group">',
												'<label for="adm_form_databases_create_panel_description" class="required"> <%=_T("Description")%><%=_T(":")%></label>',
												'<input id="adm_form_databases_create_panel_description" class="form-control" type="text" placeholder="', '<%=_T("Enter description")%>...', '" />',
												'<i id="adm_form_databases_create_panel_description_validation" class="formFieldValidation formFieldError" hidden></i>',
											'</div>',
										'</div>',
									'</div>',
								'</div>',	
							'</div>',
						'</div>',
					'</div>',
					'<div class="internalPopUpButtons d-flex justify-content-end">',
						"<button id='adm_form_databases_create_panel_cancel' class='pageButtonGeneric buttonColorWhite'>" + "<%=_T('Cancel')%>" + "</button>",
						"<button id='adm_form_databases_create_panel_confirm' class='pageButtonGeneric buttonColorBlue'>" + "<%=_T('Confirm')%>" + "</button>",
					'</div>',
				'</div>',
			'</div>'
		),
		edit_base_info : ("").concat(
			'<div id="adm_form_databases_edit_section_design_info_attention" class="inlineMessagesContainer messageWarning">',
				'<strong><%=_T("Attention")%></strong> <%=_T("Tables with greater than {0} rows will be purged by the job.")%>',
			'</div>',
			'<div class="card no-card">',
				'<div class="card-block">',
					'<div class="row">',
						'<div class="col-6">',
							'<div class="card-header card-header-md">',
								'<h5><%=_T("Basic information")%></h5>',
							'</div>',
						'</div>',
					'</div>',
					'<div class="row">',
						'<div class="col-6">',
							'<div class="form-group">',
								'<label for="adm_form_databases_edit_section_design_info_name" class="required"><%=_T("Name")%><%=_T(":")%></label>',
								'<input id="adm_form_databases_edit_section_design_info_name" class="form-control" value="{{Name}}" type="text" disabled/>',
							'</div>',
						'</div>',
						'<div class="col-6">',
							'<div class="form-group">',
								'<label for="adm_form_databases_edit_section_design_info_description" class="required"><%=_T("Description")%><%=_T(":")%></label>',
								'<input id="adm_form_databases_edit_section_design_info_description" class="form-control" value="{{Description}}" type="text" disabled/>',
							'</div>',
						'</div>',
					'</div>',
					'<div class="row">',
						'<div class="col-6 col-lg-3">',
							'<div class="form-group">',
								'<label for="adm_form_databases_edit_section_design_info_used_space" class="required"><%=_T("Used Space")%><%=_T(":")%></label>',
								'<input id="adm_form_databases_edit_section_design_info_used_space" class="form-control" value="{{Sizing}}Mb" type="text" disabled />',
							'</div>',
						'</div>',
						'<div class="col-6 col-lg-3">',
							'<div class="form-group">',
								'<label for="adm_form_databases_edit_section_design_info_free_space" class="required"><%=_T("Open Space")%><%=_T(":")%></label>',
								'<input id="adm_form_databases_edit_section_design_info_free_space" class="form-control" value="{{OpenSpace}}Mb" type="text" disabled/>',
							'</div>',
						'</div>',
					'</div>',
					'<div class="row">',
						'<div class="col-12">',
							'<div class="card-header">',
								'<h5><%=_T("History")%></h5>',
							'</div>',
						'</div>',
					'</div>',
					'<div class="row">',
						'<div class="col-3">',
							'<div class="form-group">',
								'<label for="adm_form_databases_edit_section_design_info_creation_date" class="required"><%=_T("Creation Date")%><%=_T(":")%></label>',
								'<input id="adm_form_databases_edit_section_design_info_creation_date" class="form-control" value="{{CreationDate}}" type="text" disabled/>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',
			'</div>'
		),
		edit_general_table : ("").concat(
			'<li id="adm_form_databases_edit_section_design_general_table_{{Name}}">',
				'<div class="d-flex flex-column">',
					'<label class="ic-menu-title">{{Name}}</label>',
					'<label class="ic-menu-info"><%=_T("Fields")%>: <span>{{ NumFields }}</span></label>',
				'</div>',
				'<button table_action_menu class="buttonToggle">',
						'<i class="far fa-ellipsis-v"></i>',
				'</button>',
			'</li>'
		),
		edit_general_sp : ("").concat(
			'<li id="adm_form_databases_edit_section_design_general_sp_{{Name}}">',
				'<div class="d-flex flex-column">',
					'<label class="ic-menu-title">{{Name}}</label>',
				'</div>',
				'<button sp_action_menu class="buttonToggle">',
						'<i class="far fa-ellipsis-v"></i>',
				'</button>',
			'</li>'
		),
		edit_general_table_field_list_header: ("").concat(
			"<div class='row'>" +
				"<div class='col-12'>" +
					'<div class="ruleFieldTitle">',
						'<label class="ruleFieldTitleText flex-grow-1"><%=_T("Column Name")%></label>',
						'<label class="ruleFieldTitleText ruleFieldSelect"><%=_T("Data Type")%></label>',
						'<label class="ruleFieldTitleText ruleFieldLength"><%=_T("Length")%></label>',
						'<label class="ruleFieldTitleText ruleFieldCheck"><%=_T("Not Null")%></label>',
						'<label class="ruleFieldTitleText ruleFieldCheck"><%=_T("Required")%></label>',
						'<label class="ruleFieldActionButtons"></label>',
					'</div>',
				'</div>',
			'</div>'
		),
		edit_general_table_field_list: ("").concat(
			"<div class='row ruleField'>" +
				"<div class='col-12'>" +
					"<div class='ruleFieldContent'>" +
						"<div class='form-group flex-grow-1'>" +
							'<input field_column_name type="text" value="" class="form-control mt-0"></input>' +
						"</div>" +
						"<div class='form-group ruleFieldSelect'>" +
							'<select field_data_type class="formListField form-control">' +
							'</select>' +
						"</div>" +
						"<div class='form-group ruleFieldLength'>" +
							'<input field_length type="text" value="" class="form-control mt-0"></input>' +
						"</div>" +
						"<div class='form-group d-flex align-items-center field_not_null_check_container'>" +
							'<div class="form-check mr-0">' +
								'<label for="ruleField_field_not_null" class="form-check-label form-check-label-title">' +
									'<input field_not_null id="ruleField_field_not_null" class="form-check-input form-check-blue" type="checkbox">' +
								'</label>' +
							"</div>" +
						"</div>" +
						"<div class='form-group d-flex align-items-center ruleFieldCheck'>" +
							'<div class="form-check mr-0">' +
								'<label for="ruleField_field_key" class="form-check-label form-check-label-title">' +
									'<input field_key id="ruleField_field_key" class="form-check-input" type="checkbox">' +
								'</label>' +
							"</div>" +
						"</div>" +
						"<div class='ruleFieldButtons form-group d-flex align-items-end'>" +
							'<button field_remove class="buttonToggle ruleFieldDelete" title="' + ' <%=_T("Delete")%> ' + '"><i class="far fa-minus-circle"></i></button>' +
							'<button field_add class="buttonToggle ruleFieldAdd" title="' + ' <%=_T("Add")%> ' + '"><i class="far fa-check-circle"></i></button>' +
						"</div>" +
					"</div>" +
				"</div>" +
			"</div>"
		),
		edit_console_title : ("").concat(
			'<h5 id="adm_form_databases_edit_section_console_header">{1}</h5>',
		)
	};

    function adm_form_databases(params)
	{
		var success = adm_form_databases.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		this.view_title     = "<%=_T('Databases')%>";
		this.update_title   = "<%=_T('Database {0}')%>";
		this.tagline = "<%=_T('Tagline form Databases!!!')%>";

		this.html_file_name = "/inconcert/apps/administration/databases/frm/render/";
		this.delete_uri     = "/inconcert/apps/administration/databases/delete/";
		this.get_uri		= "/inconcert/apps/administration/databases/get/"
		this.include_save_and_continue = false;
		this.m_upload_instance = null;
		this.m_timeout_handle_hide_message = null;
		this.m_uploader = null;
		return true;
	};

	inConcert.Utils.inherit(adm_form_databases, inConcert.conf_form);

	if (typeof inConcert.adm_form_databases !== "function") {
		inConcert.adm_form_databases = adm_form_databases;
	}

	adm_form_databases.prototype.set = function(success, _)
	{
		if(!success){
			this.hide_header_custom_actions();
		}

		this.instance_db_design = new adm_database_design({
			form : this
		});
	};

	adm_form_databases.prototype.build_header_custom_buttons = function()
	{
		const html_buttons = 
		// '<div class="customPageButtonContainer">'+
			//'<button id="adm_form_databases_edit_console_btn" class="pageButtonGeneric pageButtonNew buttonColorWhite pageButtonRightSeparator " type="button"><i class="far fa-database"></i> <%=_T("SQL")%></button>'+
			// '<button id="adm_form_databases_edit_add_tables_btn" class="pageButtonGeneric pageButtonNew buttonColorWhite" type="button"><i class="far fa-table"></i> <%=_T("Add Table")%></button>'+
			// '<button id="adm_form_databases_edit_add_sp_btn" class="pageButtonGeneric pageButtonNew buttonColorWhite" type="button"><%=_T("Add Stored Procedures")%></button>'+	
		// '</div>'+
		'<button id="adm_form_databases_back_btn" class="pageButtonGeneric buttonColorWhite" type="button"><%=_T("Cancel")%></button>'+
		'<button id="adm_form_databases_confirm_changes_btn" class="pageButtonGeneric buttonColorBlue" type="button" disabled><%=_T("Confirm Changes")%></button>'

		adm_form_databases.uber.build_header_custom_buttons.call(this, html_buttons);
	};

    adm_form_databases.prototype.render = function( $row, instance_config)
	{
		const config_db = inConcert.app.getDetabasesConfig();

		if ( !$row) {
			if(this.total_rows() < config_db.LimitNumber)
			{
				// new database popup
				return this.popup_render();
			}
			else{
				this.show_status_message_in_view( "<%=_T('Can not create database, exceeds limit')%>", "Info", 5000 );
				return;
			}
		}
		this.toggle_full_screen("HIDE-NAVIGATION");
		adm_form_databases.uber.render.call(this, $row,instance_config);
	};

	adm_form_databases.prototype.total_rows = function()
	{
		const $total_rows = this.$get_dom_element_by_id("view_total_rows");
		return parseInt($total_rows.attr("total"), 10);
	};
	
    adm_form_databases.prototype.popup_html = function()
	{
		return templates.popup_create;
	};

	adm_form_databases.prototype.toggle_full_screen = function(force_action)
	{
		force_action = force_action || "NONE";
		
		const $navigation = this.$get_dom_element_by_id("navigation");
		
		if (force_action === "HIDE-NAVIGATION") {
			this.dashboard.$dashboard.addClass("confEditFullScreenMode dbCustomPage");
			$navigation.hide();
		}
		else if(force_action === "SHOW-NAVIGATION") {
			this.dashboard.$dashboard.removeClass("confEditFullScreenMode dbCustomPage");
			$navigation.show();
		}
	};

    adm_form_databases.prototype.__edit_new_db_added = function(data)
	{
        //Pasar a la ventana de disenno de database
		let $rows = this.dashboard.view.$get_rows();
		if (!$rows) {
			return;
		}
		let $last_row_append;
		$.each($rows, function(_, row) {
			const attr = $(row).attr("row_id");
			if(attr === data.Name.toLowerCase()){
				$last_row_append = $(row)
				return false; // break
			}
		});
		if (!$last_row_append) {
			return;
		}
		this.dashboard.view.grid_execute_action("edit", $last_row_append);
	};

	adm_form_databases.prototype.show_error_panel = function(message, timeout_ms, $control, $container, timeout_callback = $.noop)
	{
		const self = this;
		($container || $("#adm_form_databases_create_panel_error_message")).text( message ).show();
			if ( $control ) {
				const validation_id = $control.attr("id") + "_validation";
				$("#" + validation_id).show();
				$control.focus();
			}
			else{
				$("#adm_form_databases_create_panel_error_message").focus();
			}

			if (timeout_ms) {
				this.m_timeout_handle_hide_message = window.setTimeout(function() {
					self.hide_error_panel();
					timeout_callback();
				}, timeout_ms);
			}
	};

	adm_form_databases.prototype.hide_error_panel = function($container)
	{
		($container || $("#adm_form_databases_create_panel_error_message")).text("").hide();
		if (this.m_timeout_handle_hide_message) {
			window.clearTimeout(this.m_timeout_handle_hide_message);
			this.m_timeout_handle_hide_message = null;
		}
	};

    adm_form_databases.prototype.validate_new_database = function(callback)
	{
		this.popup_hide_errors();

		const $name = $("#adm_form_databases_create_panel_name");
		const $description = $("#adm_form_databases_create_panel_description");
			// requerido
			if (!$name.val()) { 
				this.show_error_panel("<%=_T('Name is required.')%>", 5000, $name);
				return callback(false);
			}
			if (!inConcert.Utils.isValid($name.val(), "id_without_dots_underscore")) {
				this.show_error_panel("<%=_T('Only letters and numbers are allowed in database name.')%>", 5000, $name);
				return callback(false);
			}
			if ($name.val().length > 64 ) {
				this.show_error_panel(format("<%=_T('Please enter a valid value with length between {0} and {1}.')%>", 1 ,64), 5000, $name);
				return callback(false);
			}
			if (!$description.val()) {
				this.show_error_panel("<%=_T('Description is required.')%>", 5000, $description);
				return callback(false);
			}

		//Validation OK
		const data = {
			Name : $name.val(),
			Description : $description.val()
		};

        callback(true, data);
	};

    adm_form_databases.prototype.create_database = function()
	{
		var self = this;
		this.validate_new_database(function(success, data) {
			if (!success) {
				return;
			}
			self.dashboard.show_waiting("<%=_T('Please wait, creating database')%>");
			var callback = function( success, response)
			{
				self.dashboard.hide_waiting();
				
				if ( success ) {
					if(response.result === "DATABASE_ALREADY_EXIST")
					{
						self.show_error_panel( "<%=_T('The database already exists.')%>", 5000, $("#adm_form_databases_create_panel_name"));
						return;
					}
					const config_db = inConcert.app.getDetabasesConfig();
					if(self.total_rows() + 1 >= config_db.LimitNumber)
					{
						const btn_create = self.dashboard.view.$get_dom_element_by_id("view_button_new");
						btn_create.prop("disabled", true);
						btn_create.prop("title", `<%=_T('Can not create database, exceeds limit')%> (${config_db.LimitNumber}).`);
					}
					self.popup_hide();
					self.grid_refresh(function(success) {
						if(success){
						   self.__edit_new_db_added(data);
						}
					});
				}
				else{
					self.popup_hide();
					if(response && response.error && response.error.reason){
						self.show_status_message_in_view(format("<%=_T('{0}')%>",response.error.reason), "Error", 5000);
					}
					else{
						self.show_status_message_in_view( "<%=_T('Error creating database')%>", "Error", 5000);
					}
					
				}
			};

			var api = self.dashboard.get_api();
			api.save({
				uri     : inConcert.app.getBaseDomain() + "/inconcert/apps/administration/databases/create/",
				data    : data,
				callback: callback
			});
			
		});
	};

    adm_form_databases.prototype.popup_set_events = function()
	{
        var self = this;
        $("#adm_form_databases_create_panel_confirm")
        .off("click")
        .on("click", function() {
            self.create_database();
        });

    	$("#adm_form_databases_create_panel_cancel")
        	.off("click")
        	.on("click", function() {
            	self.popup_hide();
        	});
		
		$("#adm_form_databases_create_panel_cancel_times")
        	.off("click")
        	.on("click", function() {
            	self.popup_hide();
        	});
	};
	
	adm_form_databases.prototype.dispose = function(){
		adm_form_databases.uber.dispose.call(this);
		if(this.instance_db_design){
			this.instance_db_design.destroy();
			this.instance_db_design = null;
		}

		if(this.inst_import_table_values){
			this.inst_import_table_values.destroy();
			this.inst_import_table_values = null;

		}
	}

	adm_form_databases.prototype.close = function( action ){
		adm_form_databases.uber.close.call(this,action);

		if(action === "cancel"){
			if(this.instance_db_design){
				this.instance_db_design.ask_output_confirmation_tables(function(success) {
					if(success){
						this.toggle_full_screen("SHOW-NAVIGATION");
						this.grid_refresh();
					}
				});
			}
			else{
				this.toggle_full_screen("SHOW-NAVIGATION");
				this.grid_refresh();
			}
		}
	};

	 adm_form_databases.prototype.__show_waiting_upload_create_popup = function(msg)
	{
		const $waiting = $("#adm_form_databases_create_panel_waiting");
		$waiting.show();
		$waiting.find("[waiting_message]").text(msg || "<%=_T('Loading')%>");
	};

	adm_form_databases.prototype.apply_initial_config = function()
	{
		if(!this.is_readonly()){
		this.hide_header_system_actions();
		}
	};

	

//--------------------------------------------------------------

	function adm_database_design(params)
	{
		this.form = params.form;
		this.database = this.form.entity
		this.config_db = inConcert.app.getDetabasesConfig();
		this.database.OpenSpace = this.config_db.Sizing - parseFloat(this.database.Sizing);
		if (this.database.OpenSpace < 0) {
			this.database.OpenSpace = 0;
		}
		this.container_section = "#adm_form_databases_edit_section";
		this.$console = $(this.container_section + "_console");
		this.$design = $(this.container_section + "_design");
		this.$design_tables = $(this.container_section + "_design_tables");
		this.$section_info = $(this.container_section + "_design_info");
		this.$general_header = $(this.container_section + "_general_header");
		this.$console_btn_execute = $(this.container_section + "_console_btn_execute");
		this.$console_btn_result = $(this.container_section + "_console_btn_view_results_table");
		this.$console_btn_result_text = $(this.container_section + "_console_btn_view_results_table span");
		this.$tables_container = $(this.container_section + "_general_tables_container");
		this.$sp_container = $(this.container_section + "_general_sp_container");
		this.initialize()
	};

	adm_database_design.prototype.initialize = function(){
		this.make_markup_basic_info();
		this.make_markup_code_block();
		this.make_markup_tables();
		this.make_markup_stored_procedures();
		this.set_events();
		this.on_read_only();
		this.has_permission_to_execute();
		this.has_permission_to_export();
	};

	adm_database_design.prototype.has_permission_to_execute = function(){
		this.has_permission_to_execute = this.form.dashboard.permissions.to_action(this.form.dashboard.current_app, "executedatabase");
	};

	adm_database_design.prototype.has_permission_to_export = function(){
		this.has_permission_to_export = this.form.dashboard.permissions.to_action(this.form.dashboard.current_app, "exportdatabase");
	};

	adm_database_design.prototype.on_read_only = function(){
		
		if(!this.form.is_readonly()){
			return;
		}

		const $msg_attention = $(this.container_section + "_design_info_attention");
		$msg_attention.hide();
	};

	

	adm_database_design.prototype.is_read_only = function(){
		//Solo dejar ver lista de tablas y SP
		if (this.form.is_readonly()) {
			this.form.show_status_message("<%=_T('You do not have permission for this action.')%>", "Error", 6000);
			return true;
		}

		return false;
	};

	adm_database_design.prototype.__is_there_free_space = function(hideMsg){
		//Si existe espacio
		if(this.config_db.Sizing > parseFloat(this.database.Sizing)){
			return true;
		}
		
		if(!hideMsg){
			this.form.show_status_message("<%=_T('Base datos sizing is complete.')%>", "Error", 5000);
		}
		return false;
	};

	adm_database_design.prototype.refresh_database_data = function(callback = $.noop){
		this.form.show_waiting("<%=_T('Please wait, updating data')%>");
		const self = this;
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/databases/get/" + this.database.Name,
			type: "GET",
			success: function(database) {
				self.database = database;
				let size = (self.config_db.Sizing - parseFloat(database.Sizing));
				if (size < 0) {
					size = 0;
				}
				self.database.OpenSpace = size;
				callback(true);
				self.form.hide_waiting();
			},
			error: function(_, error) {
				self.form.hide_waiting();
				self.form.show_status_message("<%=_T('Error updating')%>", "Error", 5000);
				callback(false);
			}
		});
	};

	adm_database_design.prototype.__collapse_console_results = function(collapse, $container_output_console, isToggleBtnResult){
		$container_output_console = $container_output_console || $("#adm_form_databases_edit_section_console_output_container");
		this.nInterval = null;
		const self = this;
		if(collapse){
			this.$console_btn_result.removeClass("collapsed").addClass("collapsed");
			$("#adm_form_databases_edit_section_console_code_block_container").removeClass("CodeBlockCollapsedHalf").addClass("CodeBlockCollapsed");
			this.$console_btn_result.prop("disabled", false);
			this.$console_btn_result_text.html("<%=_T('Hide results')%>");
			$container_output_console.show();
			$container_output_console.removeClass("collapsed").removeClass("collapsedHalf").addClass("collapsed");
			self.nInterval = setInterval(function() {
				if (self.codeBlock) {// Se agrega timeout, ya q el collapsed lleva una transicion
					self.codeBlock.resize();
				}
			}, 100);
		}
		else{
			this.$console_btn_result.removeClass("collapsed").removeClass("collapsedHalf");
			$("#adm_form_databases_edit_section_console_code_block_container").removeClass("CodeBlockCollapsedHalf").removeClass("CodeBlockCollapsed");
			this.$console_btn_result_text.html("<%=_T('View results')%>");
			$container_output_console.removeClass("collapsed");

			if (isToggleBtnResult) {
				$("#adm_form_databases_edit_section_console_code_block_container").addClass("CodeBlockCollapsedHalf");
				$container_output_console.addClass("collapsedHalf");
				this.$console_btn_result.prop("disabled", false);
			}
			else{
				$container_output_console.hide();
				this.$console_btn_result.prop("disabled", true);
			}
		}

		if (self.codeBlock) {// Se agrega timeout, ya q el collapsed lleva una transicion 0.4 seg
			if (this.m_timeout_resize_codeblock) {
				this.m_timeout_resize_codeblock = null;
			}
			this.m_timeout_resize_codeblock = window.setTimeout(function() {
				if (self.nInterval) {
					clearInterval(self.nInterval);
				}
				else{
					self.codeBlock.resize();
				}
			}, 900);
		}
	};
	adm_database_design.prototype.__make_console_title = function(options){

		const $console_deader = $(this.container_section + "_console_header_container");
		$console_deader.html("")
		let icon = '<i class="far fa-database"></i>';
		let title = "<%=_T('SQL Console')%>";
		if(options && options.Type === "TABLE"){
			icon = '<i class="far fa-table"></i>';
			title = "<%=_T('New table')%>" + ((options.Data && options.Data.Name)? format("{0}", options.Data.Name ): "");
		}
		else if(options && options.Type === "SP")
		{
			let action = "New";
			let subtitle = " <%=_T('New procedure')%>";
			if (options.Action === "Edit") {
				action = "Edit";
				subtitle = ""; //<%=_T('Edit procedure')%>
			}
			icon = '<i class="far fa-folder fa-stack-2x"></i><i class="fas fa-cog fa-stack-1x"></i>';
			title = subtitle + "<span class='table"+ action +"'>" + ((options.Data && options.Data.Name)? format("{0}", options.Data.Name ): "") + "</span>";
			
		}
		$console_deader.html(format(templates.edit_console_title, icon, title));
	};

	adm_database_design.prototype.__open_close_console = function(open, query, callback = $.noop){
		this.codeBlock.getSession().setValue(" ");
		const $btn_console = $("#adm_form_databases_edit_console_btn");
		const $btn_addtable = $("#adm_form_databases_edit_add_tables_btn");
		this.__collapse_console_results(false);
		
		if(open){

			if(this.options_query_by_sql_console)
			{
				this.codeBlock.setReadOnly(this.options_query_by_sql_console.Import);
			}
			else{
				this.__remove_class_active();
				this.codeBlock.setReadOnly(false);
			}
			this.$design.hide();
			this.$console.show();
			$btn_console.hide();
			$btn_addtable.addClass("pageButtonRightSeparator");
			this.__make_console_title(this.options_query_by_sql_console);
		}
		else{
			this.$console.hide();
			this.$design.show();
			$btn_addtable.removeClass("pageButtonRightSeparator");
			$btn_console.show();

			if(this.options_query_by_sql_console)
			{
				this.options_query_by_sql_console = null;
			}
		}
		this.__formatQueryInCodeBlock(query);
		callback();
	};

	adm_database_design.prototype.refresh_info_sizing = function () {
		$(this.container_section + "_design_info_used_space").val(this.database.Sizing + "Mb");
		$(this.container_section + "_design_info_free_space").val(this.database.OpenSpace + "Mb");
	};

	adm_database_design.prototype.toggle_tables = function(){
		const $sp = $(this.container_section + "_general_sp_container");
		const $sp_title =  $(this.container_section + "_general_sp_title");
		const $tables = $(this.container_section + "_general_tables_container");
		const $tables_title =  $(this.container_section + "_general_tables_title");
		
		$tables.find("#collapseTables").removeClass("show").addClass("show");
		$tables_title.removeClass("collapsed").addClass("collapsed");
		$tables_title.attr('aria-expanded', 'true');

		$sp.find("#collapseSProcedures").removeClass("show");
		$sp_title.removeClass("collapsed");
		$sp_title.attr('aria-expanded', 'false');
	};

	adm_database_design.prototype.toggle_stored_procedures = function(){
		const $sp = $(this.container_section + "_general_sp_container");
		const $sp_title =  $(this.container_section + "_general_sp_title");
		const $tables = $(this.container_section + "_general_tables_container");
		const $tables_title =  $(this.container_section + "_general_tables_title");
		
		$tables.find("#collapseTables").removeClass("show");
		$tables_title.removeClass("collapsed");
		$tables_title.attr('aria-expanded', "false");

		$sp.find("#collapseSProcedures").removeClass("show").addClass("show");
		$sp_title.removeClass("collapsed").addClass("collapsed");
		$sp_title.attr('aria-expanded', 'true');
		
	};

	adm_database_design.prototype.show_basic_info = function(){
		this.__open_close_console(false);
		this.$design.children().hide();
		this.$section_info.show();
	};

	adm_database_design.prototype.save_changes= function(){
		//Si existen cambios para la tabla selecionada
		const self = this;
		const data_to_update = this.get_table_data_to_manage();
		if(data_to_update.TableFields && Object.keys(data_to_update.TableFields).length > 0){
		
			const callback = function(success) {
				if(success){
					self.refresh_database_data(function(success){
						if(success)
						{
						 self.refresh_info_sizing();
						 self.make_markup_tables();
						}
						$("#adm_form_databases_confirm_changes_btn").prop("disabled", true);
						if(self.list_fields_to_manage){
							self.list_fields_to_manage = null;
						}
						self.select_last_table_updated(data_to_update.TableName);
					});
					
				}
			};
		
		//Request para eliminar tabla
		this.form.show_waiting("<%=_T('Please wait, Saving data')%>");
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/databases/update/",
			type: "POST",
			dataType    : "json",
			contentType : "application/json",
			data : JSON.stringify(data_to_update),
			success: function(/*response*/) {
				self.form.hide_waiting();
				callback(true);
			},
			error: function(_, error) {
				self.form.hide_waiting();
				if(error && error.error && error.error.reason){
					self.form.show_status_message(format("<%=_T('{0}')%>",error.error.reason), "Error", 5000);
				}
				else{
					self.form.show_status_message("<%=_T('Error saving data')%>", "Error", 5000);
				}
				callback(false);
			}
		});
		}
		else{
			$("#adm_form_databases_confirm_changes_btn").prop("disabled", true);
			self.form.show_status_message("<%=_T('No changes to save')%>", "Info", 5000);
		}
	};

	adm_database_design.prototype.__remove_class_active = function()
	{
		this.$general_header.removeClass("active");
		$(this.container_section + " li").removeClass("active");
	};

	adm_database_design.prototype.__after_executed_console = function()
	{
		this.refresh_info_sizing();
		this.update_title_stored_proc();
		this.update_title_tables();
		this.make_markup_tables();
		this.make_markup_stored_procedures();
		this.select_to_edit_last_sp_updated();
	};

	adm_database_design.prototype.set_events = function(){
		const self = this;
		this.$general_header
        	.off("click")
        	.on("click", function() {
				self.__remove_class_active();
				$(this).removeClass("active").addClass("active");
				const $section_info = $(self.container_section + "_design_info");
				if($section_info.is(":hidden")){
					self.ask_output_confirmation_tables(function(success){
						if(success){
							self.__open_close_console(false);
							self.$design.show();
							self.$design.children().hide();
							self.$section_info.show();
						}
					});
				}
        	});
		
		$("#adm_form_databases_edit_console_btn")
        	.off("click")
        	.on("click", function(e, query) {
				if (!query && !self.has_permission_to_execute) {
					self.form.show_status_message("<%=_T('You do not have permission for this action.')%>", "Error", 5000);
					return;
				}
				self.ask_output_confirmation_tables(function(success){
					if(success){
						self.__open_close_console(true, query);
					}
				});
        	});

		$("#adm_form_databases_edit_add_sp_btn")
        	.off("click")
        	.on("click", function(e) {
				self.ask_output_confirmation_tables(function(success){
					if(success){
						self.$general_header.trigger("click");
						self.show_popup_create();
					}
				});
				e.preventDefault();
				e.stopPropagation();
        	});

		$("#adm_form_databases_edit_add_tables_btn")
        	.off("click")
        	.on("click", function(e) {
				if(self.__is_there_free_space()){
				self.ask_output_confirmation_tables(function(success){
					if (success) {
						self.$general_header.trigger("click");
						self.show_popup_create(true);
					}
				});
				e.preventDefault();
				e.stopPropagation();
			}
        	});

		$("#adm_form_databases_back_btn")
			.off("click")
        	.on("click", function() {
				self.ask_output_confirmation_tables(function(success){
					if (success) {
						self.__remove_class_active();
						self.form.close("cancel");
					}
				});
        	});

		$("#adm_form_databases_confirm_changes_btn")
			.off("click")
        	.on("click", function() {
				self.save_changes();
        	});

        this.$console_btn_execute
			.off("click")
        	.on("click", function() {
				self.__executeCodeBlock(function(success) 
				{
					if(success)
					{
						self.refresh_database_data(function (success) {
							if(success)
							{
								self.__after_executed_console();
							}
						});
					}
				});
        	});

		this.$console_btn_result
        	.off("click")
        	.on("click", function() {
				const $console_container = $("#adm_form_databases_edit_section_console_output_container");
				const isHalfOutputResult = $console_container[0].classList.contains("collapsedHalf");
				self.__collapse_console_results(isHalfOutputResult, $console_container, true);
        	});

	};

	adm_database_design.prototype.ask_output_confirmation_tables = function(callback = $.noop){
		const self = this;
		if(this.list_fields_to_manage && Object.keys(this.list_fields_to_manage).length > 0 && !this.$design_tables.is(":hidden")){
			this.ask_confirm(function(success) {
				if (success) {
					self.list_fields_to_manage = null;
					const $save = $("#adm_form_databases_confirm_changes_btn");
					$save.prop("disabled", true);
				}
				callback(success);
			}, "<%=_T('The current changes will be lost. Do you want continues?')%>");
		}else{
			callback(true);
		}
	};

	adm_database_design.prototype.ask_confirm = function(callback = $.noop, sub_title){
		const self = this;
		$.inconcertPopup.Show(
			"<%=_T('Confirm')%>",
			sub_title || "",
			$.inconcertPopup.ButtonSets.BS_YESNO,
			function(response) {
				callback(response.toLowerCase() === "yes");
			},
			undefined,
			{
				popup_id        : "conf_inconcertPopup",
				container_class : "confirmationPopUp",
				overlay_class   : "confirmationOverlay"
			}
		);
	};

	adm_database_design.prototype.update_title_tables = function(){
		const tables = this.database.tables;
		let $tables_title = this.$tables_container.find("[general_tables_title]"); ;
		$tables_title.html(format("<%=_T('Tables')%> <span>({0})</span>", Object.keys(tables).length))
	};

	adm_database_design.prototype.update_title_stored_proc = function(){
		const stored_proc = this.database.stored_procedures;
		let $sp_title = this.$sp_container.find("[general_sp_title]"); ;
		$sp_title.html(format("<%=_T('Stored Procedures')%> <span>({0})</span>", Object.keys(stored_proc).length))
	};
	
	adm_database_design.prototype.execute_delete_table_or_sp = function(data, callback){
		const self = this;
		//Request para eliminar tabla
		this.form.show_waiting("<%=_T('Please wait, Deleting')%>");
		data.Database = self.database.Name;
		data.RowsNumber = self.config_db.RowsNumber
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/databases/delete_table_sp/",
			type: "POST",
			dataType    : "json",
			contentType : "application/json",
			data : JSON.stringify(data),
			success: function(/*response*/) {
				self.form.hide_waiting();
				callback(true);
			},
			error: function(response, error) {
				self.form.hide_waiting();
				if(error && error.error && error.error.reason){
					self.form.show_status_message("<%=_T('Error Deleting')%> " + format("<%=_T('{0}')%>",error.error.reason), "Error", 5000);
				}
				else{
					self.form.show_status_message("<%=_T('Error Deleting')%>", "Error", 5000);
				}
				
				callback(false);
			}
		});
	};

	adm_database_design.prototype.__listFieldDataTypes = function() {
		const data_types = [
			{ id : "int", label : "<%=_T('INTEGER')%>" },
			{ id : "tinyint", label : "<%=_T('BOOLEAN')%>" },
			{ id : "decimal", label : "<%=_T('DECIMAL')%>" },
			{ id : "double", label : "<%=_T('DOUBLE')%>" },
			{ id : "varchar", label : "<%=_T('VARCHAR')%>" },
			{ id : "text", label : "<%=_T('TEXT')%>" },
			{ id : "datetime", label : "<%=_T('DATETIME')%>" },
			{ id : "time", label : "<%=_T('TIME')%>" },
			{ id : "date", label : "<%=_T('DATE')%>" },
		];

		return data_types;
	};

	adm_database_design.prototype.__is_new_field_type_compatible = function(oldFieldType, currFieldType){

		const list_compatible = {
			int :{
				float: true,
				double:true,
				decimal: true
			},
			double :{
				int: true,
				double:true,
				decimal: true
			},
			decimal :{
				int: true,
				double:true,
				float: true
			},
			datetime :{
				time: true,
				date:true,
			},
			time :{
				datetime: true,
				date:true,
			},
			date :{
				time: true,
				datetime:true,
			},
			varchar :{
				text: true
			},
			text :{
				varchar: true
			}

		}
		const comp = list_compatible[oldFieldType];
		
		return comp && comp[currFieldType];
		
	};

	adm_database_design.prototype.__validate_field_to_update_add = function($html_field_li){
		const field_data = this.__get_field_html_data($html_field_li);

		//valido que exista el nombre de la columna
		if(!field_data.name || field_data.name.trim() === ""){
			this.form.show_status_message("<%=_T('Name is required.')%>", "Error", 5000);
			return false;
		}
		const fieldId = $html_field_li.data("fieldId");
		const already_exists_file = this.fields && this.fields[fieldId];
		
		//Valido existencia del nombre
		if(!already_exists_file && this.fields && Object.keys(this.fields).length > 0){
			const arr_names = inConcert.Utils.hash_to_sorted_array(this.fields,
				function(field) {
					return field.name;
				}
			);
			const alreadyName = arr_names.find(field => field.name.toLowerCase() === field_data.name.toLowerCase());
			if(alreadyName){
				this.form.show_status_message("<%=_T('Name already exists.')%>", "Error", 5000);
				return false;
			}
		}
		else if(this.list_fields_to_manage && !this.list_fields_to_manage[fieldId] && Object.keys(this.list_fields_to_manage).length > 0){
			const arr_names = inConcert.Utils.hash_to_sorted_array(this.list_fields_to_manage,
				function(field) {
					return field.name;
				}
			);
			const alreadyName = arr_names.find(field => field.name.toLowerCase() === field_data.name.toLowerCase());
			if(alreadyName){
				this.form.show_status_message("<%=_T('Name already exists')%>", "Error", 5000);
				return false;
			}
		}

		if (field_data.name.length > 64 ) {
			this.form.show_status_message(format("<%=_T('Length Name out range, Please enter a value with length between {0} and {1}.')%>", 1 ,64),"Error", 5000);
			return false;
		}

		if (!inConcert.Utils.isValid(field_data.name, "letters_number_underscore")) {
			this.form.show_status_message("<%=_T('Only letters, numbers and dashes are allowed in name.')%>", "Error", 5000);
			return false;
		}

		if (field_data.name.trim().match(/(dec|decimal|text|double|int|integer|char|varchar|date|time|datetime|bit|tinyint|BIGINT|SMALLINT|MEDIUMINT|YEAR|BINARY|VARBINARY|BLOB|TEXT|ENUM|SET)$/gi)) {
			this.form.show_status_message("<%=_T('The name cannot be the same as a data type.')%>", "Error", 5000);
			return false;
		}

		//Valido tipo de dato
		//1- Compatibilidad
		if(already_exists_file && already_exists_file.type !== field_data.type && !this.__is_new_field_type_compatible(already_exists_file.type, field_data.type)){
			this.form.show_status_message("<%=_T('The data type is not compatible with the current')%>", "Error", 5000);
			return false;
		}

		//Valido que el campo no sea de nombre ic_timestamp
		if(field_data.name.trim() === "ic_timestamp"){
			this.form.show_status_message(format("<%=_T('Can not add column with name {0}. Private field')%>", "ic_timestamp"), "Error", 5000);
			return false;
		}

		//Longitud

		if (field_data.type.trim() === "")
		{
			this.form.show_status_message("<%=_T('Data type is required.')%>", "Error", 5000);
			return false;
		}

		switch(field_data.type){
			case "datetime":
			case "date":
			case "time":
			case "int":
			case "text":
			case "tinyint":
				break;
			default:
				if(field_data.length.trim() === ""){
					this.form.show_status_message("<%=_T('The length value is required')%>", "Error", 5000);
					return false;
				}
				break;
		}

		if (field_data.type === "varchar" && (!inConcert.Utils.isValid(field_data.length, "number") || parseInt(field_data.length, 10) > 255)){
			this.form.show_status_message(format("<%=_T('Please enter a valid value with length between {0} and {1}.')%>", 0 ,255),"Error", 5000);
			return false;
		}

		if (field_data.type === "double" || (field_data.type === "dec" || field_data.type === "decimal")){
			if (!field_data.length.match(/^([0-9]+,[0-9]+)?$/gi)) {
				this.form.show_status_message(format("<%=_T('The format of the length value must be equal to {0}.')%>", "(##,##)"),"Error", 5000);
				return false;
			}

			if ((field_data.type === "dec" || field_data.type === "decimal")) {
				
				if ( parseInt(field_data.length.trim().substring(0, field_data.length.trim().indexOf(","))) > 65) {
					this.form.show_status_message(format("<%=_T('The maximum of the integer part of the length value is {0}')%>", 65),"Error", 5000);
					return false;
				}
				else if(parseInt(field_data.length.trim().substring(field_data.length.trim().indexOf(",") + 1)) > 30){
					this.form.show_status_message(format("<%=_T('The maximum of the scale of the length value is {0}')%>", 30),"Error", 5000);
					return false;
				}
			}
			else{
				if (parseInt(field_data.length.trim().substring(0, field_data.length.trim().indexOf(","))) > 255) {
					this.form.show_status_message(format("<%=_T('The maximum of the integer part of the length value is {0}')%>", 255),"Error", 5000);
					return false;
				}
				else if (parseInt(field_data.length.trim().substring(field_data.length.trim().indexOf(",") + 1)) > 30) {
					this.form.show_status_message(format("<%=_T('The maximum of the scale of the length value is {0}')%>", 30),"Error", 5000);
					return false;
				}
			}
			
		}

		return true;
	};

	adm_database_design.prototype.__get_field_html_data = function($html_field_li){
		return {
			primary_key: $html_field_li.find("[field_key]").is(':checked'),
			not_null: $html_field_li.find("[field_not_null]").is(':checked'),
			length: $html_field_li.find("[field_length]").val(),
			type : $html_field_li.find("[field_data_type]").val(),
			name: $html_field_li.find("[field_column_name]").val()
		}
	};

	adm_database_design.prototype.get_table_data_to_manage = function(){
		this.table_to_manage.DataBase = this.database.Name;
		this.table_to_manage.TableFields = this.list_fields_to_manage
		return this.table_to_manage;
	};

	adm_database_design.prototype.__trigger_table_to_view_edit = function(tableName){
		const self = this;
		self.ask_output_confirmation_tables(function(success) {
			if(success){
				self.create_view_edit_table(tableName);
			}
		});
	};
	
	adm_database_design.prototype.select_last_table_updated = function(tableName){

		tableName = tableName || (this.table_to_manage && this.table_to_manage.TableName);
		if(tableName){
			const $table_li = $(this.container_section + "_design_general_table_" + tableName);
			if($table_li.length){
				$(this.container_section + "_general_tables_title").trigger("click");
				this.__trigger_table_to_view_edit(tableName);
			}
		}
	};

	adm_database_design.prototype.select_to_edit_last_sp_updated = function () {
		const self = this;
		let name = ""
		if (this.options_query_by_sql_console && this.options_query_by_sql_console.Type === "SP" && this.options_query_by_sql_console.Data
			&& this.options_query_by_sql_console.Data.Name
			&& this.options_query_by_sql_console.Action === "Edit" && this.options_query_by_sql_console.OldStoredP) {
			const beforeFields = this.options_query_by_sql_console.OldStoredP || {};
			const currentFields = this.database && this.database.stored_procedures || {};
			const diff = jsondiffpatch.diff(beforeFields, currentFields);
			
			if(!diff){
				return;
			}

			switch (Object.keys(diff).length) {
				case 0:
					break;
				default:
					for (key in diff) {
						if (diff.hasOwnProperty(key) && key !== this.options_query_by_sql_console.Data.Name) {
							name = key;
							break;
						}
					}
					break;
			}

			if (name !== "") {
				const $sp_li = $(this.container_section + "_design_general_sp_" + name);
				if ($sp_li.length) {
					self.ask_output_confirmation_tables(function (success) {
						if (success) {
							const sprocData = $sp_li.data("data");
							self.__remove_class_active();
							$sp_li.removeClass("active").addClass("active");
							self.__edit_stored_procedure(sprocData);
						}
					});
				}
			}

		}
	};
	
	adm_database_design.prototype.__add_field_to_manage = function($html_field_li, isDelete){
		let field_data = this.__get_field_html_data($html_field_li);
		
		this.list_fields_to_manage = this.list_fields_to_manage || {};
		let action = "";
		const fieldId = $html_field_li.data("fieldId");
		if(isDelete){
			/*
			Boton de eliminar, si ya esta como field de la tabla y no en la lista de campos a actualizar, Elimino
			En caso contrario, si esta en la lista a actualizar, lo elimino de la lista.
			*/
			if(this.fields[fieldId] && !this.list_fields_to_manage[fieldId]){
				action = "DELETE";
			}
			else if(this.list_fields_to_manage[fieldId]){
				delete this.list_fields_to_manage[fieldId];
				return true;
			}
		}
		/*
		Boton de cambio (Add or Update).

		 */
		else if(this.fields[fieldId]){
			action = "UPDATE";
			const diff = inConcert.Utils.diffObjects(this.fields[fieldId], field_data);
			
			if(!diff){
				if(this.list_fields_to_manage[fieldId]){
					delete this.list_fields_to_manage[fieldId];
				}
				return true;
			}

			// No agrego el primary_key no tuvo cambios el check
			if ((!this.fields[fieldId].primary_key && !field_data.primary_key) || (this.fields[fieldId].primary_key && field_data.primary_key)) {
				delete field_data.primary_key;
			}

		}
		else{
			action = "ADD";
		}
		
		field_data.action = action;
		this.list_fields_to_manage[fieldId] = field_data;

		return true;
	};

	adm_database_design.prototype.__are_all_fields_confimed = function(){
		const $fields = $(this.container_section + "_design_tables_fields").find("[field_add]");
		let result = true; 
		$fields.each(function() {
			let $field_add_btn = $(this);
				if($field_add_btn.length && !$field_add_btn.prop('disabled')){
					result = false;
					return;
				}
		  });

		return result;
	};

	adm_database_design.prototype.__set_event_field = function($html_field_li, $fields_ul){
		const self = this;
		const $rem_container = $html_field_li.find("[field_remove]");
		$rem_container
		.off("click")
		.on("click", function() {
			if($html_field_li.siblings().length > 2){
				self.__add_field_to_manage($html_field_li, true);
				$html_field_li.remove();
				const $save = $("#adm_form_databases_confirm_changes_btn");
				$save.prop("disabled", !(self.list_fields_to_manage && Object.keys(self.list_fields_to_manage).length > 0));
			}
			else{
				self.form.show_status_message("<%=_T('Can not delete all columns')%>", "Info", 5000);
			}
		});

		const $add_container = $html_field_li.find("[field_add]");
		$add_container
		.off("click")
		.on("click", function() {

			if(self.__validate_field_to_update_add($html_field_li) && self.__is_there_free_space() && self.__add_field_to_manage($html_field_li)){
				$(this).attr("disabled", true);
				$rem_container.attr("disabled", false);
				if(self.__are_all_fields_confimed()){
					self.__make_table_field_html($fields_ul); //Agregar en blanco un nuevo campo si estan confirmados los demas rows
				}
				const $save = $("#adm_form_databases_confirm_changes_btn");
				$save.prop("disabled", !(self.list_fields_to_manage && Object.keys(self.list_fields_to_manage).length > 0));
			}
		});

		const $field_key = $html_field_li.find("[field_key]");
		const $field_not_null = $html_field_li.find("[field_not_null]");
		const $field_length = $html_field_li.find("[field_length]");
		const $field_column_name = $html_field_li.find("[field_column_name]");
		const $field_data_type = $html_field_li.find("[field_data_type]");

		$field_key
		.off("change")
		.on("change", function() {

			const $this = $(this);
			const is_checked = $this.prop("checked");
			if (is_checked) {
				const type = $field_data_type.val();
				if (type === "text" || type === "tinyint") { 
					self.form.show_status_message( format("<%=_T('The column of type {0} cannot be a primary key.')%>", type === "tinyint"? "boolean": type), "Error", 5000 );
					$this.prop("checked", false);
					return;
				}
				$field_not_null.prop("checked", true);	
			}
			$add_container.attr("disabled", false);
			$field_not_null.attr("disabled", is_checked);
		});

		$field_not_null
		.off("change")
		.on("change", function() {
			$add_container.attr("disabled", false);
		});

		$field_data_type
		.off("change")
		.on("change", function(e) {
			$add_container.attr("disabled", false);
			const $this = $(this);
			const val_selected = $this.val();
			switch(val_selected){
				case "datetime":
				case "date":
				case "time":
					$field_length.attr("disabled", true);
					$field_length.val("");
					$field_length.attr("placeholder","<%=_T('Enter value')%>");
					break;
				case "text":
				case "tinyint":
					$field_length.attr("placeholder","<%=_T('Enter value')%>");
					
					if ($field_key.prop("checked")) {
						$field_length.attr("disabled", false);
						self.form.show_status_message( format("<%=_T('The column of type {0} cannot be a primary key.')%>", val_selected === "tinyint"? "boolean": val_selected), "Error", 5000 );
						$this.val("");
					}
					else{
						$field_length.val("");
						$field_length.attr("disabled", true);
					}
					break;
				default:
					$field_length.attr("disabled", false);
					if (val_selected === "double" || val_selected === "decimal") {
						$field_length.attr("placeholder","<%=_T('Enter value')%> (#,#)");
					}
					else{
						$field_length.attr("placeholder","<%=_T('Enter value')%>");
					}
					break;
			}
		});

		const event_fn = function() {
			if(self.fields && self.fields[$(this).val()]){
				$add_container.attr("disabled", true);
			}
			else{
				$add_container.attr("disabled", false);
			}
		};
		var field_events_fn = {
			keyup: event_fn,
			page: event_fn,
			change: event_fn
		}

	$field_column_name
		.off("keyup", "page", "change" )
		.on(field_events_fn);

	$field_length
		.off("keyup", "page", "change" )
		.on(field_events_fn);

	};

	adm_database_design.prototype.__exists_primary_key = function(tablename) {
		const self = this;
		if(!self.database.tables[tablename])
		{
			return false;
		}
		const arr_pk = inConcert.Utils.hash_to_sorted_array(self.database.tables[tablename],
			function(field) {
				return field.primary_key;
			}
		);

		return arr_pk.find(pk => pk.primary_key);
	};

	adm_database_design.prototype.__make_table_field_html = function($fields_ul, fieldId, fieldData) {
		fieldData = fieldData || {};
		const $html_field_li = $(templates.edit_general_table_field_list);

		const $field_key = $html_field_li.find("[field_key]");
		const $field_not_null = $html_field_li.find("[field_not_null]");
		const $field_length = $html_field_li.find("[field_length]");
		const $field_column_name = $html_field_li.find("[field_column_name]");
		const $field_data_type = $html_field_li.find("[field_data_type]");
		
		
		$field_not_null.prop("checked", fieldData.not_null);
		$field_length.val(fieldData.length || "");

		$field_column_name.val(fieldData.name || "");

		this.form.fill_combo( $field_data_type, true, this.__listFieldDataTypes(), "id", "label", false);
		if(fieldData.type){
			$field_data_type.val(fieldData.type);
			switch(fieldData.type){
				case "datetime":
				case "date":
				case "time":
				case "text":
				case "tinyint":
					$field_length.val("");
					$field_length.attr("disabled", true);
					break;
			}		
		}
		
		$field_key.prop("checked", fieldData.primary_key);
		$field_key.attr("disabled", this.__exists_primary_key(this.table_to_manage.TableName));
		if($field_key.is(":checked"))
		{
			$field_not_null.prop("checked", true);
			$field_not_null.attr("disabled", true);
		}

		$html_field_li.data("fieldId",fieldId || inConcert.Utils.generateGuid());
		$field_column_name.attr("disabled", fieldId)
		const $bt_remove = $html_field_li.find("[field_remove]");
		const $bt_add = $html_field_li.find("[field_add]");
		$bt_remove.attr("disabled", !fieldId);
		$bt_add.attr("disabled", fieldId);

		if (this.form.is_readonly()) {
			this.form.readonly_control($bt_add, true);
			this.form.readonly_control($bt_remove, true);
			this.form.readonly_control($field_not_null, true);
			this.form.readonly_control($field_data_type, true);
			this.form.readonly_control($field_length, true);
			this.form.readonly_control($field_key, true);
			this.form.readonly_control($field_column_name, true);
		}
		else{
			$field_length.attr("placeholder","<%=_T('Enter value')%>");
			$field_column_name.attr("placeholder","<%=_T('Enter value')%>");
			if (fieldData.type && (fieldData.type === "double" || fieldData.type === "decimal")) {
				$field_length.attr("placeholder","<%=_T('Enter value')%> (#,#)");
			}
			this.__set_event_field($html_field_li, $fields_ul);
		}

		$fields_ul.append($html_field_li);
	};


	adm_database_design.prototype.create_view_edit_table = function(tableName, isCreateNew){
		this.__open_close_console(false);
		this.toggle_tables();
		this.$design.children().hide();
		this.$design_tables.show();
		const $save = $("#adm_form_databases_confirm_changes_btn");
		$save.prop("disabled",true);
		const $table_title = $(this.container_section +"_design_tables_title");
		let action = "Edit";
		let title = ""; //"<%=_T('Edit table')%>"
		if (this.form.is_readonly()) {
			action = "View";
			title = ""; //<%=_T('View table')%>
		}else if(isCreateNew){
			action = "New";
			title = "<%=_T('New table')%>";
		}

		$table_title.html(title +"<span class='table"+ action +"'>" + tableName +"</span>")
		
		const $fields_ul  = $(this.container_section +"_design_tables_fields");
		$fields_ul.html("");
		$fields_ul.append(templates.edit_general_table_field_list_header);

		this.list_fields_to_manage = null;
		this.table_to_manage = {
			TableName: tableName,
			Create: isCreateNew || false
		};
		this.fields = null;
		this.fields = this.database.tables[tableName] || {};
		
		for(fieldId in this.fields){
			if(this.fields.hasOwnProperty(fieldId)){
				this.__make_table_field_html($fields_ul, fieldId, this.fields[fieldId]);
			}
		}

		if (this.form.is_readonly()) {
			$(this.container_section +"_design_tables_attention").hide();
		}
		else{
			this.__make_table_field_html($fields_ul);
		}
		
	};

	adm_database_design.prototype.__edit_stored_procedure = function(sprocData) {

		const sql_query = "CREATE PROCEDURE "+ sprocData.Name +"("+ sprocData.Param_list + ") "+
		sprocData.Body

		this.options_query_by_sql_console = {
			Type : "SP",
			Action: "Edit",
			Data: sprocData,
			OldStoredP : this.database.stored_procedures || {}
		};
		this.__open_close_console(true, sql_query);
	};

	adm_database_design.prototype.__export_table_values = function (tableName) {
		const self = this;
		self.form.show_waiting("<%=_T('Please wait, exporting table values')%>");
		$.fileDownload( inConcert.app.getBaseDomain() + "/inconcert/apps/administration/databases/table_export/", {
			httpMethod : "GET",
			cookieName : "download_started",
			data       : {
				data: JSON.stringify({
					TableName : tableName,
					Database : self.database.Name,
					Limit: self.config_db.RowsNumber
				})
			}
		}).done(function() {
			self.form.hide_waiting();
		}).fail(function(error) {
			self.form.hide_waiting();
			try {
				const err = JSON.parse(error)
				self.form.show_status_message( format("<%=_T('{0}')%>", err.reason), "Error", 5000 );
			} catch (error) {
				self.form.show_status_message( "<%=_T('Unable to export')%>", "Error", 5000 );
			}
		});
		
	};

	adm_database_design.prototype.__on_save_import_table_values = function (item, callback = $.noop)
	{
		const self = this;
		item.Database = this.database.Name
		self.form.show_waiting("<%=_T('Please wait, importing table values')%>");
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/databases/table_import/",
			type: "POST",
			dataType    : "json",
			contentType : "application/json",
			data : JSON.stringify(item),
			success: function(response) {
				self.form.hide_waiting();
				self.form.show_status_message("<%=_T('Import of values successful')%>", "Info", 5000);
				self.refresh_database_data(function(success){
					if(success)
					{
					 self.refresh_info_sizing();
					}
				});
				callback(true, response);
			},
			error: function(response, error) {
				self.form.hide_waiting();
				if(error && error.error && error.error.reason){
					self.form.show_status_message("<%=_T('Data import failed')%>. " + format("<%=_T('{0}')%>", error.error.reason), "Error", 5000);
				}
				else{
					self.form.show_status_message("<%=_T('Data import failed')%>", "Error", 5000);
				}
			}
		});
	};

	adm_database_design.prototype.__add_events_table = function($table_li) {
		const self = this;
		let menu_options = [{
			id     : "edit",
			name   : "<%=_T('Edit')%>",
			execute: function() {
				if (!self.is_read_only()) {
					self.ask_output_confirmation_tables(function (success) {
						if (!success) {
							return;
						}
						const tableName = $table_li.data("Name");
						self.__remove_class_active();
						$table_li.removeClass("active").addClass("active");
						self.__trigger_table_to_view_edit(tableName);
					});
				}
			}
		},
		{
			id     : "import",
			name   : "<%=_T('Import')%>",
			execute: function() {
				
				if (!self.is_read_only() && self.__is_there_free_space()) {
					if(self.inst_import_table_values){
						self.inst_import_table_values.destroy();
						self.inst_import_table_values = null;
					}
					const tableName = $table_li.data("Name");
	
					let instance_info = {
						container_id: "adm_form_databases_popup_import_table_values",
						owner       : self,
						container_class : "formPopUp popUp520w",
						container_popup_middle_class : "pageFormContainer",
						title       : "<%=_T('Import table values')%>",
						frm         : self.form,
						buttons_actions: {},
						tableName : tableName,
						columns: self.database.tables[tableName] || {}
					};
	
					self.inst_import_table_values = new import_tables_values(instance_info);
				}
			}
		},
		{
			id     : "export",
			name   : "<%=_T('Export')%>",
			execute: function() {
				if (self.has_permission_to_export) {
					const tableName = $table_li.data("Name");
					self.__export_table_values(tableName);
				}
				else{
					self.form.show_status_message("<%=_T('You do not have permission for this action.')%>", "Error", 6000);
				}
				
			}
		}, {
			id     : "delete",
			name   : "<%=_T('Delete')%>",
			execute: function() {
				if (!self.is_read_only()) {
					const tableName = $table_li.data("Name");
					self.ask_confirm(function (success) {
						if (success) {
							self.ask_output_confirmation_tables(function (success) {
								if (!success) {
									return;
								}
								self.execute_delete_table_or_sp({ Name: tableName, Type: "TABLE" }, function (success) {
									if (success) {
										$table_li.remove();
										self.refresh_database_data(function () {
											self.update_title_tables();
											self.refresh_info_sizing();
										});

										if ($("#adm_form_databases_edit_section_design_general_table_" + tableName)) {
											self.$general_header.trigger("click");
										}
									}
								});
							});
						}
					}, "<%=_T('Do you want to remove the table?')%>");
				}
			}
		}
		
	];

	if (this.form.is_readonly()) {
		menu_options.push({
			id     : "view",
			name   : "<%=_T('View')%>",
			execute: function() {
				const tableName = $table_li.data("Name");
				self.__remove_class_active();
				$table_li.removeClass("active").addClass("active");
				self.__trigger_table_to_view_edit(tableName);
			}
		});
	}

		$table_li.find("[table_action_menu]")
		.off("click")
		.on("click", function() {
			const $this = $(this);
			self.form.toggle_contextual_menu($this, menu_options);

			const $menu = $(`#${self.form.dashboard.prefix_id}view_contextual_menu_actions`);
			if ($menu) {
				const $btnAction = $this;
				const btnActionOffset = $btnAction.offset();
				const dropdownLeft = btnActionOffset.left - ($menu.outerWidth() - $btnAction.outerWidth());
				$menu.css({left: dropdownLeft });
			}
		});
	};

	adm_database_design.prototype.__add_events_stored_proc = function($sproc_li) {
		const self = this;

		const menu_options = [{
			id     : "edit",
			name   : "<%=_T('Edit')%>",
			execute: function() {
				if (!self.is_read_only()) {
					const sprocData = $sproc_li.data("data");
					self.ask_output_confirmation_tables(function (success) {
						if (success) {
							self.__remove_class_active();
							$sproc_li.removeClass("active").addClass("active");
							self.__edit_stored_procedure(sprocData);
						}
					});
				}
			}
		}, {
			id     : "delete",
			name   : "<%=_T('Delete')%>",
			execute: function() {
				if (!self.is_read_only()) {
					const sprocData = $sproc_li.data("data");
					self.ask_confirm(function (success) {
						if (success) {
							self.ask_output_confirmation_tables(function (success) {
								if (!success) {
									return;
								}
								self.execute_delete_table_or_sp({ Name: sprocData.Name, Type: "SP" }, function (success) {
									if (success) {
										$sproc_li.remove();
										delete self.database.stored_procedures[sprocData.Name];
										self.update_title_stored_proc();
										if ($("#adm_form_databases_edit_section_design_general_sp_" + sprocData.Name)) {
											self.$general_header.trigger("click");
										}
									}
								});
							});
						}
					}, "<%=_T('Do you want to remove the stored procedure?')%>");
				}
			}
		}
	];

		$sproc_li.find("[sp_action_menu]")
		.off("click")
		.on("click", function() {
			const $this = $(this);
			self.form.toggle_contextual_menu($this, menu_options);
			const $menu = $(`#${self.form.dashboard.prefix_id}view_contextual_menu_actions`);
			if ($menu) {
				const $btnAction = $this;
				const btnActionOffset = $btnAction.offset();
				const dropdownLeft = btnActionOffset.left - ($menu.outerWidth() - $btnAction.outerWidth());
				$menu.css({left: dropdownLeft });
			}
		});
	};

	adm_database_design.prototype.add_table_markup = function($list_tables, tableData)
	{
		const self = this;
		const data =  {
			Name : tableData.Name,
			NumFields : tableData.NumFields
		};
		const $table_li = $(Mustache.render(templates.edit_general_table, data));
		$table_li.data("Name", data.Name);
		this.__add_events_table($table_li);
		$list_tables.append($table_li);
	};

	adm_database_design.prototype.add_stored_proc_markup = function($list_sp, sprocData)
	{
		const data =  {
			Name : sprocData.Name,
			Body : sprocData.Body,
			Param_list: sprocData.Param_list
		};
		const $sp_li = $(Mustache.render(templates.edit_general_sp, data));
		$sp_li.data("data", data);
		this.__add_events_stored_proc($sp_li);
		$list_sp.append($sp_li);
	};

	adm_database_design.prototype.make_markup_tables = function(){

		const tables = this.database.tables;
		let $list_tables = this.$tables_container.find("[general_table_fields]");
		$list_tables.html("");
		this.update_title_tables();
		for (const table in tables) {
			if(tables.hasOwnProperty(table)){
				let numFields = Object.keys(tables[table]).length;
				this.add_table_markup($list_tables, {
					Name : table,
					NumFields : numFields
				});
			}
		}
	};

	adm_database_design.prototype.make_markup_stored_procedures = function(){

		const stored_proc = this.database.stored_procedures;
		let $list_sp = this.$sp_container.find("[general_stored_procedures]");
		$list_sp.html("");
		this.update_title_stored_proc();
		for (const sp in stored_proc) {
			if(stored_proc.hasOwnProperty(sp)){
				this.add_stored_proc_markup($list_sp, {
					Name : sp,
					Body : stored_proc[sp].Body || "",
					Param_list : stored_proc[sp].Param_list
				});
			}
		}
	};

	adm_database_design.prototype.make_markup_code_block = function(){
		if(this.codeBlock){
			this.codeBlock = null
		}
		const $container = $(this.container_section + "_console");
		this.codeBlock = ace.edit($container.find("[code_block]")[0]);
		this.codeBlock.getSession().setMode("ace/mode/sql");
		this.codeBlock.renderer.setScrollMargin(8, 8);
		this.codeBlock.renderer.setPadding(8);
		this.codeBlock.getSession().setValue("");
	};

	adm_database_design.prototype.make_markup_basic_info = function(){
		this.$section_info.html( $(Mustache.render(format(templates.edit_base_info, this.config_db.RowsNumber), {
			Name : this.database.Name,
			Description : this.database.Description,
			Sizing :this.database.Sizing,
			OpenSpace : this.database.OpenSpace,
			CreationDate : this.database.CreationDate
		})));
	};

	adm_database_design.prototype.__formatQueryInCodeBlock= function(query){
		if(!this.codeBlock){
			return;
		}
		this.codeBlock.getSession().clearAnnotations();
		const formater_query = sqlFormatter.format(query || this.codeBlock.getSession().getValue() || "", { language: 'plsql' });
		this.codeBlock.getSession().setValue(formater_query || "");
	};
	
	adm_database_design.prototype.__show_result_query = function(response, callback = $.noop){
		const self = this;
		let columns = [{id: "_number"    , name: "", type: "counter"}];
		const results = response.data || null
		if(results && results.columns && results.rows){

			if (results.rows.length > 0 ) {
				columns = columns.concat(results.columns);
				
				this.__resp_console_grid(columns, results.rows, function(success) {
					if (success) {
						self.__collapse_console_results(true);
					}
					self.form.hide_waiting();
				});
			}
			else{
				this.form.show_status_message("<%=_T('No results found.')%>", "Info", 10000);
			}
		}
		else if(!results || results.count === 1 || results.count === 0){
			if(this.m_console_query_grid){
				this.m_console_query_grid.__destroy_paginator();
			}
			this.form.show_status_message("<%=_T('Query executed successfully')%>", "Info", 5000);
			callback();
		}
	};

	adm_database_design.prototype.__executeCodeBlock = function(callback = $.noop){
		const self = this;
		if(!this.codeBlock){
			return callback(false);
		}
		this.__collapse_console_results(false);

		//Request para eliminar tabla
		this.form.show_waiting("<%=_T('Please wait, executing query')%>");
		
		this.__formatQueryInCodeBlock();
		let data = {
			Database:self.database.Name
			};
		
		if(this.options_query_by_sql_console){
			data.Options = this.options_query_by_sql_console;
		}

		if(!this.validateQueryToExecute(undefined, this.options_query_by_sql_console && this.options_query_by_sql_console.Type)){
			return callback(false);
		}
		
		data.Query = this.codeBlock.getValue();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/databases/console/",
			type: "POST",
			dataType    : "json",
			contentType : "application/json",
			data : JSON.stringify(data),
			success: function(response) {
				self.__show_result_query(response, function () {
					self.form.hide_waiting();
					callback(true);
				});
			},
			error: function(_, response) {
				self.form.hide_waiting();
				if(response.error && response.error.line){
					const error_line = parseInt(response.error.line);
					if(error_line <= self.codeBlock.session.getLength()){
						self.codeBlock.getSession().setAnnotations([{
							row: error_line-1,
							text: response.error.reason && format("<%=_T('{0}')%>", response.error.reason) || "<%=_T('Error in SQL syntax')%>",
							type: "error" // also warning and information
						}]);
					return;
					}
				}
				if(response.error && response.error.reason){
					self.form.show_status_message(format("<%=_T('{0}')%>", response.error.reason), "Error", 5000);
				}
				else{
					self.form.show_status_message("<%=_T('Error executing query')%>", "Error", 5000);
				}
				
				callback(false);
			}
		});
	};

	adm_database_design.prototype.show_popup_create = function(isCreateTable)
	{
		if (this.m_create_popup) {
			this.m_create_popup = null;
		}

		let entity = "Table";
		let title = "<%=_T('New table')%>";
		if(!isCreateTable){
			entity = "Stored Procedure";
			title = "<%=_T('New procedure')%>";
		}

		let instance_info = {
			container_id: "adm_form_databases_popup_create",
			owner       : this,
			container_class : "formPopUp popUp520w",
			container_popup_middle_class : "pageFormContainer",
			title       : title,
			frm         : this.form,
			buttons_actions: {},
			title_entity: entity
		};

		this.m_create_popup = new create_table_sp_popup(instance_info);

	};

	adm_database_design.prototype.validateIsMultipleQueries = function(query)
	{
		//Validar que no exista mas de una query
		const splitSemiColon = query.match(/;/g);
		const isProcedure = this.isQueryCreateStoredProcedure(query);
		if (!splitSemiColon) {
			return false;
		}
		
		if((splitSemiColon.length > 1 || !query.match(/;\n*\s*$/gi)) && !isProcedure)
		{
			return true
		}
		return false;
	};

	adm_database_design.prototype.isQueryCreateTable = function(query)
	{
		const patt = /^\s*(CREATE\s*TABLE)\s*[A-Za-z0-9_`]+\s*[(]/gi;
		return query.match(patt);
	};

	adm_database_design.prototype.isQueryCreateStoredProcedure = function(query)
	{
		const patt = /^\s*(CREATE\s*PROCEDURE)[A-Za-z0-9_,)(\s\n]*(begin)(.*[\n\s])*(end)\n*\s*$/gi;
		return query.match(patt)
	};

	adm_database_design.prototype.isQueryExecStoredProcedure = function(query)
	{
		const patt = /^\s*(CALL|EXEC)\s*.*\s*[(].*;\s*$/gi;
		return query.match(patt)
	};

	adm_database_design.prototype.isQuerySelect = function(query)
	{
		const patt = /SELECT.*FROM.*/gi;
		return query.replace(/\n*|\r*/gi,"").match(patt)
	};

	adm_database_design.prototype.isQuerySelectWithLimit = function(query)
	{
		const patt = /SELECT.*FROM\s.*LIMIT\n*\s*[0-9,]+\s*.*/gi;
		return query.match(patt)
	};

	adm_database_design.prototype.validateLimitQuerySelect = function(query)
	{
		const selectQueries = this.isQuerySelect(query)
		if (!selectQueries) {
			return true;
		}

		const splitBySemiColon = selectQueries[0].split(";")

		for (let index = 0; index < splitBySemiColon.length; index++) {
			const element = splitBySemiColon[index];
			if (!element.match(/SELECT.*FROM.*/gi)) {
				continue;
			}

			let limitStr = this.isQuerySelectWithLimit(element);
			if (limitStr) {
				const regexLimit = /LIMIT\n*\s*[0-9,\s\n]*/gi;
				let limitValue = limitStr[0].match(regexLimit)[0].replace(/\s|\n|\r/gi, "").match(/[0-9,]+/gi);
				if (limitValue) {
					const splitNumValue = limitValue[0].split(",")
					try {
						if (splitNumValue.length === 1 && parseInt(limitValue) > this.config_db.RowsNumber) {
							this.form.show_status_message(format("<%=_T('Limit select queries to the allowed limit, less than or equal to ({0}).')%>", this.config_db.RowsNumber), "Error", 5000);
							return false;
						}
						else if (splitNumValue.length > 1 && parseInt(splitNumValue[1]) > this.config_db.RowsNumber) {
							this.form.show_status_message(format("<%=_T('Limit select queries to the allowed limit, less than or equal to ({0}).')%>", this.config_db.RowsNumber), "Error", 5000);
							return false;
						}
					} catch (error) {
					}
				}
			}
			else {

				if (this.isQueryCreateStoredProcedure(query)) {
					this.form.show_status_message(format("<%=_T('Limit select queries to the allowed limit, less than or equal to ({0}).')%>", this.config_db.RowsNumber), "Error", 5000);
					return false;
				}

				//Agregar limit
				const pos = query.indexOf(";");

				if (pos !== -1) {
					query = query.substring(0, pos) + format(" LIMIT {0};", this.config_db.RowsNumber);
				}
				else {
					query = query + format(" LIMIT {0};", this.config_db.RowsNumber);
				}

				if (this.codeBlock) {
					this.codeBlock.getSession().setValue(query);
					this.__formatQueryInCodeBlock();
					this.codeBlock.getSession().setAnnotations([{
						row: this.codeBlock.session.getLength()-1,
						text: "<%=_T('Table value selection queries are restricted to the configured limit. The limit is added to the original query.')%>",
						type: "warning"
					}]);
				}
				else{
					this.form.show_status_message(format("<%=_T('Limit select queries to the allowed limit, less than or equal to ({0}).')%>", this.config_db.RowsNumber), "Error", 5000);
					return false;
				}

			}
		}
		return true;
	};

	adm_database_design.prototype.validateProcedureExecution = function(query)
	{
		const isExecSP = this.isQueryExecStoredProcedure(query)

		if (!isExecSP) {
			return true;
		}
		//Si es una ejecucion de SP y no hay espacio, no se ejecuta sp
		//Para una primera solucion se queda asi, posterior se debe validar el body
		if(!this.__is_there_free_space()){
			this.form.show_status_message("<%=_T('Base datos sizing is complete, not allowed to execute procedures.')%>", "Error", 5000);
			return false;
		}

		return true;
	};

	adm_database_design.prototype.validateQueryToExecute = function(query, type)
	{
		query = query || (this.codeBlock && this.codeBlock.getValue()) || "";
		if (!query || query.replace(/\n|\r|\s/gi, "") === "") {
			this.form.show_status_message("<%=_T('Must enter a code.')%>", "Error", 5000);
			return false;
		}

		const create_database = /(CREATE \s*DATABASE\s*)|(DELETE \s*DATABASE\s*)/gi;

		//No permitir create db
		if(query.match(create_database))
		{
			this.form.show_status_message("<%=_T('The query to execute is not allowed')%>", "Error", 5000);
			return false;
		}

		//No permitir multiqueries
		if(this.validateIsMultipleQueries(query))
		{
			this.form.show_status_message("<%=_T('Multiple queries are not allowed')%>", "Error", 5000);
			return false;
		}

		const regex_only_queries_allowed = /(CREATE\s*TRIGGER\s*)|(ALTER\s*TABLE\s*)|(UPDATE\s*[A-Za-z0-9._]+\s*SET)|(TRUNCATE\s*TABLE\s*)|(DROP\s*PROCEDURE\s*)/gi;
		//No permitir regex_only_queries_allowed
		if(!this.isQueryCreateStoredProcedure(query) && query.match(regex_only_queries_allowed))
		{
			this.form.show_status_message("<%=_T('The query to execute is not allowed')%>", "Error", 5000);
			return false;
		}

		//Para cuando se edita un SP o se importa una table/SP, limitar a ejecutar solo el tipo en cuestion
		if(type)
		{
			if (type === "SP" && !this.isQueryCreateStoredProcedure(query)) {
				this.form.show_status_message("<%=_T('Only create Stored procedure query is allowed')%>", "Error", 5000);
			return false;
			}
			else if (type === "TABLE" && !this.isQueryCreateTable(query)) {
				this.form.show_status_message("<%=_T('Only create table query is allowed')%>", "Error", 5000);
			return false;
			} 
		}
		
		//No permitir create o drop table
		const query_with_table = /(CREATE\s*TABLE)|(DROP \s*TABLE\s*)/gi;
		if(query.match(query_with_table) && (!type || type !== "TABLE"))
		{
			this.form.show_status_message("<%=_T('The query to execute is not allowed. Use the designer to create or drop a table.')%>", "Error", 5000);
			return false;
		}

		if(!this.validateProcedureExecution(query)){
			return false;
		}

		if(!this.validateLimitQuerySelect(query)){
			return false;
		}

		return true

	};

	adm_database_design.prototype.onChangeQuery = function(query)
	{
		query = this.onChangeSelect(query);

		return query;
	};

	adm_database_design.prototype.on_save_create_entity = function(item)
	{
		const isTable = item.isTable;

		if(item.isImport){
			if(isTable)
			{
				this.toggle_tables();
			}
			else{
				this.toggle_stored_procedures();
			}

			this.options_query_by_sql_console = {
				Type : isTable?"TABLE":"SP",
				Action: "New", 
				Import: true
			};

			$("#adm_form_databases_edit_console_btn").trigger( "click", [ item.Query ] );
		}
		else if(isTable)
		{
			this.create_view_edit_table(item.Name, true);
		}
		else{ //SP
			this.toggle_stored_procedures();
			const sql_query = "CREATE PROCEDURE " + item.Name + "() BEGIN END";

			this.options_query_by_sql_console = {
				Type : "SP",
				Action: "New",
				Data: {
					Name: item.Name
				}
			};
			$("#adm_form_databases_edit_console_btn").trigger( "click", [ sql_query ] );
		}
	};

	adm_database_design.prototype.destroy = function()
	{
		if(this.codeBlock){
			this.codeBlock = null
		}

		if (this.m_create_popup) {
			this.m_create_popup.destroy();
			this.m_create_popup = null;
		}

		if(this.m_timeout_resize_codeblock){
			this.m_timeout_resize_codeblock = null;
		}
	};

	adm_database_design.prototype.__resp_console_grid = function(columns, rows, callback = $.noop)
	{
		const self = this;

		let param_paginator = {
			paginator_name: "ADM_DB_QUERY_RESULT",
			owner: self,
			frm: self.form,
			row_id: "Id",
			display_name: "Id",
			rows_per_page: self.config_db.RowsNumber,
			show_at_least: self.config_db.RowsNumber - 1,
			paginator_type: "ALL_ROWS_CLIENT_SIDE_ASYNC",
			sortable: true,
			without_paginator: true,
			strings:{},
			auto_initialize: true,
			ids: {
				grid: "adm_form_databases_edit_section_console_output_list"
			},
			columns: columns || [],
			callbacks: {}
		}
		if(this.m_console_query_grid){
			this.m_console_query_grid = null;
		}
		this.m_console_query_grid = new inConcert.conf_form_paginator(param_paginator);
		this.m_console_query_grid.initialize(callback, rows || []);
	};

//--------------------------------------------------------------

	function base_create_popup (params) {
		const self = this;
		params.callbacks = {
			on_close: function() {
				self.on_close();
			},
			on_save: function(item, create_and_continue, callback) {
				self.on_save(item, create_and_continue, callback);
			}
		};
		base_create_popup.uber.constructor.call(this, params);
	}

	inConcert.Utils.inherit(base_create_popup, inConcert.conf_form_popup);

	base_create_popup.prototype.set_events = function() {
		base_create_popup.uber.set_events.call(this);
	};

	base_create_popup.prototype.on_close = function() {
	};

	base_create_popup.prototype.on_save = function(item, create_and_continue, callback) {
		callback(true);
	};

//--------------------------------------------------------------
	function create_table_sp_popup (params) {
		
		this.title_entity = params.title_entity;
		this.is_create_table = params.title_entity === "Table";
		create_table_sp_popup.uber.constructor.call(this, params);
	}

	inConcert.Utils.inherit(create_table_sp_popup, base_create_popup);

	create_table_sp_popup.prototype.get_html_middle = function() {
		const self = this;

		let btn_create_label = "<%=_T('Create Stored Procedure')%>";
		let btn_create_import = "<%=_T('Import Stored Procedure')%>";

		if ( this.title_entity.toLowerCase() === "table") {
			btn_create_label = "<%=_T('Create Table')%>";
			btn_create_import = "<%=_T('Import Table')%>";
		}

		let html = ("").concat(
			'<div class="card no-card">',
				'<div class="card-block">',
					'<div class="row">',
						'<div class="col-12">',
							'<div class="form-group">',
								'<div class="form-radiobutton">',
									'<label for="'+ self.container_id + '_select_create" class="form-radiobutton-label">',
									'<input type="radio" name="select_creation_type" id="'+ self.container_id + '_select_create" class="form-radiobutton-input form-radiobutton-blue" checked>',
									'<span>'+ btn_create_label +'</span>',
									'</label>',
								'</div>',
								'<div class="form-radiobutton">',
									'<label for="'+ self.container_id + '_select_import" class="form-radiobutton-label">',
									'<input name="select_creation_type" type="radio" id="'+ self.container_id + '_select_import" class="form-radiobutton-input form-radiobutton-blue">',
									'<span>' + btn_create_import + '</span>',
									'</label>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					'<hr />',
					'<div id="'+ self.container_id + '_create_container" class="row"> ',
						'<div class="col-6">',
							'<div class="form-group mb-0">',
								'<label for="'+ self.container_id + '_create_name" class="required"><%=_T("Name")%><%=_T(":")%></label>',
								'<input id="'+ self.container_id + '_create_name" class="form-control" type="text" placeholder="', "<%=_T('Enter the name')%>...", '"/>',
								'<i id="'+ self.container_id + '_create_name_validation" class="formFieldValidation formFieldError" hidden></i>',
							'</div>',
						'</div>',
					'</div>',
					'<div id="'+ self.container_id + '_import_schema_container" class="row" style="display:none;">',
						'<div class="col-12">',
							'<div class="form-group d-flex flex-column">',
								'<div class="sharedFileUploadContainer">',
									'<div class="w-100 d-flex flex-column">',
										'<div id="'+ self.container_id + '_import_schema_control" class="sharedFileUploadControl mt-0">',
											'<%=_T("Drag file here or click to open.")%>',
											'<input id="'+ self.container_id + '_import_schema_file_mng" type="file" hidden="" accept=".sql">',					
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					'<div id="'+ self.container_id + '_import_schema_preview_container" class="row mb-4" style="display:none;">',
						'<div class="col-12">',
							'<div class="uploadedFilePills" id="'+ self.container_id + '_import_schema_preview">',
							
							'</div>',
						'</div>',
					'</div>',
				'</div>',
			'</div>')
		return html;
	};

	create_table_sp_popup.prototype.destroy = function()
	{
		if (this.m_uploader) {
			this.m_uploader.destroy();
			this.m_uploader = null;
		}

	}

	create_table_sp_popup.prototype.__makeImportTableSPUploader = function()
	{
		const self = this;
		const MAX_FILE_UPLOAD_SIZE_MB = 50;
		const MAX_FILE_UPLOAD_SIZE_BYTES = MAX_FILE_UPLOAD_SIZE_MB * 1024 * 1024;
		

		if (this.m_uploader) {
			this.m_uploader.destroy();
			this.m_uploader = null;
		}

		this.m_uploader = new inConcert.FileUploaderControl({
			uploader : {
				$control :  $("#" + self.container_id + "_import_schema_control")
			},
			dragger : {
				$control : $("#" + self.container_id + "_import_schema_control")
			},
			preview:{
				$control : $("#" + self.container_id + "_import_schema_preview"),
				uploadStatus: false,
				size:false,
				image:false
			},
			type               : {
				extensions : [ "sql" ]
			},
			sizeLimitMB        : MAX_FILE_UPLOAD_SIZE_BYTES,
			filesLimit         : 1,
			disabled : false,
			uploadOnAdd : false,
		});

		this.m_uploader.onBatchFilesUploadStart = function(callback = $.noop) {
			self.show_waiting("<%=_T('Loading, wait moment please')%>");
			callback();
		};

		this.m_uploader.onBatchFilesUploadEnd = function() {
			self.hide_waiting();
			const file = this.files && this.files[0];
		
			if(file){
				this.getFileText(file, function(result) {
				self.fileResultContent = result.content;
			});
		}
		};

		this.m_uploader.onFileAddError = function(_, result, callback) {
			self.hide_waiting();
			self.show_status_message(result.reason, "Error", 5000);
			this.cleanAllFiles();
			callback();
		};
	};

	create_table_sp_popup.prototype.get_data = function() {
		let item = create_table_sp_popup.uber.get_data.call(this);
		let isImport = false;
		if(this.m_uploader){
			//Import
			item.Query = this.__get_import_file_content();
			isImport = true;
		}
		else{
			const $name = $("#" + this.container_id + "_create_name");
			item.Name = $name.val();
			
		}

		item.isTable = this.is_create_table;
		item.isImport = isImport;
		return item;
	};

	create_table_sp_popup.prototype.__get_import_file_content = function() {
		if(!this.m_uploader){
			return "";
		}
		
		if(this.fileResultContent){
			return this.fileResultContent
		}
		
		return "";
	};

	create_table_sp_popup.prototype.validate = function() {
		const self = this;

		const showError = function ($ctrl, message) {
			self.display_field_error($ctrl);
			self.show_status_message(message, "Error", 5000);
		};

		if(this.m_uploader){
			
			const text_import = self.__get_import_file_content();
			if(!text_import || text_import.trim() === ""){
				self.show_status_message("<%=_T('Must upload a file.')%>", "Error", 5000);
				return false;
			}
		}
		else{
			const $name = $("#" + this.container_id + "_create_name");
			const error_name = "<%=_T('Name is required.')%>";

			if (!$name || $name.val().trim().length === 0) {
				showError($name, error_name);
				return false;
			}

			if (!inConcert.Utils.isValid($name.val(), "variable")) {
				showError($name, "<%=_T('Only letters, numbers, and dashes are allowed. The name cannot start with a number.')%>");
				return false;
			}

			if($name.val().length > 64)
			{
				showError($name, format("<%=_T('Please enter a valid value with length between {0} and {1}.')%>", 1 ,64));
				return false;
			}

			let tables = self.owner && self.owner.database && self.owner.database.tables && Object.keys(self.owner.database.tables) || false;
			if (tables && tables.find(element => element.toLowerCase() === $name.val().trim().toLowerCase())) {
				showError($name, "<%=_T('Table already exists.')%>");
				return false;
			}
		}

		return true;
	};

	create_table_sp_popup.prototype.set_events = function() {
		const self = this;
		create_table_sp_popup.uber.set_events.call(this);
		const create_container = $("#" + self.container_id + "_create_container");
		const import_container = $("#" + self.container_id + "_import_schema_container");
		const import_preview = $("#" + self.container_id + "_import_schema_preview_container");
		
		$("#" + self.container_id + "_select_create")
			.off("change")
			.on("change", function() {
				import_container.hide();
				import_preview.hide();
				create_container.show();
				if (self.m_uploader) {
					self.m_uploader.destroy();
					self.m_uploader = null;
				}
			});

		$("#" + self.container_id + "_select_import")
			.off("change")
			.on("change", function() {
				create_container.hide();
				create_container.val("");
				self.__makeImportTableSPUploader();
				import_container.show();
				import_preview.show();
		});
	};

	create_table_sp_popup.prototype.on_save = function(item, create_and_continue, callback) {
		this.owner.on_save_create_entity(item);
		create_table_sp_popup.uber.on_save.call(this, item, create_and_continue, callback);
	};

	//--------------------------------------------------------------
	function import_tables_values (params) {
		this.m_columns = params.columns;
		this.m_table_name = params.tableName;
		import_tables_values.uber.constructor.call(this, params);

		this.__make_allowed_columns();
		this.__initialize_upload_ctrl();
		this.__show_hide_control_upload(true);
	}

	inConcert.Utils.inherit(import_tables_values, base_create_popup);

	import_tables_values.prototype.destroy = function()
	{

		if (this.m_upload_instance) {
			this.__cleanFiles();
			this.m_upload_instance = null;
		}
	};
	
	import_tables_values.prototype.init = function()
	{
		import_tables_values.uber.init.call(this);
		$("#adm_form_databases_popup_import_table_values_create").prop("disabled", true);
	};

	import_tables_values.prototype.get_html_middle = function() {
		const self = this;

		let html = ("").concat(
			'<div class="card no-card">',
				'<div class="card-block">',

					'<div class="row">',
						'<div class="col-12">',
							'<div class="form-group">',
								'<div class="form-check">',
									'<label for="', self.container_id, '_file_csv_panel_upload_override" class="form-check-label form-check-label-title">',
										'<input id="', self.container_id, '_file_csv_panel_upload_override" class="form-check-input" type="checkbox">',
										'<%=_T("Override Data")%><span class="fa fa-question-circle" title="', '<%=_T("If checked, before inserting, the data will be deleted.")%>', '"></span>',
									'</label>',
								'</div>' ,
							'</div>' ,
						'</div>' ,
					'</div>' ,
					'<div id="'+ self.container_id + '_container" class="row">',
						'<div class="col-12">',
						"<div id='", self.container_id, "_file_csv_panel_upload' class='fileSelectionSection'></div>",
					// Columnas permitidas
					'<div class="card no-card" id="'+ self.container_id + '_allowed_columns_container">' ,
						'<div class="card-block">' ,
							'<div class="row">' ,
								'<div class="col-12">' ,
									'<div class="card-header card-header-sm">',
										'<h5><%=_T("Required CSV Columns")%></h5>',
									'</div>',
									'<div class="form-group">' ,
										'<div id="'+ self.container_id + '_allowed_columns" class="importationHeaders w-100"></div>',
									'</div>' ,
									'</div>' ,
								'</div>' ,
							'</div>' ,
						'</div>' ,
					'</div>',
				'</div>',
			'</div>')
		return html;
	};

	import_tables_values.prototype.get_data = function() {
		let item = import_tables_values.uber.get_data.call(this);
		
		if(this.tableValues){
			item.tableValues = this.tableValues,
			item.TableName = this.m_table_name,
			item.Override = $("#adm_form_databases_popup_import_table_values_file_csv_panel_upload_override").prop("checked");
		}
		return item;
	};

	import_tables_values.prototype.__make_allowed_columns = function()
	{
		var $header = $("#" + this.container_id + "_allowed_columns");
		$header.html("");
		this.m_allowed_csv_columns = []
		for(colId in this.m_columns){
			if(this.m_columns.hasOwnProperty(colId)){
				const column = this.m_columns[colId];
				var $column = $("<div class='importationHeaderItem badge required'>" + column.name + "</div>");
				$column.attr("col_name", column.name.toUpperCase());
				this.m_allowed_csv_columns.push({ CSVFieldName: column.name.toUpperCase(), required:true});
				$header.append($column);
			}
		}
		$("#" + this.container_id + "_allowed_columns_container").show();
	};

	import_tables_values.prototype.__mark_csv_columns = function(list, type)
	{
		var $header = $("#" + this.container_id + "_allowed_columns");
		$.each(list || [], function(_, col_name) {
			var $column = $header.find("[col_name='" + col_name.toUpperCase() + "']");
			if ($column.length > 0) {
				$column.removeClass("error").removeClass("success");
				if (type === "SUCCESS") {
					$column.addClass("success");
				}
				else {
					$column.addClass("error");
				}
			}
		});
	};

	import_tables_values.prototype.__load_custom_csv_uploaded_to_json = function(data, callback){
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/imports/load_custom_csv_uploaded_to_json/",
			type: "POST",
			dataType    : "json",
			contentType : "application/json",
			data : JSON.stringify(data),
			success: function(response) {	
				callback(true, response);
			},
			error: function(response, error) {
				callback(false, error);
			}
		});
	};

	import_tables_values.prototype.__initialize_upload_ctrl = function()
	{
		var self = this;

		this.m_upload_instance = new inConcert.RepositoryUpload({
			auto_initialize: true,
			repository_url: "/inconcert/apps/administration/imports",
			container_id: self.container_id + "_file_csv_panel_upload",
			must_validate_max_size: false,
			availables_extensions: {
				"csv": true
			},
			show_status_message_fn: function(message, type, time_ms) {
				self.show_status_message(message, type, time_ms);
			},
			on_uploaded_fn: function(success, data, callback) {
				
				if (!success) {
					this.m_current_upload_info = null;
					callback();
				}
				else{self.__start_importation(success, data, callback);}
				
			},
			can_upload_file_fn: function(callback) {
				callback = callback || $.noop;
				callback(true);
			}
		});
	};

	import_tables_values.prototype.__cleanFiles = function(){

		if(this.m_upload_instance){
			this.m_current_upload_info = null;
			this.m_upload_instance.dispose();
		}
		if(this.tableValues){
			this.tableValues = null;
		}
	};

	import_tables_values.prototype.__start_importation = function(success, data, callback){
		const self = this;
		this.show_waiting("<%=_T('Loading, wait moment please')%>");
		self.__show_hide_control_upload(false);
		if (success) {
			self.on_uploaded_csv_file(data, function(success, response) {
				self.__mark_csv_columns(response.csvHeader || [], "SUCCESS");
						
				if (success) {
					//Si existen mas columnas de las que se requiere
					if(Object.keys(response.jsonValues[0]).length > self.m_allowed_csv_columns.length){
						success = false;
						response.info = {
							code : -106,
							maxNumFieldsInImport: self.m_allowed_csv_columns.length,
							fileFields: Object.keys(response.jsonValues[0]).length
						};
					}else{
						self.tableValues = {
							columns : response.csvHeader,
							values : response.jsonValues,
							rowsLimit : self.owner.config_db.RowsNumber
						};
						$("#adm_form_databases_popup_import_table_values_create").prop("disabled", false);
					}
				}
	
				if(!success){
					self.__cleanFiles();
					self.__show_csv_popup_error(response.info, data.table_curr_rows)
				}
	
				self.hide_waiting();
			});
		}
		callback();
	};

	import_tables_values.prototype.on_uploaded_csv_file = function(file_info, callback = $.noop)
	{
		this.m_current_upload_info = file_info;
		this.__load_custom_csv_uploaded_to_json({
			CSVFields: this.m_allowed_csv_columns,
			fileId: file_info.fileId,
			Limit : this.owner.config_db.RowsNumber
		},
			function (success, response) {
				callback(success, response);
			});
	};

	import_tables_values.prototype.__show_csv_popup_error = function(current_err)
	{
		let msg;
		if (!current_err) {
			msg = "<%=_T('Unable to Upload CSV File.')%>";
		}
		else if (typeof current_err === "string") {
			msg = current_err;
		}
		else {
			let code_error = parseInt(current_err.code, 10);
			switch(code_error) {
				// Client side errors
				case -1:
					msg = "<%=_T('CSV File has not been uploaded')%>";
					break;
	
				// Server side errors
				case -100:
					msg = "<%=_T('Invalid request')%>";
					break;
	
				case -101:
					msg = "<%=_T('CSV File does not exist')%>";
					break;
	
				case -102:
					const missing_fields = current_err.missingRequiredFields || [];
					const total_missing_fields = missing_fields.length;
					msg = total_missing_fields === 1 ?
					"<%=_T('Missing {0} required field in CSV File')%>" :
					"<%=_T('Missing {0} required fields in CSV File')%>";
					msg = format(msg, total_missing_fields);
					this.__mark_csv_columns(missing_fields, "ERROR");
					break;
	
				case -103:
					msg = "<%=_T('Unable to Upload CSV File. There another uploaded file in progress, try later.')%>";
					break;
	
				case -104:
					msg = "<%=_T('The uploaded file must not exceed {0} rows')%>";
					msg = format(msg, current_err.maximumNumberRowsInImport);
					break;
				
				case -105:
						msg = "<%=_T('Invalid CSV File')%>";
						break;
				case -106:
					msg = "<%=_T('The uploaded file must not exceed {0} columns')%>";
					msg = format(msg, current_err.maxNumFieldsInImport);
					break;
	
				default:
					msg = "<%=_T('Unable to Upload CSV File.')%>";
			}
		}

		const timemout_ms = 5000;
		this.show_status_message(msg, "Error", timemout_ms);
	};

	import_tables_values.prototype.validate = function()
	{
		if (!this.m_current_upload_info || (this.m_current_upload_info && !this.m_current_upload_info.fileName)) {
			this.show_status_message("<%=_T('Must upload a file.')%>", "Error", 5000);
			this.__cleanFiles();
			return false;
		}

		if(!this.tableValues){
			this.show_status_message("<%=_T('No values to insert in table')%>", "Error", 5000);
			this.__cleanFiles();
			return false;
		}
		return true;
	};

	import_tables_values.prototype.on_save = function(item, create_and_continue, callback) {
		this.__cleanFiles();
		this.owner.__on_save_import_table_values(item);
		import_tables_values.uber.on_save.call(this, item, create_and_continue, callback);
	};
	import_tables_values.prototype.on_close = function() {
		this.__cleanFiles();
	};

	import_tables_values.prototype.__show_hide_control_upload = function(show) {
		
		const $upload = $("#" + this.container_id + "_file_csv_panel_upload");
		const $btn_label = $("#" + this.container_id + "_file_csv_panel_upload_file_btn");

		if(show)
		{
			$upload.find("[upload_file='true']").show();
			$btn_label.hide();
			$upload.find("[for='"+ this.container_id + "_file_csv_panel_upload_file_btn" +"']").hide();
		}
		else{
			$upload.find("[upload_file='true']").hide();
			$upload.find("[for='"+ this.container_id + "_file_csv_panel_upload_file_btn" +"']").show();
			$btn_label.show();
		}
	};

}());