/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form skills class
	function adm_form_skills(params)
	{
		var success = adm_form_skills.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title = "<%=_T('Create skill')%>";
		this.update_title = "<%=_T('Edit Skill {0}')%>";
		this.view_title = "<%=_T('View skill {0}')%>";
		this.tagline = "<%=_T('Tagline form Skill!!!')%>";

		this.html_file_name = "/inconcert/apps/administration/skills/frm/render/";
		this.save_uri       = "/inconcert/apps/administration/skills/save/";
		this.get_uri        = "/inconcert/apps/administration/skills/get/";

		return true;
	}

	inConcert.Utils.inherit(adm_form_skills, inConcert.conf_form);

	if (typeof inConcert.adm_form_skills !== "function") {
		inConcert.adm_form_skills = adm_form_skills;
	}

	adm_form_skills.prototype.get = function()
	{
		var skill = {
			Name: $("#adm_form_skill_name").val(),
			Description: $("#adm_form_skill_desc").val(),
			DefaultValue: parseInt($("#adm_form_skill_value").val(), 10)
		};
		var action = this.dashboard.get_current_action_obj();
		var id = action.view.row_id;
		if (!this.is_new) {
			skill[id] = this.$current_row.attr("row_id");
		}
		return skill;
	};

	adm_form_skills.prototype.set = function(success, skill)
	{
		if (!success) {
			return;
		}
		$("#adm_form_skill_name").val(skill.Name);
		$("#adm_form_skill_desc").val(skill.Description);
		$("#adm_form_skill_value").val(skill.DefaultValue);
	};

	adm_form_skills.prototype.empty_controls = function()
	{
		$("#adm_form_skill_name").val("").focus();
		$("#adm_form_skill_desc").val("");
		$("#adm_form_skill_value").val("");
	};

	adm_form_skills.prototype.err_save_messages = function(err)
	{
		var is_custom_message = false;

		if ( typeof err === "object" ) {
			var error_type = err.result.toUpperCase();
			if (error_type === "MUST_HAVE_A_NAME" || error_type === "MUST_HAVE_UNIQUE_NAME") {
				$("#adm_form_skill_name").focus();
			}
			else if (error_type === "MUST_HAVE_A_DESCRIPTION") {
				$("#adm_form_skill_desc").focus();
			}
			else if ( err.result === "ALLEGRO_INTEGRATION_ERROR" ) {
				err = "<%=_T('Error updating information on Allegro integration...')%>";
				$("#adm_form_skill_name").focus();
				is_custom_message = true;
			}
		}

		adm_form_skills.uber.err_save_messages.call( this, err, is_custom_message ); //invokes the base class method
	};

	adm_form_skills.prototype.show_status_message = function(message, type, timeout_ms, scrolling, show_custom_button, $custom_message_container, callbacks, wrap_classes)
	{
		wrap_classes = "class_wrap_message_skills";
		adm_form_skills.uber.show_status_message.call( this, message, type, timeout_ms, scrolling, show_custom_button, $custom_message_container, callbacks, wrap_classes);
	};

	adm_form_skills.prototype.get_validation_def = function()
	{
		var definitions = [
			{
				control_id: "adm_form_skill_name",
				messages: {
					required : "<%=_T('Please enter the skill Name.')%>",
					id       : "<%=_T('Only letters, numbers, dashes and dots are allowed in the skill Name.')%>"
				}
			},
			{
				control_id: "adm_form_skill_desc",
				messages: {
					required : "<%=_T('Please enter the skill description.')%>"
				}
			},
			{
				control_id: "adm_form_skill_value",
				messages: {
					required : "<%=_T('Please enter the skill Default Value.')%>",
					digits   : "<%=_T('Only numbers are allowed in the skill Default Value.')%>",
					range    : {
						type    : "range",
						between : { from: 1, to: 10 },
						message : "<%=_T('Please enter skill Default Value between {0} and {1}.')%>"
					}
				}
			}
		];
		return definitions;
	};

	adm_form_skills.prototype.save = function(callback)
	{
		adm_form_skills.uber.save.call( this, callback );  //invokes the base class method
	};

	adm_form_skills.prototype.ready = function()
	{
		adm_form_skills.uber.ready.call( this );  //invokes the base class method

		var $name = $("#adm_form_skill_name");
		if (!this.is_new) {
			if ( inConcert.app.has_allegro_integration() ) {
				this.readonly_control($name, true);
				$("#adm_form_skill_desc").focus();
				return;
			}
		}
		$name.focus();
	};
}());
