/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// popup alta/edicion spell checker class
	function spell_checker_popup( params )
	{
		this.parent = params.frm;
		// dom ids
		this.id_title            = "adm_form_spell_checker_popup_title";
		this.id_waiting          = "adm_form_spell_checker_popup_waiting";
		this.id_create_update    = "adm_form_spell_checker_popup_create_update";
		this.id_create_continue  = "adm_form_spell_checker_popup_create_continue";
		this.id_hide_popup       = "adm_form_spell_checker_popup_close_popup";
		this.id_message          = "adm_form_spell_checker_popup_message";
		this.id_word_id          = "adm_form_spell_checker_popup_word_id";

		this.edit_word_info = null;
		this.initialize();
	}

	spell_checker_popup.prototype.initialize = function()
	{
		this.make_popup_markup();
		this.set_events();
	};

	spell_checker_popup.prototype.make_popup_markup = function()
	{
		var $popup = this.parent.$get_dom_element_by_id( "view_popup" );

		$popup.html(

			"<div class='internalPopUpContainer spellCheckerPopUp formPopUp'>" +
				"<div class='internalPopUpOverlay'></div>" +
						"<div class='internalPopUp'>" +

							// waiting
							'<div id="' + this.id_waiting + '" class="popupWaitingContainer" hidden>' +
								'<div waiting_message="true" class="internalWaitingMessage"></div>' +
								'<div class="internalWaitingAnimation"></div>' +
								'<div class="internalWaitingOverlay"></div>' +
							'</div>' +

							// title
							"<div class='internalPopUpTitle'>" +
								"<span id='" + this.id_title + "'> </span>" +
								//"<button id='" + this.id_hide_popup + "_times' class='internalPopUpCloseButton'><i class='far fa-times'></i></button>" +
							'</div>' +

							'<div class="internalPopUpMiddle pageFormContainer">' +
								
								// mensaje de error
								'<div id="' + this.id_message + '" class="genericFormMessagesContainer messageError" hidden>FIELD ERROR MESSAGE</div>' +

								// word info
								'<div class="card no-card">' +
									'<div class="card-block">' +
										'<div class="row">' +
											'<div class="col-12">' +
												'<div class="form-group">' +

													'<label for="' + this.id_word_id + '" class="required">' + ' <%=_T("Word")%><%=_T(":")%>' + '</label>' +
													'<input id="' + this.id_word_id + '" placeholder="<%=_T("Enter word")%>..." class="form-control" type="text" maxlength="250" />' +
													'<i id="' + this.id_word_id + '_validation" class="formFieldValidation formFieldError" hidden></i>' +

												'</div>' +
											'</div>' +
										'</div>' +
									'</div>' +
								'</div>' +

							'</div>' +


							// MODAL FOOTER BUTTONS
							'<div class="internalPopUpButtons">' +
								"<button id='" + this.id_hide_popup + "' class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>" +
								"<button id='" + this.id_create_continue + "' class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Confirm & Continue')%>" + "</button>" +
								"<button id='" + this.id_create_update + "' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>" +
							'</div>' +

						'</div>' +
			'</div>'
		);
	};

	spell_checker_popup.prototype.set = function( word_info )
	{
		$("#" + this.id_word_id).val(word_info.name).focus();
	};

	spell_checker_popup.prototype.show = function( word_info )
	{
		this.edit_word_info = word_info || null;
		this.hide_messages();
		this.hide_waiting();
		if ( !this.parent.has_permission_to_save() ) {
			var message = "<%=_T('Unable to add or update words: You dont have permissions for this action.')%>";
			this.parent.show_status_message( message, "Error", 5000 );
			return;
		}

		// cuando abro el popup, dejo sin filtar la grilla
		this.parent.reset_search();

		var $popup = this.parent.$get_dom_element_by_id( "view_popup" );
		$popup.show();
		var $id_create_update = $("#" + this.id_create_update);
		var $id_create_continue = $("#" + this.id_create_continue);
		var title;

		if ( word_info ) {
			title = "<%=_T('Update word')%>";
			$id_create_update.val("<%=_T('Confirm')%>");
			$id_create_continue.hide();
			this.set(word_info);
		}
		else {
			title = "<%=_T('Create word')%>";
			$id_create_update.val("<%=_T('Confirm')%>");
			$id_create_continue.show();
			this.empty_ctrls();
		}
		$("#" + this.id_title).text(title);
	};

	spell_checker_popup.prototype.hide = function()
	{
		var $popup = this.parent.$get_dom_element_by_id( "view_popup" );
		$popup.hide();
		$("#" + this.id_search_text).val("");
	};

	spell_checker_popup.prototype.show_not_results_found = function()
	{
		$("#" + this.id_search_list).hide();
		$("#" + this.id_search_not_result_found).show();
		//$("#" + this.id_total_rows).hide();
	};

	spell_checker_popup.prototype.hide_messages = function()
	{
		$("#" + this.id_message).hide();
		var $popup = this.parent.$get_dom_element_by_id( "view_popup" );
		$popup.find(".formFieldError").hide();
	};

	spell_checker_popup.prototype.show_message = function( message )
	{
		var self = this;
		var $field_mark_err = $("#" + this.id_word_id + "_validation");
		var $message = $("#" + this.id_message);
		$message.removeClass("messageError messageInfo");
		if ( message.success ) {
			$field_mark_err.hide();
			$message.addClass("messageInfo");
			window.setTimeout(function() {
				self.hide_messages();
			}, 2500);
		}
		else {
			$field_mark_err.show();
			$message.addClass("messageError");
		}
		$message.text(message.text).show();
		if ( message.$ctrl ) {
			message.$ctrl.focus();
		}
	};

	spell_checker_popup.prototype.validate = function()
	{
		this.hide_messages();
		var result = { success: true };

		if ( !this.parent.has_permission_to_save() ) {
			result.success = false;
			result.text = "<%=_T('You dont have permissions for this action.')%>";
			result.$ctrl = $word;
			this.show_message(result);
			return result;
		}

		var $word = $("#" + this.id_word_id);
		var word = $word.val().trim();

		if ( word.length === 0 ) {
			result.success = false;
			result.text = "<%=_T('Word is required.')%>";
			result.$ctrl = $word;
			this.show_message(result);
			return result;
		}
		result.value = { name: word };

		if ( !this.parent.grid.can_add_row( result.value ) ) {
			result.success = false;
			result.text = format("<%=_T('{0} already exist.')%>", word);
			result.$ctrl = $word;
			this.show_message(result);
			return result;
		}

		return result;
	};

	spell_checker_popup.prototype.create_or_update_word = function()
	{
		if ( this.edit_word_info ) {
			this.update_word();
		}
		else {
			this.create_word();
		}
	};

	spell_checker_popup.prototype.show_waiting = function( message )
	{
		var $waiting = $("#" + this.id_waiting);
		$waiting.find("[waiting_message]").text(message || "<%=_T('Wait moment please!! ...')%>");
		$waiting.show();
	};

	spell_checker_popup.prototype.hide_waiting = function()
	{
		$("#" + this.id_waiting).hide();
	};

	spell_checker_popup.prototype.update_word = function( callback )
	{
		var self = this;
		callback = callback || $.noop;
		var result = this.validate();
		if ( !result.success ) {
			return;
		}
		var old_word = this.edit_word_info;
		var new_word = result.value;

		this.show_waiting( "<%=_T('Wait moment please!! ... Updating word.')%>" );

		var show_error = function() {
			result.success = false;
			result.text = format("<%=_T('Unable to updated old word: {0} with new word: {1}.')%>", old_word.name, new_word.name);
			self.show_message(result);
			self.hide_waiting();
		};

		var api = this.parent.dashboard.get_api();
		api.save({
			uri  : inConcert.app.getBaseDomain() + this.parent.save_uri,
			data : {
				language : this.parent.get_entity_id(),
				new_word : new_word,
				old_word : old_word
			},
			callback : function( updated )
			{
				if ( !updated ) {
					show_error();
					return;
				}

				self.parent.grid.update_row_word( old_word, new_word, true,
					function( success )
					{
						var message, type;
						if ( success ) {
							self.parent.grid.show_or_hide_grid();
							message = format("<%=_T('{0} word was successfully updated.')%>", new_word.name);
							$('.searchFilterToPage').addClass("messageInfoShown");
							type = "Info";
							self.hide();
							self.parent.show_status_message( message, type, 5000 );
							setTimeout(function(){
								$('.searchFilterToPage').removeClass("messageInfoShown");
							}, 5001);
						}
						else {
							show_error();
						}
						callback( success );
					}
				);
			}
		});
	};

	spell_checker_popup.prototype.create_word = function( no_close, callback )
	{
		var self = this;

		callback = callback || $.noop;
		var result = this.validate();
		if ( !result.success ) {
			callback(false);
			return;
		}
		var word = result.value;

		this.show_waiting( "<%=_T('Wait moment please!! ... Adding word.')%>" );

		var show_error = function( err )
		{
			var msg_err;
			if ( typeof err === "object" ) {
				switch( (err.result || "").toUpperCase() )
				{
					case "ERROR_UPDATING_EQUALS_WORDS":
						msg_err = "<%=_T('Unable to update the same words.')%>";
						break;

					case "ALREADY_EXISTS_IN_SYSTEM_WORDS":
						msg_err = "<%=_T('Unable to add or update the word. This is a system word.')%>";
						break;
				}
			}
			result.success = false;
			result.text = msg_err || format("<%=_T('Unable to add {0} word.')%>", word.name); // el mensaje por default
			self.show_message(result);
			self.hide_waiting();
		};

		var api = this.parent.dashboard.get_api();
		api.save({
			uri  : inConcert.app.getBaseDomain() + this.parent.save_uri,
			data : {
				language : this.parent.get_entity_id(),
				new_word : word
			},
			callback : function( created, err )
			{
				if ( !created ) {
					show_error(err);
					callback( false );
					return;
				}

				self.parent.grid.add_row_word( word, true,
					function( success )
					{
						var message, type;
						if ( success ) {
							self.parent.grid.show_or_hide_grid();
							message = format("<%=_T('{0} word was successfully added.')%>", word.name);
							type = "Info";
							$('.searchFilterToPage').addClass("messageInfoShown");
							if ( !no_close ) {
								self.hide();
								self.parent.show_status_message( message, type, 5000 );
								setTimeout(function(){
									$('.searchFilterToPage').removeClass("messageInfoShown");
								}, 5001);
							}
							else {
								result.success = true;
								result.text = message;
								self.show_message(result);
							}
							self.parent.grid.update_rows_counter();
							self.parent.update_total_words_in_view_row( "increment" );
						}
						else {
							show_error();
						}
						callback( success );
					}
				);
			}
		});
	};

	spell_checker_popup.prototype.create_word_continue = function( callback )
	{
		callback = callback || $.noop;
		var self = this;
		this.create_word( true /* no close */, function( success ) {
			if ( success ) {
				self.empty_ctrls();
				self.hide_waiting();
			}
			callback( success );
		});
	};

	spell_checker_popup.prototype.empty_ctrls = function()
	{
		$("#" + this.id_word_id).val("").focus();
	};

	spell_checker_popup.prototype.set_events = function()
	{
		var self = this;

		// click sobre el boton agregar/actualizar palabras
		$("#" + this.id_create_update)
			.off("click")
			.on("click", function() {
				self.create_or_update_word();
			});
		// click sobre el boton para crear y continuar agregando palabras
		$("#" + this.id_create_continue)
			.off("click")
			.on("click", function() {
				self.create_word_continue();
			});
		// click en el boton para cerrar el popup y descartar cambios
		$("#" + this.id_hide_popup)
			.off("click")
			.on("click", function() {
				self.hide();
			});

		// click en el boton para cerrar el popup y descartar cambios
		$("#" + this.id_hide_popup + "_times")
			.off("click")
			.on("click", function() {
				self.hide();
			});
	};
	//-----------------------------------


	//---------------------------------------------------------------------
	// grid spell checker class
	function spell_checker_grid( params )
	{
		this.parent = params.frm;
		// dom ids
		this.id_not_result         = "adm_form_spell_checker_not_results_found";
		this.id_spell_checker_list = "adm_form_spell_checker_list";
		//this.id_total_rows         = "conf_form_total_rows";
	}

	spell_checker_grid.prototype.show_not_results_found = function( message )
	{
		message = message || "<%=_T('No words found.')%>";
		$("#" + this.id_spell_checker_list).hide();
		//$("#" + this.id_total_rows).hide();
		$("#" + this.id_not_result).text(message).show();
	};

	spell_checker_grid.prototype.hide_not_results_found = function()
	{
		$("#" + this.id_not_result).hide();
		$("#" + this.id_spell_checker_list).show();
		//$("#" + this.id_total_rows).show();
		this.update_total_rows_msg();
	};

	spell_checker_grid.prototype.show_words = function( words )
	{
		words = words || {};
		this.add_rows_words( words );
	};

	spell_checker_grid.prototype.count_rows = function()
	{
		return $("#" + this.id_spell_checker_list).find("li[word_data]").length;
	};

	spell_checker_grid.prototype.count_visible_rows = function()
	{
		return $("#" + this.id_spell_checker_list).find("li[word_data]:visible").length;
	};

	spell_checker_grid.prototype.show_or_hide_grid = function()
	{
		if ( this.count_rows() === 0 ) {
			this.show_not_results_found();
		}
		else {
			this.hide_not_results_found();
			if ( this.count_visible_rows() === 0 ) {
				this.show_not_results_found();
			}
		}
	};

	spell_checker_grid.prototype.add_rows_words = function( words )
	{
		var self = this;
		$("#" + this.id_spell_checker_list).find("li[word_data]").remove();

		inConcert.Utils.foreach_timeout({
			rows : words || {},
			waiting_message : "<%=_T('Please wait, adding words, {0} of {1}.')%>",
			append_fn: function( word ) {
				self.add_row_word( word );
			},
			waiting_fn: function( message ) {
				self.parent.show_waiting( message );
			},
			complete_fn: function() {
				window.setTimeout(function() {
					self.show_or_hide_grid();
					self.update_rows_counter();
					self.parent.hide_waiting();
					$("#" + self.parent.id_search_text).focus();
				});
			}
		});
	};

	spell_checker_grid.prototype.can_add_row = function( word )
	{
		var $row = $("#" + this.get_opt_word_id( word.name ) );
		return $row.length === 0;
	};

	spell_checker_grid.prototype.update_rows_counter = function()
	{
		// esta funcion actualiza el contador que inidica el numero de fila.
		// es bastante carreta como esta, porque siempre recorre todos los rows para actualizar la celda.
		// por ejemplo en el caso de borrar, deberia actualizar a partir de la posicion donde se encuentra la row a eliminar, en delante
		// lo mismo cuando se agrega.
		// TODO: cambiar por lo anterior, por ahora queda asi.
		//
		var $list_container = $("#" + this.id_spell_checker_list);
		var count = 0;
		$list_container.find("li[word_data] label[counter]:visible").each(function(_, counter)
		{
			count++;
			var $counter = $(counter);
			$counter.text(count);
		});
	};

	spell_checker_grid.prototype.add_row_word = function( word, apply_effect, callback )
	{
		var self = this;
		callback = callback || $.noop;
		if ( !word ) {
			callback( false );
			return;
		}
		if ( !this.can_add_row( word ) ) {
			callback( false );
			return;
		}
		var display = "";
		if ( apply_effect ) {
			display = " hidden ";
		}
		var unique_id = word.name.trim().toLowerCase();

		var $make_new_row = function()
		{
			var html_actions = "";
			if ( self.parent.has_permission_to_save() ) {
				html_actions = "<button action_edit='true' class='buttonColorGray gridActionButton edit' type='button'><i class='buttons-icons-edit'></i>" + "<%=_T('Edit')%>" + "</button>";
			}
			if ( self.parent.has_permission_to_delete() ) {
				html_actions = html_actions + "<button action_del='true' class='buttonColorGray gridActionButton delete last' type='button'><i class='buttons-icons-delete'></i>" + "<%=_T('Delete')%>" + "</button>";
			}

			var word_id = word.name;
			var opt_dom_id = self.get_opt_word_id( word_id );
			var $word = $(
				"<li id='" + opt_dom_id + "' word_id='" + word_id + "' search_text='" + word_id + "' word_data='true' class='viewListItem' " + display + ">" +
					"<label counter='true' class='viewListItemText'></label>" +
					"<label word_id='true' class='viewListItemText' unique_id='" + unique_id + "'>" + word_id  + "</label>" +
					html_actions +
				"</li>");
			$word.data("word_info", word);
			return $word;
		};

		var added = false;
		var $list_container = $("#" + this.id_spell_checker_list);
		var $new_row;
		$list_container.find("li[word_data]").each(function(_, row)
		{
			var $row = $(row);
			var current_unique_id = $row.find("label[word_id]").attr("unique_id");

			if ( !added && unique_id < current_unique_id ) {
				$new_row = $make_new_row();
				$row.before($new_row);
				added = true;
				return false; // break
			}
		});
		if (!added) {
			$new_row = $make_new_row();
			$list_container.append($new_row);
		}
		if (apply_effect && $new_row) {
			// aca realizo el fade in
			$new_row.fadeIn("slow");
		}
		callback( true );
	};

	spell_checker_grid.prototype.remove_row_word = function( $word_to_remove, apply_effect )
	{
		var self = this;
		if ( apply_effect ) {
			$word_to_remove.fadeOut("slow", function() {
				$word_to_remove.remove();
				self.show_or_hide_grid();
				self.update_rows_counter();
			});
		}
		else {
			$word_to_remove.remove();
			this.update_rows_counter();
		}
		this.parent.update_total_words_in_view_row( "decrement" );
	};

	spell_checker_grid.prototype.update_row_word = function( old_value, new_value, apply_effect, callback )
	{
		var word_id = old_value.name;
		var opt_dom_id = this.get_opt_word_id( word_id );
		this.remove_row_word( $("#" + opt_dom_id) );
		this.add_row_word( new_value, apply_effect, callback );
		this.update_rows_counter();
	};

	spell_checker_grid.prototype.get_opt_word_id = function( word_id )
	{
		var normalized_id = inConcert.Utils.getNormalizedId( word_id || "" );
		var opt_id = this.id_spell_checker_list + "_opt_word_" + normalized_id;
		return opt_id;
	};

	spell_checker_grid.prototype.make_search_regexp = function( word )
	{
		if (typeof word !== "string") {
			return "";
		}
		var search_pattern = inConcert.Utils.removeSpecialChars(word);
		return new RegExp(search_pattern.replace(/[^\w\s]/gi, ""), "i");
	};

	spell_checker_grid.prototype.filter = function( text )
	{
		var self = this;

		var total_rows = this.count_rows();
		if ( total_rows === 0 ) {
			this.show_not_results_found();
			return;
		}

		var $list_container = $("#" + this.id_spell_checker_list);
		if ( text.trim().length === 0 ) {
		// si no hay texto buscado en el filtro, no filtro la row
			$list_container.find("li[word_data]").show();
			this.update_rows_counter();
			this.hide_not_results_found();
			return;
		}
		var hidden_rows = 0;
		$list_container.find("li[word_data]").each(function(_, row)
		{
			var $row = $(row);
			var row_value = $row.attr("search_text");
			var search_regexp = self.make_search_regexp(text);
			if (row_value.search(search_regexp) === -1) {
				$row.hide();
				hidden_rows++;
			}
			else {
				$row.show();
			}
		});
		if ( total_rows === hidden_rows ) {
			this.show_not_results_found();
		}
		else {
			this.update_rows_counter();
			this.hide_not_results_found();
		}
	};

	spell_checker_grid.prototype.update_total_rows_msg = function()
	{
		var message;
		var total_rows = this.count_rows();
		var words_text = total_rows === 1 ? "<%=_T('word')%>" : "<%=_T('words')%>";
		var visible_rows = this.count_visible_rows();
		if ( visible_rows === total_rows ) {
			message = format("<%=_T('{0} {1}')%>", total_rows, words_text);
		}
		else {
			message = format("<%=_T('{0} of {1} {2}')%>", visible_rows, total_rows, words_text);
		}
		//$("#" + this.id_total_rows).text( message );
	};

	spell_checker_grid.prototype.remove_word = function( $row, apply_effect )
	{
		var self = this;
		var word =  $row.attr("word_id");

		// TODO: agregar waiting
		var api = this.parent.dashboard.get_api();
		api.erase({
			uri  : inConcert.app.getBaseDomain() + this.parent.delete_uri,
			entities_to_delete : {
				language : this.parent.get_entity_id(),
				word : word
			},
			callback : function( removed )
			{
				var message, type;

				if ( !removed ) {
					message = format("<%=_T('Unable to delete word: {0}.')%>", word);
					type = "Error";
					$('.searchFilterToPage').addClass("messageInfoShown");
					self.parent.show_status_message( message, type, 5000 );
					setTimeout(function(){
						$('.searchFilterToPage').removeClass("messageInfoShown");
					}, 5001);
					return;
				}

				message = format("<%=_T('{0} word was successfully deleted.')%>", word);
				type = "Info";
				$('.searchFilterToPage').addClass("messageInfoShown");
				self.parent.show_status_message( message, type, 5000 );
				setTimeout(function(){
					$('.searchFilterToPage').removeClass("messageInfoShown");
				}, 5001);
				self.remove_row_word( $row, apply_effect );
			}
		});
	};

	spell_checker_grid.prototype.set_events = function()
	{
		var self = this;

		// grilla acciones boton delete
		var $list_container = $("#" + this.id_spell_checker_list);
		// boton delete de la lista de parametros
		var event_selector = "button[action_del]";
		$list_container
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var message;
				if ( !self.parent.has_permission_to_delete() ) {
					message = "<%=_T('Unable to remove words: You dont have permissions for this action.')%>";
					$('.searchFilterToPage').addClass("messageInfoShown");
					self.parent.show_status_message( message, "Error", 5000 );
					setTimeout(function(){
						$('.searchFilterToPage').removeClass("messageInfoShown");
					}, 5001);
					return;
				}

				var $row = $(this).parent();
				message = format(
					"<%=_T('Do you want to remove word {0} ?')%>", $row.find("[word_id='true']").text()
				);
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					jQuery.inconcertPopup.ButtonSets.BS_YESNO,
					function( response )
					{
						if (response.toLowerCase() !== "yes") {
							return;
						}
						if ( !self.parent.has_permission_to_delete() ) {
							var message = "<%=_T('Unable to remove words: You dont have permissions for this action.')%>";
							$('.searchFilterToPage').addClass("messageInfoShown");
							self.parent.show_status_message( message, "Error", 5000 );
							setTimeout(function(){
								$('.searchFilterToPage').removeClass("messageInfoShown");
							}, 5001);
							return;
						}
						self.remove_word( $row, true );
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});

		event_selector = "button[action_edit]";
		$list_container
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var word_info = $(this).parent().data("word_info");
				self.parent.popup.show( word_info );
			}
		);

		event_selector = "li[word_id]";
		$list_container
			.off("dblclick", event_selector)
			.on("dblclick", event_selector, function()
			{
				var $row = $(this);
				var $btn_edit = $row.find("button[action_edit]");
				$btn_edit.trigger("click");
			}
		);
	};

	//---------------------------------------------------------------------
	// form spell checker class
	function adm_form_spell_checker( params )
	{
		var success = adm_form_spell_checker.uber.constructor.call( this, params );
		if ( !success ) {
			return;
		}

		this.update_title   = "<%=_T('Spell Checker {0} Words')%>";
		this.view_title     = "<%=_T('View {0} Words')%>";
		this.tagline        = "<%=_T('Tagline form Words!!!')%>";

		this.html_file_name = "/inconcert/apps/administration/spell_checker/frm/render/";
		this.save_uri       = "/inconcert/apps/administration/spell_checker/save_word/";
		this.delete_uri     = "/inconcert/apps/administration/spell_checker/delete_word/";
		this.get_uri        = "{0}/inconcert/apps/administration/spell_checker/load_words/{1}";
		this.not_show_required_message = true;

		// dom ids
		this.id_search_text        = "adm_form_spell_checker_search_text";
		this.id_new_word           = "adm_form_spell_checker_new_word";

		this.grid = new spell_checker_grid({ frm: this });
		this.popup = new spell_checker_popup({ frm: this });

		return true;
	}

	inConcert.Utils.inherit( adm_form_spell_checker, inConcert.conf_form );

	if ( typeof inConcert.adm_form_spell_checker !== "function" ) {
		inConcert.adm_form_spell_checker = adm_form_spell_checker;
	}

	adm_form_spell_checker.prototype.ready_for_save = function()
	{
		adm_form_spell_checker.uber.ready_for_save.call( this );  //invokes the base class method
		this.readonly_buttons();
		const $cancel = this.$get_dom_element_by_id("form_button_cancel");
		$cancel.hide();
	};

	adm_form_spell_checker.prototype.initialize = function() {
		this.add_css_class("pageFormForVisibleButtons");
		const $cancel = this.$get_dom_element_by_id("form_button_cancel");
		$cancel.hide();
		const $back_btn_container = this.$get_dom_element_by_id("form_back_btn_container");
		$back_btn_container.show();
	};

	adm_form_spell_checker.prototype.on_close = function() {
		this.remove_css_class();
	};

	adm_form_spell_checker.prototype.update_total_words_in_view_row = function( action )
	{
		var $language_row = this.$current_row;
		if ( !$language_row || $language_row.length === 0 ) {
			return;
		}
		var $total_words_cell = $language_row.find("[column_id='total_words']");
		if ( $total_words_cell.length === 0 ) {
			return;
		}
		var total_words = parseInt($total_words_cell.text() || "0", 10);
		if ( action === "increment" ) {
			total_words++;
		}
		else {
			total_words--;
		}
		$total_words_cell.text(total_words);
	};

	adm_form_spell_checker.prototype.set_events = function()
	{
		var self = this;
		adm_form_spell_checker.uber.set_events.call( this );  //invokes the base class method

		var $new_word = $("#" + this.id_new_word);
		$new_word
			.off("click")
			.on("click", function() {
				self.popup.show();
			});

		var $search_word = $("#" + this.id_search_text);
		$search_word
			.off("keyup")
			.on("keyup", function() {
				var text = $(this).val();
				if ( self.timeout ) {
					window.clearTimeout( self.timeout );
					self.timeout = null;
				}
				self.timeout = window.setTimeout( function() {
					self.grid.filter( text );
					window.clearTimeout( self.timeout );
					self.timeout = null;
				}, 500 );
			});

		const $form_back_btn = this.$get_dom_element_by_id("form_back_btn");
		$form_back_btn.
		off("click")
		.on("click", function() {
			self.close("cancel");
		});

		this.grid.set_events();
	};

	adm_form_spell_checker.prototype.readonly = function()
	{
		adm_form_spell_checker.uber.readonly.call( this );
	};

	adm_form_spell_checker.prototype.set = function( success, words )
	{
		if ( !success ) {
			return;
		}
		if ( !words || words.length === 0 ) {
			this.grid.show_not_results_found();
			return;
		}
		this.grid.show_words( words );
	};

	adm_form_spell_checker.prototype.build_header_custom_buttons = function()
	{
		var value = this.search_text || "";
		var html_buttons =
		"<div class='pageViewFilter searchFilterToPage searchFieldIcon goToInline'>" +
				"<input id='" + this.id_search_text + "' class='filterField' type='text' value='" + value + "' />" +
			"</div>"+
			"<button id='" + this.id_new_word + "' class='pageButtonGeneric buttonColorOrange pageButtonNew' type='button'><i class='fal fa-plus'></i><%=_T('Create word')%></button>";
		adm_form_spell_checker.uber.build_header_custom_buttons.call( this, html_buttons );  //invokes the base class method
	};

	adm_form_spell_checker.prototype.ready = function()
	{
		adm_form_spell_checker.uber.ready.call( this );  //invokes the base class method
	};

	adm_form_spell_checker.prototype.reset_search = function()
	{
		$("#" + this.id_search_text).val("");
		this.grid.filter("");
	};

	adm_form_spell_checker.prototype.uri_get_entity = function()
	{
		if (this.is_new) {
			return "";
		}
		var name = this.$current_row.attr("row_id");
		var uri = format( this.get_uri, inConcert.app.getBaseDomain(), name );
		return uri;
	};
}());

