/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form states class
	function adm_form_states(params)
	{
		var success = adm_form_states.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title = "<%=_T('Create custom status')%>";
		this.update_title = "<%=_T('Edit Custom Status {0}')%>";
		this.view_title = "<%=_T('View Custom State {0}')%>";
		this.tagline = "<%=_T('Tagline form State!!!')%>";

		this.html_file_name = "/inconcert/apps/administration/states/frm/render/";
		this.save_uri       = "/inconcert/apps/administration/states/save/";
		this.get_uri        = "/inconcert/apps/administration/states/get/";
		/*
			Dejo comentado, si quisieramos habilitar el delete en batch, tenemos que descomentar y tambien la defincion de "adm_config.js" para esta vista.
		*/
		//this.delete_uri     = "/inconcert/apps/administration/states/delete/";

		return true;
	}

	inConcert.Utils.inherit(adm_form_states, inConcert.conf_form);

	if (typeof inConcert.adm_form_states !== "function") {
		inConcert.adm_form_states = adm_form_states;
	}

	adm_form_states.prototype.get = function()
	{
		var state = {
			Name: $("#adm_form_state_name").val(),
			Description: $("#adm_form_state_desc").val()
		};
		var action = this.dashboard.get_current_action_obj();
		var id = action.view.row_id;
		if (!this.is_new) {
			state[id] = this.$current_row.attr("row_id");
		}
		return state;
	};

	adm_form_states.prototype.set = function(success, state)
	{
		if (!success) {
			return;
		}
		$("#adm_form_state_name").val(state.Name);
		$("#adm_form_state_desc").val(state.Description);
	};

	adm_form_states.prototype.empty_controls = function()
	{
		$("#adm_form_state_name").val("").focus();
		$("#adm_form_state_desc").val("");
	};

	adm_form_states.prototype.err_save_messages = function( err, is_custom_message )
	{
		adm_form_states.uber.err_save_messages.call( this, err, is_custom_message ); //invokes the base class method
		if (typeof err !== "object") {
			return;
		}
		if (err.result === "MUST_HAVE_A_NAME" || err.result === "MUST_HAVE_UNIQUE_NAME" || err.result === "OVERFLOW_NAME") {
			$("#adm_form_state_name").focus();
		}
		else if (err.result === "MUST_HAVE_A_DESCRIPTION") {
			$("#adm_form_state_desc").focus();
		}
	};

	adm_form_states.prototype.get_validation_def = function()
	{
		var definitions = [
			{
				control_id: "adm_form_state_name",
				messages: {
					required: "<%=_T('Please enter the state Name.')%>",
					id:    "<%=_T('Only letters, numbers, dashes and dots are allowed in the state Name.')%>"
				}
			},
			{
				control_id: "adm_form_state_desc",
				messages: {
					required: "<%=_T('Please enter the state description.')%>"
				}
			}
		];
		return definitions;
	};

	adm_form_states.prototype.ready = function()
	{
		adm_form_states.uber.ready.call( this ); //invokes the base class method
		$("#adm_form_state_name").focus();
	};
}());