/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const FORMAT = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// Profile Management
	function AdminTtsVoicesMng(params)
	{
		if (!params) {
			throw("AdminTtsVoicesMng - 'params' is required");
		}
		if (!params.owner) {
			throw("AdminTtsVoicesMng - 'params.owner' is required");
		}
		if (!params.prefix) {
			throw("AdminTtsVoicesMng - 'params.prefix' is required");
		}
		if (!params.container_id) {
			throw("AdminTtsVoicesMng - 'params.container_id' is required");
		}

		this.owner = params.owner;
		this.owner_name = params.owner_name || "";
		this.prefix = params.prefix + "_";
		this.container_id = params.container_id;

		this.m_grid_voices = null;

		return true;
	}
	
	inConcert.Utils.inherit(AdminTtsVoicesMng, inConcert.conf_form);

	if (typeof inConcert.AdminTtsVoicesMng !== "function") {
		inConcert.AdminTtsVoicesMng = AdminTtsVoicesMng;
	}

	AdminTtsVoicesMng.prototype.initialize = function()
	{
		this.__make_popup_html();
		this.__init_voices();
		this.__init_grid();
	};

	AdminTtsVoicesMng.prototype.get_grid_dom_id = function()
	{
		return this.prefix + "list";
	};

	AdminTtsVoicesMng.prototype.__make_popup_html = function()
	{
		let html = '' +
		'<div class="row" id="' + this.prefix + 'new_container">' +
			'<div class="col-12">' +
				'<div class="card-header">' +
					'<h5> <%=_T([[Voices Config]])%></h5>' +
					'<i id="' + this.prefix + 'new_list_validation" class="formFieldValidation formFieldError" hidden></i>' +
						// '<label class="subTitleHelp"><%=_T([[/ You can configure voices for the TTS/ASR Engine.]])%></label>' +
						// '<i id="' + this.prefix + 'new_list_validation" class="formFieldValidation formFieldError" hidden></i>' +
				'</div>' +
			'</div>' +
		'</div>' +
		'<div class="row">' +
			'<div class="col-6">' +
				'<div class="form-group mb-4">' +
					'<label for="vccDefaultVoice"><%=_T([[Default TTS voice:]])%></label>' +
					'<select id="vccDefaultVoice" class="form-control"></select>' +
				'</div>' +
			'</div>' +
		'</div>' +
		// TABLE
		'<div class="row" id="' + this.prefix + 'container" >' +
			'<div class="col-12">' +
			'<div id="' + this.prefix + 'not_results_found" class="inlineMessagesContainer messageInfo mt-0" style="display:none"></div>' +
				'<table id="' + this.get_grid_dom_id() + '" cellpadding="0" cellspacing="0" border="0" class="viewGrid mt-0 mb-3">' +
					'<thead class="viewGridHeader"></thead>' +
					'<tbody class="viewGridBody"></tbody>' +
				'</table>' +
				'<div class="mb-2" id="' + this.prefix + 'paginator"></div>' +
			'</div>' +
		'</div>' +
		'<hr />' +

		// popup
		'<div id="' + this.prefix + 'popup" class="internalPopUpContainer formPopUp popUp720w" style="display:none;">' +
			'<div class="internalPopUpOverlay"></div>' +

			'<div class="internalPopUp">' +

				// waiting
				'<div id="' + this.prefix + 'popup_waiting" class="popupWaitingContainer" style="display:none;">' +
					'<div waiting_message="true" class="popupWaitingMessage"></div>' +
					'<div class="popupWaitingAnimation"></div>' +
					'<div class="popupWaitingOverlay"></div>' +
				'</div>' +

				// title
				'<div class="internalPopUpTitle">'+
					'<span id="' + this.prefix + 'popup_title"></span>'+
					'<button  id="' + this.prefix + 'popup_close_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>'+
				'</div>'+


				'<div class="internalPopUpMiddle pageFormContainer">' +

					// error
					'<div id="' + this.prefix + 'popup_message" class="genericFormMessagesContainer messageError" style="display:none;">' +
						'<label class="messageText"></label>' +
					'</div>' +

					'<div class="card">' +
						'<div class="card-block">' +
							'<div class="row">' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_voice_id" ><%=_T([[Voice Id]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_voice_id" class="form-control" type="text"  placeholder="<%=_T([[Enter the identifier]])%>..." />' +
										'<i id="' + this.prefix + 'popup_voice_id_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_name" ><%=_T([[Description]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_name" class="form-control" type="text" placeholder="<%=_T([[Enter description]])%>..." />' +
										'<i id="' + this.prefix + 'popup_name_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="row">' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_LanguageCode" ><%=_T([[Language Code]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_LanguageCode" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>..." />' +
										'<i id="' + this.prefix + 'popup_version_LanguageCode" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_LanguageName" ><%=_T([[Language Name]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_LanguageName" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>..." />' +
										'<i id="' + this.prefix + 'popup_LanguageName_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="row">' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_VoiceName" ><%=_T([[Voice Name]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_VoiceName" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>..." />' +
										'<i id="' + this.prefix + 'popup_VoiceName_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_Gender" ><%=_T([[Gender]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_Gender" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>..." />' +
										'<i id="' + this.prefix + 'popup_Gender_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="row">' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_Age" ><%=_T([[Age]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_Age" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>..." />' +
										'<i id="' + this.prefix + 'popup_Age_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_Variant" ><%=_T([[Variant]])%><%=_T([[:]])%></label>' +
										'<input id="' + this.prefix + 'popup_Variant" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>..." />' +
										'<i id="' + this.prefix + 'popup_Variant_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="row">' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_prosodyVolume" ><%=_T([[Volume]])%><%=_T([[:]])%></label>' +
										'<select id="' + this.prefix + 'popup_prosodyVolume" class="form-control"></select>' +
										'<i id="' + this.prefix + 'popup_prosodyVolume_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
								'<div class="col-6">' +
									'<div class="form-group">' +
										'<label for="' + this.prefix + 'popup_prosodyRate" ><%=_T([[Rate]])%><%=_T([[:]])%></label>' +
										'<select id="' + this.prefix + 'popup_prosodyRate" class="form-control"></select>' +
										'<i id="' + this.prefix + 'popup_prosodyRate_validation" class="formFieldValidation formFieldError" hidden></i>' +
									'</div>' +
								'</div>' +
							'</div>' +

						'</div>' +
					'</div>' +
				'</div>' +

				// MODAL FOOTER BUTTONS
				'<div class="internalPopUpButtons">' +
					'<button id="' + this.prefix + 'popup_create"  class="pageButtonGeneric buttonColorBlue float-right">' + "<%=_T([[Confirm]])%>" + '</button>' +
					'<button id="' + this.prefix + 'popup_create_and_continue"  class="pageButtonGeneric buttonColorBlue float-right">' + "<%=_T([[Confirm & continue]])%>" + '</button>' +
					'<button id="' + this.prefix + 'popup_close"  class="pageButtonGeneric buttonColorWhite float-right">' + "<%=_T([[Cancel]])%>" + '</button>' +
				'</div>' +

			'</div>' +
		'</div>';

		const $container = $("#" + this.container_id);
		$container.html(html);
	};

	AdminTtsVoicesMng.prototype.__init_grid = function()
	{
		const self = this;

		this.m_grid_voices = new inConcert.conf_form_paginator({
			owner: this.owner,
			frm: this.owner,
			row_id: "id",
			display_name: "id",
			rows_per_page: 10,
			show_at_least: 9,
			paginator_type: "ALL_ROWS_CLIENT_SIDE",
			without_paginator: false,
			loading_waiting_msg: "<%=_T('Please wait, loading Voices ...')%>",
			ids: {
				paginator: this.prefix + "paginator",
				grid: this.get_grid_dom_id(),
				not_results_found: this.prefix + "not_results_found",
			//popup0
				popup: this.prefix + "popup",
				popup_msg: this.prefix + "popup_message",
				popup_create: this.prefix + "popup_create",
				popup_create_and_continue: this.prefix + "popup_create_and_continue",
				popup_title: this.prefix + "popup_title",
				popup_close: this.prefix + "popup_close",
				popup_close_times: this.prefix + "popup_close_times",
				popup_input_id: this.prefix + "popup_question",
				popup_waiting: this.prefix + "popup_waiting"
			},
			strings: {
				not_results_found: "<%=_T('No Voices found.')%>"
			},
			columns: [
				{id: "_number"           , name: "", type: "counter"                            },
				{id: "id"                , name: "<%=_T('Id')%>"                                },
				{id: "LanguageCode"      , name: "<%=_T('Language Code')%>"                     },
				{id: "LanguageName"      , name: "<%=_T('Language Name')%>"                     },
				{id: "VoiceName"         , name: "<%=_T('Voice Name')%>"                        },
				{id: "Gender"            , name: "<%=_T('Gender')%>"                            },
				{id: "prosodyVolume"     , name: "<%=_T('Volume')%>"                            },
				{id: "prosodyRate"       , name: "<%=_T('Rate')%>"                              },
				{
					id: "_action",
					name: "",
					system_action: {
						edit: true,
						erase: false
					}
				}
			],
			callbacks: {
				save: function(callback, must_create_and_contiune, current_popup) {
					callback = callback || $.noop;
					self.add_or_update_row(callback, must_create_and_contiune, current_popup);
				},
				edit: function(row_data) {
					self.on_open_popup(row_data);
				},
				on_removed_row: function(/*row, callback = $.noop*/) {},
 				on_closed_popup: function() {
 					self.on_closed_popup();
 				}
			},
			validate: {
				required_msg: "<%=_T('Must add at least one Voice.')%>",
				required: false
			}
		});
	};

	AdminTtsVoicesMng.prototype.start_grid_validation = function()
	{
		let response = {
			success: true
		};
		let success = this.m_grid_voices.start_validation().success;
		if (!success) {
			response.success = false;
			response.message = this.m_grid_voices.get_validation_message_err("required");
		}
		return response;
	};

	AdminTtsVoicesMng.prototype.on_closed_popup = function(/*current_popup*/)
	{
		this.m_is_new_voice = null;
		this.m_current_voice = null;
	};

	AdminTtsVoicesMng.prototype.add_or_update_row = function(callback/*, _, current_popup*/)
	{
		callback = callback || $.noop;

		const self = this;

		this.validate_voice_to_add_or_update(function(response)
		{
			if (!response.success) {
				callback(false);
				return;
			}
			let msg_response = {
				msg : "",
				type: "Info"
			};
	
			if (self.m_is_new_voice) {
				msg_response.msg = "<%=_T('Voice was successfully added.')%>";
				let must_add_many = false;
				callback(true, response.item, msg_response, must_add_many);
			}
			else {
				msg_response.msg = "<%=_T('Voice was successfully updated.')%>";
				self.m_current_voice = inConcert.Utils.cloneObject(response.item);
				var localCurrentVoice = inConcert.Utils.cloneObject(self.m_current_voice);
				callback(true, self.m_current_voice, msg_response);
			}
	
			self.clean_up_controls_voice();
		});
	};

	AdminTtsVoicesMng.prototype.clean_up_controls_voice = function()
	{

	};

	AdminTtsVoicesMng.prototype.on_open_popup = function(item)
	{
		var self = this;
		const $title = $("#" + this.prefix + "popup_title");
		this.m_is_new_voice = item ? false: true;
		this.m_current_voice = item || {};

		this.clean_up_controls_voice();
		
		const $voice_id = $("#" + this.prefix + "popup_voice_id");
		const $name = $("#" + this.prefix + "popup_name");
		const $languageCode = $("#" + this.prefix + "popup_LanguageCode");
		const $languageName = $("#" + this.prefix + "popup_LanguageName");
		const $voiceName = $("#" + this.prefix + "popup_VoiceName");
		const $gender = $("#" + this.prefix + "popup_Gender");
		const $age = $("#" + this.prefix + "popup_Age");
		const $variant = $("#" + this.prefix + "popup_Variant");
		const $prosodyVolume = $("#" + this.prefix + "popup_prosodyVolume");
		const $prosodyRate = $("#" + this.prefix + "popup_prosodyRate");
		
		if (this.m_is_new_voice) {
			//Este caso no se debe dar
			return;
		}
		// editando
		$title.text("<%=_T('Update Voice')%>");

		$voice_id.val(item.id);
		$name.val(item.name);
		$languageCode.val(item.LanguageCode);
		$languageName.val(item.LanguageName);
		$voiceName.val(item.VoiceName);
		$gender.val(item.Gender);
		$age.val(item.Age);
		$variant.val(item.Variant);
		$prosodyVolume.val(item.prosodyVolume);
		$prosodyRate.val(item.prosodyRate);
		
		this.owner.readonly_control($voice_id, true);
		this.owner.readonly_control($name, true);
		this.owner.readonly_control($languageCode, true);
		this.owner.readonly_control($languageName, true);
		this.owner.readonly_control($voiceName, true);
		this.owner.readonly_control($gender, true);
		this.owner.readonly_control($age, true);
		this.owner.readonly_control($variant, true);
	};

	AdminTtsVoicesMng.prototype.validate_voice_to_add_or_update = function(callback = $.noop)
	{
		const self = this;

		this.hide_all_errors();
		let response = {success: false, $ctrl: null, item: null, msg: "<%=_T('Unable to Add Voice.')%>"};

		let item = {};
		let is_new = false;
		if (this.m_current_voice) {
			item = this.m_current_voice;
		}
		else {
			is_new = true;
		}

		const $voice_id = $("#" + this.prefix + "popup_voice_id");
		let voice_id = $voice_id.val();

		const $name = $("#" + this.prefix + "popup_name");
		let name = $name.val();

		const $languageCode = $("#" + this.prefix + "popup_LanguageCode");
		let languageCode = $languageCode.val();

		const $languageName = $("#" + this.prefix + "popup_LanguageName");
		let languageName = $languageName.val();

		const $voiceName = $("#" + this.prefix + "popup_VoiceName");
		let voiceName = $voiceName.val();

		const $gender = $("#" + this.prefix + "popup_Gender");
		let gender = $gender.val();

		const $age = $("#" + this.prefix + "popup_Age");
		let age = $age.val();

		const $variant = $("#" + this.prefix + "popup_Variant");
		let variant = $variant.val();

		const $prosodyVolume = $("#" + this.prefix + "popup_prosodyVolume");
		let prosodyVolume = $prosodyVolume.val();

		const $prosodyRate = $("#" + this.prefix + "popup_prosodyRate");
		let prosodyRate = $prosodyRate.val();
		
		const row_profile = self.make_row_voice(item, voice_id, name, languageCode, languageName, voiceName, gender, age, variant, prosodyVolume, prosodyRate);
		
		response.success = true;
		response.msg = "";
		response.item = row_profile;

		callback(response);
	};

	AdminTtsVoicesMng.prototype.hide_all_errors = function()
	{
		this.m_grid_voices.hide_popup_msg();
	};

	AdminTtsVoicesMng.prototype.show_ctrl_err = function(err_info)
	{
		if (!err_info) {
			return;
		}
		const $control = err_info.$ctrl;
		if ($control) {
			const error_id = $control.attr("id") + "_validation";
			const $error_indicator = $("#" + error_id);
			if ($error_indicator) {
				$error_indicator.show();
			}
			$control.focus();
		}
		this.m_grid_voices.show_popup_msg(err_info.msg, "Error"); //, ERROR_TIMEOUT_MS);
	};

	AdminTtsVoicesMng.prototype.dispose = function()
	{
		//TODO: implementar, si es necesario
	};

	AdminTtsVoicesMng.prototype.make_row_voice = function(current_row_item, voice_id, name, languageCode, languageName, voiceName, gender, age, variant, prosodyVolume, prosodyRate)
	{
		let row_item = current_row_item || {};

		row_item.id                    = voice_id;
		row_item.name                  = name;
		row_item.LanguageCode          = languageCode;
		row_item.LanguageName          = languageName;
		row_item.VoiceName             = voiceName;
		row_item.Gender                = gender;
		row_item.Age                   = age;
		row_item.Variant               = variant;
		row_item.prosodyVolume         = prosodyVolume;
		row_item.prosodyRate           = prosodyRate;

		return row_item;
	};

	AdminTtsVoicesMng.prototype.set = function(entity)
	{
		const self = this;
		let voices_info = [];
		let defaultVoiceId;
		if (!entity || !(Array.isArray(entity.voices) && entity.voices.length)) {
			this.m_grid_voices.initialize($.noop, voices_info);
			return;
		}

		var add_voice = function(voice_id, name, languageCode, languageName, voiceName, gender, age, variant, prosodyVolume, prosodyRate, defaultVoice) {
			if(defaultVoice){
				defaultVoiceId = voice_id;
			}
			const row_voice = self.make_row_voice(null, voice_id, name, languageCode, languageName, voiceName, gender, age, variant, prosodyVolume, prosodyRate);
			voices_info.push(row_voice);
		};

		entity.voices.forEach(voice => add_voice(voice.id, voice.name, voice.LanguageCode, voice.LanguageName, voice.VoiceName, voice.Gender, voice.Age, voice.Variant, voice.prosodyVolume, voice.prosodyRate, voice.defaultVoice));
		
		this.m_grid_voices.initialize($.noop, voices_info);
		
		this.fill_combo($("#vccDefaultVoice"), true, voices_info, "id", "name");
		$("#vccDefaultVoice").val(defaultVoiceId);
	};

	AdminTtsVoicesMng.prototype.empty_controls = function()
	{
		this.m_grid_voices.remove_all_rows();
	};

	AdminTtsVoicesMng.prototype.set_events = function()
	{
		const self = this;
	
		this.m_grid_voices.set_events();
	};

	AdminTtsVoicesMng.prototype.popup_show_ctrl_err = function(message, $ctrl, $popup_msg)
	{
		if ($ctrl) {
			const error_id = $ctrl.attr("id") + "_validation";
			const $error_indicator = $("#" + error_id);
			if ($error_indicator) {
				$error_indicator.show();
			}
			$ctrl.focus();
		}
	};

	AdminTtsVoicesMng.prototype.__init_voices = function()
	{
		$("body").removeClass("popupDisplay").addClass("popupDisplay");
	};
	
	AdminTtsVoicesMng.prototype.get = function()
	{
		var self = this;
		var voices = this.m_grid_voices.get_items();
		voices.forEach(function (voice, index, voices) {
			voices[index].defaultVoice = voice.id === $("#vccDefaultVoice").val() ? 1 : 0;
		});
		return voices;
	};
	
	AdminTtsVoicesMng.prototype.fill_prosodyVolume = function()
	{
		const self = this;

		const $combo = $("#" + this.prefix + "popup_prosodyVolume");
		$combo.html("");
		let volumes = this.owner.sorted_volumes;

		$.each(volumes, function(_, volume) {
			self.owner.combo_add_value($combo, volume.id, volume.name, false /*selected*/);
		});
	};
	
	AdminTtsVoicesMng.prototype.fill_prosodyRate = function()
	{
		const self = this;

		const $combo = $("#" + this.prefix + "popup_prosodyRate");
		$combo.html("");
		let sorted_rates = this.owner.sorted_rates;

		$.each(sorted_rates, function(_, rate) {
			self.owner.combo_add_value($combo, rate.id, rate.name, false /*selected*/);
		});
	};

}());
