/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

// try improve namespacing a bit
if ( !this.inConcert.Administration ) {
	this.inConcert.Administration = {};
}

if ( !this.inConcert.Administration.Campaigns ) {
	this.inConcert.Administration.Campaigns = {};
}

(function () {

	"use strict";

	var MS     = inConcert.Utils.secondsToMilliseconds;
	var SEC    = inConcert.Utils.millisecondsToSeconds;
	var FORMAT = inConcert.Utils.format;
	var BOOL   = inConcert.Utils.to_boolean;
	var INC_TAB_ID = "incoming";
	var OUT_TAB_ID = "outgoing";
	var UNLIMITED_VALUE_AFTER_CONVERSATION_WORK = 999999999;

	var __MakeDnisId = function(dnis) { return dnis.TrunkId + "," + dnis.TrunkType + "," + dnis.DNIS; };

	//---------------------------------------------------------------------
	// frm call account edition
	function CallAllegroAccountPanel( params )
	{
		/* jshint validthis: true*/
		this.prefix_id = "adm_form_campaign_accounts_call_allegro_";
		var success = CallAllegroAccountPanel.uber.constructor.call( this, params );
		if ( !success ) {
			return;
		}
		this.tagline_new                  = "<%=_T('New call account.')%>";
		this.tagline_edit                 = "<%=_T('Edit call account {0}.')%>";
		this.tagline_readonly             = "<%=_T('Call account {0}.')%>";

		// container
		this.container_id                         = "#adm_form_campaign_accounts_call_allegro_panel";

		// tabs and panels
		this.tabs_panels                          = "#adm_form_campaign_accounts_call_allegro_tabs_panels";

		// common ctrls
		this.callback                             = "#adm_form_campaign_accounts_call_allegro_callback";
		this.callback_retain_abandoned            = "#adm_form_campaign_accounts_call_allegro_callback_retain_abandoned";
		this.wait_between_call                    = "#adm_form_campaign_accounts_call_allegro_wait_between_call";
		this.wait_between_call_time               = "#adm_form_campaign_accounts_call_allegro_wait_between_call_time";

		// after conversation
		this.uses_after_conversation_work         = "#adm_form_campaign_accounts_call_allegro_after_conversation_work";
		this.after_conversation_work_panel        = "#adm_form_campaign_accounts_call_allegro_after_conversation_work_data_panel";
		this.after_conversation_work_time         = "#adm_form_campaign_accounts_call_allegro_after_conversation_work_time";
		this.after_conversation_work_time_limit   = "#adm_form_campaign_accounts_call_allegro_after_conversation_work_time_limit";

		// screen recording
		this.screen_recording                     = "#adm_form_campaign_accounts_call_allegro_screen_recording";
		this.screen_recording_percentage          = "#adm_form_campaign_accounts_call_allegro_screen_recording_percentage";

		// mas integration
		this.marketing_integration_enabled        = "#adm_form_campaign_accounts_call_allegro_mas_enabled";

		// tabs incoming / outgoing
		this.inc_out_tabs                         = "#adm_form_campaign_accounts_call_allegro_inc_out_tabs";

		// incoming controls
		this.inc_enabled_config                   = "#adm_form_campaign_accounts_call_allegro_enabled_incoming";
		this.inc_panel_enabled                    = "#adm_form_campaign_accounts_call_allegro_enabled_panel_incoming";
		this.inc_dnis                             = "#adm_form_campaign_accounts_call_allegro_dnis_incoming";
		this.inc_active_process                   = "#adm_form_campaign_accounts_call_allegro_active_process_incoming";
		this.inc_active_process_id                = "#adm_form_campaign_accounts_call_allegro_active_process_id_incoming";
		this.inc_inactive_process                 = "#adm_form_campaign_accounts_call_allegro_inactive_process_incoming";
		this.inc_inactive_process_id              = "#adm_form_campaign_accounts_call_allegro_inactive_process_id_incoming";
		this.inc_auto_answer                      = "#adm_form_campaign_accounts_call_allegro_auto_answer_incoming";
		this.inc_auto_answer_time                 = "#adm_form_campaign_accounts_call_allegro_auto_answer_time_incoming";
		// incoming contact center
		this.inc_uses_contact_center              = "#adm_form_campaign_accounts_call_allegro_use_contact_center_incoming";
		this.inc_contact_center_panel             = "#adm_form_campaign_accounts_call_allegro_contact_center_panel_incoming";
		this.inc_distribution                     = "#adm_form_campaign_accounts_call_distribution_incoming";
		this.inc_voicemail_timeout                = "#adm_form_campaign_accounts_call_allegro_voicemail_timeout_incoming";
		this.inc_voicemail_timeout_retain         = "#adm_form_campaign_accounts_call_allegro_voicemail_timeout_retain_incoming";
		this.inc_voicemail_waiting                = "#adm_form_campaign_accounts_call_allegro_voicemail_waiting_incoming";
		this.inc_voicemail_waiting_time           = "#adm_form_campaign_accounts_call_allegro_voicemail_waiting_time_incoming";
		this.inc_announce_queue                   = "#adm_form_campaign_accounts_call_allegro_announce_queue_incoming";
		this.inc_announce_wait                    = "#adm_form_campaign_accounts_call_allegro_announce_wait_incoming";
		this.inc_allowed_redial                   = "#adm_form_campaign_accounts_call_allegro_redial_incoming";
		this.inc_hide_acd                         = "#adm_form_campaign_accounts_call_allegro_hide_acd_incoming";
		this.inc_acd_priority                     = "#adm_form_campaign_accounts_call_allegro_acd_prioirty_incoming";
		this.inc_contact_name_format              = "#adm_form_campaign_accounts_call_allegro_contact_name_format_incoming";
		// outgoing controls
		this.out_enabled_config                   = "#adm_form_campaign_accounts_call_allegro_enabled_outgoing";
		this.out_panel_enabled                    = "#adm_form_campaign_accounts_call_allegro_enabled_panel_outgoing";
		this.out_routing_group                    = "#adm_form_campaign_accounts_call_allegro_routing_group_outgoing";
		this.out_dialing_rule                     = "#adm_form_campaign_accounts_call_allegro_dialing_rule_outgoing";
		this.out_capacity_assigned                = "#adm_form_campaign_accounts_call_allegro_capacity_assigned_outgoing";
		this.out_prefix                           = "#adm_form_campaign_accounts_call_allegro_outbound_prefix_outgoing";
		this.out_active_process                   = "#adm_form_campaign_accounts_call_allegro_active_process_outgoing";
		this.out_active_process_id                = "#adm_form_campaign_accounts_call_allegro_active_process_id_outgoing";
		this.out_inactive_process                 = "#adm_form_campaign_accounts_call_allegro_inactive_process_outgoing";
		this.out_inactive_process_id              = "#adm_form_campaign_accounts_call_allegro_inactive_process_id_outgoing";
		this.out_telesales                        = "#adm_form_campaign_accounts_call_allegro_telesales_outgoing";
		this.out_telesales_msg                    = "#adm_form_campaign_accounts_call_allegro_telesales_message_outgoing";
		// outgoing contact center
		this.out_uses_contact_center              = "#adm_form_campaign_accounts_call_allegro_use_contact_center_outgoing";
		this.out_contact_center_panel             = "#adm_form_campaign_accounts_call_allegro_contact_center_panel_outgoing";
		this.out_distribution                     = "#adm_form_campaign_accounts_call_distribution_outgoing";
		this.out_manual_calls                     = "#adm_form_campaign_accounts_call_manual_calls_outgoing";
		this.out_manual_contact_name_format       = "#adm_form_campaign_accounts_call_allegro_manual_contact_name_format_outgoing";
		// outboundengine
		this.out_uses_outboundengine              = "#adm_form_campaign_accounts_call_allegro_outboundegine_outgoing";
		this.out_outboundengine_panel             = "#adm_form_campaign_accounts_call_allegro_outboundegine_panel_outgoing";
		this.out_outboundprocess                  = "#adm_form_campaign_accounts_call_allegro_outboundprocess_outgoing";
		this.out_outboundprocess_type             = "#adm_form_campaign_accounts_call_allegro_outboundprocess_type_outgoing";
		this.out_voiceblaster                     = "#adm_form_campaign_accounts_call_allegro_voiceblaster_outgoing";
		this.out_abandoned_rate                   = "#adm_form_campaign_accounts_call_allegro_abandoned_rate_outgoing";
		this.out_out_hours                        = "#adm_form_campaign_accounts_call_allegro_out_hours_outgoing";
		this.out_has_preview                      = "#adm_form_campaign_accounts_call_allegro_has_preview_outgoing";
		this.out_dialer_throttle                  = "#adm_form_campaign_accounts_call_allegro_dialer_throttle_outgoing";
		this.out_per_available_agent              = "#adm_form_campaign_accounts_call_allegro_per_available_agent_outgoing";
		this.out_hangup_threshold                 = "#adm_form_campaign_accounts_call_allegro_hangup_threshold_outgoing";
		this.out_hangup_am                        = "#adm_form_campaign_accounts_call_allegro_hangup_am_outgoing";
		this.out_autoattend_am                    = "#adm_form_campaign_accounts_call_allegro_autoattend_am_outgoing";
		this.out_autoattend_abandoned             = "#adm_form_campaign_accounts_call_allegro_autoattend_abandoned_outgoing";
		this.out_answer_process                   = "#adm_form_campaign_accounts_call_allegro_answering_process_outgoing";
		this.out_abandoned_process                = "#adm_form_campaign_accounts_call_allegro_abandoned_process_outgoing";
		this.out_guess_am_connected               = "#adm_form_campaign_accounts_call_allegro_guess_am_connected_time_outgoing";
		this.out_positive_am_below                = "#adm_form_campaign_accounts_call_positive_am_below_outgoing";
		this.out_positive_am_above                = "#adm_form_campaign_accounts_call_positive_am_above_outgoing";
		this.out_contact_name_format              = "#adm_form_campaign_accounts_call_allegro_contact_name_format_outgoing";
		// thresholds
		this.thresholds_info                      = "#adm_form_campaign_accounts_call_allegro_thresholds_info";

		this.messages_class = inConcert.adm_form_campaigns_call_allegro_account_messages;

		return true;
	}

	inConcert.Utils.inherit( CallAllegroAccountPanel, inConcert.adm_form_campaigns_section_accounts_base_panel );

	if ( typeof inConcert.Administration.Campaigns.CallAllegroAccountPanel !== "function" ) {
		inConcert.Administration.Campaigns.CallAllegroAccountPanel = CallAllegroAccountPanel;
	}

	CallAllegroAccountPanel.prototype.load = function( callback )
	{
		var self = this;
		callback = callback || $.noop;

		var full_campaign_id = this.get_campaign_id() || "";
		var pending_requests = 0; // variable que lleva en contador de request pendientes

		var on_complete_request = function() {
			pending_requests--;
			if ( pending_requests === 0 ) {
				callback();
			}
		};
		var allegro_api = inConcert.app.getAllegroAPI();

		// 0.1 - ejecuto para obtener las SUPERIVSOR RECORDING PERCENTAGE e incremento en 1 el contador de request
		var $screen_recording_percentage = $(this.screen_recording_percentage);
		pending_requests++;
		allegro_api.loadScreenRecordingPercentage( function( success, rows )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro Screen Recording Percentage list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// la lleno a la lista de SCREEN RECORDING PERCENTAGE
				self.parent.fill_combo(
					$screen_recording_percentage,
					true, // is_blank_first_item
					rows,
					"id", // id
					"description", // description
					false //sorted
				);
			}

			on_complete_request();
		});

		// 0.2 - ejecuto para obtener las AFTER CONVERSATION WORK TIME e incremento en 1 el contador de request
		var $after_conversation_work_time = $(this.after_conversation_work_time);
		pending_requests++;
		allegro_api.loadAfterConversationWorkTime( function( success, rows )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro After converstion work time list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// la lleno a la lista de AFTER CONVERSATION WORK TIME
				self.parent.fill_combo(
					$after_conversation_work_time,
					false, // is_blank_first_item
					rows,
					"id", // id
					"description", // description
					false //sorted
				);
			}

			on_complete_request();
		});

		// 1 - ejecuto para obtener los Algorithms distributon (entrantes y salientes) e incremento en 1 el contador de request
		var $inc_distribution = $(this.inc_distribution);
		var $out_distribution = $(this.out_distribution);
		pending_requests++;
		allegro_api.loadAlgorithms( function( success, rows )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro Algorithms list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {

				var __get_descr = function( _, row ) { return row.DisplayName || row.Name; };
				// 1.1 la lleno a la lista de Algorithms Entrantes
				self.parent.fill_combo(
					$inc_distribution,
					true, // is_blank_first_item
					rows,
					"Value", // id
					__get_descr, // description
					false //sorted
				);
				// 2.1 la lleno a la lista de Algorithms Salientes
				self.parent.fill_combo(
					$out_distribution,
					true, // is_blank_first_item
					rows,
					"Value", // id
					__get_descr, // description
					false //sorted
				);
			}

			on_complete_request();
		});

		// 2 - ejecuto para obtener las DNIS e incremento en 1 el contador de request
		var $dnis = $(this.inc_dnis);
		pending_requests++;
		allegro_api.loadDNISs( full_campaign_id, function( success, dnis_list )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro DNIS list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// la lleno a la lista de DNIS
				self.parent.fill_combo(
					$dnis,
					true, // is_blank_first_item
					dnis_list,
					function( _, dnis ) { return __MakeDnisId(dnis); }, // id
					function( _, dnis ) { return dnis.TrunkId + " - " + dnis.DNIS; }, // description
					false //sorted
				);
			}

			on_complete_request();
		});

		// 3 - ejecuto para obtener todos los procesos e incremento en 1 el contador de request
		var $inc_active_process_id = $(this.inc_active_process_id);
		var $inc_inactive_process_id = $(this.inc_inactive_process_id);
		var $out_active_process_id = $(this.out_active_process_id);
		var $out_inactive_process_id = $(this.out_inactive_process_id);
		var $out_answer_process = $(this.out_answer_process);
		var $out_abandoned_process = $(this.out_abandoned_process);

		pending_requests++;
		allegro_api.loadProcesses( function( success, processes_list )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro processes list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// typos devueltos en process.InitialProcessEvent : "DISPOUTBINT", "DISPOUTBIVR", "CHATREQCX", "NEWMAIL", el que venga!!
				var allowed_types = { DISPOUTBINT: "DISPOUTBINT", DISPOUTBIVR: "DISPOUTBIVR", CHATREQCX: "CHATREQCX", NEWMAIL: "NEWMAIL" };

				var __get_descr = function( _, process ) { return process.Description || process.Id; };
				// 3.1 llena a la lista de incoming active process
				self.parent.fill_combo(
					$inc_active_process_id,
					true, // is_blank_first_item
					processes_list,
					"Id", // id
					__get_descr, // description
					false, //sorted
					// si el row se puede agregar o no
					function( _, process ) {
						// si no es de ninguno de los tipos permitidos, tiene que agregarlo en active e inactive process
						if (!allowed_types[process.InitialProcessEvent]) {
							return true;
						}
						return false;
					}
				);
				// 3.2 llena a la lista de incomming inactive process
				self.parent.fill_combo(
					$inc_inactive_process_id,
					true, // is_blank_first_item
					processes_list,
					"Id", // id
					__get_descr, // description
					false, //sorted
					// si el row se puede agregar o no
					function( _, process ) {
						// si no es de ninguno de los tipos permitidos, tiene que agregarlo en active e inactive process
						if (!allowed_types[process.InitialProcessEvent]) {
							return true;
						}
						return false;
					}
				);
				//-----
				// 3.3 llena a la lista de outgoing active process
				self.parent.fill_combo(
					$out_active_process_id,
					true, // is_blank_first_item
					processes_list,
					"Id", // id
					__get_descr, // description
					false, //sorted
					// si el row se puede agregar o no
					function( _, process ) {
						// si no es de ninguno de los tipos permitidos, tiene que agregarlo en active e inactive process
						if (process.InitialProcessEvent === allowed_types.DISPOUTBINT) {
							return true;
						}
						return false;
					}
				);
				// 3.4 llena a la lista de outgoing inactive process
				self.parent.fill_combo(
					$out_inactive_process_id,
					true, // is_blank_first_item
					processes_list,
					"Id", // id
					__get_descr, // description
					false, //sorted
					// si el row se puede agregar o no
					function( _, process ) {
						// si no es de ninguno de los tipos permitidos, tiene que agregarlo en active e inactive process
						if (process.InitialProcessEvent === allowed_types.DISPOUTBINT) {
							return true;
						}
						return false;
					}
				);

				//-----
				// 3.5 llena a la lista de outgoing outboundprocess answering process
				self.parent.fill_combo(
					$out_answer_process,
					true, // is_blank_first_item
					processes_list,
					"Id", // id
					__get_descr, // description
					false, //sorted
					// si el row se puede agregar o no
					function( _, process ) {
						// si no es de ninguno de los tipos permitidos, tiene que agregarlo en active e inactive process
						if (process.InitialProcessEvent === allowed_types.DISPOUTBIVR) {
							return true;
						}
						return false;
					}
				);
				// 3.6 llena a la lista de outgoing outboundprocess abandoned process
				self.parent.fill_combo(
					$out_abandoned_process,
					true, // is_blank_first_item
					processes_list,
					"Id", // id
					__get_descr, // description
					false, //sorted
					// si el row se puede agregar o no
					function( _, process ) {
						// si no es de ninguno de los tipos permitidos, tiene que agregarlo en active e inactive process
						if (process.InitialProcessEvent === allowed_types.DISPOUTBIVR) {
							return true;
						}
						return false;
					}
				);

			}

			on_complete_request();
		});

		// 4 - ejecuto para obtener los Routingroup e incremento en 1 el contador de request
		var $routing_group = $(this.out_routing_group);
		pending_requests++;
		allegro_api.loadRoutingGroups( function( success, rows )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro Routing Group list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// la lleno a la lista de Routing Group
				self.parent.fill_combo(
					$routing_group,
					true, // is_blank_first_item
					rows,
					"Id", // id
					"Id", // description
					false //sorted
				);
			}

			on_complete_request();
		});

		// 5 - ejecuto para obtener los Outbound Processes e incremento en 1 el contador de request
		var $out_outboundprocess = $(this.out_outboundprocess);
		pending_requests++;
		allegro_api.loadOutboundProcesses( function( success, rows )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro Outbound Processes list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				if (!self.is_new()) {
				// Si estoy editando tengo en lista de outboundprocess que se retornan desde 5.5,
				//   tengo que agregar de forma manual el outbounprocess que utiliza esta cuenta/campana (si es que el mismo no se encuentra ya en la lista)
				//  Esto porque en 5.5 asi, funciona y no me voy a poner a cambiar eso en 5.5. He dicho!!
					var outgoing_config = self.current_account.outgoingConfig;
					if ( outgoing_config && outgoing_config.OutboundEngine) {
						var outbound_process_id = outgoing_config.OutboundEngine.OutboundProcessId;
						rows = rows || [];
						var exist_outboundprocess = false;
						$.each(rows, function(_, row) {
							if ( row.Id === outbound_process_id ) {
								exist_outboundprocess = true;
								return false; // break
							}
						});
						if (!exist_outboundprocess) {
							// lo agrego primero en la lista
							rows.unshift({Id: outbound_process_id});
						}
					}
				}
				// la lleno a la lista de Outbound Processes
				self.parent.fill_combo(
					$out_outboundprocess,
					true, // is_blank_first_item
					rows,
					"Id", // id
					"Id", // description
					false //sorted
				);
			}

			on_complete_request();
		});

		// 6 - ejecuto para obtener los Outbound Processes Types e incremento en 1 el contador de request
		var $out_outboundprocess_type = $(this.out_outboundprocess_type);
		pending_requests++;
		allegro_api.loadOutboundProcessesTypes( function( success, rows )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro Outbound Processes Types list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				var __get_descr = function(_, row) {
					// TODO: Este IF tiene que volar, y debe de quedar solo la linea del return que se encuentra fuera del IF
					//       De momento se reailzo, asi porque sino viene el valor "Automated" en lugar de "Voice Blaster".
					//       Para solucionar esto hay que: En 5.5 en la aplicacion "omnichannelintegration", agregar el lenguaje y traducciones (.po, .mo, registry, etc)
					//
					if ( (row.DisplayName || "" ).toUpperCase() === "AUTOMATED") {
						return "<%=_T('Voice Blaster')%>";
					}
					return row.DisplayName || row.Name;
				};
				// la lleno a la lista de Outbound Processes Types
				self.parent.fill_combo(
					$out_outboundprocess_type,
					true, // is_blank_first_item
					rows,
					"Value", // id
					__get_descr, // description
					false //sorted
				);
			}

			on_complete_request();
		});

		// 7 - ejecuto para obtener los Voice Blaster e incremento en 1 el contador de request
		var $out_voiceblaster = $(this.out_voiceblaster);
		pending_requests++;
		allegro_api.loadVoiceBlaster( function( success, rows )
		{
			if (!success) {
				var message = "<%=_T('Error retrieving allegro Voice Blaster list.')%>";
				self.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// la lleno a la lista de Voice Blaster
				self.parent.fill_combo(
					$out_voiceblaster,
					true, // is_blank_first_item
					rows,
					"VoiceBlasterId", // id
					function( _, row ) { return row.Description || row.VoiceBlasterId; }, // description
					false //sorted
				);
			}

			on_complete_request();
		});

	};

	CallAllegroAccountPanel.prototype.initialize = function()
	{
		CallAllegroAccountPanel.uber.initialize.call(this);
		this.__switch_conversation_tab( INC_TAB_ID );
	};

	CallAllegroAccountPanel.prototype.initialize_thresholds = function()
	{
		const self = this;
		// build thresholds panel
		CallAllegroAccountPanel.uber.initialize_thresholds.call(
			this,
			"CALL",
			{
				parent   : this.parent,
				prefix_id: "adm_form_campaign_accounts_call_allegro_thresholds",
				callbacks: {
					on_show_tab: function() {
						$(self.thresholds_info).hide();
					},
					on_hide_all_tabs: function() {
						$(self.thresholds_info).show();
					}
				}
			}
		);
	};

	CallAllegroAccountPanel.prototype.initialize_contact_mng = function()
	{
		// build contact management panel
		CallAllegroAccountPanel.uber.initialize_contact_mng.call(
			this,
			{
				type         : "CALL"                                                     ,
				parent       : this                                                       ,
				auto_add_type: "BOTH"                                                     , // incoming y outgoing
				container_id : "adm_form_campaign_accounts_call_allegro_contact_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_allegro_contact_mng"
			}
		);
	};

	CallAllegroAccountPanel.prototype.initialize_flows_mng = function()
	{
		// build flows designer management panel
		CallAllegroAccountPanel.uber.initialize_flows_mng.call(
			this,
			{
				type         : "CALL"                                                            ,
				parent       : this                                                              ,
				container_id : "adm_form_campaign_accounts_call_allegro_flows_designer_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_allegro_flows_designer_mng"
			}
		);
	};

	CallAllegroAccountPanel.prototype.initialize_ticket_emitter = function()
	{
		CallAllegroAccountPanel.uber.initialize_ticket_emitter.call(
			this,
			{
				type         : "CALL",
				parent       : this,
				container_id : "adm_form_campaign_accounts_call_allegro_tickets_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_allegro_tickets_mng"
			}
		);
	};

	CallAllegroAccountPanel.prototype.initialize_tabs = function()
	{
		// build tabs
		CallAllegroAccountPanel.uber.initialize_tabs.call(
			this,
			{
				parent       : this                              ,
				frm          : this.parent.frm                   ,
				container_id : "adm_form_campaign_accounts_tabs" ,
				tabs_list    : {
					basic : {
						id               : "basic",
						name             : "<%=_T('Call Config')%>",
						tab_container_id : "adm_form_campaign_accounts_call_allegro_panel_tab_basic",
						selected         : true
					},
					messages : {
						id               : "messages",
						name             : "<%=_T('Messages')%>",
						tab_container_id : "adm_form_campaign_accounts_call_allegro_panel_tab_messages"
					}
				}
			}
		);
	};

	CallAllegroAccountPanel.prototype.initialize_skills = function()
	{
		CallAllegroAccountPanel.uber.initialize_skills.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_call_allegro_skills_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION"
			}
		);
	};

	CallAllegroAccountPanel.prototype.initialize_attention_levels = function()
	{
		CallAllegroAccountPanel.uber.initialize_attention_levels.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_call_allegro_attention_levels_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION",
				proxy_type   : "CALL"
			}
		);
	};

	CallAllegroAccountPanel.prototype.is_enable_menu_option = function( callback )
	{
		// 1 - valida si ya existe alguna cuenta en la campana.
		var count_accounts = 0;
		var section = this.parent;
		var accounts = section.frm.campaign.accounts;
		var response = { enabled: true };

		$.each( accounts || {}, function( /*_, account*/ ) {
			count_accounts++;
			return false; // BREAK
		});
		if ( count_accounts > 0 ) {
			// si ya existe alguna se va retornado FALSE, para que NO muestre la opcion en el menu
			response.enabled = false;
			response.message = "<%=_T('Only one account in allegro campaign.')%>";
			callback( response );
			return;
		}

		callback( response );
	};

	CallAllegroAccountPanel.prototype.readonly = function()
	{
		CallAllegroAccountPanel.uber.readonly.call( this );
	};

	CallAllegroAccountPanel.prototype.empty_controls = function()
	{
		CallAllegroAccountPanel.uber.empty_controls.call( this );
		this.__clean_up_ctrls();
	};

	CallAllegroAccountPanel.prototype.__clean_up_ctrls = function()
	{
		// common info
		$(this.callback).prop("checked", true).trigger("change");
		this.parent.frm.related_empty_disabled( $(this.wait_between_call) );
		// after conversation
		$(this.uses_after_conversation_work).prop("checked", true).trigger("change");
		$(this.after_conversation_work_time).val("Unlimited").trigger("change");
		$(this.after_conversation_work_time_limit).val("");

		// incoming
		$(this.inc_enabled_config).prop("checked", false).trigger("change");
		$(this.inc_dnis).val("").trigger("change");
		this.parent.frm.related_empty_disabled( $(this.inc_active_process) );
		this.parent.frm.related_empty_disabled( $(this.inc_inactive_process) );
		this.parent.frm.related_empty_disabled( $(this.inc_auto_answer) );
		this.parent.frm.related_empty_disabled( $(this.inc_voicemail_timeout) );
		this.parent.frm.related_empty_disabled( $(this.inc_voicemail_waiting) );
		// incoming contact center
		$(this.inc_uses_contact_center).prop("checked", false).trigger("change");
		$(this.inc_distribution).val("").trigger("change");

		// outgoing
		$(this.out_enabled_config).prop("checked", false).trigger("change");
		$(this.out_routing_group).val("").trigger("change");
		$(this.out_dialing_rule).val("").trigger("change");
		$(this.out_capacity_assigned).val("");
		$(this.out_prefix).val("");
		$(this.out_active_process).prop("checked", false).trigger("change");
		this.parent.frm.related_empty_disabled( $(this.out_inactive_process) );
		$(this.out_telesales).prop("checked", true).trigger("change");
		// outgoing contact center
		$(this.out_uses_contact_center).prop("checked", false).trigger("change");
		$(this.out_distribution).val("").trigger("change");
		$(this.out_manual_calls).prop("checked", true);
		$(this.out_manual_contact_name_format).val("");
		// outboundprocess
		$(this.out_uses_outboundengine).prop("checked", false).trigger("change");
		$(this.out_outboundprocess_type).val("").trigger("change");
		$(this.out_guess_am_connected).prop("checked", false).trigger("change");
		$(this.out_hangup_threshold).prop("checked", false);
		this.parent.frm.related_empty_disabled( $(this.out_guess_am_connected) );
		$(this.out_contact_name_format).val("");
	};

	CallAllegroAccountPanel.prototype.edit = function( account )
	{
		CallAllegroAccountPanel.uber.edit.call( this, account );

		if ( !account ) {
			return;
		}

		var self = this;
		this.__clean_up_ctrls();

		var acc = this.current_account;

		// callback is allowed
		if ( acc.CallbackIsAllowed && acc.CallbackIsAllowed.to_boolean() ) {
			$(this.callback).prop("checked", true).trigger("change");
			$(this.callback_retain_abandoned).val(acc.LifeTimeAbandonedCalls);
		}
		else {
			$(this.callback).prop("checked", false).trigger("change");
			$(this.callback_retain_abandoned).val("");
		}

		// wait between calls
		var wait_between_calls = parseInt(acc.waitBetweenCalls, 10);
		if ( wait_between_calls > 0 ) {
			$(this.wait_between_call).prop("checked", true).trigger("change");
			$(this.wait_between_call_time).val(SEC(wait_between_calls));
		}
		else {
			$(this.wait_between_call).prop("checked", false).trigger("change");
		}

		// screen recording
		var screen_recording_percentage = parseInt(acc.ScreenRecording, 10);
		if ( screen_recording_percentage > 0 ) {
			$(this.screen_recording).prop("checked", true).trigger("change");
			$(this.screen_recording_percentage).val(screen_recording_percentage.toString());
		}
		else {
			$(this.screen_recording).prop("checked", false).trigger("change");
		}

		// marketing & sales
		const marketing_integration_enabled = (parseInt(acc.MarketingIntegrationEnabled, 10) > 0);
		$(this.marketing_integration_enabled).prop("checked", marketing_integration_enabled).trigger("change");

		// after conversation work
		var after_conversation_work = parseFloat(acc.AfterInteractionWork, 10);
		if ( after_conversation_work > 0 ) {

			var limit_type;
			if ( after_conversation_work === UNLIMITED_VALUE_AFTER_CONVERSATION_WORK ) {
				limit_type = "Unlimited";
				after_conversation_work = "";
			}
			else {
				limit_type = "TimeLimited";
				after_conversation_work = SEC(after_conversation_work);
			}

			$(this.uses_after_conversation_work).prop("checked", true).trigger("change");
			$(this.after_conversation_work_time).val(limit_type).trigger("change");
			$(this.after_conversation_work_time_limit).val(after_conversation_work);
		}
		else {
			$(this.uses_after_conversation_work).prop("checked", false).trigger("change");
		}

		var selected_convseration_tab;

	// configuracion INCOMING ---------------------------------------
		var incoming_config = acc.incomingConfig;
		if ( incoming_config && incoming_config.enabled ) {
			// selecciono el tab entrante
			this.__switch_conversation_tab( INC_TAB_ID );
			selected_convseration_tab = INC_TAB_ID;

			// activo el tab de configuracion
			$(this.inc_enabled_config).prop("checked", true).trigger("change");
			//dnis
			$(this.inc_dnis).val(__MakeDnisId(incoming_config));
			// custom active process
			if ( incoming_config.SelfServiceProcess !== undefined ) {
				$(this.inc_active_process).prop("checked", true).trigger("change");
				$(this.inc_active_process_id).val(incoming_config.SelfServiceProcess);
			}
			// custom inactive process
			if ( incoming_config.OutOfTimeProcess !== undefined ) {
				$(this.inc_inactive_process).prop("checked", true).trigger("change");
				$(this.inc_inactive_process_id).val(incoming_config.OutOfTimeProcess);
			}
			// auto answer
			if ( incoming_config.AutoAnswerTime !== undefined ) {
				$(this.inc_auto_answer).prop("checked", true).trigger("change");
				$(this.inc_auto_answer_time).val(SEC(incoming_config.AutoAnswerTime));
			}

			// si usa contact center
			var incoming_cc = incoming_config.ContactCenter;
			if ( incoming_cc ) {
				$(this.inc_uses_contact_center).prop("checked", true).trigger("change");
				// distribution
				$(this.inc_distribution).val(incoming_cc.CCAlgorithm).trigger("change");

				if ( incoming_cc.VoicemailOnWait ) {
				// voicemail option on wait / retain voicemail / voicemail repeat time
					$(this.inc_voicemail_waiting).prop("checked", true).trigger("change");
					$(this.inc_voicemail_timeout_retain).val(incoming_cc.LifeTimeVoicemail);
					$(this.inc_voicemail_waiting_time).val(SEC(incoming_cc.VoicemailOnWaitRepeatTime));
				}
				if ( incoming_cc.VoicemailOnTimeout ) {
				// voicemail on timeout / retain voicemail
					$(this.inc_voicemail_timeout).prop("checked", true).trigger("change");
					$(this.inc_voicemail_timeout_retain).val(incoming_cc.LifeTimeVoicemail);
				}
				// announce place in queue
				$(this.inc_announce_queue).prop("checked", BOOL(incoming_cc.AnnouncePlaceInQueue)).trigger("change");
				// annouce wait time
				$(this.inc_announce_wait).prop("checked", BOOL(incoming_cc.AnnounceEstimatedWaitTime)).trigger("change");
				// allowed redial
				$(this.inc_allowed_redial).prop("checked", BOOL(incoming_cc.CheckRedial)).trigger("change");
				// hide acd
				$(this.inc_hide_acd).prop("checked", BOOL(incoming_cc.HideACD)).trigger("change");
				// acd priority
				$(this.inc_acd_priority).val(incoming_cc.ACDPriority);
				// contact name format
				$(this.inc_contact_name_format).val(incoming_cc.ContactNameFormat);
			}
		}

	// configuracion OUTGOING ---------------------------------------
		var outgoing_config = acc.outgoingConfig;
		if ( outgoing_config && outgoing_config.enabled ) {
			// si no tiene configuracion entrante, debe de quedar seleccionado el tab saliente
			if (!selected_convseration_tab) {
				this.__switch_conversation_tab( OUT_TAB_ID );
			}
			// activo el tab de configuracion
			$(this.out_enabled_config).prop("checked", true).trigger("change");
			// routing group
			$(this.out_routing_group).val(outgoing_config.RoutingGroup).trigger("change");
			// dialing rule
			$(this.out_dialing_rule).val(outgoing_config.DialingRule).trigger("change");
			// capacity assigned
			$(this.out_capacity_assigned).val(outgoing_config.CapacityAssigned);
			// outboundprefix
			$(this.out_prefix).val(outgoing_config.OutboundPrefix);
			// custom active process
			if ( outgoing_config.SelfServiceProcess !== undefined ) {
				$(this.out_active_process).prop("checked", true).trigger("change");
				$(this.out_active_process_id).val(outgoing_config.SelfServiceProcess);
			}
			// custom inactive process
			if ( outgoing_config.OutOfTimeProcess !== undefined ) {
				$(this.out_inactive_process).prop("checked", true).trigger("change");
				$(this.out_inactive_process_id).val(outgoing_config.OutOfTimeProcess);
			}
			// telesales
			$(this.out_telesales).prop("checked", BOOL(outgoing_config.IsTelesales)).trigger("change");

			// si usa contact center
			var outgoing_cc = outgoing_config.ContactCenter;
			if ( outgoing_cc ) {
				$(this.out_uses_contact_center).prop("checked", true).trigger("change");
				// distribution
				$(this.out_distribution).val(outgoing_cc.CCAlgorithm).trigger("change");
				// manual calls are allowed
				$(this.out_manual_calls).prop("checked", BOOL(outgoing_cc.AllowManualCalls)).trigger("change");
				// manual contact name format
				$(this.out_manual_contact_name_format).val(outgoing_cc.ManualContactNameFormat);
			}

			// si usa outbound engine
			var outgoing_obe = outgoing_config.OutboundEngine;
			if ( outgoing_obe ) {
				$(this.out_uses_outboundengine).prop("checked", true).trigger("change");
				// outbound process
				$(this.out_outboundprocess).val(outgoing_obe.OutboundProcessId).trigger("change");
				// outbound process type
				$(this.out_outboundprocess_type).val(outgoing_obe.OutboundProcessType).trigger("change");

				// "Dialer Throttle" seteo los valores del chk y los textboxes relacionados
				var __set_dialer_throttle = function()
				{
					var has_dialer_throttle = outgoing_obe.CorrectionManualRate && outgoing_obe.CorrectionManualRate >= 0;
					$(self.out_dialer_throttle).prop("checked", has_dialer_throttle).trigger("change");
					if (has_dialer_throttle) {
						$(self.out_per_available_agent).val(outgoing_obe.CorrectionManualRate);
						$(self.out_abandoned_rate).val("");
					} else {
						$(self.out_per_available_agent).val("");
						$(self.out_abandoned_rate).val(parseInt((outgoing_obe.DesiredAbandonRate || 0) * 100, 10));
					}
				};

				// "Has preview"
				var __set_has_preview = function() { $(self.out_has_preview).prop("checked", BOOL(outgoing_obe.HasPreview)); };

				// "Auto attendand" seteo los valores del chk y los ctrls relacionados
				var __set_auto_attendand = function()
				{
					// AM
					var has_configured_am = outgoing_obe.AnsweringMachineProcess !== undefined;
					$(self.out_autoattend_am).prop("checked", has_configured_am).trigger("change");
					if (has_configured_am) {
						$(self.out_answer_process).val(outgoing_obe.AnsweringMachineProcess);
					}
					// Abandoned
					var has_configured_abandoned = outgoing_obe.AbandonedPredictiveProcess !== undefined;
					$(self.out_autoattend_abandoned).prop("checked", has_configured_abandoned).trigger("change");
					if (has_configured_abandoned) {
						$(self.out_abandoned_process).val(outgoing_obe.AbandonedPredictiveProcess);
					}
				};

				// los campos segun el outbound process type
				switch(outgoing_obe.OutboundProcessType)
				{
					case "AUTOMATIC":    // voice blaster / automated
						$(this.out_voiceblaster).val(outgoing_obe.VoiceBlasterID);
						// // call out of hours // TODO: revisar esto!!!
						// if ( outgoing_obe.OutOfTimeProcess ) {
							// $(this.out_out_hours).prop("checked", true);
						// }
						__set_dialer_throttle();
						__set_auto_attendand();
						break;

					case "PREDICTIVE":   // predicitive dialer
						__set_has_preview();
						__set_dialer_throttle();
						__set_auto_attendand();
						break;

					case "PROGRESSIVE":  // progressive dialer
						__set_has_preview();
						$(this.out_hangup_am).prop("checked", BOOL(outgoing_obe.HangupOnAM));
						break;

					default:
						throw("Unrecogniezed - outgoing_obe.OutboundProcessType: " + outgoing_obe.OutboundProcessType);
				}

				// hang up call on threshold
				$(this.out_hangup_threshold).prop("checked", BOOL(outgoing_obe.StrictThreshold));

				// guess am by connect time
				if (outgoing_obe.MinTimeForAgent || outgoing_obe.MaxTimeForAgent) {
					$(this.out_guess_am_connected).prop("checked", true).trigger("change");
					// above
					$(this.out_positive_am_below).val(outgoing_obe.MinTimeForAgent);
					// below
					$(this.out_positive_am_above).val(outgoing_obe.MaxTimeForAgent);
				}
				// contact name format
				$(this.out_contact_name_format).val(outgoing_obe.ContactNameFormat);
			}
		}
	};

	CallAllegroAccountPanel.prototype.can_configure_thresholds = function( internal_tab )
	{
		if ( this.is_new() ) {
		// si no es nuevo, NO puedo configurar
			return true;
		}

		var call_account = this.parent.get_accounts()[0];
		if ( internal_tab === INC_TAB_ID ) {
			if ( call_account.incomingConfig.enabled ) {
				return false;
			}
		}
		else if ( internal_tab === OUT_TAB_ID ) {
			if ( call_account.outgoingConfig.enabled ) {
				return false;
			}
		}

		// SI puede configurar
		return true;
	};

	CallAllegroAccountPanel.prototype.__switch_conversation_tab = function( tab_id, on_selected )
	{
		on_selected = on_selected || $.noop;

		if ( !tab_id ) { on_selected(false); return; }

		tab_id = ( tab_id || "" ).toLowerCase();

		$( this.inc_out_tabs ).find( "li[tab_type]" ).removeClass( "tabsMenuItemSelect" );
		$( this.tabs_panels ).find( "div[panel]" ).hide();

		$( this.inc_out_tabs ).find( "li[tab_type='" + tab_id + "']" ).addClass( "tabsMenuItemSelect" );
		$( this.tabs_panels ).find( "div[panel='" + tab_id + "']" ).show();

		on_selected(true);
	};

	CallAllegroAccountPanel.prototype.__enable_disable_incoming_config = function( is_enabled )
	{
		var $inc_panel_enabled = $(this.inc_panel_enabled);
		if (is_enabled) {
			$inc_panel_enabled.show();
			if (this.thresholds_instance) {
				this.thresholds_instance.show_internal_tab( INC_TAB_ID );
				this.disable_thresholds( false, INC_TAB_ID );
			}
		}
		else {
			$inc_panel_enabled.hide();
			if (this.thresholds_instance) {
				if (this.is_new()) {
					this.thresholds_instance.hide_internal_tab( INC_TAB_ID );
				}
				this.disable_thresholds( true, INC_TAB_ID );
			}
		}
		this.show_or_hide_skills_section();
	};

	CallAllegroAccountPanel.prototype.__enable_disable_outgoing_config = function( is_enabled )
	{
		var $out_panel_enabled = $(this.out_panel_enabled);
		if (is_enabled) {
			$out_panel_enabled.show();
			if (this.thresholds_instance) {
				this.thresholds_instance.show_internal_tab( OUT_TAB_ID );
				this.disable_thresholds( false, OUT_TAB_ID );
			}
		}
		else {
			$out_panel_enabled.hide();
			if (this.thresholds_instance) {
				if (this.is_new()) {
					this.thresholds_instance.hide_internal_tab( OUT_TAB_ID );
				}
				this.disable_thresholds( true, OUT_TAB_ID );
			}
		}
		this.show_or_hide_skills_section();
	};

	CallAllegroAccountPanel.prototype.__enable_disable_incoming_contact_center = function( is_enabled )
	{
		var $inc_contact_center_panel = $(this.inc_contact_center_panel);
		var $inc_active_process = $(this.inc_active_process);
		var $inc_inactive_process = $(this.inc_inactive_process);
		var is_required;

		if (is_enabled) {
			$inc_contact_center_panel.show();
			// Si utilizamos contact center los procesos active e inactive NO son requeridos.
			is_required = false;
		}
		else {
			$inc_contact_center_panel.hide();
			// Si utilizamos contact center los procesos active e inactive SI son requeridos.
			is_required = true;
		}
		this.parent.frm.required_label( $inc_active_process, is_required );
		this.parent.frm.required_label( $inc_inactive_process, is_required );

		this.show_or_hide_skills_section();
	};

	CallAllegroAccountPanel.prototype.__enable_disable_outgoing_contact_center = function( is_enabled )
	{
		var $out_contact_center_panel = $(this.out_contact_center_panel);
		var $out_active_process = $(this.out_active_process);
		var $out_inactive_process = $(this.out_inactive_process);
		var is_required;

		if (is_enabled) {
			$out_contact_center_panel.show();
			// Si utilizamos contact center los procesos active e inactive NO son requeridos.
			is_required = false;
		}
		else {
			$out_contact_center_panel.hide();
			// Si utilizamos contact center los procesos active e inactive SI son requeridos.
			is_required = true;
		}
		this.parent.frm.required_label( $out_active_process, is_required );
		this.parent.frm.required_label( $out_inactive_process, is_required );

		this.show_or_hide_skills_section();
	};

	CallAllegroAccountPanel.prototype.set_events = function()
	{
		var self = this;

		$(this.inc_out_tabs).find( "[tab_type]" )
			.off( "click" )
			.on({
				click: function() {
					var selected_tab = $( this ).attr( "tab_type" );
					self.__switch_conversation_tab( selected_tab );
				}
			});

	// 1 common ---------------
		$(this.uses_after_conversation_work)
			.off("change")
			.on("change", function() {
				var is_enabled = $(this).prop("checked");
				$(self.after_conversation_work_panel)[ is_enabled ? "show" : "hide" ]();
			});

		var $after_work_time_limit = $(this.after_conversation_work_time_limit);
		$(this.after_conversation_work_time)
			.off("change")
			.on("change", function() {
				var is_disabled = $(this).val() !== "TimeLimited";
				var is_requerid = true;
				self.parent.disable_control( $after_work_time_limit, is_disabled, is_requerid );
				if (!is_disabled) {
					$after_work_time_limit.focus();
				}
			});

	// 2 incoming ---------------
		$(this.inc_enabled_config)
			.off("change")
			.on("change", function() {
				var is_enabled = $(this).prop("checked");
				self.__enable_disable_incoming_config( is_enabled );
			});

		$(this.inc_distribution)
			.off("change")
			.on("change", function() {
				self.show_or_hide_skills_section();
			});
		// contact center
		$(this.inc_uses_contact_center)
			.off("change")
			.on("change", function() {
				var is_enabled = $(this).prop("checked");
				self.__enable_disable_incoming_contact_center(is_enabled);
			});

		// Eventos "change" personalizados de los chk "voicemail on timeout" y "voicemail option on waiting"
		//  Estos eventos se deben de agregar tambien aca, ademas de las relaciones de todos los controles de related de "conf_form"
		//  ya que en si, tiene relacionados a parte de los mismos controles, entonces no puede funcionar los ds-enabled por si solos, si ambos controles
		//  owners se encuentran checked.
		//
		var $inc_voicemail_timeout = $(this.inc_voicemail_timeout);
		var $inc_voicemail_waiting = $(this.inc_voicemail_waiting);
		var $inc_voicemail_timeout_retain = $(this.inc_voicemail_timeout_retain);

		// Activo el control relacionado en comun de los controles owners.
		var __enabled_timeout_retain = function( is_enabled_other_owner ) {
			if (is_enabled_other_owner) {
				self.parent.frm.disable_control($inc_voicemail_timeout_retain, false, true);
				var previous_value = $inc_voicemail_timeout_retain.attr("previous_value");
				$inc_voicemail_timeout_retain.val(previous_value);
			}
		};
		// "voicemail on timeout" evento personalizado "change"
		$inc_voicemail_timeout
			.off("change.custom")
			.on("change.custom", function() {
				var is_enabled = $(this).prop("checked");
				if (!is_enabled) {
					var is_enabled_voicemail_waiting = $inc_voicemail_waiting.prop("checked");
					__enabled_timeout_retain( is_enabled_voicemail_waiting );
				}
			});
		// "voicemail option on waiting" evento personalizado "change"
		$inc_voicemail_waiting
			.off("change.custom")
			.on("change.custom", function() {
				var is_enabled = $(this).prop("checked");
				if (!is_enabled) {
					var is_enabled_voicemail_timeout = $inc_voicemail_timeout.prop("checked");
					__enabled_timeout_retain( is_enabled_voicemail_timeout );
				}
			});
		// ------------------------------

	// 3 outging ---------------
		$(this.out_enabled_config)
			.off("change")
			.on("change", function() {
				var is_enabled = $(this).prop("checked");
				self.__enable_disable_outgoing_config( is_enabled );
			});

		$(this.out_distribution)
			.off("change")
			.on("change", function() {
				self.show_or_hide_skills_section();
			});

		var $out_capacity_assigned = $(this.out_capacity_assigned);
		var $out_dialing_rule = $(this.out_dialing_rule);
		var $out_routing_group = $(this.out_routing_group);
		$out_routing_group
			.off("change")
			.on("change", function() {
				var current_routing_group = self.parent.frm.combo_get_selected_item_data( $out_routing_group );
				var list = [];
				var capacity = 0;
				if ( current_routing_group ) {
					list = inConcert.Utils.cloneArray(current_routing_group.OutgoingDialingRules) || [];
					// lo agrego primero en la lista
					list.unshift({Id: "NOSET", Description: "<%=_T('NO SET')%>"});
					capacity = parseInt(current_routing_group.DisplayCapacity || 0, 10);
				}
				// la lleno a la lista de DIALING RULES
				self.parent.fill_combo(
					$out_dialing_rule,
					true, // is_blank_first_item
					list,
					"Id", // id
					"Description", // description
					false //sorted
				);
				// asigno el valor maximo permitido al txt
				$out_capacity_assigned.val(capacity);
			});

		// El evento del outobund active process id (el chk y el cbo), no se realiza con la clase Base "conf_form" con los metodos
		//  relacionados ya que en este evento "change" se necesitan realizar mas acciones ademas de acivar o desactivar el combo.
		var $out_active_process_id = $(this.out_active_process_id);
		$(this.out_active_process)
			.off("change")
			.on("change", function() {
				self.__OnChangedOutobundprocessType(false);
				if ($(this).prop("checked")) {
					self.parent.frm.disable_control($out_active_process_id, false, true);
					window.setTimeout(function() {
						$out_active_process_id.focus();
					});
				}
				else {
					self.parent.frm.disable_control($out_active_process_id, true);
				}
			});

		$(this.out_telesales)
			.off("change")
			.on("change", function() {
				var is_hidden = $(this).prop("checked");
				$(self.out_telesales_msg)[ is_hidden ? "hide" : "show" ]();
			});

		// contact center
		$(this.out_uses_contact_center)
			.off("change")
			.on("change", function() {
				var is_enabled = $(this).prop("checked");
				self.__enable_disable_outgoing_contact_center(is_enabled);
			});

		// outboundengine
		$(this.out_uses_outboundengine)
			.off("change")
			.on("change", function() {
				var is_enabled = $(this).prop("checked");
				$(self.out_outboundengine_panel)[ is_enabled ? "show" : "hide" ]();
			});

		$(this.out_outboundprocess_type)
			.off("change")
			.on("change", function() {
				self.__OnChangedOutobundprocessType(true);
			});
	};

	CallAllegroAccountPanel.prototype.__OnChangedOutobundprocessType = function(must_execute_trigger)
	{
		var self = this;

		var $out_voiceblaster         = $(this.out_voiceblaster);
		var $out_out_hours            = $(this.out_out_hours);
		var $out_has_preview          = $(this.out_has_preview);
		var $out_dialer_throttle      = $(this.out_dialer_throttle);
		var $out_hangup_threshold     = $(this.out_hangup_threshold);
		var $out_hangup_am            = $(this.out_hangup_am);
		var $out_autoattend_am        = $(this.out_autoattend_am);
		var $out_autoattend_abandoned = $(this.out_autoattend_abandoned);

		var ds = function( $ctrl, disabled, readonly ) { self.parent.frm.disable_control($ctrl, disabled, readonly); };

		var outboundprocess_type = $(this.out_outboundprocess_type).val();
		switch(outboundprocess_type)
		{
			case "AUTOMATIC":    // voice blaster / automated
				// El combo de Voiceblaster queda enabled/disabled dependiendo de si se ha marcado o no el checkbox de "Custom Active Process"
				var $out_active_process = $(this.out_active_process);
				var used_out_active_process = $out_active_process.prop("checked");
				var disabled_out_voiceblaster = used_out_active_process;
				ds($out_voiceblaster        , disabled_out_voiceblaster, true );
				//-------------
				ds($out_out_hours           , false, false);
				ds($out_has_preview         , true , false);
				ds($out_dialer_throttle     , false, true );
				if (must_execute_trigger) {
					$out_dialer_throttle.trigger("change");
				}
				ds($out_hangup_threshold    , false, false);
				ds($out_hangup_am           , true , false);
				ds($out_autoattend_am       , false, false);
				ds($out_autoattend_abandoned, true , false);
				this.parent.frm.related_empty_disabled($out_autoattend_abandoned);
				break;

			case "PREDICTIVE":   // predicitive dialer
				ds($out_voiceblaster        , true , true );
				ds($out_out_hours           , true , false);
				ds($out_has_preview         , false, false);
				ds($out_dialer_throttle     , false, true );
				if (must_execute_trigger) {
					$out_dialer_throttle.trigger("change");
				}
				ds($out_hangup_threshold    , false, false);
				ds($out_hangup_am           , true,  false);
				ds($out_autoattend_am       , false, false);
				ds($out_autoattend_abandoned, false, false);
				break;

			case "PROGRESSIVE":  // progressive dialer
				ds($out_voiceblaster        , true , true );
				ds($out_out_hours           , true , false);
				ds($out_has_preview         , false, false);
				ds($out_dialer_throttle     , true , false);
				this.parent.frm.related_empty_disabled($out_dialer_throttle);
				ds($out_hangup_threshold    , false, false);
				ds($out_hangup_am           , false, false);
				ds($out_autoattend_am       , true , true );
				this.parent.frm.related_empty_disabled($out_autoattend_am);
				ds($out_autoattend_abandoned, true , true );
				this.parent.frm.related_empty_disabled($out_autoattend_abandoned);

				break;

			default:            // blank option
				ds($out_voiceblaster        , true , true );
				ds($out_out_hours           , true , true );
				ds($out_has_preview         , true , false);
				ds($out_dialer_throttle     , true , true );
				this.parent.frm.related_empty_disabled($out_dialer_throttle);
				ds($out_hangup_threshold    , true , false);
				ds($out_hangup_am           , true , false);
				ds($out_autoattend_am       , true , true );
				this.parent.frm.related_empty_disabled($out_autoattend_am);
				ds($out_autoattend_abandoned, true , true );
				this.parent.frm.related_empty_disabled($out_autoattend_abandoned);
		}
	};

	CallAllegroAccountPanel.prototype.on_show = function()
	{
		CallAllegroAccountPanel.uber.on_show.call( this );
		$( this.callback ).focus();
	};

	CallAllegroAccountPanel.prototype.__is_enabled_skill_configuration = function()
	{
	// 1 - Valida si se encuentra enabled la configuracion "incoming"
		var is_enabled_incoming_config = $(this.inc_enabled_config).prop("checked");
		if ( is_enabled_incoming_config ) {
		// 1.2 - Valida si esta utilizando configuracion de contact center dentro de la configuracion "incoming"
			var uses_inc_contact_center = $(this.inc_uses_contact_center).prop("checked");
			if ( uses_inc_contact_center ) {
			// 1.3 - Valida si la distribucion es de tipo "skill" en la configuracion "incoming"
				var inc_distribution = $(this.inc_distribution).val();
				if ( inc_distribution === "SKILL" ) {
				// 1.4 La configuracion de "skills" se encuentra enabled
					return true;
				}
			}
		}
	// 2 - Valida si se encuentra enabled la configuracion "outgoing"
		var is_enabled_outgoing_config = $(this.out_enabled_config).prop("checked");
		if ( is_enabled_outgoing_config ) {
		// 2.2 - Valida si esta utilizando configuracion de contact center dentro de la configuracion "outgoing"
			var uses_out_contact_center = $(this.out_uses_contact_center).prop("checked");
			if ( uses_out_contact_center ) {
			// 2.3 - Valida si la distribucion es de tipo "skill" en la configuracion "outgoing"
				var out_distribution = $(this.out_distribution).val();
				if ( out_distribution === "SKILL" ) {
				// 2.4 La configuracion de "skills" se encuentra enabled
					return true;
				}
			}
		}

	// 3 - Si no se dio ninguna de las opciones anteriores la configuracion de "skills" se encuentra disabled
		return false;
	};

	CallAllegroAccountPanel.prototype.show_or_hide_skills_section = function()
	{
		if ( this.__is_enabled_skill_configuration() ) {
			this.skills_handle.show_container();
			return;
		}
		this.skills_handle.hide_container();
	};

	CallAllegroAccountPanel.prototype.is_used_voice_blaster = function()
	{
		// Marca que indica si esta utilizando config de outboundengine
		var out_use_outboundengine = $(this.out_uses_outboundengine).prop("checked");
		if (!out_use_outboundengine) {
			return false;
		}
		// El tipo de outbound process
		var $out_outboundprocess_type = $(this.out_outboundprocess_type);
		var selected_outboundprocess_type = $out_outboundprocess_type.val();
		if (selected_outboundprocess_type !== "AUTOMATIC") {
			return false;
		}
		// El voiceblaster seleccionado
		var $out_voiceblaster = $(this.out_voiceblaster);
		var selected_voice_blaster_id = $out_voiceblaster.val();
		var is_used_voice_blaster = selected_voice_blaster_id.trim().length > 0;

		return is_used_voice_blaster;
	};

	CallAllegroAccountPanel.prototype.validate = function()
	{
		var self = this;

		var is_new = this.is_new();
		var account_info = {
			success       : false,
			account       : null,
			is_new        : is_new,
			error_message : null
		};

		// los 2 parametros son opcionales
		var error_in_basic_tab = function( conversation_tab_type, $field )
		{
			self.tabs.switch_tab( "basic" );
			self.__switch_conversation_tab( conversation_tab_type );
			if ( $field ) {
				window.setTimeout(function() {
					$field.focus();
				});
			}
			return account_info;
		};

		this.hide_marked_errors(); // oculto todos los errors de los campos

		var msg_err, range;

		// -------------------------------------------------------
	// 1 - Validacion de "COMMON CONTROLS"
	//
		var is_enabled_incoming_config = $( this.inc_enabled_config ).prop("checked");
		var is_enabled_outgoing_config = $( this.out_enabled_config ).prop("checked");

		const $retain_abandoned = $( this.callback_retain_abandoned );

		// CALLBACK IS ALLOWED - validation
		var $callback = $( this.callback );
		if ($callback.prop("checked")) {
			msg_err = "<%=_T('Outgoing call conversations need to be configured to check Callback is Allowed.')%>";
			if (!is_enabled_outgoing_config) {
				this.show_validation_error( $callback, msg_err, false );
				return error_in_basic_tab();
			}

			// RETAIN ABANDONED - validation
			msg_err = "<%=_T('Retain abandoned is required.')%>";
			if ( !this.validate_field( $retain_abandoned, "required", msg_err ) ) {
				return error_in_basic_tab();
			}
			range = { between: { from: 0, to: 15 } };
			msg_err = FORMAT("<%=_T('Retain abandoned value out of range. Please enter retain abandoned value between {0} and {1}.')%>", range.between.from, range.between.to);
			if ( !this.validate_field($retain_abandoned, "range", msg_err, range)) {
				return error_in_basic_tab();
			}
		}

		// WAIT BETWEEN CALLS TIME - validation
		var $wait_between_call_time = $( this.wait_between_call_time );
		msg_err = "<%=_T('Wait between calls time is required.')%>";
		if ( !this.validate_field( $wait_between_call_time, "required", msg_err ) ) {
			return error_in_basic_tab();
		}
		range = { between: { from: 0, to: 30 } };
		msg_err = FORMAT("<%=_T('Wait between calls time value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
		if ( !this.validate_field($wait_between_call_time, "range", msg_err, range)) {
			return error_in_basic_tab();
		}

		// SCREEN RECORDING PERCENTAGE - validation
		if ($(this.screen_recording).prop("checked")) {
			var $screen_recording_percentage = $( this.screen_recording_percentage );
			msg_err = "<%=_T('Screen recording percentage is required.')%>";
			if ( !this.validate_field( $screen_recording_percentage, "required", msg_err ) ) {
				return error_in_basic_tab();
			}
		}

		// AFTER CONVERSATION WORK TIME LIMIT - validation
		var $uses_after_conversation_work = $(this.uses_after_conversation_work);
		if ($uses_after_conversation_work.prop("checked")) {
			var $after_conversation_work_time_limit = $(this.after_conversation_work_time_limit);
			msg_err = "<%=_T('After conversation work time is required.')%>";
			if ( !this.validate_field( $after_conversation_work_time_limit, "required", msg_err ) ) {
				return error_in_basic_tab();
			}
			range = { between: { from: 5, to: 120 } };
			msg_err = FORMAT("<%=_T('After conversation work time value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
			if ( !this.validate_field($after_conversation_work_time_limit, "range", msg_err, range)) {
				return error_in_basic_tab();
			}
		}
		// INCOMING ENABLED / OUTGOING ENABLED - Valida que se encuentre activa al menos una de las 2 configuraciones
		if ( !is_enabled_incoming_config && !is_enabled_outgoing_config ) {
			msg_err = "<%=_T('Incoming or Outgoing configuration are required.')%>";
			var $inc_out_tabs = $( this.inc_out_tabs );
			this.show_validation_error( $inc_out_tabs, msg_err, false );
			return error_in_basic_tab();
		}

	// -------------------------------------------------------
	// 2 - Validacion de "INCOMING CONTROLS"
	//
		var incoming_config = { enabled: false };

		if ( is_enabled_incoming_config ) {
			incoming_config.enabled = true;
			// DNIS
			var $inc_dnis = $(this.inc_dnis);
			msg_err = "<%=_T('Incoming DNIS is required.')%>";
			if ( !this.validate_field( $inc_dnis, "required", msg_err ) ) {
				return error_in_basic_tab( INC_TAB_ID );
			}
			var full_dnis = $inc_dnis.val().splitrim(",");
			incoming_config.TrunkId = full_dnis[0];
			incoming_config.TrunkType = full_dnis[1];
			incoming_config.DNIS = full_dnis[2];

			// validacion del custom active process
			var $inc_active_process = $(this.inc_active_process);
			var uses_inc_active_process = $inc_active_process.prop("checked");

			if (uses_inc_active_process) {
				var $inc_active_process_id = $(this.inc_active_process_id);
				msg_err = "<%=_T('Incoming custom active process is required.')%>";
				if ( !this.validate_field( $inc_active_process_id, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.SelfServiceProcess = $inc_active_process_id.val();
			}

			// validacion del custom inactive process
			var $inc_inactive_process = $(this.inc_inactive_process);
			var uses_inc_inactive_process = $inc_inactive_process.prop("checked");

			if (uses_inc_inactive_process) {
				var $inc_inactive_process_id = $(this.inc_inactive_process_id);
				msg_err = "<%=_T('Incoming custom inactive process is required.')%>";
				if ( !this.validate_field( $inc_inactive_process_id, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.OutOfTimeProcess = $inc_inactive_process_id.val();
			}

			// validacion del answer time (requerido y rango)
			if ($(this.inc_auto_answer).prop("checked")) {
				var $inc_auto_answer_time = $(this.inc_auto_answer_time);
				msg_err = "<%=_T('Incoming answer time is required.')%>";
				if ( !this.validate_field( $inc_auto_answer_time, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				range = { between: { from: 0, to: 20 } };
				msg_err = FORMAT("<%=_T('Incoming answer time value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
				if ( !this.validate_field($inc_auto_answer_time, "range", msg_err, range)) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.AutoAnswerTime = MS( $inc_auto_answer_time.val() );
			}

			// Asigna si utiliza o no configuracion de contact center
			var uses_inc_contact_center = $(this.inc_uses_contact_center).prop("checked");
			if ( !uses_inc_contact_center ) {
			// SI NO utiliza configuracion de contact center
			//..
				// Valida que utilice un custom active process
				if (!uses_inc_active_process) {
					msg_err = "<%=_T('If you do not use a contact center you must select incoming custom active process.')%>";
					this.show_validation_error( $inc_active_process, msg_err, false );
					return error_in_basic_tab( INC_TAB_ID );
				}
				// Valida que utilice un custom inactive process
				if (!uses_inc_inactive_process) {
					msg_err = "<%=_T('If you do not use a contact center you must select incoming custom inactive process.')%>";
					this.show_validation_error( $inc_inactive_process, msg_err, false );
					return error_in_basic_tab( INC_TAB_ID );
				}
			}
			else {
			// SI utiliza configuracion de contact center
			//..

				incoming_config.ContactCenter = {};

				// validacion de la distribucion incoming contact center
				var $inc_distribution = $(this.inc_distribution);
				msg_err = "<%=_T('Incoming contact center distribution is required.')%>";
				if ( !this.validate_field( $inc_distribution, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.ContactCenter.CCAlgorithm = $inc_distribution.val();

				// validacion retain voicemal
				var $inc_voicemail_timeout_retain = $(this.inc_voicemail_timeout_retain);
				msg_err = "<%=_T('Incoming retain voicemail is required.')%>";
				if ( !this.validate_field( $inc_voicemail_timeout_retain, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				range = { between: { from: 1, to: 15 } };
				msg_err = FORMAT("<%=_T('Incoming retain voicemail value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
				if ( !this.validate_field($inc_voicemail_timeout_retain, "range", msg_err, range)) {
					return error_in_basic_tab( INC_TAB_ID );
				}

				// validacion voicemail repeat time
				var $inc_voicemail_waiting_time = $(this.inc_voicemail_waiting_time);
				msg_err = "<%=_T('Incoming voicemail repeat time is required.')%>";
				if ( !this.validate_field( $inc_voicemail_waiting_time, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				range = { between: { from: 6, to: 1200 } };
				msg_err = FORMAT("<%=_T('Incoming voicemail repeat time value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
				if ( !this.validate_field($inc_voicemail_waiting_time, "range", msg_err, range)) {
					return error_in_basic_tab( INC_TAB_ID );
				}

				// validacion allowed redial
				var $allowed_redial = $(this.inc_allowed_redial);
				var allowed_redial = $allowed_redial.prop("checked") ? 1 : 0;
				if (allowed_redial === 1) {
					msg_err = "<%=_T('Outgoing call conversations need to be configured to check Allowed Redial.')%>";
					if (!is_enabled_outgoing_config) {
						this.show_validation_error( $allowed_redial, msg_err, false );
						return error_in_basic_tab( INC_TAB_ID );
					}
					incoming_config.ContactCenter.CheckRedial = allowed_redial;
				}

				// aca asigno los valores de retain voicemail y repeat time
				incoming_config.ContactCenter.VoicemailOnTimeout = $(this.inc_voicemail_timeout).prop("checked") ? 1 : 0;
				incoming_config.ContactCenter.VoicemailOnWait = $(this.inc_voicemail_waiting).prop("checked") ? 1 : 0;

				if ( incoming_config.ContactCenter.VoicemailOnTimeout === 1 || incoming_config.ContactCenter.VoicemailOnWait === 1 ) {
					incoming_config.ContactCenter.LifeTimeVoicemail = $inc_voicemail_timeout_retain.val();
				}
				if ( incoming_config.ContactCenter.VoicemailOnWait === 1 ) {
					incoming_config.ContactCenter.VoicemailOnWaitRepeatTime = MS($inc_voicemail_waiting_time.val());
				}

				// validacion acd priority
				var $inc_acd_priority = $(this.inc_acd_priority);
				msg_err = "<%=_T('Incoming ACD priority is required.')%>";
				if ( !this.validate_field( $inc_acd_priority, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				range = { between: { from: 0, to: 9999 } };
				msg_err = FORMAT("<%=_T('Incoming ACD priority value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
				if ( !this.validate_field($inc_acd_priority, "range", msg_err, range)) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.ContactCenter.ACDPriority = $inc_acd_priority.val();

				// announce place in queue
				incoming_config.ContactCenter.AnnouncePlaceInQueue = $(this.inc_announce_queue).prop("checked") ? 1 : 0;
				// annouce wait time
				incoming_config.ContactCenter.AnnounceEstimatedWaitTime = $(this.inc_announce_wait).prop("checked") ? 1 : 0;
				// hide acd
				incoming_config.ContactCenter.HideACD = $(this.inc_hide_acd).prop("checked") ? 1 : 0;
				// contact name format
				const $contact_name_format = $(this.inc_contact_name_format);
				const regex_contact_name_format = /[\u00F1#?=&]/;
				if (regex_contact_name_format.test($contact_name_format.val() || "")) {
					let err =  FORMAT("<%=_T('The contact name format cannot contain the characters {0}.')%>", "(#,?,=,&,ñ)");
					this.show_validation_error( $contact_name_format, err, false );
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.ContactCenter.ContactNameFormat = $contact_name_format.val();
			}
		}

	// -------------------------------------------------------
	// 3 - Validacion de "OUTGOING CONTROLS"
	//
		var outgoing_config = { enabled: false };

		if ( is_enabled_outgoing_config ) {
			outgoing_config.enabled = true;
			// Outgoing Routing Group
			var $out_routing_group = $(this.out_routing_group);
			msg_err = "<%=_T('Outgoing Routing Group is required.')%>";
			if ( !this.validate_field( $out_routing_group, "required", msg_err ) ) {
				return error_in_basic_tab( OUT_TAB_ID );
			}
			outgoing_config.RoutingGroup = $out_routing_group.val();

			// Dialing Rule
			var $out_dialing_rule = $(this.out_dialing_rule);
			msg_err = "<%=_T('Outgoing Dialing Rule is required.')%>";
			if ( !this.validate_field( $out_dialing_rule, "required", msg_err ) ) {
				return error_in_basic_tab( OUT_TAB_ID );
			}
			outgoing_config.DialingRule = $out_dialing_rule.val();

			// Capacity Assigned
			var $out_capacity_assigned = $(this.out_capacity_assigned);
			msg_err = "<%=_T('Outgoing capacity assigned is required.')%>";
			if ( !this.validate_field( $out_capacity_assigned, "required", msg_err ) ) {
				return error_in_basic_tab( OUT_TAB_ID );
			}
			var capacity = (this.parent.frm.combo_get_selected_item_data( $out_routing_group ) || {}).DisplayCapacity || 0;
			range = { between: { from: 1, to: capacity } };
			msg_err = FORMAT("<%=_T('Outgoing capacity assigned out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
			if ( !this.validate_field($out_capacity_assigned, "range", msg_err, range)) {
				return error_in_basic_tab( OUT_TAB_ID );
			}
			outgoing_config.CapacityAssigned = $out_capacity_assigned.val();

			// OutboundPrefix
			var $out_prefix = $(this.out_prefix);
			msg_err = "<%=_T('Outgoing prefix is required.')%>";
			if ( !this.validate_field( $out_prefix, "required", msg_err ) ) {
				return error_in_basic_tab( OUT_TAB_ID );
			}
			msg_err = "<%=_T('Outoing prefix only digits are allowed.')%>";
			if ( !this.validate_field($out_prefix, "digits", msg_err ) ) {
				return error_in_basic_tab( OUT_TAB_ID );
			}
			/*
				Atencion: El prefijo en la cuenta de tel de Allegro en 5.5, comienza en mayusculas por tal motivo es que tenemos esta diferencia como queda en cassandra
							si es que comparamos como queda almacenado este atributo contra una cuenta de Tel de i6.
							Ej:
								En la CF "CampaignAccounts" Column "outgoingConfig" existe un JSON con los siguientes atributos segun si es una cuenta de i6 o 5.5.
									En la cuenta Tel i6 queda en el atributo "outboundPrefix".
									En la cuenta Tel 5.5 queda en el atributo "OutboundPrefix".
			*/
			outgoing_config.OutboundPrefix = $out_prefix.val();

			// validacion del active custom process
			var $out_active_process = $(this.out_active_process);
			var used_out_active_process = $out_active_process.prop("checked");

			if (used_out_active_process) {
				var $out_active_process_id = $(this.out_active_process_id);
				msg_err = "<%=_T('Outgoing custom active process is required.')%>";
				if ( !this.validate_field( $out_active_process_id, "required", msg_err ) ) {
					return error_in_basic_tab( OUT_TAB_ID );
				}
				outgoing_config.SelfServiceProcess = $out_active_process_id.val();
			}

			// validacion del inactive custom process
			var $out_inactive_process = $(this.out_inactive_process);
			var uses_out_inactive_process = $out_inactive_process.prop("checked");

			if (uses_out_inactive_process) {
				var $out_inactive_process_id = $(this.out_inactive_process_id);
				msg_err = "<%=_T('Outgoing custom inactive process is required.')%>";
				if ( !this.validate_field( $out_inactive_process_id, "required", msg_err ) ) {
					return error_in_basic_tab( OUT_TAB_ID );
				}
				outgoing_config.OutOfTimeProcess = $out_inactive_process_id.val();
			}

			// telesales
			outgoing_config.IsTelesales = $(this.out_telesales).prop("checked") ? 1 : 0;

			// Asigna si utiliza o no configuracion de contact center
			var uses_out_contact_center = $(this.out_uses_contact_center).prop("checked");
			if ( !uses_out_contact_center ) {
			// SI NO utiliza configuracion de contact center
			//..
				var is_used_voice_blaster = this.is_used_voice_blaster();
				if (!is_used_voice_blaster) {
					// Valida que utilice un custom active process
					if (!used_out_active_process) {
						msg_err = "<%=_T('If you do not use a contact center you must select outgoing custom active process.')%>";
						this.show_validation_error( $out_active_process, msg_err, false );
						return error_in_basic_tab( OUT_TAB_ID );
					}
					// Valida que utilice un custom inactive process
					if (!uses_out_inactive_process) {
						msg_err = "<%=_T('If you do not use a contact center you must select outgoing custom inactive process.')%>";
						this.show_validation_error( $out_inactive_process, msg_err, false );
						return error_in_basic_tab( OUT_TAB_ID );
					}
				}
			}
			else {
			// SI utiliza configuracion de contact center
			//..
				outgoing_config.ContactCenter = {};
				// validacion de la distribucion outgoing contact center
				var $out_distribution = $(this.out_distribution);
				msg_err = "<%=_T('Outgoing contact center distribution is required.')%>";
				if ( !this.validate_field( $out_distribution, "required", msg_err ) ) {
					return error_in_basic_tab( OUT_TAB_ID );
				}
				outgoing_config.ContactCenter.CCAlgorithm = $out_distribution.val();
				// manual calls
				outgoing_config.ContactCenter.AllowManualCalls = $(this.out_manual_calls).prop("checked") ? 1 : 0;
				// manual contact name format
				outgoing_config.ContactCenter.ManualContactNameFormat = $(this.out_manual_contact_name_format).val();
			}

			// Asigna si utiliza o no configuracion de outboundengine
			var out_use_outboundengine = $(this.out_uses_outboundengine).prop("checked");

			if ( out_use_outboundengine ) {
				outgoing_config.OutboundEngine = {};
				// validacion outboundprocess
				var $out_outboundprocess = $(this.out_outboundprocess);
				msg_err = "<%=_T('Outgoing outbound process is required.')%>";
				if ( !this.validate_field( $out_outboundprocess, "required", msg_err ) ) {
					return error_in_basic_tab( OUT_TAB_ID );
				}
				outgoing_config.OutboundEngine.OutboundProcessId = $out_outboundprocess.val();

				// validacion outboundprocess type
				var $out_outboundprocess_type = $(this.out_outboundprocess_type);
				msg_err = "<%=_T('Outgoing outbound process type is required.')%>";
				if ( !this.validate_field( $out_outboundprocess_type, "required", msg_err ) ) {
					return error_in_basic_tab( OUT_TAB_ID );
				}

				var selected_outboundprocess_type = $out_outboundprocess_type.val();
				outgoing_config.OutboundEngine.OutboundProcessType = selected_outboundprocess_type;

				// validaciones de los diferentes tipos de controles, segun el oubtound process type que se ha seleccionado.
				var $out_dialer_throttle = $(this.out_dialer_throttle);
				var $out_abandoned_rate = $(this.out_abandoned_rate);
				var $out_per_available_agent = $(this.out_per_available_agent);

				// validacion de los throttle ctrls para voice blaster y predictive
				var __validate_throttle_ctrls = function(outboundprocess_type)
				{
					var default_value = -1;
					var has_dialer_throttle = $out_dialer_throttle.prop("checked");

					if (!has_dialer_throttle) {
						if (outboundprocess_type === "AUTOMATIC" && used_out_active_process) {
							outgoing_config.OutboundEngine.CorrectionManualRate = default_value;
							outgoing_config.OutboundEngine.DesiredAbandonRate = $out_abandoned_rate.val() / 100;
							return true; // is ok
						}

					// Si el chk 'dialer_throttle' NO se encuentra marcado asigno valor
						msg_err = "<%=_T('Outgoing outobund engine, desired abandoned rate is required.')%>";
						if ( !self.validate_field( $out_abandoned_rate, "required", msg_err ) ) {
							return false;
						}
						range = { between: { from: 0, to: 100 } };
						msg_err = FORMAT("<%=_T('Outgoing outobund engine, desired abandoned rate value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
						if ( !self.validate_field($out_abandoned_rate, "range", msg_err, range)) {
							return false;
						}

						outgoing_config.OutboundEngine.CorrectionManualRate = default_value;
						outgoing_config.OutboundEngine.DesiredAbandonRate = $out_abandoned_rate.val() / 100;
						return true; // is ok
					}
					else {
						if (outboundprocess_type === "AUTOMATIC" && used_out_active_process) {
							outgoing_config.OutboundEngine.CorrectionManualRate = $out_per_available_agent.val();
							outgoing_config.OutboundEngine.DesiredAbandonRate = default_value;
							return true; // is ok
						}

					// Si el chk 'dialer_throttle' SI se encuentra marcado asigno valor
						msg_err = "<%=_T('Outgoing outobund engine, calls per available agent is required.')%>";
						if ( !self.validate_field( $out_per_available_agent, "required", msg_err ) ) {
							return false;
						}
						range = { between: { from: 1, to: 100 } };
						msg_err = FORMAT("<%=_T('Outgoing outobund engine, calls per available agent value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
						if ( !self.validate_field($out_per_available_agent, "range", msg_err, range)) {
							return false;
						}

						outgoing_config.OutboundEngine.CorrectionManualRate = $out_per_available_agent.val();
						outgoing_config.OutboundEngine.DesiredAbandonRate = default_value;
						return true; // is ok
					}
				};

				// validacion de los Answering match process ctrls para voicemail y predictive
				var __validate_auto_attend_am = function()
				{
					var $out_answer_process = $(self.out_answer_process);
					msg_err = "<%=_T('Outgoing outobund engine, auto-attending an answered maching is required.')%>";
					if ( !self.validate_field( $out_answer_process, "required", msg_err ) ) {
						return false;
					}
					if ( $(self.out_autoattend_am).prop("checked") ) {
						outgoing_config.OutboundEngine.AnsweringMachineProcess = $(self.out_answer_process).val();
					}
					return true;
				};

				// Asigna el valor del has preview
				var __set_has_preview = function() { outgoing_config.OutboundEngine.HasPreview = $(self.out_has_preview).prop("checked") ? 1 : 0; };

				switch(selected_outboundprocess_type)
				{
					case "AUTOMATIC":    // voice blaster / automated
						// validacion de voice blaster process
						var $out_voiceblaster = $(this.out_voiceblaster);
						msg_err = "<%=_T('Outgoing outobund engine, voice blaster process is required.')%>";
						if ( !this.validate_field( $out_voiceblaster, "required", msg_err ) ) {
							return error_in_basic_tab( OUT_TAB_ID );
						}
						var voice_blaster_id = $out_voiceblaster.val();
						outgoing_config.OutboundEngine.VoiceBlasterID = voice_blaster_id.trim().length > 0 ? voice_blaster_id : null;

						// validacion de los throttle ctrls para voice blaster
						if (!__validate_throttle_ctrls(selected_outboundprocess_type)) {
							return error_in_basic_tab( OUT_TAB_ID );
						}
						// validacion auto attend Answering match process
						if ( !__validate_auto_attend_am() ) {
							return error_in_basic_tab( OUT_TAB_ID );
						}
						break;

					case "PREDICTIVE":   // predicitive dialer
						// validacion de los throttle ctrls para predictive
						if (!__validate_throttle_ctrls(selected_outboundprocess_type)) {
							return error_in_basic_tab( OUT_TAB_ID );
						}
						// validacion auto attend Answering match process
						if ( !__validate_auto_attend_am() ) {
							return error_in_basic_tab( OUT_TAB_ID );
						}
						// validacion auto attend abandoned process
						var $out_abandoned_process = $(this.out_abandoned_process);
						msg_err = "<%=_T('Outgoing outobund engine, auto attened abandoned process is required.')%>";
						if ( !this.validate_field( $out_abandoned_process, "required", msg_err ) ) {
							return error_in_basic_tab( OUT_TAB_ID );
						}

						if ( $(this.out_autoattend_abandoned).prop("checked") ) {
							outgoing_config.OutboundEngine.AbandonedPredictiveProcess = $out_abandoned_process.val();
						}
						__set_has_preview();

						break;

					case "PROGRESSIVE":  // progressive dialer
						// En principo en esta opcion no existe ninguna validacion extra!!
						__set_has_preview();
						outgoing_config.OutboundEngine.HangupOnAM = $(this.out_hangup_am).prop("checked") ? 1 : 0;
						break;
				}

				// Si tiene marcado el chk Guess AM By connect time
				if ($(this.out_guess_am_connected).prop("checked")) {
					// Positive AM Below
					var $out_positive_am_below = $(this.out_positive_am_below);
					msg_err = "<%=_T('Outgoing outobund engine, positive AM below is required.')%>";
					if ( !this.validate_field( $out_positive_am_below, "required", msg_err ) ) {
						return error_in_basic_tab( OUT_TAB_ID );
					}
					range = { between: { from: 1, to: 3 } };
					msg_err = FORMAT("<%=_T('Outgoing outobund engine, positive AM below value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
					if ( !this.validate_field($out_positive_am_below, "range", msg_err, range)) {
						return error_in_basic_tab( OUT_TAB_ID );
					}
					outgoing_config.OutboundEngine.MinTimeForAgent = $out_positive_am_below.val();

					// Positive AM Above
					var $out_positive_am_above = $(this.out_positive_am_above);
					msg_err = "<%=_T('Outgoing outobund engine, positive AM above is required.')%>";
					if ( !this.validate_field( $out_positive_am_above, "required", msg_err ) ) {
						return error_in_basic_tab( OUT_TAB_ID );
					}
					range = { between: { from: 40, to: 70 } };
					msg_err = FORMAT("<%=_T('Outgoing outobund engine, positive AM above value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
					if ( !this.validate_field($out_positive_am_above, "range", msg_err, range)) {
						return error_in_basic_tab( OUT_TAB_ID );
					}
					outgoing_config.OutboundEngine.MaxTimeForAgent = $out_positive_am_above.val();
				}

				// hang up call on threshold
				outgoing_config.OutboundEngine.StrictThreshold = $(this.out_hangup_threshold).prop("checked") ? 1 : 0;
				// contact name format
				outgoing_config.OutboundEngine.ContactNameFormat = $(this.out_contact_name_format).val();
			}
		}

	// -------------------------------------------------------
	// 4 - Validacion de los controles comunes entre los diferentes tipos de cuentas.
	//

		// valido los skills ----------
		var result_skills = this.validate_skills();
		if ( !result_skills.success ) {
			this.show_validation_error( result_skills.$ctrl, result_skills.message );
			return error_in_basic_tab();
		}

		// valido los attention levels ----------
		var result_attention_levels = this.validate_attention_levels();
		if ( !result_attention_levels.success ) {
			this.show_validation_error(
				result_attention_levels.$ctrl,
				result_attention_levels.message,
				false, //timeout_ms
				true, //scrolling
				result_attention_levels.show_custom_button
			);
			return error_in_basic_tab();
		}

		// valido los thresholds ----------
		var result_th = this.validate_thresholds();
		if ( !result_th.success ) {
			this.show_validation_error( result_th.$ctrl, result_th.error_message );
			return error_in_basic_tab();
		}

		// valido los contact mng ----------
		var result_contact_mng = this.validate_contact_mng();
		if ( !result_contact_mng.success ) {
			this.show_validation_error( result_contact_mng.$ctrl, result_contact_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los flows mng ----------
		var result_flows_mng = this.validate_flows_mng();
		if ( !result_flows_mng.success ) {
			this.show_validation_error( result_flows_mng.$ctrl, result_flows_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los qna maker mng ----------
		var result_qna_maker_mng = this.validate_qna_maker_mng();
		if ( !result_qna_maker_mng.success ) {
			this.show_validation_error( result_qna_maker_mng.$ctrl, result_qna_maker_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los messages de la account ----------
		var result_messages = this.validate_messages();
		if ( !result_messages.success ) {
			this.show_validation_error( undefined, result_messages.error_message );
			return account_info;
		}

		// valido la configuracion de tickets
		var result_ticket_emitter = this.validate_ticket_emitter();
		if (!result_ticket_emitter.success) {
			this.show_validation_error( result_ticket_emitter.$ctrl, result_ticket_emitter.error_message );
			return account_info;
		}

		// //------------------------------------------------------
		// // paso la validacion correctamente, ahora a guardar!!!
		var account_id, account_name;
		if ( is_new ) {
			var campaign = this.parent.frm.campaign;
			account_name = inConcert.app.getAllegroAPI().getAllegroCampaign(campaign.Id);
			account_id = "CALL_" + campaign.Id + "_" + account_name;
		}
		else {
			account_id = this.current_account.id;
			account_name = this.current_account.name;
		}

		var account = {
		// i6 - Informacion basica y necesaria para todas las cuentas de i6
			id              : account_id,
			name            : account_name,
			uid             : account_name,
			proxyType       : "CALL",
			TicketEmitter   : result_ticket_emitter.result,
			Skills          : this.skills_handle.get(),
			AttentionLevels : this.attention_levels_handle.get(),
			GUI             : this.get_gui_config(),

		// i6 - Informacion necesaria para las cuentas de CALL en i6
			// ..
			// ..

		// 5.5 - Informacion requerida tanto para Incoming y Outgoing
			//

			CallbackIsAllowed          : $callback.prop("checked") ? 1 : 0,
			LifeTimeAbandonedCalls     : $retain_abandoned.val(),
			waitBetweenCalls           : this.__GetWaitBetweenCalls(),
			ScreenRecording            : this.__GetScreenRecording(),
			MarketingIntegrationEnabled: $(this.marketing_integration_enabled).prop("checked") ? 1 : 0,
			AfterInteractionWork       : this.__GetAfterConversationWork(),

			incomingConfig : incoming_config,
			outgoingConfig : outgoing_config
		};

		this.contact_mng_instance.attach_data( account );
		if (this.flow_mng_instance) {
			this.flow_mng_instance.attach_data( account );
		}

		if (this.qna_maker_mng_instance) {
			this.qna_maker_mng_instance.attach_data(account);
		}

		account_info.account = account;
		account_info.success = true;

		return account_info;
	};

	CallAllegroAccountPanel.prototype.__GetWaitBetweenCalls = function()
	{
		if ( !$(this.wait_between_call).prop("checked") ) {
			return 0; // Si ha marcado que no quiere "wait between calls"
		}
		// Si ha marcado que quiere "wait between calls"
		return MS( $(this.wait_between_call_time).val() );
	};

	CallAllegroAccountPanel.prototype.__GetScreenRecording = function()
	{
		if ( !$(this.screen_recording).prop("checked") ) {
			return 0; // Si ha marcado que no quiere "screen recording"
		}
		// Si ha marcado que quiere "screen recording"
		return $(this.screen_recording_percentage).val();
	};

	CallAllegroAccountPanel.prototype.__GetAfterConversationWork = function()
	{
		if ( !$(this.uses_after_conversation_work).prop("checked") ) {
			return 0; // Si ha marcado que no quiere "after conversation work"
		}
		if ( $(this.after_conversation_work_time).val() === "Unlimited" ) {
			return UNLIMITED_VALUE_AFTER_CONVERSATION_WORK; // Si ha marcado que quiere "after conversation work" y ha seleccionado ilimitado
		}
		// Si ha marcado que quiere "after conversation work" y ha seleccionado con un tiempo limitado
		return MS( $(this.after_conversation_work_time_limit).val() );
	};

	CallAllegroAccountPanel.prototype.has_qna_maker = function() {return true;};

	CallAllegroAccountPanel.prototype.initialize_qna_maker_mng = function()
	{
		// build qna_maker management panel
		CallAllegroAccountPanel.uber.initialize_qna_maker_mng.call(
			this,
			{
				type         : "CALL"                                                       ,
				parent       : this                                                         ,
				container_id : "adm_form_campaign_accounts_call_allegro_qna_maker_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_allegro_qna_maker_mng"
			}
		);
	};

	CallAllegroAccountPanel.prototype.get_account_name = function()
	{
		return this.current_account.name;
	};

}());
