/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

// try improve namespacing a bit
if ( !this.inConcert.Administration ) {
	this.inConcert.Administration = {};
}

if ( !this.inConcert.Administration.Campaigns ) {
	this.inConcert.Administration.Campaigns = {};
}

(function () {

//	"use strict";

	var FORMAT = inConcert.Utils.format;
	var SANITIZE_ID = function(id) { return id.replace("#", ""); };

	//---------------------------------------------------------------------
	// class parameters (web)
	function web_parameters(params)
	{
		var self = this;

		this.owner = params.owner;
		this.type = params.type;
		this.prefix_id = params.container_prefix_id;
		var panel_id = params.panel_id || "";

		this.param_section         = FORMAT( this.prefix_id + "{0}_parameters_section"                     , panel_id );
		this.param_new             = FORMAT( this.prefix_id + "{0}_parameter_new"                          , panel_id );
		this.param_popup           = FORMAT( this.prefix_id + "{0}_popup_parameters"                       , panel_id );
		this.param_popup_title     = FORMAT( this.prefix_id + "{0}_popup_title"                            , panel_id );
		this.param_create          = FORMAT( this.prefix_id + "{0}_param_create"                           , panel_id );
		this.param_create_continue = FORMAT( this.prefix_id + "{0}_param_create_and_continue"              , panel_id );
		this.param_cancel          = FORMAT( this.prefix_id + "{0}_param_cancel"                           , panel_id );
		this.param_message         = FORMAT( this.prefix_id + "{0}_popup_message"                          , panel_id );
		this.param_list            = FORMAT( this.prefix_id + "{0}_parameters"                             , panel_id );
		this.param_own_name        = FORMAT( this.prefix_id + "{0}_popup_own_name"                         , panel_id );
		this.param_your_name       = FORMAT( this.prefix_id + "{0}_popup_your_name"                        , panel_id );
		this.save_btn_prefix_id    = params.save_btn_prefix_id;

		var popup_id = SANITIZE_ID(this.param_popup);
		this.popup_instance = new inConcert.PopupWindow({
			ownerId: popup_id, // container id
			eventName: popup_id, // evento click personalizado
			closeOnFocusLost: false,
			callbacks: {
				onClose: function(){
					self.hide_popup();
				}
			}
		});

		// Mapeo Parametros del Sistema para SMS entrantes
		this.inc_system_parameters = inConcert.Utils.sortArray([
				{ id: "FROM"    , required: true  },
				{ id: "TO"      , required: true  },
				{ id: "TEXT"    , required: true  }
			],
			"id"
		);
		// Mapeo Parametros del Sistema para SMS salientes
		this.out_system_parameters = inConcert.Utils.sortArray([
				{ id: "FROM"    , required: true  },
				{ id: "TO"      , required: true  },
				{ id: "TEXT"    , required: true  },
				{ id: "USERNAME", required: false },
				{ id: "PASSWORD", required: false },
				{ id: "CODING"  , required: false },
				{ id: "DLR-MASK", required: false },
				{ id: "FSEND"   , required: false },
				{ id: "PARTS"   , required: false },
				{ id: "TRSEC"   , required: false }
			],
			"id"
		);

		this.render();
		this.load_data();
	}

	web_parameters.prototype.render = function()
	{
		var sanitized_id_param_new = SANITIZE_ID(this.param_new);

		var html_parameters = "".concat(
			"<h2 class='formSubTitle'>",
				"<label class='subTitleText'>", "<%=_T('Mapped Parameters')%>", "</label>",
				"<i id='", sanitized_id_param_new, "_validation' class='formFieldValidation formFieldError' hidden></i>",
				"<input id='", sanitized_id_param_new, "' class='pageButtonGeneric buttonColorBlack internalButtons' type='button' value='", "<%=_T('New Parameter')%>", "' />",
			"</h2>",

			"<div class='formAuxiliarRow'>",
				"<div id='", SANITIZE_ID(this.param_popup), "' class='formFieldset parameters' style='display:none;'>",
					"<div class='pageFormParentContanier'>",

						"<div class='formRow'>",
							"<div class='formData formDataExt'>",
								"<label for='", SANITIZE_ID(this.param_own_name), "' class='formLabel formLabel-rq'>", "<%=_T('Our Name')%>", "<%=_T(':')%>", "</label>",
								"<input id='", SANITIZE_ID(this.param_own_name), "' class='formField' type='text' maxlength='50' />",
								"<i id='", SANITIZE_ID(this.param_own_name), "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",

						"<div class='formRow'>",
							"<div class='formData formDataExt'>",
								"<label class='formLabel formLabel-rq'>" + "<%=_T('Your Name')%>" + "<%=_T(':')%>" + "</label>",
								"<input id='", SANITIZE_ID(this.param_your_name), "' class='formField' type='text' maxlength='100' />",
								"<i id='", SANITIZE_ID(this.param_your_name), "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",

						"<div id='", SANITIZE_ID(this.param_message), "' class='genericFormMessagesContainer messageError' hidden></div>",
						"<div class='pageButtonContainer internal'>",
							"<input id='", SANITIZE_ID(this.param_create), "' class='pageButtonGeneric buttonColorBlack' type='button' value='", "<%=_T('Create')%>", "' />",
							"<input id='", SANITIZE_ID(this.param_create_continue), "' class='pageButtonGeneric buttonColorBlack' type='button' value='", "<%=_T('Create & Continue')%>", "' />",
							"<input id='", SANITIZE_ID(this.param_cancel), "' class='pageButtonGeneric buttonColorGray' type='button' value='", "<%=_T('Cancel')%>", "' />",
						"</div>",
					"</div>",
				"</div>",
				"<div class='formFieldset'>",
					"<div class='newParameterListContainer'>",
						"<ul id='", SANITIZE_ID(this.param_list), "' class='formList newParameterList'>",
							"<li class='formListTitle'>",
								"<label head='true' class='formTitleText nameColumn'>", "<%=_T('Our Name')%>", "</label>",
								"<label head='true' class='formTitleText valueColumn'>", "<%=_T('Your Name')%>", "</label>",
							"</li>",
						"</ul>",
					"</div>",
				"</div>",
			"</div>");

		var $container = $(this.param_section);
		$container.html(html_parameters);
	};

	web_parameters.prototype.load_data = function(callback)
	{
		callback = callback || $.noop;

		if (this.type !== "incoming" && this.type !== "outgoing") {
			callback();
			return;
		}

		var system_parameters = this.type === "incoming" ? this.inc_system_parameters : this.out_system_parameters;
		var list = [];
		$.each(system_parameters, function(_, field) {
			var item = field.id;
			list.push(item);
		});
		// combo autocomplete
		var $field_value = $(this.param_own_name);
		this.owner.parent.frm.make_autocomplete(
			$field_value,
			list
		);
		$field_value.val("");
		callback();
	};

	web_parameters.prototype.dispose = function()
	{
		if (this.popup_instance) {
			if ( this.popup_instance.isVisible() ) {
				this.popup_instance.hide();
			}
			this.popup_instance = null;
		}
	};

	web_parameters.prototype.count = function()
	{
		// retorna la cantidad de parametros
		var count = 0;
		$(this.param_list).find("li[param_data]").each(function() { count++; });
		return count;
	};

	web_parameters.prototype.get = function()
	{
		var parameters = {};
		// carga la lista de parameters
		$(this.param_list).find("li[param_data]").each(function(_, param_data)
		{
			var $param_data = $(param_data);
			var name = $param_data.find("label[param_own_name]").text();
			var value = $param_data.find("label[param_your_name]").attr("value_id");
			parameters[name] = {value: value};
		});
		return parameters;
	};

	web_parameters.prototype.set = function(parameters)
	{
		var self = this;
		$(this.param_list).find("li[param_data]").remove();
		if (!parameters) {
			return;
		}
		$.each(parameters, function(name, info) {
			self.add_row(name, info);
		});
	};

	web_parameters.prototype.show_popup = function()
	{
		this.hide_errors();

		if ( !this.owner.parent.has_permission_to_section() || !this.owner.parent.has_permission_to_save() ) {
			var message = "<%=_T('You dont have permissions for this action.')%>";
			this.owner.parent.frm.show_status_message( message, "Error", 5000 );
			return;
		}

		this.popup_instance.show();
		// disable actions popup parameters (new, delete, edit)
		this.disable_actions(true);
		if (!this.$row_editing) {
		// si presione el boton para crear uno nuevo
			$(this.param_popup_title).text("<%=_T('New Parameter')%>");
			$(this.param_create).val("<%=_T('Create')%>");
			$(this.param_create_continue).show();
			$(this.param_own_name).focus().val("");
			$(this.param_your_name).val("");
		}
		else {
		// si presione el boton para editar
			$(this.param_popup_title).text("<%=_T('Update Parameter')%>");
			$(this.param_create).val("<%=_T('Update')%>");
			$(this.param_create_continue).hide();
			var name = this.$row_editing.find("label[param_own_name='true']").text();
			$(this.param_own_name).focus().val(name);
			var value = this.$row_editing.find("label[param_your_name='true']").attr("value_id");
			$(this.param_your_name).val(value);
		}
	};

	web_parameters.prototype.hide_popup = function()
	{
		if (this.popup_instance) {
			this.popup_instance.hide();
		}
		// enable actions popup parameters (new, delete, edit)
		this.disable_actions(false);
	};

	web_parameters.prototype.can_add_row = function(/*name*/) { return true; };

	web_parameters.prototype.add_row = function(name, info, apply_effect)
	{
		if (typeof name !== "string" || typeof info !== "object") {
			return;
		}
		if (!this.can_add_row(name)) {
			return;
		}

		var value = info.value || "";
		var unique_id = name.trim().toLowerCase();

		var $make_new_row = function()
		{
			value = value || "";
			var description = value;
			var display = "";
			if (apply_effect) {
				display = "style='display:none;' ";
			}
			var $new_row = $(
				"<li param_data='true' class='formListItem'" + display + ">" +
					"<label param_own_name='true' class='formItemText nameColumn' unique_id='" + unique_id + "'>" + name  + "</label>" +
					"<label param_your_name='true' class='formItemText valueColumn' value_id='" + value + "'>" + description + "</label>" +
					"<input action_del='true' class='buttonColorGray gridActionButton delete last' type='button' value='" + "<%=_T('Delete')%>" + "' />" +
					"<input action_edit='true' class='buttonColorGray gridActionButton edit' type='button' value='" + "<%=_T('Edit')%>" + "' />" +
				"</li>");
			$new_row.data("info", info);
			return $new_row;
		};

		var added = false;
		var $list = $(this.param_list);
		var $new_row;
		$list.find("li[param_data]").each(function(_, row)
		{
			var $row = $(row);
			var current_unique_id = $row.find("label[param_own_name]").attr("unique_id");

			if (unique_id < current_unique_id) {
				$new_row = $make_new_row();
				$row.before($new_row);
				added = true;
				return false; // break
			}
		});
		if (!added) {
			$new_row = $make_new_row();
			$list.append($new_row);
		}
		if (apply_effect && $new_row) {
			// aca realizo el fade in
			$new_row.fadeIn("slow");
		}
	};

	web_parameters.prototype.hide_errors = function()
	{
		$(this.param_message).hide();
		$(this.param_section).find(".formFieldError").hide();
	};

	web_parameters.prototype.validate = function(own_name, your_name)
	{
		var self = this;

		var show_error = function(message, $control)
		{
			$(self.param_message).text(message).show();
			if ($control) {
				var validation_id = $control.attr("id") + "_validation";
				$("#" + validation_id).show();
				$control.focus();
			}
		};
		var message;
		var $own_name = $(this.param_own_name);
		if (!this.is_valid_data(own_name, "required")) {
			message = FORMAT("<%=_T('Please enter the {0} parameter Our Name.')%>", this.type);
			show_error(message, $own_name);
			return false;
		}

		if (!this.is_valid_data(own_name, "alpha")) {
			message = FORMAT("<%=_T('Only letters, numbers, dashes and dots are allowed in the {0} parameter Our Name.')%>", this.type);
			show_error(message, $own_name);
			return false;
		}
		//valido que no sean solo numeros
		if (this.is_valid_data(own_name, "number")) {
			message =FORMAT("<%=_T('The Our Name of the {0} parameter could not be a number.')%>", this.type);
			show_error(message, $own_name);
			return false;
		}

	// valido el your_name de tipo custom. si es requerido y el tipo de texto ingresado, ya que es un txt
		var $your_name = $(this.param_your_name);
		if (!this.is_valid_data(your_name, "required")) {
			message = FORMAT("<%=_T('Please enter the {0} parameter Your Name.')%>", this.type);
			show_error(message, $your_name);
			return false;
		}
		if (!this.is_valid_data(your_name, "alpha")) {
			message = FORMAT("<%=_T('Only letters, numbers, dashes and dots are allowed in the {0} parameter Your Name.')%>", this.type);
			show_error(message, $your_name);
			return false;
		}

		//valido que no sean solo numeros
		if (this.is_valid_data(your_name, "number")) {
			message = FORMAT("<%=_T('The Your Name of the {0} parameter could not be a number.')%>", this.type);
			show_error(message, $your_name);
			return false;
		}

		var validate_unique_name = function(params)
		{
			var unique_val = params.$ctrl.val().trim().toLowerCase();

			var already_exist = function()
			{
				var current_param = $(self.param_list).find("li[param_data] label[" + params.attr_name + "='true'][" + params.attr_value + "='" + unique_val + "']");
				var len = current_param.length;
				if (len > 0) {
					var message = FORMAT("<%=_T('Already exist {0} parameter {1} {2}.')%>", self.type, params.display_name, params.$ctrl.val());
					show_error(message, params.$ctrl);
					return true;
				}
				return false;
			};

			if (!self.$row_editing) {
				// si es un parametro nuevo valida que el mismo ya no exista en la lista
				if (already_exist()) {
					return false;
				}
			}
			else {
				var val = self.$row_editing.find("[" + params.attr_name + "='true']").text();
				val = val.trim().toLowerCase();
				if (val !== unique_val) {
				// si es name del parametro ha cambiado valido que el nuevo nombre ya no exista en la lista
					if (already_exist()) {
						return false;
					}
				}
			}

			return true;
		};

		if (!validate_unique_name({
				$ctrl       : $own_name,
				attr_name   : "param_own_name",
				attr_value  : "unique_id",
				display_name: "<%=_T('Our Name')%>"
			})) {
			return false;
		}

		if (!validate_unique_name({
				$ctrl       : $your_name,
				attr_name   : "param_your_name",
				attr_value  : "value_id",
				display_name: "<%=_T('Your Name')%>"
			})) {
			return false;
		}

		// validation successufully
		return true;
	};

	web_parameters.prototype.add_or_update = function( has_continue )
	{
		var self = this;
		this.hide_errors();

		if ( !this.owner.parent.has_permission_to_section() || !this.owner.parent.has_permission_to_save() ) {
			var message = "<%=_T('You dont have permissions for this action.')%>";
			this.owner.parent.frm.show_status_message( message, "Error", 5000 );
			this.hide_popup();
			return;
		}

		var $own_name = $(this.param_own_name);
		var $your_name = $(this.param_your_name);

		var own_name = $own_name.val();
		var info = {value: $your_name.val()};

		// validate parameters
		var result = this.validate( own_name, info.value );
		if ( !result || ( typeof result === "object" && !result.success ) ) {
			return;
		}

		if (!has_continue) {
			this.hide_popup();
		}

		if (!this.$row_editing) {
		// add new parameter
			var apply_effect = true;
			this.add_row(own_name, info, apply_effect);
		}
		else {
		// update actual parameter
			this.$row_editing.fadeOut("slow", function()
			{
				var $param_own_name = $(self.$row_editing.find("[param_own_name='true']"));
				var old_name = $param_own_name.attr("unique_id");

				if (old_name !== own_name) {
					// si el grupo o el own_name cambio, tengo que cambiarlo de posicion dentro de la table (alfabeticamente)
					self.$row_editing.remove();
					var apply_effect = true;
					self.add_row(own_name, info, apply_effect);
				}
				else {
					var description = info.value;
					var $param_your_name = $(self.$row_editing.find("[param_your_name='true']"));
					// actualizo el own_name
					$param_own_name.attr("unique_id", own_name);
					$param_own_name.text(own_name);
					// actualizo el your_name
					$param_your_name.attr("value_id", info.value);
					$param_your_name.text(description);
					// aca realizo el fade in
					self.$row_editing.fadeIn("slow");
				}
			});
		}

		$own_name.val("");
		$your_name.val("");
		if (!has_continue) {
			return;
		}
		$own_name.focus();
	};

	web_parameters.prototype.disable_actions = function( disable )
	{
		disable = disable === undefined ? true : disable;

		if (this.owner.parent.is_readonly()) {
			disable = true;
		}

		$(this.param_new).prop("disabled", disable);
		var $param_data = $(this.param_list).find("li[param_data]");
		// boton edit de la lista de parametros
		$param_data.find("input[action_edit]").prop("disabled", disable);
		// boton delete de la lista de parametros
		$param_data.find("input[action_del]").prop("disabled", disable);
		this.owner.parent.disable_actions(disable, this.save_btn_prefix_id);
	};

	web_parameters.prototype.is_valid_data = function(value, validation_type)
	{
		var response = this.owner.parent.frm.validation.valid( value, validation_type );
		return response.success;
	};

	web_parameters.prototype.set_events = function()
	{
		var self = this;
		if ( this.param_new === undefined ) {
			return;
		}

		// boton new que abre el popup para poder agregar un nuevo parametro
		$(this.param_new)
			.off("click")
			.on("click", function() {
				self.$row_editing = null;
				self.show_popup( true /*is_new*/ );
			});

		$(this.param_create)
			.off("click")
			.on("click", function() {
				var has_continue = false;
				self.add_or_update(has_continue);
			});
		$(this.param_create_continue)
			.off("click")
			.on("click", function() {
				var has_continue = true;
				self.add_or_update(has_continue);
			});
		$(this.param_cancel)
			.off("click")
			.on("click", function() {
				self.hide_popup();
			});

		// grilla botones edit / delete
		var $param_list = $(this.param_list);
		var event_selector = "li[param_data]";
		// doble click sobre la row edita la misma
		$param_list
			.off("dblclick", event_selector)
			.on("dblclick", event_selector, function(event) {
				event.stopPropagation();
				self.$row_editing = $(this);
				self.show_popup( false /*is_new*/ );
			});
		// boton edit de la lista de parametros
		event_selector = "input[action_edit]";
		$param_list
			.off("click", event_selector)
			.on("click", event_selector, function() {
				self.$row_editing = $(this).parent();
				self.show_popup( false /*is_new*/ );
			});

		// boton delete de la lista de parametros
		event_selector = "input[action_del]";
		$param_list
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var $parameter = $(this).parent();
				var message = FORMAT(
					"<%=_T('Do you want to delete parameter ({0}: {1}) ?')%>",
					$parameter.find("[param_own_name='true']").text(),
					$parameter.find("[param_your_name='true']").text()
				);
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					jQuery.inconcertPopup.ButtonSets.BS_YESNO,
					function( response )
					{
						if (response.toLowerCase() !== "yes") {
							return;
						}
						if ( !self.owner.parent.has_permission_to_section() || !self.owner.parent.has_permission_to_save() ) {
							var message = "<%=_T('You dont have permissions for this action.')%>";
							self.owner.parent.frm.show_status_message( message, "Error", 5000 );
							return;
						}
						$parameter.fadeOut("slow", function() {
							$parameter.remove();
						});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});
	};

	web_parameters.prototype.validate_list = function()
	{
		var self = this;

		var result = {
			success: false,
			message: "Error",
			$ctrl: $(this.param_new)
		};

		// valida que al menos exista un parametro en la grilla
		var total_parameters = this.count();
		if (total_parameters === 0) {
			result.message = FORMAT("<%=_T('You must specify {0} parameters.')%>", this.type);
			return result;
		}

		// valida que existan todos los requeridos.
		var has_all_required = function ()
		{
			var required_result = {
				success: true
			};

			var system_parameters = self.type === "incoming" ? self.inc_system_parameters : self.out_system_parameters;
			var current_parameters = self.get();
			$.each(system_parameters, function(_, system_param)
			{
				if (!system_param.required) {
					return true; // continue
				}
				var system_param_id = system_param.id.toUpperCase().trim();
				var exist_field_required = false;

				$.each(current_parameters, function(current_id)
				{
					current_id = current_id.toUpperCase().trim();
					if (system_param_id === current_id) {
						exist_field_required = true;
						return false; // break
					}
				});

				if (!exist_field_required) {
					required_result.success = false;
					required_result.message = FORMAT("<%=_T('The {0} parameters {1} is required.')%>", self.type, ("'" + system_param.id + "'"));
					return false; // break
				}
			});

			return required_result;
		};

		var required_result = has_all_required();
		if (!required_result.success) {
			result.message = required_result.message;
			return result;
		}

		result.success = true;
		return result;
	};

	//---------------------------------------------------------------------
	// SMS HTTP config panel
	function SMS_HTTP_Config (params)
	{
		this.owner = params.account_config;

		// El prefijo ya contiene el indicador de jQuery --> #
		this.prefix_id = params.prefix_id + "_http";
		this.url = this.prefix_id + "_url";

		this.inc_webhooks_section = this.prefix_id + "_incoming_webhooks_section";

		this.inc_webhooks_new_messages_code    = this.prefix_id + "_incoming_webhooks_new_messages";
		this.inc_webhooks_stauts_message_code    = this.prefix_id + "_incoming_webhooks_status_message";

		this.inc_web_hooks_changed_popup = this.prefix_id + "_incoming_webhooks_has_changed";
		this.inc_web_hooks_changed_new_messages = this.prefix_id + "_incoming_webhooks_has_changed_new_messages";
		this.inc_web_hooks_changed_status_message = this.prefix_id + "_incoming_webhooks_has_changed_status_message";

		this.params = params;
	/* -------------------------------------------------------------------------------------
	// Ref: #7617
	// Se deja de utilizar de forma momentanea la configuracion en TABs (entrantes y salientes)
	//
		this.tabs = null;
	*/
	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		this.inc_params_hnd = null;
		this.out_params_hnd = null;
	*/
	}

	SMS_HTTP_Config.prototype.initialize = function()
	{
	/* -------------------------------------------------------------------------------------
	// Ref: #7617
	// Se deja de utilizar de forma momentanea la configuracion en TABs (entrantes y salientes)
	//
		var prefix_id = SANITIZE_ID(this.prefix_id);

		this.tabs = new inConcert.conf_form_tab({
			parent       : this ,
			frm          : this.owner.frm,
			container_id : prefix_id + "_tabs",
			tabs_list    : {
				incoming : {
					id               : "incoming",
					name             : "<%=_T('Incoming')%>",
					tab_container_id : prefix_id + "_incoming_tab",
					selected         : true
				},
				outgoing : {
					id               : "outgoing",
					name             : "<%=_T('Outgoing')%>",
					tab_container_id : prefix_id + "_outgoing_tab"
				}
			}
		});
		this.tabs.show_tabs_container();
	*/

	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		this.inc_params_hnd = new web_parameters({
			container_prefix_id: this.prefix_id + "_incoming",
			save_btn_prefix_id : "#adm_form_campaign_accounts", // el Id del boton generico de las cuentas
			owner              : this.owner,
			type               : "incoming"
		});

		this.out_params_hnd = new web_parameters({
			container_prefix_id: this.prefix_id + "_outgoing",
			save_btn_prefix_id : "#adm_form_campaign_accounts", // el Id del boton generico de las cuentas
			owner              : this.owner,
			type               : "outgoing"
		});
	----------------------------------------------------------------------------------------*/
	};

	SMS_HTTP_Config.prototype.set_events = function()
	{
	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		this.inc_params_hnd.set_events();
		this.out_params_hnd.set_events();
	----------------------------------------------------------------------------------------*/
	};

	SMS_HTTP_Config.prototype.load = $.noop;

	SMS_HTTP_Config.prototype.empty_controls = function()
	{
		$(this.url).val("");
		$(this.inc_webhooks_section).hide();
		$(this.inc_webhooks_new_messages_code).val("");
		$(this.inc_webhooks_stauts_message_code).val("");
	};

	SMS_HTTP_Config.prototype.edit = function(account)
	{
	// incoming info

	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		// la lista de parametros
		this.inc_params_hnd.set(account.incomingConfig.mappedParameters);
	----------------------------------------------------------------------------------------*/
		var webhooks_new_messages_url = this.get_web_hooks_new_messages_url(account.id);
		$(this.inc_webhooks_new_messages_code).val(webhooks_new_messages_url);

		var webhooks_status_message_url = this.get_web_hooks_status_message_url(account.id);
		$(this.inc_webhooks_stauts_message_code).val(webhooks_status_message_url);

		$(this.inc_webhooks_section).show();
	/* -------------------------------------------------------------------------------------
	// Ref: #7617
	// Se deja de utilizar de forma momentanea la configuracion en TABs (entrantes y salientes)
	//
		this.tabs.switch_tab("incoming");
	*/

	// outgoing info
		var $url = $(this.url);
		$url.val(account.sendMessageUrl);
	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		// la lista de parametros
		this.out_params_hnd.set(account.outgoingConfig.mappedParameters);
	----------------------------------------------------------------------------------------*/
	};

	SMS_HTTP_Config.prototype.validate = function()
	{
		var is_new = this.owner.is_new();

		var result = {
			success: false,
			is_new: is_new
		};

	// Validacion INCOMING ---------------------

	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		// incoming parameters list - validation
		var response_params = this.inc_params_hnd.validate_list();
		if (!response_params.success) {
			this.tabs.switch_tab("incoming");
			this.owner.show_validation_error(response_params.$ctrl, response_params.message);
			return result;
		}
	*/

	// Validacion OUTGOING ---------------------
		// url - validation
		var $url = $(this.url);
		if (!this.owner.validate_field($url, "required", "<%=_T('URL is required.')%>")) {
	/* -------------------------------------------------------------------------------------
	// Ref: #7617
	// Se deja de utilizar de forma momentanea la configuracion en TABs (entrantes y salientes)
	//
			this.tabs.switch_tab("outgoing");
	*/
			return result;
		}
		if (!this.owner.validate_field($url, "url", "<%=_T('Please enter a valid URL.')%>")) {
	/* -------------------------------------------------------------------------------------
	// Ref: #7617
	// Se deja de utilizar de forma momentanea la configuracion en TABs (entrantes y salientes)
	//
			this.tabs.switch_tab("outgoing");
	*/
			return result;
		}

	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		// outgoing parameters list - validation
		response_params = this.out_params_hnd.validate_list();
		if (!response_params.success) {
			this.tabs.switch_tab("outgoing");
			this.owner.show_validation_error(response_params.$ctrl, response_params.message);
			return result;
		}
	*/

	/* -------------------------------------------------------------------------------------
	// Ref: #7598
	// Se deja de utilizar de forma momentanea la configuracion de parametros de las URLs (entrantes y salientes)
	//
		var account = {
		// atributos especificos de la cuenta SMS (HTTP)
			incomingConfig: {
				mappedParameters: this.inc_params_hnd.get()
			},
			outgoingConfig: {
				mappedParameters: this.out_params_hnd.get()
			},
			sendMessageUrl: $url.val()
		};
	*/

		var account = {
		// atributos especificos de la cuenta SMS (HTTP)
			sendMessageUrl: $url.val()
		};

		result.account = account;
		result.success = true;

		return result;
	};

	SMS_HTTP_Config.prototype.on_show = function(with_focus)
	{
		if (with_focus) {
			var $url = $(this.url);
			window.setTimeout(function() {
				$url.focus();
			}, 100);
		}
	};

	SMS_HTTP_Config.prototype.__can_show_webhooks_message = function()
	{
		return this.owner.is_new();
	};

	SMS_HTTP_Config.prototype.show_webhooks = function(account, callback)
	{
		callback = callback || $.noop;

		if (this.__can_show_webhooks_message()) {

			var webhooks_new_messages = this.get_web_hooks_new_messages_url(account.id);
			$(this.inc_web_hooks_changed_new_messages).text(webhooks_new_messages);

			var webhooks_status_message = this.get_web_hooks_status_message_url(account.id);
			$(this.inc_web_hooks_changed_status_message).text(webhooks_status_message);

			var $inc_web_hooks_changed_popup = $(this.inc_web_hooks_changed_popup);
			$inc_web_hooks_changed_popup
				.off("click", "input")
				.on("click", "input", function() {
					callback();
					$inc_web_hooks_changed_popup.hide();
				});
			$inc_web_hooks_changed_popup.show();
		}
		else {
			callback();
		}
	};

	SMS_HTTP_Config.prototype.get_web_hooks_new_messages_url = function(account_id)
	{
		return FORMAT("{0}/new_messages/{1}", inConcert.app.getWebSmsWebhooksUrl(), encodeURIComponent(account_id));
	};


	SMS_HTTP_Config.prototype.get_web_hooks_status_message_url = function(account_id)
	{
		return FORMAT("{0}/messages_status/{1}", inConcert.app.getWebSmsWebhooksUrl(), encodeURIComponent(account_id));
	};

	//---------------------------------------------------------------------
	// SMS SMPP config panel
	function SMS_SMPP_Config (params)
	{
		this.owner = params.account_config;

		this.server_ip = "#adm_form_campaign_accounts_sms_smpp_server_ip";
		this.server_port = "#adm_form_campaign_accounts_sms_smpp_server_port";
		this.user_name = "#adm_form_campaign_accounts_sms_smpp_user_name";
		this.pwd = "#adm_form_campaign_accounts_sms_smpp_password";
		this.bind_type = "#adm_form_campaign_accounts_sms_smpp_bind_type";
		//this.numbers = "#adm_form_campaign_accounts_sms_smpp_numbers";
		this.session_on_timeout = "#adm_form_campaign_accounts_sms_smpp_close_session_on_timeout";
		this.session_minutes = "#adm_form_campaign_accounts_sms_smpp_close_session_minutes";
		this.system_type = "#adm_form_campaign_accounts_sms_smpp_system_type";
		this.keep_alive_interval_sec = "#adm_form_campaign_accounts_sms_smpp_keep_alive_interval_sec";
		this.msg_max_length = "#adm_form_campaign_accounts_sms_smpp_msg_max_length";
		this.msg_enable_payload = "#adm_form_campaign_accounts_sms_smpp_msg_enable_payload";
		this.enable_concatenation = "#adm_form_campaign_accounts_sms_smpp_enable_concatenation";
		this.enable_submit_multi = "#adm_form_campaign_accounts_sms_smpp_enable_submit_multi";
		this.gms_7_bit_packing = "#adm_form_campaign_accounts_sms_smpp_gms_7_bit_packing";
		this.data_coding = "#adm_form_campaign_accounts_sms_smpp_data_coding";
		this.server_data_coding = "#adm_form_campaign_accounts_sms_smpp_server_data_coding";
		this.unicode_endianness = "#adm_form_campaign_accounts_sms_smpp_unicode_endianness";

		// as the protocol stands, this enum defines how long some parameters can be
		this.smpp_field_bounds = {
			MAX_SYSTEMID_LENGTH      : 16,
			MAX_PASSWORD_LENGTH      : 9,
			MAX_ADDRESS_RANGE_LENGTH : 41,
			MAX_SYSTEMTYPE_LENGTH    : 13
		};
	}

	SMS_SMPP_Config.prototype.initialize = $.noop;

	SMS_SMPP_Config.prototype.set_events = $.noop;

	SMS_SMPP_Config.prototype.empty_controls = function()
	{
		$(this.server_ip).val("");
		$(this.server_port).val("");
		$(this.user_name).val("");
		$(this.pwd).val("");
		$(this.bind_type).val("");
		//$(this.numbers).val("");
		$(this.session_on_timeout).prop("checked", false).trigger("change");
		$(this.session_minutes).val("");
		$(this.system_type).val("");
		$(this.keep_alive_interval_sec).val("");
		$(this.msg_max_length).val("");
		$(this.msg_enable_payload).prop("checked", false);
		$(this.enable_concatenation).prop("checked", false);
		$(this.enable_submit_multi).prop("checked", false);
		$(this.gms_7_bit_packing).prop("checked", false);
		$(this.data_coding).val("");
		$(this.server_data_coding).val("");
		$(this.unicode_endianness).val("");
	};

	SMS_SMPP_Config.prototype.edit = function(account)
	{
		var $ip = $(this.server_ip);
		var $port = $(this.server_port);
		var $user_name = $(this.user_name);

		this.owner.parent.frm.readonly_control($ip, true /* disabled */);
		this.owner.parent.frm.readonly_control($port, true /* disabled */);

		$ip.val(account.smsc_ip);
		$port.val(account.smsc_port);
		$user_name.val(account.username);
		$(this.pwd).val(account.password);
		$(this.bind_type).val(account.bindType);
//		$(this.numbers).val(account.nnnnnnnn);
		var timeout_seconds = parseInt(account.interactionTimeout || "0", 10);
		if (timeout_seconds) {
			$(this.session_on_timeout).prop("checked", true).trigger("change");
			$(this.session_minutes).val(timeout_seconds / 60); // lo muestro en minutos
		}
		else {
			$(this.session_on_timeout).prop("checked", false).trigger("change");
		}
		$(this.system_type).val(account.systemType);
		$(this.keep_alive_interval_sec).val(account.keepAliveTime);
		$(this.msg_max_length).val(account.maxMessageLength);
		$(this.msg_enable_payload).prop("checked", account.msgPayloadAllowed.to_boolean());
		$(this.enable_concatenation).prop("checked", account.msgConcatenationAllowed.to_boolean());
		$(this.enable_submit_multi).prop("checked",  account.submitMultiAllowed.to_boolean());
		$(this.gms_7_bit_packing).prop("checked",  account.gsm7bitPacking.to_boolean());
		$(this.data_coding).val(account.defaultDataCoding);
		$(this.server_data_coding).val(account.serverDataCoding);

		var unicode_endianness = account.unicodeEndianness;
		if (unicode_endianness.length > 0) {
			if (account.unicodeEndianness.to_boolean()) {
				unicode_endianness = "LittleEndian";
			} else {
				unicode_endianness = "BigEndian";
			}
		}
		$(this.unicode_endianness).val(unicode_endianness);

		window.setTimeout(function() {
			$user_name.focus();
		}, 200);
	};

	SMS_SMPP_Config.prototype.validate = function()
	{
		var is_new = this.owner.is_new();

		var result = {
			success: false,
			is_new: is_new
		};

		// server ip - validation
		var $ip = $(this.server_ip);
		if (!this.owner.validate_field($ip, "required", "<%=_T('Server IP is required.')%>")) {
			return result;
		}
		if (!this.owner.validate_field($ip, "domain", "<%=_T('Server IP must be a valid domain name.')%>")) {
			return result;
		}

		// server port - validation
		var $port = $(this.server_port);
		if (!this.owner.validate_field($port, "required", "<%=_T('Server Port is required.')%>")) {
			return result;
		}
		if (!this.owner.validate_field($port, "number", "<%=_T('Server Port must be a number.')%>")) {
			return result;
		}
		var options = {between: {from: 1, to: 65535}};
		var msg_err = FORMAT("<%=_T('Server Port out of range. Please enter Server Port value between {0} and {1}.')%>", options.between.from, options.between.to);
		if (!this.owner.validate_field($port, "range", msg_err, options)) {
			return result;
		}

		// user_name - validation
		var $user_name = $(this.user_name);
		if (!this.owner.validate_field($user_name, "required", "<%=_T('User Name is required.')%>")) {
			return result;
		}
		options = {max_length: this.smpp_field_bounds.MAX_SYSTEMID_LENGTH};
		msg_err = FORMAT("<%=_T('Very long User Name. The maximum allowed size is {0} characters.')%>", options.max_length);
		if (!this.owner.validate_field($user_name, "string_max_length", msg_err, options)) {
			return result;
		}

		// password - validation
		var $pwd = $(this.pwd);
		if (!this.owner.validate_field($pwd, "required", "<%=_T('Password is required.')%>")) {
			return result;
		}
		options = {max_length: this.smpp_field_bounds.MAX_PASSWORD_LENGTH};
		msg_err = FORMAT("<%=_T('Very long Password. The maximum allowed size is {0} characters.')%>", options.max_length);
		if (!this.owner.validate_field($pwd, "string_max_length", msg_err, options)) {
			return result;
		}

		// bind type - validation
		var $bind_type = $(this.bind_type);
		if (!this.owner.validate_field($bind_type, "required", "<%=_T('Bind Type is required.')%>")) {
			return result;
		}

		// close session on timeout - validation
		var interaction_timeout_min = 0;
		var $session_on_timeout = $(this.session_on_timeout);
		if ($session_on_timeout.prop("checked")) {
			var $session_minutes = $(this.session_minutes);
			if (!this.owner.validate_field($session_minutes, "required", "<%=_T('Close Session Timeout is required.')%>")) {
				return result;
			}
			if (!this.owner.validate_field($session_minutes, "number", "<%=_T('Close Session Timeout must be a number.')%>")) {
				return result;
			}
			interaction_timeout_min = parseInt($session_minutes.val(), 10);
		}

		// system_type - validation
		var $system_type = $(this.system_type);
		options = {max_length: this.smpp_field_bounds.MAX_SYSTEMTYPE_LENGTH};
		msg_err = FORMAT("<%=_T('Very long System Type. The maximum allowed size is {0} characters.')%>", options.max_length);
		if (!this.owner.validate_field($system_type, "string_max_length", msg_err, options)) {
			return result;
		}

		// keep alive interval - validation
		var $keep_alive_interval_sec = $(this.keep_alive_interval_sec);
		if (!this.owner.validate_field($keep_alive_interval_sec, "number", "<%=_T('Keep Alive Interval must be a number.')%>")) {
			return result;
		}

		// max message length - validation
		var $msg_max_length = $(this.msg_max_length);
		if (!this.owner.validate_field($msg_max_length, "number", "<%=_T('Max Message Length must be a number.')%>")) {
			return result;
		}
		options = {between: {from: 1, to: 254}};
		msg_err = FORMAT("<%=_T('Max Message Length out of range. Please enter Max Message Length value between {0} and {1}.')%>", options.between.from, options.between.to);
		if (!this.owner.validate_field($msg_max_length, "range", msg_err, options)) {
			return result;
		}

		var $data_coding = $(this.data_coding);
		var $server_data_coding = $(this.server_data_coding);

		var default_data_coding = $data_coding.val();
		var server_data_coding = $server_data_coding.val();
		if (default_data_coding === "-1") { // server default
			default_data_coding = "0"; // reset to zero
		} else { // set server config to -1, so we know this is gsm7 and not server default
			server_data_coding = "-1";
		}

		var $msg_enable_payload = $(this.msg_enable_payload);
		var $enable_concatenation = $(this.enable_concatenation);
		var $enable_submit_multi = $(this.enable_submit_multi);
		var $gms_7_bit_packing = $(this.gms_7_bit_packing);
		var $unicode_endianness = $(this.unicode_endianness);
		var unicode_endianness = $unicode_endianness.val();

		var account = {
		// atributos especificos de la cuenta SMS (SMPP)
			smsc_ip            : $ip.val(),
			smsc_port          : $port.val(),
			username           : $user_name.val(),
			password           : $pwd.val(),
			bindType           : $bind_type.val(),
//			address            : $user_name.val(),
			interactionTimeout : interaction_timeout_min * 60, // lo convierto a segundos
			systemType         : $system_type.val(),
			keepAliveTime      : $keep_alive_interval_sec.val(),
			defaultDataCoding  : default_data_coding,
			serverDataCoding   : server_data_coding,
			maxMessageLength   : $msg_max_length.val(),
			msgPayloadAllowed  : $msg_enable_payload.prop("checked") ? 1 : 0,
			msgConcatenationAllowed : $enable_concatenation.prop("checked") ? 1 : 0,
			submitMultiAllowed : $enable_submit_multi.prop("checked") ? 1 : 0,
			gsm7bitPacking     : $gms_7_bit_packing.prop("checked") ? 1 : 0,
			unicodeEndianness  : unicode_endianness,
			// deprecated code begins
			bigEndianUnicode   : unicode_endianness.toUpperCase() === "BIGENDIAN" ? 0 : 1
			// deprecated code ends
		};

		result.account = account;
		result.success = true;

		return result;
	};

	SMS_SMPP_Config.prototype.load = function(params)
	{
		var self = this;

		// 1 - Obtengo los SMS BIND TYPES e incremento en 1 el contador de request
		var $bind_type = $(this.bind_type);
		params.pending_requests++;

		inConcert.app.loadSMSBindTypes(function(success, rows ) {
			if (!success) {
				var message = "<%=_T('Error retrieving SMS bind types.')%>";
				self.owner.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// la lleno a la lista de SMS BIND TYPES
				self.owner.parent.fill_combo(
					$bind_type,
					true, // is_blank_first_item
					rows,
					"id", // id
					"description", // description
					false //sorted
				);
			}
			params.on_complete_request();
		});

		// 2 - Obtengo los SMS DATA CODING Y LOS SMS SERVER DATA CODING e incremento en 1 el contador de request
		var $data_coding = $(this.data_coding);
		var $server_data_coding = $(this.server_data_coding);
		params.pending_requests++;

		inConcert.app.loadSMSDataCoding(function(success, rows ) {
			if (!success) {
				var message = "<%=_T('Error retrieving SMS data coding.')%>";
				self.owner.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// 2.1 la lleno a la lista de SMS DATA CODING
				self.owner.parent.fill_combo(
					$data_coding,
					true, // is_blank_first_item
					rows,
					"code", // id
					"description", // description
					false //sorted
				);
				// 2.2 la lleno a la lista de SMS SERVER DATA CODING
				self.owner.parent.fill_combo(
					$server_data_coding,
					true, // is_blank_first_item
					rows,
					"code", // id
					"description", // description
					false, //sorted
					// Evalua si el item se debe agregar o no
					function(_, item) {
						if (item.code !== -1) { // code for 'Server Default' (defined above)
							return true;
						}
						return false;
					}
				);
			}
			params.on_complete_request();
		});

		// 3 - Obtengo los SMS UNICODE ENDIANNESS e incremento en 1 el contador de request
		var $unicode_endianness = $(this.unicode_endianness);
		params.pending_requests++;

		inConcert.app.loadSMSUnicodeEndianess(function(success, rows ) {
			if (!success) {
				var message = "<%=_T('Error retrieving SMS Unicode endianness.')%>";
				self.owner.parent.show_status_message(message, "Error", 5000 /*timeout_ms*/ );
			}
			else {
				// la lleno a la lista de SMS UNICODE ENDIANNESS
				self.owner.parent.fill_combo(
					$unicode_endianness,
					true, // is_blank_first_item
					rows,
					"id", // id
					"description", // description
					false //sorted
				);
			}
			params.on_complete_request();
		});
	};

	SMS_SMPP_Config.prototype.on_show = function(with_focus)
	{
		if (with_focus) {
			var $ip = $(this.server_ip);
			window.setTimeout(function() {
				$ip.focus();
			}, 100);
		}
	};

	//---------------------------------------------------------------------
	// frm sms account edition
	function SMSAccountPanel(params)
	{
		/* jshint validthis: true*/
		this.prefix_id = "adm_form_campaign_accounts_sms_";
		var success = SMSAccountPanel.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.messages_class = null; // sms no tiene mensajes automaticos ya que da problemas.
		this.container_id = "#adm_form_campaign_accounts_sms_panel";

		params.account_config = this;
		params.prefix_id = this.container_id;

		this.http_hnd = new SMS_HTTP_Config(params);
		this.smpp_hnd = new SMS_SMPP_Config(params);

		this.name = "#adm_form_campaign_accounts_sms_name";

		this.http_config = "#adm_form_campaign_accounts_sms_http_config";
		this.http_config_2 = "#adm_form_campaign_accounts_sms_http_config_2";
		this.smpp_config = "#adm_form_campaign_accounts_sms_smpp_config";
		this.inconcert_config = "#adm_form_campaign_accounts_sms_inconcert_config";
		this.another_config = "#adm_form_campaign_accounts_sms_http_another_config";

		this.account_type = "#adm_form_campaign_accounts_sms_account_type";
		this.language = "#adm_form_campaign_accounts_sms_language";
		this.distribution = "#adm_form_campaign_accounts_sms_distribution";
		this.priority = "#adm_form_campaign_accounts_sms_priority";

		this.attention_levels_container = "#adm_form_campaign_accounts_sms_attention_levels_config";
		this.ticket_management_container = "#adm_form_campaign_accounts_sms_tickets_mng_panel";
		this.contact_management_container = "#adm_form_campaign_accounts_sms_contact_mng_panel";
		this.thresholds_container = "#adm_form_campaign_accounts_sms_thresholds_panel";

		this.account_save_id = "#adm_form_campaign_accounts_save";
		this.tagline_new      = "<%=_T('New SMS account.')%>";
		this.tagline_edit     = "<%=_T('Edit SMS account {0}.')%>";
		this.tagline_readonly = "<%=_T('SMS account {0}.')%>";
	}

	inConcert.Utils.inherit( SMSAccountPanel, inConcert.adm_form_campaigns_section_accounts_base_panel) ;

	if ( typeof inConcert.Administration.Campaigns.SMSAccountPanel !== "function" ) {
		inConcert.Administration.Campaigns.SMSAccountPanel = SMSAccountPanel;
	}

	SMSAccountPanel.prototype.has_qna_maker       = function() {return true;};
	SMSAccountPanel.prototype.has_flow_management = function() {return true;};
	SMSAccountPanel.prototype.has_flow_inactivity = function() {return true;};

	SMSAccountPanel.prototype.initialize = function()
	{
		this.http_hnd.initialize();
		this.smpp_hnd.initialize();
		SMSAccountPanel.uber.initialize.call(this);
	};

	// SMSAccountPanel.prototype.dispose = function()
	// {
		// SMSAccountPanel.uber.dispose.call( this );
		
	// };

	/**
	 * Initializes thresholds management
	 *
	 * @public
	 */
	SMSAccountPanel.prototype.initialize_thresholds = function()
	{
		// build thresholds panel
		SMSAccountPanel.uber.initialize_thresholds.call( this,
			"SMS",
			{
				parent    : this.parent,
				prefix_id : "adm_form_campaign_accounts_sms_thresholds"
			}
		);
	};

	/**
	 * Initializes contact management
	 *
	 * @public
	 */
	SMSAccountPanel.prototype.initialize_contact_mng = function(){
		// build contact management panel
		SMSAccountPanel.uber.initialize_contact_mng.call(this,
			{
				type         : "SMS"                                              ,
				parent       : this                                               ,
				auto_add_type: "BOTH"                                             , // incoming y outgoing
				container_id : "adm_form_campaign_accounts_sms_contact_mng_panel" ,
				prefix_id    : "adm_form_campaign_accounts_sms_contact_mng"
			}
		);
	};

	SMSAccountPanel.prototype.initialize_flows_mng = function()
	{
		// build flows designer management panel
		SMSAccountPanel.uber.initialize_flows_mng.call(
			this,
			{
				type         : "SMS"                                                    ,
				parent       : this                                                     ,
				container_id : "adm_form_campaign_accounts_sms_flows_designer_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_sms_flows_designer_mng"
			}
		);
	};

	/**
	 * Initializes ticket management
	 *
	 * @public
	 */
	SMSAccountPanel.prototype.initialize_ticket_emitter = function(){
		// build ticket management section
		SMSAccountPanel.uber.initialize_ticket_emitter.call(this,
			{
				type         : "SMS"                                              ,
				parent       : this                                               ,
				auto_add_type: "BOTH"                                             , // incoming y outgoing
				container_id : "adm_form_campaign_accounts_sms_tickets_mng_panel" ,
				prefix_id    : "adm_form_campaign_accounts_sms_tickets_mng"
			}
		);
	};

	SMSAccountPanel.prototype.initialize_qna_maker_mng = function()
	{
		// build qna_maker management panel
		SMSAccountPanel.uber.initialize_qna_maker_mng.call(
			this,
			{
				type         : "SMS"                                               ,
				parent       : this                                                ,
				container_id : "adm_form_campaign_accounts_sms_qna_maker_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_sms_qna_maker_mng"
			}
		);
	};

	SMSAccountPanel.prototype.initialize_skills = function()
	{
		SMSAccountPanel.uber.initialize_skills.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_sms_skills_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION"
			}
		);
	};

	SMSAccountPanel.prototype.initialize_attention_levels = function()
	{
		SMSAccountPanel.uber.initialize_attention_levels.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_sms_attention_levels_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION",
				proxy_type   : "SMS"
			}
		);
	};

	SMSAccountPanel.prototype.load = function( callback )
	{
		var self = this;
		callback = callback || $.noop;

		var info;
		info = {
			pending_requests: 0,// variable que lleva en contador de request pendientes
			on_complete_request: function() {
				info.pending_requests--;
				if (info.pending_requests <= 0) {
					callback();
				}
			}
		};

		// 1 - Los config types (HTTP y SMPP)
		var $account_type = $(this.account_type);
		info.pending_requests++;

		window.setTimeout(function() {
/*
*****************************************************************************
Ref #7598: Se deja una unica opcion (HTTP) en el combo selector de tipo de configuracion de SMS (HTTP o SMPP)
           ya que por el momento unicamente soportamos HTTP.

           Ademas no permitimos que el combo tenga un item en blanco, ya que con una unica opcion siempre tiene que quedar seleccionado HTTP.
*****************************************************************************
*/

			var list = [
				{id: "HTTP", description: "<%=_T('HTTP')%>"}//,
//				{id: "SMPP", description: "<%=_T('SMPP')%>"}
			];
			// la lleno a la lista de tipo de configuracion HTTP o SMPP
			self.parent.fill_combo(
				$account_type,
				false, // is_blank_first_item
				list,
				"id", // id
				"description", // description
				false //sorted
			);
			info.on_complete_request();
		});

		this.http_hnd.load(info);
		this.smpp_hnd.load(info);
	};

	/**
	 * Called when the user enter to account edition
	 *
	 * @public
	 */
	SMSAccountPanel.prototype.empty_controls = function()
	{
		SMSAccountPanel.uber.empty_controls.call(this);

		$(this.name).val("");
/*
*****************************************************************************
Ref #7598:
Como ahora solo permitimos la configuracion HTTP, tengo que dejar seleccionada la misma.
Cuando se active la opcion SMPP, debemos dejar la opcion en blanco ""
*****************************************************************************
*/
		var $account_type = $(this.account_type);
		var account_type = "HTTP"; // ""
		$account_type.val(account_type);
		this.__toggle_config(account_type, false);
//-----------------------------
		this.parent.frm.readonly_control($account_type, false /* disabled */, true /* required */);

		this.http_hnd.empty_controls();
		this.smpp_hnd.empty_controls();
	};

	/**
	 * Called when the user enter to account edition
	 *
	 * @public
	 */
	SMSAccountPanel.prototype.edit = function(account)
	{
		SMSAccountPanel.uber.edit.call( this, account );
		if ( !this.current_account ) {
			return;
		}

		$(this.name).val(this.current_account.name);
		var $account_type = $(this.account_type);
		$account_type.val(this.current_account.accountType);
		this.__toggle_config($account_type.val(), false);
		this.parent.frm.readonly_control($account_type, true /* disabled */);

		if (this.current_account.accountType === "HTTP") {
			this.http_hnd.edit(account);
		}
		else if (this.current_account.accountType === "SMPP") {
			this.smpp_hnd.edit(account);
		}
		else {
			throw("SMSAccountPanel.prototype.edit. Unrecognized SMS accountType " + this.current_account.accountType);
		}

	};

	SMSAccountPanel.prototype.get_account_name = function()
	{
		return this.current_account.name;
	};


	/**
	 * Validates SMS account fields.
	 *
	 * @todo Validate and save should be separated actions
	 *
	 * @public
	 *
	 * @return {Object}  result
	 * @return {Boolean} result.success
	 * @return {Boolean} result.is_new
	 *
	 * @return {Object}  [result.account]
	 * @return {String}  [result.account.id]
	 * @return {String}  [result.account.proxyType]
	 * @return {String}  [result.account.name]
	 * @return {String}  [result.account.CCAlgorithm]
	 *
	 * @return {String}  [result.error_message]
	 */
	SMSAccountPanel.prototype.validate = function()
	{
		var is_new = this.is_new();

		var result = {
			success: false,
			is_new: is_new
		};

		this.hide_marked_errors();

		// NAME - validation
		var $name = $(this.name);
		if (!this.validate_field($name, "required", "<%=_T('Account name is required.')%>")) {
			return result;
		}
		if (!this.validate_field($name, "alpha", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Account Name.')%>")) {
			return result;
		}

		// account type - validation
		var $account_type = $(this.account_type);
		if (!this.validate_field($account_type, "required", "<%=_T('Account Type is required.')%>")) {
			return result;
		}

		// DISTRIBUTION - validation
		var $distribution = $(this.distribution);
		if (!this.validate_field($distribution, "required", "<%=_T('Distribution is required.')%>")) {
			return result;
		}

		// PRIORITY - validation
		var $priority = $(this.priority);
		var has_att_levels = this.attention_levels_handle.count_selected() > 0;
		if (!has_att_levels && $priority.val().trim().length > 0) {
			var range = { between: { from: 0, to: 99 } }; // range attention_level value validation
			if (!this.validate_field($priority, "range", FORMAT("<%=_T('Account priority value out of range. Please enter account priority value between {0} and {1}.')%>", range.between.from, range.between.to ), range )) {
				return result;
			}
		}

		// LANGUAGE - validation
		var $language = $(this.language);
		if (!this.validate_field($language, "required", "<%=_T('Language is required.')%>")) {
			return result;
		}

		var account_type = $account_type.val();
		if (account_type === "HTTP") {
			result = this.http_hnd.validate();
		}
		else {
			result = this.smpp_hnd.validate();
		}

		if (!result.success) {
			return result;
		}

		result.success = false;
		var account = result.account;

		// valido los skills ----------
		var result_skills = this.validate_skills();
		if ( !result_skills.success ) {
			this.show_validation_error( result_skills.$ctrl, result_skills.message );
			return result;
		}

		// valido los attention levels ----------
		var result_attention_levels = this.validate_attention_levels();
		if ( !result_attention_levels.success ) {
			this.show_validation_error(
				result_attention_levels.$ctrl,
				result_attention_levels.message,
				false, //timeout_ms
				true, //scrolling
				result_attention_levels.show_custom_button
			);
			return result;
		}

		// validate ticket configuration
		var result_ticket_emitter = this.validate_ticket_emitter();
		if (!result_ticket_emitter.success) {
			this.show_validation_error( result_ticket_emitter.$ctrl, result_ticket_emitter.error_message );
			return result;
		}

		// valido los contact mng ----------
		var result_contact_mng = this.validate_contact_mng();
		if ( !result_contact_mng.success ) {
			this.show_validation_error( result_contact_mng.$ctrl, result_contact_mng.error_message );
			return result;
		}

		// valido los flows mng ----------
		var result_flows_mng = this.validate_flows_mng();
		if ( !result_flows_mng.success ) {
			this.show_validation_error( result_flows_mng.$ctrl, result_flows_mng.error_message );
			return result;
		}

		// valido los qna maker mng ----------
		var result_qna_maker_mng = this.validate_qna_maker_mng();
		if ( !result_qna_maker_mng.success ) {
			this.show_validation_error( result_qna_maker_mng.$ctrl, result_qna_maker_mng.error_message );
			return result;
		}

		// valido los messages de la account ----------
		var result_messages = this.validate_messages();
		if ( !result_messages.success ) {
			this.show_validation_error( undefined, result_messages.error_message );
			return result;
		}

		// valido los thresholds ----------
		var result_th = this.validate_thresholds();
		if ( !result_th.success ) {
			this.show_validation_error( result_th.$ctrl, result_th.error_message );
			return result;
		}

		var name = $name.val();
		var account_id;
		if (is_new) {
			var guid = inConcert.Utils.generateGuid();
			var campaign = this.parent.frm.get_entity_instance();
			account_id = "SMS_" + campaign.Id + "_" + guid;
		}
		else {
			account_id = this.current_account.id;
		}

		$.extend(true, account, {
		// atributos comunes entre diferentes tipos de cuentas
			id                 : account_id,
			proxyType          : "SMS",
			uid                : name,
			name               : name,
			accountType        : account_type,
			CCAlgorithm        : $distribution.val(),
			language           : $language.val(),
			TicketEmitter      : result_ticket_emitter.result,
			Skills             : this.skills_handle.get(),
			Priority           : $priority.val(),
			AttentionLevels    : this.attention_levels_handle.get(),
			GUI                : this.get_gui_config(),
			ActionOnAcdWaitTimeout : result_th.ActionOnAcdWaitTimeout,
			InactivityTimeout : result_th.InactivityTimeout,
			ignoreAgentAssignedFromReOpen : $(this.ignoreAgent).prop("checked")? "1" : "0"
		});

		this.contact_mng_instance.attach_data(account);
		if (this.flow_mng_instance) {
			this.flow_mng_instance.attach_data( account );
		}
		if (this.qna_maker_mng_instance) {
			this.qna_maker_mng_instance.attach_data(account);
		}

		result.account = account;
		result.success = true;

		return result;
	};

	SMSAccountPanel.prototype.set_events = function()
	{
		SMSAccountPanel.uber.set_events.call(this);
		var self = this;

		var timeout = null;
		$(this.account_type)
			.off("change")
			.on({
				change: function() {
					var $cbo = $(this);
					window.clearTimeout(timeout);
					timeout = null;
					window.setTimeout(function() {
						var account_type = $cbo.val();
						self.__toggle_config(account_type, true);
					}, 100);
				}
			});

		this.http_hnd.set_events();
		this.smpp_hnd.set_events();
	};

	SMSAccountPanel.prototype.__toggle_config = function(account_type, with_focus)
	{
		var $http_config = $(this.http_config);
		var $http_config_2 = $(this.http_config_2);
		var $smpp_config = $(this.smpp_config);
		var $inconcert_config = $(this.inconcert_config);
		var $another_config = $(this.another_config);

		if (account_type === "HTTP") {
			$smpp_config.hide();
			$http_config.show();
			$http_config_2.show();
			$inconcert_config.show();
			$another_config.show();
			this.http_hnd.on_show(with_focus);
		}
		else if (account_type === "SMPP") {
			$http_config.hide();
			$http_config_2.hide();
			$smpp_config.show();
			$inconcert_config.show();
			$another_config.show();
			this.smpp_hnd.on_show(with_focus);
		}
		else {
			$http_config.hide();
			$http_config_2.hide();
			$smpp_config.hide();
			$inconcert_config.hide();
			$another_config.hide();
		}
	};

	SMSAccountPanel.prototype.on_show = function()
	{
		SMSAccountPanel.uber.on_show.call(this);

		var $account_type = $(this.account_type);
		var is_new = this.is_new();
		if (is_new) {
			this.parent.frm.readonly_control($account_type, false /* disabled */, true /* required */);
		}
		else {
			this.parent.frm.readonly_control($account_type, true /* disabled */);
		}
		$(this.name).focus();
	};

	SMSAccountPanel.prototype.show_message_after_save = function(account, callback = $.noop)
	{
		if ($(this.account_type).val() === "HTTP") {
			this.http_hnd.show_webhooks(account, callback);
		}
		else {
			callback();
		}
	};

}());
