/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */
 
/* global $, inConcert */
 
if (!this.inConcert) {
	this.inConcert = {};
}

// try improve namespacing a bit
if ( !this.inConcert.Administration ) {
	this.inConcert.Administration = {};
}

if ( !this.inConcert.Administration.Campaigns ) {
	this.inConcert.Administration.Campaigns = {};
}

(function () {

	"use strict";

	const format = inConcert.Utils.format;

	const AGENT_NOANSWER_MIN_SECCONDS = 30;
	const AGENT_NOANSWER_MAX_SECCONDS = 1800;

	var mark_chk = function( ctrl, checked ) { $( ctrl ).prop( "checked", checked ); };

	var get_chk_bool_to_string  = function( chk_id ) {
		var $chk = $( chk_id );
		if ( $chk.length === 0 ) {
			return undefined;
		}
		var checked = $chk.prop("checked");
		return Number( checked ).toString();
	};

	//---------------------------------------------------------------------
	// frm webchat account edition
	function webchat_account_panel(params)
	{
		/* jshint validthis: true*/
		var self = this;
		this.prefix_id = "adm_form_campaign_accounts_webchat_";
		var success = webchat_account_panel.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		this.container_id                  = "#adm_form_campaign_accounts_webchat_panel";
		// controles
		this.name                          = "#adm_form_campaign_accounts_webchat_name";
/*
 * (***) De momento el autochat no se utiliza, queda comentado.
 */
/*
		this.autochat                      = "#adm_form_campaign_accounts_webchat_autochat";
		this.autochat_time                 = "#adm_form_campaign_accounts_webchat_autochat_time";
*/
		this.annouce                       = "#adm_form_campaign_accounts_webchat_annouce"                             ;
		this.go_chat                       = "#adm_form_campaign_accounts_webchat_gochat"                              ;
		this.bot_name                      = "#adm_form_campaign_accounts_webchat_bot_name"                            ;
		this.distribution                  = "#adm_form_campaign_accounts_webchat_distribution"                        ;
		this.language                      = "#adm_form_campaign_accounts_webchat_language"                            ;
		this.priority                      = "#adm_form_campaign_accounts_webchat_priority"                            ;
		this.tracking                      = "#adm_form_campaign_accounts_webchat_tracking"                            ;
		this.tracking_code                 = "#adm_form_campaign_accounts_webchat_tracking_code"                       ;
		this.tracking_disclaimer           = "#adm_form_campaign_accounts_webchat_tracking_disclaimer"                 ;
		
		// screen recording
		this.screen_recording_container    = "#adm_form_campaign_accounts_webchat_screen_recording_container"          ;
		this.screen_recording              = "#adm_form_campaign_accounts_webchat_screen_recording"                    ;
		this.screen_recording_percentage   = "#adm_form_campaign_accounts_webchat_screen_recording_percentage"         ;

		//iframe tweety
		// snippet
		this.tweety_app_name               = "#adm_form_campaign_accounts_webchat_tweety_app_name"                     ;
		this.tweety_info                   = "#adm_form_campaign_accounts_webchat_tweety_info"                         ;

		this.snippet_code                  = "#adm_form_campaign_accounts_webchat_snippet"                             ;
		this.snippet_param_list            = "#adm_form_campaign_accounts_webchat_snippet_parameters"                  ;
		this.snippet_param_new             = "#adm_form_campaign_accounts_webchat_snippet_new_parameter"               ;
		this.snippet_param_popup           = "#adm_form_campaign_accounts_webchat_snippet_popup_parameters"            ;
		this.snippet_param_control_id      = "#adm_form_campaign_accounts_webchat_snippet_param_control_id"            ;
		this.snippet_param_type            = "#adm_form_campaign_accounts_webchat_snippet_param_type"                  ;
		this.snippet_param_alias           = "#adm_form_campaign_accounts_webchat_snippet_param_alias"                 ;
		this.snippet_param_hidden          = "#adm_form_campaign_accounts_webchat_snippet_param_hidden"                ;
		this.snippet_param_create          = "#adm_form_campaign_accounts_webchat_snippet_param_create"                ;
		this.snippet_param_create_continue = "#adm_form_campaign_accounts_webchat_snippet_param_create_and_continue"   ;
		this.snippet_param_cancel          = "#adm_form_campaign_accounts_webchat_snippet_param_cancel"                ;
		this.snippet_param_message         = "#adm_form_campaign_accounts_webchat_snippet_popup_message"               ;
		this.snippet_message               = "#adm_form_campaign_accounts_webchat_snippet_has_changed"                 ;

		this.triggers_list                 = "#adm_form_campaign_accounts_webchat_triggers"                            ;
		this.triggers_new                  = "#adm_form_campaign_accounts_webchat_triggers_new"                        ;
		this.triggers_popup_ctrl           = "#adm_form_campaign_accounts_webchat_triggers_popup"                      ;
		this.triggers_type                 = "#adm_form_campaign_accounts_webchat_triggers_type"                       ;
		this.triggers_regex                = "#adm_form_campaign_accounts_webchat_triggers_regex"                      ;
		this.triggers_regex_test           = "#adm_form_campaign_accounts_webchat_triggers_regex_test"                 ;
		this.triggers_timeout              = "#adm_form_campaign_accounts_webchat_triggers_timeout"                    ;
		this.triggers_open                 = "#adm_form_campaign_accounts_webchat_triggers_open"                       ;
		this.triggers_create               = "#adm_form_campaign_accounts_webchat_triggers_create"                     ;
		this.triggers_create_continue      = "#adm_form_campaign_accounts_webchat_triggers_create_and_continue"        ;
		this.triggers_cancel               = "#adm_form_campaign_accounts_webchat_triggers_cancel"                     ;
		this.triggers_popupmessage         = "#adm_form_campaign_accounts_webchat_triggers_popup_message"              ;

		this.window_type                   = "#adm_form_campaign_accounts_webchat_window_type"                         ;
		this.start_button                  = "#adm_form_campaign_accounts_webchat_start_button"                        ;
		this.button_id                     = "#adm_form_campaign_accounts_webchat_button_id"                           ;

		this.google_panel                  = "#adm_form_campaign_accounts_webchat_google_panel"                        ;
		this.google_enabled                = "#adm_form_campaign_accounts_webchat_google_enabled"                      ;
		this.google_key                    = "#adm_form_campaign_accounts_webchat_google_key"                          ;
		this.google_bySections             = "#adm_form_campaign_accounts_webchat_google_bysection"                    ;
		
		this.outHours_process              = "#adm_form_campaign_accounts_webchat_flows_designer_mng_flows_process_out_of_schedule";

		this.outHours_panel                = "#adm_form_campaign_accounts_webchat_outHours_panel"                      ;
		this.outHours_enabled              = "#adm_form_campaign_accounts_webchat_outHours_enabled"                    ;
		this.outHours_campaign             = "#adm_form_campaign_accounts_webchat_outHours_campaign"                   ;
		this.outHours_account              = "#adm_form_campaign_accounts_webchat_outHours_account"                    ;

		this.check_active_agent_row        = "#adm_form_campaign_accounts_webchat_check_active_agents_row"             ;
		this.check_active_agent            = "#adm_form_campaign_accounts_webchat_check_active_agents"                 ;

		this.on_agent_noanswer_enabled              = "#adm_form_campaign_accounts_webchat_on_agent_noanswer_enabled"              ;
		this.on_agent_noanswer_timeout_container    = "#adm_form_campaign_accounts_webchat_on_agent_noanswer_timeout_container"    ;
		this.on_agent_noanswer_timeout              = "#adm_form_campaign_accounts_webchat_on_agent_noanswer_timeout"              ;
		
		this.tagline_new                   = "<%=_T('New web chat account.')%>";
		this.tagline_edit                  = "<%=_T('Edit web chat account {0}.')%>";
		this.tagline_readonly              = "<%=_T('Webchat account {0}.')%>";

		this.messages_class                = inConcert.adm_form_campaigns_webchat_account_messages;

		this.tweety_webchat_projects = null;
		this.default_project_id = "chat{9CA752E9-3BA3-4FEB-931D-3E61734151D8}";
		this.current_snippet = null;
		this.parameter_editing = null;

		this.snippet_parameters_types = {
			ID:     { id: "ID"     , description: "<%=_T('Id')%>"     , has_alias: false } ,
			NAME:   { id: "NAME"   , description: "<%=_T('Name')%>"   , has_alias: false } ,
			PHONE:  { id: "PHONE"  , description: "<%=_T('Phone')%>"  , has_alias: false } ,
			EMAIL:  { id: "EMAIL"  , description: "<%=_T('E-mail')%>" , has_alias: false } ,
			CUSTOM: { id: "CUSTOM" , description: "<%=_T('Custom')%>" , has_alias: true  }
		};

		this.trigger_types = {
			time:   { id: "time"     , description: "<%=_T('Time on Page')%>"            }
		};

		this.parameters_popup = new inConcert.PopupWindow({
			ownerId: "adm_form_campaign_accounts_webchat_snippet_popup_parameters", // container id
			eventName: "campaign_accounts_parameters", // evento click personalizado
			callbacks: {
				onClose: function(){
					self.hide_popup_parameters();
				}
			}
		});

		this.triggers_popup = new inConcert.PopupWindow({
			ownerId: "adm_form_campaign_accounts_webchat_triggers_popup", // container id
			eventName: "campaign_accounts_triggers", // evento click personalizado
			callbacks: {
				onClose: function(){
					self.hide_popup_triggers();
				}
			}
		});

		return true;
	}

	inConcert.Utils.inherit( webchat_account_panel, inConcert.adm_form_campaigns_section_accounts_base_panel );

	if ( typeof inConcert.Administration.Campaigns.WebChatAccountPanel !== "function" ) {
		inConcert.Administration.Campaigns.WebChatAccountPanel = webchat_account_panel;
	}

	webchat_account_panel.prototype.has_qna_maker       = function() {return true;};
	webchat_account_panel.prototype.has_flow_management = function() {return true;};

	webchat_account_panel.prototype.initialize = function()
	{
		webchat_account_panel.uber.initialize.call(this);
		this.current_snippet = null;
		this.initialize_on_agent_noanswer();
		this.generate_token();
		this.fill_parameters_types();
		this.fill_triggers_types();
		this.fill_combo_tweety_webchats();
		this.fill_combo_webContact_campaigns();
		if(!inConcert.app.getAgentScreenServiceEnabled())
		{
			$(this.screen_recording_container).hide();
		}
		else
		{
			$(this.screen_recording_container).show();
			this.fill_screen_recording_percentage();
		}
		$(this.outHours_campaign).change();
		this.disable_tweety_chats();
		$(this.google_key).prop("disabled", true);
		$(this.outHours_enabled)
			.prop("checked", false)
			.change();
		
		this.init_check_active_agents();
	};
	
	webchat_account_panel.prototype.initialize_on_agent_noanswer = function()
	{
		$(this.on_agent_noanswer_enabled)
			.prop("checked", false)
			.change();
	};

	webchat_account_panel.prototype.init_check_active_agents = function () {
		const self = this;
		$(this.check_active_agent).prop("checked", false);
		$(this.check_active_agent).prop("disabled", true);
		$(this.flow_mng_instance.flows_process + "_on_schedule")
			.off("change")
			.on("change", function () {
				if ($(self.distribution).val() !== "QUEUED") {
					if ($(this).val() !== "") {
						$(self.check_active_agent).prop("disabled", true);
						$(self.check_active_agent).prop("checked", false);
					}
					else {
						$(self.check_active_agent).prop("disabled", false);
					}
				}
			});
		$(this.distribution)
			.off("change")
			.on("change", function () {
				if ($(this).val() !== "QUEUED" && $(self.flow_mng_instance.flows_process + "_on_schedule").val() === "") {
					$(self.check_active_agent).prop("disabled", false);
				}
				else {
					$(self.check_active_agent).prop("disabled", true);
					$(self.check_active_agent).prop("checked", false);
				}
				const distribution = $(this).val();
				const answer_time_checked = $( "#adm_form_campaign_accounts_webchat_thresholds_answer" ).is(":checked");
				const on_agent_noanswer_enabled_allowed = ["CIRCULAR", "SKILL"].includes(distribution) && answer_time_checked;
				if(!on_agent_noanswer_enabled_allowed) {
					$( self.on_agent_noanswer_enabled ).prop("checked", false).change();
				}					
				self.parent.disable_control($( self.on_agent_noanswer_enabled ), !on_agent_noanswer_enabled_allowed, false, false);				
			});
	};

	webchat_account_panel.prototype.__loadAsync = function(callback)
	{
		const self = this;
		inConcert.app.GetWebcontactCampaignAccounts(function( success, data ) {
			if (!success) {
				self.parent.frm.show_status_message("<%=_T('Error retrieving campaign accounts for out of hours.')%>", 'Error', false);
				callback();
				return;
			}
			self.m_campaigns = data || {};
			callback();
		});
	};

	webchat_account_panel.prototype.show = function(account)
	{
		var self = this;
		self.__loadAsync(function() {
			webchat_account_panel.uber.show.call(self, account);
		});
	};

	webchat_account_panel.prototype.initialize_thresholds = function()
	{
		var self = this;
		var after_answer_time_chk_change = function($chk) {
			const distribution = $( self.distribution ).val();
			const answer_time_checked = $chk.is(":checked");
			const on_agent_noanswer_enabled_allowed = ["CIRCULAR", "SKILL"].includes(distribution) && answer_time_checked;
			if(!on_agent_noanswer_enabled_allowed) {
				$( self.on_agent_noanswer_enabled ).prop("checked", false).change();
			}					
			self.parent.disable_control($( self.on_agent_noanswer_enabled ), !on_agent_noanswer_enabled_allowed, false, false);
		};
		// build thresholds panel
		webchat_account_panel.uber.initialize_thresholds.call(
			this,
			"CHAT",
			{
				parent    : this.parent,
				prefix_id : "adm_form_campaign_accounts_webchat_thresholds",
				after_answer_time_chk_change : after_answer_time_chk_change
			}
		);
	};

	webchat_account_panel.prototype.initialize_contact_mng = function()
	{
		// build contact management panel
		webchat_account_panel.uber.initialize_contact_mng.call(
			this,
			{
				type         : "CHAT"                                                 ,
				parent       : this                                                   ,
				auto_add_type: "ONLY_INCOMING"                                        , // incoming
				container_id : "adm_form_campaign_accounts_webchat_contact_mng_panel" ,
				prefix_id    : "adm_form_campaign_accounts_webchat_contact_mng"
			}
		);
	};

	webchat_account_panel.prototype.initialize_qna_maker_mng = function()
	{
		// build qna_maker management panel
		webchat_account_panel.uber.initialize_qna_maker_mng.call(
			this,
			{
				type         : "CHAT"                                                  ,
				parent       : this                                                    ,
				container_id : "adm_form_campaign_accounts_webchat_qna_maker_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_webchat_qna_maker_mng"
			}
		);
	};

	webchat_account_panel.prototype.initialize_flows_mng = function()
	{
		const self = this;
		const $outHours_process = $(this.outHours_process);

		// build flows designer management panel
		webchat_account_panel.uber.initialize_flows_mng.call(
			this,
			{
				type        : "CHAT"                                                       ,
				parent      : this                                                         ,
				container_id: "adm_form_campaign_accounts_webchat_flows_designer_mng_panel",
				prefix_id   : "adm_form_campaign_accounts_webchat_flows_designer_mng"      ,
				onDataLoaded: function() {
					$outHours_process.change();
				}
			}
		);
		$outHours_process
			.off("change")
			.on("change", function() {
				let current_process = $(this).val();
				if (current_process) {
					$(self.outHours_enabled).prop("checked", false);
					self.parent.disable_control($(self.outHours_campaign), current_process, false);
					self.parent.disable_control($(self.outHours_account), current_process, false);
				}
				self.parent.disable_control($outHours_process, current_process, false);
			});
	};

	webchat_account_panel.prototype.initialize_ticket_emitter = function()
	{
		webchat_account_panel.uber.initialize_ticket_emitter.call(
			this,
			{
				type         : "CHAT",
				parent       : this,
				container_id : "adm_form_campaign_accounts_webchat_tickets_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_webchat_tickets_mng"
			}
		);
	};

	webchat_account_panel.prototype.initialize_tabs = function()
	{
		// build tabs
		webchat_account_panel.uber.initialize_tabs.call(
			this,
			{
				parent       : this                              ,
				frm          : this.parent.frm                   ,
				container_id : "adm_form_campaign_accounts_tabs" ,
				tabs_list    : {
					basic : {
						id               : "basic",
						name             : "<%=_T('Web Chat Config')%>",
						tab_container_id : "adm_form_campaign_accounts_webchat_panel_tab_basic",
						selected         : true
					},
					messages : {
						id               : "messages",
						name             : "<%=_T('Messages')%>",
						tab_container_id : "adm_form_campaign_accounts_webchat_panel_tab_messages"
					}
				}
			}
		);
	};

	webchat_account_panel.prototype.initialize_skills = function()
	{
		webchat_account_panel.uber.initialize_skills.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_webchat_skills_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION"
			}
		);
	};

	webchat_account_panel.prototype.initialize_attention_levels = function()
	{
		webchat_account_panel.uber.initialize_attention_levels.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_webchat_attention_levels_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION",
				proxy_type   : "WEBCHAT"
			}
		);
	};

	webchat_account_panel.prototype.disable_tweety_chats = function()
	{
		var disabled, is_required;
		if ( this.parent.is_readonly() || !this.tweety_webchat_projects || Object.keys( this.tweety_webchat_projects ).length <= 1 ) {
		/* si solo tiene un elemento en el cbo, es el default y el combo tiene que quedar readonly*/
			disabled = true;
			is_required = false;
		}
		else {
			disabled = false;
			is_required = true;
		}
		this.parent.frm.readonly_control( $( this.tweety_app_name ), disabled, is_required );
	};

	webchat_account_panel.prototype.set_tweety_webchat_projects = function( projects )
	{
		var self = this;
		if ( projects ) {
			this.tweety_webchat_projects = {};
			this.tweety_webchat_projects[ this.default_project_id ] = {
				id   : this.default_project_id,
				name : "<%=_T('Default')%>"
			};
			$.each( projects, function( _, project )
			{
				self.tweety_webchat_projects[project.id] = project;
			});
		}
		else {
			this.tweety_webchat_projects = null;
		}
	};

	webchat_account_panel.prototype.fill_parameters_types = function()
	{
		var $combo = $( this.snippet_param_type );
		var is_blank_first_item = true;
		var attr_id = "id";
		var attr_name = "description";
		var list = this.snippet_parameters_types;
		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name );
	};

	webchat_account_panel.prototype.fill_triggers_types = function()
	{
		var $combo = $( this.triggers_type );
		var is_blank_first_item = false;
		var attr_id = "id";
		var attr_name = "description";
		var list = this.trigger_types;
		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name );
	};

	webchat_account_panel.prototype.fill_combo_tweety_webchats = function()
	{
		var $combo = $( this.tweety_app_name );
		var is_blank_first_item = false;
		var attr_id = "id";
		var attr_name = "name";
		var sorted = true;
		var list = this.tweety_webchat_projects || {};

		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name, sorted );
	};

	webchat_account_panel.prototype.fill_combo_webContact_campaigns = function()
	{
		var $combo = $( this.outHours_campaign );
		var is_blank_first_item = false;
		var attr_id = true;
		var attr_name = "Name";
		var sorted = true;
		var list = this.m_campaigns || {};

		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name, sorted );
	};

	webchat_account_panel.prototype.fill_combo_webContact_accounts = function()
	{
		var $combo = $( this.outHours_account );
		var is_blank_first_item = false;
		var attr_id = "Token";
		var attr_name = "Name";
		var sorted = true;
		
		var campaign = $( this.outHours_campaign ).val();
		var list = this.m_campaigns && this.m_campaigns[campaign] && this.m_campaigns[campaign].accounts || {};

		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name, sorted );
	};

	webchat_account_panel.prototype.fill_screen_recording_percentage = function()
	{
		const list = [];
		var step = 5;
		var start = step;
		var end = 100;
		for (var i = start; i <= end; i += step) {
			var percentage = i.toString();
			list.push({
				id: percentage,
				description: percentage + " %"
			});
		}
		var $combo = $( this.screen_recording_percentage );
		var is_blank_first_item = false;
		var attr_id = "id";
		var attr_name = "description";
		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name );
	};

	webchat_account_panel.prototype.readonly = function()
	{
		webchat_account_panel.uber.readonly.call( this );

		// disable combo tweety projects (web chat)
		this.parent.frm.readonly_control( $( this.tweety_app_name ), true /*disable*/ );

		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(true);
		this.disable_actions_trigger(true);
	};

	webchat_account_panel.prototype.generate_token = function()
	{
		this.current_token = inConcert.Utils.generateGuid();
		if (!this.is_new()) {
		// esta editando una account existente
			var acc = this.current_account;
			this.current_token = acc.Token ? acc.Token : this.current_token;
		}
	};
	
	//old projects
	webchat_account_panel.prototype.__generate_snippet_v2 = function()
	{
		// get WebChat url but strip the protocol
		var webchat_url = inConcert.app.getWebchatUrl().match("^http[s]?://(.+)")[1];
		webchat_url = webchat_url.replace("/v3", "/v2");
		var token = this.current_token;
		var container_id = $(this.button_id).val();
		var window_type = "popup";

		var google_enabled = $(this.google_enabled).is(":checked");
		var google_key = $(this.google_key).val();
		var google_bySections = $(this.google_bySections).is(":checked");
		
		/*
		*	Sample:
		<script type='text/javascript'>
			(function() {
				var proto  = document.location.protocol || 'http:';
				var node   = document.createElement('script');
				node.type  = 'text/javascript';
				node.async = true;
				node.src   = proto +  '//webchat-i6.inconcert.cc/v2/click_to_chat?token=710DB0B21AD6F20F16531D5821811601&container_id=chatbutton';
				var s = document.getElementsByTagName('script')[0];
				s.parentNode.insertBefore(node, s);
			})();
		</script>
		*/
		var new_url = format(
			"{0}/click_to_chat?token={1}&container_id={2}&type={3}",
			webchat_url              ,          // {0}
			encodeURIComponent(token),          // {1}
			encodeURIComponent(container_id),   // {3}
			window_type                         // {4}
		);

		if (google_enabled) {
			new_url += format("&google_key={0}&google_bysections={1}",
				encodeURIComponent(google_key),
				google_bySections? "1" : "0"
			);
		}

		var triggers = [];
		$(this.triggers_list).find("li[param_data]").each(function(_, param_data) {
			var $param_data  = $(param_data);
			triggers.push($param_data.data("trigger"));
		});
		var triggersSnippet = JSON.stringify(triggers).replace(/\\/g, "\\\\");

		var snippet = "".concat(
			"<script type='text/javascript'>\n",
			"  (function() {\n",
			"    window['" + token + "_triggers'] = " + triggersSnippet + ";\n",
			"    var proto  = document.location.protocol || 'http:';\n",
			"    var node   = document.createElement('script');\n",
			"    node.type  = 'text/javascript';\n",
			"    node.async = true;\n",
			"    node.src   = proto +  '//", new_url, "';\n",
			"    var s = document.getElementsByTagName('script')[0];\n",
			"    s.parentNode.insertBefore(node, s);\n",
			"  })();\n" +
			"</script>\n");

		$(this.snippet_code).val(snippet);

		return snippet;
	};

	webchat_account_panel.prototype.generate_snippet = function()
	{
		if (this._projectVersion === "v2") {
			return this.__generate_snippet_v2();
		}
		
		// get WebChat url but strip the protocol
		var webchat_url = inConcert.app.getWebchatUrl().match("^http[s]?://(.+)")[1];
		var token = this.current_token;
		
		/*
		*	Sample:
		<script type='text/javascript'>
			(function() {
				var proto  = document.location.protocol || 'http:';
				var node   = document.createElement('script');
				node.type  = 'text/javascript';
				node.async = true;
				node.src   = proto +  '//webchat-i6.inconcert.cc/v3/click_to_chat?token=710DB0B21AD6F20F16531D5821811601';
				var s = document.getElementsByTagName('script')[0];
				s.parentNode.insertBefore(node, s);
			})();
		</script>
		*/
		var new_url = format(
			"{0}/click_to_chat?token={1}",
			webchat_url              ,          // {0}
			encodeURIComponent(token)           // {1}
		);

		var snippet = "".concat(
			"<script type='text/javascript'>\n",
			"  (function() {\n",
			"    var proto  = document.location.protocol || 'http:';\n",
			"    var node   = document.createElement('script');\n",
			"    node.type  = 'text/javascript';\n",
			"    node.async = true;\n",
			"    node.src   = proto +  '//", new_url, "';\n",
			"    var s = document.getElementsByTagName('script')[0];\n",
			"    s.parentNode.insertBefore(node, s);\n",
			"  })();\n" +
			"</script>\n");

		$(this.snippet_code).val(snippet);

		return snippet;
	};

	webchat_account_panel.prototype.show_tracking = function()
	{
		var snippet = "".concat(
			"<script type='text/javascript'>\n",
			"  (function() {\n",
			"    var proto  = document.location.protocol || 'http:';\n",
			"    var trme   = document.createElement('script');\n",
			"    trme.type  = 'text/javascript';\n",
			"    trme.async = true;\n",
			"    trme.src   = proto +  '//", inConcert.app.getTrackmeServerAddress(), "/inconcert/apps/trackme/js/tm.js';\n",
			"    var s = document.getElementsByTagName('script')[0];\n",
			"    s.parentNode.insertBefore(trme, s);\n",
			"  })();\n" +
			"</script>\n");

		$(this.tracking_code).val(snippet);

		var $tracking_disclaimer = $(this.tracking_disclaimer);
		$tracking_disclaimer.parent().parent()
			// .removeClass("highRow")
			// .addClass("highRowWithMessage");
			.removeClass("d-none");
		$tracking_disclaimer.show();
	};

	webchat_account_panel.prototype.hide_tracking = function()
	{
		$(this.tracking_code)
			.val("");
		var $tracking_disclaimer = $(this.tracking_disclaimer);
		$tracking_disclaimer.parent().parent()
			// .removeClass("highRowWithMessage")
			// .addClass("highRow");
			.addClass("d-none");
		$tracking_disclaimer.hide();
	};

	webchat_account_panel.prototype.has_changed_snippet = function()
	{
		let actual_snippet = $(this.snippet_code).val();
		return this.is_new() || this.current_snippet !== actual_snippet;
	};

	webchat_account_panel.prototype.show_message_after_save = function(_ /*account*/, callback = $.noop)
	{
		if (!this.has_changed_snippet()) {
			callback();
			return;
		}
		let actual_snippet = $(this.snippet_code).val();
		const $snippet_message = $(this.snippet_message);
		$snippet_message.find("textarea").text(actual_snippet);
		$snippet_message
			.off("click", "button")
			.on("click", "button", function() {
				callback();
				$snippet_message.hide();
			}
		);
		$snippet_message.show();
	};

	webchat_account_panel.prototype.get_account_name = function()
	{
		var acc = this.current_account;
		if (acc.name) {
			return acc.name;
		}
		var uris = acc.url_regexp;
		if ($.isArray(uris) && uris.length > 0) {
			return uris[0];
		}
		return acc.id;
	};

	webchat_account_panel.prototype.edit = function( account /* optional */ )
	{
		webchat_account_panel.uber.edit.call( this, account );

		var acc = this.current_account;
		if ( !acc ) {
			return;
		}

		const self = this;
		var project_id = acc.TweetyAppName;

		$( this.name ).val( this.get_account_name() );
		$( this.annouce ).prop( "checked", acc.AnnounceEntry === "1" );
		$( this.go_chat ).prop( "checked", acc.GoChatIfTransfer === "1" );

		$( this.tracking ).prop( "checked", acc.Tracking === "1" ).change();
		$( this.bot_name ).val( acc.CampaignBotName );
		this.set_tweety_app_name( project_id );

		$(this.snippet_param_list).find("li[param_data]").remove();
		if (acc.snippet_parameters) {
			$.each(acc.snippet_parameters, function(_, parameter)
			{
				self.add_html_snippet_parameter(parameter.controlId, parameter.type, parameter.alias, parameter.hidden);
			});
			this.disable_actions_snippet_parameters( false );
		}

		$(this.triggers_list).find("li[param_data]").remove();
		if (acc.triggers) {
			$.each(acc.triggers, function(_, trigger)
			{
				self.add_html_trigger(trigger);
			});
			this.disable_actions_trigger( false );
		}

		// screen recording
		if(inConcert.app.getAgentScreenServiceEnabled())
		{
			var screen_recording_percentage = parseInt(acc.ScreenRecording, 10);
			if ( screen_recording_percentage > 0 ) {
				$(this.screen_recording).prop("checked", true).trigger("change");
				$(this.screen_recording_percentage).val(screen_recording_percentage.toString());
			}
			else {
				$(this.screen_recording).prop("checked", false).trigger("change");
			}
		}

		$(this.window_type).val(acc.window_type || "embedded");
		$(this.start_button).val(acc.start_button || "app").trigger("change");
		$(this.button_id).val(acc.containerId || "");

		$(this.google_enabled)
			.prop("checked", acc.google_enabled === "true" || acc.google_enabled === true)
			.trigger("change");
		$(this.google_key).val(acc.google_key || "");
		$(this.google_bySections)
			.prop("checked", acc.google_bySections === "true" || acc.google_bySections === true);

		$(this.outHours_enabled)
			.prop("checked", acc.outHours_enabled === "true" || acc.outHours_enabled === true)
			.trigger("change");
		$(this.outHours_campaign)
			.val(acc.outHours_campaign || "")
			.trigger("change");
		$(this.outHours_account).val(acc.outHours_account || "");

		if (acc.CCAlgorithm !== "QUEUED") {
			if (acc.FlowInformation.on_schedule && acc.FlowInformation.on_schedule.Process) {
				$(this.check_active_agent).prop("disabled", true);
			}
			else {
				$(this.check_active_agent).prop("disabled", false);
				$(this.check_active_agent)
					.prop("checked", acc.checkActiveAgents === "true" || acc.checkActiveAgents === true);
			}
		}
		
		const distribution = $( this.distribution ).val();
		const answer_time_checked = $( "#adm_form_campaign_accounts_webchat_thresholds_answer" ).is(":checked");
		const on_agent_noanswer_enabled_allowed = ["CIRCULAR", "SKILL"].includes(distribution) && answer_time_checked;
		if(!on_agent_noanswer_enabled_allowed) {
			$( this.on_agent_noanswer_enabled ).prop("checked", false).trigger("change");
		}
		else {
			const agent_noanswer = acc.agentNoAnswerConfig;
			if (agent_noanswer && agent_noanswer.enabled) {
				$(this.on_agent_noanswer_enabled).prop("checked", true).trigger("change");
				$(this.on_agent_noanswer_timeout).val(agent_noanswer.timeout);
			}
		}
		this.parent.disable_control($( this.on_agent_noanswer_enabled ), !on_agent_noanswer_enabled_allowed, false, false);
		
	};

	webchat_account_panel.prototype.set_tweety_app_name = function( project_id )
	{
		project_id = project_id || this.default_project_id;
		$( this.tweety_app_name ).val( project_id );
		this.show_tweety_info( project_id );
	};

	webchat_account_panel.prototype.empty_controls = function()
	{
		webchat_account_panel.uber.empty_controls.call( this );
		$( this.name                 ).val( "" );
		$( this.button_id            ).val( "" );
		$( this.bot_name             ).val( "" );
		this.set_tweety_app_name( /* default */ );
		mark_chk( this.annouce, false );
		mark_chk( this.go_chat, false );
		$( this.snippet_param_list   ).find("li[param_data]").remove();
		$( this.triggers_list        ).find("li[param_data]").remove();
		$(this.on_agent_noanswer_enabled).prop("checked", false).trigger("change");
	};

	webchat_account_panel.prototype.disable_actions_snippet_parameters = function(disable)
	{
		disable = disable === undefined ? true : disable;

		if (this.parent.is_readonly()) {
			disable = true;
		}

		$(this.snippet_param_new).prop("disabled", disable);
		var $snippet_param_data = $(this.snippet_param_list).find("li[param_data]");
		// boton edit de la lista de parametros
		$snippet_param_data.find("button[action_edit]").prop("disabled", disable);
		// boton delete de la lista de parametros
		$snippet_param_data.find("button[action_del]").prop("disabled", disable);
	};

	webchat_account_panel.prototype.disable_actions_trigger = function(disable)
	{
		disable = disable === undefined ? true : disable;

		if (this.parent.is_readonly()) {
			disable = true;
		}

		$(this.triggers_new).prop("disabled", disable);
		var $trigger_param_data = $(this.triggers_list).find("li[param_data]");
		// boton edit de la lista de parametros
		$trigger_param_data.find("button[action_edit]").prop("disabled", disable);
		// boton delete de la lista de parametros
		$trigger_param_data.find("button[action_del]").prop("disabled", disable);
	};

	webchat_account_panel.prototype.show_popup_parameters = function()
	{
		$(this.snippet_param_message).hide();
		this.parameters_popup.show();
		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(true);

		var control_id = "", type_id = "", alias = "", hidden = false;
		if (!this.parameter_editing) {
		// si presione el boton para crear uno nuevo
			$(this.snippet_param_create).val("<%=_T('Create')%>");
			$(this.snippet_param_create_continue).show();
		}
		else {
		// si presione el boton para editar
			$(this.snippet_param_create).val("<%=_T('Update')%>");
			$(this.snippet_param_create_continue).hide();
			control_id = this.parameter_editing.find("label[param_control_id='true']").text();
			type_id = this.parameter_editing.find("label[param_type='true']").attr("type_id");
			var type = this.snippet_parameters_types[type_id];
			if (type) {
				var $alias = this.parameter_editing.find("label[param_alias='true']");
				alias = $alias.text();
			}
			hidden = this.parameter_editing.attr("is_hidden") === "true";
		}

		$(this.snippet_param_type).val(type_id).change();
		$(this.snippet_param_alias).val(alias);
		$(this.snippet_param_hidden).prop("checked", hidden);
		$(this.snippet_param_control_id).focus().val(control_id);
	};

	webchat_account_panel.prototype.show_popup_triggers = function()
	{
		$(this.triggers_popupmessage).hide();
		this.triggers_popup.show();
		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_trigger(true);

		var type = "", regex = ".*", timeout = "", open = "CHAT_WINDOW";
		if ( !this.trigger_editing ) {
		// si presione el boton para crear uno nuevo
			$(this.triggers_create).val("<%=_T('Create')%>");
			$(this.triggers_create_continue).show();
		}
		else {
		// si presione el boton para editar
			$(this.triggers_create).val("<%=_T('Update')%>");
			$(this.triggers_create_continue).hide();
			var trigger = this.trigger_editing.data("trigger");
				type = trigger.type;
				regex = trigger.regex;
				timeout = trigger.timeout;
				open = trigger.open;
		}

		$(this.triggers_regex_test)
			.val("")
			.parent()
			.removeClass("regex_matches")
			.removeClass("regex_notmatches");

		$(this.triggers_type).val(type).change();
		$(this.triggers_timeout).val(timeout);
		$(this.triggers_regex).focus().val(regex);
		$(this.triggers_open).val(open);
	};

	webchat_account_panel.prototype.hide_popup_parameters = function()
	{
		$(this.snippet_param_popup).hide();
		// enable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(false);
	};

	webchat_account_panel.prototype.hide_popup_triggers = function()
	{
		$(this.triggers_popup_ctrl).hide();
		// enable actions popup parameters (new, delete, edit)
		this.disable_actions_trigger(false);
	};

	webchat_account_panel.prototype.add_html_snippet_parameter = function(control_id, type_id, alias, hidden)
	{
		if (typeof control_id !== "string" || typeof type_id !== "string") {
			return;
		}
		var type = this.snippet_parameters_types[type_id];
		var unique_id = control_id.trim().toLowerCase();
		alias = alias || "";

		$(this.snippet_param_list).append(
			"<li param_data='true' class='formListItem' is_hidden='" + (hidden? "true" : "false") + "' >" +
				"<label param_control_id='true' class='formItemText nameColumn' unique_id='" + unique_id + "'>" + control_id  + "</label>" +
				"<label param_type='true' class='formItemText valueColumn' type_id='" + type.id + "'>" + type.description + "</label>" +
				"<label param_alias='true' class='formItemText valueColumn'>" + alias + "</label>" +
				"<button action_edit='true' class='buttonColorGray gridActionButton edit'><i class='buttons-icons-edit'></i>" + "<%=_T('Edit')%>" + "</button>" +
				"<button action_del='true' class='buttonColorGray gridActionButton delete last'><i class='buttons-icons-delete'></i>" + "<%=_T('Delete')%>" + "</button>" +
			"</li>");
	};

	webchat_account_panel.prototype.make_trigger_action = function(trigger)
	{
		var type = this.trigger_types[trigger.type];
		var action = "";
		if (type.id === "time" ) {
			action = format("<%=_T('After {0} seconds on page')%>", trigger.timeout);
		}
		return action;
	};

	webchat_account_panel.prototype.add_html_trigger = function(trigger)
	{
		var type = this.trigger_types[trigger.type];
		var action = this.make_trigger_action(trigger);

		$(this.triggers_list)
			.append(
				"<li param_data='true' class='formListItem' >" +
					"<label class='formItemText nameColumn'  trigger_type >" + type.description  + "</label>" +
					"<label class='formItemText valueColumn' trigger_regex >" + trigger.regex + "</label>" +
					"<label class='formItemText valueColumn' trigger_action >" + action + "</label>" +
					"<button action_edit='true' class='buttonColorGray gridActionButton edit' disabled='true'><i class='buttons-icons-edit'></i>" + "<%=_T('Edit')%>" + "</button>" +
					"<button action_del='true' class='buttonColorGray gridActionButton delete last' disabled='true'><i class='buttons-icons-delete'></i>" + "<%=_T('Delete')%>" + "</button>" +
				"</li>"
			)
			.children("li[param_data]")
			.last()
			.data("trigger", trigger);
	};

	webchat_account_panel.prototype.validate_snippet_parameter = function(control_id, type, alias)
	{
		var self = this;

		var show_error = function(message, $control)
		{
			$(self.snippet_param_message).text(message).show();
			if ($control) {
				$control.focus();
			}
		};

		var message;
		if (control_id.trim().length === 0) {
			// valida que el control_id tenga al menos un caracter
			message = "<%=_T('Parameter control id is required')%>";
			show_error(message, $(this.snippet_param_control_id));
			return false;
		}

		if (!type) {
			// valida que hayan seleccionado un tipo en el combo
			message = "<%=_T('Parameter type is required')%>";
			show_error(message, $(this.snippet_param_alias));
			return false;
		}

		if (type.has_alias) {
			if (alias.trim().length === 0) {
				// valida que el alias tenga al menos un caracter
				message = "<%=_T('Parameter display name is required')%>";
				show_error(message, $(this.snippet_param_alias));
				return false;
			}
		}

		var unique_id = control_id.trim().toLowerCase();
		var already_exist = function()
		{
			var current_param = $(self.snippet_param_list).find("li[param_data] label[param_control_id='true'][unique_id='" + unique_id + "']");
			var len = current_param.length;
			if (len > 0) {
				message = format("<%=_T('Already exist parameter control id {0}.')%>", control_id);
				show_error(message, $(self.snippet_param_control_id));
				return true;
			}
			return false;
		};

		if (!this.parameter_editing) {
			// si es un paramerto nuevo valida que el mismo ya no exista en la lista
			if (already_exist()) {
				return false;
			}
		}
		else {
			var actual_name = this.parameter_editing.find("[param_control_id='true']").text();
			actual_name = actual_name.trim().toLowerCase();
			if (actual_name !== unique_id) {
			// si es name del paramerto ha cambiado valido que el nuevo nombre ya no exista en la lista
				if (already_exist()) {
					return false;
				}
			}
		}

		// validation successfully
		return true;
	};

	webchat_account_panel.prototype.validate_trigger = function(trigger)
	{
		var self = this;

		var show_error = function(message, $control)
		{
			$(self.triggers_popupmessage).text(message).show();
			if ($control) {
				$control.focus();
			}
		};

		var message;
		var result = this.parent.valid(trigger.timeout, "required");
		if ( !result.success ) {
			message = "<%=_T('Trigger regex is required')%>";
			show_error(message, $(this.triggers_regex));
			return false;
		}

		if ( trigger.type === "time" ) {
			result = this.parent.valid(trigger.timeout, "number");
			if ( !result.success ) {
				message = "<%=_T('Trigger time on page is not a number')%>";
				show_error(message, $(this.triggers_timeout));
				return;
			}
			trigger.timeout = parseInt(trigger.timeout, 10);
		}

		// validation successfully
		return true;
	};

	webchat_account_panel.prototype.add_or_update_snippet_parameter = function(has_continue)
	{
		$(this.snippet_param_message).hide();
		var control_id = $(this.snippet_param_control_id).val();
		var type_id = $(this.snippet_param_type).val();
		var type = this.snippet_parameters_types[type_id];
		var	alias = $(this.snippet_param_alias).val();
		var hidden = $(this.snippet_param_hidden).prop("checked");

		// validate snippet parameters
		if (!this.validate_snippet_parameter(control_id, type, alias)) {
			return;
		}

		if (!this.parameter_editing) {
		// add new parameter
			this.add_html_snippet_parameter(control_id, type.id, alias, hidden);
		}
		else {
		// update actual parameter
			// control id
			var $parameter_control_id = this.parameter_editing.find("[param_control_id='true']");
			$parameter_control_id.attr("unique_id", control_id);
			$parameter_control_id.text(control_id);
			// combo type
			var $parameter_type = $(this.parameter_editing.find("[param_type='true']"));
			$parameter_type.attr("type_id", type.id);
			$parameter_type.text(type.description);
			// alias
			var $parameter_alias = $(this.parameter_editing.find("[param_alias='true']"));
			$parameter_alias.text(alias);
			//hidden
			this.parameter_editing.attr("is_hidden", hidden? "true" : "false");
		}

		$(this.snippet_param_type).val("").change();
		$(this.snippet_param_alias).val("");
		$(this.snippet_param_control_id).val("");
		$(this.snippet_param_hidden).prop("checked", false);

		if (!has_continue) {
			this.hide_popup_parameters();
			return;
		}
		$(this.snippet_param_control_id).focus();
	};

	webchat_account_panel.prototype.add_or_update_trigger = function(has_continue)
	{
		$(this.triggers_popupmessage).hide();

		var trigger = {
			type : $(this.triggers_type).val(),
			regex: $(this.triggers_regex).val(),
			open: $(this.triggers_open).val()
		};

		if (trigger.type === "time") {
			trigger.timeout = $(this.triggers_timeout).val();
		}

		// validate snippet parameters
		if (!this.validate_trigger(trigger)) {
			return;
		}

		if (!this.trigger_editing) {
		// add new parameter
			this.add_html_trigger(trigger);
		}
		else {
			// update actual parameter
			var type = this.trigger_types[trigger.type];
			var action = this.make_trigger_action(trigger);

			this.trigger_editing.data("trigger", trigger);
			this.trigger_editing.find("[trigger_type]").text(type.description);
			this.trigger_editing.find("[trigger_regex]").text(trigger.regex);
			this.trigger_editing.find("[trigger_action]").text(action);
		}

		$(this.triggers_type)
			.val($(this.triggers_type + " option:first").val())
			.change();
		$(this.triggers_regex).val("");
		$(this.triggers_timeout).val("");

		this.generate_snippet();

		if (!has_continue) {
			this.hide_popup_triggers();
			return;
		}
		$(this.triggers_type).focus();
	};

	webchat_account_panel.prototype.set_events_popup_parameters = function()
	{
		var self = this;

		// boton new que abre el popup para poder agregar un nuevo parametro
		$(this.snippet_param_new)
			.off("click")
			.on("click", function() {
				self.parameter_editing = null;
				self.show_popup_parameters();
			});

		// boton create parameter
		$(this.snippet_param_create)
			.off("click")
			.on("click", function() {
				var has_continue = false;
				self.add_or_update_snippet_parameter(has_continue);
			});

		// boton create & continue parameter
		$(this.snippet_param_create_continue)
			.off("click")
			.on("click", function() {
				var has_continue = true;
				self.add_or_update_snippet_parameter(has_continue);
			});

		// boton que cancela la creacion del parametro
		$(this.snippet_param_cancel)
			.off("click")
			.on("click", function() {
				self.hide_popup_parameters();
			});

		// change en el combo de type en el popup
		$(this.snippet_param_type)
			.off("change")
			.on("change", function() {
				var type_id = $(this).val();
				var type = self.snippet_parameters_types[type_id];
				var $alias = $(self.snippet_param_alias);

				var $alias_lbl = $alias.parent().find("label[for='adm_form_campaign_accounts_webchat_snippet_param_alias']");
				if (type && type.has_alias) {
					$alias.prop("disabled", false).removeClass("readonly");
					$alias_lbl
						// .removeClass("formLabel-ds")
						// .addClass("formLabel-rq");
						.addClass("required");
				}
				else {
					$alias.prop("disabled", true).addClass("readonly");
					$alias_lbl
						// .removeClass("formLabel-rq")
						.removeClass("required");
						// .addClass("formLabel-ds");
				}

				$alias.val("").focus();
			});

		var $snippet_param = $(this.snippet_param_list);
		// boton edit de la lista de parametros
		var event_selector = "li[param_data='true'] button[action_edit='true']";
		$snippet_param
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				self.parameter_editing = $(this).parent();
				self.show_popup_parameters();
			});

		// boton delete de la lista de parametros
		event_selector = "li[param_data='true'] button[action_del='true']";
		$snippet_param
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var $parameter = $(this).parent();
				var message = format(
					"<%=_T('Do you want to delete parameter control id {0} type {1} ?')%>",
					$parameter.find("[param_control_id='true']").text(),
					$parameter.find("[param_type='true']").text()
				);
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					jQuery.inconcertPopup.ButtonSets.BS_YESNO,
					function(response) {
						if (response.toLowerCase() !== "yes") {
							return;
						}
						$parameter.fadeOut("slow", function() {
							$parameter.remove();
							self.generate_snippet();
						});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});

		// on agent no answer ---------------
		$( this.on_agent_noanswer_enabled )
			.off( "change" )
			.on({
				change: function() {
					$( self.on_agent_noanswer_timeout_container ).toggle($(this).is(":checked"));
				}
			});

	};

	webchat_account_panel.prototype.set_events_popup_triggers = function()
	{
		var self = this;

		// boton new que abre el popup para poder agregar un nuevo parametro
		$(this.triggers_new)
			.off("click")
			.on("click", function() {
				self.trigger_editing = null;
				self.show_popup_triggers();
			});

		// boton create parameter
		$(this.triggers_create)
			.off("click")
			.on("click", function() {
				var has_continue = false;
				self.add_or_update_trigger(has_continue);
			});

		// boton create & continue parameter
		$(this.triggers_create_continue)
			.off("click")
			.on("click", function() {
				var has_continue = true;
				self.add_or_update_trigger(has_continue);
			});

		// boton que cancela la creacion del parametro
		$(this.triggers_cancel)
			.off("click")
			.on("click", function() {
				self.hide_popup_triggers();
			});

		var $triggers_popup_ctrl = $(this.triggers_popup_ctrl);
		// change en el combo de type en el popup
		var $triggers_type = $(this.triggers_type);
		$triggers_type
			.off("change")
			.on("change", function() {
				if ( $(this).val() === "time" ) {
					$triggers_popup_ctrl.find("[webchat_trigger_time]").show();
				}
			});

		var $triggers_list = $(this.triggers_list);
		// boton edit de la lista de parametros
		var event_selector = "li[param_data='true'] button[action_edit='true']";
		$triggers_list
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				self.trigger_editing = $(this).parent();
				self.show_popup_triggers();
			});

		// boton delete de la lista de parametros
		event_selector = "li[param_data='true'] button[action_del='true']";
		$triggers_list
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var $trigger = $(this).parent();
				var message = format(
					"<%=_T('Do you want to delete trigger with action {0} and regex {1}?')%>",
					$trigger.find("[trigger_action]").text(),
					$trigger.find("[trigger_regex]").text()
				);
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					jQuery.inconcertPopup.ButtonSets.BS_YESNO,
					function(response) {
						if (response.toLowerCase() !== "yes") {
							return;
						}
						$trigger.fadeOut("slow", function() {
							$trigger.remove();
							self.generate_snippet();
						});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});

			var $triggers_regex_test = $(this.triggers_regex_test);
			var test_trigger_regex_fn = function() {
				var regex_s = $(self.triggers_regex).val();
				var url = $triggers_regex_test.val();
				if (!regex_s || !url) {
					$triggers_regex_test
						.parent()
						.removeClass("regex_matches")
						.removeClass("regex_notmatches");
					return;
				}
				var regex = new RegExp(regex_s, "i");
				var matches = regex.test(url);
				$triggers_regex_test
					.parent()
					.toggleClass("regex_matches", matches)
					.toggleClass("regex_notmatches", !matches);
			};

		 $(this.triggers_regex_test + ", " + this.triggers_regex)
			.off("paste")
			.on("paste", function() {
				window.setTimeout(function() {
					test_trigger_regex_fn();
				}, 100);
			})
			.off("keyup")
			.on("keyup", function() {
				test_trigger_regex_fn();
			});
	};

	webchat_account_panel.prototype.show_tweety_info = function( project_id )
	{
		var self = this;
		var $tweety_info = $( this.tweety_info );

		var show = function( info )
		{
			var only_default = ( self.parent.is_readonly() || !self.tweety_webchat_projects || Object.keys( self.tweety_webchat_projects ).length <= 1 );

			$.each( $tweety_info.find("[info_type]"), function ( _, img )
			{
				var $img = $( img );
				$img.removeClass().addClass( "checkboxImageUnchecked" );
				if ( only_default ) {
					var $lbl = $img.parent().find( "label" );
					$lbl.removeClass().addClass( "readonly" );
				}
			});

			if ( info && info.status ) {
				var views = info.result.views;
				$.each( views, function ( _, view )
				{
					if ( view.name ) {
						var $img = $tweety_info.find("[info_type='" + view.name + "']");
						if ( $img.length > 0 ) {
							$img.removeClass("checkboxImageUnchecked")
								.addClass("checkboxImageChecked");
						}
					}
				});
				$tweety_info.show();
			}
			else {
				$tweety_info.hide();
			}
			self.__setProjectVersion(info);
		};

		var tweety_project = this.tweety_webchat_projects[project_id];
		if ( tweety_project && tweety_project.info ) {
		// si la info para este proyecto ya se recupero al menos una vez, la toma del cache asi no tiene que realizar el request nuevamente.
			show( tweety_project.info );
		}
		else {
		// si la info para este proyecto no se ha recuperado nunca (o sea es la primera vez), realizo el request y luego me lo guardo, para una siguiente vez.
			var tweety = inConcert.app.getTweetyAPI();
			return tweety.get_info( project_id,
				function( info ) {
					if ( self.tweety_webchat_projects[project_id] ) {
					// aca lo cacheo a la info, en la info del proyecto.
						self.tweety_webchat_projects[project_id].info = info;
					}
					show( info );
				}
			);
		}
	};

	webchat_account_panel.prototype.__setProjectVersion = function(info) {
		this._projectVersion = "v3";
		if (info && info.result && info.result.views) {
			$.each(info.result.views, function(_, view) {
				if (view.name === "___chat") {
					this._projectVersion = "v2";
					return false;
				}
			});
		}
		if (this._projectVersion === "v2") {
			$(this.start_button)
				.val("control")
				.change();
			this.parent.disable_control( $(this.start_button), true, true );
			$(this.window_type)
				.val("popup")
				.change();
			this.parent.disable_control( $(this.window_type), true, true );

			$(this.go_chat).prop("checked", false);
			this.parent.disable_control( $(this.go_chat), true, false );

			$(this.outHours_enabled).prop("checked", false);
			this.parent.disable_control( $(this.outHours_enabled), true, false );
			this.parent.disable_control( $(this.outHours_campaign), true, false );
			this.parent.disable_control( $(this.outHours_account), true, false );
		}
		else {
			this.parent.disable_control( $(this.start_button), false, true );
			this.parent.disable_control( $(this.window_type), false, true );
			this.parent.disable_control( $(this.go_chat), false, true );

			this.parent.disable_control( $(this.outHours_enabled), false, false );
			$(this.outHours_enabled).change();
		}
		this.generate_snippet();
	};

	webchat_account_panel.prototype.set_events = function()
	{
		webchat_account_panel.uber.set_events.call( this );

		const self = this;

		$( this.tweety_app_name )
			.off( "change" )
			.on({
				change: function() {
					let project_id = $( this ).val();
					self.show_tweety_info( project_id );
				}
			});

		if ( this.parent.is_readonly() ) {
			return;
		}

		// input element id de la page
		$(this.button_id + ", " + this.google_key)
				.off("keyup")
				.on("keyup", function() {
					self.generate_snippet();
				});

		$(this.google_bySections)
				.off("change")
				.on("change", function() {
					self.generate_snippet();
				});

		// chk enabled tracking
		$(this.tracking)
			.off("change")
			.on("change", function() {
				if ($(this).prop("checked")) {
					self.show_tracking();
				}
				else {
					self.hide_tracking();
				}
			});

		$(this.start_button)
			.off("change")
			.on("change", function()
			{
				$(self.button_id).parent().toggle($(this).val() === "control");
			});

		const $google_panel = $(this.google_panel);
		const $google_enabled = $(this.google_enabled);
		$google_enabled
			.off("change")
			.on("change", function()
			{
				$google_panel.find("[webchat_google]")
					.find("input, select")
					.prop("disabled", !$google_enabled.is(":checked"))
					// .siblings("label.formLabel")
					.siblings("label");
					// .toggleClass("formLabel-ds", !$google_enabled.is(":checked"));

				$(self.google_key)
					// .siblings("label.formLabel")
					.siblings("label")
					// .toggleClass("formLabel-rq", $google_enabled.is(":checked"));
					.toggleClass("required", $google_enabled.is(":checked"));

				self.generate_snippet();
			});

		const $outHours_campaign = $(this.outHours_campaign);
		const $outHours_enabled = $(this.outHours_enabled);

		$outHours_enabled
			.off("change")
			.on("change", function() {
				let is_outHours_enabled = $outHours_enabled.is(":checked");
				self.parent.disable_control($outHours_campaign, !is_outHours_enabled, false);
				self.parent.disable_control($(self.outHours_account), !is_outHours_enabled, false);
				self.parent.disable_control($(self.outHours_process), is_outHours_enabled, false);
			});

		$outHours_campaign
			.off("change")
			.on("change", function() {
				self.fill_combo_webContact_accounts();
			});

		$(this.snippet_code + ", " + this.tracking_code)
			.off("click")
			.on("click", function() {
				this.setSelectionRange(0, this.value.length);
			});
			
		$(this.snippet_message)
			.find(".formTextarea")
			.off("click")
			.on("click", function() {
				this.setSelectionRange(0, this.value.length);
			});

		// snippet events
		this.set_events_popup_parameters();
		this.set_events_popup_triggers();

		$( this.on_agent_noanswer_enabled )
			.off( "change" )
			.on({
				change: function() {
					$( self.on_agent_noanswer_timeout_container ).toggle($(this).is(":checked"));
				}
			});		
	};

	webchat_account_panel.prototype.on_hide = function()
	{
		webchat_account_panel.uber.on_hide.call( this );

		if ( ! this.tweety_webchat_projects ) {
			return;
		}
		$.each( this.tweety_webchat_projects, function ( _, data )
		{
			if ( data && data.info ) {
				data.info = null;
			}
		});
	};

	webchat_account_panel.prototype.on_show = function()
	{
		webchat_account_panel.uber.on_show.call( this );
		this.current_snippet = this.generate_snippet();
		this.hide_popup_parameters();
		$(this.name).focus();
	};

	webchat_account_panel.prototype.on_saved = function(new_account, current_account, callback = $.noop)
	{
		const self = this;

		webchat_account_panel.uber.on_saved.call(this, new_account, current_account, callback);

		var project_id = new_account.TweetyAppName;
		var token = new_account.Token;

		// si estoy actualizando una account y no se ha cambiado de proyecto de tweety, no actualizo el authfilter
		if (current_account &&
			(current_account.TweetyAppName === project_id && current_account.Token === token)) {
			return;
		}
		var tweety = inConcert.app.getTweetyAPI();

		return tweety.set_authfilter( project_id, token,
			function( success )
			{
				if ( !success ) {
					var error_message = "<%=_T('Error setting auth filter to web desginer.')%>";
					var timeout_ms = 5000;
					self.parent.frm.show_status_message(error_message, "Error", timeout_ms);
				}
			}
		);
	};

	webchat_account_panel.prototype.validate = function()
	{
		var self = this;

		var is_new = this.is_new();
		var account_info = {
			success: false,
			account: null,
			is_new:  is_new,
			error_message: null
		};

		var error_in_basic_tab = function() {
			self.tabs.switch_tab( "basic" );
			return account_info;
		};

		this.hide_marked_errors(); // oculto todos los errors de los campos

		// NAME - validation
		var $name = $(this.name);
		if (!this.validate_field($name, "required", "<%=_T('Account name is required.')%>")) {
			return error_in_basic_tab();
		}
		if (!this.validate_field($name, "alpha", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Account Name.')%>")) {
			return error_in_basic_tab();
		}

		// DISTRIBUTION - validation
		var $distribution = $(this.distribution);
		if (!this.validate_field($distribution, "required", "<%=_T('Distribution is required.')%>")) {
			return error_in_basic_tab();
		}

		// LANGUAGE - validation
		var $language = $(this.language);
		if (!this.validate_field($language, "required", "<%=_T('Language is required.')%>")) {
			return error_in_basic_tab();
		}

		// PRIORITY - validation
		var $priority = $(this.priority);
		var has_att_levels = this.attention_levels_handle.count_selected() > 0;
		if (!has_att_levels && $priority.val().trim().length > 0) {
			let range = { between: { from: 0, to: 99 } }; // range attention_level value validation
			if (!this.validate_field($priority, "range", format("<%=_T('Account priority value out of range. Please enter account priority value between {0} and {1}.')%>", range.between.from, range.between.to ), range )) {
				return error_in_basic_tab();
			}
		}

		// SCREEN RECORDING PERCENTAGE - validation
		if ($(this.screen_recording).prop("checked")) {
			var $screen_recording_percentage = $( this.screen_recording_percentage );
			if ( !this.validate_field( $screen_recording_percentage, "required", "<%=_T('Screen recording percentage is required.')%>" ) ) {
				return error_in_basic_tab();
			}
		}

		// tweety app name - validation
		var $tweety_app_name = $( this.tweety_app_name );
		if (!this.validate_field( $tweety_app_name, "required", "<%=_T('Web chat name is required.')%>" ) ) {
			return error_in_basic_tab();
		}
		// START BUTTON - validation
		if ($(this.start_button).val() === "control") {
			if (!this.validate_field( $(this.button_id), "required", "<%=_T('Start Button Id is required.')%>")) {
				return error_in_basic_tab();
			}
			if (!this.validate_field( $(this.button_id), "html_element_id", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Start Button Id.')%>" )) {
				return error_in_basic_tab();
			}
		}

		//valido la configuracion de out of hours
		var $outHours_enabled = $(this.outHours_enabled),
			$outHours_campaign = $(this.outHours_campaign),
			$outHours_account = $(this.outHours_account);

		var outHours_enabled = $outHours_enabled.is(":checked");
		if (outHours_enabled) {
			if (!this.validate_field( $outHours_campaign, "required", "<%=_T('Out of hours contact form campaign is required.')%>" ) ) {
				return error_in_basic_tab();
			}
			if (!this.validate_field( $outHours_account, "required", "<%=_T('Out of hours contact form account is required.')%>" ) ) {
				return error_in_basic_tab();
			}
		}

		//valido la configuracion de google analytics
		var $google_enabled = $(this.google_enabled),
			$google_key = $(this.google_key),
			$google_bySections = $(this.google_bySections);

		var google_enabled = $google_enabled.is(":checked");
		if (google_enabled) {
			if (!this.validate_field( $google_key, "required", "<%=_T('Google Analytics key is required.')%>" ) ) {
				return error_in_basic_tab();
			}
		}

		// valido los skills ----------
		var result_skills = this.validate_skills();
		if ( !result_skills.success ) {
			this.show_validation_error( result_skills.$ctrl, result_skills.message );
			return error_in_basic_tab();
		}

		// valido los attention levels ----------
		var result_attention_levels = this.validate_attention_levels();
		if ( !result_attention_levels.success ) {
			this.show_validation_error(
				result_attention_levels.$ctrl,
				result_attention_levels.message,
				false, //timeout_ms
				true, //scrolling
				result_attention_levels.show_custom_button
			);
			return error_in_basic_tab();
		}

		// valido la configuracion de tickets
		var result_ticket_emitter = this.validate_ticket_emitter();
		if (!result_ticket_emitter.success) {
			this.show_validation_error( result_ticket_emitter.$ctrl, result_ticket_emitter.error_message );
			return error_in_basic_tab();
		}

		// valido los contact mng ----------
		var result_contact_mng = this.validate_contact_mng();
		if ( !result_contact_mng.success ) {
			this.show_validation_error( result_contact_mng.$ctrl, result_contact_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los flows mng ----------
		var result_flows_mng = this.validate_flows_mng();
		if ( !result_flows_mng.success ) {
			this.show_validation_error( result_flows_mng.$ctrl, result_flows_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los qna maker mng ----------
		var result_qna_maker_mng = this.validate_qna_maker_mng();
		if ( !result_qna_maker_mng.success ) {
			this.show_validation_error( result_qna_maker_mng.$ctrl, result_qna_maker_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los thresholds ----------
		var result_th = this.validate_thresholds();
		if ( !result_th.success ) {
			this.show_validation_error( result_th.$ctrl, result_th.error_message );
			return error_in_basic_tab();
		}

		// valido los messages de la account ----------
		var result_messages = this.validate_messages();
		if ( !result_messages.success ) {
			this.show_validation_error( undefined, result_messages.error_message );
			return account_info;
		}

		// valido la configuracion de on agent no answer
		let agent_noanswer_config = { enabled: $(this.on_agent_noanswer_enabled).is(":checked") };
		if (agent_noanswer_config.enabled) {
			// timeout - validation
			var $on_agent_noanswer_timeout = $( this.on_agent_noanswer_timeout );
			let range = { between: { from: AGENT_NOANSWER_MIN_SECCONDS, to: AGENT_NOANSWER_MAX_SECCONDS } }; // range timeout value validation
			if (!this.validate_field( $on_agent_noanswer_timeout, "range", format("<%=_T('The value of available again after seconds is out of range. Please enter a value between {0} and {1}.')%>", range.between.from, range.between.to ), range )){
				return error_in_basic_tab();
			}
			agent_noanswer_config.timeout = $on_agent_noanswer_timeout.val();
		}		

		//------------------------------------------------------
		// paso la validacion correctamente, ahora a guardar!!!
		var name = $name.val();
		var account = {};
		if (is_new) {
			var campaign = this.parent.frm.campaign;
			account.id = "WEBCHAT_" + campaign.Id + "_" + name;
		}
		else {
			account.id = this.current_account.id;
		}
		account.proxyType               = "CHAT";
		account.name                    = name;
		account.uid                     = name;
		account.CampaignBotName         = $(this.bot_name).val();
		account.AnnounceEntry           = get_chk_bool_to_string( this.annouce );
		account.GoChatIfTransfer        = get_chk_bool_to_string( this.go_chat );
		account.Tracking                = get_chk_bool_to_string( this.tracking );
		account.CCAlgorithm             = $distribution.val();
		account.ScreenRecording         = this.__GetScreenRecording();
		account.language                = $language.val();
		account.TweetyAppName           = $tweety_app_name.val();
		account.Token                   = this.current_token;
		account.TicketEmitter           = result_ticket_emitter.result;
		account.Skills                  = this.skills_handle.get();
		account.Priority                = $priority.val();
		account.AttentionLevels         = this.attention_levels_handle.get();
		account.GUI                     = this.get_gui_config();
		account.window_type             = $(this.window_type).val();
		account.start_button            = $(this.start_button).val();
		account.containerId             = $(this.button_id).val();
		account.google_enabled          = google_enabled;
		account.google_key              = $google_key.val();
		account.google_bySections       = $google_bySections.is(":checked");
		account.outHours_enabled        = outHours_enabled;
		account.outHours_campaign       = $outHours_campaign.val();
		account.outHours_account        = $outHours_account.val();
		account.ActionOnAcdWaitTimeout  = result_th.ActionOnAcdWaitTimeout;
		account.InactivityTimeout       = result_th.InactivityTimeout;
		account.checkActiveAgents       = $(this.check_active_agent).is(":checked");
		account.agentNoAnswerConfig     = agent_noanswer_config;
		this.contact_mng_instance.attach_data( account );
		if (this.flow_mng_instance) {
			this.flow_mng_instance.attach_data( account );
		}
		if (this.qna_maker_mng_instance) {
			this.qna_maker_mng_instance.attach_data(account);
		}

		account.snippet_parameters = [];
		// carga la lista de snippet parameters
		$(this.snippet_param_list).find("li[param_data]").each(function(_, param_data)
		{
			var $param_data  = $(param_data);

			var new_parameter = {
				controlId  : $param_data.find("label[param_control_id]").text(),
				type       : $param_data.find("label[param_type]").attr("type_id")
			};
			if ($param_data.attr("is_hidden") === "true") {
				new_parameter.hidden = true;
			}
			var type = self.snippet_parameters_types[new_parameter.type];
			if (type && type.has_alias) {
				new_parameter.alias = $param_data.find("label[param_alias]").text();
			}

			account.snippet_parameters.push(new_parameter);
		});

		account.triggers = [];
		$(this.triggers_list).find("li[param_data]").each(function(_, param_data) {
			var $param_data  = $(param_data);
			account.triggers.push($param_data.data("trigger"));
		});

		account_info.account = account;
		account_info.success = true;

		return account_info;
	};

	webchat_account_panel.prototype.__GetScreenRecording = function()
	{
		if ( !$(this.screen_recording).prop("checked") ) {
			return 0; // Si ha marcado que no quiere "screen recording"
		}
		// Si ha marcado que quiere "screen recording"
		return $(this.screen_recording_percentage).val();
	};

}());
