/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

// try improve namespacing a bit
if ( !this.inConcert.Administration ) {
	this.inConcert.Administration = {};
}

if ( !this.inConcert.Administration.Campaigns ) {
	this.inConcert.Administration.Campaigns = {};
}

(function () {

//	"use strict";

	const _T = inConcert.i18n.getString;
	const FORMAT = inConcert.Utils.format;
	
	const SMOOCH_AUTHORIZATION = "MANUAL";

	let get_chk_bool_to_string  = function(chk_id) {
		const $chk = $(chk_id);
		if ($chk.length === 0) {
			return undefined;
		}
		const checked = $chk.prop("checked");
		return Number(checked).toString();
	};

	//---------------------------------------------------------------------
	// frm whatsapp account edition
	function WHATSAPPAccountPanel(params)
	{
		/* jshint validthis: true*/
		this.prefix_id = "adm_form_campaign_accounts_whatsapp_";
		let success = WHATSAPPAccountPanel.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.messages_class = inConcert.adm_form_campaigns_whatsapp_account_messages;
		this.container_id = "#adm_form_campaign_accounts_whatsapp_panel";

		params.account_config = this;
		params.prefix_id = this.container_id;

		this.name = "#adm_form_campaign_accounts_whatsapp_name";
		this.integrationType = "#adm_form_campaign_accounts_whatsapp_account_integrationtype";
		this.account_activation_code = "#adm_form_campaign_accounts_whatsapp_account_activation_code";
		this.activation_code_disclaimer = "#adm_form_campaign_accounts_whatsapp_account_activation_code_disclaimer";

		this.webAuthorizeButton = '#adm_form_campaign_accounts_whatsapp_account_web_auth';
		this.webAuthorizeImage = '#adm_form_campaign_accounts_whatsapp_account_web_auth_img';

		this.wavyUserName = "#adm_form_campaign_accounts_whatsapp_wavy_username";
		this.wavyUserToken = "#adm_form_campaign_accounts_whatsapp_wavy_usertoken";

		this.inconcertCloudApiAuthorizeButton = '#adm_form_campaign_accounts_whatsapp_account_inconcert_cloud_api_auth';
		this.inconcertCloudApiAuthorizeImage = '#adm_form_campaign_accounts_whatsapp_account_inconcert_cloud_api_auth_img';
		this.inconcertCloudApiWaba = "#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_waba";
		this.inconcertCloudApiPhone = '#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_phone';
		this.inconcertCloudApiCodeVerificationStatus = '#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_code_verification_status';
		this.inconcertCloudApiPhoneStatus = '#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_phone_status';
		this.inconcertCloudApiTemplateNamespace = '#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_template_namespace';
		this.inconcertCloudApiMessageLimit = '#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_message_limit';
		this.inconcertCloudApiVerifyPhone = "#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_verify_phone";
		this.inconcertCloudApiRegisterPhone = "#adm_form_campaign_accounts_whatsapp_inconcert_cloud_api_register_phone";
		this.m_verification_step = null;
		this.m_migration_step = null;
		this.activation_code = null;

		this.smoochAuthorizeButton = '#adm_form_campaign_accounts_whatsapp_account_smooch_auth';
		this.smoochAuthorizeImage = '#adm_form_campaign_accounts_whatsapp_account_smooch_auth_img';
		this.smoochPhone = "#adm_form_campaign_accounts_whatsapp_smooch_phone";

		this.infobipAuthorizeButton = '#adm_form_campaign_accounts_whatsapp_account_infobip_auth';
		this.infobipAuthorizeImage = '#adm_form_campaign_accounts_whatsapp_account_infobip_auth_img';
		this.infobipUserName = "#adm_form_campaign_accounts_whatsapp_infobip_username";
		this.infobipUserToken = "#adm_form_campaign_accounts_whatsapp_infobip_usertoken";
		this.infobipBaseUrl = "#adm_form_campaign_accounts_whatsapp_infobip_baseurl";
		this.infobipPhone = "#adm_form_campaign_accounts_whatsapp_infobip_phone";

		this.businessAuthorizeButton = '#adm_form_campaign_accounts_whatsapp_account_business_auth';
		this.businessAuthorizeImage = '#adm_form_campaign_accounts_whatsapp_account_business_auth_img';
		this.businessUserName = "#adm_form_campaign_accounts_whatsapp_business_username";
		this.businessUserToken = "#adm_form_campaign_accounts_whatsapp_business_usertoken";
		this.businessBaseUrl = "#adm_form_campaign_accounts_whatsapp_business_baseurl";
		this.businessPhone = "#adm_form_campaign_accounts_whatsapp_business_phone";

		this.inconcert_config = "#adm_form_campaign_accounts_whatsapp_inconcert_config";

		this.language = "#adm_form_campaign_accounts_whatsapp_language";
		this.distribution = "#adm_form_campaign_accounts_whatsapp_distribution";
		this.priority = "#adm_form_campaign_accounts_whatsapp_priority";
		this.newContacts = "#adm_form_campaign_accounts_whatsapp_new_contacts";

		this.attention_levels_container = "#adm_form_campaign_accounts_whatsapp_attention_levels_config";
		this.ticket_management_container = "#adm_form_campaign_accounts_whatsapp_tickets_mng_panel";
		this.contact_management_container = "#adm_form_campaign_accounts_whatsapp_contact_mng_panel";
		this.thresholds_container = "#adm_form_campaign_accounts_whatsapp_thresholds_panel";

		this.account_save_id = "#adm_form_campaign_accounts_save";
		this.tagline_new      = "<%=_T('New Whatsapp account.')%>";
		this.tagline_edit     = "<%=_T('Edit Whatsapp account {0}.')%>";
		this.tagline_readonly = "<%=_T('Whatsapp account {0}.')%>";
	}

	inConcert.Utils.inherit( WHATSAPPAccountPanel, inConcert.adm_form_campaigns_section_accounts_base_panel) ;

	if ( typeof inConcert.Administration.Campaigns.WHATSAPPAccountPanel !== "function" ) {
		inConcert.Administration.Campaigns.WHATSAPPAccountPanel = WHATSAPPAccountPanel;
	}

	WHATSAPPAccountPanel.prototype.initialize = function()
	{
		WHATSAPPAccountPanel.uber.initialize.call(this);
		this.m_authorizingId = null;
		this.m_authorizingUserName = null;
		this.m_authorizingUserToken = null;
		this.m_authorizingBaseUrl = null;
		this.m_authorizingPhone = null;
		this.m_authorizedId = null;
	};

	WHATSAPPAccountPanel.prototype.has_hsm_maker       = function() {return true;};
	WHATSAPPAccountPanel.prototype.has_qna_maker       = function() {return true;};
	WHATSAPPAccountPanel.prototype.has_flow_management = function() {return true;};
	WHATSAPPAccountPanel.prototype.has_flow_inactivity = function() {return true;};

	/**
	 * Initializes thresholds management
	 *
	 * @public
	 */
	WHATSAPPAccountPanel.prototype.initialize_thresholds = function()
	{
		// build thresholds panel
		WHATSAPPAccountPanel.uber.initialize_thresholds.call( this,
			"WHATSAPP",
			{
				parent    : this.parent,
				prefix_id : "adm_form_campaign_accounts_whatsapp_thresholds"
			}
		);
	};

	/**
	 * Initializes contact management
	 *
	 * @public
	 */
	WHATSAPPAccountPanel.prototype.initialize_contact_mng = function(){
		// build contact management panel
		WHATSAPPAccountPanel.uber.initialize_contact_mng.call(this,
			{
				type         : "WHATSAPP"                                              ,
				parent       : this                                               ,
				auto_add_type: "BOTH"                                             , // incoming y outgoing
				container_id : "adm_form_campaign_accounts_whatsapp_contact_mng_panel" ,
				prefix_id    : "adm_form_campaign_accounts_whatsapp_contact_mng"
			}
		);
	};

	WHATSAPPAccountPanel.prototype.initialize_flows_mng = function()
	{
		// build flows designer management panel
		WHATSAPPAccountPanel.uber.initialize_flows_mng.call(
			this,
			{
				type         : "WHATSAPP"                                                    ,
				parent       : this                                                     ,
				container_id : "adm_form_campaign_accounts_whatsapp_flows_designer_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_whatsapp_flows_designer_mng"
			}
		);
	};

	/**
	 * Initializes ticket management
	 *
	 * @public
	 */
	WHATSAPPAccountPanel.prototype.initialize_ticket_emitter = function(){
		// build ticket management section
		WHATSAPPAccountPanel.uber.initialize_ticket_emitter.call(this,
			{
				type         : "WHATSAPP"                                              ,
				parent       : this                                               ,
				auto_add_type: "BOTH"                                             , // incoming y outgoing
				container_id : "adm_form_campaign_accounts_whatsapp_tickets_mng_panel" ,
				prefix_id    : "adm_form_campaign_accounts_whatsapp_tickets_mng"
			}
		);
	};

	WHATSAPPAccountPanel.prototype.initialize_survey_management = function()
	{
		WHATSAPPAccountPanel.uber.initialize_survey_management.call(
			this,
			{
				type         : "WHATSAPP",
				parent       : this,
				container_id : "adm_form_campaign_accounts_whatsapp_survey_panel",
				prefix_id    : "adm_form_campaign_accounts_whatsapp_survey"
			}
		);
	};

	WHATSAPPAccountPanel.prototype.initialize_qna_maker_mng = function()
	{
		// build qna_maker management panel
		WHATSAPPAccountPanel.uber.initialize_qna_maker_mng.call(
			this,
			{
				type         : "WHATSAPP"                                               ,
				parent       : this                                                     ,
				container_id : "adm_form_campaign_accounts_whatsapp_qna_maker_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_whatsapp_qna_maker_mng"
			}
		);
	};

	WHATSAPPAccountPanel.prototype.initialize_hsm_mng = function()
	{
		// build hsm management panel
		WHATSAPPAccountPanel.uber.initialize_hsm_mng.call(
			this,
			{
				type         : "WHATSAPP"                                        ,
				parent       : this                                              ,
				container_id : "adm_form_campaign_accounts_webchat_hsm_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_whatsapp_hsm_mng"
			}
		);
	};

	WHATSAPPAccountPanel.prototype.initialize_skills = function()
	{
		WHATSAPPAccountPanel.uber.initialize_skills.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_whatsapp_skills_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION"
			}
		);
	};

	WHATSAPPAccountPanel.prototype.initialize_attention_levels = function()
	{
		WHATSAPPAccountPanel.uber.initialize_attention_levels.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_whatsapp_attention_levels_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION",
				proxy_type   : "WHATSAPP"
			}
		);
	};

	/**
	 * Toggle every control, used from init and edit mode.
	 *
	 * @param  {Boolean} on_or_off - Toggle or not.
	 */
	WHATSAPPAccountPanel.prototype.__toggle_controls = function(on_or_off)
	{
		$(this.webAuthorizeButton).val(!on_or_off ? "<%=_T('Authorize Application')%>" : "<%=_T('Re-Authorize Application')%>");
		$(this.webAuthorizeImage).toggleClass('formImageTrue', on_or_off).toggleClass('formImageFalse', !on_or_off);
		
		$(this.inconcertCloudApiAuthorizeButton).val(!on_or_off ? "<%=_T('Authorize Application')%>" : "<%=_T('Re-Authorize Application')%>");
		$(this.inconcertCloudApiAuthorizeImage).toggleClass('formImageTrue', on_or_off).toggleClass('formImageFalse', !on_or_off);
		$(this.inconcertCloudApiWaba + ", " + this.inconcertCloudApiPhone + ", " + this.inconcertCloudApiCodeVerificationStatus  + ", " + this.inconcertCloudApiPhoneStatus + ", " + this.inconcertCloudApiTemplateNamespace + ", " + this.inconcertCloudApiMessageLimit)
			.prop("disabled", true)
			.addClass("readonly");
		let selectedWaba = this.m_wabas && this.m_wabas.find(waba => waba.id === $(this.inconcertCloudApiWaba).val());
		let selectedPhone = selectedWaba && selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(this.inconcertCloudApiPhone).val());
		if(selectedPhone) {
			$( this.inconcertCloudApiVerifyPhone ).toggle(selectedPhone.codeVerificationStatus !== "VERIFIED");
			$( this.inconcertCloudApiRegisterPhone ).text((selectedPhone.phoneStatus === "CONNECTED") ? "<%=_T('Deregister Phone')%>" : "<%=_T('Register Phone')%>");
			$( this.inconcertCloudApiRegisterPhone ).toggle(selectedPhone.codeVerificationStatus === "VERIFIED");
		}
		else {
			$( this.inconcertCloudApiVerifyPhone ).hide();
			$( this.inconcertCloudApiRegisterPhone ).hide();
		}
		
		$(this.smoochAuthorizeButton).val(!on_or_off ? "<%=_T('Authorize Application')%>" : "<%=_T('Re-Authorize Application')%>");
		$(this.smoochAuthorizeImage).toggleClass('formImageTrue', on_or_off).toggleClass('formImageFalse', !on_or_off);
		$(this.smoochPhone)
			.prop("disabled", true)
			.addClass("readonly");
	
		$(this.infobipAuthorizeButton).val(!on_or_off ? "<%=_T('Authorize Application')%>" : "<%=_T('Re-Authorize Application')%>");
		$(this.infobipAuthorizeImage).toggleClass('formImageTrue', on_or_off).toggleClass('formImageFalse', !on_or_off);
		$(this.infobipUserName + ", " + this.infobipBaseUrl + ", " + this.infobipPhone)
			.prop("disabled", true)
			.addClass("readonly");
	
		$(this.businessAuthorizeButton).val(!on_or_off ? "<%=_T('Authorize Application')%>" : "<%=_T('Re-Authorize Application')%>");
		$(this.businessAuthorizeImage).toggleClass('formImageTrue', on_or_off).toggleClass('formImageFalse', !on_or_off);
		$(this.businessUserName + ", " + this.businessBaseUrl + ", " + this.businessPhone)
			.prop("disabled", true)
			.addClass("readonly");
	};

	/**
	 * Called when the user enter to account edition
	 *
	 * @public
	 */
	WHATSAPPAccountPanel.prototype.empty_controls = function()
	{
		WHATSAPPAccountPanel.uber.empty_controls.call(this);

		$(this.name).val("");
		
		$(this.wavyUserName).val("");
		$(this.wavyUserToken).val("");

		$(this.inconcertCloudApiWaba).html("");
		$(this.inconcertCloudApiPhone).html("");
		$(this.inconcertCloudApiCodeVerificationStatus).val("");
		$(this.inconcertCloudApiPhoneStatus).val("");
		$(this.inconcertCloudApiTemplateNamespace).val("");
		$(this.inconcertCloudApiMessageLimit).val("");
		$(this.account_activation_code).val("");
		
		$(this.smoochPhone).val("");
		
		$(this.infobipUserName).val("");
		$(this.infobipUserToken).val("");
		$(this.infobipBaseUrl).val("");
		$(this.infobipPhone).val("");
		
		$(this.businessUserName).val("");
		$(this.businessUserToken).val("");
		$(this.businessBaseUrl).val("");
		$(this.businessPhone).val("");
		
		$(this.newContacts).prop("checked", false);
		
		$(this.integrationType)
			.prop("disabled", false)
			.val("ICC_CLOUD_API")
			.change();
		
		this.__toggle_controls(false);
	};

	WHATSAPPAccountPanel.prototype.get_account_name = function()
	{
		return this.current_account.name;
	};

	/**
	 * Called when the user enter to account edition
	 *
	 * @public
	 */
	WHATSAPPAccountPanel.prototype.edit = function(account)
	{
		let self = this;
		WHATSAPPAccountPanel.uber.edit.call( this, account );
		if ( !this.current_account ) {
			return;
		}

		$(this.name).val(this.current_account.name);
		let integrationType = this.current_account.integrationType || "WEB";
		$(this.integrationType)
			.prop("disabled", true)
			.val(integrationType)
			.change();
		$(this.account_activation_code)
			.prop("disabled", true);
		$(this.activation_code_disclaimer)
			.prop("disabled", true);
		switch(integrationType) {
			case "WEB":
				$(this.newContacts).prop("checked", this.current_account.newContacts === "1");
				break;
			case "WAVY":
				$(this.wavyUserName).val(this.current_account.userName);
				$(this.wavyUserToken).val(this.current_account.userToken);
				break;
			case "ICC_CLOUD_API":
				this.m_name = this.current_account.name;
				this.m_user_uid = this.current_account.uid;
				this.m_authorization_code = this.current_account.code;
				this.m_access_token = this.current_account.accessToken;
				if(this.current_account.wabaId && this.current_account.wabaName) {
					this.m_wabas = [];
					this.m_wabas.push({ id: this.current_account.wabaId, name: this.current_account.wabaName, phoneNumbers: [], message_template_namespace: this.current_account.message_template_namespace});
					this.parent.frm.fill_combo( $( this.inconcertCloudApiWaba ), false, this.m_wabas, "id", "name", "name" );

					$(this.inconcertCloudApiWaba)
						.prop("disabled", true)
						.val(this.current_account.wabaId);

					$(this.inconcertCloudApiTemplateNamespace)
						.prop("disabled", true)
						.val(this.current_account.message_template_namespace);

					if(this.current_account.phoneId && this.current_account.phoneNumber) {
						this.m_wabas[0].phoneNumbers.push({ phoneId: this.current_account.phoneId, phoneNumber: this.current_account.phoneNumber, phoneStatus: this.current_account.phoneStatus, displayPhoneNumber: this.current_account.phoneNumber, messageLimit: this.current_account.messageLimit });
						this.parent.frm.fill_combo( $( this.inconcertCloudApiPhone ), false, this.m_wabas[0].phoneNumbers, "phoneId", "displayPhoneNumber", "displayPhoneNumber" );

						$(this.inconcertCloudApiPhone)
							.prop("disabled", true)
							.val(this.current_account.phoneId);

						// En lugar de asumir que el code_verification_status, status y el message limit son los que indica la cuenta, los consulto al proxy
						let campaign = self.parent.frm.get_entity_instance();
						inConcert.invoke({
							url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_get_phone_status/",
							type: "POST",
							data: JSON.stringify({
								campaignId : campaign.Id,
								accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
								phoneId: $( self.inconcertCloudApiPhone ).val()
							}),
							dataType: "json",
							contentType: "application/json",
							success: function(response) {
								let codeVerificationStatus = response.result === "OK" ? response.code_verification_status : "";
								$( self.inconcertCloudApiCodeVerificationStatus ).val(_T(codeVerificationStatus));

								let phoneStatus = response.result === "OK" ? response.status : "";
								$( self.inconcertCloudApiPhoneStatus ).val(_T(phoneStatus));

								let messageLimit = response.result === "OK" ? response.messaging_limit : "";
								$( self.inconcertCloudApiMessageLimit ).val(messageLimit >= 0 ? messageLimit : _T("Unlimited"));

								let selectedWaba = self.m_wabas && self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
								let selectedPhone = selectedWaba && selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());
								if(selectedPhone) {
									selectedPhone.codeVerificationStatus = codeVerificationStatus;
									selectedPhone.phoneStatus = phoneStatus;
									selectedPhone.messageLimit = messageLimit;
									$( self.inconcertCloudApiVerifyPhone ).toggle(selectedPhone.codeVerificationStatus !== "VERIFIED");
									$( self.inconcertCloudApiRegisterPhone ).text((selectedPhone.phoneStatus === "CONNECTED") ? "<%=_T('Deregister Phone')%>" : "<%=_T('Register Phone')%>");
									$( self.inconcertCloudApiRegisterPhone ).toggle(selectedPhone.codeVerificationStatus === "VERIFIED");
								}
								else {
									$( self.inconcertCloudApiVerifyPhone ).hide();
									$( self.inconcertCloudApiRegisterPhone ).hide();
								}
							},
							error: function() {
								$( self.inconcertCloudApiCodeVerificationStatus ).val("");
								$( self.inconcertCloudApiPhoneStatus ).val("");
								$( self.inconcertCloudApiMessageLimit ).val("");
							}
						});
					}
				}
				$( self.account_activation_code ).val(this.current_account.activation_code);
				break;
			case "SMOOCH":
				$(this.smoochPhone).val(this.current_account.phoneNumber);
				break;
			case "INFOBIP":
				$(this.infobipUserName).val(this.current_account.userName);
				$(this.infobipUserToken).val(this.current_account.userToken);
				$(this.infobipBaseUrl).val(this.current_account.baseUrl);
				$(this.infobipPhone).val(this.current_account.phoneNumber);
				break;
			case "BUSINESS":
				$(this.businessUserName).val(this.current_account.userName);
				$(this.businessUserToken).val(this.current_account.userToken);
				$(this.businessBaseUrl).val(this.current_account.baseUrl);
				$(this.businessPhone).val(this.current_account.phoneNumber);
				break;
		}
		this.m_authorizedId = this.current_account.id;
		this.__toggle_controls(true);
	};

	/**
	 * Method to initialize tabs (basic & messages)
	 *
	 * @public
	 */
	WHATSAPPAccountPanel.prototype.initialize_tabs = function() {
		WHATSAPPAccountPanel.uber.initialize_tabs.call(this,
			{
				parent       : this                              ,
				frm          : this.parent.frm                   ,
				container_id : 'adm_form_campaign_accounts_tabs' ,
				tabs_list    : {
					basic : {
						id               : "basic",
						name             : "<%=_T('Whatsapp Config')%>",
						tab_container_id : 'adm_form_campaign_accounts_whatsapp_inconcert_config',
						selected         : true
					},
					messages : {
						id               : "messages",
						name             : "<%=_T('Messages')%>",
						tab_container_id : "adm_form_campaign_messages_whatsapp_panel" 
					}
				}
			}
		);
	};

	WHATSAPPAccountPanel.prototype.__makeAccountId = function() {
		let guid = inConcert.Utils.generateGuid();
		let campaign = this.parent.frm.get_entity_instance();
		return "WHATSAPP_" + campaign.Id + "_" + guid;
	};

	/**
	 * Validates WHATSAPP account fields.
	 *
	 * @todo Validate and save should be separated actions
	 *
	 * @public
	 *
	 * @return {Object}  result
	 * @return {Boolean} result.success
	 * @return {Boolean} result.is_new
	 *
	 * @return {Object}  [result.account]
	 * @return {String}  [result.account.id]
	 * @return {String}  [result.account.proxyType]
	 * @return {String}  [result.account.name]
	 * @return {String}  [result.account.CCAlgorithm]
	 *
	 * @return {String}  [result.error_message]
	 */
	WHATSAPPAccountPanel.prototype.validate = function()
	{
		const self = this;
		let result_survey_management;
		
		let is_new = this.is_new();
		let result = {
			success: false,
			is_new: is_new
		};

		this.hide_marked_errors();

		// NAME - validation
		let $name = $(this.name);
		if (!this.validate_field($name, "required", "<%=_T('Account name is required.')%>")) {
			return result;
		}
		if (!this.validate_field($name, "alpha", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Account Name.')%>")) {
			return result;
		}

		// DISTRIBUTION - validation
		let $distribution = $(this.distribution);
		if (!this.validate_field($distribution, "required", "<%=_T('Distribution is required.')%>")) {
			return result;
		}

		// PRIORITY - validation
		let $priority = $(this.priority);
		let has_att_levels = this.attention_levels_handle.count_selected() > 0;
		if (!has_att_levels && $priority.val().trim().length > 0) {
			let range = { between: { from: 0, to: 99 } }; // range attention_level value validation
			if (!this.validate_field($priority, "range", FORMAT("<%=_T('Account priority value out of range. Please enter account priority value between {0} and {1}.')%>", range.between.from, range.between.to ), range )) {
				return result;
			}
		}

		// LANGUAGE - validation
		let $language = $(this.language);
		if (!this.validate_field($language, "required", "<%=_T('Language is required.')%>")) {
			return result;
		}

		let account_id = !is_new? this.current_account.id : null;
		let integrationType = $(this.integrationType).val();

		var validate_hsm = function() {
			if (!self.hsm_mng_instance) {
				return {
					success: true
				};
			}
			let resp = self.hsm_mng_instance.validate_required();
			return resp;
		};

		let resp_hsm;
		switch(integrationType) {
			case "WEB":
				if (is_new) {
					if (!this.m_authorizedId) {
						this.show_validation_error( $(this.webAuthorizeButton),
							"<%=_T('Must authorize whatsapp account using QR.')%>");
						return result;
					}
					account_id = this.m_authorizedId;
				}
				break;
			case "WAVY":
				if (!this.validate_field($(this.wavyUserName), "required", "<%=_T('User name is required.')%>")) {
					return result;
				}
				if (!this.validate_field($(this.wavyUserToken), "required", "<%=_T('User token is required.')%>")) {
					return result;
				}
				resp_hsm = validate_hsm();
				break;
			case "ICC_CLOUD_API":
				if (is_new) {
					if (!this.validate_field($(this.account_activation_code), "required", "<%=_T('Activation Code is required.')%>")) {
						return result;
					}
					if (!this.m_authorizedId) {
						this.show_validation_error( $(this.inconcertCloudApiAuthorizeButton),
							"<%=_T('Must authorize whatsapp account.')%>");
						return result;
					}
					account_id = this.m_authorizedId;
				}
				if (!this.validate_field($(this.inconcertCloudApiWaba), "required", "<%=_T('Whatsapp Business Account is required.')%>")) {
					return result;
				}
				if (!this.validate_field($(this.inconcertCloudApiPhone), "required", "<%=_T('Phone is required.')%>")) {
					return result;
				}

				let selectedWaba = this.m_wabas.find(waba => waba.id === $(this.inconcertCloudApiWaba).val());
				let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(this.inconcertCloudApiPhone).val());
				if (selectedPhone.phoneStatus !== "CONNECTED") {
					this.show_validation_error( $(this.inconcertCloudApiPhone),
						"<%=_T('Phone must be CONNECTED.')%>");
					return result;
				}				

				resp_hsm = validate_hsm();
				break;
			case "SMOOCH":
				if (is_new) {
					if (!this.m_authorizedId) {
						this.show_validation_error( $(this.smoochAuthorizeButton),
							"<%=_T('Must authorize whatsapp account.')%>");
						return result;
					}
					account_id = this.m_authorizedId;
				}
				resp_hsm = validate_hsm();
				break;
			case "INFOBIP":
				if (is_new) {
					if (!this.m_authorizedId) {
						this.show_validation_error( $(this.infobipAuthorizeButton),
							"<%=_T('Must authorize whatsapp account.')%>");
						return result;
					}
					account_id = this.m_authorizedId;
				}
				resp_hsm = validate_hsm();
				break;
			case "BUSINESS":
				if (is_new) {
					if (!this.m_authorizedId) {
						this.show_validation_error( $(this.businessAuthorizeButton),
							"<%=_T('Must authorize whatsapp account.')%>");
						return result;
					}
					account_id = this.m_authorizedId;
				}
				resp_hsm = validate_hsm();
				break;
		}

		if (resp_hsm && !resp_hsm.success) {
			this.show_validation_error(null, resp_hsm.message);
			return result;
		}

		result.success = false;

		// valido los skills ----------
		let result_skills = this.validate_skills();
		if ( !result_skills.success ) {
			this.show_validation_error( result_skills.$ctrl, result_skills.message );
			return result;
		}

		// valido los attention levels ----------
		let result_attention_levels = this.validate_attention_levels();
		if ( !result_attention_levels.success ) {
			this.show_validation_error(
				result_attention_levels.$ctrl,
				result_attention_levels.message,
				false, //timeout_ms
				true, //scrolling
				result_attention_levels.show_custom_button
			);
			return result;
		}

		// validate ticket configuration
		let result_ticket_emitter = this.validate_ticket_emitter();
		if (!result_ticket_emitter.success) {
			this.show_validation_error( result_ticket_emitter.$ctrl, result_ticket_emitter.error_message );
			return result;
		}

		// valido los contact mng ----------
		let result_contact_mng = this.validate_contact_mng();
		if ( !result_contact_mng.success ) {
			this.show_validation_error( result_contact_mng.$ctrl, result_contact_mng.error_message );
			return result;
		}

		// valido los flows mng ----------
		let result_flows_mng = this.validate_flows_mng();
		if ( !result_flows_mng.success ) {
			this.show_validation_error( result_flows_mng.$ctrl, result_flows_mng.error_message );
			return result;
		}

		// valido la configuracion de survey ----------
		result_survey_management = self.validate_survey();
		if ( !result_survey_management.success ) {
			self.show_validation_error( result_survey_management.$ctrl, result_survey_management.error_message );
			return result;
		}

		// valido los hsm maker mng ----------
		let result_hsm_mng = this.validate_hsm_mng();
		if ( !result_hsm_mng.success ) {
			this.show_validation_error( result_hsm_mng.$ctrl, result_hsm_mng.error_message );
			return result;
		}

		// valido los messages de la account ----------
		let result_messages = this.validate_messages();
		if ( !result_messages.success ) {
			this.show_validation_error( undefined, result_messages.error_message );
			return result;
		}

		// valido los thresholds ----------
		let result_th = this.validate_thresholds();
		if ( !result_th.success ) {
			this.show_validation_error( result_th.$ctrl, result_th.error_message );
			return result;
		}

		let name = $name.val();

		let account = {
		// atributos comunes entre diferentes tipos de cuentas
			id                 : account_id || this.__makeAccountId(),
			proxyType          : "WHATSAPP",
			uid                : name,
			name               : name,
			integrationType    : integrationType,
			CCAlgorithm        : $distribution.val(),
			language           : $language.val(),
			TicketEmitter      : result_ticket_emitter.result,
			Skills             : this.skills_handle.get(),
			Priority           : $priority.val(),
			AttentionLevels    : this.attention_levels_handle.get(),
			GUI                : this.get_gui_config(),
			Survey             : result_survey_management.result,
			ActionOnAcdWaitTimeout : result_th.ActionOnAcdWaitTimeout,
			InactivityTimeout : result_th.InactivityTimeout,
			ignoreAgentAssignedFromReOpen : $(this.ignoreAgent).prop("checked")? "1" : "0"
		};
		switch(integrationType) {
			case "WEB":
				account.newContacts = get_chk_bool_to_string(this.newContacts);
				break;
			case "WAVY":
				account.userName = $(this.wavyUserName).val();
				account.userToken = $(this.wavyUserToken).val();
				break;
			case "ICC_CLOUD_API":
				account.code = this.m_authorization_code;
				account.accessToken = this.m_access_token;
				account.wabaId = $(this.inconcertCloudApiWaba).val();
				account.wabaName = $(this.inconcertCloudApiWaba + " option:selected").text();
				account.phoneId = $(this.inconcertCloudApiPhone).val();
				let selectedWaba = this.m_wabas.find(waba => waba.id === account.wabaId);
				account.message_template_namespace = selectedWaba.message_template_namespace;
				let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === account.phoneId);
				account.phoneNumber = selectedPhone.phoneNumber;
				account.codeVerificationStatus = selectedPhone.codeVerificationStatus;
				account.phoneStatus = selectedPhone.phoneStatus;
				account.activation_code = $(this.account_activation_code).val();
				account.messageLimit = selectedPhone.messageLimit;
				break;
			case "SMOOCH":
				account.phoneNumber = $(this.smoochPhone).val();
				break;
			case "INFOBIP":
				account.userName = $(this.infobipUserName).val();
				account.userToken = $(this.infobipUserToken).val();
				account.baseUrl = $(this.infobipBaseUrl).val();
				account.phoneNumber = $(this.infobipPhone).val();
				break;
			case "BUSINESS":
				account.userName = $(this.businessUserName).val();
				account.userToken = $(this.businessUserToken).val();
				account.baseUrl = $(this.businessBaseUrl).val();
				account.phoneNumber = $(this.businessPhone).val();
				break;
		}

		this.contact_mng_instance.attach_data(account);
		if (this.flow_mng_instance) {
			this.flow_mng_instance.attach_data( account );
		}
		if (this.qna_maker_mng_instance) {
			this.qna_maker_mng_instance.attach_data(account);
		}
		if (this.hsm_mng_instance) {
			this.hsm_mng_instance.attach_data(account);
		}

		result.account = account;
		result.success = true;

		return result;
	};

	WHATSAPPAccountPanel.prototype.__on_app_authorized = function(data, close_popup_window) {
		const self = this;
		if(close_popup_window) {
			close_popup_window();
		}
		this.m_authorizedId = this.m_authorizingId;
		switch($(this.integrationType).val()) {
			case "SMOOCH":
				$(this.smoochPhone).val(this.m_authorizingPhone);
				break;
			case "ICC_CLOUD_API":
				this.m_authorization_code = data.authorization_code;
				this.m_access_token = data.access_token;
				this.m_user_uid = data.uid;
				this.m_name = data.name;
				$(this.inconcertCloudApiWaba).html("").prop("disabled", false);
				$(this.inconcertCloudApiPhone).html("").prop("disabled", false);
				$(this.inconcertCloudApiCodeVerificationStatus).val("");			
				$(this.inconcertCloudApiPhoneStatus).val("");			
				$(this.inconcertCloudApiTemplateNamespace).val("");
				$(this.inconcertCloudApiMessageLimit).val("");	
				if(data.wabas) {
					try {
						this.m_wabas = JSON.parse(data.wabas);
						if(this.m_wabas.length === 0) {
							this.parent.frm.show_status_message("<%=_T('No WhatsApp Business Accounts defined')%>", "Error", 5000);
							return;
						}
						let fullOnboarding = $("#adm_form_whatsapp_account_authorizate_full").is(":checked");
						if(fullOnboarding) {
							this.parent.frm.fill_combo( $( this.inconcertCloudApiWaba ), false, this.m_wabas, "id", "name" );
							$( this.inconcertCloudApiWaba )
								.val(this.m_wabas[0] && this.m_wabas[0].id)
								.change();
							this.__closeAuthorizationPopup();
						}
						else { //Migrate phone
							$( "#adm_form_whatsapp_account_authorizate_migrate_source_waba" ).unbind('change').bind('change', function() {
								let wabaId = $(this).val();
								let waba = wabaId && self.m_wabas.find(waba => waba.id === wabaId);
								$( "#adm_form_whatsapp_account_authorizate_migrate_source_phone" ).html("");
								if(waba && waba.phoneNumbers) {
									self.parent.frm.fill_combo( $( "#adm_form_whatsapp_account_authorizate_migrate_source_phone" ), false, waba.phoneNumbers, "phoneId", "displayPhoneNumber", "displayPhoneNumber" );
								}
							});
							this.parent.frm.fill_combo( $( "#adm_form_whatsapp_account_authorizate_migrate_source_waba" ), false, this.m_wabas, "id", "name", "name" );
							this.parent.frm.fill_combo( $( "#adm_form_whatsapp_account_authorizate_migrate_destination_waba" ), false, this.m_wabas, "id", "name", "name" );
							$( "#adm_form_whatsapp_account_authorizate_migrate_source_waba" ).change();
							$("#adm_form_whatsapp_account_authorizate_popup_title").text("<%=_T('Migrate Phone')%>");
							$("#adm_account_authorizate_option_container").hide();	
							$("#adm_form_whatsapp_account_authorizate_migrate_source_container").show();
							$("#adm_form_whatsapp_account_authorizate_migrate_destination_container").show();
							$("#adm_form_whatsapp_account_authorizate_start").text("<%=_T('Migrate')%>");
							this.m_migration_step = "migrating";
						}
					}
					catch(e) {
						console.error(e);
						this.parent.frm.show_status_message("<%=_T('Error doing authorization')%>", "Error", 5000);
						this.m_wabas = undefined;
					}
				} 
				return;	//avoid toggle controls here
			case "INFOBIP":
				$(this.infobipUserName).val(this.m_authorizingUserName);
				$(this.infobipUserToken).val(this.m_authorizingUserToken);
				$(this.infobipBaseUrl).val(this.m_authorizingBaseUrl);
				$(this.infobipPhone).val(this.m_authorizingPhone);
				break;
			case "BUSINESS":
				this.m_authorizingPhone = data.phoneNumber;
				$(this.businessUserName).val(this.m_authorizingUserName);
				$(this.businessUserToken).val(this.m_authorizingUserToken);
				$(this.businessBaseUrl).val(this.m_authorizingBaseUrl);
				$(this.businessPhone).val(this.m_authorizingPhone);
				break;
		}
		this.__toggle_controls(true);
	};

	WHATSAPPAccountPanel.prototype.on_show = function()
	{
		WHATSAPPAccountPanel.uber.on_show.call(this);
		
		$(this.name).focus();
	};

	WHATSAPPAccountPanel.prototype.on_saved = function(new_account, current_account, callback = $.noop)
	{
		WHATSAPPAccountPanel.uber.on_saved.call(this, new_account, current_account, callback);

		var self = this;

		if ( new_account.Survey ) {
			var project_id = new_account.Survey.id;
			var token = new_account.Survey.Token;

			if ( !project_id ) { return; }

			var tweety = inConcert.app.getTweetyAPI();

			return tweety.set_authfilter( project_id, token,
				function( success )
				{
					if( !success ) {
						var error_message = "<%=_T('Error setting auth filter to survey.')%>";
						var timeout_ms = 3000;
						self.parent.frm.show_status_message( error_message, "Error", timeout_ms );
					}
				}
			);
		}
	};

	/**
	 * Called once the panel is initialized, we can attach buttons events here.
	 *
	 * @public
	 */
	WHATSAPPAccountPanel.prototype.set_events = function()
	{
		WHATSAPPAccountPanel.uber.set_events.call( this );

		let self = this;

		$(this.webAuthorizeButton).unbind('click').bind('click', function() {
			if ( !self.parent.has_permission_to_save() ) {
				let message = "<%=_T('You do not have permissions for save account.')%>";
				self.parent.frm.show_status_message( message, 'Error', 5000 );
				return;
			}
			self.__openAuthorizationPopup();
		});

		$(this.inconcertCloudApiAuthorizeButton)
			.unbind('click')
			.bind('click', function() {
				if ( !self.parent.has_permission_to_save() ) {
					let message = "<%=_T('You do not have permissions for save account.')%>";
					self.parent.frm.show_status_message( message, 'Error', 5000 );
					return;
				}
				if(self.is_new()) {
					if (!self.validate_field($(self.account_activation_code), "required", "<%=_T('Activation Code is required.')%>")) {
						return;
					}				
					self.m_authorizingId = self.m_authorizingId || self.m_authorizedId || self.__makeAccountId();
					self.parent.frm.dashboard.show_waiting("<%=_T('Validating activation code')%>");
					let campaign = self.parent.frm.get_entity_instance();
					inConcert.invoke({
						url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_validate_activation_code/",
						type: "POST",
						data: JSON.stringify({
							campaignId : campaign.Id,
							accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
							code: $(self.account_activation_code).val()
						}),
						dataType: "json",
						contentType: "application/json",
						success: function(response) {
							self.parent.frm.dashboard.hide_waiting();
							if(response.result === "OK") {
								$(self.account_activation_code).prop("disabled", true);
								self.__openAuthorizationPopup();
							}
							else {
								self.parent.frm.show_status_message("<%=_T('Unknown error')%>", "Error", 5000);
							}
						},
						error: function(_, text_status) {
							var err = text_status.reason || "Unknown error";
							self.parent.frm.dashboard.hide_waiting();
							self.parent.frm.show_status_message(_T(err), "Error", 5000);
						}
					});	
				}
				else {
					self.__openAuthorizationPopup();
				}			
			});	

		$(this.smoochAuthorizeButton + ", " + this.infobipAuthorizeButton + ", " + this.businessAuthorizeButton)
			.unbind('click')
			.bind('click', function() {
				if ( !self.parent.has_permission_to_save() ) {
					let message = "<%=_T('You do not have permissions for save account.')%>";
					self.parent.frm.show_status_message( message, 'Error', 5000 );
					return;
				}
				self.__openAuthorizationPopup();
			});		

		$(this.integrationType).unbind('change').bind('change', function() {
			let integration_type = $(this).val();
			self.m_authorizedId = null;
			$("[row_toggle_integration_type]")
				.hide()
				.filter(FORMAT("[row_toggle_integration_type={0}]", integration_type))
					.show();
			self.__set_integration_type(integration_type);
		});

		$(this.inconcertCloudApiWaba).unbind('change').bind('change', function() {
			let wabaId = $(this).val();
			let waba = wabaId && self.m_wabas.find(waba => waba.id === wabaId);
			$( self.inconcertCloudApiPhone ).html("");
			$( self.inconcertCloudApiCodeVerificationStatus ).val("");
			$( self.inconcertCloudApiPhoneStatus ).val("");
			$( self.inconcertCloudApiTemplateNamespace ).val(waba && waba.message_template_namespace ? waba.message_template_namespace : "");
			$( self.inconcertCloudApiMessageLimit ).val("");
			if(waba && waba.phoneNumbers) {
				self.parent.frm.fill_combo( $( self.inconcertCloudApiPhone ), false, waba.phoneNumbers, "phoneId", "displayPhoneNumber", "displayPhoneNumber" );
				let selectedPhone = ((self.current_account && self.current_account.phoneId && waba.phoneNumbers.find(phone => phone.phoneId === self.current_account.phoneId)) || waba.phoneNumbers[0]);
				$( self.inconcertCloudApiPhone )
					.prop("disabled", false)
					.val(selectedPhone && selectedPhone.phoneId)
					.change();					
			}
		});

		$(this.inconcertCloudApiPhone).unbind('change').bind('change', function() {
			let wabaId = $( self.inconcertCloudApiWaba ).val();
			let phoneId = $(this).val();
			let waba = wabaId && self.m_wabas.find(waba => waba.id === wabaId);
			let phone = waba && waba.phoneNumbers && waba.phoneNumbers.find(phone => phone.phoneId === phoneId);
			$( self.inconcertCloudApiCodeVerificationStatus ).val(_T((phone && phone.codeVerificationStatus) ? phone.codeVerificationStatus : ""));
			$( self.inconcertCloudApiPhoneStatus ).val(_T((phone && phone.phoneStatus) ? phone.phoneStatus : ""));
			$( self.inconcertCloudApiMessageLimit ).val((phone && phone.messageLimit) ? (phone.messageLimit >= 0 ? phone.messageLimit : _T("Unlimited")) : "");
			if(phone) {
				$( self.inconcertCloudApiVerifyPhone ).toggle(phone.codeVerificationStatus !== "VERIFIED");
				$( self.inconcertCloudApiRegisterPhone ).text((phone.phoneStatus === "CONNECTED") ? "<%=_T('Deregister Phone')%>" : "<%=_T('Register Phone')%>");
				$( self.inconcertCloudApiRegisterPhone ).toggle(phone.codeVerificationStatus === "VERIFIED");
			}
			else {
				$( self.inconcertCloudApiVerifyPhone ).hide();
				$( self.inconcertCloudApiRegisterPhone ).hide();
			}			
		});

		$(this.inconcertCloudApiVerifyPhone)
			.unbind('click')
			.bind('click', function() {
				if ( !self.parent.has_permission_to_save() ) {
					let message = "<%=_T('You do not have permissions for save account.')%>";
					self.parent.frm.show_status_message( message, 'Error', 5000 );
					return;
				}
				let selectedWaba = self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
				let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());
				if(selectedPhone && selectedPhone.codeVerificationStatus !== "VERIFIED") {		
					self.m_verification_step = null;
					self.__openPhoneVerificationPopup();						
				}				
			});	

		$(this.inconcertCloudApiRegisterPhone)
			.unbind('click')
			.bind('click', function() {
				if ( !self.parent.has_permission_to_save() ) {
					let message = "<%=_T('You do not have permissions for save account.')%>";
					self.parent.frm.show_status_message( message, 'Error', 5000 );
					return;
				}
				let selectedWaba = self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
				let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());
				if(selectedPhone) {		
					self.__openPhoneRegisterPopup(selectedPhone.phoneStatus !== "CONNECTED");						
				}				
			});	
	};

	WHATSAPPAccountPanel.prototype.__set_integration_type = function(integration_type) 
	{
		if (!this.hsm_mng_instance) {
			return;
		}
		this.hsm_mng_instance.set_integration_type(integration_type);
	};

	WHATSAPPAccountPanel.prototype.__makeWebAuthorizationPopup = function() 
	{
		let $popup = $("".concat(
			'<div id="adm_form_whatsapp_account_authorizate" class="internalPopUpContainer popUp520w formPopUp" style="">',
				'<div class="internalPopUpOverlay"></div>' ,
				'<div class="internalPopUp">',

					// title
					'<div class="internalPopUpTitle">',
						'<label>', "<%=_T('Authorize Application in Whatsapp Web')%>", '</label>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					// content
					'<div class="internalPopUpMiddle pageFormContainer">',
						'<div class="row">',
							'<div id="adm_form_whatsapp_account_qr_container" class="whatsappQrContainer loadingQr col-12 mt-3 mb-4">',
								'<div waiting_message="true" class="loadingWaitingMessage">',
									'<%=_T("Loading QR")%>',
								'</div>',
								'<div class="loadingWaitingAnimation"></div>',
								'<div class="loadingWaitingOverlay"></div>',
							'</div>',
						'</div>',
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
						'<button id="adm_form_whatsapp_account_authorizate_cancel" class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
					'</div>' ,

				'</div>',
			'</div>'
		));
		return $popup;
	};
	
	WHATSAPPAccountPanel.prototype.__makeSmoochAuthorizationPopup = function() 
	{
		let self = this;
		let $popup = $("".concat(
			'<div id="adm_form_whatsapp_account_authorizate" class="internalPopUpContainer popUp520w formPopUp" style="">',
				'<div class="internalPopUpOverlay"></div>' ,
				'<div class="internalPopUp">',

					// waiting
					'<div id="adm_form_whatsapp_account_loading_container" class="internalWaitingContainer whatsappLoadingIntegrationContainer" hidden>',
						'<div waiting_message="true" class="internalWaitingMessage">',
							'<%=_T("Starting integration")%>',
						'</div>',
						'<div class="internalWaitingAnimation"></div>',
						'<div class="internalWaitingOverlay"></div>',
					'</div>',

					// title
					'<div class="internalPopUpTitle">',
						'<label>', '<%=_T("Authorize Application")%>', '</label>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					// content
					'<div class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div id="adm_form_whatsapp_account_authorizate_error" class="genericFormMessagesContainer messageError" hidden style="display: none;">',
							'<label class="messageText"></label>',
						'</div>',

						// form
						'<div class="no-card">' ,
							'<div class="card-block">' ,
								'<div class="row">' ,
									'<div class="col-12">' ,
										'<div class="form-group">' ,
											'<label for="adm_form_whatsapp_account_authorizate_phone" class="required"><%=_T("Phone")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_phone" class="form-control" type="text" placeholder="', '<%=_T("Enter phone number")%>...', '" />',
											'<i id="adm_form_whatsapp_account_authorizate_phone_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>' ,
									'</div>' ,
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_certificate" class="required"><%=_T("Certificate")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_certificate" class="form-control" type="text"/>',
											'<i id="adm_form_whatsapp_account_authorizate_certificate_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_verification" class="required"><%=_T("Verification Method")%><%=_T(":")%></label>',
											'<select id="adm_form_whatsapp_account_authorizate_verification" class="form-control">',
												'<option value="sms"><%=_T("Sms")%></option>',
												'<option value="voice"><%=_T("Voice (phone call)")%></option>',
											'</select>',
											'<i id="adm_form_whatsapp_account_authorizate_verification_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12" hidden>',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_code" class="required"><%=_T("Verification Code")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_code" class="form-control" type="text"/>',
											'<i id="adm_form_whatsapp_account_authorizate_code_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									
								'</div>' ,
							'</div>' ,
						'</div>' ,

						
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
						'<button id="adm_form_whatsapp_account_authorizate_start" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Start")%> </button>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel" class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
					'</div>' ,

				'</div>',
			'</div>'
		));

		if (SMOOCH_AUTHORIZATION === "MANUAL") {
			$popup.find("#adm_form_whatsapp_account_authorizate_certificate, #adm_form_whatsapp_account_authorizate_verification")
				.parent().parent().hide();
			$popup.find("#adm_form_whatsapp_account_authorizate_certificate").val("dummy");
		}

		$popup.find("#adm_form_whatsapp_account_authorizate_phone").val($(self.smoochPhone).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_start").click(function() {
			self.__startAuthorization();
		});

		return $popup;
	};

	WHATSAPPAccountPanel.prototype.__makeInfobipAuthorizationPopup = function() 
	{
		let self = this;
		let disclaimer = FORMAT("<%=_T('Login to infobip and enter to {0} to find it. Example: {1}')%>",
			"https://dev.infobip.com/getting-started/base-url",
			"https://qzlnr.api.infobip.com/");
		let $popup = $("".concat(
			'<div id="adm_form_whatsapp_account_authorizate" class="internalPopUpContainer popUp520w formPopUp" style="">',
				'<div class="internalPopUpOverlay"></div>' ,
				'<div class="internalPopUp">',

					// waiting
					'<div id="adm_form_whatsapp_account_loading_container" class="internalWaitingContainer whatsappLoadingIntegrationContainer" hidden>',
						'<div waiting_message="true" class="internalWaitingMessage">',
							'<%=_T("Starting integration")%>',
						'</div>',
						'<div class="internalWaitingAnimation"></div>',
						'<div class="internalWaitingOverlay"></div>',
					'</div>',

					// title
					'<div class="internalPopUpTitle">',
						'<label>', '<%=_T("Authorize Application")%>', '</label>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					// content
					'<div class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div id="adm_form_whatsapp_account_authorizate_error" class="genericFormMessagesContainer messageError" hidden style="display: none;">',
							'<label class="messageText"></label>',
						'</div>',

						// form
						'<div class="no-card">' ,
							'<div class="card-block">' ,
								'<div class="row">' ,
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_userName" class="required">', "<%=_T([[User Name]])%>", '<%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_userName" class="form-control" type="text" placeholder="<%=_T("Enter username")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_userName_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_userToken" class="required"><%=_T("User Password")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_userToken" class="form-control" autocomplete="new-password" type="password" placeholder="<%=_T("Enter password")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_userToken_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_baseUrl" class="required"><%=_T("Base Url")%><%=_T(":")%> <span class="fa fa-question-circle" title="', disclaimer, '"></span></label>',
											'<input id="adm_form_whatsapp_account_authorizate_baseUrl" class="form-control" type="text" placeholder="<%=_T("Enter the URL")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_baseUrl_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_phone" class="required"><%=_T("Phone")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_phone" class="form-control" type="text" placeholder="<%=_T("Enter phone number")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_phone_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
						'<button id="adm_form_whatsapp_account_authorizate_start" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Start")%> </button>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel" class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
					'</div>' ,
				'</div>',
			'</div>'
		));

		$popup.find("#adm_form_whatsapp_account_authorizate_userName").val($(self.infobipUserName).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_userToken").val($(self.infobipUserToken).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_baseUrl").val($(self.infobipBaseUrl).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_phone").val($(self.infobipPhone).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_start").click(function() {
			self.__startAuthorization();
		});

		return $popup;
	};
	
	WHATSAPPAccountPanel.prototype.__makeBusinessAuthorizationPopup = function() 
	{
		let self = this;
		let disclaimer = FORMAT("<%=_T('Docker url. Example: {0}')%>", "https://52.225.130.179:9090/");
		let $popup = $("".concat(
			'<div id="adm_form_whatsapp_account_authorizate" class="internalPopUpContainer popUp520w formPopUp" style="">',
				'<div class="internalPopUpOverlay"></div>' ,
				'<div class="internalPopUp">',

					// waiting
					'<div id="adm_form_whatsapp_account_loading_container" class="internalWaitingContainer whatsappLoadingIntegrationContainer" hidden>',
						'<div waiting_message="true" class="internalWaitingMessage">',
							'<%=_T("Starting integration")%>',
						'</div>',
						'<div class="internalWaitingAnimation"></div>',
						'<div class="internalWaitingOverlay"></div>',
					'</div>',

					// title
					'<div class="internalPopUpTitle">',
						'<label>', '<%=_T("Authorize Application")%>', '</label>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					// content
					'<div class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div id="adm_form_whatsapp_account_authorizate_error" class="genericFormMessagesContainer messageError" hidden style="display: none;">',
							'<label class="messageText"></label>',
						'</div>',

						// form
						'<div class="no-card">' ,
							'<div class="card-block">' ,
								'<div class="row">' ,
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_userName" class="required">', "<%=_T([[User Name]])%>", '<%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_userName" class="form-control" type="text" placeholder="<%=_T("Enter username")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_userName_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_userToken" class="required"><%=_T("User Password")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_userToken" class="form-control" type="password" autocomplete="new-password" placeholder="<%=_T("Enter password")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_userToken_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_baseUrl" class="required"><%=_T("Base Url")%><%=_T(":")%> <span class="fa fa-question-circle" title="', disclaimer, '"></span></label>',
											'<input id="adm_form_whatsapp_account_authorizate_baseUrl" class="form-control" type="text" placeholder="<%=_T("Enter the URL")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_baseUrl_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_phone" class="required"><%=_T("Phone")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_phone" class="form-control" type="text" placeholder="<%=_T("Enter phone number")%>..." />',
											'<i id="adm_form_whatsapp_account_authorizate_phone_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
						'<button id="adm_form_whatsapp_account_authorizate_start" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Start")%> </button>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel" class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
					'</div>' ,
				'</div>',
			'</div>'
		));

		$popup.find("#adm_form_whatsapp_account_authorizate_userName").val($(self.businessUserName).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_userToken").val($(self.businessUserToken).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_baseUrl").val($(self.businessBaseUrl).val() || "");
		$popup.find("#adm_form_whatsapp_account_authorizate_start").click(function() {
			self.__startAuthorization();
		});

		return $popup;
	};
	
	WHATSAPPAccountPanel.prototype.__makeCloudApiAuthorizationPopup = function() 
	{
		let self = this;
		let $popup = $("".concat(
			'<div id="adm_form_whatsapp_account_authorizate" class="internalPopUpContainer popUp520w formPopUp" style="">',
				'<div class="internalPopUpOverlay"></div>' ,
				'<div class="internalPopUp">',

					// waiting
					'<div id="adm_form_whatsapp_account_loading_container" class="internalWaitingContainer whatsappLoadingIntegrationContainer" hidden>',
						'<div waiting_message="true" class="internalWaitingMessage">',
							'<%=_T("Starting integration")%>',
						'</div>',
						'<div class="internalWaitingAnimation"></div>',
						'<div class="internalWaitingOverlay"></div>',
					'</div>',

					// title
					'<div id="adm_form_whatsapp_account_authorizate_popup_title" class="internalPopUpTitle">',
						'<label>', '<%=_T("Authorize Application")%>', '</label>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					// content
					'<div class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div id="adm_form_whatsapp_account_authorizate_error" class="genericFormMessagesContainer messageError" hidden style="display: none;">',
							'<label class="messageText"></label>',
						'</div>',

						// form
						'<div class="no-card">' ,
							'<div class="card-block">' ,
								'<div id="adm_account_authorizate_option_container" class="row">' ,
									'<div class="col-12">',
										'<div class="form-group">',
											'<div class="form-radiobutton">',
												'<label for="adm_form_whatsapp_account_authorizate_full" class="form-radiobutton-label">',
													'<input type="radio" name="adm_account_authorizate_option" value="full" id="adm_form_whatsapp_account_authorizate_full" class="form-radiobutton-input">',
													'<span><%=_T("Onboarding")%></span>',
													'<i class="fa fa-question-circle" title="<%=_T("Select this option when you need: Create a Meta business account, or Create a WhatsApp business account, or Register a new phone in a WhatsApp business account. The phone must not be already register in WhatsApp.")%>"></i>',
												'</label>',
											'</div>',
											'<div class="form-radiobutton">',
												'<label for="adm_form_whatsapp_account_authorizate_migrate" class="form-radiobutton-label">',
													'<input type="radio" name="adm_account_authorizate_option" value="migrate" id="adm_form_whatsapp_account_authorizate_migrate" class="form-radiobutton-input">',
													'<span><%=_T("Migrate phone")%></span>',
													'<i class="fa fa-question-circle" title="<%=_T("Select this option when you need migrate a phone from a source WhatsApp business account to a destination WhatsApp business account, both existing in your Meta business account. If you dont have a destination WhatsApp business account, select the Onboarding option to create it. Once the destination WhatsApp business account is created close the Onboarding window and select this option.")%>"></i>',
												'</label>',
											'</div>',
										'</div>',
									'</div>',
								'</div>',
								'<div id="adm_form_whatsapp_account_authorizate_migrate_source_container" class="row" style="display:none;">' ,
									'<div class="col-6">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_migrate_source_waba" class="required"><%=_T("Source Whatsapp Business Account")%><%=_T(":")%></label>',
											'<select id="adm_form_whatsapp_account_authorizate_migrate_source_waba" class="form-control"></select>',
											'<i id="adm_form_whatsapp_account_authorizate_migrate_source_waba_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',					
									'<div class="col-6">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_migrate_source_phone" class="required"><%=_T("Phone to migrate")%><%=_T(":")%></label>',
											'<select id="adm_form_whatsapp_account_authorizate_migrate_source_phone" class="form-control"></select>',
											'<i id="adm_form_whatsapp_account_authorizate_migrate_destination_phone_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
								'</div>',
								'<div id="adm_form_whatsapp_account_authorizate_migrate_destination_container" class="row" style="display:none;">' ,
									'<div class="col-6">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_migrate_destination_waba" class="required"><%=_T("Destination Whatsapp Business Account")%><%=_T(":")%></label>',
											'<select id="adm_form_whatsapp_account_authorizate_migrate_destination_waba" class="form-control"></select>',
											'<i id="adm_form_whatsapp_account_authorizate_migrate_destination_waba_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
								'</div>',
								'<div id="adm_form_whatsapp_account_authorizate_migrate_verification_method_container" class="row" style="display:none;">' ,		
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_migrate_verification_method" class="required"><%=_T("Verification Method")%><%=_T(":")%></label>',
											'<select id="adm_form_whatsapp_account_authorizate_migrate_verification_method" class="form-control">',
												'<option value="sms"><%=_T("Sms")%></option>',
												'<option value="voice"><%=_T("Voice (phone call)")%></option>',
											'</select>',
											'<i id="adm_form_whatsapp_account_authorizate_migrate_verification_method_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
								'</div>',	
								'<div id="adm_form_whatsapp_account_authorizate_migrate_verification_verify_code_container" class="row" style="display:none;">' ,		
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_authorizate_migrate_verification_verify_code" class="required"><%=_T("Verify code")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_authorizate_migrate_verification_verify_code" class="form-control" type="text"/>',
											'<i id="adm_form_whatsapp_account_authorizate_migrate_verification_verify_code_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-6">',
										'<div class="form-group">',
											'<label><%=_T("Have not you received the code?")%></label>',
										'</div>',
									'</div>',
									'<div class="col-6">',
										'<div class="form-group">',
											'<button id="adm_form_whatsapp_account_authorizate_migrate_verification_new_code" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Request another code")%> </button>',
										'</div>',
									'</div>',
								'</div>',				
							'</div>',
						'</div>',
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
						'<button id="adm_form_whatsapp_account_authorizate_start" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Start")%> </button>',
						'<button id="adm_form_whatsapp_account_authorizate_cancel" class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
					'</div>' ,
				'</div>',
			'</div>'
		));

		$popup.find("#adm_form_whatsapp_account_authorizate_start").click(function() {
			switch(self.m_migration_step) {
				case "migrating":
					self.__MigrateWhatsappPhone();
					break;
				case "request_verifying":
					self.__migrate_verifyPhone_request_code();
					break;
				case "verifying":
					self.__migrate_verifyPhone_verify_code();
					break;
				default:
					self.__openWhatsappOauthPopup();
					break;
			}
		});

		$popup.find("#adm_form_whatsapp_account_authorizate_migrate_verification_new_code").click(function() {
			if(self.m_migration_step === "verifying") {
				$("#adm_form_whatsapp_account_authorizate_popup_title").text("<%=_T('Request Phone Verification Code')%>");
				$("#adm_account_authorizate_option_container").hide();	
				$("#adm_form_whatsapp_account_authorizate_migrate_source_container").hide();
				$("#adm_form_whatsapp_account_authorizate_migrate_destination_container").hide();
				$("#adm_form_whatsapp_account_authorizate_migrate_verification_method_container").hide();
				$("#adm_form_whatsapp_account_authorizate_migrate_verification_verify_code_container").show();
				$("#adm_form_whatsapp_account_authorizate_start").text("<%=_T('Verify')%>");
				self.m_migration_step = "request_verifying";
			}
		});

		return $popup;
	};
	
	WHATSAPPAccountPanel.prototype.__openAuthorizationPopup = function()
	{
		let self = this;
		switch($(self.integrationType).val()) {
			case "WEB":
				self.$authorizationPopup = self.__makeWebAuthorizationPopup();
				break;
			case "ICC_CLOUD_API":
				self.$authorizationPopup = self.__makeCloudApiAuthorizationPopup();				
				break;

			case "SMOOCH":
				self.$authorizationPopup = self.__makeSmoochAuthorizationPopup();
				break;
			case "INFOBIP":
				self.$authorizationPopup = self.__makeInfobipAuthorizationPopup();
				break;
			case "BUSINESS":
				self.$authorizationPopup = self.__makeBusinessAuthorizationPopup();
				break;
		}
		$("body").append(self.$authorizationPopup);
		self.authorizationPopup = new inConcert.PopupWindow();
		self.authorizationPopup.show({
			ownerId         : "adm_form_whatsapp_account_authorizate",
			eventName       : "adm_form_whatsapp_account_authorizate",
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$authorizationPopup,
			callbacks: {
				onOpen: function() {
					self.$authorizationPopup.show();
				},
				onClose: function( callback ) {
					self.m_migration_step = null;
					callback = callback || $.noop;
					if (self.authorizationPopup) {
						self.authorizationPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});

		self.$authorizationPopup.find("#adm_form_whatsapp_account_authorizate_cancel").click(function() {
			self.__stopAuthorization();
		});

		self.$authorizationPopup.find("#adm_form_whatsapp_account_authorizate_cancel_times").click(function() {
			self.__stopAuthorization();
		});
		
		self.__onAuthorizationPopupOpen();
	};
	
	WHATSAPPAccountPanel.prototype.__onAuthorizationPopupOpen = function() {
		switch($(this.integrationType).val()) {
			case "WEB":
				this.__startAuthorization();
				break;
		}
	};
	
	WHATSAPPAccountPanel.prototype.__makeAuthorizationData = function() {
		let self = this;
		self.hide_marked_errors();
		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();
		let data = {
			integrationType : $(self.integrationType).val()
		};
		let $phone;
		switch(data.integrationType) {
			case "SMOOCH":
				//phone
				$phone = $("#adm_form_whatsapp_account_authorizate_phone");
				if (!self.validate_field($phone, "required", "<%=_T('Must enter a phone number.')%>", null, null, null, $error)) {
					return;
				}
				$phone.val($phone.val().replace(/[^0-9]/g, ""));
				if (!self.validate_field($phone, "digits", "<%=_T('Invalid phone.')%>", null, null, null, $error)) {
					return;
				}
				data.phoneNumber = $phone.val();
				self.m_authorizingPhone = data.phoneNumber;
				//certificate
				let $certificate = $("#adm_form_whatsapp_account_authorizate_certificate");
				if (!self.validate_field($certificate, "required", "<%=_T('Certificate is required.')%>", null, null, null, $error)) {
					return;
				}
				data.certificate = $certificate.val();
				//verificationMode
				let $verificationMode = $("#adm_form_whatsapp_account_authorizate_verification");
				data.verificationMode = $verificationMode.val();
				//ui
				$phone.prop("disabled", true);
				$certificate.prop("disabled", true);
				$verificationMode.prop("disabled", true);
				$("#adm_form_whatsapp_account_authorizate_start")
					.prop("disabled", true)
					.off("click");
				$("#adm_form_whatsapp_account_loading_container").show();
				break;
			case "INFOBIP": {
				//user name
				let $userName = $("#adm_form_whatsapp_account_authorizate_userName");
				if (!self.validate_field($userName, "required", "<%=_T('User name is required.')%>", null, null, null, $error)) {
					return;
				}
				data.userName = $userName.val();
				self.m_authorizingUserName = data.userName;
				//user password
				let $userToken = $("#adm_form_whatsapp_account_authorizate_userToken");
				if (!self.validate_field($userToken, "required", "<%=_T('User password is required.')%>", null, null, null, $error)) {
					return;
				}
				data.userToken = $userToken.val();
				self.m_authorizingUserToken = data.userToken;
				//base url
				let $baseUrl = $("#adm_form_whatsapp_account_authorizate_baseUrl");
				if (!self.validate_field($baseUrl, "required", "<%=_T('Base url is required.')%>", null, null, null, $error)) {
					return;
				}
				data.baseUrl = $baseUrl.val();
				self.m_authorizingBaseUrl = data.baseUrl;
				//phone
				$phone = $("#adm_form_whatsapp_account_authorizate_phone");
				if (!self.validate_field($phone, "required", "<%=_T('Must enter a phone number.')%>", null, null, null, $error)) {
					return;
				}
				$phone.val($phone.val().replace(/[^0-9]/g, ""));
				if (!self.validate_field($phone, "digits", "<%=_T('Invalid phone.')%>", null, null, null, $error)) {
					return;
				}
				data.phoneNumber = $phone.val();
				self.m_authorizingPhone = data.phoneNumber;
				//ui
				$userName.prop("disabled", true);
				$userToken.prop("disabled", true);
				$baseUrl.prop("disabled", true);
				$phone.prop("disabled", true);
				$("#adm_form_whatsapp_account_authorizate_start")
					.prop("disabled", true)
					.off("click");
				$("#adm_form_whatsapp_account_loading_container").show();
				break;
			}
			case "BUSINESS": {
				//user name
				let $userName = $("#adm_form_whatsapp_account_authorizate_userName");
				if (!self.validate_field($userName, "required", "<%=_T('User name is required.')%>", null, null, null, $error)) {
					return;
				}
				data.userName = $userName.val();
				self.m_authorizingUserName = data.userName;
				//user password
				let $userToken = $("#adm_form_whatsapp_account_authorizate_userToken");
				if (!self.validate_field($userToken, "required", "<%=_T('User password is required.')%>", null, null, null, $error)) {
					return;
				}
				data.userToken = $userToken.val();
				self.m_authorizingUserToken = data.userToken;
				//base url
				let $baseUrl = $("#adm_form_whatsapp_account_authorizate_baseUrl");
				if (!self.validate_field($baseUrl, "required", "<%=_T('Base url is required.')%>", null, null, null, $error)) {
					return;
				}
				data.baseUrl = $baseUrl.val();
				self.m_authorizingBaseUrl = data.baseUrl;
				//ui
				$userName.prop("disabled", true);
				$userToken.prop("disabled", true);
				$baseUrl.prop("disabled", true);
				$("#adm_form_whatsapp_account_authorizate_start")
					.prop("disabled", true)
					.off("click");
				$("#adm_form_whatsapp_account_loading_container").show();
				break;
			}
		}
		return data;
	};

	WHATSAPPAccountPanel.prototype.__startAuthorization = function() {
		let self = this;
		let data = self.__makeAuthorizationData();
		if (!data) {
			return;
		}
		self.m_authorizingId = self.m_authorizedId || self.__makeAccountId();
		self.m_lastStatus = "";
		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/start_whatsapp_authorization/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : self.m_authorizingId,
				data : data
			}),
			dataType: "json",
			contentType: "application/json",
			success: function()
			{
				if (self.authorizationPooling) {
					window.clearInterval(self.authorizationPooling);
					self.authorizationPooling = null;
				}
				self.authorizationPooling = window.setInterval(function() {
					self.__doAuthorizationPooling();
				}, 3000);
			},
			error: function(_, error)
			{
				let message = "<%=_T('Error starting authorization process')%>";
				switch(error && error.reason || "") {
					case "app_not_found":
						message = "<%=_T('App for phone not found')%>";
						break;
				}
				self.parent.frm.show_status_message(message, "Error", 5000);
				self.__closeAuthorizationPopup();
			},
			timeout : 300 * 1000
		});
	};
	
	WHATSAPPAccountPanel.prototype.__stopAuthorization = function() {
		let self = this;
		if($(this.integrationType).val() === "ICC_CLOUD_API" && this.is_new()) {
			let campaign = self.parent.frm.get_entity_instance();
			inConcert.invoke({
				url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_unlock_activation_code/",
				type: "POST",
				data: JSON.stringify({
					campaignId : campaign.Id,
					accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
					code: $(self.account_activation_code).val()
				}),
				dataType: "json",
				contentType: "application/json",
				success: function() {
					self.m_authorizingId = null;
					$(self.account_activation_code).prop("disabled", false);
				},
				error: function() {
					self.m_authorizingId = null;
					$(self.account_activation_code).prop("disabled", false);
				}
			});
		}
		if (!self.m_authorizingId) {
			self.__closeAuthorizationPopup();
			return;
		}
		let campaign = this.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/stop_whatsapp_authorization/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : self.m_authorizingId
			}),
			dataType: "json",
			contentType: "application/json",
			success: function()
			{
				self.__closeAuthorizationPopup();
			},
			error: function( /*xhr, textStatus, errorThrown */)
			{
				self.__closeAuthorizationPopup();
			}
		});
	};
	
	WHATSAPPAccountPanel.prototype.__loadQrCode = function(qrCode) {
		$("#adm_form_whatsapp_account_qr_container")
			.removeClass("loadingQr")
			.html("<img class='whatsappQrCode' src='data:image/png;base64," + qrCode + "'>");
	};	

	WHATSAPPAccountPanel.prototype.__doAuthorizationPooling = function() {
		let self = this;
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/get_whatsapp_authorization_status/",
			type: "POST",
			data: JSON.stringify({
				accountId : self.m_authorizingId
			}),
			dataType: "json",
			contentType: "application/json",
			success: function(result)
			{
				switch(result.data.status) {
					case "LOGIN":
						if (result.data.qr) {
							self.__loadQrCode(result.data.qr);
						}
						break;
					case "STARTING":
						break;
					case "PENDING_VALIDATION":
						if (self.m_lastStatus !== result.data.status) {
							self.__requestValidationCode();
						}
						break;
					case "INVALID_VALIDATION":
						if (self.m_lastStatus !== result.data.status) {
							self.__setInvalidCode();
						}
						break;
					case "SUCCESS":
						self.__closeAuthorizationPopup();
						self.__on_app_authorized(result.data);
						break;
					default:
						self.parent.frm.show_status_message("<%=_T('Error doing authorization')%>", "Error", 5000);
						self.__closeAuthorizationPopup();
						break;
				}
				self.m_lastStatus = result.data.status;
			},
			error: function( /*xhr, textStatus, errorThrown */)
			{
				self.parent.frm.show_status_message("<%=_T('Error doing authorization')%>", "Error", 5000);
				self.__stopAuthorization();
			}
		});
	};
	
	WHATSAPPAccountPanel.prototype.__requestValidationCode = function() {
		let self = this;
		self.hide_marked_errors();
		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();
		
		$("#adm_form_whatsapp_account_loading_container").hide();
		$("#adm_form_whatsapp_account_authorizate_code")
			.prop("disabled", false)
			.parent().parent().show();
		$("#adm_form_whatsapp_account_authorizate_start")
			.prop("disabled", false)
			.val("<%=_T('Verify Code')%>")
			.off("click")
			.on("click", function() {
				self.__validateCode();
			});
	};
	
	WHATSAPPAccountPanel.prototype.__validateCode = function() {
		let self = this;
		self.hide_marked_errors();
		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();
		
		let $code = $("#adm_form_whatsapp_account_authorizate_code");
		if (!self.validate_field($code, "required", "<%=_T('Must enter a verification code.')%>", null, null, null, $error)) {
			return;
		}
		$("#adm_form_whatsapp_account_authorizate_start")
			.prop("disabled", true)
			.off("click");
		$code.prop("disabled", true);
		$("#adm_form_whatsapp_account_loading_container")
			.show()
			.find("[waiting_message]")
			.text("<%=_T('Checking code')%>");
		
		let campaign = this.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/set_whatsapp_authorization_code/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : self.m_authorizingId,
				code : $code.val()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function()
			{
				
			},
			error: function( /*xhr, textStatus, errorThrown */)
			{
				self.parent.frm.show_status_message("<%=_T('Error doing authorization')%>", "Error", 5000);
				self.__closeAuthorizationPopup();
			}
		});
	};
	
	WHATSAPPAccountPanel.prototype.__setInvalidCode = function() {
		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();
		this.show_validation_error( $("#adm_form_whatsapp_account_authorizate_code"), 
			"<%=_T('Invalid verification code.')%>", null, null, null, $error);
		this.__requestValidationCode();
	};
	
	WHATSAPPAccountPanel.prototype.__closeAuthorizationPopup = function() {
		let self = this;
		if (self.authorizationPooling) {
			window.clearInterval(self.authorizationPooling);
			self.authorizationPooling = null;
		}
		if (self.authorizationPopup && self.authorizationPopup.isVisible()) {
			self.authorizationPopup.finalize(function() {
				self.authorizationPopup = null;
				self.$authorizationPopup.remove();
			});
		}
		else {
			self.$authorizationPopup.remove();
		}
	};

	WHATSAPPAccountPanel.prototype.editable = function()
	{
		WHATSAPPAccountPanel.uber.editable.call( this );
		$( this.webAuthorizeButton ).show();
		$( this.inconcertCloudApiAuthorizeButton ).show();
		$( this.inconcertCloudApiPhone ).show();
		$( this.inconcertCloudApiCodeVerificationStatus ).show();
		$( this.inconcertCloudApiPhoneStatus ).show();
		$( this.inconcertCloudApiMessageLimit ).show();
		$( this.smoochAuthorizeButton ).show();
		$( this.infobipAuthorizeButton ).show();
		$( this.businessAuthorizeButton ).show();
	};

	WHATSAPPAccountPanel.prototype.readonly = function()
	{
		WHATSAPPAccountPanel.uber.readonly.call( this );
		$( this.webAuthorizeButton ).hide();
		$( this.inconcertCloudApiAuthorizeButton ).hide();
		$( this.inconcertCloudApiPhone ).hide();
		$( this.inconcertCloudApiCodeVerificationStatus ).hide();
		$( this.inconcertCloudApiPhoneStatus ).hide();
		$( this.inconcertCloudApiMessageLimit ).hide();
		$( this.smoochAuthorizeButton ).hide();
		$( this.infobipAuthorizeButton ).hide();
		$( this.businessAuthorizeButton ).hide();
	};

	WHATSAPPAccountPanel.prototype.__MigrateWhatsappPhone = function()
	{
		var self = this;

		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();

		let $sourceWaba = $("#adm_form_whatsapp_account_authorizate_migrate_source_waba");
		let $sourcePhone = $("#adm_form_whatsapp_account_authorizate_migrate_source_phone");
		let $destinationWaba = $("#adm_form_whatsapp_account_authorizate_migrate_destination_waba");

		if (!this.validate_field($sourceWaba, "required", "<%=_T('Source Whatsapp Business Account is required.')%>", null, null, null, $error)) {
			return;
		}
		if (!this.validate_field($sourcePhone, "required", "<%=_T('Phone to migrate is required.')%>", null, null, null, $error)) {
			return;
		}
		if (!this.validate_field($destinationWaba, "required", "<%=_T('Destination Whatsapp Business Account is required.')%>", null, null, null, $error)) {
			return;
		}
		if($sourceWaba.val() === $destinationWaba.val()) {
			this.show_validation_error( null, "<%=_T('Source and Destination Whatsapp Business Accounts cannot match.')%>", null, null, undefined, $error);
			return;
		}

		showInconcertCloudApiInProgress(true, "<%=_T('Migrating phone')%>");

		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_migrate_phone/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
				fromWaba: $sourceWaba.val(),
				toWaba: $destinationWaba.val(),
				fullPhoneNumber: $sourcePhone.text()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function(response) {
				showInconcertCloudApiInProgress(false);
				if(response.result === "OK" && response.migratedPhone) {					
					let waba = {
						id: $destinationWaba.val(),
						name: $destinationWaba.find("option:selected").text(),
						message_template_namespace: self.m_wabas.find(waba => waba.id === $destinationWaba.val()).message_template_namespace
					};
					let phoneNumber = {
						phoneStatus: response.migratedPhone.status,
						phoneNumber: response.migratedPhone.display_phone_number,
						phoneId: response.migratedPhone.id,
						codeVerificationStatus: response.migratedPhone.code_verification_status,
						displayPhoneNumber: response.migratedPhone.display_phone_number,
						messageLimit: response.migratedPhone.messaging_limit
					};
					waba.phoneNumbers = [];
					waba.phoneNumbers.push(phoneNumber);
					self.m_wabas = [];
					self.m_wabas.push(waba);

					// Si ya esta el telefono migrado verificado nos saltamos este paso
					if(response.migratedPhone.code_verification_status === "VERIFIED") {
						self.parent.frm.fill_combo( $( self.inconcertCloudApiWaba ), false, self.m_wabas, "id", "name" );
						$( self.inconcertCloudApiWaba )
							.val(self.m_wabas[0] && self.m_wabas[0].id)
							.change();

						self.m_migration_step = null;

						self.__closeAuthorizationPopup();	
						return;
					}

					$("#adm_form_whatsapp_account_authorizate_popup_title").text("<%=_T('Request Phone Verification Code')%>");
					$("#adm_account_authorizate_option_container").hide();	
					$("#adm_form_whatsapp_account_authorizate_migrate_source_container").hide();
					$("#adm_form_whatsapp_account_authorizate_migrate_destination_container").hide();
					$("#adm_form_whatsapp_account_authorizate_migrate_verification_method_container").show();
					$("#adm_form_whatsapp_account_authorizate_start").text("<%=_T('Start')%>");
					self.m_migration_step = "request_verifying";
				}
				else {
					$error
						.show()
						.find(".messageText")
						.text("<%=_T('Unknown error')%>");
				}
			},
			error: function(_, text_status) {
				var err = text_status.reason || "Unknown error";
				showInconcertCloudApiInProgress(false);
				$error
					.show()
					.find(".messageText")
					.text(_T(err));
			}
		});	

	};

	WHATSAPPAccountPanel.prototype.__openWhatsappOauthPopup = function()
	{
		var self = this;

		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();

		let fullOnboarding = $("#adm_form_whatsapp_account_authorizate_full").is(":checked");
		let migratePhone = $("#adm_form_whatsapp_account_authorizate_migrate").is(":checked");
		if(!fullOnboarding && !migratePhone) {
			this.show_validation_error( null, "<%=_T('Must select an option.')%>", null, null, undefined, $error);	
			return;
		}

		self.m_authorizingId = self.m_authorizingId || self.m_authorizedId || self.__makeAccountId();

		this.parent.frm.hide_messages();
		if ( !this.parent.has_permission_to_save() ) {
			var message = "<%=_T('You do not have permissions for save account.')%>";
			this.parent.frm.show_status_message( message, 'Error', 5000 );
			return;
		}

		var postback_data = JSON.stringify({ 
			origin : window.location.origin,
			host : window.location.host,
			authorizingId : self.m_authorizingId,
			fullOnboarding : fullOnboarding
		});
		var parameters = '?&post_data=' + encodeURIComponent( postback_data );
		var href = '/inconcert/apps/oauth/whatsapp/authorize_user/' + parameters;
		var window_options = 'height=600,width=800,status=yes,toolbar=yes,menubar=no,location=yes';
		var whatsapp_window = window.open( href, '_blank', window_options );

		if (window.adm_form_campaigns_section_accounts_whatsapp_message_listener) {
			window.removeEventListener("message", window.adm_form_campaigns_section_accounts_whatsapp_message_listener);
			window.adm_form_campaigns_section_accounts_whatsapp_message_listener = undefined;
		}

		var close_popup_window = function( can_add ) {
			var timeout_ms = can_add ? 1500 : undefined;
			window.setTimeout( function() {
				whatsapp_window.close();
				whatsapp_window = undefined;
			}, timeout_ms );
		};

		var listener = function( ev )
		{
			if (ev.origin.search( window.location.host ) > 0 && ev.data && ev.data.authorization === "WHATSAPP")
			{
				self.__on_app_authorized( ev.data, close_popup_window );
				window.removeEventListener( 'message', window.adm_form_campaigns_section_accounts_whatsapp_message_listener );
				window.adm_form_campaigns_section_accounts_whatsapp_message_listener = undefined;
			}
		};

		window.adm_form_campaigns_section_accounts_whatsapp_message_listener = listener;
		window.addEventListener("message", window.adm_form_campaigns_section_accounts_whatsapp_message_listener, false );
	};	

	WHATSAPPAccountPanel.prototype.__makePhoneVerificationPopup = function() 
	{
		let self = this;
		let $popup = $("".concat(
			'<div id="adm_form_whatsapp_account_phone_verification" class="internalPopUpContainer popUp520w formPopUp" style="">',
				'<div class="internalPopUpOverlay"></div>' ,
				'<div class="internalPopUp">',

					// waiting
					'<div id="adm_form_whatsapp_account_loading_container" class="internalWaitingContainer whatsappLoadingIntegrationContainer" hidden>',
						'<div waiting_message="true" class="internalWaitingMessage">',
							'<%=_T("Starting integration")%>',
						'</div>',
						'<div class="internalWaitingAnimation"></div>',
						'<div class="internalWaitingOverlay"></div>',
					'</div>',

					// title
					'<div class="internalPopUpTitle">',
						'<label>', '<%=_T("Verify Phone")%> ', $( self.inconcertCloudApiPhone + " option:selected").text() ,'</label>',
						'<button id="adm_form_whatsapp_account_phone_verification_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					// content
					'<div class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div id="adm_form_whatsapp_account_phone_verification_error" class="genericFormMessagesContainer messageError" hidden style="display: none;">',
							'<label class="messageText"></label>',
						'</div>',

						// form
						'<div class="no-card">' ,
							'<div class="card-block">' ,
								'<div id="adm_form_whatsapp_account_verification_method_container" class="row" style="display:none;">' ,		
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_verification_method" class="required"><%=_T("Verification Method")%><%=_T(":")%></label>',
											'<select id="adm_form_whatsapp_account_verification_method" class="form-control">',
												'<option value="sms"><%=_T("Sms")%></option>',
												'<option value="voice"><%=_T("Voice (phone call)")%></option>',
											'</select>',
											'<i id="adm_form_whatsapp_account_verification_method_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
								'</div>',	
								'<div id="adm_form_whatsapp_account_verification_verify_code_container" class="row" style="display:none;">' ,		
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_verification_verify_code" class="required"><%=_T("Verify code")%><%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_verification_verify_code" class="form-control" type="text"/>',
											'<i id="adm_form_whatsapp_account_verification_verify_code_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
									'<div class="col-6">',
										'<div class="form-group">',
											'<label><%=_T("Have not you received the code?")%></label>',
										'</div>',
									'</div>',
									'<div class="col-6">',
										'<div class="form-group">',
											'<button id="adm_form_whatsapp_account_verification_new_code" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Request another code")%> </button>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
						'<button id="adm_form_whatsapp_account_phone_verification_start" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Request Code")%> </button>',
						'<button id="adm_form_whatsapp_account_phone_verification_cancel" class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
					'</div>' ,
				'</div>',
			'</div>'
		));

		$popup.find("#adm_form_whatsapp_account_phone_verification_start").click(function() {
			let $error = $("#adm_form_whatsapp_account_phone_verification_error");
			$error.hide();			
			let selectedWaba = self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
			let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());
			if(selectedPhone) {		
				if(self.m_verification_step === "verifying") {
					self.__verifyPhone_verify_code();
				}
				else {
					self.__verifyPhone_request_code();
				}
			}
		});

		$popup.find("#adm_form_whatsapp_account_verification_new_code").click(function() {
			if(self.m_verification_step === "verifying") {
				$("#adm_form_whatsapp_account_verification_method_container").show();
				$("#adm_form_whatsapp_account_verification_verify_code_container").hide();	
				$("#adm_form_whatsapp_account_phone_verification_start").text("<%=_T('Request Code')%>");
				self.m_verification_step = null;
			}
		});

		return $popup;
	};		

	WHATSAPPAccountPanel.prototype.__makePhoneRegisterPopup = function(register) 
	{
		let self = this;
		let $popup = $("".concat(
			'<div id="adm_form_whatsapp_account_phone_register" class="internalPopUpContainer popUp520w formPopUp" style="">',
				'<div class="internalPopUpOverlay"></div>' ,
				'<div class="internalPopUp">',

					// waiting
					'<div id="adm_form_whatsapp_account_loading_container" class="internalWaitingContainer whatsappLoadingIntegrationContainer" hidden>',
						'<div waiting_message="true" class="internalWaitingMessage">',
							'<%=_T("Starting integration")%>',
						'</div>',
						'<div class="internalWaitingAnimation"></div>',
						'<div class="internalWaitingOverlay"></div>',
					'</div>',

					// title
					'<div class="internalPopUpTitle">',
						'<label>', register ? '<%=_T("Register Phone")%> ' : '<%=_T("Deregister Phone")%> ', $( self.inconcertCloudApiPhone + " option:selected").text() ,'</label>',
						'<button id="adm_form_whatsapp_account_phone_register_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					// content
					'<div class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div id="adm_form_whatsapp_account_phone_register_error" class="genericFormMessagesContainer messageError" hidden style="display: none;">',
							'<label class="messageText"></label>',
						'</div>',

						// form
						'<div class="card">' ,
							'<div class="card-block">' ,
								'<div class="row" id="row_adm_form_whatsapp_account_phone_register_pin" style="display: none;">',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="adm_form_whatsapp_account_phone_register_pin" class="required">', "<%=_T([[6 digits code]])%>", '<%=_T(":")%></label>',
											'<input id="adm_form_whatsapp_account_phone_register_pin" class="form-control" type="text" placeholder="', '<%=_T("Enter a 6 digits code")%>...', '" />',
											'<i id="adm_form_whatsapp_account_phone_register_pin_validation" class="formFieldValidation formFieldError" hidden></i>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
						'<button id="adm_form_whatsapp_account_phone_register_start" class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Start")%> </button>',
						'<button id="adm_form_whatsapp_account_phone_register_cancel" class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
					'</div>' ,
				'</div>',
			'</div>'
		));

		$popup.find("#adm_form_whatsapp_account_phone_register_start").click(function() {
			let $error = $("#adm_form_whatsapp_account_phone_register_error");
			$error.hide();			
			let selectedWaba = self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
			let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());
			if(selectedPhone) {		
				if(selectedPhone.phoneStatus === "CONNECTED") {
					self.__deregisterPhone();
				}	
				else {	
					let $pin = $("#adm_form_whatsapp_account_phone_register_pin");

					if (!self.validate_field($pin, "digits", "<%=_T('Invalid code. Enter a 6 digits code.')%>", null, null, null, $error)) {
						return;
					}
					let pinValidationOptions = {};
					pinValidationOptions.max_length = 6;
					pinValidationOptions.min_length = 6;
					if (!self.validate_field($pin, "string_max_length", "<%=_T('Invalid code. Enter a 6 digits code.')%>", pinValidationOptions, null, null, $error)) {
						return;
					}
					if (!self.validate_field($pin, "string_min_length", "<%=_T('Invalid code. Enter a 6 digits code.')%>", pinValidationOptions, null, null, $error)) {
						return;
					}			
					self.__registerPhone();
				}		
			}
		});

		return $popup;
	};	
	
	WHATSAPPAccountPanel.prototype.__closePhoneVerificationPopup = function() {
		let self = this;
		if (self.phoneVerificationPopup && self.phoneVerificationPopup.isVisible()) {
			self.phoneVerificationPopup.finalize(function() {
				self.phoneVerificationPopup = null;
				self.$phoneVerificationPopup.remove();
			});
		}
		else {
			self.$phoneVerificationPopup.remove();
		}
	};	

	function showInconcertCloudApiInProgress(show, message) {
		let $loading = $("#adm_form_whatsapp_account_loading_container");

		if(show) {
			$loading
				.show()
				.find("[waiting_message]")
				.text(message);
		}
		else {
			$loading.hide();
		}
	}

	WHATSAPPAccountPanel.prototype.__registerPhone = function() {
		let self = this;
		
		let $pin = $("#adm_form_whatsapp_account_phone_register_pin");
		let $error = $("#adm_form_whatsapp_account_phone_register_error");
		$error.hide();
		showInconcertCloudApiInProgress(true, "<%=_T('Registering phone')%>");

		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_register_phone/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
				phoneId: $( self.inconcertCloudApiPhone ).val(),
				pin: $pin.val()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function() {
				showInconcertCloudApiInProgress(false);
				
				let selectedWaba = self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
				let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());			
				if(selectedPhone) {
					 selectedPhone.phoneStatus = "CONNECTED";	
					 $( self.inconcertCloudApiVerifyPhone ).toggle(selectedPhone.codeVerificationStatus !== "VERIFIED");
					 $( self.inconcertCloudApiRegisterPhone ).toggle(selectedPhone.codeVerificationStatus === "VERIFIED");	
					 $( self.inconcertCloudApiPhoneStatus ).val("<%=_T('CONNECTED')%>");
					 $( self.inconcertCloudApiRegisterPhone ).text("<%=_T('Deregister Phone')%>");			 
				}
				else {
					$( self.inconcertCloudApiVerifyPhone ).hide();
					$( self.inconcertCloudApiRegisterPhone ).hide();
				}
				self.__closePhoneRegisterPopup();
			},
			error: function(_, text_status) {
				var err = text_status.reason || "Unknown error";
				showInconcertCloudApiInProgress(false);
				$error
					.show()
					.find(".messageText")
					.text(_T(err));
			}
		});		
	};

	WHATSAPPAccountPanel.prototype.__deregisterPhone = function() {
		let self = this;
		
		let $error = $("#adm_form_whatsapp_account_phone_register_error");
		$error.hide();
		showInconcertCloudApiInProgress(true, "<%=_T('Deregistering phone')%>");

		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_deregister_phone/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
				phoneId: $( self.inconcertCloudApiPhone ).val()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function() {
				showInconcertCloudApiInProgress(false);
				
				let selectedWaba = self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
				let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());			
				if(selectedPhone) {
					selectedPhone.phoneStatus = "DISCONNECTED";	
					$( self.inconcertCloudApiVerifyPhone ).toggle(selectedPhone.codeVerificationStatus !== "VERIFIED");
					$( self.inconcertCloudApiRegisterPhone ).toggle(selectedPhone.codeVerificationStatus === "VERIFIED");	
					$( self.inconcertCloudApiPhoneStatus ).val("<%=_T('DISCONNECTED')%>");
					$( self.inconcertCloudApiRegisterPhone ).text("<%=_T('Register Phone')%>");			 
				}
				else {
					$( self.inconcertCloudApiVerifyPhone ).hide();
					$( self.inconcertCloudApiRegisterPhone ).hide();
				}
				self.__closePhoneRegisterPopup();
			},
			error: function(_, text_status) {
				var err = text_status.reason || "Unknown error";
				showInconcertCloudApiInProgress(false);
				$error
					.show()
					.find(".messageText")
					.text(_T(err));
			}
		});		
	};
	
	WHATSAPPAccountPanel.prototype.__closePhoneRegisterPopup = function() {
		let self = this;
		if (self.phoneRegisterPopup && self.phoneRegisterPopup.isVisible()) {
			self.phoneRegisterPopup.finalize(function() {
				self.phoneRegisterPopup = null;
				self.$phoneRegisterPopup.remove();
			});
		}
		else {
			self.$phoneRegisterPopup.remove();
		}
	};

	WHATSAPPAccountPanel.prototype.__openPhoneRegisterPopup = function(register)
	{
		let self = this;
		self.$phoneRegisterPopup = self.__makePhoneRegisterPopup(register);

		$("body").append(self.$phoneRegisterPopup);
		self.phoneRegisterPopup = new inConcert.PopupWindow();
		self.phoneRegisterPopup.show({
			ownerId         : "adm_form_whatsapp_account_phone_register",
			eventName       : "adm_form_whatsapp_account_phone_register",
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$phoneRegisterPopup,
			callbacks: {
				onOpen: function() {
					$("#row_adm_form_whatsapp_account_phone_register_pin").toggle(register);
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.phoneRegisterPopup) {
						self.phoneRegisterPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});

		self.$phoneRegisterPopup.find("#adm_form_whatsapp_account_phone_register_cancel").click(function() {
			self.__closePhoneRegisterPopup();
		});

		self.$phoneRegisterPopup.find("#adm_form_whatsapp_account_phone_register_cancel_times").click(function() {
			self.__closePhoneRegisterPopup();
		});		
	};

	WHATSAPPAccountPanel.prototype.__openPhoneVerificationPopup = function(register)
	{
		let self = this;
		self.$phoneVerificationPopup = self.__makePhoneVerificationPopup(register);

		$("body").append(self.$phoneVerificationPopup);
		self.phoneVerificationPopup = new inConcert.PopupWindow();
		self.phoneVerificationPopup.show({
			ownerId         : "adm_form_whatsapp_account_phone_verification",
			eventName       : "adm_form_whatsapp_account_phone_verification",
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$phonephoneVerificationPopupRegisterPopup,
			callbacks: {
				onOpen: function() {
					$("#adm_form_whatsapp_account_verification_method_container").show();	
					$("#adm_form_whatsapp_account_verification_verify_code_container").hide();
					$("#adm_form_whatsapp_account_phone_verification_start").text("<%=_T('Request Code')%>");
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.phoneVerificationPopup) {
						self.phoneVerificationPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});

		self.$phoneVerificationPopup.find("#adm_form_whatsapp_account_phone_verification_cancel").click(function() {
			self.__closePhoneVerificationPopup();
		});

		self.$phoneVerificationPopup.find("#adm_form_whatsapp_account_phone_verification_cancel_times").click(function() {
			self.__closePhoneVerificationPopup();
		});		
	};

	WHATSAPPAccountPanel.prototype.__verifyPhone_request_code = function() {
		let self = this;
		
		let $method = $("#adm_form_whatsapp_account_verification_method");
		let $error = $("#adm_form_whatsapp_account_phone_verification_error");
		$error.hide();

		if (!this.validate_field($method, "required", "<%=_T('Verification Method is required.')%>", null, null, null, $error)) {
			return;
		}

		showInconcertCloudApiInProgress(true, "<%=_T('Requesting phone code verification')%>");

		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_request_code/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
				phoneId: $(self.inconcertCloudApiPhone).val(),
				method: $method.val(),
				language: inConcert.app.getLoggedUserLanguage()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function() {
				showInconcertCloudApiInProgress(false);
				
				$("#adm_form_whatsapp_account_verification_method_container").hide();	
				$("#adm_form_whatsapp_account_verification_verify_code_container").show();
				$("#adm_form_whatsapp_account_phone_verification_start").text("<%=_T('Verify Code')%>");
				self.m_verification_step = "verifying";
			},
			error: function(_, text_status) {
				var reason = text_status.reason || "Unknown error";
				var err = _T(reason.replace(/[']/g, ''));
				if(text_status.reason_detail) {
					err += " (" + _T(text_status.reason_detail.replace(/[']/g, '')) + ")";
				}
				showInconcertCloudApiInProgress(false);
				$error
					.show()
					.find(".messageText")
					.text(err);
			}
		});		
	};	

	WHATSAPPAccountPanel.prototype.__verifyPhone_verify_code = function() {
		let self = this;
		
		let $pin = $("#adm_form_whatsapp_account_verification_verify_code");
		let $error = $("#adm_form_whatsapp_account_phone_verification_error");
		$error.hide();

		if (!this.validate_field($pin, "required", "<%=_T('Verify code is required.')%>", null, null, null, $error)) {
			return;
		}

		if (!this.validate_field($pin, "digits", "<%=_T('Invalid code. Enter a 6 digits code.')%>", null, null, null, $error)) {
			return;
		}
		let pinValidationOptions = {};
		pinValidationOptions.max_length = 6;
		pinValidationOptions.min_length = 6;
		if (!this.validate_field($pin, "string_min_length", "<%=_T('Invalid code. Enter a 6 digits code.')%>", pinValidationOptions, null, null, $error)) {
			return;
		}

		if (!this.validate_field($pin, "string_max_length", "<%=_T('Invalid code. Enter a 6 digits code.')%>", pinValidationOptions, null, null, $error)) {
			return;
		}

		showInconcertCloudApiInProgress(true, "<%=_T('Verifying code')%>");

		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_verify_code/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
				phoneId: $(self.inconcertCloudApiPhone).val(),
				pin: $pin.val()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function() {
				showInconcertCloudApiInProgress(false);
				
				let selectedWaba = self.m_wabas.find(waba => waba.id === $(self.inconcertCloudApiWaba).val());
				let selectedPhone = selectedWaba.phoneNumbers.find(phoneNumber => phoneNumber.phoneId === $(self.inconcertCloudApiPhone).val());			
				if(selectedPhone) {
					 selectedPhone.codeVerificationStatus = "VERIFIED";	
					 $( self.inconcertCloudApiVerifyPhone ).hide();
					 $( self.inconcertCloudApiRegisterPhone ).show();	
					 $( self.inconcertCloudApiCodeVerificationStatus ).val("<%=_T('VERIFIED')%>");			 
				}
				else {
					$( self.inconcertCloudApiVerifyPhone ).hide();
					$( self.inconcertCloudApiRegisterPhone ).hide();
				}
				self.m_verification_step = null;

				self.__closePhoneVerificationPopup();
			},
			error: function(_, text_status) {
				var reason = text_status.reason || "Unknown error";
				var err = _T(reason.replace(/[']/g, ''));
				if(text_status.reason_detail) {
					err += " (" + _T(text_status.reason_detail.replace(/[']/g, '')) + ")";
				}
				showInconcertCloudApiInProgress(false);
				$error
					.show()
					.find(".messageText")
					.text(err);
			}
		});		
	};


	WHATSAPPAccountPanel.prototype.__migrate_verifyPhone_request_code = function() {
		let self = this;
		
		let migratedPhoneId = self.m_wabas[0].phoneNumbers[0].phoneId;
		let $method = $("#adm_form_whatsapp_account_authorizate_migrate_verification_method");
		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();

		if (!this.validate_field($method, "required", "<%=_T('Verification Method is required.')%>", null, null, null, $error)) {
			return;
		}

		showInconcertCloudApiInProgress(true, "<%=_T('Requesting phone code verification')%>");

		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_request_code/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
				phoneId: migratedPhoneId,
				method: $method.val(),
				language: inConcert.app.getLoggedUserLanguage()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function() {
				showInconcertCloudApiInProgress(false);
				
				$("#adm_form_whatsapp_account_authorizate_popup_title").text("<%=_T('Verify Phone Code')%>");
				$("#adm_account_authorizate_option_container").hide();	
				$("#adm_form_whatsapp_account_authorizate_migrate_source_container").hide();
				$("#adm_form_whatsapp_account_authorizate_migrate_destination_container").hide();
				$("#adm_form_whatsapp_account_authorizate_migrate_verification_method_container").hide();
				$("#adm_form_whatsapp_account_authorizate_migrate_verification_verify_code_container").show();
				$("#adm_form_whatsapp_account_authorizate_start").text("<%=_T('Verify')%>");
				self.m_migration_step = "verifying";
			},
			error: function(_, text_status) {
				var err = text_status.reason || "Unknown error";
				showInconcertCloudApiInProgress(false);
				$error
					.show()
					.find(".messageText")
					.text(_T(err));
			}
		});		
	};	

	WHATSAPPAccountPanel.prototype.__migrate_verifyPhone_verify_code = function() {
		let self = this;
		
		let migratedPhoneId = self.m_wabas[0].phoneNumbers[0].phoneId;
		let $pin = $("#adm_form_whatsapp_account_authorizate_migrate_verification_verify_code");
		let $error = $("#adm_form_whatsapp_account_authorizate_error");
		$error.hide();

		if (!this.validate_field($pin, "required", "<%=_T('Verify code is required.')%>", null, null, null, $error)) {
			return;
		}

		if (!this.validate_field($pin, "digits", "<%=_T('Invalid code. Enter a 6 digits code.')%>", null, null, null, $error)) {
			return;
		}
		let pinValidationOptions = {};
		pinValidationOptions.max_length = 6;
		pinValidationOptions.min_length = 6;
		if (!this.validate_field($pin, "string_min_length", "<%=_T('Invalid code. Enter a 6 digits code.')%>", pinValidationOptions, null, null, $error)) {
			return;
		}

		if (!this.validate_field($pin, "string_max_length", "<%=_T('Invalid code. Enter a 6 digits code.')%>", pinValidationOptions, null, null, $error)) {
			return;
		}		

		showInconcertCloudApiInProgress(true, "<%=_T('Verifying code')%>");

		let campaign = self.parent.frm.get_entity_instance();
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_verify_code/",
			type: "POST",
			data: JSON.stringify({
				campaignId : campaign.Id,
				accountId : (self.current_account && self.current_account.id) ? self.current_account.id : self.m_authorizingId,
				phoneId: migratedPhoneId,
				pin: $pin.val()
			}),
			dataType: "json",
			contentType: "application/json",
			success: function() {
				showInconcertCloudApiInProgress(false);
				
				self.m_wabas[0].phoneNumbers[0].codeVerificationStatus = "VERIFIED";
				
				self.parent.frm.fill_combo( $( self.inconcertCloudApiWaba ), false, self.m_wabas, "id", "name" );
				$( self.inconcertCloudApiWaba )
					.val(self.m_wabas[0] && self.m_wabas[0].id)
					.change();

				self.m_migration_step = null;

				self.__closeAuthorizationPopup();
			},
			error: function(_, text_status) {
				var reason = text_status.reason || "Unknown error";
				var err = _T(reason.replace(/[']/g, ''));
				if(text_status.reason_detail) {
					err += " (" + _T(text_status.reason_detail.replace(/[']/g, '')) + ")";
				}
				showInconcertCloudApiInProgress(false);
				$error
					.show()
					.find(".messageText")
					.text(_T(err));
			}
		});		
	};
}());
