/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:false, esversion: 11*/

/* global inConcert, Mustache, _, Clipboard, EmojiPicker */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const format = inConcert.Utils.format;
	let templates =  {
		base : ('').concat(
			'<div id="{{ popup_id }}" class="internalPopUpContainer pageMessengerPopUp popUpFullHeight formPopUp popUp1300w" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// waiting
					'<div popup_loading class="popupWaitingContainer">',
						'<div popup_loading_label class="internalWaitingMessage">',
							"<%=_T('Loading bot configuration')%>...",
						'</div>',
						'<div class="popupWaitingAnimation"></div>',
						'<div class="popupWaitingOverlay"></div>',
					'</div>',
					// title
					'<div class="internalPopUpTitle">',
						'<span>',
							"<%=_T('Messenger bot')%>",
							'<span class="messengerPageName">',
								'{{ name }}',
							'</span>',
						'</span>',
						'<button cancel_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					'<div popup_form class="internalPopUpMiddle pageFormContainer" hidden>',
						// mensaje de error
						'<div popup_error class="genericFormMessagesContainer messageError" hidden style="display:none;">',
							'<label popup_error_label class="messageText"></label>',
						'</div>',

						// content
						'<div class="card no-card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-12">',
										'<div class="formTabsMainContainer">',
											'<div id="page_messenger_tabs">',
											'</div>',
				
											'<div id="page_messenger_tabs_configuration"  class="formTabsBody" hidden >',
											'</div>',
				
											'<div id="page_messenger_tabs_entry_points"  class="formTabsBody" hidden >',
											'</div>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						"<button cancel_button class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>",
						"<button restore_button class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Restore to Defaults')%>" + "</button>",
						"<button update_button class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
					'</div>',
				'</div>',
			'</div>'
		),
		global_configuration: ('').concat(
			'<div>',
			'</div>'
		),
		process_flow: ('').concat(
			'<div class="row">',
				'<div class="col-6">',
					'<div class="form-group">',
						'<label for="{{ guid }}_process_flow">',
							"<%=_T('Process Flow')%>:",
						'</label>',
						'<select control="process_flow" id="{{ guid }}_process_flow" class="form-control">',
						'</select>',
						'<i validation="process_flow" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
				'<div class="col-4 d-flex flex-row">',
					'<div class="form-group flex-grow-1 mr-2 w-100 position-relative">',
						'<label control_label="process_flow_inactivity_time" for="{{ guid }}_process_flow_inactivity_time">',
							"<%=_T('Inactivity Time')%>: <span disclaimer='process_flow_inactivity_time'  class='fa fa-question-circle' title='", "<%=_T('The interaction will be closed if the customer does not respond during the configured idle time (maximum: 24 hours).')%>", "'></span>",
						'</label>',
						'<input control="process_flow_inactivity_time" id="{{ guid }}_process_flow_inactivity_time" class="form-control" type="text">',
						'<i validation="process_flow_inactivity_time" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',	
					'<div class="form-group flex-grow-1 w-100 align-self-end">',
						'<select control="process_flow_inactivity_time_unit" id="{{ guid }}_process_flow_inactivity_time_unit" class="form-control">',
							'<option value="minutes"><%=_T("Minutes")%></option>',
							'<option value="hours"><%=_T("Hours")%></option>',
						'</select>',
					'</div>',
				'</div>',
			'</div>'
		),
		start_button: ('').concat(
			'<div class="row">',
				'<div class="col-6 d-flex flex-row">',
					'<div class="form-group">',
						'<div class="form-check form-check-right-input">',
				 			'<label for="{{ guid }}_start_button_enabled" class="form-check-label form-check-label-title">',
				 				'<input control="start_button_enabled" id="{{ guid }}_start_button_enabled" class="form-check-input" type="checkbox">',
				 				"<%=_T('Enable start button')%>:",
				 			'</label>',
						'</div>',
					'</div>',
					'<div class="form-group flex-grow-1">',
						'<label control_label="start_button_postback" for="{{ guid }}_start_button_postback">',
							"<%=_T('Postback')%>:",
						'</label>',
						'<input control="start_button_postback" id="{{ guid }}_start_button_postback" class="form-control" type="text" placeholder="', "<%=_T('Enter the message')%>...", '" />',
						'<i validation="start_button_postback" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',	
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div disclaimer="start_button_postback" class="inlineMessagesContainer messageInfo">', 
						"<%=_T('This message will be received in the process flow as a New Incoming event when the user presses the button.')%>",
					'</div>',
				'</div>',
			'</div>',
			'<hr/>'
		),
		greeting_text: ('').concat(
			'<div greeting_text_container>',
				'<div class="row">',
					'<div class="col-12">',
						'<div class="card-header d-flex flex-row justify-content-between">',
							'<h5>', "<%=_T('Greeting Text')%>", '</h5>',
							'<div class="d-flex align-items-start pt-1 align-self-start mb-4">',
								'<button new_greeting_text class="pageButtonGeneric buttonColorWhite pageButtonNew"> <i class="far fa-plus"> </i>', "<%=_T('Add Text')%>", '</button>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',
				'<div greeting_text_form_container style="display:none;">',
				'</div>',
				'<div class="row">',
					'<div class="col-12">',
						'<ul greeting_text_list class="formList formListAsGrid mt-0">',
							'<li class="formListTitle">',
								'<label class="formListTitleText nameColumn">',
									"<%=_T('Language')%>",
								'</label>',
								'<label class="formListTitleText valueColumn">',
									"<%=_T('Text')%>",
								'</label>',
								'<label class="gridAction3ButtonCol"></label>',
							'</li>',
						'</ul>',
					'</div>',
				'</div>',
			'</div>',
			'<hr />'
		),
		greeting_text_row: ('').concat(
			'<li greeting_text_row locale="{{ locale }}" text="{{ text }}" class="formListItem">',
				'<label class="formItemText nameColumn">',
					'{{ locale }}',
				'</label>',
				'<label class="formItemText valueColumn">',
					'{{ text }}',
				'</label>',
				'<button greeting_text_action="duplicate" class="buttonColorGray gridActionButton chatbotConfigDuplicate">',
					'<i class="buttons-icons-clone"></i>',
				'</button>',
				'<button greeting_text_action="edit" class="buttonColorGray gridActionButton chatbotConfigEdit">',
					'<i class="buttons-icons-edit"></i>',
				'</button>',
				'<button greeting_text_action="delete" class="buttonColorGray gridActionButton chatbotConfigDelete last">',
					'<i class="buttons-icons-delete"></i>',
				'</button>',
				'<i validation class="formFieldValidation formFieldError" style="display: none;"></i>',
			'</li>'
		),
		greeting_text_form: ('').concat(
			'<div id="adm_form_campaign_page_messenger_popup_greeting_text" >',
				'<div class="row">',
					'<div class="col-6">',
						'<div class="form-group">',
							'<label for="{{ guid }}_greeting_text_locale" class="required">',
								"<%=_T('Language')%>", "<%=_T(':')%>",
							'</label>',
							'<select control="greeting_text_locale" id="{{ guid }}_greeting_text_locale" class="form-control"></select>',
							'<i validation="greeting_text_locale" class="formFieldValidation formFieldError" style="display: none;"></i>',
						'</div>',
					'</div>',
				'</div>',
				'<div class="row">',
					'<div class="col-12">',
						'<div class="form-group">',
							'<label for="{{ guid }}_greeting_text_message" class="required">',
								"<%=_T('Message')%>:",
							'</label>',
							'<textarea control="greeting_text_message" id="{{ guid }}_greeting_text_message" rows="10" class="rowsBased form-control emojipickerTextarea">',
							'</textarea>',
							'<i validation="greeting_text_message" class="formFieldValidation formFieldError" style="display: none;"></i>',
						'</div>',
					'</div>',
				'</div>',
				'<div class="row">',
					'<div class="col-12">',
						'<div class="inlineMessagesContainer messageInfo">',
							'{{ text_disclaimer }}',
						'</div>',
					'</div>',
				'</div>',
				// buttons
				"<div class='row custom-form-buttons-container'>",
					"<div class='col-12'>",
					"<button greeting_cancel_button class='pageButtonGeneric buttonColorWhite' ><%=_T('Cancel')%></button>",
						"<button greeting_update_button class='pageButtonGeneric buttonColorWhite'><%=_T('Confirm')%></button>",
					"</div>",
				"</div>",
			'</div>'
		),
		whitelisted_domains: ('').concat(
			'<div whitelisted_domains_container>',
				'<div class="row">',
					'<div class="col-12">',
						'<div class="card-header d-flex flex-row justify-content-between">',
							'<h5>', "<%=_T('Whitelisted Domains')%>", ' <span class="fa fa-question-circle" title="', "<%=_T('Specifies a list of third-party domains that can be accessed in the Messenger web view for use with the Messenger Extensions SDK, the checkbox plug-in, and the customer chat plug-in.')%>", '"></span></h5>',

							'<div class="d-flex align-items-start pt-1 align-self-start mb-4">',
								'<button new_whitelisted_domain class="pageButtonGeneric buttonColorWhite pageButtonNew"> <i class="far fa-plus"> </i>', "<%=_T('Add Domain')%>", '</button>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',
				'<div whitelisted_domains_form_container style="display:none;">',
				'</div>',
				'<div class="row">',
					'<div class="col-12">',
					'	<ul whitelisted_domains_list class="formList formListAsGrid mt-0 whitelistedDomainsTextList">',
							'<li class="formListTitle">',
								'<label class="formListTitleText nameColumn">',
									"<%=_T('Domain')%>",
								'</label>',
								'<label class="gridAction2ButtonCol"></label>',
							'</li>',
						'</ul>',
					'</div>',
				'</div>',
			'</div>'
		),
		whitelisted_domains_row: ('').concat(
			'<li whitelisted_domain_row domain="{{ domain }}" class="formListItem">',
				'<label class="formItemText nameColumn">',
					'{{ domain }}',
				'</label>',
				'<button whitelisted_domain_action="edit" class="buttonColorGray gridActionButton chatbotConfigEdit">',
					'<i class="buttons-icons-edit"></i>',
				'</button>',
				'<button whitelisted_domain_action="delete" class="buttonColorGray gridActionButton chatbotConfigDelete last">',
					'<i class="buttons-icons-delete"></i>',
				'</button>',
				'<i validation class="formFieldValidation formFieldError" style="display: none;"></i>',
			'</li>'
		),
		whitelisted_domains_form: ('').concat(
			'<div id="adm_form_campaign_page_messenger_popup_whitelisted_domain">',
				'<div class="row">',
					'<div class="col-12">',
						'<div class="form-group mb-4">',
							'<label for="{{ guid }}_whitelisted_domain" class="required">',
								"<%=_T('Domain')%>:",
							'</label>',
							'<div class="d-flex flex-row">',
								'<div class="position-relative flex-grow-1">',
									'<input control="whitelisted_domain" id="{{ guid }}_whitelisted_domain" class="form-control" type="text" placeholder="', "<%=_T('Enter the domain')%>...", '" />',
									'<i validation="whitelisted_domain" class="formFieldValidation formFieldError" style="display: none;"></i>',
								'</div>',
								'<button whitelisted_domain_update_button class="pageButtonGeneric buttonColorWhite iconOnlyBtn save align-self-end" title="', "<%=_T('Confirm')%>", '"><i class="fa fa-check-circle"></i></button>',
								'<button whitelisted_domain_cancel_button class="pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end ml-0" title="', "<%=_T('Cancel')%>", '"><i class="fa fa-times-circle"></i></button>',
							'</div>',
						'</div>',
				'</div>',
			'</div>'
		),
		persistent_menu: ('').concat(
			'<div class="row">',
				'<div class="col-12">',
					'<div class="card-header d-flex flex-row justify-content-between">',
						'<h5>', "<%=_T('Persistent menu with global actions')%>", ' <span class="fa fa-question-circle" title="', "<%=_T('Create drop-down menu options that the client will have available during the Messenger conversation with the fanpage.')%>", '"></span></h5>',

						'<div class="d-flex align-items-start pt-1 align-self-start mb-4">',
							'<button new_persistent_menu class="pageButtonGeneric buttonColorWhite pageButtonNew"> <i class="far fa-plus"> </i>', "<%=_T('Add Menu')%>", '</button>',
						'</div>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<ul persistent_menu_list class="formList formListAsGrid mt-0 persistentMenuList">',
						'<li class="formListTitle">',
							'<label class="formListTitleText nameColumn">',
								"<%=_T('Language')%>", "<%=_T(':')%>",
							'</label>',
							'<label class="gridAction3ButtonCol"></label>',
						'</li>',
					'</ul>',
				'</div>',
			'</div>',
			'<hr/>'
		),
		persistent_menu_row: ('').concat(
			'<li persistent_menu_row locale="{{ locale }}" text="{{ text }}" class="formListItem persistentMenuRow">',
				'<label class="formItemText nameColumn">',
					'{{ locale }}',
				'</label>',
				'<button persistent_menu_action="duplicate" class="buttonColorGray gridActionButton chatbotConfigDuplicate">',
					'<i class="buttons-icons-clone"></i>',
				'</button>',
				'<button persistent_menu_action="edit" class="buttonColorGray gridActionButton chatbotConfigEdit">',
					'<i class="buttons-icons-edit"></i>',
				'</button>',
				'<button persistent_menu_action="delete" class="buttonColorGray gridActionButton chatbotConfigDelete last">',
					'<i class="buttons-icons-delete"></i>',
				'</button>',
				
				'<i validation class="formFieldValidation formFieldError" style="display: none;"></i>',
			'</li>'
		),
		persistent_menu_form: ('').concat(
			// pageMessengerPersistentMenuPopUp
			'<div id="adm_form_campaign_page_messenger_popup_persistent_menu" class="internalPopUpContainer formPopUp popUp720w popUpFullHeight" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// title
					'<div class="internalPopUpTitle">',
						'<label>', 
							// "<%=_T('Messenger bot')%>", 
							// '<span class="messengerPageName">',
							// '{{ main_title }}',
							// '</span>',
							"<%=_T('Persistent Menu')%>",
						'</label>',
						'<button persistent_menu_cancel_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					'<div persistent_menu_popup_form class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div popup_error class="genericFormMessagesContainer messageError" hidden style="display:none;">',
							'<label popup_error_label class="messageText"></label>',
						'</div>',
						// form
						'<div class="bo-card card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-8">',
										'<div class="form-group">',
											'<label for="{{ guid }}_persistent_menu_locale" class="required">',
												"<%=_T('Language')%>", "<%=_T(':')%>",
											'</label>',
											'<select control="persistent_menu_locale" id="{{ guid }}_persistent_menu_locale" class="form-control"></select>',
											'<i validation="persistent_menu_locale" class="formFieldValidation formFieldError" style="display:none;"></i>',
										'</div>',
									'</div>',
									'<div class="col-4">',
										'<div class="form-group">',
											'<div class="form-check">',
												'<label for="{{ guid }}_persistent_menu_input_disabled" class="form-check-label form-check-label-title">',
													'<input control="persistent_menu_input_disabled" id="{{ guid }}_persistent_menu_input_disabled" class="form-check-input" type="checkbox">',
													"<%=_T('Disable the composer')%>", '<span class="fa fa-question-circle" title="', "<%=_T('By checking the box, you will be making the persistent menu the only way for the client to interact with your Messenger bot. This is useful if your bot has a very specific purpose or set of options.')%>", '"></span>',
												'</label>',
											'</div>',
										'</div>',
									'</div>',
								'</div>',
								'<hr />',
								'<div buttons_container>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						'<button persistent_menu_cancel_button class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
						'<button persistent_menu_update_button class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Confirm")%> </button>',		
					'</div>',
				'</div>',
			'</div>'
		),
		persistent_menu_button_form: ('').concat(
			// pageMessengerPersistentMenuPopUp
			'<div id="adm_form_campaign_page_messenger_popup_persistent_menu_button" class="internalPopUpContainer formPopUp popUp720w popUpFullHeight" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// title
					'<div class="internalPopUpTitle">',
						'<label>', 
							// "<%=_T('Messenger bot')%>", 
							// '<span class="messengerPageName">',
							// '{{ main_title }}',
							// '</span>',
							"<%=_T('Persistent Menu')%>", 
							" > <%=_T('Button')%>",
						'</label>',
						'<button persistent_menu_button_cancel_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					'<div persistent_menu_button_popup_form class="internalPopUpMiddle pageFormContainer">',
						// mensaje de error
						'<div popup_error class="genericFormMessagesContainer messageError" hidden style="display:none;">',
							'<label popup_error_label class="messageText"></label>',
						'</div>',
						// form
						'<div class="no-card card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-6">',
										'<div class="form-group">',
											'<label for="{{ guid }}_button_type" class="required">',
												"<%=_T('Button Type')%>:",
											'</label>',
											'<select control="button_type" id="{{ guid }}_button_type" class="form-control"></select>',
											'<i validation="button_type" class="formFieldValidation formFieldError" style="display: none;"></i>',
											// '<div button_type_disclaimer class="formDataDisclaimer explanation">', 
											// '</div>',
										'</div>',
									'</div>',
								'</div>',

							'</div>',
						'</div>',
					'</div>',
					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						'<button persistent_menu_button_cancel_button class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
						'<button persistent_menu_button_update_button class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Confirm")%> </button>',
					'</div>',
				'</div>',
			'</div>'
		),
		persistent_menu_button_web_url: ('').concat(
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_title" class="required">',
							"<%=_T('Title')%>:",
						'</label>',
						'<input control="button_title" id="{{ guid }}_button_title" class="form-control" type="text" placeholder="', "<%=_T('Enter the title')%>...", '" >',
						'<i validation="button_title" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>',
			'<hr />',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_url" class="required">',
							"<%=_T('Url')%>:",
						'</label>',
						'<input control="button_url" id="{{ guid }}_button_url" class="form-control" type="text" placeholder="', "<%=_T('Enter the URL')%>...", '" />',
						'<i validation="button_url" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row pt-2">',
				'<div class="col-6">',
					'<div class="form-group">',
						'<div class="form-check">',
							'<label for="{{ guid }}_button_messenger_extensions" class="form-check-label form-check-label-title">',
								'<input  control="button_messenger_extensions" id="{{ guid }}_button_messenger_extensions"  class="form-check-input" type="checkbox">',
								"<%=_T('Show url in a webview')%>",
							'</label>',
						'</div>',
					'</div>',
				'</div>',
			'</div>',
			// webview control
			'<div webview_control class="row">',
				'<div class="col-6">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_webview_height_ratio" class="required">',
							"<%=_T('Webview size')%>:",
						'</label>',
						'<select control="button_webview_height_ratio" id="{{ guid }}_button_webview_height_ratio" class="form-control">',
							'<option value="compact"><%=_T("Compact")%></option>',
							'<option value="tall"><%=_T("Tall")%></option>',
							'<option value="full"><%=_T("Full")%></option>',
						'</select>',
						'<i validation="button_webview_height_ratio" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
				'<div webview_control class="col-6">',
					'<div class="form-group">',
						'<div class="form-check">',
							'<label for="{{ guid }}_button_webview_share_button" class="form-check-label form-check-label-title">',
								'<input  control="button_webview_share_button" id="{{ guid }}_button_webview_share_button"  class="form-check-input" type="checkbox">',
								"<%=_T('Share Button')%>",
							'</label>',
						'</div>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div disclaimer="start_button_postback" class="inlineMessagesContainer messageInfo">', 
						"<%=_T('The entered domain must be included as Whitelisted.')%>",
					'</div>',
				'</div>',
			'</div>'
		),
		persistent_menu_button_phone_number: ('').concat(
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_title" class="required">',
							"<%=_T('Title')%>:",
						'</label>',
						'<input control="button_title" id="{{ guid }}_button_title" class="form-control" type="text" placeholder="', "<%=_T('Enter the title')%>...", '" >',
						'<i validation="button_title" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>',
			'<hr />',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_number" class="required">',
							"<%=_T('Number')%>:",
						'</label>',
						'<input control="button_number" id="{{ guid }}_button_number" class="form-control" type="text" />',
						'</select>',
						'<i validation="button_number" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="inlineMessagesContainer messageInfo">',
						"<%=_T('Must start with + and include country code')%>",
					'</div>',
				'</div>',
			'</div>'
		),
		persistent_menu_button_postback: ('').concat(
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_title" class="required">',
							"<%=_T('Title')%>:",
						'</label>',
						'<input control="button_title" id="{{ guid }}_button_title" class="form-control" type="text" placeholder="', "<%=_T('Enter the title')%>...", '" >',
						'<i validation="button_title" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>',
			'<hr />',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_state" class="required">',
							"<%=_T('State')%>:",
						'</label>',
						'<select control="button_state" id="{{ guid }}_button_state" class="form-control">',
						'</select>',
						'<i validation="button_state" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="inlineMessagesContainer messageInfo">', 
						"<%=_T('The state will be executed when the user presses the button.')%>",
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_message">',
							"<%=_T('Message')%>:",
						'</label>',
						'<input control="button_message" id="{{ guid }}_button_message" class="form-control" type="text" placeholder="', "<%=_T('Enter the message')%>...", '" />',
						'<i validation="button_message" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="inlineMessagesContainer messageInfo">', 
						"<%=_T('The message will be shown when the state is executed.')%>",
					'</div>',
				'</div>',
			'</div>'
		),
		persistent_menu_button_nested: ('').concat(
			'<div class="row">',
				'<div class="col-12">',
					'<div class="form-group">',
						'<label for="{{ guid }}_button_title" class="required">',
							"<%=_T('Title')%>:",
						'</label>',
						'<input control="button_title" id="{{ guid }}_button_title" class="form-control" type="text" placeholder="', "<%=_T('Enter the title')%>...", '" >',
						'<i validation="button_title" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
			'</div>'
		),
		persistent_menu_button_list: ('').concat(
			'<div button_list_container>',
				'<ul button_list class="formList formListAsGrid mt-0 persistentMenuButtonList"></ul>',
			'</div>'
		),
		persistent_menu_button_add_root: ('').concat(
			'<div class="row mb-4"><div class="col-12">',
				'<button add_button class="pageButtonGeneric buttonColorWhite pageButtonNew float-left">',
					'<i class="far fa-plus"> </i>',
					"<%=_T('Add Button')%>",
				'</button>',
			'</div></div>'
		),
		persistent_menu_button_add: ('').concat(
			'<button add_button class="buttonColorGray gridActionButton">',
				'<i class="buttons-icons-add"></i>',
			'</button>',
		),
		persistent_menu_button: ('').concat(
			'<li menu_button class="formListItem persistentMenuButton {{className}}">',
				'<label button_title class="formItemText nameColumn">',
					'{{ title }}',
				'</label>',
				'<i validation class="formFieldValidation formFieldError" style="display: none;"></i>',
				'<label button_subtitle class="formItemText valueColumn">',
					'{{ subtitle }}',
				'</label>',
				'<button edit_button class="buttonColorGray gridActionButton chatbotConfigEdit">',
					'<i class="buttons-icons-edit"></i>',
				'</button>',
				'<button delete_button class="buttonColorGray gridActionButton chatbotConfigDelete last">',
					'<i class="buttons-icons-delete"></i>',
				'</button>',
			'</li>'
		),
		entry_points: ('').concat(
			//m.me link
			'<div class="row">',
				'<div class="col-12">',
					'<div class="card-header">',
						'<h5>', "<%=_T('m.me Link to access to facebook bot')%>", '</h5>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12 d-flex flex-row">',
					'<div class="form-group flex-grow-1">',
						'<label for="{{ guid }}_mme_postback">',
							"<%=_T('Postback')%>", "<%=_T(':')%>",
						'</label>',
						'<input control="mme_postback" id="{{ guid }}_mme_postback" class="form-control" type="text">',
						'<i validation="mme_postback" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
					'<div class="form-group d-flex align-items-end">',
						'<button mme_open_popup class="pageButtonGeneric buttonColorWhite">',
							"<%=_T('Get Url')%>",
						'</button>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="inlineMessagesContainer messageInfo">', 
						"<%=_T('This message will be received by New Incoming event when user enters the url.')%>",
					'</div>',
				'</div>',
			'</div>',
			'<hr />',
			//messenger code
			'<div class="row">',
				'<div class="col-12">',
					'<div class="card-header">',
						'<h5>', "<%=_T('Messenger Code')%>", ' <span class="fa fa-question-circle" title="', "<%=_T('Messenger Codes can be scanned to instantly link the user to your bot.')%>", '"></span>', '</h5>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-6">',
					'<div class="form-group">',
						'<label for="{{ guid }}_code_postback">',
							"<%=_T('Postback')%>:",
						'</label>',
						'<input control="code_postback" id="{{ guid }}_code_postback" class="form-control" type="text">',
						'<i validation="code_postback" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
				'<div class="col-5">',
					'<div class="form-group">',
						'<label for="{{ guid }}_code_size">',
							"<%=_T('QR Image size')%>:",
						'</label>',
						'<div class="messengerCodeSizeContainer">',
							'<div control="code_size" id="{{ guid }}_code_size" class="messengerCodeSize">',
								'<div control="code_size_handle" class="ui-slider-handle">',
								'</div>',
							'</div>',
							'<span class="ui-slider-pixels-value"></span>',
						'</div>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-12">',
					'<div class="inlineMessagesContainer messageInfo">', 
						"<%=_T('This message will be received by New Incoming event when user scans the code.')%>",
					'</div>',
				'</div>',
			'</div>',
			'<div class="row pt-2">',
				'<div class="col-6">',
					'<div class="form-group d-flex">',
						'<button code_button class="pageButtonGeneric buttonColorWhite">',
							"<%=_T('Get Code')%>",
						'</button>',
					'</div>',
				'</div>',
			'</div>',
			'<hr />',
			//message us plugin
			'<div class="row">',
				'<div class="col-12">',
					'<div class="card-header">',
						'<h5>', "<%=_T('Message-Us button plugin')%>", '</h5>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-8">',
					'<div class="row">',
						'<div class="col-6">',
							'<div class="form-group">',
								'<label for="{{ guid }}_messageus_color">',
									"<%=_T('Color')%>:",
								'</label>',
								'<select control="messageus_color" id="{{ guid }}_messageus_color" class="form-control">',
									'<option value="blue"><%=_T("Blue")%></option>',
									'<option value="white"><%=_T("White")%></option>',
								'</select>',
							'</div>',
						'</div>',
						'<div class="col-6">',
							'<div class="form-group">',
								'<label for="{{ guid }}_messageus_size">',
									"<%=_T('Size')%>:",
								'</label>',
								'<select control="messageus_size" id="{{ guid }}_messageus_size" class="form-control">',
									'<option value="standard"><%=_T("Standard")%></option>',
									'<option value="large"><%=_T("Large")%></option>',
									'<option value="xlarge"><%=_T("X Large")%></option>',
								'</select>',
							'</div>',
						'</div>',
					'</div>',
					'<div class="row pt-2">',
						'<div class="col-6">',
							'<div class="form-group d-flex">',
								'<button message_us_open_popup class="pageButtonGeneric buttonColorWhite">',
									"<%=_T('Get Snippet')%>",
								'</button>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',
				// COL2
				'<div class="col-4">',
					'<div class="form-group">',
						'<label for="{{ guid }}_messageus_example">',
							"<%=_T('Preview')%>:",
						'</label>',
						'<div control="messageus_example" class="pageMessengerEntryPointsExample">',
						'</div>',
					'</div>',
				'</div>',
			'</div>',
			'<hr />',
			//send to messenger plugin
			'<div class="row">',
				'<div class="col-12">',
					'<div class="card-header">',
						'<h5>', "<%=_T('Send-To-Messenger Plugin')%>", ' <span class="fa fa-question-circle" title="', "<%=_T('Fires a NewIncoming flow event allowing to chat with the user.')%>", '"></span>', '</h5>',
					'</div>',
				'</div>',
			'</div>',
			'<div class="row">',
				'<div class="col-8">',
					'<div class="row">',
						'<div class="col-6">',
							'<div class="form-group">',
								'<label for="{{ guid }}_sendtomessenger_color">',
									"<%=_T('Color')%>:",
								'</label>',
								'<select control="sendtomessenger_color" id="{{ guid }}_sendtomessenger_color" class="form-control">',
									'<option value="blue"><%=_T("Blue")%></option>',
									'<option value="white"><%=_T("White")%></option>',
								'</select>',
							'</div>',
						'</div>',
						'<div class="col-6">',
							'<div class="form-group">',
								'<label for="{{ guid }}_sendtomessenger_size">',
									"<%=_T('Size')%>:",
								'</label>',
								'<select control="sendtomessenger_size" id="{{ guid }}_sendtomessenger_size" class="form-control">',
									'<option value="standard"><%=_T("Standard")%></option>',
									'<option value="large"><%=_T("Large")%></option>',
									'<option value="xlarge"><%=_T("X Large")%></option>',
								'</select>',
							'</div>',
						'</div>',
					'</div>',
					'<div class="row">',
						'<div class="col-6">',
							'<div class="form-group">',
								'<label for="{{ guid }}_sendtomessenger_postback">',
									"<%=_T('Postback')%>:",
								'</label>',
								'<input control="sendtomessenger_postback" id="{{ guid }}_sendtomessenger_postback" class="form-control" type="text">',
								'<i validation="sendtomessenger_postback" class="formFieldValidation formFieldError" style="display: none;"></i>',
							'</div>',
						'</div>',
						'<div class="col-6">',
							'<div class="form-group">',
								'<div class="form-check form-check-right-input">',
									'<label for="{{ guid }}_sendtomessenger_enforce_login" class="form-check-label form-check-label-title">',
										'<input control="sendtomessenger_enforce_login" id="{{ guid }}_sendtomessenger_enforce_login" class="form-check-input" type="checkbox">',
										"<%=_T('Enforce Login')%>:",
									'</label>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					'<div class="row">',
						'<div class="col-12">',
							'<div class="inlineMessagesContainer messageInfo">', 
								"<%=_T('This message will be received by New Incoming event when user enters the url.')%>",
							'</div>',
						'</div>',
					'</div>',
					'<div class="row pt-2">',
						'<div class="col-6">',
							'<div class="form-group d-flex">',
								'<button sendtomessenger_open_popup class="pageButtonGeneric buttonColorWhite">',
									"<%=_T('Get Snippet')%>",
								'</button>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',
				// COL2
				'<div class="col-4">',
					'<div class="form-group">',
						'<label for="{{ guid }}_sendtomessenger_example">',
							"<%=_T('Preview')%>:",
						'</label>',
						'<div control="sendtomessenger_example" class="pageMessengerEntryPointsExample">',
						'</div>',
					'</div>',
				'</div>',
			'</div>'
		),
		m_me_link_form: ('').concat(
			'<div id="adm_form_campaign_page_messenger_popup_m_me_link" class="internalPopUpContainer formPopUp popUp720w" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// title
					'<div class="internalPopUpTitle">',
						'<label>', 
							"<%=_T('m.me Link')%>",
						'</label>',
						'<button m_me_link_close_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					'<div class="internalPopUpMiddle pageFormContainer">',
						// form
						'<div class="no-card card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-12 d-flex flex-row">',
										'<div class="form-group flex-grow-1">',
												'<label for="i{{ guid }}_m_me_link_url">',
												"<%=_T('Url')%>:",
											'</label>',
											'<input control="m_me_link_url" id="i{{ guid }}_m_me_link_url" class="form-control" type="text" readonly>',
										'</div>',
										'<div class="form-group d-flex align-items-end">',
											'<button copy_control="m_me_link_url" class="pageButtonGeneric buttonColorWhite iconOnlyBtn" data-clipboard-target="#i{{ guid }}_m_me_link_url">',
												'<i class="far fa-clone"></i>',
											'</button>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						'<button m_me_link_close_button class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Close")%> </button>',
					'</div>',
				'</div>',
			'</div>',
		),
		code_form: ('').concat(
			'<div id="adm_form_campaign_page_messenger_popup_code" class="internalPopUpContainer formPopUp popUp720w" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// title
					'<div class="internalPopUpTitle">',
						'<label>', 
							"<%=_T('Messenger Code')%>",
						'</label>',
						'<button code_close_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					'<div class="internalPopUpMiddle pageFormContainer">',
						// form
						'<div class="card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-12 d-flex flex-row align-items-start justify-content-center">',
										'<div class="form-group  mr-2">',
											// '<label>',
											// 	"<%=_T('Code')%>:",
											// '</label>',
											'<div class="messengerCodeImagContainer">',
												'<img code_image src="{{ image_url }}" class="messengerCodeImage">',
											'</div>',
										'</div>',
										'<div class="form-group">',
											'<button download_code_image class="pageButtonGeneric buttonColorWhite iconOnlyBtn">',
												'<i class="far fa-download"></i>',
											'</button>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						'<button code_close_button class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Close")%> </button>',
					'</div>',
				'</div>',
			'</div>',

		),
		message_us_form: ('').concat(
			'<div id="adm_form_campaign_page_messenger_popup_message_us" class="internalPopUpContainer formPopUp popUp720w" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// title
					'<div class="internalPopUpTitle">',
						'<label>', 
							"<%=_T('Message-Us Plugin')%>",
						'</label>',
						'<button message_us_close_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					'<div class="internalPopUpMiddle pageFormContainer">',
						// form
						'<div class="card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-12 d-flex flex-row">',
											'<div class="form-group flex-grow-1">',
												'<label for="{{ guid }}_messageus_javascript">',
												"<%=_T('Javascript snippet')%>:",
											'</label>',
											'<textarea control="messageus_javascript" id="i{{ guid }}_messageus_javascript" rows="6" class="form-control rowsBased" readonly>',
											'</textarea>',
										'</div>',
										'<div class="form-group d-flex align-items-start">',
											'<button copy_control="messageus_javascript" class="pageButtonGeneric buttonColorWhite iconOnlyBtn" data-clipboard-target="#i{{ guid }}_messageus_javascript">',
												'<i class="far fa-clone"></i>',
											'</button>',
										'</div>',
									'</div>',
								'</div>',
								'<div class="row">',
									'<div class="col-12 d-flex flex-row">',
											'<div class="form-group flex-grow-1">',
												'<label for="{{ guid }}_messageus_html">',
												"<%=_T('Html Control')%>:",
											'</label>',
											'<textarea control="messageus_html" id="i{{ guid }}_messageus_html" rows="6" class="form-control rowsBased" readonly>',
											'</textarea>',
										'</div>',
										'<div class="form-group d-flex align-items-start">',
											'<button copy_control="messageus_html" class="pageButtonGeneric buttonColorWhite iconOnlyBtn" data-clipboard-target="#i{{ guid }}_messageus_html">',
												'<i class="far fa-clone"></i>',
											'</button>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						'<button message_us_close_button class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Close")%> </button>',
					'</div>',
				'</div>',
			'</div>',
		),
		sendtomessenger_form: ('').concat(
			'<div id="adm_form_campaign_page_messenger_popup_sendtomessenger" class="internalPopUpContainer formPopUp popUp720w" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// title
					'<div class="internalPopUpTitle">',
						'<label>', 
							"<%=_T('Send-To-Messenger Plugin')%>",
						'</label>',
						'<button sendtomessenger_close_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',
					'<div class="internalPopUpMiddle pageFormContainer">',
						// form
						'<div class="card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-12 d-flex flex-row">',
											'<div class="form-group flex-grow-1">',
												'<label for="{{ guid }}_sendtomessenger_javascript">',
												"<%=_T('Javascript snippet')%>:",
											'</label>',
											'<textarea control="sendtomessenger_javascript" id="i{{ guid }}_sendtomessenger_javascript" rows="6" class="form-control rowsBased" readonly>',
											'</textarea>',
										'</div>',
										'<div class="form-group d-flex align-items-start">',
											'<button copy_control="sendtomessenger_javascript" class="pageButtonGeneric buttonColorWhite iconOnlyBtn" data-clipboard-target="#i{{ guid }}_sendtomessenger_javascript">',
												'<i class="far fa-clone"></i>',
											'</button>',
										'</div>',
									'</div>',
								'</div>',
								'<div class="row">',
									'<div class="col-12 d-flex flex-row">',
											'<div class="form-group flex-grow-1">',
												'<label for="{{ guid }}_sendtomessenger_html">',
												"<%=_T('Html Control')%>:",
											'</label>',
											'<textarea control="sendtomessenger_html" id="i{{ guid }}_sendtomessenger_html" rows="6" class="form-control rowsBased" readonly>',
											'</textarea>',
										'</div>',
										'<div class="form-group d-flex align-items-start">',
											'<button copy_control="sendtomessenger_html" class="pageButtonGeneric buttonColorWhite iconOnlyBtn" data-clipboard-target="#i{{ guid }}_sendtomessenger_html">',
												'<i class="far fa-clone"></i>',
											'</button>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						'<button sendtomessenger_close_button class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Close")%> </button>',
					'</div>',
				'</div>',
			'</div>'
		),
		messageus_js: ('').concat(
			'<script>\n',
			'	\n',
			'	window.fbAsyncInit = function() {\n',
			'		FB.init({\n',
			'			appId: "{{ app_id }}",\n',
			'			xfbml: true,\n',
			'			version: "v2.10"\n',
			'		});\n',
			'	\n',
			'	};\n',
			'	\n',
			'	(function(d, s, id){\n',
			'		var js, fjs = d.getElementsByTagName(s)[0];\n',
			'		if (d.getElementById(id)) { return; }\n',
			'		js = d.createElement(s); js.id = id;\n',
			'		js.src = "//connect.facebook.net/en_US/sdk.js";\n',
			'		fjs.parentNode.insertBefore(js, fjs);\n',
			'	}(document, "script", "facebook-jssdk"));\n',
			'	\n',
			'</script>'
		),
		messageus_html: ('').concat(
			'<div class="fb-messengermessageus"\n',
			'	messenger_app_id="{{ app_id }}"\n',
			'	page_id="{{ page }}"\n',
			'	color="{{ color }}"\n',
			'	size="{{ size }}" >\n',
			'</div>'
		),
		sendtomessenger_js: ('').concat(
			'<script>\n',
			'	\n',
			'	window.fbAsyncInit = function() {\n',
			'		FB.init({\n',
			'			appId: "{{ app_id }}",\n',
			'			xfbml: true,\n',
			'			version: "v2.10"\n',
			'		});\n',
			'	\n',
			'	};\n',
			'	\n',
			'	(function(d, s, id){\n',
			'		var js, fjs = d.getElementsByTagName(s)[0];\n',
			'		if (d.getElementById(id)) { return; }\n',
			'		js = d.createElement(s); js.id = id;\n',
			'		js.src = "//connect.facebook.net/en_US/sdk.js";\n',
			'		fjs.parentNode.insertBefore(js, fjs);\n',
			'	}(document, "script", "facebook-jssdk"));\n',
			'	\n',
			'</script>'
		),
		sendtomessenger_html: ('').concat(
			'<div class="fb-send-to-messenger"\n',
			'	messenger_app_id="{{ app_id }}"\n',
			'	page_id="{{ page }}"\n',
			'	data-ref="{{ postback }}"\n', 
			'	enforce_login="{{ enforce_login }}"\n',
			'	color="{{ color }}"\n',
			'	size="{{ size }}" >\n',
			'</div>'
		)
	};

	function PageMessengerAdministration(parent, pageId, pageName, accessToken, data, onSave) {
		this.parent = parent;
		this.pageId = pageId;
		this.pageName = pageName;
		this.accessToken = accessToken;
		this.data = data || {};
		this.onSave = onSave || $.noop;
	}

	if (typeof inConcert.PageMessengerAdministration !== "function") {
		inConcert.PageMessengerAdministration = PageMessengerAdministration;
	}

	PageMessengerAdministration.prototype.Show = function(callback) {
		callback = callback || $.noop;
		var self = this;
		self.__make();
		$("body").append(self.$container);
		self.popup = new inConcert.PopupWindow();
		self.popup.show({
			ownerId         : self.__getPopupId(),
			eventName       : self.__getPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$container,
			callbacks: {
				onOpen: function() {
					self.$container.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.popup) {
						self.popup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
		self.__loadForm(function() {
			self.__afterAppendBody();
			callback();
		});
	};

	PageMessengerAdministration.prototype.Close = function(callback) {
		callback = callback || $.noop;
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		if (self.popup && self.popup.isVisible()) {
			self.popup.finalize(function() {
				self.popup = null;
				self.$container.remove();
				callback();
			});
		}
		else {
			self.$container.remove();
			callback();
		}
	};

	PageMessengerAdministration.prototype.RestoreDefaults = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		function doAction() {
			self.__restoreForm();
			self.__save();
		}
		$.inconcertPopup.Show(
			"<%=_T('Confirmation')%>",
			"<%=_T('Do you want to restore default settings?')%>",
			$.inconcertPopup.ButtonSets.BS_YESNO,
			function(response) {
				if (response.toLowerCase() === "yes") {
					doAction();
				}
			},
			undefined,
			{
				popup_id        : "conf_inconcertPopup",
				container_class : "confirmationPopUp",
				overlay_class   : "confirmationOverlay"
			}
		);
	};

	PageMessengerAdministration.prototype.__restoreForm = function() {
		this.__restoreProcessFlow();
		this.__restoreStartButton();
		this.__restoreGreetingText();
		this.__restorePersistentMenu();
		this.__restoreWhitelistedDomains();
	};

	PageMessengerAdministration.prototype.__save = function(callback) {
		var self = this;
		callback = callback || $.noop;

		var data = {};
		var fbData = {};
		self.__validateProcessFlow(data, fbData);
		self.__validateStartButton(data, fbData);
		self.__validateGreetingText(data, fbData);
		self.__validatePersistentMenu(data, fbData);
		self.__validateWhitelistedDomains(data, fbData);
		
		if (data.error) {
			self.__showError(data.error);
			return callback(false);
		}
		
		self.__processing(true);
		self.__updateFbData(fbData, function(error) {
			self.__processing(false);
			if (!error) {
				self.onSave(self.pageId, data);
			}
			else {
				self.__showError(error);
			}
			callback(!error);
		});
	};

	PageMessengerAdministration.prototype.Save = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		
		self.__save(function(status) {
			if (status) {
				self.Close();
			}
		});
	};

	PageMessengerAdministration.prototype.__updateFbData = function(data, callback) {
		callback = callback || $.noop;
		var self = this;
		var dataToUpdate = {};
		var dataToDelete = [];
		$.each(data, function(id, property) {
			if (property && !$.isEmptyObject(property)) {
				dataToUpdate[id] = property;
			}
			else {
				dataToDelete.push(id);
			}
		});

		function updateProperties(callback) {
			if ($.isEmptyObject(dataToUpdate)) {
				return callback();
			}
			self.parent.update_messenger_profile(self.accessToken, dataToUpdate, function(status, error) {
				callback(status? null : format("<%=_T('Error updating facebook properties: {0}.')%> ", error || ""));
			});
		}

		function deleteProperties(callback) {
			if (!dataToDelete.length) {
				return callback();
			}
			self.parent.delete_messenger_profile(self.accessToken, dataToDelete, function(status, error) {
				callback(status? null : format("<%=_T('Error deleting facebook properties: {0}.')%> ", error || ""));
			});
		}

		deleteProperties(function(errorDeleting) {
			updateProperties(function(errorUpdating) {
				var error = "" + (errorDeleting || "") + (errorUpdating || "");
				callback(error);
			});
		});
	};

	PageMessengerAdministration.prototype.IsProcessing = function() {
		return !!this.processing;
	};

	PageMessengerAdministration.prototype.__processing = function(processing, text) {
		this.processing = !!processing;
		this.$container.find("[popup_loading_label]").text(text || "<%=_T('Updating bot configuration')%>...");
		this.$container.find("[popup_loading]").toggle(this.processing);
	};

	PageMessengerAdministration.prototype.__clearErrors = function($container) {
		$container = $container || this.$container;
		$container.find("[validation], [popup_error]").hide();
		$container.find("[popup_error_label]").text("");
	};

	PageMessengerAdministration.prototype.__showError = function(error, $container) {
		var root = !$container;
		$container = $container || this.$container;
		if (typeof error === "string") {
			error = { message : error };
		}
		$container.find("[popup_error]").show();
		$container.find("[popup_error_label]").text(error.message);
		if (error.control) {
			$container.find(format("[validation={0}]", error.control)).show();
		}
		else if (error.$control) {
			error.$control.find("[validation]:first").show();
		}
		$container.find(".internalPopUpMiddle").scrollTop(0);
		if (root) {
			this.tabs.switch_tab("configuration");
		}
	};

	PageMessengerAdministration.prototype.__make = function() {
		var self = this;
		self.$container = $(Mustache.render(templates.base, {
			name : self.pageName,
			popup_id : self.__getPopupId()
		}));
		self.$container.find("[update_button]")
			.click(function() {
				self.Save();
			})
			.prop("disabled", true);
		self.$container.find("[cancel_button]").click(function() {
			self.Close();
		});
		self.$container.find("[restore_button]").click(function() {
			self.RestoreDefaults();
		});
	};

	PageMessengerAdministration.prototype.__getPopupId = function() {
		return "adm_form_campaign_page_messenger_popup";
	};

	PageMessengerAdministration.prototype.__afterAppendBody = $.noop;

	PageMessengerAdministration.prototype.__loadProcessFlows = function(callback) {
		callback = callback || $.noop;
		var self = this;
		var flowAPI = inConcert.app.getFlowDesignerAPI();
		flowAPI.loadFlowsByType({ proxyType : "FACEBOOK_BOT" }, function(success, flows) {
			if (success) {
				self.processFlows = flows;
				callback();
			}
			else {
				callback("<%=_T('Error loading process flows.')%>");
			}
		});
	};

	PageMessengerAdministration.prototype.__loadFacebookData = function(callback) {
		callback = callback || $.noop;
		var self = this;
		self.parent.get_messenger_profile(self.accessToken, function(data, error) {
			if (data) {
				self.fbData = data;
				callback();
			}
			else {
				callback(format("<%=_T('Error loading facebook profile. Please try to reauthorize app.')%> - {0}", error || ""));
			}
		});
	};

	PageMessengerAdministration.prototype.__loadForm = function(callback) {
		callback = callback || $.noop;
		var self = this;
		//load flows
		self.__loadProcessFlows(function(error) {
			if (error) {
				self.__processing(false);
				self.$container.find("[popup_form]").show();
				return self.__showError(error);
			}
			//load fb data
			self.__loadFacebookData(function(error) {
				if (error) {
					self.__processing(false);
					self.$container.find("[popup_form]").show();
					return self.__showError(error);
				}
				//make form
				self.__makeForm();
				callback();
			});
		});
	};

	PageMessengerAdministration.prototype.__makeForm = function() {
		var self = this;
		var $form = self.$container.find("[popup_form]");
		//configuration
		var $configuration = $form.find("#page_messenger_tabs_configuration");
		var $globalConfiguration = $(templates.global_configuration);
		$configuration.append($globalConfiguration);
		$globalConfiguration.append(self.__makeProcessFlow());
		self.__loadProcessFlowStates();
		$globalConfiguration.append(self.__makeStartButton());
		$configuration.append(self.__makeGreetingText());
		$configuration.append(self.__makePersistentMenu());
		$configuration.append(self.__makeWhitelistedDomains());
		//entry points
		var $entryPoints = $form.find("#page_messenger_tabs_entry_points");
		$entryPoints.append(self.__makeEntryPoints());
		//tabs
		this.tabs = new inConcert.conf_form_tab({
			parent       : this,
			container_id : "page_messenger_tabs",
			tabs_list    : {
				configuration : {
					id               : "configuration",
					name             : "<%=_T('Configuration')%>",
					tab_container_id : "page_messenger_tabs_configuration",
					selected         : true,
					initial_state    : "enabled"
				},
				entry_points : {
					id               : "entry_points",
					name             : "<%=_T('Entry Points')%>",
					tab_container_id : "page_messenger_tabs_entry_points",
					initial_state    : "enabled"
				}
			}
		});
		this.tabs.show_tabs_container();
		//show form
		self.__processing(false);
		self.$container.find("[update_button]").prop("disabled", false);
		$form.show();
	};

	PageMessengerAdministration.prototype.__loadProcessFlowStates = function() {
		var self = this;
		var flowId = self.$container.find("[control=process_flow]").val();
		var flow = flowId && self.processFlows[flowId] || null;
		//form
		self.$container.find("[control_label=process_flow_inactivity_time]")
			// .toggleClass("formLabel-ds", !flow)
			.toggleClass("required", !!flow);
		self.$container.find("[control=process_flow_inactivity_time]").prop("disabled", !flow);
		self.$container.find("[control=process_flow_inactivity_time_unit]").prop("disabled", !flow);
		self.$container.find("[disclaimer=process_flow_inactivity_time]").toggle(!!flow);
		//states
		self.states = {};
		self.states_byName = {};
		self.states_a = [];
		if (flow) {
			$.each(flow.Draw.states, function(id, state) {
				id  = "state_" + id;
				var stateData = {
					id : id,
					name : state.name,
					description : state.description
				};
				self.states[id] = stateData;
				self.states_byName[state.name] = stateData;
				self.states_a.push(stateData);
			});
		}
		self.states_a.sort(function(a, b) {
			return a.name.localeCompare(b.name);
		});
		self.states_o = "<option value=''></option>";
		$.each(self.states_a, function(_, state) {
			self.states_o += format("<option value='{0}' title={1}'>{2}</option>",
				state.id, state.description, state.name);
		});
	};

	PageMessengerAdministration.prototype.__getStateFromPayload = function(payload) {
		if (!payload) {
			return null;
		}
		var sections = payload.split(":");
		if (sections.length < 4 || sections[0] !== "state") {
			return null;
		}
		var stateId = sections[1];
		var stateName = sections[2];
		if (this.states[stateId]) {
			return stateId;
		}
		return this.states_byName[stateName]? this.states_byName[stateName].id : null;
	};

	PageMessengerAdministration.prototype.__getStateNameFromPayload = function(payload) {
		if (!payload) {
			return "";
		}
		var sections = payload.split(":");
		if (sections.length < 4 || sections[0] !== "state") {
			return "";
		}
		return sections[2];
	};

	PageMessengerAdministration.prototype.__getMessageFromPayload = function(payload) {
		if (!payload) {
			return "";
		}
		var sections = payload.split(":");
		if (sections.length < 4 || sections[0] !== "state") {
			return "";
		}
		var message = sections[3];
		for (var i = 4; i < sections.length; i++) {
			message += ":" + sections[i];
		}
		return message;
	};

	PageMessengerAdministration.prototype.__getPayloadFromState = function(stateId, message) {
		if (!stateId || !this.states[stateId]) {
			return "";
		}
		var state = this.states[stateId];
		return format("state:{0}:{1}:{2}", state.id, state.name, message || "");
	};

	PageMessengerAdministration.prototype.__validateStatePayload = function(payload) {
		var stateId = this.__getStateFromPayload(payload);
		if (!stateId) {
			return false;
		}
		return this.__getPayloadFromState(stateId, this.__getMessageFromPayload(payload));
	};

	PageMessengerAdministration.prototype.__showPopup = function(parentId) {
		$("#" + (parentId || this.__getPopupId())).addClass("withChildPopup");
	};

	PageMessengerAdministration.prototype.__closePopup = function(parentId) {
		$("#" + (parentId || this.__getPopupId())).removeClass("withChildPopup");
	};

//process flow
	PageMessengerAdministration.prototype.__makeProcessFlow = function() {
		var self = this;
		var $container = $(Mustache.render(templates.process_flow, {
			guid : inConcert.Utils.generateGuid()
		}));
		//load options
		var options_a = self.processFlows;
		self.processFlows = {};
		options_a.sort(function(a, b) {
			return a.Name.localeCompare(b.Name);
		});
		var options_s = "<option value=''>---<%=_T('Without process')%>---</option>";
		$.each(options_a, function(_, option) {
			options_s += format("<option value='{0}' title={1}'>{2}</option>",
				option.Id, option.Description, option.Name);
			self.processFlows[option.Id] = option;
		});
		$container.find("[control=process_flow]")
			.html(options_s)
			.change(function() {
				self.__loadProcessFlowStates();
			})
			.val(self.data.processFlow || "");
		var inactivityUnit = self.data.inactivityTimeUnit || "minutes";
		var inactivityTime = self.data.inactivityTimeSeconds || 30 * 60;
		$container.find("[control=process_flow_inactivity_time_unit]").val(inactivityUnit);
		switch(inactivityUnit) {
			case "minutes":
					$container.find("[control=process_flow_inactivity_time]").val(inactivityTime / 60);
					break;
				case "hours":
					$container.find("[control=process_flow_inactivity_time]").val(inactivityTime / 60 / 60);
					break;
		}
		return $container;
	};

	PageMessengerAdministration.prototype.__validateProcessFlow = function(data/*, fbData*/) {
		var self = this;
		data.processFlow = self.$container.find("[control=process_flow]").val() || null;
		if (data.processFlow) {
			var inactivityTime = parseInt(self.$container.find("[control=process_flow_inactivity_time]").val());
			data.inactivityTimeUnit = self.$container.find("[control=process_flow_inactivity_time_unit]").val();
			switch(data.inactivityTimeUnit) {
				case "minutes":
					data.inactivityTimeSeconds = inactivityTime * 60;
					break;
				case "hours":
					data.inactivityTimeSeconds = inactivityTime * 60 * 60;
					break;
			}
			if (!data.inactivityTimeSeconds || data.inactivityTimeSeconds < 0 || data.inactivityTimeSeconds > 24 * 60 * 60) {
				data.error = data.error = {
					control : "process_flow_inactivity_time",
					message : "<%=_T('Inactivity time must be a number and less than 24 hours.')%>"
				};
			}
		}
	};

	PageMessengerAdministration.prototype.__restoreProcessFlow = function() {
		this.$container.find("[control=process_flow]")
			.val("")
			.change();
	};

//start button
	PageMessengerAdministration.prototype.__makeStartButton = function() {
		var self = this;
		var $container = $(Mustache.render(templates.start_button, {
			guid : inConcert.Utils.generateGuid()
		}));
		$container.find("[control=start_button_enabled]")
			.change(function() {
				self.__enableStartButton();
			})
			.prop("checked", !!self.fbData.get_started);
		var payload = (self.fbData.get_started && self.fbData.get_started.payload || "").replace("start_button:", "");
		$container.find("[control=start_button_postback]")
			.val(payload);
		self.__enableStartButton($container);
		return $container;
	};

	PageMessengerAdministration.prototype.__enableStartButton = function($container) {
		$container = $container || this.$container;
		var enabled = $container.find("[control=start_button_enabled]").is(":checked");
		$container.find("[control_label=start_button_postback]")
			// .toggleClass("formLabel-ds", !enabled)
			.toggleClass("required", enabled);
		$container.find("[control=start_button_postback]").prop("disabled", !enabled);
		$container.find("[disclaimer=start_button_postback]").toggle(enabled);
	};

	PageMessengerAdministration.prototype.__validateStartButton = function(data, fbData) {
		var self = this;
		fbData.get_started = self.$container.find("[control=start_button_enabled]").is(":checked")? {} : false;
		if (fbData.get_started) {
			fbData.get_started.payload = self.$container.find("[control=start_button_postback]").val();
			if (!fbData.get_started.payload) {
				data.error = {
					control : "start_button_postback",
					message : "<%=_T('Must enter a start button postback message.')%>"
				};
			}
			fbData.get_started.payload = "start_button:" + fbData.get_started.payload;
		}
	};

	PageMessengerAdministration.prototype.__restoreStartButton = function() {
		this.$container.find("[control=start_button_enabled]")
			.prop("checked", false)
			.change();
	};

//greeting text
	PageMessengerAdministration.prototype.__makeGreetingText = function() {
		var self = this;
		var $container = $(templates.greeting_text);
		var $rows = [];
		var rows = self.fbData.greeting || [];
		rows.sort(function(a, b) {
			return a.locale === "default" ? 1 :
					b.locale === "default" ? -1:
					a.locale.localeCompare(b.locale);
		});
		$.each(rows, function(_, row) {
			$rows.push(self.__makeGreetingTextRow(row));
		});
		$container.find("[greeting_text_list]").append($rows);
		$container.find("[new_greeting_text]").click(function() {
			self.__newGreetingText();
		});
		return $container;
	};

	PageMessengerAdministration.prototype.__makeGreetingTextRow = function(data) {
		var self = this;
		var $row = $(Mustache.render(templates.greeting_text_row, {
			locale : data.locale,
			text : data.text
		}));
		$row.find("[greeting_text_action=edit]").click(function() {
			if ($("#adm_form_campaign_page_messenger_popup_greeting_text").length) {
				return;
			}
			self.__editGreetingText(self.__getGreetingTextRowData($(this).closest("[greeting_text_row]")));
		});
		$row.dblclick(function() {
			if ($("#adm_form_campaign_page_messenger_popup_greeting_text").length) {
				return;
			}
			self.__editGreetingText(self.__getGreetingTextRowData($(this)));
		});
		$row.find("[greeting_text_action=duplicate]").click(function() {
			if ($("#adm_form_campaign_page_messenger_popup_greeting_text").length) {
				return;
			}
			self.__newGreetingText(self.__getGreetingTextRowData($(this).closest("[greeting_text_row]")));
		});
		$row.find("[greeting_text_action=delete]").click(function() {
			var data = self.__getGreetingTextRowData($(this).closest("[greeting_text_row]"));
			$.inconcertPopup.Show(
				"<%=_T('Confirmation')%>",
				format("<%=_T('Do you want to delete greeting text for language {0}?')%>", data.locale),
				$.inconcertPopup.ButtonSets.BS_YESNO,
				function(response) {
					if (response.toLowerCase() === "yes") {
						self.__removeGreetingTextRow(data);
					}
				},
				undefined,
				{
					popup_id        : "conf_inconcertPopup",
					container_class : "confirmationPopUp",
					overlay_class   : "confirmationOverlay"
				}
			);
		});
		return $row;
	};

	PageMessengerAdministration.prototype.__addGreetingTextRow = function(data) {
		var self = this;
		var $row = self.__makeGreetingTextRow(data);
		var $rows = self.$container.find("[greeting_text_row]");
		if (!$rows.length || data.locale === "default") {
			self.$container.find("[greeting_text_list]").append($row);
			return;
		}
		var added = false;
		$rows.each(function() {
			var locale = $(this).attr("locale");
			if (locale !== "default"&& locale > data.locale) {
				$(this).before($row);
				added = true;
				return false;
			}
		});
		if (!added) {
			self.$container.find("[greeting_text_list]").append($row);
		}
	};

	PageMessengerAdministration.prototype.__removeGreetingTextRow = function(data) {
		this.$container.find(format("[greeting_text_row][locale={0}]", data.locale)).remove();
	};

	PageMessengerAdministration.prototype.__getGreetingTextRowData = function($row) {
		return {
			locale : $row.attr("locale"),
			text : $row.attr("text")
		};
	};
	
	PageMessengerAdministration.prototype.__newGreetingText = function(data) {
		this.__showGreetingTextPopup(data || {}, true);
	};

	PageMessengerAdministration.prototype.__editGreetingText = function(data) {
		this.__showGreetingTextPopup(data, false);
	};

	PageMessengerAdministration.prototype.__showGreetingTextPopup = function(data, isNew) {
		var self = this;
		self.greetingTextIsNew = isNew;
		self.greetingTextOriginal = data;
		self.__makeGreetingTextPopup(data);
		self.$container.find("[greeting_text_form_container]")
			.append(self.$greetingTextContainer)
			.show();
		self.$container.find("[popup_form]").scrollTo(self.$container.find("[greeting_text_container]"));
		self.$container.find("[greeting_text_action]").prop("disabled", true);
		self.$container.find("[new_greeting_text]").prop("disabled", true);
		self.__afterAppendGreetingTextBody();
	};

	PageMessengerAdministration.prototype.__getGreetingTextPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_greeting_text";
	};

	PageMessengerAdministration.prototype.__makeGreetingTextPopup = function(data) {
		const self = this;
		this.$greetingTextContainer = $(Mustache.render(templates.greeting_text_form, {
			guid : inConcert.Utils.generateGuid(),
			text_disclaimer : "<%=_T('You can use {{user_first_name}}, {{user_last_name}} and {{user_full_name}} to include user name in text.')%>"
		}));
		let existentOptions = {};
		this.$container.find("[greeting_text_row]").each(function() {
			let locale = $(this).attr("locale");
			if (locale !== data.locale || self.greetingTextIsNew) {
				existentOptions[locale] = true;
			}
		});
		let localeOptions = existentOptions.default? "" : "<option value='default'>default</option>";
		$.each(inConcert.MessengerLanguages, function(_, locale) {
			if (existentOptions[locale]) {
				return;
			}
			localeOptions += format("<option value='{0}'>{0}</option>", locale);
		});
		this.$greetingTextContainer.find("[control=greeting_text_locale]").html(localeOptions).val(data.locale);
		this.$greetingTextContainer.find("[control=greeting_text_message]").val(data.text);
		this.$greetingTextContainer.find("[greeting_update_button]").click(function() {
			self.__saveGreetingText();
		});
		this.$greetingTextContainer.find("[greeting_cancel_button]").click(function() {
			self.__closeGreetingTextPopup();
		});
	};

	PageMessengerAdministration.prototype.__afterAppendGreetingTextBody = function() {
		this.emojiPicker = this.emojiPicker || new EmojiPicker({
			emojiable_selector: ".emojipickerTextarea",
			assetsPath: "/inconcert/lib/emoji-picker/lib/img/",
			popupButtonClasses: "pageButtonGeneric buttonColorWhite iconOnlyBtn emoji-picker-button flowDesignerControlEmojiPicker",
			norealTime: false,
			onPaste: function(pasted) {
				return pasted;
			}
		});
		this.emojiPicker.discover();
	};

	PageMessengerAdministration.prototype.__closeGreetingTextPopup = function() {
		this.__clearErrors();
		this.$greetingTextContainer.remove();
		this.$greetingTextContainer = null;
		this.$container.find("[greeting_text_form_container]").hide();
		this.$container.find("[greeting_text_action]").prop("disabled", false);
		this.$container.find("[new_greeting_text]").prop("disabled", false);
	};

	PageMessengerAdministration.prototype.__saveGreetingText = function() {
		this.__clearErrors();
		const $language = this.$greetingTextContainer.find("[control=greeting_text_locale]");
		let data = {
			locale: $language.val(),
			text  : this.$greetingTextContainer.find("[control=greeting_text_message]").val()
		};
		if (!data.locale) {
			return this.__showError({
				control : "greeting_text_locale",
				message : "<%=_T('You must select language.')%>"
			});
		}
		if (!data.text) {
			return this.__showError({
				control : "greeting_text_message",
				message : "<%=_T('Must enter a message.')%>"
			});
		}
		if (!this.greetingTextIsNew) {
			this.__removeGreetingTextRow(this.greetingTextOriginal);
		}
		this.__addGreetingTextRow(data);
		this.__closeGreetingTextPopup();
	};

	PageMessengerAdministration.prototype.__validateGreetingText = function(data, fbData) {
		var self = this;
		fbData.greeting = [];
		var hasDefault = false;
		self.$container.find("[greeting_text_row]").each(function() {
			var rowData = self.__getGreetingTextRowData($(this));
			fbData.greeting.push(rowData);
			hasDefault = hasDefault || rowData.locale === "default";
		});
		//has default option
		if (!data.error && fbData.greeting.length && !hasDefault) {
			data.error = {
				message : "<%=_T('Must define a greeting text for default locale.')%>",
				$control : self.$container.find("[greeting_text_row]").first()
			};
		}
	};

	PageMessengerAdministration.prototype.__restoreGreetingText = function() {
		this.$container.find("[greeting_text_row]").remove();
	};

//persistent menu
		PageMessengerAdministration.prototype.__makePersistentMenu = function() {
		var self = this;
		var $container = $(templates.persistent_menu);
		var $rows = [];
		var rows = self.fbData.persistent_menu || [];
		rows.sort(function(a, b) {
			return	a.locale === "default"? 1 :
					b.locale === "default"? -1:
					a.locale.localeCompare(b.locale);
		});
		$.each(rows, function(_, row) {
			$rows.push(self.__makePersistentMenuRow(row));
		});
		$container.find("[persistent_menu_list]").append($rows);
		$container.find("[new_persistent_menu]").click(function() {
			self.__newPersistentMenu();
		});
		return $container;
	};

	PageMessengerAdministration.prototype.__validatePersistentMenuRow = function(data) {
		var self = this;
		var error = "";
		$.each(data.call_to_actions || [], function(_, button) {
			if (button.type === "postback" && !self.__validateStatePayload(button.payload)) {
				error = "<%=_T('There are invalid button states.')%>";
				return false;
			}
			if (button.type === "nested") {
				error = error || self.__validatePersistentMenuRow(button);
			}
		});
		return error;
	};

	PageMessengerAdministration.prototype.__makePersistentMenuRow = function(data) {
		var self = this;
		var $row = $(Mustache.render(templates.persistent_menu_row, {
			locale : data.locale
		}));
		if (self.__validatePersistentMenuRow(data)) {
			$row.addClass("invalidRow");
		}
		$row.data("composer_input_disabled", !!data.composer_input_disabled);
		$row.data("call_to_actions", data.call_to_actions);
		$row.find("[persistent_menu_action=edit]").click(function() {
			if ($("#adm_form_campaign_page_messenger_popup_persistent_menu").length) {
				return;
			}
			self.__editPersistentMenu(self.__getPersistentMenuRowData($(this).closest("[persistent_menu_row]")));
		});
		$row.dblclick(function() {
			if ($("#adm_form_campaign_page_messenger_popup_persistent_menu").length) {
				return;
			}
			self.__editPersistentMenu(self.__getPersistentMenuRowData($(this)));
		});
		$row.find("[persistent_menu_action=duplicate]").click(function() {
			if ($("#adm_form_campaign_page_messenger_popup_persistent_menu").length) {
				return;
			}
			self.__newPersistentMenu(self.__getPersistentMenuRowData($(this).closest("[persistent_menu_row]")));
		});
		$row.find("[persistent_menu_action=delete]").click(function() {
			var data = self.__getPersistentMenuRowData($(this).closest("[persistent_menu_row]"));
			$.inconcertPopup.Show(
				"<%=_T('Confirmation')%>",
				format("<%=_T('Do you want to delete persistent menu for language {0}?')%>", data.locale),
				$.inconcertPopup.ButtonSets.BS_YESNO,
				function(response) {
					if (response.toLowerCase() === "yes") {
						self.__removePersistentMenuRow(data);
					}
				},
				undefined,
				{
					popup_id        : "conf_inconcertPopup",
					container_class : "confirmationPopUp",
					overlay_class   : "confirmationOverlay"
				}
			);
		});
		return $row;
	};

	PageMessengerAdministration.prototype.__addPersistentMenuRow = function(data) {
		var self = this;
		var $row = self.__makePersistentMenuRow(data);
		var $rows = self.$container.find("[persistent_menu_row]");
		if (!$rows.length || data.locale === "default") {
			self.$container.find("[persistent_menu_list]").append($row);
			return;
		}
		var added = false;
		$rows.each(function() {
			var locale = $(this).attr("locale");
			if (locale !== "default"&& locale > data.locale) {
				$(this).before($row);
				added = true;
				return false;
			}
		});
		if (!added) {
			self.$container.find("[persistent_menu_list]").append($row);
		}
	};

	PageMessengerAdministration.prototype.__removePersistentMenuRow = function(data) {
		this.$container.find(format("[persistent_menu_row][locale={0}]", data.locale)).remove();
	};

	PageMessengerAdministration.prototype.__getPersistentMenuRowData = function($row) {
		return {
			locale : $row.attr("locale"),
			composer_input_disabled : !!$row.data("composer_input_disabled"),
			call_to_actions : $row.data("call_to_actions")
		};
	};
	
	PageMessengerAdministration.prototype.__newPersistentMenu = function(data) {
		this.__showPersistentMenuPopup(data || {}, true);
	};

	PageMessengerAdministration.prototype.__editPersistentMenu = function(data) {
		this.__showPersistentMenuPopup(data, false);
	};

	PageMessengerAdministration.prototype.__showPersistentMenuPopup = function(data, isNew) {
		var self = this;
		self.persistentMenuIsNew = isNew;
		self.persistentMenuOriginal = data;
		self.__makePersistentMenuPopup(data);
		$("body").append(self.$persistentMenuContainer);
		self.persistentMenuPopup = new inConcert.PopupWindow();
		self.persistentMenuPopup.show({
			ownerId         : self.__getPersistentMenuPopupId(),
			eventName       : self.__getPersistentMenuPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$persistentMenuContainer,
			callbacks: {
				onOpen: function() {
					self.__showPopup();
					self.$persistentMenuContainer.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.persistentMenuPopup) {
						self.persistentMenuPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
		self.__afterAppendPersistentMenuBody();
	};

	PageMessengerAdministration.prototype.__getPersistentMenuPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_persistent_menu";
	};

	PageMessengerAdministration.prototype.__makePersistentMenuPopup = function(data) {
		const self = this;
		this.$persistentMenuContainer = $(Mustache.render(templates.persistent_menu_form, {
			main_title : self.pageName,
			guid : inConcert.Utils.generateGuid()
		}));
		let existentOptions = {};
		this.$container.find("[persistent_menu_row]").each(function() {
			let locale = $(this).attr("locale");
			if (locale !== data.locale || self.persistentMenuIsNew) {
				existentOptions[locale] = true;
			}
		});
		let localeOptions = existentOptions.default? "" : "<option value='default'>default</option>";
		$.each(inConcert.MessengerLanguages, function(_, locale) {
			if (existentOptions[locale]) {
				return;
			}
			localeOptions += format("<option value='{0}'>{0}</option>", locale);
		});
		this.$persistentMenuContainer.find("[control=persistent_menu_locale]").html(localeOptions).val(data.locale);
		this.$persistentMenuContainer.find("[control=persistent_menu_input_disabled]").prop("checked", !!data.composer_input_disabled);
		this.$persistentMenuContainer.find("[buttons_container]").append(this.__makePersistentMenuButtonsList(data, true));
		this.$persistentMenuContainer.find("[persistent_menu_update_button]").click(function() {
			self.__savePersistentMenu();
		});
		this.$persistentMenuContainer.find("[persistent_menu_cancel_button]").click(function() {
			self.__closePersistentMenuPopup();
		});
	};

	PageMessengerAdministration.prototype.__makePersistentMenuButtonsList = function(data, isRoot) {
		var self = this;
		data = data || {};

		var $button = $(isRoot? templates.persistent_menu_button_add_root : templates.persistent_menu_button_add);
		$button.click(function() {
			self.__newPersistentMenuButton($(this).siblings("[button_list_container]").children("[button_list]"));
		});
		
		var $container = $(templates.persistent_menu_button_list);
		var $list = [];
		var list = data.call_to_actions || [];
		$.each(list, function(_, button) {
			$list.push(self.__makePersistentMenuButton(button));
		});
		$container.find("[button_list]")
			.sortable({
				cursor: "move", connectWith: ".persistentMenuButtonList"
			})
			.append($list);
	
		return [$button, $container];
	};

	PageMessengerAdministration.prototype.__getPersistentMenuButtonTitle = function(data) {
		switch(data.type) {
			default:
				return data.title;
		}
	};

	PageMessengerAdministration.prototype.__getPersistentMenuButtonSubtitle = function(data) {
		switch(data.type) {
			case "web_url":
				return data.url;
			case "phone_number":
				return data.payload;
			case "postback":
				return this.__getStateNameFromPayload(data.payload);
			default:
				return "";
		}
	};

	PageMessengerAdministration.prototype.__makePersistentMenuButton = function(data) {
		var self = this;
		var className = data.type + "Button";
		if (data.type === "postback" && !this.__validateStatePayload(data.payload)) {
			className += " invalidButton";
		}
		var $container = $(Mustache.render(templates.persistent_menu_button, {
			className : className,
			title : self.__getPersistentMenuButtonTitle(data),
			subtitle : self.__getPersistentMenuButtonSubtitle(data)
		}));
		$container.data("data", data);
		$container.find("[edit_button]").click(function() {
			if ($("#adm_form_campaign_page_messenger_popup_persistent_menu_button").length) {
				return;
			}
			const $button = $(this).closest("[menu_button]");
			self.__editPersistentMenuButton($button.parent(), $button, $button.data("data"));
		});
		$container.dblclick(function() {
			if ($("#adm_form_campaign_page_messenger_popup_persistent_menu_button").length) {
				return;
			}
			const $button = $(this);
			self.__editPersistentMenuButton($button.parent(), $button, $button.data("data"));
		});
		$container.find("[delete_button]").click(function() {
			var $button = $(this).closest("[menu_button]");
			$.inconcertPopup.Show(
				"<%=_T('Confirmation')%>",
				"<%=_T('Do you want to delete button?')%>",
				$.inconcertPopup.ButtonSets.BS_YESNO,
				function(response) {
					if (response.toLowerCase() === "yes") {
						$button.remove();
					}
				},
				undefined,
				{
					popup_id        : "conf_inconcertPopup",
					container_class : "confirmationPopUp",
					overlay_class   : "confirmationOverlay"
				}
			);
		});
		if (data.type === "nested") {
			$container.append(self.__makePersistentMenuButtonsList(data));
		}
		return $container;
	};

	PageMessengerAdministration.prototype.__addPersistentMenuButton = function($list, data) {
		$list.append(this.__makePersistentMenuButton(data));
	};

	PageMessengerAdministration.prototype.__updatePersistentMenuButton = function($button, data) {
		// el titulo
		let title = this.__getPersistentMenuButtonTitle(data);
		const $title = $button.find("[button_title]:first");
		$title.text(title);
		// el subtitulo
		let subTitle = this.__getPersistentMenuButtonSubtitle(data);
		const $subTitle = $button.find("[button_subtitle]:first");
		$subTitle.text(subTitle);
		// otros
		$button.attr("class", "formListItem persistentMenuButton " + data.type + "Button");
		$button.data("data", data);
		if (data.type === "nested") {
			if (!$button.find("[button_list_container]").length) {
				const $arrMenuButtonAndContainer = this.__makePersistentMenuButtonsList();
				$button.append($arrMenuButtonAndContainer);
			}
		}
		else {
			$button.find("[button_list_container]").remove();
			$button.find("[add_button]").remove();
		}
	};

	PageMessengerAdministration.prototype.__afterAppendPersistentMenuBody = $.noop;

	PageMessengerAdministration.prototype.__closePersistentMenuPopup = function() {
		var self = this;
		self.__closePopup();
		if (self.persistentMenuPopup && self.persistentMenuPopup.isVisible()) {
			self.persistentMenuPopup.finalize(function() {
				self.persistentMenuPopup = null;
				self.$persistentMenuContainer.remove();
			});
		}
		else {
			self.$persistentMenuContainer.remove();
		}
	};

	PageMessengerAdministration.prototype.__addPersistentMenuManyButtonsData = function(data, $list, isRoot) {
		const self = this;
		if (isRoot && !data.locale) {
			const $ctrl = this.$persistentMenuContainer.find("[control=persistent_menu_locale]");
			return {
				message : "<%=_T('You must select language.')%>",
				$control: $ctrl
			};
		}
		const $buttons = $list.children();
		if (!$buttons.length) {
			return {
				message : "<%=_T('Must enter almost one button per list.')%>",
				$control: $list.closest("[menu_button]")
			};
		}
		data.call_to_actions = [];
		let error = null;
		$buttons.each(function() {
			const $button = $(this);
			let buttonData = self.__addPersistentMenuOneButtonData($button);
			if (buttonData.error) {
				error = buttonData.error;
				return false;
			}
			data.call_to_actions.push(buttonData);
		});
		return error;
	};

	PageMessengerAdministration.prototype.__addPersistentMenuOneButtonData = function($button) {
		let data = $button.data("data");
		if (data.type === "nested") {
			const isRoot = false;
			data.error = this.__addPersistentMenuManyButtonsData(data, $button.find("[button_list]:first"), isRoot) || undefined;
		}
		else {
			data.call_to_actions = undefined;
			if (data.type === "postback") {
				data.payload = this.__validateStatePayload(data.payload);
				if (!data.payload) {
					data.error = {
						$control : $button,
						message : "<%=_T('Invalid button state.')%>"
					};
				}
			}
		}
		return data;
	};

	PageMessengerAdministration.prototype.__savePersistentMenu = function() {
		this.__clearErrors(this.$persistentMenuContainer);
		let data = {
			locale : this.$persistentMenuContainer.find("[control=persistent_menu_locale]").val(),
			composer_input_disabled : this.$persistentMenuContainer.find("[control=persistent_menu_input_disabled]").is(":checked")
		};
		const isRoot = true;
		let error = this.__addPersistentMenuManyButtonsData(data, this.$persistentMenuContainer.find("[button_list]:first"), isRoot);
		if (error) {
			this.__showError(error, this.$persistentMenuContainer);
			return;
		}
		if (!this.persistentMenuIsNew) {
			this.__removePersistentMenuRow(this.persistentMenuOriginal);
		}
		this.__addPersistentMenuRow(data);
		this.__closePersistentMenuPopup();
	};

	PageMessengerAdministration.prototype.__validatePersistentMenu = function(data, fbData) {
		var self = this;
		fbData.persistent_menu = [];
		var hasDefault = false;
		self.$container.find("[persistent_menu_row]").each(function() {
			var rowData = self.__getPersistentMenuRowData($(this));
			var error = self.__validatePersistentMenuRow(rowData);
			if (error) {
				data.error = {
					message : error,
					$control : $(this)
				};
				return false;
			}
			fbData.persistent_menu.push(rowData);
			hasDefault = hasDefault || rowData.locale === "default";
		});
		//has default option
		if (!data.error && fbData.persistent_menu.length && !hasDefault) {
			data.error = {
				message : "<%=_T('Must define a persistent menu for default locale.')%>",
				$control : self.$container.find("[persistent_menu_row]").first()
			};
		}
		//has start button
		if (!data.error && fbData.persistent_menu.length && !fbData.get_started) {
			data.error = {
				message : "<%=_T('Start button is required to use a persistent menu.')%>",
				control : "start_button_enabled"
			};
		}
	};

	PageMessengerAdministration.prototype.__restorePersistentMenu = function() {
		this.$container.find("[persistent_menu_row]").remove();
	};

	//button
	PageMessengerAdministration.prototype.__newPersistentMenuButton = function($parent, data) {
		this.__clearErrors();
		var level = $parent.parents("[menu_button]").length;
		if (level >= 5) {
			this.__showError("<%=_T('Peristent menu has a limit of 5 levels.')%>", this.$persistentMenuContainer);
			return;
		}
		this.__showPersistentMenuButtonPopup($parent, null, data || {});
	};

	PageMessengerAdministration.prototype.__editPersistentMenuButton = function($parent, $row, data) {
		this.__showPersistentMenuButtonPopup($parent, $row, data);
	};

	PageMessengerAdministration.prototype.__showPersistentMenuButtonPopup = function($parent, $row, data) {
		const self = this;
		this.__clearErrors(this.$persistentMenuContainer);
		this.__makePersistentMenuButtonPopup(data);
		$("body").append(this.$persistentMenuButtonContainer);
		this.$persistentMenuButtonParent = $parent;
		this.$persistentMenuButtonRow = $row;
		this.persistentMenuButtonOriginal = data;
		this.persistentMenuButtonPopup = new inConcert.PopupWindow();
		this.persistentMenuButtonPopup.show({
			ownerId         : this.__getPersistentMenuButtonPopupId(),
			eventName       : this.__getPersistentMenuButtonPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : this.$persistentMenuButtonContainer,
			callbacks: {
				onOpen: function() {
					self.__showPopup(self.__getPersistentMenuPopupId());
					self.$persistentMenuButtonContainer.show();
				},
				onClose: function(callback = $.noop) {
					if (self.persistentMenuButtonPopup) {
						self.persistentMenuButtonPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
		this.__afterAppendPersistentMenuButtonBody();
	};

	PageMessengerAdministration.prototype.__getPersistentMenuButtonPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_persistent_menu_button";
	};

	var persistent_menu_button_types = [
		{
			id : "web_url",
			name : "<%=_T('Open popup from url')%>",
			description : "<%=_T('Open a popup from url.')%>"
		},
		/*{
			id : "phone_number",
			name : "<%=_T('phone number')%>",
			description : "<%=_T('Makes a phone call.')%>"
		},*/
		{
			id : "postback",
			name : "<%=_T('Execute a process flow state')%>",
			description : "<%=_T('Executes a process flow state.')%>"
		},
		{
			id : "nested",
			name : "<%=_T('Open a submenu (max. 5 levels)')%>",
			description : "<%=_T('Opens a submenu (max 5 levels).')%>"
		}
	];

	PageMessengerAdministration.prototype.__makePersistentMenuButtonPopup = function(data) {
		const self = this;
		this.$persistentMenuButtonContainer = $(Mustache.render(templates.persistent_menu_button_form, {
			main_title : self.pageName,
			guid : inConcert.Utils.generateGuid()
		}));
		this.options_d = {};
		let options = "";
		$.each(persistent_menu_button_types, function(_, option) {
			self.options_d[option.id] = option;
			options += format("<option value='{0}'>{1}</option>", option.id, option.name);
		});
		this.$persistentMenuButtonContainer.find("[control=button_type]")
			.html(options)
			.val(data.type)
			.change(function() {
				self.__selectPersistentMenuButtonType($(this).val());
			});
		this.__selectPersistentMenuButtonType(data.type || persistent_menu_button_types[0].id, data);
		this.$persistentMenuButtonContainer.find("[persistent_menu_button_update_button]").click(function() {
			self.__savePersistentMenuButton();
		});
		this.$persistentMenuButtonContainer.find("[persistent_menu_button_cancel_button]").click(function() {
			self.__closePersistentMenuButtonPopup();
		});
	};

	PageMessengerAdministration.prototype.__selectPersistentMenuButtonType = function(type, data) {
		var self = this;
		data = data  || {};
		if (this.$persistentMenuButtonTypeControls) {
			data.title = this.$persistentMenuButtonTypeControls.find("[control=button_title]").val() || data.title;
			this.$persistentMenuButtonTypeControls.remove();
		}
		if (data.type !== type) {
			data = {
				title : data.title
			};
		}
		switch(type) {
			case "web_url":
				this.$persistentMenuButtonTypeControls = $(Mustache.render(templates.persistent_menu_button_web_url, {
					guid : inConcert.Utils.generateGuid()
				}));
				this.$persistentMenuButtonTypeControls.find("[control=button_title]").val(data.title);
				this.$persistentMenuButtonTypeControls.find("[control=button_url]").val(data.url);
				this.$persistentMenuButtonTypeControls.find("[control=button_messenger_extensions]")
					.prop("checked", !!data.messenger_extensions)
					.change(function() {
						self.$persistentMenuButtonTypeControls.filter("[webview_control]").toggle($(this).is(":checked"));
					})
					.change();
				if (data.messenger_extensions) {
					this.$persistentMenuButtonTypeControls.find("[control=button_webview_height_ratio]").val(data.webview_height_ratio);
					this.$persistentMenuButtonTypeControls.find("[control=button_webview_share_button]").prop("checked", data.webview_share_button === "SHOW");
				}
				break;
			case "phone_number":
				this.$persistentMenuButtonTypeControls = $(Mustache.render(templates.persistent_menu_button_phone_number, {
					guid : inConcert.Utils.generateGuid()
				}));
				this.$persistentMenuButtonTypeControls.find("[control=button_title]").val(data.title);
				this.$persistentMenuButtonTypeControls.find("[control=button_number]").val(data.payload);
				break;
			case "postback":
				this.$persistentMenuButtonTypeControls = $(Mustache.render(templates.persistent_menu_button_postback, {
					guid : inConcert.Utils.generateGuid()
				}));
				this.$persistentMenuButtonTypeControls.find("[control=button_title]").val(data.title);
				this.$persistentMenuButtonTypeControls.find("[control=button_state]")
					.html(this.states_o)
					.val(this.__getStateFromPayload(data.payload));
				this.$persistentMenuButtonTypeControls.find("[control=button_message]").val(this.__getMessageFromPayload(data.payload));
				break;
			case "nested":
				this.$persistentMenuButtonTypeControls = $(Mustache.render(templates.persistent_menu_button_nested, {
					guid : inConcert.Utils.generateGuid()
				}));
				this.$persistentMenuButtonTypeControls.find("[control=button_title]").val(data.title);
				break;
		}
		this.$persistentMenuButtonContainer.find("[persistent_menu_button_popup_form] .card .card-block").append(this.$persistentMenuButtonTypeControls);
		this.$persistentMenuButtonContainer.find("[button_type_disclaimer]").text(this.options_d[type].description);
	};

	PageMessengerAdministration.prototype.__afterAppendPersistentMenuButtonBody = $.noop;

	PageMessengerAdministration.prototype.__closePersistentMenuButtonPopup = function() {
		var self = this;
		self.__closePopup(self.__getPersistentMenuPopupId());
		self.$persistentMenuButtonTypeControls = null;
		if (self.persistentMenuButtonPopup && self.persistentMenuButtonPopup.isVisible()) {
			self.persistentMenuButtonPopup.finalize(function() {
				self.persistentMenuButtonPopup = null;
				self.$persistentMenuButtonContainer.remove();
			});
		}
		else {
			self.$persistentMenuButtonContainer.remove();
		}
	};

	PageMessengerAdministration.prototype.__savePersistentMenuButton = function() {
		this.__clearErrors(this.$persistentMenuButtonContainer);
		let data = {
			type: this.$persistentMenuButtonContainer.find("[control=button_type]").val()
		};
		let error = this.__addPersistentMenuButtonTypeData(data);
		if (error) {
			this.__showError(error, this.$persistentMenuButtonContainer);
			return;
		}
		if (this.$persistentMenuButtonRow) {
			this.__updatePersistentMenuButton(this.$persistentMenuButtonRow, data);
		}
		else {
			this.__addPersistentMenuButton(this.$persistentMenuButtonParent, data);
		}
		this.__closePersistentMenuButtonPopup();
	};

	PageMessengerAdministration.prototype.__addPersistentMenuButtonTypeData = function(data) {
		switch (data.type) {
			case "web_url":
				data.title = this.$persistentMenuButtonTypeControls.find("[control=button_title]").val();
				if (!data.title) {
					return {
						control : "button_title",
						message : "<%=_T('Must enter a title.')%>"
					};
				}
				data.url = this.$persistentMenuButtonTypeControls.find("[control=button_url]").val();
				if (!data.url) {
					return {
						control : "button_url",
						message : "<%=_T('Must enter an url.')%>"
					};
				}
				data.messenger_extensions = this.$persistentMenuButtonTypeControls.find("[control=button_messenger_extensions]").is(":checked");
				if (data.messenger_extensions) {
					data.webview_height_ratio = this.$persistentMenuButtonTypeControls.find("[control=button_webview_height_ratio]").val();
					data.webview_share_button = this.$persistentMenuButtonTypeControls.find("[control=button_webview_share_button]").is(":checked") ? "SHOW" : "HIDE";
				}
				break;
			case "phone_number":
				data.title = this.$persistentMenuButtonTypeControls.find("[control=button_title]").val();
				if (!data.title) {
					return {
						control : "button_title",
						message : "<%=_T('Must enter a title.')%>"
					};
				}
				data.payload = this.$persistentMenuButtonTypeControls.find("[control=button_number]").val();
				if (!data.payload) {
					return {
						control : "button_number",
						message : "<%=_T('Must enter a phone number.')%>"
					};
				}
				if (data.payload[0] !== "+") {
					return {
						control : "button_number",
						message : "<%=_T('Phone number must starts with +.')%>"
					};
				}
				break;
			case "postback":
				data.title = this.$persistentMenuButtonTypeControls.find("[control=button_title]").val();
				if (!data.title) {
					return {
						control : "button_title",
						message : "<%=_T('Must enter a title.')%>"
					};
				}
				data.payload = this.__getPayloadFromState(
					this.$persistentMenuButtonTypeControls.find("[control=button_state]").val(),
					this.$persistentMenuButtonTypeControls.find("[control=button_message]").val());
				if (!data.payload) {
					return {
						control : "button_state",
						message : "<%=_T('Must select a state.')%>"
					};
				}
				break;
			case "nested":
				data.title = this.$persistentMenuButtonTypeControls.find("[control=button_title]").val();
				if (!data.title) {
					return {
						control : "button_title",
						message : "<%=_T('Must enter a title.')%>"
					};
				}
				break;
			default:
				return {
					control : "button_type",
					message : "<%=_T('Type button is required.')%>"
				};
		}
	};

//whitelisted domains
	PageMessengerAdministration.prototype.__makeWhitelistedDomains = function() {
		var self = this;
		var $container = $(templates.whitelisted_domains);
		var $rows = [];
		var rows = self.fbData.whitelisted_domains || [];
		rows.sort();
		$.each(rows, function(_, domain) {
			$rows.push(self.__makeWhitelistedDomainRow({ domain : domain }));
		});
		$container.find("[whitelisted_domains_list]").append($rows);
		$container.find("[new_whitelisted_domain]").click(function() {
			self.__newWhitelistedDomain();
		});
		return $container;
	};

	PageMessengerAdministration.prototype.__makeWhitelistedDomainRow = function(data) {
		var self = this;
		var $row = $(Mustache.render(templates.whitelisted_domains_row, {
			domain : data.domain
		}));
		$row.find("[whitelisted_domain_action=edit]").click(function() {
			if ($("#adm_form_campaign_page_messenger_popup_whitelisted_domain").length) {
				return;
			}
			self.__editWhitelistedDomain(self.__getWhitelistedDomainRowData($(this).closest("[whitelisted_domain_row]")));
		});
		$row.dblclick(function() {
			if ($("#adm_form_campaign_page_messenger_popup_whitelisted_domain").length) {
				return;
			}
			self.__editWhitelistedDomain(self.__getWhitelistedDomainRowData($(this)));
		});
		$row.find("[whitelisted_domain_action=delete]").click(function() {
			var data = self.__getWhitelistedDomainRowData($(this).closest("[whitelisted_domain_row]"));
			$.inconcertPopup.Show(
				"<%=_T('Confirmation')%>",
				format("<%=_T('Do you want to delete domain {0}?')%>", data.domain),
				$.inconcertPopup.ButtonSets.BS_YESNO,
				function(response) {
					if (response.toLowerCase() === "yes") {
						self.__removeWhitelistedDomainRow(data);
					}
				},
				undefined,
				{
					popup_id        : "conf_inconcertPopup",
					container_class : "confirmationPopUp",
					overlay_class   : "confirmationOverlay"
				}
			);
		});
		return $row;
	};

	PageMessengerAdministration.prototype.__addWhitelistedDomainRow = function(data) {
		var self = this;
		var $row = self.__makeWhitelistedDomainRow(data);
		var $rows = self.$container.find("[whitelisted_domain_row]");
		if (!$rows.length) {
			self.$container.find("[whitelisted_domains_list]").append($row);
			return;
		}
		var added = false;
		$rows.each(function() {
			var domain = $(this).attr("domain");
			if (domain > data.domain) {
				$(this).before($row);
				added = true;
				return false;
			}
		});
		if (!added) {
			self.$container.find("[whitelisted_domains_list]").append($row);
		}
	};

	PageMessengerAdministration.prototype.__removeWhitelistedDomainRow = function(data) {
		this.$container.find(format("[whitelisted_domain_row][domain='{0}']", data.domain)).remove();
	};

	PageMessengerAdministration.prototype.__getWhitelistedDomainRowData = function($row) {
		return {
			domain : $row.attr("domain")
		};
	};

	PageMessengerAdministration.prototype.__newWhitelistedDomain = function(data) {
		this.__showWhitelistedDomainPopup(data || {}, true);
	};

	PageMessengerAdministration.prototype.__editWhitelistedDomain = function(data) {
		this.__showWhitelistedDomainPopup(data, false);
	};

	PageMessengerAdministration.prototype.__showWhitelistedDomainPopup = function(data, isNew) {
		var self = this;
		self.whitelistedDomainIsNew = isNew;
		self.whitelistedDomainOriginal = data;
		self.__makeWhitelistedDomainPopup(data);
		self.$container.find("[whitelisted_domains_form_container]")
			.append(self.$whitelistedDomainContainer)
			.show();
		self.$container.find("[popup_form]").scrollTo(self.$container.find("[whitelisted_domains_container]"));
		self.$container.find("[whitelisted_domain_action]").prop("disabled", true);
		self.$container.find("[new_whitelisted_domain]").prop("disabled", true);
	};

	PageMessengerAdministration.prototype.__getWhitelistedDomainPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_whitelisted_domain";
	};

	PageMessengerAdministration.prototype.__makeWhitelistedDomainPopup = function(data) {
		var self = this;
		self.$whitelistedDomainContainer = $(Mustache.render(templates.whitelisted_domains_form, {
			guid : inConcert.Utils.generateGuid(),
			text_disclaimer : "<%=_T('You can use {{user_first_name}}, {{user_last_name}} and {{user_full_name}} to include user name in text.')%>"
		}));
		self.$whitelistedDomainContainer.find("[control=whitelisted_domain]").val(data.domain);
		
		self.$whitelistedDomainContainer.find("[whitelisted_domain_update_button]").click(function() {
			self.__saveWhitelistedDomain();
		});
		self.$whitelistedDomainContainer.find("[whitelisted_domain_cancel_button]").click(function() {
			self.__closeWhitelistedDomainPopup();
		});
	};

	PageMessengerAdministration.prototype.__closeWhitelistedDomainPopup = function() {
		var self = this;
		self.__clearErrors();
		self.$whitelistedDomainContainer.remove();
		self.$whitelistedDomainContainer = null;
		self.$container.find("[whitelisted_domains_form_container]").hide();
		self.$container.find("[whitelisted_domain_action]").prop("disabled", false);
		self.$container.find("[new_whitelisted_domain]").prop("disabled", false);
	};

	PageMessengerAdministration.prototype.__saveWhitelistedDomain = function() {
		this.__clearErrors();
		var data = {
			domain : this.$whitelistedDomainContainer.find("[control=whitelisted_domain]").val()
		};
		if (!data.domain) {
			return this.__showError({
				control : "whitelisted_domain",
				message : "<%=_T('Must enter a domain.')%>"
			});
		}
		var found = false;
		this.$container.find("[whitelisted_domain_row]").each(function() {
			if ($(this).attr("domain") === data.domain) {
				found = true;
				return false;
			}
		});
		if (found) {
			return this.__showError({
				control : "whitelisted_domain",
				message : "<%=_T('Domain already exists.')%>"
			});
		}
		if (!this.whitelistedDomainIsNew) {
			this.__removeWhitelistedDomainRow(this.whitelistedDomainOriginal);
		}
		this.__addWhitelistedDomainRow(data);
		this.__closeWhitelistedDomainPopup();
	};

	PageMessengerAdministration.prototype.__validateWhitelistedDomains = function(_, fbData) {
		const self = this;
		fbData.whitelisted_domains = [];
		this.$container.find("[whitelisted_domain_row]").each(function() {
			let domainData = self.__getWhitelistedDomainRowData($(this));
			fbData.whitelisted_domains.push(domainData.domain);
		});
	};

	PageMessengerAdministration.prototype.__restoreWhitelistedDomains = function() {
		this.$container.find("[whitelisted_domain_row]").remove();
	};

	PageMessengerAdministration.prototype.__makeEntryPoints = function() {
		this.$entryPointsContainer = $(templates.entry_points);
		this.__makeMMLink();
		this.__makeMessengerCode();
		this.__makeMessageUs();
		this.__makeSendToMessenger();
		return this.$entryPointsContainer;
	};

	PageMessengerAdministration.prototype.__openMMLinkPopup = function() {
		var self = this;
		self.__makeMMLinkPopup();
		$("body").append(self.$mMLinkPopup);
		self.mMLinkPopup = new inConcert.PopupWindow();
		self.mMLinkPopup.show({
			ownerId         : self.__getMMLinkPopupId(),
			eventName       : self.__getMMLinkPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$mMLinkPopup,
			callbacks: {
				onOpen: function() {
					self.__showPopup();
					self.$mMLinkPopup.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.mMLinkPopup) {
						self.mMLinkPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
	};

	PageMessengerAdministration.prototype.__getMMLinkPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_m_me_link";
	};

	PageMessengerAdministration.prototype.__makeMMLinkPopup = function() {
		var self = this;
		self.$mMLinkPopup = $(Mustache.render(templates.m_me_link_form, {
			main_title : self.pageName,
			guid : inConcert.Utils.generateGuid()
		}));
		var postback = self.$entryPointsContainer.find("[control=mme_postback]").val();
		var url = "http://m.me/" + self.pageId;
		if (postback) {
			url += "?ref=" + postback;
		}
		self.$mMLinkPopup.find("[control=m_me_link_url]")
			.click(function() {
				this.setSelectionRange(0, this.value.length);
			})
			.val(url);
		new Clipboard("[copy_control=m_me_link_url]");
		self.$mMLinkPopup.find("[m_me_link_close_button]").click(function() {
			self.__closePopup();
			if (self.mMLinkPopup && self.mMLinkPopup.isVisible()) {
				self.mMLinkPopup.finalize(function() {
					self.mMLinkPopup = null;
					self.$mMLinkPopup.remove();
				});
			}
			else {
				self.$mMLinkPopup.remove();
			}
		});
	};

	PageMessengerAdministration.prototype.__makeMMLink = function() {
		var self = this;
		self.$entryPointsContainer.find("[mme_open_popup]").click(function() {
			self.__openMMLinkPopup();
		});
	};

	PageMessengerAdministration.prototype.__openMessengerCodePopup = function() {
		var self = this;
		self.__makeMessengerCodePopup();
		$("body").append(self.$messengerCodePopup);
		self.messengerCodePopup = new inConcert.PopupWindow();
		self.messengerCodePopup.show({
			ownerId         : self.__getMessengerCodePopupId(),
			eventName       : self.__getMessengerCodePopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$messengerCodePopup,
			callbacks: {
				onOpen: function() {
					self.__showPopup();
					self.$messengerCodePopup.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.messengerCodePopup) {
						self.messengerCodePopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
	};

	PageMessengerAdministration.prototype.__getMessengerCodePopupId = function() {
		return "adm_form_campaign_page_messenger_popup_code";
	};

	PageMessengerAdministration.prototype.__makeMessengerCodePopup = function() {
		var self = this;
		self.$messengerCodePopup = $(Mustache.render(templates.code_form, {
			main_title : self.pageName,
			guid : inConcert.Utils.generateGuid(),
			image_url : self.messengerCodeUrl
		}));
		
		self.$messengerCodePopup.find("[download_code_image]").click(function() {
			var a = $("<a>").attr("href", self.messengerCodeUrl).attr("download", "messenger_code.png").appendTo("body");
			a[0].click();
			a.remove();
		});
		
		self.$messengerCodePopup.find("[code_close_button]").click(function() {
			self.__closePopup();
			if (self.messengerCodePopup && self.messengerCodePopup.isVisible()) {
				self.messengerCodePopup.finalize(function() {
					self.messengerCodePopup = null;
					self.$messengerCodePopup.remove();
				});
			}
			else {
				self.$messengerCodePopup.remove();
			}
		});
	};

	PageMessengerAdministration.prototype.__makeMessengerCode = function() {
		var self = this;
		// var $handle = self.$entryPointsContainer.find("[control=code_size_handle]");
		var $slider_value = self.$entryPointsContainer.find(".ui-slider-pixels-value");
		self.$entryPointsContainer.find("[control=code_size]").slider({
			range: "min",
			min: 100,
			max: 2000,
			value: 1000,
			step: 100,
			create: function() {
				// $handle.text($(this).slider("value") + "px");
				$slider_value.text($(this).slider("value") + "px");
			},
			slide: function(_, ui) {
				// $handle.text("");
				$slider_value.text(ui.value + "px");
			}
		});
		self.$entryPointsContainer.find("[code_button]").click(function() {
			var size = self.$entryPointsContainer.find("[control=code_size]").slider("value");
			var postback = self.$entryPointsContainer.find("[control=code_postback]").val();
			if (self.IsProcessing()) {
				return;
			}
			self.__clearErrors();
			self.__processing(true, "<%=_T('Getting messenger code')%>...");
			self.parent.get_messenger_qr(self.accessToken, size, postback, function(url, error) {
				self.__processing(false);
				if (url) {
					self.messengerCodeUrl = url;
					self.__openMessengerCodePopup();
				}
				else {
					self.__showError(format("<%=_T('Error getting code: {0}.')%>", error || ""));
				}
			});
		});
	};

	PageMessengerAdministration.prototype.__openMessageUsPopup = function() {
		var self = this;
		self.__makeMessageUsPopup();
		$("body").append(self.$messageUsPopup);
		self.messageUsPopup = new inConcert.PopupWindow();
		self.messageUsPopup.show({
			ownerId         : self.__getMessageUsPopupId(),
			eventName       : self.__getMessageUsPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$messageUsPopup,
			callbacks: {
				onOpen: function() {
					self.__showPopup();
					self.$messageUsPopup.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.messageUsPopup) {
						self.messageUsPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
	};

	PageMessengerAdministration.prototype.__getMessageUsPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_message_us";
	};

	PageMessengerAdministration.prototype.__makeMessageUsPopup = function() {
		var self = this;
		self.$messageUsPopup = $(Mustache.render(templates.message_us_form, {
			main_title : self.pageName,
			guid : inConcert.Utils.generateGuid()
		}));
		var color = self.$entryPointsContainer.find("[control=messageus_color]").val();
		var size = self.$entryPointsContainer.find("[control=messageus_size]").val();
		//js code
		var jsCode = Mustache.render(templates.messageus_js, {
			app_id : window.fbAppId
		});
		self.$messageUsPopup.find("[control=messageus_javascript]")
			.click(function() {
				this.setSelectionRange(0, this.value.length);
			})
			.text(jsCode);
		new Clipboard("[copy_control=messageus_javascript]");
		//html code
		var htmlCode = Mustache.render(templates.messageus_html, {
			app_id : window.fbAppId,
			page : self.pageId,
			color : color,
			size : size
		});
		self.$messageUsPopup.find("[control=messageus_html]")
			.click(function() {
				this.setSelectionRange(0, this.value.length);
			})
			.text(htmlCode);
		new Clipboard("[copy_control=messageus_html]");
		self.$messageUsPopup.find("[message_us_close_button]").click(function() {
			self.__closePopup();
			if (self.messageUsPopup && self.messageUsPopup.isVisible()) {
				self.messageUsPopup.finalize(function() {
					self.messageUsPopup = null;
					self.$messageUsPopup.remove();
				});
			}
			else {
				self.$messageUsPopup.remove();
			}
		});
	};

	PageMessengerAdministration.prototype.__messageUsChange = _.throttle(function() {
		var color = this.$entryPointsContainer.find("[control=messageus_color]").val();
		var size = this.$entryPointsContainer.find("[control=messageus_size]").val();
		var iframe = document.createElement("iframe");
		var exampleUrl = format("/inconcert/apps/administration/campaigns/messenger_examples/{0}/{1}",
			"message_us", encodeURIComponent(JSON.stringify({
			app_id : window.fbAppId,
			page : this.pageId,
			color : color,
			size : size
		})));
		iframe.src = exampleUrl;
		this.$entryPointsContainer.find("[control=messageus_example]")
			.html("")
			.attr("class", "pageMessengerEntryPointsExample " + size + "MessageUsSize")
			.append(iframe);
	}, 100);

	PageMessengerAdministration.prototype.__makeMessageUs = function() {
		var self = this;
		self.$entryPointsContainer.find("[control=messageus_color]").change(function() {
			self.__messageUsChange();
		});
		self.$entryPointsContainer.find("[control=messageus_size]").change(function() {
			self.__messageUsChange();
		});
		self.$entryPointsContainer.find("[message_us_open_popup]").click(function() {
			self.__openMessageUsPopup();
		});
		self.__messageUsChange();
	};

	PageMessengerAdministration.prototype.__openSendToMessengerPopup = function() {
		var self = this;
		self.__makeSendToMessengerPopup();
		$("body").append(self.$sendToMessengerPopup);
		self.sendToMessengerPopup = new inConcert.PopupWindow();
		self.sendToMessengerPopup.show({
			ownerId         : self.__getSendToMessengerPopupId(),
			eventName       : self.__getSendToMessengerPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$sendToMessengerPopup,
			callbacks: {
				onOpen: function() {
					self.__showPopup();
					self.$sendToMessengerPopup.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.sendToMessengerPopup) {
						self.sendToMessengerPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
	};

	PageMessengerAdministration.prototype.__getSendToMessengerPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_sendtomessenger";
	};

	PageMessengerAdministration.prototype.__makeSendToMessengerPopup = function() {
		var self = this;
		self.$sendToMessengerPopup = $(Mustache.render(templates.sendtomessenger_form, {
			main_title : self.pageName,
			guid : inConcert.Utils.generateGuid()
		}));
		
		var color = self.$entryPointsContainer.find("[control=sendtomessenger_color]").val();
		var size = self.$entryPointsContainer.find("[control=sendtomessenger_size]").val();
		var postback = self.$entryPointsContainer.find("[control=sendtomessenger_postback]").val() || "";
		var enforce_login = self.$entryPointsContainer.find("[control=sendtomessenger_enforce_login]").is(":checked")? "true" : "false";
		
		//js code
		var jsCode = Mustache.render(templates.sendtomessenger_js, {
			app_id : window.fbAppId
		});
		self.$sendToMessengerPopup.find("[control=sendtomessenger_javascript]")
			.click(function() {
				this.setSelectionRange(0, this.value.length);
			})
			.text(jsCode);
		new Clipboard("[copy_control=sendtomessenger_javascript]");
		//html code
		var htmlCode = Mustache.render(templates.sendtomessenger_html, {
			app_id : window.fbAppId,
			page : self.pageId,
			color : color,
			size : size,
			postback : postback,
			enforce_login : enforce_login
		});
		self.$sendToMessengerPopup.find("[control=sendtomessenger_html]")
			.click(function() {
				this.setSelectionRange(0, this.value.length);
			})
			.text(htmlCode);
		new Clipboard("[copy_control=sendtomessenger_html]");
		
		self.$sendToMessengerPopup.find("[sendtomessenger_close_button]").click(function() {
			self.__closePopup();
			if (self.sendToMessengerPopup && self.sendToMessengerPopup.isVisible()) {
				self.sendToMessengerPopup.finalize(function() {
					self.sendToMessengerPopup = null;
					self.$sendToMessengerPopup.remove();
				});
			}
			else {
				self.$sendToMessengerPopup.remove();
			}
		});
	};

	PageMessengerAdministration.prototype.__sendToMessengerChange = _.throttle(function() {
		var color = this.$entryPointsContainer.find("[control=sendtomessenger_color]").val();
		var size = this.$entryPointsContainer.find("[control=sendtomessenger_size]").val();
		var postback = this.$entryPointsContainer.find("[control=sendtomessenger_postback]").val() || "";
		var enforce_login = this.$entryPointsContainer.find("[control=sendtomessenger_enforce_login]").is(":checked")? "true" : "false";
		var iframe = document.createElement("iframe");
		var exampleUrl = format("/inconcert/apps/administration/campaigns/messenger_examples/{0}/{1}",
			"send_to_messenger", encodeURIComponent(JSON.stringify({
			app_id : window.fbAppId,
			page : this.pageId,
			color : color,
			size : size,
			postback : postback,
			enforce_login : enforce_login
		})));
		iframe.src = exampleUrl;
		this.$entryPointsContainer.find("[control=sendtomessenger_example]")
			.html("")
			.attr("class", "pageMessengerEntryPointsExample " + size + "SendToMessengerSize")
			.append(iframe);
	}, 100);

	PageMessengerAdministration.prototype.__makeSendToMessenger = function() {
		var self = this;
		self.$entryPointsContainer.find("[control=sendtomessenger_color]").change(function() {
			self.__sendToMessengerChange();
		});
		self.$entryPointsContainer.find("[control=sendtomessenger_size]").change(function() {
			self.__sendToMessengerChange();
		});
		self.$entryPointsContainer.find("[control=sendtomessenger_enforce_login]").click(function() {
			self.__sendToMessengerChange();
		});
		self.$entryPointsContainer.find("[control=sendtomessenger_postback]")
			.on("paste", function() {
				self.__sendToMessengerChange();
			})
			.on("keyup", function() {
				self.__sendToMessengerChange();
			});
		self.$entryPointsContainer.find("[sendtomessenger_open_popup]").click(function() {
			self.__openSendToMessengerPopup();
		});
		self.__sendToMessengerChange();
	};

	//https://developers.facebook.com/docs/messenger-platform/messenger-profile/supported-locales
	if (!inConcert.MessengerLanguages) {
		inConcert.MessengerLanguages = [
			"en_US",
			"ca_ES",
			"cs_CZ",
			"cx_PH",
			"cy_GB",
			"da_DK",
			"de_DE",
			"eu_ES",
			"en_UD",
			"es_LA",
			"es_ES",
			"gn_PY",
			"fi_FI",
			"fr_FR",
			"gl_ES",
			"hu_HU",
			"it_IT",
			"ja_JP",
			"ko_KR",
			"nb_NO",
			"nn_NO",
			"nl_NL",
			"fy_NL",
			"pl_PL",
			"pt_BR",
			"pt_PT",
			"ro_RO",
			"ru_RU",
			"sk_SK",
			"sl_SI",
			"sv_SE",
			"th_TH",
			"tr_TR",
			"ku_TR",
			"zh_CN",
			"zh_HK",
			"zh_TW",
			"af_ZA",
			"sq_AL",
			"hy_AM",
			"az_AZ",
			"be_BY",
			"bn_IN",
			"bs_BA",
			"bg_BG",
			"hr_HR",
			"nl_BE",
			"en_GB",
			"et_EE",
			"fo_FO",
			"fr_CA",
			"ka_GE",
			"el_GR",
			"gu_IN",
			"hi_IN",
			"is_IS",
			"id_ID",
			"ga_IE",
			"jv_ID",
			"kn_IN",
			"kk_KZ",
			"lv_LV",
			"lt_LT",
			"mk_MK",
			"mg_MG",
			"ms_MY",
			"mt_MT",
			"mr_IN",
			"mn_MN",
			"ne_NP",
			"pa_IN",
			"sr_RS",
			"so_SO",
			"sw_KE",
			"tl_PH",
			"ta_IN",
			"te_IN",
			"ml_IN",
			"uk_UA",
			"uz_UZ",
			"vi_VN",
			"km_KH",
			"tg_TJ",
			"ar_AR",
			"he_IL",
			"ur_PK",
			"fa_IR",
			"ps_AF",
			"my_MM",
			"qz_MM",
			"or_IN",
			"si_LK",
			"rw_RW",
			"cb_IQ",
			"ha_NG",
			"ja_KS",
			"br_FR",
			"tz_MA",
			"co_FR",
			"as_IN",
			"ff_NG",
			"sc_IT",
			"sz_PL"
		];
		inConcert.MessengerLanguages.sort();
	}
}());