/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;
	var templates =  {
		base : ('').concat(
			'<div id="{{ popup_id }}" class="internalPopUpContainer whatsappGroupsPopUp fullScreenPopUp" hidden>',
				'<div class="internalPopUp">',
					'<div class="internalPopUpTitle">',
						"<%=_T('Whatsapp groups')%>",
						'<span class="groupsAccountName">',
							'{{ name }}',
						'</span>',
						'<span popup_groups_details_subtitle class="botPopupTitleElement lastElement" hidden>',
						'</span>',
					'</div>',
					'<div popup_loading class="popupWaitingContainer">','<div popup_loading_label class="popupWaitingMessage">',
							"<%=_T('Loading groups')%>...",
						'</div>',
						'<div class="popupWaitingAnimation"></div>',
						'<div class="popupWaitingOverlay"></div>',
					'</div>',
					'<div popup_form class="internalPopUpMiddle" hidden>',
						'<div popup_error class="genericFormMessagesContainer messageError" hidden>',
							'<label popup_error_label class="messageText"></label>',
						'</div>',
						'<div popup_groups_list class="formFatherFieldset">',
						'</div>',
						'<div popup_group_details class="formFatherFieldset" hidden>',
						'</div>',
					'</div>',
					'<div popup_groups_list_actions class="internalPopUpButtons internal">',
						'<button close_button class="pageButtonGeneric buttonColorLightblue" type="button"><%=_T("Close")%></button>',
					'</div>',
					'<div popup_groups_details_actions class="internalPopUpButtons internal" hidden>',
						'<button close_button class="pageButtonGeneric buttonColorLightblue"><%=_T("Back")%></button>',
					'</div>',
				'</div>',
			'</div>'
		),
		list : ('').concat(
			'<div class="formFieldset">',
				'<h2 class="formSubTitle">',
					'<label class="subTitleText">',
						"<%=_T('Groups')%>",
					'</label>',
					'<label class="subTitleHelp">',
						"<%=_T('/ List of groups that account belongs to.')%>",
					'</label>',
					'<input new_group class="pageButtonGeneric buttonColorBlack internalButtons" type="button" value="', "<%=_T('New')%>" , '" />',
				'</h2>',
				'<div class="formAuxiliarRow">',
					'<div new_group_form_container class="formFieldset newWhatsappGroupForm" style="display:none;">',
					'</div>',
					'<div class="formFieldset">',
						'<div class="whatsappGroupsListContainer">',
							'<ul whatsapp_groups_list class="formList greetingTextList">',
								'<li class="formListTitle">',
									'<label class="formTitleText nameColumn">',
										"<%=_T('Id')%>",
									'</label>',
									'<label class="formTitleText valueColumn">',
										"<%=_T('Subject')%>",
									'</label>',
								'</li>',
							'</ul>',
						'</div>',
					'</div>',
				'</div>',
			'</div>'
		),
		group_row: ('').concat(
			'<li whatsapp_group_row class="formListItem">',
				'<label class="formItemText nameColumn">',
					'{{ id }}',
				'</label>',
				'<label class="formItemText valueColumn">',
					'{{ subject }}',
				'</label>',
				'<button whatsapp_action="leave" class="buttonColorGray whatsappGroupLeaveButton">',
					'<i class="buttons-icons-leave-group"></i>',
					"<%=_T('Leave')%>",
				'</button>',
				'<button whatsapp_action="details" class="buttonColorGray whatsappGroupDetailsButton">',
					'<i class="buttons-icons-edit"></i>',
					"<%=_T('Edit')%>",
				'</button>',
			'</li>'
		),
		new_group_form: ('').concat(
			'<div class="pageFormParentContanier">',
				'<div class="formRow">',
					'<div class="formData formDataExt">',
						'<label for="{{ guid }}_subject" class="formLabel">',
							"<%=_T('Subject')%>:",
						'</label>',
						'<input control="subject" id="{{ guid }}_subject" class="formField" type="text" maxlength="25">',
						'<i validation="subject" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
				'<div class="pageButtonContainer internal">',
					'<input whatsapp_action="create" class="pageButtonGeneric buttonColorBlack" type="button" value="', "<%=_T('Create')%>" ,'" />',
					'<input whatsapp_action="cancel" class="pageButtonGeneric buttonColorGray" type="button" value="', "<%=_T('Cancel')%>" ,'" />',
				'</div>',
			'</div>'
		),
		details: ('').concat(
			'<div popup_group_details_basic_data class="formFieldset">',
				'<h2 class="formSubTitle">',
					'<label class="subTitleText">',
						"<%=_T('Details')%>",
					'</label>',
					'<label class="subTitleHelp">',
						"<%=_T('/ Group details')%>",
					'</label>',
				'</h2>',
				'<div class="formRow">',
					'<div class="formData formDataExt">',
						'<label for="{{ guid }}_subject" class="formLabel">',
							"<%=_T('Subject')%>:",
						'</label>',
						'<input control="subject" id="{{ guid }}_subject" class="formField" type="text" maxlength="25">',
						'<i validation="subject" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',
				'</div>',
				'<input update_details class="messengerCodeButton" type="button" value="', "<%=_T('Update')%>" , '" />',
			'</div>'
		),
		avatar: ('').concat(
			'<div popup_group_details_avatar class="formFieldset">',
				'<h2 class="formSubTitle">',
					'<label class="subTitleText">',
						"<%=_T('Avatar')%>",
					'</label>',
					'<label class="subTitleHelp">',
						"<%=_T('/ Group avatar')%>",
					'</label>',
				'</h2>',
				'<div class="formRow">',
					'<div class="whatsappGroupsAvatarContainer">',
						'<img avatar_image class="whatsappGroupsAvatarImage" src="{{ avatar }}" />',
						'<button update_avatar class="whatsappGroupsAvatarButton" title="',
							"<%=_T('Update group avatar')%>", '">',
							'<i class="buttons-icons-edit"></i>',
						'</button>',
						'<input update_avatar_input option="image" type="file" hidden="" accept="image/*">',
					'</div>',
				'</div>',
			'</div>'
		),
		participants : ('').concat(
			'<div popup_group_details_participants class="formFieldset">',
				'<h2 class="formSubTitle">',
					'<label class="subTitleText">',
						"<%=_T('Members')%>",
					'</label>',
					'<label class="subTitleHelp">',
						"<%=_T('/ List of group members.')%>",
					'</label>',
				'</h2>',
				'<div class="formAuxiliarRow">',
					'<div class="formFieldset">',
						'<div class="whatsappGroupsListContainer">',
							'<ul whatsapp_participants_list class="formList greetingTextList">',
								'<li class="formListTitle">',
									'<label class="formTitleText nameColumn">',
										"<%=_T('Number')%>",
									'</label>',
									'<label class="formTitleText valueColumn">',
										"<%=_T('Role')%>",
									'</label>',
								'</li>',
							'</ul>',
						'</div>',
						'<div participants_limit class="whatsappGroupsListLimit">',
						'</div>',
					'</div>',
				'</div>',
				'<div class="formRow">',
					'<div class="formData formDataWithDisclaimer">',
						'<div class="formDataDisclaimer explanation">', 
							"<%=_T('Whatsapp groups have a limit of {{ members_limit }} users.')%>",
						'</div>',
					'</div>',
				'</div>',
			'</div>'
		),
		participant_row: ('').concat(
			'<li whatsapp_participant_row participant="{{ id }}" class="formListItem">',
				'<label class="formItemText nameColumn">',
					'{{ id }}',
				'</label>',
				'<label participant_role class="formItemText valueColumn">',
					'{{ role }}',
				'</label>',
				'<button whatsapp_action="remove" class="buttonColorGray whatsappGroupRemoveButton">',
					'<i class="buttons-icons-delete"></i>',
					"<%=_T('Delete')%>",
				'</button>',
				'<button whatsapp_action="admin" class="buttonColorGray whatsappGroupAdminButton">',
					'<i class="buttons-icons-add-member"></i>',
					"<%=_T('Add Admin')%>",
				'</button>',
				'<button whatsapp_action="remove_admin" class="buttonColorGray whatsappGroupRemoveAdminButton">',
					'<i class="buttons-icons-remove-member"></i>',
					"<%=_T('Remove Admin')%>",
				'</button>',
			'</li>'
		),
		invite_link: ('').concat(
			'<div popup_group_details_invite_link class="formFieldset">',
				'<h2 class="formSubTitle">',
					'<label class="subTitleText">',
						"<%=_T('Invite link')%>",
					'</label>',
					'<label class="subTitleHelp">',
						"<%=_T('/ Using this link users can join the group.')%>",
					'</label>',
				'</h2>',
				'<div invite_link_row class="formRow">',
					'<div class="formData formDataExt">',
						'<label for="{{ guid }}_invite_link" class="formLabel">',
							"<%=_T('Link')%>:",
						'</label>',
						'<input control="invite_link" id="{{ guid }}_invite_link" class="formField" type="text" disabled>',
					'</div>',
				'</div>',
				'<button invite_link_get_button class="messengerCodeButton">',
					"<%=_T('Generate Link')%>",
				'</button>',
				'<button invite_link_remove_button class="messengerCodeButton" hidden>',
					"<%=_T('Invalidate Link')%>",
				'</button>',
			'</div>'
		)
	};
	
	///////////////////////////////FORM

	function WhatsappGroupsManager(campaign, account) {
		this.campaign = campaign;
		this.account = account;
	}

	if (typeof inConcert.WhatsappGroupsManager !== "function") {
		inConcert.WhatsappGroupsManager = WhatsappGroupsManager;
	}
	
	WhatsappGroupsManager.prototype.Show = function(callback) {
		callback = callback || $.noop;
		var self = this;
		self.__make();
		$("body").append(self.$container);
		self.popup = new inConcert.PopupWindow();
		self.popup.show({
			ownerId         : self.__getPopupId(),
			eventName       : self.__getPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$container,
			callbacks: {
				onOpen: function() {
					self.$container.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.popup) {
						self.popup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
		self.__loadForm(function() {
			self.__afterAppendBody();
			callback();
		});
	};

	WhatsappGroupsManager.prototype.Close = function(callback) {
		callback = callback || $.noop;
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		if (self.popup && self.popup.isVisible()) {
			self.popup.finalize(function() {
				self.popup = null;
				self.$container.remove();
				callback();
			});
		}
		else {
			self.$container.remove();
			callback();
		}
	};

	WhatsappGroupsManager.prototype.IsProcessing = function() {
		return !!this.processing;
	};

	WhatsappGroupsManager.prototype.__processing = function(processing, text) {
		this.processing = !!processing;
		this.$container.find("[popup_loading_label]").text(text || "<%=_T('Updating group configuration')%>...");
		this.$container.find("[popup_loading]").toggle(this.processing);
	};

	WhatsappGroupsManager.prototype.__clearErrors = function($container) {
		$container = $container || this.$container;
		$container.find("[validation], [popup_error]").hide();
		$container.find("[popup_error_label]").text("");
	};

	WhatsappGroupsManager.prototype.__showError = function(error, $container) {
		$container = $container || this.$container;
		if (typeof error === "string") {
			error = { message : error };
		}
		$container.find("[popup_error]").show();
		$container.find("[popup_error_label]").text(error.message);
		if (error.control) {
			$container.find(format("[validation={0}]", error.control)).show();
		}
		else if (error.$control) {
			error.$control.find("[validation]:first").show();
		}
		$container.find(".internalPopUpMiddle").scrollTop(0);
	};

	WhatsappGroupsManager.prototype.__make = function() {
		var self = this;
		self.$container = $(Mustache.render(templates.base, {
			name : self.account.name,
			popup_id : self.__getPopupId()
		}));
		var $actions = self.$container.find("[popup_groups_list_actions]");
		$actions.find("[close_button]").click(function() {
			self.Close();
		});
	};

	WhatsappGroupsManager.prototype.__getPopupId = function() {
		return "adm_form_campaign_whatsapp_groups_popup";
	};

	WhatsappGroupsManager.prototype.__afterAppendBody = function() {};

	WhatsappGroupsManager.prototype.__loadForm = function(callback) {
		callback = callback || $.noop;
		var self = this;
		//load groups
		self.__loadGroups(function(error) {
			if (error) {
				self.__processing(false);
				self.$container.find("[popup_form]").show();
				return self.__showError(error);
			}
			self.__makeForm();
		});
	};

	WhatsappGroupsManager.prototype.__reloadForm = function(loadGroups, callback) {
		callback = callback || $.noop;
		var self = this;
		function reload() {
			self.__makeGroupsList();
		}
		if (!loadGroups) {
			return reload();
		}
		//load groups
		self.__processing(true, "<%=_T('Loading groups')%>...");
		self.__loadGroups(function(error) {
			self.__processing(false);
			if (error) {
				return self.__showError(error);
			}
			reload();
		});
	};

	WhatsappGroupsManager.prototype.__makeGroupRow = function(group) {
		var self = this;
		var $group = $(Mustache.render(templates.group_row, {
			id : group.id,
			subject : group.subject
		}));
		$group.data("group", group.id);
		$group.find("[whatsapp_action=leave]").click(function() {
			self.__requestLeave($(this).parent().data("group"));
		});
		$group.find("[whatsapp_action=details]").click(function() {
			self.__loadGroupDetails($(this).parent().data("group"));
		});
		return $group;
	};

	WhatsappGroupsManager.prototype.__makeGroupsList = function() {
		var self = this;
		var sortedList = [];
		$.each(self.groups, function(_, group) {
			sortedList.push(group);
		});
		sortedList.sort(function(a, b) {
			return a.subject.localeCompare(b.subject);
		});
		var $list = [];
		$.each(sortedList, function(_, group) {
			$list.push(self.__makeGroupRow(group));
		});
		var $listContainer = self.$container.find("[whatsapp_groups_list]");
		$listContainer.find("[whatsapp_group_row]").remove();
		$listContainer.append($list);
	};

	WhatsappGroupsManager.prototype.__makeForm = function() {
		var self = this;
		var $form = self.$container.find("[popup_form]");
		//groups list
		var $list = $(templates.list);
		$form.find("[popup_groups_list]").append($list);
		self.__makeGroupsList();
		$form.find("[new_group]").click(function() {
			self.__loadNewGroupForm();
		});
		//show form
		self.__processing(false);
		$form.show();
	};

	WhatsappGroupsManager.prototype.__requestLeave = function(groupId) {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		var group = self.groups[groupId];
		self.__clearErrors();
		self.__processing(true, "<%=_T('leaving group')%>...");
		$.inconcertPopup.Show(
			"<%=_T('Confirmation')%>",
			format("<%=_T('Would you want to leave group {0}?')%>", group.subject),
			$.inconcertPopup.ButtonSets.BS_YESNO,
			function(response) {
				switch(response.toLowerCase()) {
					case "yes":
						self.__leaveGroup(group, function(error) {
							self.__processing(false);
							if (!error) {
								self.__reloadForm();
							}
							else {
								self.__showError(error);
							}
						});
						break;
					default:
						self.__processing(false);
				}
			},
			undefined,
			{
				popup_id        : "conf_inconcertPopup",
				container_class : "confirmationPopUp",
				overlay_class   : "confirmationOverlay"
			}
		);
	};

	WhatsappGroupsManager.prototype.__loadNewGroupForm = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		var $form = $(Mustache.render(templates.new_group_form, {
			guid : inConcert.Utils.generateGuid()
		}));
		$form.find("[whatsapp_action=create]").click(function() {
			self.__requestNewGroup();
		});
		$form.find("[whatsapp_action=cancel]").click(function() {
			self.__closeNewGroupForm();
		});
		self.$container.find("[new_group_form_container]")
			.append($form)
			.show();
	};

	WhatsappGroupsManager.prototype.__closeNewGroupForm = function() {
		if (this.IsProcessing()) {
			return;
		}
		this.__clearErrors();
		this.$container.find("[new_group_form_container]")
			.html("")
			.hide();
	};
	
	WhatsappGroupsManager.prototype.__requestNewGroup = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		//get and validate
		var group = {
			subject : this.$container.find("[control=subject]").val()
		};
		if (!group.subject) {
			return self.__showError({
				control : "subject",
				message : "<%=_T('Must enter a subject.')%>"
			});
		}
		//create
		self.__processing(true, "<%=_T('Creating group')%>...");
		self.__newGroup(group, function(error) {
			self.__processing(false);
			if (!error) {
				self.__closeNewGroupForm();
				self.__reloadForm();
			}
			else {
				self.__showError(error);
			}
		});
	};

	///////////////////////////////DETAILS

	WhatsappGroupsManager.prototype.__loadGroupDetails = function(groupId) {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__processing(true, "<%=_T('Loading group')%>...");
		self.__loadGroupDetailsData(groupId, function(error) {
			if (error) {
				self.__processing(false);
				self.__showError(error);
				return;
			}
			self.group = self.groups[groupId];
			//title
			self.$container.find("[popup_groups_details_subtitle]")
				.text(format("<%=_T('Group: {0}')%>", self.group.subject))
				.show();
			//actions
			self.$container.find("[popup_groups_list_actions]").hide();
			var $actions = self.$container.find("[popup_groups_details_actions]").show();
			$actions.find("[close_button]")
				.off("click")
				.on("click", function() {
					self.__closeDetails();
				});
			//content
			self.$container.find("[popup_groups_list]").hide();
			var $form = self.$container.find("[popup_group_details]");
			self.__loadGroupDetailsBasicData($form);
			//self.__loadGroupDetailsAvatar($form);
			self.__loadGroupDetailsParticipants($form);
			self.__loadGroupDetailsInviteLink($form);
			//show
			$form.show();
			self.__processing(false);
		});
	};

	WhatsappGroupsManager.prototype.__loadGroupDetailsData = function(_, callback) {
		callback();
	};

	WhatsappGroupsManager.prototype.__loadGroupDetailsBasicData = function($form) {
		var self = this;
		$form = $form || self.$container.find("[popup_group_details]");
		$form.find("[popup_group_details_basic_data]").remove();
		$form.append(Mustache.render(templates.details, {
			guid : inConcert.Utils.generateGuid()
		}));
		$form.find("[control=subject]").val(self.group.subject);
		self.$container.find("[update_details]")
			.off("click")
			.on("click", function() {
				self.__requestUpdateGroup();
			});
	};

	WhatsappGroupsManager.prototype.__loadGroupDetailsAvatar = function($form) {
		var self = this;
		$form = $form || self.$container.find("[popup_group_details]");
		$form.find("[popup_group_details_avatar]").remove();
		$form.append(Mustache.render(templates.avatar, {
			guid : inConcert.Utils.generateGuid(),
			avatar : self.__getGroupAvatarUrl(self.group.id)
		}));
		
		$form.find("[update_avatar]")
			.off("click")
			.on("click", function() {
				if (!self.IsProcessing()) {
					self.$container.find("[update_avatar_input]")[0].click();
				}
			});
		$form.find("[update_avatar_input]")
			.off("change")
			.on("change", function(event) {
				self.__requestChangeAvatar(event);
			});
	};

	WhatsappGroupsManager.prototype.__makeAvatarUrl = function(avatar) {
		if (avatar) {
			return format("data:{0};base64, {1}", avatar.contentType, avatar.content);
		}
		else {
			return "/inconcert/apps/agent/images/genericAvatar.png";
		}
	};

	WhatsappGroupsManager.prototype.__getGroupAvatarUrl = function(groupId) {
		return this.__makeAvatarUrl(this.__getGroupAvatar(groupId));
	};

	WhatsappGroupsManager.prototype.__loadGroupDetailsParticipants = function($form) {
		var self = this;
		$form = $form || self.$container.find("[popup_group_details]");
		var admins = {};
		$.each(self.group.admins, function(_, id) {
			admins[id] = true;
		});
		var sortedList = [];
		$.each(self.group.participants, function(_, id) {
			sortedList.push({
				id : id,
				admin : admins[id] || false
			});
		});
		sortedList.sort(function(a, b) {
			return a.id.localeCompare(b.id);
		});
		var $list = [];
		$.each(sortedList, function(_, participant) {
			$list.push(self.__makeParticipantRow(participant));
		});
		$form.find("[popup_group_details_participants]").remove();
		$form.append(Mustache.render(templates.participants, {
			members_limit : self.__getParticipantsLimit()
		}));
		var $listContainer = self.$container.find("[whatsapp_participants_list]");
		$listContainer.append($list);
		self.__updateParticipantsNumber();
		};

		WhatsappGroupsManager.prototype.__getParticipantsLimit = function() {
			return 256;
		};

		WhatsappGroupsManager.prototype.__updateParticipantsNumber = function() {
			var current = this.$container.find("[whatsapp_participant_row]").length;
			var limit = this.__getParticipantsLimit();
			var fullList = current >= limit;
			this.$container.find("[participants_limit]")
				.text(format("<%=_T('{0}/{1} members')%>", current, limit))
				.toggleClass("fullList", fullList);
	};

	WhatsappGroupsManager.prototype.__makeParticipantRow = function(participant) {
		var self = this;
		var $participant = $(Mustache.render(templates.participant_row, {
			id : participant.id,
			role : participant.admin? "<%=_T('Admin')%>" : "<%=_T('User')%>"
		}));
		$participant.find("[whatsapp_action=admin]")
			.toggle(!participant.admin)
			.click(function() {
				self.__requestAddAdmin($(this).parent().attr("participant"));
			});
		$participant.find("[whatsapp_action=remove_admin]")
			.toggle(participant.admin)
			.click(function() {
				self.__requestRemoveAdmin($(this).parent().attr("participant"));
			});
		$participant.find("[whatsapp_action=remove]").click(function() {
			self.__requestRemoveParticipant($(this).parent().attr("participant"));
		});
		return $participant;
	};

	WhatsappGroupsManager.prototype.__loadGroupDetailsInviteLink = function($form) {
		var self = this;
		$form = $form || self.$container.find("[popup_group_details]");
		$form.find("[popup_group_details_invite_link]").remove();
		$form.append(Mustache.render(templates.invite_link, {
			guid : inConcert.Utils.generateGuid()
		}));
		$form.find("[invite_link_get_button]").on("click", function() {
			self.__requestGenerateInviteLink();
		});
		$form.find("[invite_link_remove_button]").on("click", function() {
			self.__requestRemoveInviteLink();
		});
	};

	WhatsappGroupsManager.prototype.__closeDetails = function() {
		if (this.IsProcessing()) {
			return;
		}
		this.__clearErrors();
		this.group = null;
		//title
		this.$container.find("[popup_groups_details_subtitle]").hide();
		//actions
		this.$container.find("[popup_groups_details_actions]").hide();
		this.$container.find("[popup_groups_list_actions]").show();
		//form
		this.$container.find("[popup_group_details]").html("").hide();
		this.$container.find("[popup_groups_list]").show();
	};

	WhatsappGroupsManager.prototype.__requestUpdateGroup = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		//get and validate
		var $form = self.$container.find("[popup_group_details_basic_data]");
		var group = {
			id : self.group.id,
			subject : $form.find("[control=subject]").val()
		};
		if (!group.subject) {
			return self.__showError({
				control : "subject",
				message : "<%=_T('Must enter a subject.')%>"
			}, $form);
		}
		//create
		self.__processing(true, "<%=_T('Updating group')%>...");
		self.__updateGroup(group, function(error) {
			self.__processing(false);
			if (!error) {
				self.__reloadForm();
			}
			else {
				self.__showError(error);
			}
		});
	};

	WhatsappGroupsManager.prototype.__requestChangeAvatar = function(event) {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		var file = event.target.files[0];
		if ( !file ) {
			return;
		}
		var $form = self.$container.find("[popup_group_details_avatar]");
		var reader = new FileReader();
		self.__processing(true, "<%=_T('Updating avatar')%>...");
		reader.onload = function (e) {
			var contentType = file.type;
			var urlContent = e.target.result;
			var urlContent_a = urlContent.split(",");
			var content = urlContent_a[urlContent_a.length - 1];
			self.__updateGroupAvatar(self.group.id, contentType, content, function(error) {
				self.__processing(false);
				if (!error) {
					$form.find("[avatar_image]").attr("src", urlContent);
				}
				else {
					self.__showError(error);
				}
			});
		};
		reader.readAsDataURL(file);
	};

	WhatsappGroupsManager.prototype.__requestAddAdmin = function(number) {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		self.__processing(true, "<%=_T('Adding admin')%>...");
		var $rows = self.$container.find("[whatsapp_participant_row]");
		self.__addGroupAdmins(self.group.id, [ { id : number} ], function(error) {
			self.__processing(false);
			if (!error) {
				var $row = $rows.filter(format("[participant={0}]", number));
				$row.find("[participant_role]").text("<%=_T('Admin')%>");
				$row.find("[whatsapp_action=admin]").hide();
				$row.find("[whatsapp_action=remove_admin]").show();
			}
			else {
				self.__showError(error);
			}
		});
	};

	WhatsappGroupsManager.prototype.__requestRemoveAdmin = function(number) {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		self.__processing(true, "<%=_T('Removing admin')%>...");
		var $rows = self.$container.find("[whatsapp_participant_row]");
		self.__removeGroupAdmins(self.group.id, [ { id : number} ], function(error) {
			self.__processing(false);
			if (!error) {
				var $row = $rows.filter(format("[participant={0}]", number));
				$row.find("[participant_role]").text("<%=_T('User')%>");
				$row.find("[whatsapp_action=admin]").show();
				$row.find("[whatsapp_action=remove_admin]").hide();
			}
			else {
				self.__showError(error);
			}
		});
	};

	WhatsappGroupsManager.prototype.__requestRemoveParticipant = function(number) {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		self.__processing(true, "<%=_T('Removing participant')%>...");
		var $rows = self.$container.find("[whatsapp_participant_row]");
		self.__removeGroupParticipants(self.group.id, [ { id : number} ], function(error) {
			self.__processing(false);
			if (!error) {
				var $row = $rows.filter(format("[participant={0}]", number));
				$row.remove();
				self.__updateParticipantsNumber();
			}
			else {
				self.__showError(error);
			}
		});
	};

	WhatsappGroupsManager.prototype.__requestGenerateInviteLink = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		self.__processing(true, "<%=_T('Creating link')%>...");
		self.__createGroupInviteLink(self.group.id, function(link, error) {
			self.__processing(false);
			if (link) {
				self.$container.find("[control=invite_link]")
					.val(link)
					.prop("disabled", false)
					.prop("readonly", true);
				self.$container.find("[invite_link_remove_button]").show();
				self.$container.find("[invite_link_get_button]").hide();
			}
			else {
				self.__showError(error);
			}
		});
	};

	WhatsappGroupsManager.prototype.__requestRemoveInviteLink = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		self.__processing(true, "<%=_T('Removing link')%>...");
		self.__deleteGroupInviteLink(self.group.id, function(error) {
			self.__processing(false);
			if (!error) {
				self.$container.find("[control=invite_link]")
					.val("")
					.prop("disabled", true)
					.prop("readonly", false);
				self.$container.find("[invite_link_remove_button]").hide();
				self.$container.find("[invite_link_get_button]").show();
			}
			else {
				self.__showError(error);
			}
		});
	};

	///////////////////////////////API

	WhatsappGroupsManager.prototype.__callMethod = function(method, data, callback) {
		data.campaignAtVCC = this.campaign.Id;
		data.account = this.account.id;
		inConcert.invoke({
			url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp/" + method + "/",
			type: "POST",
			data: JSON.stringify(data),
			dataType: "json",
			contentType: "application/json",
			success: function(response) {
				callback(response);
			},
			error: function(_, error) {
				callback(false, error && error.reason || "api error");
			}
		});
	};

	WhatsappGroupsManager.prototype.__loadGroups = function(callback) {
		var self = this;
		self.__callMethod("list_groups", {}, function(response, error) {
			if (response) {
				self.groups = response.groups;
			}
			callback(error? "<%=_T('Error getting groups')%>" : null);
		});
	};

	WhatsappGroupsManager.prototype.__leaveGroup = function(group, callback) {
		var self = this;
		self.__callMethod("leave_group", { groupId : group.id }, function(response) {
			if (response) {
				self.groups = response.groups;
				callback();
			}
			else {
				callback("<%=_T('Error leaving group')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__newGroup = function(group, callback) {
		var self = this;
		self.__callMethod("create_group", { group : group }, function(response) {
			if (response) {
				self.groups[response.group.id] = response.group;
				callback();
			}
			else {
				callback("<%=_T('Error creating group')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__updateGroup = function(group, callback) {
		var self = this;
		self.__callMethod("update_group", { group : group }, function(response) {
			if (response) {
				self.groups[response.group.id] = response.group;
				callback();
			}
			else {
				callback("<%=_T('Error updating group')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__loadGroupAvatar = function(groupId, callback) {
		var self = this;
		self.__callMethod("get_group_icon", { groupId : groupId }, function(response) {
			if (response) {
				self.avatars = self.avatars || {};
				self.avatars[groupId] = { 
					content : response.content,
					contentType : response.contentType
				};
				callback();
			}
			else {
				callback("<%=_T('Error getting group avatar')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__updateGroupAvatar = function(groupId, contentType, content, callback) {
		var self = this;
		self.__callMethod("set_group_icon", 
			{
				groupId : groupId,
				contentType : contentType,
				content : content
			},
			function(response) {
				if (response) {
					callback();
				}
				else {
					callback("<%=_T('Error updating group avatar')%>");
				}
			});
	};

	WhatsappGroupsManager.prototype.__getGroupAvatar = function(groupId) {
		return this.avatars && this.avatars[groupId];
	};

	WhatsappGroupsManager.prototype.__addGroupAdmins = function(groupId, admins, callback) {
		var self = this;
		self.__callMethod("add_group_admins", { groupId : groupId, admins : admins }, function(response) {
			if (response) {
				self.groups[response.group.id] = response.group;
				callback();
			}
			else {
				callback("<%=_T('Error adding admins')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__removeGroupAdmins = function(groupId, admins, callback) {
		var self = this;
		self.__callMethod("remove_group_admins", { groupId : groupId, admins : admins }, function(response) {
			if (response) {
				self.groups[response.group.id] = response.group;
				callback();
			}
			else {
				callback("<%=_T('Error removing admins')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__removeGroupParticipants = function(groupId, participants, callback) {
		var self = this;
		self.__callMethod("remove_group_participants", { groupId : groupId, participants : participants }, function(response) {
			if (response) {
				self.groups[response.group.id] = response.group;
				callback();
			}
			else {
				callback("<%=_T('Error removing participants')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__createGroupInviteLink = function(groupId, callback) {
		var self = this;
		self.__callMethod("create_group_invite_link", { groupId : groupId }, function(response) {
			if (response) {
				callback(response.link);
			}
			else {
				callback(false, "<%=_T('Error creating invite link')%>");
			}
		});
	};

	WhatsappGroupsManager.prototype.__deleteGroupInviteLink = function(groupId, callback) {
		var self = this;
		self.__callMethod("delete_group_invite_link", { groupId : groupId }, function(response) {
			if (response) {
				callback();
			}
			else {
				callback("<%=_T('Error removing invite link')%>");
			}
		});
	};
}());
