require "inconcert.translators"

local models = require("apps.agent.model"):GetModels()

local m_moduleLocation = select(2, ...)

module(..., package.seeall, inconcert.orbit.application.Decorate)

m_htmlRender = nil

function MapUris(module, htmlRender, prefix)

	local LogRequest = require("apps.agent.requestFilters").LogRequest

	module:dispatch_post( LogRequest .. SaveSettings, prefix.."/save/(.*)")
	module:dispatch_get(  LogRequest .. GetSettings, prefix.."/get/([^.]*)")
	
	m_htmlRender = htmlRender
end

function GetSettings(web)
	_M.response.DontCache(web)
	
	local vcc = inconcert.authUser.virtualContactCenter
	local name = inconcert.authUser.userName
	
	LogInfo("Retrieving settings for user %s on vcc %s", name, vcc)
	local settings = models["Settings"].Get(name, vcc)
	web.headers["Content-Type"] = "application/json"
	return json.encode(settings)
end

function SaveSettings(web)

	local settings = json.decode(web.input["post_data"])
	
	LogInfo("Saving settings for user %s on vcc %s", name, vcc)
	
	local vcc = inconcert.authUser.virtualContactCenter
	local name = inconcert.authUser.userName
	
	local result = models["Settings"].Save(name, vcc, settings)
	web.headers["Content-Type"] = "application/json"
	return json.encode(result)
end
