/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true, strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if ( !this.inConcert ) {
  this.inConcert = {};
}

(function () {


'use strict';

let Templates = {

	contact_address_item_tpl : "" +
		"<div address_type='{{ address_type }}' class='addressItem item{{ address_type }}'>" +

			"<select address_country='true' class='form-control' disabled style='display:none;' title='" + "<%=_T('Country')%>" + "'></select>" +
			"<select address_area='true' class='form-control' disabled style='display:none;' title='" + "<%=_T('Area')%>" + "'></select>" +

			"<label address_id='true' class='addressLabel'>{{ address }}</label>" +
			"<label phone_kind='true' class='addressLabel' hidden></label>" +
			"<input editable_address='true' class='form-control addressEditableField' type='text' hidden />" +
			"<select editable_phone_kind='true' class='form-control' hidden></select>" +
			"<button title='{{ cancel_close_tooltip }}' class='butInteractionGeneric butInteractionOutlined buttonAddressCancel' title='{{ address_cancel_close_tooltip }}' hidden><i class='far fa-ban'></i></button>"+
			"<button title='{{ save_tooltip }}' class='butInteractionGeneric butInteractionOutlined buttonAddressSave' title='{{ address_save_tooltip }}' style='display:none;'><i class='far fa-check'></i></button>"+
			"<button address_actions_menu='true' title='{{ actions_tooltip }}' class='butInteractionGeneric showMenu' title=''><i class='far fa-ellipsis-v'></i></button>" +
			/*--------------------------------------------------------------------------------
				Estos 3 botones NO pueden ser eliminados.
				Los mismo nunca se visualizan, pero son utilizados desde el menu y submenu de acciones.
				Esto se realizo asi, para no tener que realizar todo la logica nuevamente.
			--------------------------------------------------------------------------------*/
			"<button action_id='open_client' new_address_interaction_button title='{{ contact_tooltip }}' class='buttonColorGray butContactInteraction' hidden><i></i></button>" +
			"<button action_id='remove' title='{{ delete_tooltip }}' class='buttonAddressDelete' title='{{ address_delete_tooltip }}' hidden></button>"+
			"<button action_id='edit' title='{{ edit_tooltip }}' class='buttonAddressEdit' title='{{ address_edit_tooltip }}' hidden></button>"+
			/* -------------------------------------------------------------------------------- */
		"</div>",

	contact_addresses_menu : "<div new_address_interaction_menu id='{{ id }}' class='interactionMenuBlind contactAddressInteractionMenu' style='z-index: 900!important;' hidden>{{{ options }}}</div>",

	contact_address_item : "<div new_address_interaction='{{ type }}' class='interactionMenuItem itemContactInteraction{{ className }}'>{{ text }}</div>",

	contact_item :	"<div class='resultsListItem'>" + // item (exiting contact)
						"<img src='{{ contact_avatar_uri }}' class='resultAvatar' height='20' width='20'/>" + // item avatar
						"<label class='resultName'>{{ contact_name }}</label>" + // item name
					"</div>",

	merge_contact_address_tpl : "<div class='mergeItem'>" +
									// addresses on merge are always checked
									"<input id='contact_window_merge_address_{{ address_normalized }}' class='mergeCheckbox' type='checkbox' checked {{ #disabled }} disabled {{ /disabled }} />" +
									"<label address='{{ address }}' address_type='{{ address_type }}' for='contact_window_merge_address_{{ address_normalized }}' class='mergeLabel item{{ address_type }}' {{ #disabled }} disabled {{ /disabled }} >{{ address }}</label>" +
									"{{ #is_new }} <span class='mergeNew'>{{ new_label }}!</span> {{ /is_new }}" +
								"</div>",

	merge_contacts_tpl : "<div id='contact_window_merge_container' class='mergeWindowContainer'>" +
							"<div id='contact_window_merge_control_container' class='mergeControlContainer'>" +
								// name
								"<div class='mergeNameContainer'>" +
									"<div class='mergeSeccionTitle'>{{ contact_name_label }}" + "<%=_T(':')%>" + "</div>" +
									"<div class='mergeItem'>" + // name new
										"<input id='contact_window_merge_new_name' class='mergeRadiobutton' type='radio' name='radioName' {{ #name_disabled }} disabled {{ /name_disabled }} />" +
										"<label for='contact_window_merge_new_name' class='mergeLabel' {{ #name_disabled }} disabled {{ /name_disabled }}>{{ name_new }}</label>" +
										"<span class='mergeNew'>{{ new_label }}!</span>" +
									"</div>" +
									"<div class='mergeItem'>" + // name old
										"<input id='contact_window_merge_old_name' class='mergeRadiobutton' type='radio' checked name='radioName' {{ #name_disabled }} disabled {{ /name_disabled }} />" +
										"<label for='contact_window_merge_old_name' class='mergeLabel' {{ #name_disabled }} disabled {{ /name_disabled }} >{{ name_old }}</label>" +
									"</div>" +
								"</div>" +
								// addresses
								"<div class='mergeAddressContainer'>" +
									"<div class='mergeSeccionTitle'>{{ contact_addresses_label }}" + "<%=_T(':')%>" + "</div>" +
									"<div id='contact_window_merge_address_list' class='mergeAddressList'></div>" +
								"</div>" +
								// external id
								'{{ #show_external_id_container }}' +
									"<div class='mergeIdContainer'>" +
										"<div class='mergeSeccionTitle'>{{ contact_id_label }}" + "<%=_T(':')%>" + "</div>" +
										"<div class='mergeItem'>" + // id new
											"<input id='contact_window_merge_new_id' class='mergeRadiobutton' type='radio' name='radioID' {{ #id_disabled }} disabled {{ /id_disabled }} />" +
											"<label for='contact_window_merge_new_id' class='mergeLabel'>{{ external_id_new }} {{ #id_disabled }} disabled {{ /id_disabled }} </label>" +
											"<span class='mergeNew'>{{ new_label }}!</span>" +
										"</div>" +
										"<div class='mergeItem'>" + // id old
											"<input id='contact_window_merge_old_id' class='mergeRadiobutton' type='radio' checked name='radioID' {{ #id_disabled }} disabled {{ /id_disabled }} />" +
											"<label for='contact_window_merge_old_id' class='mergeLabel'>{{ external_id_old }} {{ #id_disabled }} disabled {{ /id_disabled }} </label>" +
										"</div>" +
									"</div>" +
								'{{ /show_external_id_container }}' +
							"</div>" +
							"<div class='mergeButtonContainer'>" +
								"<input id='contact_window_merge_cancel' class='pageButtonGeneric buttonColorWhite' type='button' value='{{ cancel_label }}'/>" +
								"<input id='contact_window_merge_back' class='pageButtonGeneric buttonColorWhite' type='button' value='{{ back_label }}'/>" +
								"<input id='contact_window_merge_save' class='pageButtonGeneric buttonColorBlue' type='button' value='{{ merge_label }}'/>" +
							"</div>" +
						"</div>",

	confirmation_dialog_tpl : "<div id='contact_window_confirmation_container' class='confirmationWindowContainer'>" +
								"<div class='confirmationContent'>" +
									"<div class='confirmationMessageContainer'>" +
										"<label class='confirmationMessageText'>{{ message }}</label>" +
									"</div>" +
									"<div class='confirmationButtonContainer'>" +
										"<input id='contact_window_confirmation_cancel' class='pageButtonGeneric buttonColorWhite' type='button' value='{{ cancel_label }}' {{ #hide_cancel }} hidden {{ /hide_cancel }}/>" +
										"<input id='contact_window_confirmation_confirm' class='pageButtonGeneric buttonColorBlue' type='button' value='{{ confirm_label }}'/>" +
									"</div>" +
								"</div>" +
								"<div class='confirmationOverlay'></div>" +
							"</div>",

	change_container_tpl : "<div id='contact_window_change_view' class='changeContactContainer'>" +
								"<div class='changeContactOtions'>" +
									// Choose existing contact
									"<input id='contact_window_change_existing' class='optionRadiobutton' type='radio' value='existing_contact' name='changeContact' checked />" +
									"<label for='contact_window_change_existing' class='optionLabel'>{{ choose_existing_label }}</label>" +
									// Create a new one
									"<input id='contact_window_change_new' class='optionRadiobutton' type='radio' value='new_contact' name='changeContact' />" +
									"<label for='contact_window_change_new' class='optionLabel'>{{ create_new_label }}</label>" +
									// Disassociate from interaction
									'{{ #show_disassociate }}' +
										"<input id='contact_window_change_disassociate' class='optionRadiobutton' type='radio' value='disassociate_contact' name='changeContact' />" +
										"<label for='contact_window_change_disassociate' class='optionLabel'>{{ disassociate_label }}</label>" +
									'{{ /show_disassociate }}' +
								"</div>" +
								"<div id='contact_window_change_container' class='changeContactPage'>" +
								"</div>" +
							"</div>",

	messages_tpl : "<div id='contact_window_message_container' class='contactWindowMessages genericMessagesContainer message{{ type }}'>" +
						"<a id='contact_window_message_close' class='genericMessagesClose' href='javascript:void(0);'>{{ close }}</a>" +
						"<div class='genericMessagesText'>" +
							"<label class='genericMessagesTextAux'>{{ message }}</label>" +
						"</div>" +
					"</div>",

	save_conflict_address_tpl : "<div class='infoItem'>" +
									"<label class='infoLabel item{{ address_type }}'>{{ address_displayable }}</label>" +
									"{{ #has_conflict }} <span class='infoConflict'>{{ conflict_label }}!</span> {{ /has_conflict }}" +
								"</div>",

	conflict_view_tpl : "<div id='contact_window_conflict_view' class='existingContactContainer'>" +
							// existing message
							"<div class='existingDisclaimerContainer'>" +
								"<label id='' class='existingDisclaimerText'>{{ message }}</label>" +
							"</div>" +
							// interaction contact info
							"<div class='existingInfoMiddleContainer'>" +
								"<div class='existingInfoContainer'>" +
									"<label class='existingInfoTitle'>{{ interaction_info_label }}</label>" +
									"<div id='contact_window_conflict_interaction_contact_list' class='existingInfoList'>" +
										"<div class='infoItem'>" +
											"<label class='infoLabel'><span>{{ contact_name_label }}" + "<%=_T(':')%>" + " </span>{{ interaction_contact_name }}</label>" +
										"</div>" +
										"<div class='infoItem'>" +
											"<label class='infoLabel'><span>{{ contact_id_label }}" + "<%=_T(':')%>" + " </span>{{ interaction_contact_id }}</label>" +
											"{{ #has_id_conflict_interaction }} <span class='infoConflict'>{{ conflict }}!</span> {{ /has_id_conflict_interaction }} " +
										"</div>" +
									"</div>" +
								"</div>" +
								// existing contact info
								"<div class='existingInfoContainer'>" +
									"<label class='existingInfoTitle'>{{ existing_info_label }}</label>" +
									"<div id='contact_window_conflict_existing_contact_list' class='existingInfoList'>" +
										"<div class='infoItem'>" +
											"<label class='infoLabel'><span>{{ contact_name_label }}" + "<%=_T(':')%>" + " </span>{{ conflict_contact_name }}</label>" +
										"</div>" +
										"<div class='infoItem'>" +
											"<label class='infoLabel'><span>{{ contact_id_label }}" + "<%=_T(':')%>" + " </span>{{ conflictive_contact_id }}</label>" +
											"{{ #has_id_conflict_existing }} <span class='infoConflict'>{{ conflict }}!</span> {{ /has_id_conflict_existing }} " +
										"</div>" +
									"</div>" +
								"</div>" +
							"</div>" +
							// existing buttons
							"<div class='existingButtonContainer'>" +
								'{{ #allow_cancel }}' +
									"<input id='contact_window_conflict_nothing' title='{{ nothing_tooltip }}' class='pageButtonGeneric buttonColorWhite mr-2' type='button' value='{{ nothing_label }}' />" +
								'{{ /allow_cancel }}' +
								'{{ #allow_move }}' +
									"<input id='contact_window_conflict_move' title='{{ move_tooltip }}' class='pageButtonGeneric buttonColorBlue mr-2' type='button' value='{{ move_label }}' />" +
								'{{ /allow_move }}' +
								'{{ #allow_merge }}' +
									"<input id='contact_window_conflict_merge' title='{{ merge_tooltip }}' class='pageButtonGeneric buttonColorBlue' type='button' value='{{ merge_label }}' />" +
								'{{ /allow_merge }}' +
								'{{ #allow_create_new }}' +
									"<input id='contact_window_conflict_create_new' title='{{ create_new_tooltip }}' class='pageButtonGeneric buttonColorBlue ml-2' type='button' value='{{ create_new_label }}' />" +
								'{{ /allow_create_new }}' +
							"</div>" +
						"</div>",

	// SEARCH CONTACT
	search_no_contact_msg_tpl : "<div class='noResultsMessage'>{{ message }}</div>",
	
	search_container_tpl : "<div id='contact_window_search_container' class='searchWindowContainer'>" +

								"<div id='contact_window_merge_title_container' class='contactAddressTitle' style='display:;'>" +
									"<a action_back='true' href='javascript:void(0);'><i class='far fa-chevron-left'></i></a>" +
									"<h3 action_title='true'>" + "{{ merge_title }}" + "</h3>" +
								"</div>" +

								// control
								"<div class='searchControlContainer'>" +
									// search input
									"<select class='form-control' id='contact_window_search_options'>" +
										// TO-DO: Do not hardcode this addresses types, should be come from somewhere else
										"<option value='name' selected>{{ search_by_name }}</option>"+
										"<option value='external_id'>{{ search_by_id }}</option>"+
										"<option value='Phone'>{{ search_by_address }} - {{ search_by_phone }}</option>"+
										"<option value='Mail'>{{ search_by_address }} - {{ search_by_mail }}</option>"+
										// TO-DO: Bring this option back when we can handle protocols the right way
										// "<option value="IM">Address - IM</option>"+
										// "<option value="Facebook'>{{ search_by_address }} - {{ search_by_facebook }}</option>"+
										"<option value='Instagram'>{{ search_by_address }} - {{ search_by_instagram }}</option>"+
										"<option value='Youtube'>{{ search_by_address }} - {{ search_by_youtube }}</option>"+
										"<option value='Appstore'>{{ search_by_address }} - {{ search_by_appstore }}</option>"+
										"<option value='Googleplay'>{{ search_by_address }} - {{ search_by_googleplay }}</option>"+
										"<option value='Twitter'>{{ search_by_address }} - {{ search_by_twitter }}</option>"+
									"</select>"+
									//search action button
									"<div class='searchControlInternalContainer'>" +
										"<input id='contact_window_search_input' class='form-control' type='text' placeholder='{{ search_placeholder }}' autofocus />" +
										"<button id='contact_window_search_button' class='butInteractionGeneric butInteractionOutlined' disabled ><i class='far fa-search'></i></button>" +
									"</div>" +
								"</div>" +
								// results
								"<div class='searchResultsContainer'>" +
									"<div id='contact_window_search_list' class='resultsList'>"+
									"</div>" +
								"</div>" +
								// actions
								"<div class='searchButtonContainer'>" +
									"<input id='contact_window_search_cancel' class='pageButtonGeneric buttonColorWhite' type='button' value='{{ search_cancel_label }}'/>" +
									"<input id='contact_window_search_associate' class='pageButtonGeneric buttonColorBlue' type='button' value='{{ search_associate_label }}' disabled />" +
								"</div>" +
						"</div>",

	contact_info_container_tpl : '' +
		"<div id='contact_window_{{ view }}' class='contactWindow'>" +

			// CONTACTO INFO
			"<div id='contact_window_container_{{ view }}' class='contactWindowContainer'>" +

				/* waiting */
				"<div id='contact_window_waiting_{{ view }}' class='contactInfoWaiting' hidden >" +
					"<div class='contactInfoWaitingAnima'></div>" +
					"<div class='contactInfoWaitingOverlay'></div>" +
				"</div>" +

				/* avatar / name / internal id */
				"<div id='contact_window_basic_info_container_{{ view }}' class='contactInfoContainer' >" +
					"<div class='contactAvatar'>" +
						"<img id='contact_window_basic_info_avatar_{{ view }}' src='{{ avatar_uri }}' height='36' width='36' />" +
					"</div>" +
					"<div class='contactName'>" +
						"<button class='butInteractionFavorites' id='contact_window_toggle_favorite_{{ view }}' {{ #hide_fav_btn }} hidden {{ /hide_fav_btn }} ></button>"+
						"<label id='contact_window_contact_name_{{ view }}' class='contactNameText'>{{ contact_name }}</label>" +
					"</div>" +

					/* name edit button */
					"<button id='contact_window_name_edit_button_{{ view }}' class='butInteractionGeneric'><i class='far fa-pencil'></i></button>"+

					/* name edit control */
					"<input id='contact_window_name_editable_{{ view }}' class='form-control' type='text' placeholder='Contact Name' hidden />" +
					"<button id='contact_window_name_edit_save_{{ view }}' class='butInteractionGeneric butInteractionOutlined' type='button' hidden ><i class='far fa-check'></i></button>"+
					"<button id='contact_window_name_edit_cancel_{{ view }}' class='butInteractionGeneric butInteractionOutlined' type='button' hidden><i class='far fa-ban'></i></button>"+
				"</div>" +

				"<div id='contact_window_title_container_{{ view }}' class='contactAddressTitle' style='display:none;'>" +
					"<a action_back='true' href='javascript:void(0);'><i class='far fa-chevron-left'></i></a>" +
					"<h3 action_title='true'>" + "Titulo" + "</h3>" +
				"</div>" +

				// ADDRESSES
				"<div id='contact_window_addressess_container_{{ view }}' class='contactAddressContainer'>" +
					"<div class='contactAddressInternalContainer'>" +
						/* Address list */
						"<div id='contact_window_address_list_{{ view }}' class='addressList'>"+
							"<div id='contact_window_addresses_empty_{{ view }}' class='noResultsMessage' {{ #hide_no_addresses_msg }}hidden{{ /hide_no_addresses_msg }}>{{ no_addresses_msg }}</div>" +
						"</div>" +
						/* Add New Address */
						"<button id='contact_window_add_address_button_{{ view }}' class='pageButtonGeneric buttonColorWhite' title='{{ add_address_tooltip }}' type='button' >{{ add_address_label }}</button>"+
					"</div>" +	
					"<div class='contactAddressMiddleContainer'>" +
						"<div class='contactAddressMiddleInternalContainer'>" +
							"<div id='contact_window_add_address_type_container_{{ view }}' hidden>" +
								"<label class='contactAddressLabel'>" + "<%=_T('Address Type')%>" + "</label>" +
								"<select id='contact_window_add_address_type_{{ view }}' class='form-control'>" +
									"<option value='Phone'>" + "<%=_T('Phone Number')%>" + "</option>"+
									"<option value='Mail'>" + "<%=_T('E-mail')%>" + "</option>"+
									"<option value='Twitter'>" + "<%=_T('Twitter username')%>" + "</option>"+
								"</select>"+
							"</div>" +

							// Phone Kind
							"<div id='contact_window_add_address_phone_kind_container_{{ view }}' hidden>" +
								"<label class='contactAddressLabel'>" + "<%=_T('Phone Type')%>" + "</label>" +
								"<select id='contact_window_add_address_phone_kind_{{ view }}' class='form-control'></select>" +
							"</div>" +

							/* Add New Address - Address protocol */
							"<div id='contact_window_add_address_protocol_container_{{ view }}' hidden>" +
								"<select id='contact_window_add_address_protocol_{{ view }}' class='form-control'>" +
									"<option value='prpl-yahoo'>Yahoo</option>"+
									"<option value='prpl-msn'>MSN</option>"+
									"<option value='prpl-jabber'>jabber/gtalk</option>"+
								"</select>"+
							"</div>" +

							/* Add New Address - Address */
							"<div id='contact_window_add_address_container_{{ view }}' hidden>" +
								"<label class='contactAddressLabel'>" + "<%=_T('Address')%>" + "</label>" +
								"<input id='contact_window_add_address_{{ view }}' class='form-control' type='text' />" +
							"</div>" +

							// Phone Country & Area
							"<div id='contact_window_add_address_phone_country_area_container_{{ view }}' hidden>" +
								// Country
								"<label class='contactAddressLabel'>" + "<%=_T('Country')%>" + "</label>" +
								"<select id='contact_window_add_address_phone_country_{{ view }}' class='form-control'></select>" +
								// Area
								"<label class='contactAddressLabel'>" + "<%=_T('Area')%>" + "</label>" +
								"<select id='contact_window_add_address_phone_area_{{ view }}' class='form-control'></select>" +
							"</div>" +
						"</div>" +
						/* Add New Address - Save/Cancel */
						"<div id='contact_window_address_actions_container_{{ view }}' class='addressButtonsContainer' hidden >" +
							"<div class='d-flex justify-content-end'>" +
								"<input class='pageButtonGeneric buttonColorWhite' id='contact_window_add_address_cancel_{{ view }}' title='{{ cancel_address_tooltip }}' type='button' value='" + "<%=_T('Cancel')%>" + "' hidden />" +
								"<input class='pageButtonGeneric buttonColorBlue' id='contact_window_add_address_save_{{ view }}' title='{{ save_address_tooltip }}' type='button' value='" + "<%=_T('Add')%>" + "' hidden disabled />" +
							"</div>" +
						"</div>" +
					"</div>" +
				"</div>" +
				
				/* EXTERNAL ID */
				"<div id='contact_window_external_id_container_{{ view }}' class='contactIdsContainer'>" +
					"<label class='externalIdLabel'>{{ external_id_label }}" + "<%=_T(':')%>" + "</label>" +
					/* editable input */
					"<input id='contact_window_external_id_editable_{{ view }}' class='form-control externalIdField externalIdField-ro' disabled type='text' " +
						"value='{{ #has_external_id }}{{ external_id }}{{ /has_external_id }}{{ ^has_external_id }}N/A{{ /has_external_id }}'/> " +
					/* edit id */
					"<button id='contact_window_external_id_edit_{{ view }}' class='butInteractionGeneric butInteractionOutlined' value='{{ edit }}'><i class='far fa-pencil'></i></button>" +
					/* save & cancel */
					"<button id='contact_window_external_id_save_{{ view }}' class='butInteractionGeneric butInteractionOutlined' hidden ><i class='far fa-check'></i></button>" +
					"<button id='contact_window_external_id_cancel_{{ view }}' class='butInteractionGeneric butInteractionOutlined' hidden ><i class='far fa-ban'></i></button>" +
				"</div>" +

				// Followers
				'{{ #show_followers_container }}' +
				"<div id='contact_window_followers_total_container_{{ view }}' class='contactIdsContainer'>" +
					"<label class='externalIdLabel'><%=_T('Twitter Followers')%><%=_T(':')%> {{ totalFollowers }} ({{followersDate}})</label>" +
				"</div>" +
				'{{ /show_followers_container }}'+

				/* contact actions */
				"<div id='contact_window_contact_actions_{{ view }}' class='contactButtonsContainer'>" +
					"<div>" +
						"<button class='butInteractionGeneric butInteractionOutlined' title='{{ merge_tooltip }}' id='contact_window_merge_{{ view }}' {{ #hide_merge_btn }} hidden {{ /hide_merge_btn }} ><i class='far fa-code-merge'></i></button>" +
						"<button class='butInteractionGeneric butInteractionOutlined' title='{{ change_tooltip }}' id='contact_window_change_{{ view }}' {{ #hide_change_btn }} hidden {{ /hide_change_btn }} ><i class='far fa-user-cog'></i></button>" +
						"<button class='butInteractionGeneric butInteractionOutlined' title='{{ delete_tooltip }}' id='contact_window_delete_{{ view }}' {{ #hide_delete_btn }} hidden {{ /hide_delete_btn }} ><i class='far fa-trash-alt'></i></button>" +
					"</div>" +
					"<div>" +
						"<input class='pageButtonGeneric buttonColorWhite'  title='{{ cancel_close_tooltip }}' type='button' id='contact_window_cancel_{{ view }}' value='{{ cancel_close_label }}' {{ #hide_cancel_close_btn }} hidden {{ /hide_cancel_close_btn }} />" +
						"<input class='pageButtonGeneric buttonColorBlue'  title='{{ save_create_tooltip }}' type='button' id='contact_window_save_{{ view }}' value='{{ save_create_label }}' {{ #disable_save_create }} disabled {{ /disable_save_create }} />" +
					"</div>" +
				"</div>" +
			"</div>" +
		"</div>",

	twitter_header_tpl : '' +
		"<div class='contactHighlights'>" +
			"<div class='highlightItem'>" +
				"<label class='itemNumber'> {{ followers_count }} </label>" +
				"<label class='itemText'> {{ followers_text }} </label>" +
			"</div>" +
			"<div class='highlightItem'>" +
				"<label class='itemNumber'> {{ following_count }} </label>" +
				"<label class='itemText'> {{ following_text }} </label>" +
			"</div>" +
			"<div class='highlightItem'>" +
				"<label class='itemNumber'> {{ tweets_count }} </label>" +
				"<label class='itemText'> {{ tweets_text }} </label>" +
			"</div>" +

			'{{#twitterContactAccount}}' +
				"<div class='highlightItem'>" +
					"<label class='itemNumber'>{{ twitter_accounts }}</label>" +
					"<label class='itemText'> {{ twitter_accounts_text }} </label>" +
				"</div>" +
			'{{/twitterContactAccount}}' +
		"</div>"
};

if ( !inConcert.ContactInformationTemplates ) {
	inConcert.ContactInformationTemplates = Templates;
}
}());
