/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:single, esversion: 11 */

/* global $, inConcert */

/*
    ---Apps selector: 
    Interactions, Administration, Outbound Engine, Reports Designer, Supervisor, Analytics, Reports, Social Networks
    Batch Management, HelpDesk, Applications Launcher, Agents Monitoring
*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	'use strict';
	
	/**
	Class apps popup.
	*/
	function DashboardAppsPopup(params)
	{
		params = params || {};
		params.parentNode = $('#dashboard_apps_selector');
		params.ownerId = 'dashboard_apps_menu_container';
		params.canReposition = true;
		params.eventName = '_dashboard_apps';
		
		DashboardAppsPopup.uber.constructor.call(this, params);
		this.owner = params && params.owner || undefined;
		this.initializeDashboardsApps();
	}

	inConcert.Utils.inherit(DashboardAppsPopup, inConcert.PopupWindow);
	
	if (typeof inConcert.DashboardAppsPopup !== 'function') {
		inConcert.DashboardAppsPopup = DashboardAppsPopup;
	}

	/*******************************************************************
	 * Metodo que setea eventos de los controles
	 */
	DashboardAppsPopup.prototype.set_events = function()
	{
	};

	/*******************************************************************
	 * Metodo que crea el markup contenedor
	 */
	DashboardAppsPopup.prototype.create_markup = function()
	{
		const container_id = this.ownerId;
		$('#' + container_id).remove();
		const $node = $(
			`<div id="${container_id}" class="quickMenuBlind quickAppsBlind" style="display:none;">
				<ul id="dashboard_apps_menu" class="appsListContainer">
					<div class="appsGroupContainer"><li dashboard_item="interaction"><img src="/inconcert/apps/agent/images/modules-icons/interactions-module-icon.svg" /><%=_T("Interactions")%></li><li dashboard_item="supervisor"><img src="/inconcert/apps/agent/images/modules-icons/supervisor-module-icon.svg" /><%=_T("Supervisor")%><div alarm_number_container="true" class="alertsNotifyNumberContainer" style="display:none;"><label alarm_unread_number="0" class="alertsNotifyLiveUnreadEvents"></label><label alarm_live_number="0" class="alertsNotifyLiveEvents"></label></div></li><li dashboard_item="configuration"><img src="/inconcert/apps/agent/images/modules-icons/administration-module-icon.svg" /><%=_T("Administration")%></li><li dashboard_item="helpdesk"><img src="/inconcert/apps/agent/images/modules-icons/helpdesk-module-icon.svg" /><%=_T("HelpDesk")%></li><li dashboard_item="outbound_engine"><img src="/inconcert/apps/agent/images/modules-icons/oe-module-icon.svg" /><%=_T("Outbound Engine")%></li><li dashboard_item="flow_designer"><img src="/inconcert/apps/agent/images/modules-icons/bots-module-icon.svg" /><%=_T("Bots & Automation")%></li><li dashboard_item="cognitive_services"><img src="/inconcert/apps/agent/images/modules-icons/cs-module-icon.svg" /><%=_T("Cognitive Services")%></li><li dashboard_item="web_designer"><img src="/inconcert/apps/agent/images/modules-icons/web-designer-module-icon.svg" /><%=_T("Web Designer")%></li></div>
					<div class="appsGroupContainer"><li dashboard_item="batch_management"><img src="/inconcert/apps/agent/images/modules-icons/batch-management-module-icon.svg" /><%=_T("Batch Management")%></li><li dashboard_item="campaign_analytics"><img src="/inconcert/apps/agent/images/modules-icons/analytics-module-icon.svg" /><%=_T("Analytics")%></li><li dashboard_item="monitoring"><img src="/inconcert/apps/agent/images/modules-icons/agents-monitoring-module-icon.svg" /><%=_T("Agents Monitoring")%></li><li dashboard_item="knowledge_base"><img src="/inconcert/apps/agent/images/modules-icons/kb-module-icon.svg" /><%=_T("Knowledge base")%></li><li dashboard_item="reports"><img src="/inconcert/apps/agent/images/modules-icons/reports-module-icon.svg" /><%=_T("Reports")%></li><li dashboard_item="report_design"><img src="/inconcert/apps/agent/images/modules-icons/reports-designer-module-icon.svg" /><%=_T("Reports Designer")%></li><li dashboard_item="apps_launcher"><img src="/inconcert/apps/agent/images/modules-icons/app-launcher-module-icon.svg" /><%=_T("Applications Launcher")%></li><li dashboard_item="social_networks"><img src="/inconcert/apps/agent/images/modules-icons/social-networks-module-icon.svg" /><%=_T("Social Networks")%></li></div>
				</ul>
			</div>`
		);

		$('body').append($node);
		return $node;
	};

	DashboardAppsPopup.prototype.destroy = function(params) {
		this.finalize(params);
		this.data.container.remove();
	};

	DashboardAppsPopup.prototype.initializeDashboardsApps = function() {
		
		this.data.container = this.create_markup();
		this.set_events();
		const self = this;
		const $body = $('body');
		const $dashboard_apps_menu = $(`#${this.ownerId}`);
		const skinName2010 = 'skinNew';
		const skinName2021 = 'skinOCCNew';
		let dashboard_items;
		let hnd_waiting = null;

		const on_enter_app = function(app)
		{
			let dashboard_item = dashboard_items[app];
			if (dashboard_item) {
				const windowManager = inConcert.app.getWindowManager();
				let skinName = dashboard_item.get_skin();
				windowManager.applySkin(window, skinName);
			}
			//////////
			const hide = function() {
				window.clearTimeout(hnd_waiting);
				hnd_waiting = null;
				inConcert.app.getMainWindow().hideGenericWaiting();
			};
			if (hnd_waiting) {
				hide();
				return;
			}
			hnd_waiting = window.setTimeout(function() {
				hide();
			}, 500);
		};

		// function used to render a generic dashboard
		let previous_dashboard_name;
		const changeSelectorAppName = function(app) {
			let dashboard_item = (dashboard_items || {})[app];
			if (dashboard_item) {
				$('#dashboard_apps_selector_title').text(dashboard_item.name);
			}
		};
		const default_render_function = function(dashboard_name) {
			self.finalize(); //Ocultar el dropdown de apps
			changeSelectorAppName(dashboard_name);
			inConcert[dashboard_name].render(function() {
				on_enter_app(dashboard_name);
			});
		};

		var canEnter = function() {
			return {success: true};
		};

		// Para saber si tiene que cargar el CSS de helpdesk tickets
		const navigation = this.owner.get_navigation();
		const can_show_helpdesk_tickets_in_app_interaction = navigation.can_show_integration_helpdesk_tickets();

		// all known dashboard items
		dashboard_items = {
			interaction: {
				dom_app_container_id: 'interaction_dashboard',
				name:'<%=_T("Interactions")%>',
				hasPermission: function() {
					return inConcert.permissions.to_application('interaction');
				},
				enter: function(dashboard_name) {
					self.finalize(); //Ocultar el dropdown de apps
					changeSelectorAppName(dashboard_name);
					$('#interaction_dashboard').show();
					self.owner.m_panels.conversations_panel.enter();
					on_enter_app(dashboard_name);
				},
				leave: $.noop,
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					let css_to_include = [];
					if (can_show_helpdesk_tickets_in_app_interaction) {
						css_to_include.push({id: 'helpdesk_tickets_css', href: '/inconcert/apps/helpdesk/css/helpdeskCommon.css#grunt-cache-bust'});
					}
					return css_to_include;
				},
				onShownTab: $.noop,
				onRemoved: function() {
					$body.removeClass('withoutQuickbar').addClass('withoutQuickbar');
					$('#interactionsMenuTop').remove();
					$('#quickTakeQueuedContainer').remove();
					$('#quickInteractionActionsContainer').remove();
				},
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			configuration: { // 'administration'
				dom_app_container_id: 'configuration_dashboard',
				name:'<%=_T("Administration")%>',
				hasPermission: function() {
					if (!inConcert.configuration) {
						return false;
					}
					const has_permission = inConcert.configuration.can_show();
					if ( has_permission ) {
						inConcert.app.loadAllRoles();
					}
					return has_permission;
				},
				enter: default_render_function,
				leave: function() {
					if (inConcert.configuration) {
						inConcert.configuration.on_hide();
						inConcert.configuration.on_leave();
					}
				},
				get_skin: function() {
					return inConcert.configuration.get_skin();
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			supervisor: {
				dom_app_container_id: 'supervisor_main',
				name:'<%=_T("Supervisor")%>',
				application: 'supervisor',
				enter: default_render_function,
				leave: function() {
					inConcert.supervisor.on_leave();
				},
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [
						{ id: 'ejs_chart_css',       href: '/inconcert/lib/ejschart-developer_2_1/dist/EJSChart.css#grunt-cache-bust'                    },
						//{ id: 'inconcert_chart_css', href: '/inconcert/apps/supervisor/css/inconcertCharts.css#grunt-cache-bust'                       },
						//{ id: 'supervisor_css',      href: '/inconcert/apps/supervisor/css/supervisorMaster.css#grunt-cache-bust'                      },
						{ id: 'messages_tooltips_css' , href: '/inconcert/apps/agent/css/skin-2021/genericMessagesAndTooltips.css#grunt-cache-bust'      },
						{ id: 'master_buttons_css'  , href: '/inconcert/apps/agent/css/skin-2021/masterButtons.css#grunt-cache-bust'                     },
						{ id: 'generic_dialog_css'  , href: '/inconcert/apps/agent/css/skin-2021/genericDialogMaster.css#grunt-cache-bust'               },
						{ id: 'sup_conf_css',        href: '/inconcert/apps/configuration/css/skin-2021/masterInternalPageLayout.css#grunt-cache-bust'   },
						{ id: 'sup_form_css',        href: '/inconcert/apps/configuration/css/skin-2021/masterInternalPageForms.css#grunt-cache-bust'    }
					];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			reports: {
				dom_app_container_id: 'reports_dashboard',
				name:'<%=_T("Reports")%>',
				hasPermission: function() {
					if (!inConcert.reports) {
						return false;
					}
					return inConcert.reports.dashboard.can_show();
				},
				enter: function(dashboard_name) {
					self.finalize(); //Ocultar el dropdown de apps
					changeSelectorAppName(dashboard_name);
					if (inConcert.reports) {
						inConcert.reports.dashboard.render();
					}
					on_enter_app(dashboard_name);
				},
				leave: $.noop,
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [
						//{ id: 'reports_master_css'  , href: '/inconcert/apps/reports/css/skin-2021/reportsMaster.css#grunt-cache-bust'                     },
						{ id: 'master_buttons_css'  , href: '/inconcert/apps/agent/css/skin-2021/masterButtons.css#grunt-cache-bust'                       },
						//{ id: 'internal_layout_css' , href: '/inconcert/apps/configuration/css/skin-2021/masterInternalPageLayout.css#grunt-cache-bust'  },
						{ id: 'internal_forms_css' , href: '/inconcert/apps/configuration/css/skin-2021/masterInternalPageForms.css#grunt-cache-bust'      },
						{ id: 'messages_tooltips_css' , href: '/inconcert/apps/agent/css/skin-2021/genericMessagesAndTooltips.css#grunt-cache-bust'        },
						//{ id: 'reports_designer_css', href: '/inconcert/apps/reports/css/skin-2021/reportsDesigner.css#grunt-cache-bust'                   }
					];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			social_networks: {
				dom_app_container_id: 'social_networks_dashboard',
				name:'<%=_T("Social Networks")%>',
				hasPermission: function() {
					if (!inConcert.social_networks) {
						return false;
					}
					return inConcert.social_networks.can_show();
				},
				enter: default_render_function,
				leave: $.noop,
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [
						{ id: 'master_internal_forms_css'  , href: '/inconcert/apps/configuration/css/skin-2021/masterInternalPageForms.css#grunt-cache-bust'     }
					];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			batch_management: {
				dom_app_container_id: 'batch_management_dashboard',
				name:'<%=_T("Batch Management")%>',
				hasPermission: function() {
					if (!inConcert.batch_management) {
						return false;
					}
					return inConcert.batch_management.can_show();
				},
				enter: default_render_function,
				leave: $.noop,
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [
						{ id: 'master_internal_forms_css'  , href: '/inconcert/apps/configuration/css/skin-2021/masterInternalPageForms.css#grunt-cache-bust'     }
					];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			helpdesk: {
				dom_app_container_id: inConcert.helpdesk_dashboard ? inConcert.helpdesk_dashboard.get_container_id() : '',
				name:'<%=_T("HelpDesk")%>',
				hasPermission: function() {
					if (!inConcert.helpdesk_dashboard) {
						return false;
					}
					return inConcert.helpdesk_dashboard.can_show();
				},
				enter: function(dashboard_name) {
					self.finalize(); //Ocultar el dropdown de apps
					changeSelectorAppName(dashboard_name);
					if (inConcert.helpdesk_dashboard) {
						inConcert.helpdesk_dashboard.render(previous_dashboard_name);
					}
					on_enter_app(dashboard_name);
				},
				leave: function() {
					if (inConcert.helpdesk_dashboard) {
						inConcert.helpdesk_dashboard.on_leave();
					}
				},
				get_skin: function() {
					return skinName2010;
				},
				css: function() {
					return [
						{ id: 'helpdesk_dashboard_css', href: '/inconcert/apps/helpdesk/css/helpdeskCommon.css#grunt-cache-bust' }
					];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: function($app_button) {
					$app_button.removeClass('disabledMenuItem')
						.removeClass('infoMenuItem');
					$app_button.removeAttr('title');
					const has_license = inConcert.helpdesk_dashboard.has_license();
					if (has_license) {
						$app_button.prop('disabled', false);
						return;
					}
					$app_button.prop('disabled', true);
					$app_button.addClass('disabledMenuItem')
						.addClass('infoMenuItem');
					$app_button.attr('title', '<%=_T("There are no licenses available to view the HelpDesk application")%>');
				},
				canEnter: function() {
					return {
						success: inConcert.helpdesk_dashboard.has_license(),
						error_msg: '<%=_T("Unable to show HelpDesk application view: There are no licenses available.")%>'
					};
				}
			},
			apps_launcher: {
				dom_app_container_id: 'apps_launcher_dashboard',
				name:'<%=_T("Applications Launcher")%>',
				hasPermission: function() {
					if (!inConcert.apps_launcher_dashboard) {
						return false;
					}
					return inConcert.apps_launcher_dashboard.can_show();
				},
				enter: function(dashboard_name) {
					self.finalize(); //Ocultar el dropdown de apps
					changeSelectorAppName(dashboard_name);
					if (inConcert.apps_launcher_dashboard) {
						inConcert.apps_launcher_dashboard.render();
					}
					on_enter_app(dashboard_name);
				},
				leave: function() {
					if (inConcert.apps_launcher_dashboard) {
						inConcert.apps_launcher_dashboard.on_leave();
					}
				},
				get_skin: function() {
					return skinName2010;
				},
				css: function() {
					return [
						{ id: 'apps_launcher_master_css', href: '/inconcert/apps/apps_launcher/css/appsLauncherMaster.css#grunt-cache-bust' }
					];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			campaign_analytics: {
				dom_app_container_id: 'campaign_analytics_dashboard',
				name:'<%=_T("Analytics")%>',
				hasPermission: function() {
					if (!inConcert.campaign_analytics) {
						return false;
					}
					return inConcert.campaign_analytics.can_show();
				},
				enter: default_render_function,
				leave: function() {
					inConcert.campaign_analytics.on_leave();
				},
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			monitoring: {
				name:'<%=_T("Agents Monitoring")%>',
				hasPermission: function() {
					if (!inConcert.app_monitoring) {
						return false;
					}
					return true;
				},
				enter: default_render_function,
				leave: function() {
					inConcert.monitoring.on_leave($.noop);
				},
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			outbound_engine: {
				dom_app_container_id: 'outbound_engine_dashboard',
				name:'<%=_T("Outbound Engine")%>',
				hasPermission: function() {
					if (!inConcert.outbound_engine) {
						return false;
					}
					const has_permission = inConcert.outbound_engine.can_show();
					if ( has_permission && !inConcert.app.cached_roles) {
						inConcert.app.loadAllRoles();
					}
					return has_permission;
				},
				enter: default_render_function,
				leave: function() {
					if (inConcert.outbound_engine) {
						inConcert.outbound_engine.on_hide();
					}
				},
				get_skin: function() {
					return inConcert.outbound_engine.get_skin();
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			report_design: {
				dom_app_container_id: 'report_design_dashboard',
				name:'<%=_T("Reports Designer")%>',
				hasPermission: function() {
					if (!inConcert.report_design) {
						return false;
					}
					const has_permission = inConcert.report_design.can_show();
					if ( has_permission && !inConcert.app.cached_roles ) {
						inConcert.app.loadAllRoles();
					}
					return has_permission;
				},
				enter: default_render_function,
				leave: function() {
					if (inConcert.report_design) {
						inConcert.report_design.on_hide();
					}
				},
				get_skin: function() {
					return inConcert.report_design.get_skin();
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			web_designer: {
				dom_app_container_id: 'web_designer_dashboard',
				name:'<%=_T("Web Designer")%>',
				hasPermission: function() {
					if (!inConcert.web_designer) {
						return false;
					}
					return inConcert.web_designer.can_show();
				},
				enter: default_render_function,
				leave: function() {
					if (inConcert.web_designer) {
						inConcert.web_designer.on_hide();
						inConcert.web_designer.on_leave();
					}
				},
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			flow_designer: {
				dom_app_container_id: 'flow_designer_dashboard',
				name:'<%=_T("Bots & Automation")%>',
				hasPermission: function() {
					if (!inConcert.flow_designer) {
						return false;
					}
					return inConcert.flow_designer.can_show();
				},
				enter: default_render_function,
				leave: function() {
					if (inConcert.flow_designer) {
						inConcert.flow_designer.on_hide();
						inConcert.flow_designer.on_leave(() => {
							inConcert.adm_process_flow_popup.prototype.Close();
							$('#overlay_flowDesignerPopup').remove();
						});
					}
					inConcert.adm_process_flow_popup.prototype.Close();
					$('#overlay_flowDesignerPopup').remove();
				},
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			cognitive_services: {
				dom_app_container_id: 'cognitive_services_dashboard',
				name:'<%=_T("Cognitive Services")%>',
				hasPermission: function() {
					if (!inConcert.cognitive_services) {
						return false;
					}
					return inConcert.cognitive_services.can_show();
				},
				enter: default_render_function,
				leave: function() {
					if (inConcert.cognitive_services) {
						inConcert.cognitive_services.on_hide();
						inConcert.cognitive_services.on_leave();
					}
				},
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
			knowledge_base: {
				dom_app_container_id: 'knowledge_base_dashboard',
				name:'<%=_T("Knowledge base")%>',
				hasPermission: function() {
					if (!inConcert.knowledge_base) {
						return false;
					}
					return inConcert.knowledge_base.can_show();
				},
				enter: default_render_function,
				leave: function() {
					if (inConcert.knowledge_base) {
						inConcert.knowledge_base.on_hide();
						inConcert.knowledge_base.on_leave();
					}
				},
				get_skin: function() {
					return skinName2021;
				},
				css: function() {
					return [];
				},
				onShownTab: $.noop,
				onRemoved: $.noop,
				customActionsToButton: $.noop,
				canEnter: canEnter
			},
		};

		var hide_all_apps_sections = function() {
			$('#inboxMainContainerTop [app_content_container]').hide();
		};

		var disable_all_apps_sections = function()
		{
			// hide all sections panels (interaction, supervisor, configuration, reports, ..)
			hide_all_apps_sections();

			self.owner.showPopupMessage({
				message :     '<%=_T("You dont have permissions to access to any application. Please contact to your administrator.")%>',
				messageTitle: '<%=_T("Will close the session!")%>',
				popUpTitle:   '',
				messageType:  'Error',
				callback: function() {
					$('#headerCloseButton').trigger('click');
				}
			});
		};

		// initial dashboard item
		let $selected_tab_dashboard;

		$dashboard_apps_menu.find('li[dashboard_item]').bind('click', function()
		{
			const $new_selected_dashboard = $(this);
			if ($new_selected_dashboard.hasClass('selected')) {
				return;
			}

			let new_selected_dashboard_name = $new_selected_dashboard.attr('dashboard_item');
			let new_selected_dashboard_item = dashboard_items[new_selected_dashboard_name]; // must be a known dashboard
			let can_enter;

			if ($selected_tab_dashboard) {
				can_enter = new_selected_dashboard_item.canEnter();
				if (can_enter.success) {
					let current_dashboard_name = $selected_tab_dashboard.attr('dashboard_item');
					previous_dashboard_name = current_dashboard_name;
					let current_dashboard_item = dashboard_items[current_dashboard_name]; // must be a known dashboard

					if (typeof current_dashboard_item.leave === 'function') {
						current_dashboard_item.leave(current_dashboard_name);
					}

					$selected_tab_dashboard.removeClass('selected');
					$.each( current_dashboard_item.css() , function(undefined, config) {
						inConcert.Utils.css.remove(config.id);
					});
				}
			}

			can_enter = can_enter || new_selected_dashboard_item.canEnter();
			if (!can_enter.success) {
				if (can_enter.error_msg) {
					inConcert.app.m_mainWindow.showBannerMessage({
						message: can_enter.error_msg,
						timeout: 5000
					});
				}
				return;
			}

			hide_all_apps_sections();

			$selected_tab_dashboard = $new_selected_dashboard;
			$selected_tab_dashboard.addClass('selected');
			$.each( new_selected_dashboard_item.css(), function(undefined, config) {
				inConcert.Utils.css.add(config);
			});

			inConcert.app.setCurrentApp(new_selected_dashboard_name);

			if (typeof(new_selected_dashboard_item.enter) === 'function') {
				new_selected_dashboard_item.enter(new_selected_dashboard_name);
			}
		});

		var showAppButton = function($app_button, data) {
			$app_button.show();
			if (!$selected_tab_dashboard) {
				$selected_tab_dashboard = $app_button;
			}
			data.onShownTab();
		};

		var removeDOMApp = function($app_button, data)
		{
			$app_button.remove(); // remuevo el boton/tab de acceso a la app.
			 // Aca remuevo el container de la app.
			const dom_app_container_id = data.dom_app_container_id;
			if (dom_app_container_id) {
				const $app_container = $('#' + dom_app_container_id);
				if ($app_container.length === 0) {
					throw('removeDOMApp-> Unexist DOM container: ' + dom_app_container_id);
				}
				$app_container.remove();
			}
			data.onRemoved();
		};

		// show dashboards this user has permissions to use
		$.each(dashboard_items, function(item, data)
		{
			const app_id = data.application;
			const hasPermissionFn = data.hasPermission;
			const $app_button = $dashboard_apps_menu.find('[dashboard_item="' + item + '"]');

			if ( (typeof hasPermissionFn === 'function') ) {
				if ( hasPermissionFn() ) {
					showAppButton($app_button, data);
				}
				else {
					removeDOMApp($app_button, data);
				}
				return true; // continue
			}

			if ( typeof app_id !== 'string' ) {
				removeDOMApp($app_button, data);
				return true; // continue
			}
			if (inConcert.permissions.to_application(app_id)) {
				showAppButton($app_button, data);
			}
			else {
				removeDOMApp($app_button, data);
			}
		});

		// Aplico customs actions (atributos a los botones.
		$.each(dashboard_items, function(item, data)
		{
			const $app_button = $dashboard_apps_menu.find('[dashboard_item="' + item + '"]');
			if (!$app_button || $app_button.length === 0) {
				return true; // continue
			}
			data.customActionsToButton($app_button);
		});

		if ($selected_tab_dashboard) {
			$selected_tab_dashboard.trigger('click');
		}
		else {
			disable_all_apps_sections();
		}
		
	};

	DashboardAppsPopup.prototype.applyZindex = function() {
		let total = inConcert.app.m_mainWindow.getTotalIframesWindowsDialogs() || 3;
		let zindex = (total * 10) + 1001;
		this.m_inlineStyleValues['z-index'] = zindex;
		DashboardAppsPopup.uber.applyZindex.call(this);
	};
}());
