/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if ( !this.inConcert ) {
	this.inConcert = {};
}
if (!inConcert.templates) {
	inConcert.templates = {};
}

(function () {

'use strict';

var TwitterClient = {

	tweet : '<div class="twitterThreadEvent {{ event_class }} " data-id="{{id}}" >' +

				'<div class="twitterThreadEventTypeLabel" hidden>' +
					'<span class="privateMessageLabel"><%=_T("Private Message")%></span>' +
				'</div>' +
				'<div class="twitterThreadEventAvatar">' +
					'<object crossorigin="anonymous" data="{{ avatar }}" type="image/png">' +
						'<img src="{{ genericAvatar }}"/>' +
					'</object>' +
				'</div>' +

				// we make contact linkeable if we have contact management enabled
				'{{ #contact_management_enabled }}' +
					'<a href="javascript:void(0);" class="eventAuthor">{{ author }}</a>' +
				'{{ /contact_management_enabled }}' +
				// otherwise it is just a label
				'{{ ^contact_management_enabled }}' +
					'<label class="eventAuthor">{{ author }}</label>' +
				'{{ /contact_management_enabled }}' +

				// text could contains <a> tags, so we tell
				// mustache to not scape this this field.
				'<label message_text="true" class="eventMessage">{{{ text }}}</label>' +
				'{{{ media }}}' +
				'{{{ location }}}' +
				'<div class="mt-2">' +
				'<div class="twitterThreadActions">' +
					'<label class="eventDate">{{ date }}</label>' +
				'</div>' +
				'{{{ quoted }}}' +
			'</div>',

	quoted :	'<div class="quoteTweetContainer">' + 
					'<div class="quoteTweetTypeIcon" hidden></div>' +
					'<div class="quoteTweetAvatar">' +
						'<object data="{{ avatar }}" type="image/png">' +
							'<img src="{{ genericAvatar }}"/>' +
						'</object>' +
					'</div>' +
					'<div class="quoteTweetContent">' +
						'<div class="quoteTweetAuthor">' +
							'{{ author }}' + 
						'</div>' +
						'<div class="quoteTweetText">' +
							'<label message_text="true" class="eventMessage">{{{ text }}}</label>' +
						'</div>' +
					'</div>' +
					'<div class="quoteTweetMedia">' +
						'{{{ media }}}' + 
					'</div>' +
				'</div>',

	retweet :	'<label class="retweetOriginAuthor">{{ name }}</label>' +
				'<label class="retweetOriginMessage">{{ text }}</label>',

	response : '<label class="retweetOriginMessage">{{ label }}</label>'+
			   '<label id="reply_users_destination" class="retweetOriginAuthor">{{ users_destination }}</label>' ,

	button : '<a href="javascript:void(0);" class="{{ class_name }}" index="{{ index }}" title="{{ tooltip }}" hidden>{{ description }}</a>',

	select_replies : ''.concat(
		'<div class="selectRecipientsPopup">',
			'<div class="selectRecipientsPopupTop">',
				'<span id="ui-id-1" class="ui-dialog-title">',
					"<%=_T('Reply to')%>",
				'</span>',
			'</div>',
			'<div class="selectRecipientsPopupMiddle">',
				'<div sender class="senderContainer">',
				'</div>',
				'<div allMentionsContainer class="selectAllMentionsContainer">',
					'<label class="selectAllMentionsLabel" for="selectAllMentions">',
						"<%=_T('Others in this conversation')%>",
					'</label>',
					'<input selectAllMentions class="selectAllMentions" id="selectAllMentions" type="checkbox">',
				'</div>',
				'<div mentionsList class="selectRecipientsMentionsList">',
				'</div>',
			'</div>',
			'<div class="selectRecipientsPopupBottom">',
				'<button confirm_button class="buttonColorBlack twitterClientPostButton">',
					"<%=_T('Update')%>",
				'</button>',
				'<button close_button class="twitterClientCancelButton buttonColorGray">',
					"<%=_T('Cancel')%>",
				'</button>',
			'</div>',
		'</div>'
	),
	select_replies_reply : ''.concat(
		'<div class="selectRecipientsEntry">',
			'<div class="selectRecipientsEntryAvatar" for="selectMention{{ id }}">',
				'<object data="{{ avatar }}" type="image/png">',
					'<img src="{{ genericAvatar }}"/>',
				'</object>',
			'</div>',
			'<div class="selectRecipientsEntryAuthor" for="selectMention{{ id }}">',
				'<label class="selectRecipientsEntryAuthorName">',
					'{{ name }}',
				'</label>',
				'<label class="selectRecipientsEntryAuthorUser">',
					'@{{ user }}',
				'</label>',
			'</div>',
			'<div class="selectMentionContainer">',
				'{{ #mention }}',
					'<input selectMention="{{ id }}" class="selectMention" id="selectMention{{ id }}" type="checkbox">',
				'{{ /mention }}',
			'</div>',
		'</div>'
	)
};

if ( !inConcert.templates.twitter_client_window ) {
	inConcert.templates.twitter_client_window = TwitterClient;
}
}());

