local allegro = require "apps.allegro.proxy"

module(..., package.seeall, inconcert.orbit.application.Decorate)

m_htmlRender = nil
m_appLocation = nil

function MapUris (module, htmlRender, prefix, appLocation)
	m_htmlRender = htmlRender
	m_appLocation = appLocation
end

function HasIntegration ( vcc_id ) return allegro.HasIntegration(vcc_id) end

--[[
  Guarda skills en 5.5
]]--
function Save ( skills_omnichannel, vcc_id )

	assert(type(skills_omnichannel) == "table")

	if not HasIntegration(vcc_id) then
		LogWarning("[ALLEGRO.SKILLS:Save] Error saving allegro skills. VCC '%s' Without integration", vcc_id)
		return true -- no es un error
	end

	local encoded_skills_omnichannel = json.encode(skills_omnichannel)
	LogInfo("[ALLEGRO.SKILLS:Save] encoded skills: %s", encoded_skills_omnichannel)

	local success, allegro_err = allegro.Post(
		vcc_id,
		encoded_skills_omnichannel,
		"administration/skills/save/" -- la URL de 5.5
	)

	local err
	if not success then
		err = { type = "ALLEGRO_INTEGRATION_ERROR", sub_type = allegro_err }
		LogWarning("[ALLEGRO.SKILLS:Save] Error saving allegro skills: %s. Err: %s.", encoded_skills_omnichannel, json.encode(err))
	end

	return success, err
end

--[[
  Elimina los skills en 5.5
]]--
function Delete ( skills_omnichannel, vcc_id )

	assert(type(vcc_id) == "string")

	local encoded_skills_omnichannel = json.encode(skills_omnichannel)

	LogInfo("[ALLEGRO.SKILLS:Delete] Deleting allegro skills '%s'", encoded_skills_omnichannel)

	if not HasIntegration(vcc_id) then
		LogWarning("[ALLEGRO.SKILLS:Delete] Error deleting allegro skills. VCC '%s' Without integration", vcc_id)
		return true -- no es un error
	end

	local success, allegro_err = allegro.Post(
		vcc_id,
		encoded_skills_omnichannel,
		"administration/skills/delete/" -- la URL de 5.5
	)

	local err
	if not success then
		err = { type = "ALLEGRO_INTEGRATION_ERROR", sub_type = allegro_err }
		if allegro_err.result == "NOT_FOUND" then
			err.type = "NOT_A_ERROR"
		end
		LogWarning("---> [ALLEGRO.SKILLS:Delete] Error deleting allegro skills: %s. Err: %s.", encoded_skills_omnichannel, json.encode(err))
	end

	return success, err
end
