local utils = require "shared.apps.utils"
module(..., package.seeall, inconcert.orbit.application.Decorate)

local function __Search (vcc, encodedInfo, url, contentType)
	vcc = vcc or inconcert.authUser.virtualContactCenter
	local allegro = require "apps.allegro.proxy"
	return allegro.Post(vcc, encodedInfo, url, contentType)
end

function Search (url, encodedInfo, vcc, contentType)
	local info = utils.JSON_Decode(encodedInfo)
	vcc = vcc or info.vcc or inconcert.authUser.virtualContactCenter
	--LogInfo("[ALLEGRO.SHARED_VIEW:Search] Searching - vcc: '%s', url: '%s', info: '%s'.", vcc, url, encodedInfo)
	local success, data = __Search(vcc, encodedInfo, url, contentType)
	if success and data then
		--LogInfo("[ALLEGRO.SHARED_VIEW:Search] Successfully Searched %d rows.", #data.paginated["0"])
		local response = {
			rows       = data.paginated["0"],
			lastRow    = data.paginated.__config.lastRow or "",
			total_rows = data.paginated.__config.numberOfRecords
		}
		return true, response
	end
	-- Error
	local err = data
	LogError("[ALLEGRO.SHARED_VIEW:Search] Error Searching. Err: '%s'.", json.encode(err))
	return false, err
end
