/*  jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.batchManagementAddresses) {
	inConcert.batchManagementAddresses = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function AddressesRCSPopup (batch)
	{
		AddressesRCSPopup.uber.constructor.call(this, batch);
	}

	inConcert.Utils.inherit(AddressesRCSPopup, inConcert.batchManagementAddresses.base);
	
	if (typeof inConcert.batchManagementAddresses.rcs !== "function") {
		inConcert.batchManagementAddresses.rcs = AddressesRCSPopup;
	}

	AddressesRCSPopup.prototype.__getClassName = function() {
		return "rcsBatch";
	};
	
	AddressesRCSPopup.prototype.__validatePhoneNumber = function(number) {
		// allow the agent to call a cab, but not Uruguay's Speaking clock
		return number.length > 2 && number.match(/^[\- \(\)\+0-9_.*#]+$/);
	};
	
	AddressesRCSPopup.prototype.__getAndValidateAddress = function(address_t) {
		return this.__validatePhoneNumber(address_t) && address_t.replace(/[^0-9#*\+]/g, "") || false;
	};

}());