/*  jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.batchManagementAddresses) {
	inConcert.batchManagementAddresses = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	const FORMAT = inConcert.Utils.format;

	function AddressesWhatsappPopup (batch)
	{
		AddressesWhatsappPopup.uber.constructor.call(this, batch);
	}

	inConcert.Utils.inherit(AddressesWhatsappPopup, inConcert.batchManagementAddresses.base);
	
	if (typeof inConcert.batchManagementAddresses.whatsapp !== "function") {
		inConcert.batchManagementAddresses.whatsapp = AddressesWhatsappPopup;
	}

	AddressesWhatsappPopup.prototype.__getClassName = function() {
		return "whatsappBatch";
	};

	AddressesWhatsappPopup.prototype.__validatePhoneNumber = function(number) {
		// allow the agent to call a cab, but not Uruguay's Speaking clock
		return number.length > 2 && number.match(/^[\- \(\)\+0-9_.*#]+$/);
	};
	
	AddressesWhatsappPopup.prototype.__getAndValidateAddress = function(address_t) {
		return this.__validatePhoneNumber(address_t) && address_t.replace(/[^0-9#*\+]/g, "") || false;
	};
	
	AddressesWhatsappPopup.prototype.__getIntegrationType = function() {
		var account = inConcert.app.getBatchesManager().GetAccountConfiguration(
			this.batch.campaign, this.batch.account);
		if (!account) {
			return "";
		}
		return account.integrationType || "WEB";
	};

	AddressesWhatsappPopup.prototype.__addDataAsync = function(data, callback) {
		if(this.__getIntegrationType() === "ICC_CLOUD_API") {
			let request = {
				campaignAtVCC : this.batch.campaign,
				account : this.batch.account
			};
			inConcert.app.getBatchesManager().WhatsappGetAccountLimitData(request, function(success, result) {
				if(success && result.active_messages_sent && result.message_limit && (result.active_messages_sent + data.addresses.length > result.message_limit)) {
					$.inconcertPopup.Show(
						"<%=_T('Confirm')%>",
						FORMAT("<%=_T('Batch length ({0}) will exceed available 24 hours messages limit ({1}), and some messages will have to wait before they can be sent. Continue?')%>", data.addresses.length, result.message_limit),
						$.inconcertPopup.ButtonSets.BS_YESNO,
						function(response) {
							callback(response.toLowerCase() === "yes");
						},
						undefined,
						{
							popup_id        : "conf_inconcertPopup",
							container_class : "confirmationPopUp",
							overlay_class   : "confirmationOverlay"
						}
					);
				}
				else {
					callback(true);
				}
			});			
		}
		else {
			callback(true);
		}
	};

}());