/*jshint quotmark:false*/
/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var format = inConcert.Utils.format;

	var actions = $.extend({}, inConcert.batchManagementActions.base, {
		EDIT		: null,
		RESCHEDULE	: null,
		PAUSE		: null,
		DELETE		: null
	});
	if (!inConcert.batchManagementActions.mail) {
		inConcert.batchManagementActions.mail = actions;
		$.each(actions, function(actionId, action) {
			inConcert.batchManagementActions.all[actionId] = inConcert.batchManagementActions.all[actionId] || action;
		});
	}

	function MailBatch (rawData)
	{
		MailBatch.uber.constructor.call(this, rawData);
	}

	inConcert.Utils.inherit(MailBatch, inConcert.batchManagement.base);
	if (typeof inConcert.batchManagement.mail !== "function") {
		inConcert.batchManagement.mail = MailBatch;
	}
	
	MailBatch.prototype.HasAddresses = function() {
		return true;
	};
	
	MailBatch.prototype.GetCharactersLimit = function() {
		return 5000;
	};
	
	MailBatch.prototype.__getScreenName = function() {
		var account = inConcert.app.getBatchesManager().GetAccountConfiguration(this.campaign, this.account);
		return account && account.name || "";
	};
	
	MailBatch.prototype.GetAccountName = function() {
		return this.__getScreenName() || MailBatch.uber.GetAccountName.call(this);
	};

}());