/*jshint quotmark:false*/
/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var format = inConcert.Utils.format;

	var actions = $.extend({}, inConcert.batchManagementActions.base, {
		EDIT		: null,
		RESCHEDULE	: null,
		PAUSE		: null,
		DELETE		: null
	});
	if (!inConcert.batchManagementActions.sms) {
		inConcert.batchManagementActions.sms = actions;
		$.each(actions, function(actionId, action) {
			inConcert.batchManagementActions.all[actionId] = inConcert.batchManagementActions.all[actionId] || action;
		});
	}

	function SmsBatch (rawData)
	{
		SmsBatch.uber.constructor.call(this, rawData);
	}

	inConcert.Utils.inherit(SmsBatch, inConcert.batchManagement.base);
	if (typeof inConcert.batchManagement.sms !== "function") {
		inConcert.batchManagement.sms = SmsBatch;
	}
	
	SmsBatch.prototype.HasAddresses = function() {
		return true;
	};
	
	SmsBatch.prototype.GetCharactersLimit = function() {
		return 160;
	};
	
	SmsBatch.prototype.__getScreenName = function() {
		var account = inConcert.app.getBatchesManager().GetAccountConfiguration(this.campaign, this.account);
		return account && account.name || "";
	};
	
	SmsBatch.prototype.GetAccountName = function() {
		return this.__getScreenName() || SmsBatch.uber.GetAccountName.call(this);
	};

}());