module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "Configuration"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function GetConfiguration(userAtVcc, keyspace)
	return utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "UserCampaignAnalyticsConfiguration",
		key = userAtVcc,
	} or {}
end

function GetConfigurationField(userAtVcc, field, keyspace)
	local value = utils.GetColumnValue({
		keyspace = keyspace or "Agent",
		columnFamily = "UserCampaignAnalyticsConfiguration",
		key = userAtVcc,
		column = field
	}) or ""
	return value ~= "" and json.decode(value) or nil
end

function SaveConfiguration(userAtVcc, configuration, keyspace)
	utils.SaveRows {
		keyspace = keyspace or "Agent",
		columnFamily = "UserCampaignAnalyticsConfiguration",
		rows = {
			[userAtVcc] = configuration,
		}
	}
end

function SavefigurationField(userAtVcc, field, configuration, keyspace)
	utils.SaveRows {
		keyspace = keyspace or "Agent",
		columnFamily = "UserCampaignAnalyticsConfiguration",
		rows = {
			[userAtVcc] = { [field] = json.encode(configuration) },
		}
	}
end
