module(..., package.seeall)

local m_rasa = require("shared.rasa.rasa")
local apiRasa = m_rasa.GetAPI() -- rocka
local m_datasource

function GetName ()
	return "RASA"
end

function GetDefinition (datasource)
	m_datasource = datasource
	apiRasa.SetRedis(m_datasource.redis)

	local webhandlerConfig = inconcert.environment.apps.agent.config_server
	--LogDebug("[ADMINISTRATION.RASA:GetDefinition] 1 ----CANY-------> webhandlerConfig: %s", json.encode(webhandlerConfig or {}))
	apiRasa.SetServerConfig({
		webhandler = {
			IP   = webhandlerConfig.myIp or webhandlerConfig.ip,    -- "192.168.4.12",
			port = webhandlerConfig.myPort or webhandlerConfig.port --"8082"
		}
	})

	local ir = require "lua_iragentlink"
	require "json"
	local irLink = ir.IRAgentLink(inconcert.environment.apps.agent.cluster)
	local nodes = irLink:GetIRNodes()
	-- table.insert(nodes.nodes, {
	--  	port = "48000",
	--  	IP = "192.168.4.12" -- este es el test la supuesta ip del node actual que esta laburando.
	-- })
	--LogInfo("[ADMINISTRATION.RASA:GetDefinition] 2 ----CANY-------> irLink:GetIRNodes() '%s'", json.encode(nodes))
	apiRasa.SetNodes(nodes)

	return _M
end
