/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

//	"use strict";
//	var format = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// form rasa class
	function adm_form_rasa(params)
	{
		var success = adm_form_rasa.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		this.new_title = "<%=_T('Create cognitive service')%>";
		this.update_title = "<%=_T('Edit Cognitive Service {0}')%>";
		this.view_title = "<%=_T('View Cognitive Service {0}')%>";
		this.tagline = "<%=_T('Tagline form Cognitive Services!!!')%>";

		this.html_file_name = "/inconcert/apps/cognitive_services/rasa/frm/render/";
		this.get_uri =        "/inconcert/apps/cognitive_services/rasa/apps/get/";

		this.classes_name_frm_container = "campaignFormPage";
		this.include_save_and_continue = false;
		this.requests = [];
		this.rasa_app = null;

		var __can_view_section = function (/*section, cognitive_id*/) {
			return true;
		};

		var __get_instance = function (section_id/*, cognitive_id /* optional */ )
		{
			switch(section_id)
			{
				case "application":
					return inConcert.adm_form_rasa_section_application;
				case "intents":
					return inConcert.adm_form_rasa_section_intents;
				case "entities":
					return inConcert.adm_form_rasa_section_entities;
				case "train_and_publish":
					return inConcert.adm_form_rasa_section_train_and_publish;
				default:
					throw "adm_form_rasa.__get_instance. Unrecognized instance: " + section_id;
			}
		};

		// definicion de las secciones del formulario.
		this.sections = {
			"application": {
				name           : "<%=_T('Application Information')%>",
				action_id      : "view_cognitive_services_basic",
				i_class_name     : "far fa-info-circle",
				instance       : function(cognitive_id) { return __get_instance("application", cognitive_id);        },
				initial_state  : "enabled",
				selected       : true,
				can_show       : function(section, cognitive_id) { return __can_view_section(section, cognitive_id); }
			},
			"intents": {
				name           : "<%=_T('Intents')%>",
				action_id      : "view_cognitive_services_intents",
				i_class_name     : "far fa-comment-alt-dots",
				instance       : function(cognitive_id) { return __get_instance("intents", cognitive_id); },
				can_show       : function(section, cognitive_id) { return __can_view_section(section, cognitive_id); }
			},
			"entities": {
				name           : "<%=_T('Entities')%>",
				i_class_name     : "far fa-hashtag",
				action_id      : "view_cognitive_services_entities",
				instance       : function(cognitive_id) { return __get_instance("entities", cognitive_id); },
				can_show       : function(section, cognitive_id) { return __can_view_section(section, cognitive_id); }
			},
			"train_and_publish": {
				name           : "<%=_T('Train')%>",
				i_class_name     : "far fa-chalkboard-teacher",
				action_id      : "view_cognitive_services_train_and_publish",
				instance       : function(cognitive_id) { return __get_instance("train_and_publish", cognitive_id);  },
				can_show       : function(section, cognitive_id) { return __can_view_section(section, cognitive_id); }
			}
		};
		this.create_sections(this);

		return true;
	}

	inConcert.Utils.inherit(adm_form_rasa, inConcert.conf_form);

	if (typeof inConcert.adm_form_rasa !== "function") {
		inConcert.adm_form_rasa = adm_form_rasa;
	}

	adm_form_rasa.prototype.get = function()
	{
		var cognitive_service;
		if (this.is_new) {
			cognitive_service = this.sections.application.frm.get();
			cognitive_service = this.new_entity(cognitive_service);
		}
		else {
			cognitive_service = this.rasa_app;
			this.sections.application.frm.get(cognitive_service);
		}
		return cognitive_service;
	};

	adm_form_rasa.prototype.new_entity = function(cognitive_service)
	{
		if (typeof cognitive_service !== "object") {
			return;
		}
		this.rasa_app = cognitive_service || {};
		return this.rasa_app;
	};

	adm_form_rasa.prototype.get_entity = function()
	{
		return this.rasa_app;
	};

	adm_form_rasa.prototype.set_entity = function(rasa_app)
	{
		this.rasa_app = rasa_app;
	};

	adm_form_rasa.prototype.get_entity_id = function()
	{
		if (this.rasa_app) {
			return this.rasa_app.id;
		}
	};

	adm_form_rasa.prototype.get_entity_display_name = function()
	{
		var display_name = "";
		if (this.rasa_app) {
			display_name = this.rasa_app.name;
		}
		return display_name;
	};

	adm_form_rasa.prototype.get_entity_instance = function()
	{
		return this.rasa_app;
	};

	adm_form_rasa.prototype.set = function(success, cognitive_service)
	{
		if (!success || !cognitive_service) {
			return;
		}
		this.new_entity(cognitive_service);

		inConcert.app.toggleConfNavigation(true, this.$get_dom_element_by_id("grid_scroll"), this.$get_dom_element_by_id("navigation"));
	};

	adm_form_rasa.prototype.__get_server_error_description = function(err)
	{
		var response = { is_custom_message: true, message: undefined };

		switch ((err.result || "").toUpperCase()) {
			case "ALLEGRO_INTEGRATION_ERROR":
				response.is_custom_message = true;
				response.message = "<%=_T('Allegro integration error.')%>";
			break;
			case "FORBIDDEN":
				response.is_custom_message = true;
				response.message = "<%=_T('Unable to save Cognitive Service. You not has permissions.')%>";
			break;
			default:
				response.is_custom_message = true;
				response.message = err.err_type || "<%=_T('Unable to save Cognitive Service. Server error.')%>";
		}

		return response;
	};

	adm_form_rasa.prototype.err_save_messages = function(err)
	{
		if (typeof err !== "object") {
			adm_form_rasa.uber.err_save_messages.call(this, err, false /* custom message*/);  //invokes the base class method
			return;
		}

		var response = this.__get_server_error_description(err);

		if (response.message !== undefined) {
			adm_form_rasa.uber.err_save_messages.call(this, response.message, response.is_custom_message);  //invokes the base class method
		}
	};

	adm_form_rasa.prototype.get_validation_def = function()
	{
		var definitions = [];
		$.each(this.sections, function(_, section)
		{
			if (!section.frm) {
				return true; //continue
			}
			section.frm.get_validation_def(definitions);
		});
		return definitions;
	};

	adm_form_rasa.prototype.load_data = function(callback_complete_requests)
	{
		var self = this;
		this.requests = [];

		$.each(this.sections, function(_, section)
		{
			if (!section.frm) {
				return true; // continue
			}
			section.frm.attach_load_request(self.requests);
		});

		adm_form_rasa.uber.load_data.call(this, callback_complete_requests); //invokes the base class method
	};

	adm_form_rasa.prototype.save_execute = function(after_save, cognitive_service)
	{
		const self = this;

		var callback = function(success, response)
		{
			let err;
			if (!success) {
				err = response;
			}
			if (self.is_new) {
				after_save = "SAVE_AND_NOT_EXIT";
				self.rasa_app.id = response.appId;
			}
			else {
				after_save = "SAVE_WITHOUT_ACTION";
			}
			self.on_saved(success, cognitive_service, after_save, err);
		};

		const rasaApi = inConcert.app.getRasaAPI();
		if (this.is_new) {
			rasaApi.addApp(cognitive_service, callback);
		}
		else {
			this.disabled_all_sub_menus(true);
			rasaApi.renameApp(cognitive_service, callback);
		}
	};

	adm_form_rasa.prototype.on_saved = function(success, cognitive_service, after_save, err)
	{
		var self = this;

		var on_saved = function() {
			if (self.is_new && success) {
				inConcert.app.toggleConfNavigation(true, self.$get_dom_element_by_id("grid_scroll"), self.$get_dom_element_by_id("navigation"));
			}
			adm_form_rasa.uber.on_saved.call(self, success, cognitive_service, after_save, err); //invokes the base class method
			if (!self.is_new) {
				self.enable_all_sections();
			}
		};
		on_saved();
		if (!success) {
			return;
		}
		var section = this.sections[this.current_section];
		if (section && section.frm && section.frm.only_modified) {
			section.frm.only_modified(cognitive_service);
		}
	};

	adm_form_rasa.prototype.dispose = function()
	{
		adm_form_rasa.uber.dispose.call( this ); //invokes the base class method
		this.rasa_app = null;
		inConcert.app.toggleConfNavigation(false, this.$get_dom_element_by_id("grid_scroll"), this.$get_dom_element_by_id("navigation"));
	};

	adm_form_rasa.prototype.enable_all_sections = function()
	{
		this.disabled_all_sub_menus(false);
		if (!this.current_section) {
			return;
		}
		this.mark_sub_menu_option(this.current_section);
	};

}());
