/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 6 */

/* global $, inConcert, _ */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

//	"use strict";

	var format = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// form wizard class
	function conf_form_wizard( params )
	{
		this.frm            = params.frm;
		this.container_id   = "#" + params.container_id;
		this.sel_index      = "[ic-role='navigation-index']";
		this.sel_page       = "[ic-role='navigation-page']";
		this.sel_next       = "[ic-role='navigation-next']";
		this.sel_prev       = "[ic-role='navigation-prev']";
		this.all_pages      = "[ic-navigation-page]";
		this.sel_nav_page   = "[ic-navigation-page='{0}']";
		this.unsel_nav_page = ".navigationListItem[ic-navigation-page!='{0}']";
		this.sel_tab        = "ic-navigation-page";

		this.current_page = undefined;
		this.wizard_options = _.extend({
			onLeavePage       : $.noop,
			onEnterPage       : $.noop,
			onCreate          : $.noop,
			all_visited       : false,
			indexCurrentClass : "navigationIndexCurrent"  ,
			indexDisabledClass: "navigationIndexDisabled"
		}, params.wizard_options );

		this.initialize();

		return true;
	}

	if ( typeof inConcert.conf_form_wizard !== "function" ) {
		inConcert.conf_form_wizard = conf_form_wizard;
	}

	conf_form_wizard.prototype.on_show = $.noop;

	conf_form_wizard.prototype.on_hide = $.noop;

	conf_form_wizard.prototype.readonly = $.noop;

	conf_form_wizard.prototype.get_current_page = function()
	{
		return this.current_page;
	};

	conf_form_wizard.prototype.page_count = function()
	{
		var $container = $( this.container_id );
		var $index = $container.find( this.sel_index );
		var pages = $index.children(":visible").length;
		return pages;
	};

	conf_form_wizard.prototype.all_visited = function()
	{
		var $container = $( this.container_id );
		var $index = $container.find( this.sel_index );
		var pages = $index.children("." + this.wizard_options.indexDisabledClass + ":visible").length === 0;
		return pages;
	};

	conf_form_wizard.prototype.create_wizard = function()
	{
		var $container = $( this.container_id );

		var pages = this.wizard_options.pages || {};
		var i = 0;
		var $tabs;
		$container.html("");

		$.each( pages, function( page_name, page_def )
		{
			i++;
			if ( !$tabs ) {
		// 1 - el contenedor de tabs
				$container.append(
					"<div class='navigationTopContainer'>" +
						"<div class='formTabsContainer formTabsContainerWizard'>" +
							"<ul ic-role='navigation-index' class='navigationList'></ul>" +
						"</div>" +
						"<div class='navigationButtonConainer float-right'>" +
							"<button type='button' class='navigationButton pageButtonGeneric buttonColorWhite' ic-role='navigation-prev' value='" + "<%=_T('Prev')%>" + "'><i class='fal fa-chevron-left'></i><%=_T('Prev')%></button>" +
							"<button type='button' class='navigationButton pageButtonGeneric buttonColorWhite' ic-role='navigation-next' value='" + "<%=_T('Next')%>" + "'><%=_T('Next')%><i class='fal fa-chevron-right'></i></button>" +
						"</div>" +
					"</div>"
				);
				$tabs = $container.find("ul");
			}
		// 2 - inserto un tab al contenedor
			var tab_class = i === 1 ? "navigationIndexCurrent" : "navigationIndexDisabled";
			$tabs.append( 
				"<li ic-navigation-page='" + i + "' class='navigationListItem " + tab_class + "' page_name='" + page_name + "'>" +
					"<span class='navigationNumber'>" + i + "</span>" + page_def.name +
				"</li>"
			);

		// 3 - inserto el contenedor de pagaina
			$container.append( "<div ic-role='navigation-page' ic-navigation-page='" + i + "' hidden page_name='" + page_name + "'>" );

		// 4 - inserto el contenido a la pagina
			var $page = $container.find("div[ic-navigation-page='" + i + "']");
			$page.append( page_def.content() );
		});

		// 5 - inserto los botones next y previous
		$container.append(
			
		);
	};

	conf_form_wizard.prototype.make_navigation_page = function( selector ) {
		selector = selector || this.sel_nav_page;
		var current_page = this.current_page || 1;
		return format( selector, current_page );
	};

	conf_form_wizard.prototype.jump_to_page = function( page, direction, enable_navigation )
	{
		enable_navigation = enable_navigation === undefined ? true : enable_navigation;
		var options = this.wizard_options;
		var $container = $( this.container_id );
		var $index = $container.find( this.sel_index );
		var $pages = $container.find( this.sel_page  );
		var $next  = $container.find( this.sel_next  );
		var $prev  = $container.find( this.sel_prev  );

		if ( this.current_page !== undefined ) {
			var nav_page = this.make_navigation_page(); 
			var $indexElem = $index.children( nav_page + ":visible" );
			var $pageElem  = $pages.filter( nav_page );

			var canLeave = options.onLeavePage(this.current_page, $pageElem, direction, $indexElem);
			if (canLeave === false) {
				return false;
			}

			$indexElem.removeClass(options.indexCurrentClass);
			$pageElem.hide();
		}

		var old_page = this.current_page;
		this.current_page = page;
		var sel_nav_page = this.make_navigation_page(); 
		var $nextIndex = $index.children(  sel_nav_page + ":visible" );
		var $nextPage  = $pages.filter( sel_nav_page );

		$nextPage.show();
		$nextIndex
			.addClass(options.indexCurrentClass)
			.removeClass(options.indexDisabledClass);

		options.onEnterPage( this.current_page, old_page, $nextPage, this.all_visited(), $nextIndex );

		if ( enable_navigation ) {
			$prev.prop( "disabled", this.current_page === 1 );
			$next.prop( "disabled", this.current_page === this.page_count() );
		}
		else {
			this.disable_navigation();
		}
	};

	conf_form_wizard.prototype.set_events = function()
	{
		var self = this;
		var options = this.wizard_options;
		var $container = $( this.container_id );
		var $index = $container.find( this.sel_index );
		var $next  = $container.find( this.sel_next  );
		var $prev  = $container.find( this.sel_prev  );

		$next.on("click", function() {
			var nextPage = self.current_page + 1;
			if (nextPage <= self.page_count()) {
				self.jump_to_page( nextPage, "forward" );
			}
		});

		$prev.on("click", function() {
			var nextPage = self.current_page - 1;
			if (nextPage > 0) {
				self.jump_to_page(nextPage, "backward");
			}
		});

		$index.on("click", "li", function() {
			var $this = $( this );
			if ( $this.hasClass( options.indexDisabledClass ) || $this.hasClass( options.indexCurrentClass ) ) {
				return;
			}

			var pageNumber = parseInt($this.attr( self.sel_tab ), 10);
			if ( isNaN(pageNumber) ) {
				return;
			}

			self.jump_to_page( pageNumber, pageNumber > self.current_page ? "forward" : "backward" );
		});

		if ( options.all_visited === true ) {
			$index.children().removeClass( options.indexDisabledClass );
		}
	};

	conf_form_wizard.prototype.disable_navigation = function()
	{
		var $container = $( this.container_id );
		var $prev = $container.find( this.sel_prev );
		var $next = $container.find( this.sel_next );

		$prev.prop( "disabled", true );
		$next.prop( "disabled", true );

		this.disable_all_navigation_tabs( true /* disabled */ );
	};

	conf_form_wizard.prototype.disable_navigation_buttons = function( disable, specific_button )
	{
		var $container = $( this.container_id );
		var $prev = $container.find( this.sel_prev );
		var $next = $container.find( this.sel_next );

		if ( specific_button === "prev" || specific_button === undefined ) {
			$prev.prop( "disabled", disable );
		}
		if ( specific_button === "next" || specific_button === undefined ) {
			$next.prop( "disabled", disable );
		}
	};

	conf_form_wizard.prototype.disable_all_navigation_tabs = function( disable )
	{
		var options = this.wizard_options;
		var $container = $( this.container_id );
		var $tabs = $container.find( this.make_navigation_page( this.unsel_nav_page ) );

		$tabs.removeClass( options.indexDisabledClass );
		if ( disable ) {
			$tabs.addClass( options.indexDisabledClass );
		}
	};

	conf_form_wizard.prototype.initialize = function()
	{
		var self = this;
		this.create_wizard();
		this.set_events();
		_.defer( function() {
			var page = 1;
			// si esta creando un nuevo elemento, la navegacion queda enabled,
			//	si esta editando, la navegacion queda disabled, hasta que se termine de cargar los datos de la misma
			var enabled = self.frm.is_creating();
			self.jump_to_page( page, undefined /* direction */ , enabled );
			self.wizard_options.onCreate();
		});
	};

}());
