module(..., package.seeall)
local utils = require "shared.apps.utils"
local agent_model = require("apps.agent.model"):GetModels()
local m_datasource

function GetName ()
	return "ProcessFlowDatasources"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetFlowDatasources (vcc, datasourceId, keyspace, allowPassword)
	local datasources = utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "ProcessFlowDatasources",
		superColumns = true,
		key = vcc,
		columns = datasourceId and {datasourceId} or {}
	}
	if datasources and not allowPassword then
		for _, datasource in pairs(datasources) do
			datasource.Password = nil
		end
	end
	if datasourceId then
		return datasources and datasources[datasourceId] or {}
	else
		return datasources or {}
	end
end

function SaveFlowDatasources (vcc, datasources, keyspace)
	local arrayDs = {}
	for _, value in pairs(datasources) do
		table.insert( arrayDs, value.Id)
	end
	RemoveFlowDatasources(vcc, arrayDs, keyspace)
	utils.SaveRows {
		keyspace = keyspace or "Agent",
		columnFamily = "ProcessFlowDatasources",
		superColumns = true,
		rows = {
			[vcc] = datasources
		}
	}
end

function RemoveFlowDatasources (vcc, datasources_to_remove, keyspace)
	utils.RemoveColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "ProcessFlowDatasources",
		superColumns = true,
		rows = {
			[vcc] = datasources_to_remove
		}
	}
end

