local cjson = require "cjson"

local function ExecuteApiNLU (data, aux)

	local text = ""
	
	local message = data.message
	if message then
		if type(message) == "table" then
			message = cjson.encode(cjson.encode(message))
			text = text .. string.format('local _message = cjson.decode(%s)', message)
			text = text .. '\nprocessBrackets(_message)'
		else
			text = text .. string.format('local _message = %s', message)
		end
	end

	text = text .. '\nlogTrace("DEBUG", string.format("Processing activity (end) message: %s", json.encode(_message)))'

	--run method
	text = text .. string.format("local _result = ExecuteApiNLU(__vccName, '%s', _message)", data.cognitiveServicesApp)
	text = text .. '\nlogTrace("DEBUG", string.format("Processing activity (end) result: %s", json.encode(_result)))'
	--process result
	if not aux.empty(data.result) then
		text = text .. string.format('\n%s = _result', data.result)
	end
	return 200, text
end

local function MakeExecutable (stateName, activityId, data, aux, utils)
	if aux.empty(data.cognitiveServicesApp) or aux.empty(data.message) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end
	return ExecuteApiNLU(data, aux)
end

return {
	MakeExecutable = MakeExecutable
}
