
local cjson = require "cjson"

local function makeFields (fields, aux)
	local code = "{"
	local code1 = "{"
	local code2 = "{"
	for _, field in pairs(fields) do
		if field.sendToReport then
			code = code .. string.format("\n\t{ name = '%s', value = %s, hidden = %s, sendToApplication = '%s', searchable = '%s', type = '%s' },", 
				field.name, field.value, aux.booleanValue(field.hidden), field.sendToApplication or "", aux.booleanValue(field.searchable), field.type or "")
		end
		if field.sendToAgent then
			code1 = code1 .. string.format("\n\t{ name = '%s', value = %s, hidden = %s, sendToApplication = '%s' },", 
				field.name, field.value, aux.booleanValue(field.hidden), field.sendToApplication or "")
		end
		if field.sendToApplication then
			code2 = code2 .. string.format("\n\t{ name = '%s', value = %s, hidden = %s, sendToApplication = '%s' },", 
				field.name, field.value, aux.booleanValue(field.hidden), field.sendToApplication or "")
		end
	end
	code = code .. "\n}"
	code1 = code1 .. "\n}"
	code2 = code2 .. "\n}"
	return code,code1,code2
end

local function MakeExecutable (stateName, activityId, data, aux)
	local text = [[
local _fields = %s
local _fields_agent = %s
local _fields_app = %s
SetReportingData(__interactionId, 'dsprocess_flow', '%s', _fields)
SetReportingData(__interactionId, 'process_flow_data', nil, _fields_agent)
SetReportingData(__interactionId, 'dsprocess_flow_application', nil, _fields_app)
logTrace('DEBUG', 'Processing activity (end)')
]]
	code, code1, code2 = makeFields(data.fields, aux)
	text = string.format(text, code, code1, code2, aux.valueOrNil(data.group))
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
