local cjson = require "cjson"

local function MakeExecutable (stateName, activityId, data, aux)
	LogInfo("[SEND_CHANNEL_MESSAGE:MakeExecutable] data.message: %s data.messageType: %s sendType: %s phone: %s", data.message, data.messageType, data.sendType, data.phone)
	if aux.empty(data.message) or aux.empty(data.messageType) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end
	local message = data.message
	local text = ''
	if type(message) == "table" then
		message = cjson.encode(cjson.encode(message))
		text = text .. string.format('local _message = cjson.decode(%s)', message)
		text = text .. '\nprocessBrackets(_message)'
	else
		text = text .. string.format('local _message = %s', message) 
	end

	text = text .. string.format('\nSendChannelMessage(__interactionId, "%s", "%s", "%s", "%s", "%s", "%s", _message)', data.messageType, data.sendType, data.phone, data.account, data.campaign, data.batch or "") 

	LogInfo("[SEND_CHANNEL_MESSAGE:MakeExecutable] Text: %s", text)
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
