local cjson = require "cjson"

local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.message) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end
	local message = data.message
	local text = ''
	if type(message) == "table" then
		message = cjson.encode(cjson.encode(message))
		text = text .. string.format('local _message = cjson.decode(%s)', message)
		if data.message.optionsVariable then
			text = text .. '\n_message.optionsVariable = nil'
			text = text .. '\n_message.optionsTemplate = nil'
			text = text .. '\n_message.options = {}'
			text = text .. string.format('\nlocal _options = %s', data.message.optionsVariable)
			text = text .. '\nfor _, _option in pairs(_options or {}) do'
				text = text .. string.format('\nlocal _element = cjson.decode(%s)\t', cjson.encode(cjson.encode(data.message.optionsTemplate)))
				text = text .. '\nsetTemporalVariable("element", _option)'
				text = text .. '\nprocessBrackets(_element)'
				text = text .. '\ntable.insert(_message.options, _element)'
			text = text .. '\nend'
			text = text .. '\nremoveTemporalVariable("element")'
		end
		text = text .. '\nprocessBrackets(_message)'
		if message.writingWait then
			text = text .. string.format('\n_message.writingWait = %s', message.writingWait)
		end
	else
		text = text .. string.format('local _message = %s', message)
	end
	text = text .. '\nSendMessage(__interactionId, _message)'
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
