
local function MakeExecutable (stateName, activityId, data, aux)
	data.destination = data.destination or "contact_center"
	local text = ""
	if data.destination == "agent" or data.destination == "contact_center" then
		text = text .. string.format(
			"\nlocal _request = { "
		)
		if data.destination == "agent" then
			text = text .. string.format(
				"use_attention_level = %s, " ..
				"requiredAgent = %s",
				aux.valueOrNil(data.toAttentionLevel),
				data.requiredAgent
			)
		else
			text = text .. string.format(
				"use_attention_level = %s, " ..
				"preferredAgents = %s, " .. 
				"forbiddenAgents = %s ",
				aux.valueOrNil(data.toAttentionLevel),
				aux.valueOrNil(data.preferredAgents),
				aux.valueOrNil(data.forbiddenAgents)
			)
		end
		if data.toPriority then
			text = text .. string.format(", priority = %s,"..
			"actionPriority = '%s'",
			aux.valueOrNil(data.toPriority),
			aux.valueOrNil(data.toActionPriority))
		end
		if data.enableACDWaitThreshold then
			text = text .. ", ACDWaitThreshold = " .. aux.valueOrNil(data.ACDWaitThreshold)
			text = text .. ", actionOnTimeout = {action = \"" .. data.actionOnTimeout .. "\""
			if data.actionOnTimeout == "TransferToCampaign" then
				text = text .. ", campaign = " .. data.toCampaignOnTimeout
				text = text .. ", account = " .. data.toAccountOnTimeout
			end
			text = text .. "}"
		end
		text = text .. "}"
		text = text .. "\nsendToCallcenter(_request)"
	elseif data.destination == "campaign" or data.destination == "campaign_agent" then
		text = text .. string.format(
			"\nlocal _request = { " ..
				"target = { " ..
					"to = 'campaign', " ..
					"campaign_id = %s, " ..
					"account_id = %s, " ..
					"properties = {}, " ..
				"}, " ..
			"}",
			data.toCampaign,
			data.toAccount
		)
		if data.destination == "campaign_agent" then
			text = text .. string.format(
				"\n_request.target.attention_level = %s" ..
				"\n_request.target.properties.requiredAgent = %s" ..
				"\n_request.target.properties.skipFlow = %s",
				aux.valueOrNil(data.toAttentionLevel),
				data.requiredAgent,
				aux.booleanValue(data.skipFlow)
			)
		else
			text = text .. string.format(
				"\n_request.target.attention_level = %s" ..
				"\n_request.target.properties.preferredAgents = %s" ..
				"\n_request.target.properties.forbiddenAgents = %s" ..
				"\n_request.target.properties.skipFlow = %s",
				aux.valueOrNil(data.toAttentionLevel),
				aux.valueOrNil(data.preferredAgents),
				aux.valueOrNil(data.forbiddenAgents),
				aux.booleanValue(data.skipFlow)
			)
		end
		text = text .. "\ntransferInteraction(_request)"
	elseif data.destination == "number" then
		text = text .. string.format(
			"\nlocal _request = { " .. 
				"transferType = 'BLIND TRANSFER', " ..
				"target = { " .. 
					"to = 'number', " .. 
					"number = %s, " .. 
					"countryCode = %s, " .. 
					"areaCode = %s, " .. 
					"properties = {}, " ..
				"}, " ..
			"}",
				data.number,
				aux.valueOrNil(data.countryCode),
				aux.valueOrNil(data.areaCode)
		)		
		text = text .. "\ntransferInteraction(_request)"
	end
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
