local cjson = require "cjson"

local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.datasource) or aux.empty(data.code) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end

	--brackets
	local text = [[
local _query = cjson.decode(%s)
processBrackets(_query, __vccName, { sql = _query.datasource })
--run query
local _result, _err = SqlConnectAndQuery(__vccName, _query.datasource, _query.code)
if _result then
	_result.status = true
	_result = cjson.decode(cjson.encode(_result))
else
	_result = { status = false, reason = _err }
end
logTrace("DEBUG", string.format("Processing activity (end) result: %s", cjson.encode(_result)))
]]

	text = string.format(text, cjson.encode(cjson.encode(data)), "%s")

	--process result
	if not aux.empty(data.result) then
		text = text .. string.format('\n%s = _result', data.result)
	end

	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
