local cjson = require "cjson"

local function makeParams(data, aux)
	local code = string.format(
[[
{
	type = "Phone",
	country = %s,
	area = %s,
	number = %s,
}
]],
	aux.valueOrNil(data.country),
	aux.valueOrNil(data.areaCode),
	aux.valueOrNil(data.phone)
	)
	return code
end

local function makeResult(data, aux)
	local code = 'logTrace("DEBUG", string.format("Processing activity (end) result: %s", cjson.encode(_result)))'
	if not aux.empty(data.result) then
		code = code .. string.format('\n\n%s = _result', data.result)
	end
	return code
end

local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.phone) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end

	--run method
	local code = string.format(
[[
local _params = %s
_result = ValidateAddress(_params)
%s
]],
	makeParams(data, aux),
	makeResult(data, aux)
	)
	return 200, code
end

return {
	MakeExecutable = MakeExecutable
}
