/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var id = "answer";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		this.focusControl = this.startDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_activities.base );

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver380w flowDesignerGlobalModal botActivity_answer";
	};

	adm_process_flow_activity.prototype.__makeContent = function() { 
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);
		
		$content.unshift(
			this.__makeDivFlex(
			  [this.__makeDivFlex(
				  [
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(null, {
							  class: "inlineMessagesContainer messageInfo mb-0",
							  persoTags: "disclaimer",
							  content:
								"<%=_T('This activity does not require a configuration.')%>",
							}),
						  ],
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );
		  

		return $content;
	};

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Answer Conversation')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Answer the conversation.')%>";
	adm_process_flow_activity.prototype.group = "interaction";
	adm_process_flow_activity.prototype.channels = { 
		"CALL" : true
	};
	adm_process_flow_activity.prototype.image = "ico-answer.svg";

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id + "_" + type;
		}

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_answer`, 
			description: ((data.description && data.description !== "")?data.description:"<%=_T('Answer Conversation')%>") 
		})
	};

	adm_process_flow_activity.prototype.ports = function(data, node) {
		

		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "", // error/success/option
			option_label : "Input" // error/success/option
		});


		// en algún lado el usuario debe decidir si quiere un puerto por defecto
		let puerto_por_defecto = true;

		// agrego un puerto por defecto si es necesario
		if (puerto_por_defecto) {
			let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
			let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");
			let conditions = [];

			ports.push({
				direction : "out", // in/out
				type : "option", // error/success/option
				option_label : "<%=_T('Default output')%>", // error/success/option
				channels: "1", // 0, 1 o n
				id: portId,  // le asigno un id por defecto
				preset_value: {
					description: "",
					conditions: conditions,
					port_id: portId
				},
				intern_value: undefined
			});
		}
		

		return ports;
	};

}());
