/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

if (!this.inConcert.adm_process_flow_activities) {
	this.inConcert.adm_process_flow_activities = {};
}

(function () {
	//"use strict";

	const FORMAT = inConcert.Utils.format;

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this);
		this.editor = editor;
		this.node = node;
		let data = editor.GetNodeData(node);
		this.isNew = !data;
		this.data = data || {};

		this.descriptionDefinition = {
			id : "description",
			name : "<%=_T('Description')%>",
			description : "<%=_T('Activity description.')%>",
			placeholder : "<%=_T('Enter description')%>..."
		};
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_activities.base !== "function") {
		inConcert.adm_process_flow_activities.base = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = null;
	adm_process_flow_activity.prototype.name = null;
	adm_process_flow_activity.prototype.description = null;
	adm_process_flow_activity.prototype.group = null;
	adm_process_flow_activity.prototype.channels = null;
	adm_process_flow_activity.prototype.available = null;
	adm_process_flow_activity.prototype.image = null;
	adm_process_flow_activity.prototype.dataStyle = null;
	adm_process_flow_activity.prototype.dataStyles = null;
	
	adm_process_flow_activity.prototype.Override = function(channel, base) {
		base.prototype.overrides = base.prototype.overrides || {};
		base.prototype.overrides[channel] = this.constructor;
	};
	
	adm_process_flow_activity.prototype.GetActivity = function(channel) {
		if (this.overrides && this.overrides[channel]) {
			return this.overrides[channel];
		}
		return this.constructor;
	};

	adm_process_flow_activity.prototype.GetMigrationData = function(/*data*/) {
		return null;
	};

	adm_process_flow_activity.prototype.GetActivityDeclaredVariables = function(data, editor) {
		if (!data.result) {
			return [];
		}
		editor.main.declaredVariables.add(data.result);
		return [data.result];
	};

	adm_process_flow_activity.prototype.__addAutocompleteToInput = function ($inputs) {
		const self = this;
		self.editor.main.LoadVariablesSet();
		// const variableIcon = self.$get("span[class=ic_variable_icon_container");

		$inputs.each(function() { 
			let variableInput = $(this).children("input[type=text]")
			if (variableInput.length) {
				self.frm.make_autocomplete(
					variableInput,
					Array.from(self.editor.main.variables)
				);
			}	
		});

		$("[id*='ui-id']").css("z-index", 119);
	};

	adm_process_flow_activity.prototype.MigrateData = $.noop;

	adm_process_flow_activity.prototype.__getClassName = function() {
		return FORMAT("flowDesignerActivityPopup {0}Popup flowDesignerActivityPopup {1}Popup",
			this.id, this.editor.main.data.Type.toLowerCase());
	};

	adm_process_flow_activity.prototype.__getTitle = function() {
        if (this.data.description === undefined || this.data.description === "") {
            this.data.description = this.name;
        }
		if (this.isNew)
			return this.name;
		else
			return (this.data.description !== undefined) ? this.data.description: this.name;
		
	};

	adm_process_flow_activity.prototype.__makeContent = function() {
		let $content = [];
		return $content;
	};

	adm_process_flow_activity.prototype.__getAndValidate = function() {
		const data = {
			type : this.id
		};

		this.__addValue(data, this.descriptionDefinition);
		return data;
	};

	adm_process_flow_activity.prototype.__save = function(data, callback) {
		this.editor.AddOrUpdateActivity(this.node, data);
		callback(true);
	};

}());
