/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var id = "close_channel";
	const socialMediaArray = ["FACEBOOK_BOT", "TWITTER_BOT", "INSTAGRAM_BOT"];
	let isSocialMedia = false;

	function adm_process_flow_activity(editor, node) {
		const self = this;
		isSocialMedia = jQuery.inArray(editor.main.data.Type, socialMediaArray) !== -1;

		adm_process_flow_activity.uber.constructor.call(this, editor, node);
		this.focusControl = this.descriptionDefinition;
		this.frm = editor.main.frm;
		
		this.finalizationMessage = {
			id : "finalizationMessage",
			name : "<%=_T('Finalization Message')%>",
			description : "<%=_T('Send interaction finalization message when conversation ends.')%>",
			// disclaimer : "<%=_T('Must be configured on account messages as automatic.')%>",
			controlContainerClass: "form-check mt-0",
			envolving_label_class: "form-check-label form-check-label-title",
			checkBoxClass: "form-check-input",
			envolving_label: true,
			with_dots: false,
			without_label: true,
			channels : {
				"CHAT" : true, 
				"MAIL" : true,
				"WHATSAPP" : true 
			},
			change : function() {
				self.__toggleFinalizationMessage($(this).is(":checked"));
			}
		};
		if (!this.finalizationMessage.channels[editor.main.data.Type]) {
			this.finalizationMessage = null;
		}

		if (isSocialMedia) {
			this.finalizationMessage = null;
		}
		
		this.finalizationMessageAddress = {
			id : "finalizationMessageAddress",
			name : "<%=_T('Finalization Message Address')%>",
			description : "<%=_T('Email address to send finalization message.')%>",
			placeholder : "<%=_T('Enter Message Address')%>...",
			// disclaimer : "<%=_T('If is not set then will be sent to contact address.')%>",
			not_extended : true,
			variable : true,
			controlContainerClass: "form-group position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			channels : {
				"CHAT" : true,
				"WHATSAPP" : true,
				"MAIL" : true
			}
		};
		if (!this.finalizationMessageAddress.channels[editor.main.data.Type]) {
			this.finalizationMessageAddress = null;
		}
		
		if (isSocialMedia) {
			this.finalizationMessageAddress = null;
		}
		
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_activities.base );

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Close interaction')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Closes interaction channel.')%>";
	adm_process_flow_activity.prototype.group = "interaction";
	adm_process_flow_activity.prototype.image = "ico-close-channel.svg";

	adm_process_flow_activity.prototype.__getClassName = function() { 
		return "popOver520w flowDesignerGlobalModal botActivity_close_channel";
	};

	adm_process_flow_activity.prototype.GetActivityDeclaredVariables = function(/*data*/) {
		return [];
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() { 
		const self = this;
		const $inputs = self.$get("span[class=ic_variable_icon_container");
		self.__addAutocompleteToInput($inputs);
	};

	adm_process_flow_activity.prototype.__makeContent = function() { 
		
		let $content = adm_process_flow_activity.uber.__makeContent.call(this);
		
		if (isSocialMedia) {
			return this.__makeContentForSocialMedia();
		}

		if (this.finalizationMessage) {
			let finalizationMessageAddressStyle;
			if (!this.finalizationMessageAddress) {
				finalizationMessageAddressStyle = "display:none";
			}

			$content.unshift(
				this.__makeDivFlex(
				  [
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(
							  [
								this.__makeDivFlex(null, {
								  class: "inlineMessagesContainer messageInfo",
								  persoTags: "disclaimer",
								  content:
									"<%=_T('Must be configured on account messages as automatic.')%>",
								}),
							  ],
							  { class: "col-12" }
							),
							this.__makeDivFlex(
							  [
								this.__makeDivFlex(
								  this.__makeCheckbox(
									this.finalizationMessage,
									this.data[this.finalizationMessage.id]
								  ),
								  { class: "form-group" }
								),
							  ],
							  { class: "col-12" }
							),
						  ],
						  { class: "row" }
						),
						this.__makeSeparator(),
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(
							  [
								this.__makeDivFlex(null, {
								  class: "inlineMessagesContainer messageInfo",
								  persoTags: "disclaimer",
								  content:
									"<%=_T('If is not set then will be sent to contact address.')%>",
								}),
							  ],
							  { class: "col-12" }
							),
							this.__makeDivFlex(
							  [
								this.__makeInputFlex(
								  this.finalizationMessageAddress,
								  this.data[this.finalizationMessageAddress.id]
								),
							  ],
							  { class: "col-12" }
							),
						  ],
						  { class: "row",
						  	style: finalizationMessageAddressStyle
						  }
						),
					  ],
					  { class: "card-block" }
					),
				  ],
				  { class: "card no-card" }
				)
			  );					
		}

		return $content;
	};

	adm_process_flow_activity.prototype.__makeContentForSocialMedia = function() { 
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);
		
		$content.unshift(
			this.__makeDivFlex(
			  [this.__makeDivFlex(
				  [
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(null, {
							  class: "inlineMessagesContainer messageInfo mb-0",
							  persoTags: "disclaimer",
							  content:
								"<%=_T('This activity does not require a configuration.')%>",
							}),
						  ],
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );
		  

		return $content;
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() {
		if (this.finalizationMessage) {
			this.__toggleFinalizationMessage(this.data[this.finalizationMessage.id]);
		}
	};

	adm_process_flow_activity.prototype.__getAndValidate = function() {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		if (this.finalizationMessage) {
			this.__addValue(data, this.finalizationMessage);
			if (this.finalizationMessageAddress && data[this.finalizationMessage.id]) {
				this.__addValue(data, this.finalizationMessageAddress);
			}
		}
		return data;
	};
	
	adm_process_flow_activity.prototype.__toggleFinalizationMessage = function(checked) {
		if (this.finalizationMessageAddress) {
			this.__disableEnableControl(this.finalizationMessageAddress, !checked);
		}
	};
	
/*
 * CALL
 */

	function adm_process_flow_activity_call(editor, node) {
		adm_process_flow_activity_call.uber.constructor.call(this, editor, node);

		this.voicemailDefinition = {
			id : "voicemail",
			name : "<%=_T('Voicemail')%>",
			description : "<%=_T('Send interaction to voicemail request.')%>",
			form_group: false,
			controlContainerClass: "form-check",
			envolving_label_class: "form-check-label form-check-label-title",
			checkBoxClass: "form-check-input",
			envolving_label: true,
			without_label: true,
			with_dots: false
		};
	}

	inConcert.Utils.inherit( adm_process_flow_activity_call, adm_process_flow_activity );
	adm_process_flow_activity_call.prototype.Override("CALL", adm_process_flow_activity);

	adm_process_flow_activity_call.prototype.__getClassName = function() { 
		return "popOver380w flowDesignerGlobalModal botActivity_close_channel";
	};

	adm_process_flow_activity_call.prototype.__makeContent = function() { 
		var $content = adm_process_flow_activity_call.uber.__makeContent.call(this);
		
		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							[
							  this.__makeDivFlex(
								this.__makeCheckbox(
								  this.voicemailDefinition,
								  this.data[this.voicemailDefinition.id]
								),
								{ class: "form-check" }
							  ),
							],
							{ class: "form-group mb-0" }
						  ),
						],
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  )
				),
				{ class: "card no-card" },
			  ],
			  { class: "card-block" }
			)
		  );
		
		return $content;
	};

	
	adm_process_flow_activity_call.prototype.__getAndValidate = function() {
		var data = adm_process_flow_activity_call.uber.__getAndValidate.call(this);
		this.__addValue(data, this.voicemailDefinition);
		return data;
	};

	adm_process_flow_activity.prototype.htmlBody = function(/*data*/) {
		return Mustache.render(inConcert.templates.process_flows.close_activity_template, {
			image: `custom_icon_${id}`, 
			description: "<%=_T('End')%>"
			// description: ((data.description && data.description !== "")?data.description:"<%=_T('Close interaction')%>") 
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) { 
		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "error", // error/success/option
			option_label : "Input" // error/success/option
		});

		return ports;
	};

}());
