/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var id = "execute_allegro_state";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		this.frm = editor.main.frm;

		this.ipDefinition = {
			id : "ip",
			name : "<%=_T('Ip')%>",
			description : "<%=_T('Allegro webhandler ip or domain.')%>",
			required : true,
			variable : true,
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.portDefinition = {
			id : "port",
			name : "<%=_T('Port')%>",
			description : "<%=_T('Allegro webhandler port.')%>",
			required : true,
			defaultValue : "8082",
			variable : true,
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.sslDefinition = {
			id : "ssl",
			name : "<%=_T('Ssl')%>",
			description : "<%=_T('Allegro webhandler uses ssl.')%>",
			with_dots: false,
			form_group: false,
			controlContainerClass: "form-check",
			envolving_label_class: "form-check-label form-check-label-title",
			checkBoxClass: "form-check-input",
			envolving_label: true,
			without_label: true
		};

		this.vccDefinition = {
			id : "vcc",
			name : "<%=_T('Vcc')%>",
			description : "<%=_T('Allegro virtual contact center')%>",
			required : true,
			variable : true,
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.stateDefinition = {
			id : "state",
			name : "<%=_T('State')%>",
			description : "<%=_T('Allegro process state name.')%>",
			required : true,
			variable : true,
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.dataDefinition = {
			id : "data",
			name : "<%=_T('Data')%>",
			description : "<%=_T('Data to be sent to process state (must be an object).')%>",
			variable : true,
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.resultDefinition = {
			id : "result",
			name : "<%=_T('Result')%>",
			placeholder: "<%=_T('Enter result')%>...",
			description : "<%=_T('Variable name to store state result ({ status : boolean indicating if state was run successfully, data : string return value|error message }).')%>",
			form_group: true
		};
		
		this.focusControl = this.ipDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_activities.base );

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Execute allegro state')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Executes an allegro process state.')%>";
	adm_process_flow_activity.prototype.group = "middleware";
	adm_process_flow_activity.prototype.image = "ico-execute-allegro.svg";

	adm_process_flow_activity.prototype.__getClassName = function() { 
		return "popOver520w flowDesignerGlobalModal botActivity_execute_allegro_state";
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() { 
		const self = this;
		const $inputs = self.$get("span[class=ic_variable_icon_container");
		self.__addAutocompleteToInput($inputs);
	};

	adm_process_flow_activity.prototype.__makeContent = function() { 
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);

		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.ipDefinition,
							this.data[this.ipDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.portDefinition,
							this.data[this.portDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(
							  [
								this.__makeCheckbox(
								  this.sslDefinition,
								  this.data[this.sslDefinition.id]
								),
							  ],
							  { class: "form-group" }
							),
						  ],
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.vccDefinition,
							this.data[this.vccDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.stateDefinition,
							this.data[this.stateDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.dataDefinition,
							this.data[this.dataDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.resultDefinition,
							this.data[this.resultDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );
		  
		return $content;
	};


	adm_process_flow_activity.prototype.__getAndValidate = function() {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		this.__addValue(data, this.ipDefinition);
		this.__addValue(data, this.portDefinition);
		this.__addValue(data, this.sslDefinition);
		this.__addValue(data, this.vccDefinition);
		this.__addValue(data, this.stateDefinition);
		this.__addValue(data, this.dataDefinition);
		this.__addValue(data, this.resultDefinition);
		return data;
	};

	adm_process_flow_activity.prototype.htmlBody = function(data) {
		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_execute_allegro_state_text`, 
			description: ((data.description && data.description !== "")?data.description:"<%=_T('Execute allegro state')%>") 
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) {
		
		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "", // error/success/option
			option_label : "Input" // error/success/option
		});

		// agrego puerto único por defecto
		let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
		let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");
		ports.push({
			direction : "out", // in/out
			type : "option", // error/success/option
			option_label : data.result?data.result:"<%=_T('Default output')%>", // error/success/option
			channels: "n", // 0, 1 o n
			id: portId,  // le asigno un id por defecto
			preset_value: undefined, // undefined para que permita al usuario crear sus propias condiciones 
			intern_value: undefined
		});

		return ports;
	};

}());
