/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var id = "jump_to_process";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		const self = this;
		this.process = {
			id : "process",
			name : "<%=_T('Process')%>",
			description : "<%=_T('Process')%>",
			required : true,
			not_extended : true,
			form_group: true,
			change: function() {
				const $container = self.$container();
				const $control = self.__getControl(self.state, $container);
				let id = self.__getValue(self.process, $container);
				let flow = self.process.options.filter(flow => flow.id === id)[0];
				let stateOptions = "";	
				$.each(flow.childs, function(_, item) {
					stateOptions += inConcert.Utils.format("<option value='{0}'>{1}</option>", item.id, item.name);
				});
				$control.html(stateOptions);
			}
		};

		this.state = {
			id : "state",
			name : "<%=_T('State')%>",
			description : "<%=_T('State')%>",
			required : true,
			not_extended : true,
			form_group: true
		};

		this.focusControl = this.writingDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_activities.base );

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Jump to Flow')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Jump to another flow.')%>";
	adm_process_flow_activity.prototype.group = "middleware";
	adm_process_flow_activity.prototype.image = "ico-jump-to-flow.svg";	

	adm_process_flow_activity.prototype.__load = function(callback) {
		const self = this;
		this.editor.main.GetFlowsStates(function(flowsStates) {
			self.process.options = flowsStates;
			callback();
		});
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() {
		adm_process_flow_activity.uber.__afterAppendBody.call(this);

		this.process.change();
		if (this.data[this.state.id]) {
			this.__setValue(this.state, this.data[this.state.id], this.$container());
		}
	};	

	adm_process_flow_activity.prototype.__makeContent = function() { 
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);

		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeRowFlex(
					  [this.__makeComboFlex(this.process, this.data[this.process.id])],
					  { class: "col-12" }
					),
					this.__makeRowFlex(
					  [this.__makeComboFlex(this.state, this.data[this.state.id])],
					  { class: "col-12" }
					),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );  
				  
		return $content;
	};

	adm_process_flow_activity.prototype.__getAndValidate = function() {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		this.__addValue(data, this.process);
		this.__addValue(data, this.state);
		return data;
	};

	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver380w flowDesignerGlobalModal botActivity_jump_to_process";
	};

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id + "_" + type;
		}

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_jump_to_process`, 
			description: ((data.description && data.description !== "")?data.description:"<%=_T('Jump to Flow')%>") 
		});
	};

	adm_process_flow_activity.prototype.ports = function (_, node) {
		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction: "in", // in/out
			type: "option", // error/success/option
			option_label: "Input" // error/success/option
		});

		let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
		let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");

		ports.push({
			direction : "out", // in/out
			type : "option", // error/success/option
			option_label : "<%=_T('Default output')%>", // error/success/option
			channels: "n", // 0, 1 o n
			id: portId,  // le asigno un id por defecto
			preset_value: undefined, // undefined para que permita al usuario crear sus propias condiciones
			intern_value: undefined
		});
		
		return ports;
	};

}());
