/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var id = "jump_to_state";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		var main = this.editor.main;
		this.state = {
			id : "state",
			name : "<%=_T('State')%>",
			description : "<%=_T('State')%>",
			required : true,
			not_extended : true,
			form_group: false,
			controlContainerClass: "form-input-container",
			with_label: true,
			options : main.GetStatesList()	
		};

		this.backToState = {
			id : "backToState",
			name : "<%=_T('Back To State')%>",
			description : "<%=_T('Back To State')%>",
			with_dots: false,
			not_extended : true,
			form_group: false,
			controlContainerClass: "form-check",
			defaultValue: true,
			envolving_label_class: "form-check-label form-check-label-title",
			checkBoxClass: "form-check-input",
			envolving_label: true,
			without_label: true
		};

		this.focusControl = this.writingDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_activities.base );

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Jump to State')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Jump to another state within this flow.')%>";
	adm_process_flow_activity.prototype.group = "middleware";
	adm_process_flow_activity.prototype.image = "ico-jump-to-state.svg";		

	adm_process_flow_activity.prototype.__makeContent = function() { 
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);

		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeRowFlex([
					  this.__makeDivFlex(
						[
						  this.__makeComboFlex(this.state, this.data[this.state.id]),
						  this.__makeCheckbox(
							this.backToState,
							this.data[this.backToState.id]
						  ),
						],
						{ class: "form-group form-input-and-check d-flex" }
					  ),
					]),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );
	  
		return $content;
	};

	adm_process_flow_activity.prototype.__getAndValidate = function() {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		this.__addValue(data, this.state);
		this.__addValue(data, this.backToState);
		return data;
	};

	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver380w flowDesignerGlobalModal botActivity_jump_to_state";
	};

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id + "_" + type;
		}

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_jump_to_state`, 
			description: ((data.description && data.description !== "")?data.description:"<%=_T('Jump to State')%>") 
		});
	};

	adm_process_flow_activity.prototype.ports = function (data, node) { 


		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction: "in", // in/out
			type: "option", // error/success/option
			option_label: "Input" // error/success/option
		});

		if (data.backToState === true) {
			// agrego puerto de salida

			let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
			let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");

			ports.push({
				direction : "out", // in/out
				type : "option", // error/success/option
				option_label : "<%=_T('Default output')%>", // error/success/option
				channels: "n", // 0, 1 o n
				id: portId,  // le asigno un id por defecto
				preset_value: undefined, // undefined para que permita al usuario crear sus propias condiciones
				intern_value: undefined
			});
		}

		return ports;
	};

}());
