/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";


	const id = "knowledge_fusion";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		var self = this;
		self.frm = editor.main.frm;
		this.loremIpsumStandard = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec nibh ex, finibus vel rhoncus eu, malesuada non ipsum. Aliquam ac volutpat odio. Nunc massa urna, faucibus a aliquet eget, auctor ac orci. Mauris varius diam sed commodo tempus. Sed faucibus eu felis eu ultrices. Praesent ornare, quam vel ornare commodo, sem neque rhoncus dolor, in imperdiet neque mauris dapibus dui. Phasellus porttitor urna nec lorem faucibus, ac vestibulum arcu laoreet. Fusce iaculis enim quis quam.";
		this.loremIpsumShort = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vivamus ligula diam, placerat nec fringilla quis.";
		this.loremIpsumLong = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Maecenas sodales eros massa, id interdum nulla sollicitudin vel. Donec in est nec velit vehicula rhoncus. Pellentesque tempor, ipsum id egestas facilisis, metus elit malesuada erat, vitae pellentesque nulla nunc eu metus. Sed feugiat eleifend cursus. Curabitur orci est, faucibus in commodo id, bibendum nec tortor. In sagittis lectus est. Morbi accumsan nunc sit amet ipsum iaculis aliquam. Proin eget nibh rutrum magna placerat sollicitudin nec a velit. Praesent non lacus at ante ornare viverra ut sit amet quam. In blandit ipsum id purus hendrerit, quis auctor ante cursus. Mauris iaculis sagittis dolor, et luctus neque scelerisque a. Fusce eget scelerisque eros.Sed tincidunt in erat a tincidunt. Donec blandit neque ac facilisis viverra. Vivamus at tempus felis, vitae ullamcorper ante. Ut neque lectus, porta quis mollis sed, consequat nec leo. Phasellus tristique vel leo vitae consectetur. Nullam finibus velit vel eros.";
		this.kBList = [];

		this.knowledgeFusionBasesDefinition = {
			id         : "knowledgeFusionBases",
			name       : "<%=_T('Knowledge Base')%>",
			placeholder: "<%=_T('Select one or many options')%>",
			description: "",
			not_extended: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true,
			multiple: true,
			selectName: "selectKnowledgeFusionBase"
		};

		this.queryDefinition = {
			id         : "query",
			name       : "<%=_T('Query')%>",
			placeholder: "<%=_T('Select one or many')%>",
			description: "",
			required   : true,
			variable   : true,
			not_extended: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true,
		};

		this.resultDefinition = {
			id         : "result",
			name       : "<%=_T('Result')%>",
			placeholder: "<%=_T('')%>",
			description: "",
			required   : true,
			form_group: "true"
		};

		/*this.scoringDefinition = { 
			id         : "luis_scoring",
			name       : "<%=_T('Scoring')%>", 
			description: ""
		};*/

		this.maxWordLimitDefinition = {
			id : "maxWordLimit",
			name : "<%=_T('Limit max words per answer')%>",
			description : "<%=_T('Limit max words per answer')%>",
			inverse_order : true,
			change : function() {
				self.__toggleMaxWordsOptions();
			},
            not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input"
		};

		this.customMaxWordsDefinition = {
			id         : "customMaxWords",
			name       : "<%=_T('Custom value')%>",
			placeholder: "<%=_T('Insert value')%>",
			description: "",
			required   : true,
			form_group: "true",
			validate : {
				range : {
					type : "integer",
					allowVariables : false,
					min : 1
				}
			},
		};
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_activities.base );

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Knowledge Fusion')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Knowledge Fusion')%>";
	adm_process_flow_activity.prototype.group = "middleware";
	adm_process_flow_activity.prototype.image = "ico-execute-luis.svg";

	adm_process_flow_activity.prototype.__getClassName = function() {
		const drawVersion = this.editor.main.__getVersion(); 
		let flowDesignerPopupClasses = "popOver940w flowDesignerGlobalModal botActivity_knowledge_fusion";
		if (drawVersion !== "2") {
			flowDesignerPopupClasses = "popOver940w flowDesignerGlobalModal botActivity_knowledge_fusion";
		}

		return flowDesignerPopupClasses;
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() { 
		const self = this;
		const $inputs = this.$get("span[class=ic_variable_icon_container");
		this.__addAutocompleteToInput($inputs);

		const dropdownOptions = self.kBList;

		const $kbSelect = this.$get("#knowledgeFusionBases");
		$kbSelect.multipleSelectDropdown(dropdownOptions);
		if(this.data.knowledgeFusionBases) {
			$kbSelect.selectItemsFromArray(this.data.knowledgeFusionBases);
		}

		const dropdownLabel = "<label control_label='knowledgeFusionBases' for='BE2490957602E724674C3550F2B28FFD' class=' formLabel-rq'><%=_T('Knowledge Base')%>:</label>";
		$("#dropbtn").before(dropdownLabel);
		
		$("input[name=max_characters]").change(function() {
			const loremIpsumWords =	self.$get("[loremIpsumWords]");
			self.__hideControl(self.customMaxWordsDefinition);
			customMaxWordsLimit.removeClass("formLabel-rq");
			if ($(this).is(":checked")) {
				$("[loremIpsumDiv]").closest(".col-12").show();
				if ($(this).val() === "max_characters_standard") {
					loremIpsumWords.html(self.loremIpsumStandard);
				} else if ($(this).val() === "max_characters_short") {
					loremIpsumWords.html(self.loremIpsumShort);
				} else if ($(this).val() === "max_characters_long") {
					loremIpsumWords.html(self.loremIpsumLong);
				} else
				{
					self.__showControl(self.customMaxWordsDefinition);
					customMaxWordsLimit.addClass("formLabel-rq");
					$("[loremIpsumDiv]").closest(".col-12").hide();
				}
			}
		});

		const customMaxWordsLimit = self.$get("[control_label=customMaxWords]");
		if (this.data.words_limit) {
			$("[control=maxWordLimit]").click();
			$(`[control=${this.data.number_of_words_radio}`).click();
			if (this.data.number_of_words_radio === "max_characters_custom") {
				// $("[control=customMaxWords]").val(this.data.customMaxWords);
				self.__showControl(self.customMaxWordsDefinition);
				customMaxWordsLimit.addClass("formLabel-rq");
				$("[loremIpsumDiv]").closest(".col-12").hide();
			}
		}
	};

	adm_process_flow_activity.prototype.__load = function (callback) {
		const self = this;
		const qnV2API = inConcert.app.getQnAV2API();

		callback = callback || function(){};

		qnV2API.getAllKnowledgeBases(0, 1000, "", function(success, response){
			if(!success){
				callback(false, "<%=_T('Error geting Knowledge Fusion Bases.')%>");
				return;
			}
			const formatedBases = response.data.map(base => {
				return { id: base.id, name: base.name };
			});

			self.knowledgeFusionBasesDefinition.options = formatedBases;
			self.kBList = formatedBases;

			callback();
		});
	};

	adm_process_flow_activity.prototype.__makeContent = function () {
		const $content = adm_process_flow_activity.uber.__makeContent.call(this);

		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [				
					this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							[
							  this.__makeDivFlex(null, {
								class: "dropdown form-group",
								idAux: "knowledgeFusionBases",
							  }),
							],
							{ class: "col-12" },
						  ),
						],
						{ class: "row" },
					  ),

					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.queryDefinition,
							this.data[this.queryDefinition.id],
						  ),
						  { class: "col-12" },
						),
					  ],
					  { class: "row" },
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.resultDefinition,
							this.data[this.resultDefinition.id],
						  ),
						  { class: "col-12" },
						),
					  ],
					  { class: "row" },
					),
	  
					//this.__makeScoring(this.data[this.scoringDefinition.id]),
	  
					this.__makeDivFlex(
					  this.__makeCheckboxFlex(
						this.maxWordLimitDefinition,
						this.data[this.maxWordLimitDefinition.id],
					  ),
					  { class: "form-group d-flex align-items-center" },
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(null, {
							  class: "inlineMessagesContainer messageInfo",
							  persoTags: "disclaimerMaxWords",
							  style: "display:none;",
							  content:
								"<%=_T('The maximum number of words per answer does not apply to block response types (literal responses and without cuts)')%>",
							}),
						  ],
						  { class: "col-12" },
						),
					  ],
					  { class: "row" },
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  $(
							Mustache.render(
							  inConcert.templates.process_flows
								.knowledge_fusion_max_character_radiobuttons,
							  {
								guid: inConcert.Utils.generateGuid(),
							  },
							),
						  ),
						  { class: "col-12" },
						),
					  ],
					  { class: "row" },
					),
					this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							this.__makeInputFlex(
							  this.customMaxWordsDefinition,
							  this.data[this.customMaxWordsDefinition.id],
							),
							{ class: "col-2", hidden: true },
						  ),
						],
						{ class: "row" },
					  ),
					  this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							$(Mustache.render(inConcert.templates.process_flows.knowledge_fusion_lorem_ipsum_words)),
							{ class: "col-12", hidden: true }
						  ),
						],
						{ class: "row" }
					  ),
				  ],
				  { class: "card-block" },
				),
			  ],
			  { class: "card no-card" },
			),
		);
		return $content;
	  };

	  adm_process_flow_activity.prototype.__toggleMaxWordsOptions = function() {
		const self = this;
		const disclaimer = self.$get("[disclaimerMaxWords]");
		const maxCharacters = self.$get("[maxCharacters]");
		const customMaxWordsLimit = self.$get("[control_label=customMaxWords]");
		
		if (disclaimer.is(":visible")) {
			disclaimer.hide();
			maxCharacters.hide();
			self.__hideControl(self.customMaxWordsDefinition);
			customMaxWordsLimit.removeClass("formLabel-rq");
			$("[loremIpsumDiv]").closest(".col-12").hide();
		} else {
			$("[loremIpsumDiv]").closest(".col-12").show();
			disclaimer.show();
			maxCharacters.show();
			$("[control=max_characters_standard]").click();
			if ($("input[value=max_characters_custom]").is(":checked")) {
				self.__showControl(self.customMaxWordsDefinition);
				customMaxWordsLimit.addClass("formLabel-rq");
				$("[loremIpsumDiv]").closest(".col-12").hide();
			}
		}
	};
	  
	adm_process_flow_activity.prototype.__makeScoring = function(scoring) { 
		
		const $metadata = $(inConcert.templates.process_flows.execute_luis_scoring);

		let $slider_value = $metadata.find(".ui-slider-scoring-value");
		$metadata.find("[control=global_scoring]").slider({
			range: "min",
			min: 0,
			max: 1,
			value: scoring?scoring:0.50,
			step: 0.01,
			create: function() {
				$slider_value.text(Math.floor(($(this).slider("value")) * 100) + "%");
				$metadata.find(".ui-slider-scoring-input-value").val($(this).slider("value"));
			},
			slide: function(_, ui) {
				$slider_value.text(Math.floor((ui.value) * 100) + "%");
				$metadata.find(".ui-slider-scoring-input-value").val(ui.value);
			}
		});
		
		return $metadata;
	};

	adm_process_flow_activity.prototype.__getAndValidate = function(flexible) { 
		const self = this;
		
		const data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		const drawVersion = this.editor.main.__getVersion(); 

		if (drawVersion === "2") {
			if (!data.error) {
				this.__getAndValidateFields(data, flexible);
			}			
			//this.__addValue(data, this.scoringDefinition);			
		}

		data.knowledgeFusionBases = this.$get("#knowledgeFusionBases").getSelectedItems();

		this.__addValue(data, this.queryDefinition);
		this.__addValue(data, this.resultDefinition);
		data.words_limit = $("[control=maxWordLimit]").is(":checked");

		if (self.$get("[control=maxWordLimit]").is(":checked")) {
			const maxWordsChecked = $("input[name='max_characters']:checked").val();
			const numberOfWQords = self.__getNumberOfWords(maxWordsChecked);
			data.number_of_words_radio = maxWordsChecked;
			data.number_of_words = numberOfWQords;
			if (self.$get("[control=customMaxWords]").hasClass("formLabel-rq")) {
				this.__addValue(data, this.customMaxWordsDefinition);
			}
		}
		
		return data;
	};

	adm_process_flow_activity.prototype.__getNumberOfWords = function(maxWordsChecked) { 
		const self = this;
		let numberOfWords;
		self.$get("[control=customMaxWords]").removeClass("formLabel-rq");

		switch (maxWordsChecked) {
			case "max_characters_standard":
			  	numberOfWords = 75;
			  	break;
			case "max_characters_short":
				numberOfWords = 15;
			  	break;
			case "max_characters_long":
				numberOfWords = 150;
			  	break;
			default:
				numberOfWords = self.__handleCustomMaxWords();
				// numberOfWords = parseInt(self.$get("[control=customMaxWords]").val()); 
		}
		
		return numberOfWords;
	};

	adm_process_flow_activity.prototype.__handleCustomMaxWords = function() {
		const self = this;

		self.$get("[control=customMaxWords]").addClass("formLabel-rq");
		return parseInt(self.$get("[control=customMaxWords]").val());
	}


	adm_process_flow_activity.prototype.__getAndValidateField = function($field, data) {

		data.ports = data.ports || [];

		let field = {
			name: $field.find("[field_name]").val() || undefined,
			port_id: $field.attr("template_intent") || undefined,
			intents: []
		};

		//validation
		let error = null;
		if (field.name) {
			if (!field.name) {
				error = "<%=_T('Must enter a name.')%>";
			}
			let name = inConcert.Utils.htmlBodyToPlainText(field.name);
			if (name.trim().length === 0) {
				error = "<%=_T('Invalid name.')%>";
			}
		} 
		else {
			error = "<%=_T('Must enter a name.')%>";
		}

		$field.find("[ic-data-bind=intent]").each(function() {
			let $field_i = $(this);

			let value = $field_i.text();
			let is_template = $field_i.attr("ic-role");

			if (is_template !== "template" && is_template !== "template-qr") {
				field.intents.push(value);
			}
		});

		data.ports.push(field);
	};

	adm_process_flow_activity.prototype.__getAndValidateFields = function(data, flexible) { 

		const self = this;
		this.$get("[field]").each(function() {
			self.__getAndValidateField($(this), data);

			if (data.error && !flexible) {
				return false;
			}
		});

		// valido el slide scoring 
		//this.__addValue(data, this.scoringDefinition); 
	};


	adm_process_flow_activity.prototype.htmlBody = function(data) {
		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_${id}`, 
			description: ((data.description && data.description !== "")?data.description:"<%=_T('Knowledge Fusion')%>") 
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) { 
		

		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "", // error/success/option
			option_label : "Input" // error/success/option
		});

		ports.push(...this.__generate_default_port(data, node)); // debe ir siempre primero
		ports.push(...this.__generate_error_ports(data, node));

		return ports;
	};

	adm_process_flow_activity.prototype.__generate_default_port = function(data, node) {
            
        if (!data.ports) {
            data.ports = [];
        }
        
		let ports = [];
		
		let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
		let conditions = [];
		
		// agrego las condiciones para los errores
		conditions.push({ logic : conditions.length > 0?"and":undefined, field: data.result + ".eventname", comparator: "~=", value: "\"Timeout\"" });
		conditions.push({ logic : conditions.length > 0?"and":undefined, field: data.result + ".eventname", comparator: "~=", value: "\"ChannelClosed\"" });
		conditions.push({ logic : conditions.length > 0?"and":undefined, field: data.result + ".eventname", comparator: "~=", value: "\"Error\"" });

		ports.push({
			direction : "out", // in/out
			type : "option", // error/success/option
			option_label : "<%=_T('Default output')%>", // error/success/option
			channels: "1", // 0, 1 o n
			id: (existe?existe.id:inConcert.Utils.generateGuid() + "_default"),  // le asigno un id por defecto
			preset_value: {
				description: "", //<%=_T('Default output')%>
				conditions: conditions
			}
		});
		
		return ports;
	};

	adm_process_flow_activity.prototype.__generate_error_ports = function(data, node) {
            
        if (!data.ports) {
            data.ports = [];
        }
        
		let ports = [];
		
		let existe = node?node.children.find(c => c.id.includes("_" + "Error")):undefined;

		let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_Error");

		ports.push({
			direction : "out", // in/out
			type : "error", // error/success/option
			option_label : "Error", // error/success/option
			channels: "1", // 0, 1 o n
			id: portId,  // le asigno un id por defecto
			preset_value: {
				description: "", // Error
				conditions: [
					{ field: data.result + ".eventname", comparator: "==", value: "\""+ "Error" +"\"" },
					{ logic: "or", field: data.result + ".eventname", comparator: "==", value: "\""+ "Timeout" +"\"" },
					{ logic: "or", field: data.result + ".eventname", comparator: "==", value: "\""+ "ChannelClosed" +"\"" }
				],
				port_id: portId
			}
		});

		return ports;
	};

}());
