/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert, Mustache, inConcertLanguages */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	const FORMAT = inConcert.Utils.format;

	var id = "send_channel_message";

	if (!inConcert.adm_process_flow_messages_type.notification) {
		inConcert.adm_process_flow_messages_type.notification = {
			sms : inConcert.adm_process_flow_messages_type.base.text,
			whatsapp : inConcert.adm_process_flow_messages_type.base.template,
		};
	}
	
	if (!inConcert.adm_process_flow_messages_type.notification_sorted) {
		inConcert.adm_process_flow_messages_type.notification_sorted = [
			"sms",
			"whatsapp"
		];
	}
	
	//button types
	
	if (!inConcert.adm_process_flow_messages_button.notification) {
		inConcert.adm_process_flow_messages_button.notification = {
			list : inConcert.adm_process_flow_messages_button.base.base,
			gallery : inConcert.adm_process_flow_messages_button.base.base
		};
	}
	
	//quick replies
	
	if (!inConcert.adm_process_flow_messages_quickreply.notification) {
		inConcert.adm_process_flow_messages_quickreply.notification = inConcert.adm_process_flow_messages_quickreply.base;
	}
	
	//clase

	if (typeof inConcert.adm_process_flow_messages.notification !== "function") {
		inConcert.adm_process_flow_messages.notification = inConcert.adm_process_flow_messages.sms;
	}
	
	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);
		this.editor = editor;
		this.frm = editor.main.frm;
		this.node = node;
		var data = editor.GetNodeData(node);
		this.isNew = !data;
		this.data = data || {outputs: []};
		this.whatsappAccounts = [];
		this.smsAccounts = [];
		this.campaigns = [];
		this.whatsAppTemplates = [];

		const self = this;
		this.focusFirst = true;

		this.sendTypeDefinition = {
			id : "sendType",
			name : "<%=_T('Send Type')%>",
			description : "<%=_T('Send Type')%>",
			required : true,
			not_extended : true,
			form_group: true,
			options : [
				{ 
					id : "notification",
					name : "<%=_T('Notification')%>" },
				{ 
					id : "batch",
					name : "<%=_T('Batch')%>" },
			],
			change : function () {
				self.__selectSendType($(this).val());
			}
		};

		this.campaignDefinition = {
			id : "campaign",
			name : "<%=_T('Campaign')%>",
			description : "<%=_T('Campaign')%>",
			required : true,
			not_extended : true,
			form_group: true,
			change: function () {
				self.__loadCampaignAccounts($(this).val());
			}
		};

		this.accountDefinition = {
			id : "account",
			name : "<%=_T('Account')%>",
			description : "<%=_T('Account')%>",
			required : true,
			not_extended : true,
			form_group: true,
			change: function () {
				const messageType = self.$get("input[type=radio][name=message_type]:checked").val();
				if (messageType === "message_type_whatsapp") {
					self.__loadTemplatesSelectInput();
				}
			}
		};

		this.batchDefinition = {
			id : "batch",
			name : "<%=_T('Batch')%>",
			description : "<%=_T('Select batch')%>",
			required: false,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.messageIdDefinition = {
			id : "messageId",
			name : "<%=_T('Template')%>",
			description : "<%=_T('Template')%>",
			not_extended : true,
			form_group: true,
			options : [],
			change: function () {
				self.$get("textarea[flow_designer_text_area_message]").val("");
				self.$get("[message_with_params]").html("");
				self.___loadTemplateLanguages($(this).val());
			}
		};

		this.languageDefinition = {
			id : "language",
			name : "<%=_T('Language')%>",
			description : "<%=_T('Select language')%>",
			not_extended : true,
			form_group: true,
			options : [],
			change: function () {
				self.__loadTemplateText(self.$get("[control=messageId]").val(), $(this).val());
			}
		};

		this.phoneDefinition = {
			id: "phone",
			name: "<%=_T('Phone')%>",
			description: "<%=_T('Phone number')%>",
			required: false,
			not_extended: true,
			form_group: true,
			variable : true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.messageDefinition = { 
            id : "body_text",
            name : "<%=_T('Message')%>",
            description : "<%=_T('Chat message to send.')%>",
            placeholder : "<%=_T('Enter the body message')%>",
            variable: false,
            required : true,
            span: false,
            variableIconClass: "ic_variable_icon far fa-at",
            emojipicker : true,
            brackets: false,
            hyperlinks: true,
            maxLength: 1000,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

		this.messageType = {
			id: "message_type",
			not_extended: true,
			form_group: true,
			inverse_order: true
		};

		this.messageOptions = {
			channels: { CALL: true },
			toggle: false,
			checkboxInput: false,
			type_name: null,
			type_description: null
		};

		this.type = editor.main.data.Type;
		this.messageId = "message";
		this.messagesEditor = new inConcert.adm_process_flow_messages.notification(this);

	}

	inConcert.Utils.inherit(adm_process_flow_activity, inConcert.adm_process_flow_activities.base);

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Send SMS or Whatsapp')%>";
	adm_process_flow_activity.prototype.group = "interaction";
	adm_process_flow_activity.prototype.image = "ico-sms-whatsapp.svg";
	adm_process_flow_activity.prototype.channels = { 
		"CALL" : true
	};

	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver640w popOverFixedHeight flowDesignerGlobalModal botActivity_send_channel_message";
	};

	adm_process_flow_activity.prototype.__addAutocompleteToInput = function () {
		const self = this;
		self.editor.main.LoadVariablesSet();

		self.$get("[flow_designer_variable_input]").each(function() { 
			self.frm.make_autocomplete(
				$(this),
				Array.from(self.editor.main.variables)
			);
		});

		self.$get("[id*='ui-id']").css("z-index", 119);
	};

	adm_process_flow_activity.prototype.__makeContent = function () {
		let $content = this.__makeFormContent();
		let $tabs = this.messagesEditor.Make([], this.data[this.messageId], { error_message_on_top: true }, undefined, $content, true, true);
		$tabs.filter("#tabs-message").hide();
		return $tabs;
	};

	adm_process_flow_activity.prototype.__makeMessageEditor = function () {
		this.embeedMessageEditor = new inConcert.adm_process_flow_messages_embeed(
			this.messagesEditor, this.messageOptions);

		let messageObj = this.data.errorMessage;
		if (messageObj && messageObj.msgtype && !this.messageOptions.message_types.find(msgtype => msgtype.id === messageObj.msgtype)) {
			messageObj = {};
		}
		this.messageObj = this.embeedMessageEditor.Make(messageObj || {});
		return this.messageObj;
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() {
		const self = this;
		const selectedCampaign = self.data.campaign;

        self.messagesEditor.AfterAppendBody();		
        self.messagesEditor.__selectType("text", self.data, true);
        self.$get("[control=messageType").closest(".col-12").remove();
        self.__addAutocompleteToInput();

		self.$get("input[type=radio][name=message_type]").click(function(){	
			const messageType = self.$get("input[type=radio][name=message_type]:checked").val();
			if (messageType === "message_type_sms") {
				self.__selectSMS(selectedCampaign);
				self.$get("[message_with_params]").hide();
				self.$get("#messages_data").show();
				self.$get("textarea[flow_designer_text_area_message]").val(self.data && self.data.message && self.data.message.text);
				self.$get("[message_with_params]").html("");
			} else {
				self.__selectWhatsapp(selectedCampaign);
				self.$get("[message_with_params]").show();
				self.$get("#messages_data").hide();
				self.$get("textarea[flow_designer_text_area_message]").val("");
				self.$get("[message_with_params]").html("");
			}
		});
		
		if (self.data.messageType === "message_type_whatsapp") {
			self.$get(`[value=${self.data.messageType}]`).click();
		} else {
			self.$get(`[value=message_type_sms]`).click();
		}
	};

	adm_process_flow_activity.prototype.__loadTemplateText = function (templateId, selectedLanguage) {
        
		if (templateId === "" || templateId === undefined) {
			return;
		}

		const self = this;
		const template = self.whatsAppTemplates.find((obj) => obj.messages[templateId]);
		const messageType = self.$get("input[type=radio][name=message_type]:checked").val();
		const messagesByLanguage = template.messages[templateId].languages;
		const uniqueLanguage = Object.keys(messagesByLanguage)[0];
		let resultTemplate;
		
		if (selectedLanguage === null || selectedLanguage === "" || selectedLanguage === undefined  || Object.keys(messagesByLanguage).length === 1) {
			self.language = messagesByLanguage[uniqueLanguage];
            self.$get("select[control=language]").val(uniqueLanguage);
		} else {
			self.language = messagesByLanguage[selectedLanguage];
		}

		if (messageType !== "message_type_sms") {
		
			var $template = self.$get("[message_with_params]");
			var $header_template = self.$get("textarea[flow_designer_text_area_message_header]");

			self.textTemplate = new inConcert.TextTemplate({
				header_control : $header_template,
				header_text : resultTemplate,
				example_header_text : "",
				example_header_text_value : "",
				control : $template,
				content : self.language.text,
				placeholders : template.messages[templateId].params,
				values : (self.data.message && self.data.message.template && self.data.message.template.parameters) || [],
				messages : {
					"required" : "<%=_T('Item value is required')%>"
				}
			});
			
		} else {
			resultTemplate = self.language.text;
			self.$get("[message_with_params]").html(resultTemplate);
		}

		self.$get("textarea[flow_designer_text_area_message]").val(resultTemplate);
	};

	adm_process_flow_activity.prototype.__loadTemplatesSelectInput = function () {

        const self = this;
		return new Promise((resolve, _) => {
			const selectedCampaign = self.$get("select[control=campaign]").val();
			self.__loadTemplateMessages(function(_, _2) {
				let $templateSelectOptions = "<option></option>";
				
				$.each(self.whatsAppTemplates, function(_, template) {
					for (const key in template.messages) {
						if (template.messages.hasOwnProperty(key)) {
							const message = template.messages[key];
                            $templateSelectOptions += FORMAT("<option value='{0}'>{1}</option>", message.id, message.id);
						}
					}
				});
				
				self.$get("select[control=messageId]")
					.html("")
					.append($templateSelectOptions);
	
				resolve();
			}, selectedCampaign);
		});
	};

	adm_process_flow_activity.prototype.__changeAvailableAccounts = function (accountList) {
		const self = this;
		const $container = self.$container();
		const $accountDefinitionControl = self.__getControl(self.accountDefinition, $container);
		let matchingAccounts = "";

		$.each(accountList, function(_, account) {
			matchingAccounts += FORMAT("<option value='{0}'>{1}</option>", account.id, account.name);
		});
		$accountDefinitionControl.html(matchingAccounts);
	};

	adm_process_flow_activity.prototype.__getActiveAccounts = function (callback) {

        const forceReload = false;
        
		inConcert.app.getVccCampaigns(forceReload, function(success, campaigns) {
			if (!success) {
				return;
			}
			let campaigns_response = [];
            let new_campaign = true;
        
			campaigns.forEach(function(campaign) {
                new_campaign = true;
				campaign.accounts.forEach(function(account){
					if (account.state === "1" && (account.proxyType === "WHATSAPP" || account.proxyType === "SMS")) {
                        if (new_campaign) {
                            campaigns_response.push(campaign);
                            new_campaign = false;
                        }
					}
				});
			}); 

			callback(campaigns_response);
		});
	};

	adm_process_flow_activity.prototype.__loadCampaignAccounts = function (campaignId, callback) {

		callback = callback || function(){};

		if (!campaignId) {
			return callback();
		}

		const self = this;
		const messageType = self.$get("input[type=radio][name=message_type]:checked").val();
		let accountType;
		if (messageType === "message_type_whatsapp") {
			accountType = "WHATSAPP";
		} else {
			accountType = "SMS";
		}
		const campaign = self.campaigns.find((obj) => obj.Id === campaignId);

        if (campaign) {
            let accounts = [];
            let $selectOptions = "<option></option>";
            let campaignAccounts = campaign.accounts;
            campaignAccounts.forEach(function(account){
                if (account.state === "1" && account.proxyType === accountType) {
                    accounts.push({
                        id       : account.id,
                        name     : campaign.getAccountName(account),
                        type     : account.proxyType
                    });
                    $selectOptions += FORMAT("<option value='{0}'>{1}</option>", account.id, campaign.getAccountName(account));
                }
            });
            const formatedAccounts = accounts.map((obj) => {
                const id = obj.id;
                const name = obj.name;
                
                return { id, name };
            });

            self.accountDefinition.options = formatedAccounts;

            self.$get("select[control=account]")
                .html("")
                .append($selectOptions);
            
            self.$get("select[control=language]").html("");            
            self.$get("select[control=messageId]").html("");
            self.$get("select[control=account]").val(self.data.account);
            
            if (self.data.messageType === "message_type_whatsapp") {
                self.__loadTemplatesSelectInput().then(() => {
                    self.___loadTemplateLanguages(self.data.messageId);
                    if (self.data.messageType === "message_type_whatsapp") {
                        self.$get("select[control=messageId]").val(self.data.messageId);
                    }
                });
            }
            
            self.$get("textarea[flow_designer_text_area_message]").val("");
            self.$get("[message_with_params]").html("");
            if (self.data.message) {
                self.$get("textarea[flow_designer_text_area_message]").val(self.data.message.text);
                self.$get("[message_with_params]").html(self.data.message.text);
            }    
        }
		
		return callback();
	};

	adm_process_flow_activity.prototype.__loadTemplateMessages = function(callback, campaignId) {

        var self = this;
        self.whatsAppTemplates = [];

        if (!campaignId) {
			return callback(false);
		}
		
		const campaign = self.campaigns.find((obj) => obj.Id === campaignId);
		const selectedAccount = self.$get("select[control=account]").val();

        if (campaign) {
            campaign.loadTemplateMessageOptions(selectedAccount, 1, true,
                function(options) {
                    if (!options) {
                        return callback(false, "<%=_T('Error loading template messages')%>");
                    }
                    self.templateMessageOptions = {};
                    self.templateMessageOptions_a = [];
                    $.each(options, function(_, option) {
                        if (!option.available) {
                            return;
                        }
                        let group;
                        if (self.templateMessageOptions[option.groupId]) {
                            group = self.templateMessageOptions[option.groupId];
                        }
                        else {
                            group = {
                                groupId : option.groupId,
                                groupName : option.groupName || option.groupId,
                                messages : {}
                            };
                            self.templateMessageOptions[option.groupId] = group;
                            self.templateMessageOptions_a.push(group);
                        }
                        group.messages[option.id] = option;
                    });
                    self.templateMessageOptions_a.sort(function(a, b) {
                        return a.groupName.localeCompare(b.groupName);
                    });
                    self.whatsAppTemplates = self.templateMessageOptions_a;
                    callback(true);
                });
        } else {
            callback(true);
        }
	};

	adm_process_flow_activity.prototype.___loadTemplateLanguages = function(templateId) {

		if (!templateId) {
			return;
		}

		const self = this;
		self.___toggleShowLanguages(true);
		const template = self.whatsAppTemplates.find((obj) => obj.messages[templateId]);

        if (template) {
            const templateLanguages = template.messages[templateId].languages;
            self.template = template.messages[templateId];

            if (Object.keys(templateLanguages).length <= 1) 
            {	
                self.___toggleShowLanguages(false);
                self.__loadTemplateText(templateId, undefined);
                return;
            }
            var languages_a = [];
            $.each(templateLanguages || {}, function(id, language) {
                languages_a.push({
                    id : id,
                    label : inConcertLanguages.getLanguageLabel(id),
                    text : language.text
                });
            });
            languages_a.sort(function(a, b) {
                return a.label.localeCompare(b.label);
            });
            var $languages = [];
            $.each(languages_a, function(_, language) {
                var $language = FORMAT("<option value='{0}'>{1}</option>",
                    language.id, language.label);
                $languages.push($language);
            });
            if ($languages.length === 0 || $languages.length > 1) {
                var $language = $("<option></option>");
                $language.attr("title", "<%=_T('User language is used to select which message send')%>");
                $languages.unshift($language);
            }
            self.$get("select[control=language]")
                .html("")
                .append($languages);

            self.$get("select[control=language]").val(self.data.language);

            self.__loadTemplateText(templateId, self.data.language);
        }
	};

	adm_process_flow_activity.prototype.___toggleShowLanguages = function(show) {
		const self = this;

		if (show) {
			this.__showControl(this.languageDefinition);
			const languageDefinition = this.$get("[control_label=language]");
			if (languageDefinition.hasClass("formLabel-rq")) {
				languageDefinition.addClass("formLabel-rq");
			}
			this.languageDefinition.required = true;
		} else {
			this.__hideControl(this.languageDefinition);
			const languageDefinition = this.$get("[control_label=language]");
			if (languageDefinition.hasClass("formLabel-rq")) {
				languageDefinition.removeClass("formLabel-rq");
			}
			this.languageDefinition.required = false;
			self.$get("select[control=language]").html("");
		}
	};

	adm_process_flow_activity.prototype.__load = function(callback) {
		const self = this;
		self.__getActiveAccounts(function(campaigns) {
			self.campaigns = campaigns;
			callback();
		});
	};

	adm_process_flow_activity.prototype.__toggleCampaignsSmsWhatsapp = function(channel, selectedCampaign) {

		const self = this;
		const formatedCampaigns = self.campaigns
				.map((obj) => {
					const id = obj.Id;
					const name = obj.Name;

					if (obj.accounts.find((account) => account.proxyType === channel)) {
						return { id, name };
					}
					
						return null;
				})
				.filter((campaign) => campaign !== null);

		let $selectOptions = "<option value=''></option>";

		$.each(formatedCampaigns, function(_, campaign) {
			$selectOptions += FORMAT("<option value='{0}'>{1}</option>", campaign.id, campaign.name);
		});

        self.$get("select[control=campaign]")
					.html("")
					.append($selectOptions);

        self.$get("select[control=campaign]").val(selectedCampaign);
	};

	adm_process_flow_activity.prototype.__selectSendType = function (actionType, initial) {

		const self = this;
		this.__clearErrors();
		const messageType = self.$get("input[type=radio][name=message_type]:checked").val();

		if (messageType !== "message_type_whatsapp") {
			self.__smsSendType(actionType, initial);
		} else {
			self.__whatsappSendType(actionType, initial);
		}
	};

	adm_process_flow_activity.prototype.__whatsappSendType = function (actionType, initial) {
		switch (actionType) {
			case "notification":
				this.__selectWhatsapp(initial, actionType);
				break;
			case "batch":
				this.__selectWhatsappBatch(initial);
				break;
		}
	};

	adm_process_flow_activity.prototype.__smsSendType = function (actionType, initial) {
		switch (actionType) {
			case "notification":
				this.__selectNotification(initial);
				break;
			case "batch":
				this.__selectBatch(initial);
				break;
		}
	};

	adm_process_flow_activity.prototype.__selectSMS = function (campaign) {
		const self = this;
		const selectedCampaign = campaign || self.$get("select[control=campaign]").val();
		this.__selectSendType(self.data[self.sendTypeDefinition.id] || "notification", true);
        self.__toggleCampaignsSmsWhatsapp("SMS", selectedCampaign);
        self.__loadCampaignAccounts(selectedCampaign);
        
	};

	adm_process_flow_activity.prototype.__selectWhatsapp = function (campaign, actionType) {

		const self = this;
		const selectedCampaign = campaign || self.$get("select[control=campaign]").val();

		this.__showControl(this.messageIdDefinition);
        this.__showControl(this.phoneDefinition);
        
        this.__hideControl(this.languageDefinition);
        this.__hideControl(this.batchDefinition);

        const messageIdDefinition = this.$get("[control_label=messageId]");
        if (!messageIdDefinition.hasClass("formLabel-rq")) {
            messageIdDefinition.addClass("formLabel-rq");
        }
        this.messageIdDefinition.required = true;

        const languageDefinition = this.$get("[control_label=language]");
        if (!languageDefinition.hasClass("formLabel-rq")) {
            languageDefinition.removeClass("formLabel-rq");
        }
        this.languageDefinition.required = false;

        const batchDefinition = this.$get("[control_label=batch]");
        if (batchDefinition.hasClass("formLabel-rq")) {
            batchDefinition.removeClass("formLabel-rq");
        }
        this.batchDefinition.required = false;

        self.__toggleCampaignsSmsWhatsapp("WHATSAPP", selectedCampaign);

		if (selectedCampaign) {
            self.__loadCampaignAccounts(selectedCampaign);
		}

        if (actionType === "batch" || (!actionType && self.data.sendType === "batch")) {
            self.__selectWhatsappBatch();
        }
        
	};

	adm_process_flow_activity.prototype.__selectWhatsappBatch = function () {

		this.__showControl(this.messageIdDefinition);
		this.__showControl(this.batchDefinition);
		this.__showControl(this.phoneDefinition);
		
		const messageIdDefinition = this.$get("[control_label=messageId]");
		if (!messageIdDefinition.hasClass("formLabel-rq")) {
			messageIdDefinition.addClass("formLabel-rq");
		}
		this.messageIdDefinition.required = true;

		const batchDefinition = this.$get("[control_label=batch]");
		if (batchDefinition.hasClass("formLabel-rq")) {
			batchDefinition.addClass("formLabel-rq");
		}
		this.batchDefinition.required = true;
	};

	adm_process_flow_activity.prototype.__selectNotification = function () {
		this.__showControl(this.sendTypeDefinition);
		this.__showControl(this.phoneDefinition);

		this.__hideControl(this.batchDefinition);
		this.__hideControl(this.messageIdDefinition);
		this.__hideControl(this.languageDefinition);

		const sendTypeDefinition = this.$get("[control_label=sendType]");
		if (!sendTypeDefinition.hasClass("formLabel-rq")) {
			sendTypeDefinition.addClass("formLabel-rq");
		}
		this.sendTypeDefinition.required = true;

		const batchDefinition = this.$get("[control_label=batch]");
		if (batchDefinition.hasClass("formLabel-rq")) {
			batchDefinition.removeClass("formLabel-rq");
		}
		this.batchDefinition.required = false;

		const messageIdDefinition = this.$get("[control_label=messageId]");
		if (messageIdDefinition.hasClass("formLabel-rq")) {
			messageIdDefinition.removeClass("formLabel-rq");
		}
		this.messageIdDefinition.required = false;

		const languageDefinition = this.$get("[control_label=language]");
		if (languageDefinition.hasClass("formLabel-rq")) {
			languageDefinition.addClass("formLabel-rq");
		}
		this.languageDefinition.required = false;
	};

	adm_process_flow_activity.prototype.__selectBatch = function () {
		this.__showControl(this.sendTypeDefinition);
		this.__showControl(this.phoneDefinition);
		this.__showControl(this.batchDefinition);
		
		this.__hideControl(this.messageIdDefinition);
		this.__hideControl(this.languageDefinition);

		const sendTypeDefinition = this.$get("[control_label=sendType]");
		if (!sendTypeDefinition.hasClass("formLabel-rq")) {
			sendTypeDefinition.addClass("formLabel-rq");
		}
		this.sendTypeDefinition.required = true;

		const batchDefinition = this.$get("[control_label=batch]");
		if (!batchDefinition.hasClass("formLabel-rq")) {
			batchDefinition.addClass("formLabel-rq");
		}
		this.batchDefinition.required = true;

		const messageIdDefinition = this.$get("[control_label=messageId]");
		if (messageIdDefinition.hasClass("formLabel-rq")) {
			messageIdDefinition.removeClass("formLabel-rq");
		}
		this.messageIdDefinition.required = false;

		const languageDefinition = this.$get("[control_label=language]");
		if (languageDefinition.hasClass("formLabel-rq")) {
			languageDefinition.addClass("formLabel-rq");
		}
		this.languageDefinition.required = false;
	};
	
	adm_process_flow_activity.prototype.__makeFormContent = function () {
		const $content = adm_process_flow_activity.uber.__makeContent.call(this);
	 
		$content.unshift(
		  this.__makeDivFlex(
			[
			  this.__makeDivFlex(
				[
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						$(
						  Mustache.render(
							inConcert.templates.process_flows
							  .sms_whatsapp_radiobuttons,
							{
							  guid: inConcert.Utils.generateGuid(),
							}
						  )
						),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeComboFlex(
						  this.sendTypeDefinition,
						  this.data[this.sendTypeDefinition.id]
						),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeInputFlex(
							this.batchDefinition, 
							this.data[this.batchDefinition.id]
						),
						{ class: "col-12", hidden: true }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeComboFlex(
						  this.campaignDefinition,
						  this.data[this.campaignDefinition.id]
						),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeComboFlex(
						  this.accountDefinition,
						  this.data[this.accountDefinition.id]
						),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeComboFlex(
						  this.messageIdDefinition,
						  this.data[this.messageIdDefinition.id]
						),
						{ class: "col-12", hidden: true }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeComboFlex(
						  this.languageDefinition,
						  this.data[this.languageDefinition.id]
						),
						{ class: "col-12", hidden: true }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeInputFlex(
						  this.phoneDefinition,
						  this.data[this.phoneDefinition.id]
						),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeDivFlex(null, {
							class: "flowDesignerMessagesTemplateText form-control",
							persoTags: "message_with_params",
						  }),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
				],
				{ class: "card-block" }
			  ),
			],
			{ class: "card no-card" }
		  )
		);
	  
		return $content;
	  };
	  

	adm_process_flow_activity.prototype.__getAndValidate = function() {
		const data = adm_process_flow_activity.uber.__getAndValidate.call(this);

		const messageType = this.$get("input[type=radio][name=message_type]:checked").val();
		data.messageType = messageType;

		this.__addValue(data, this.sendTypeDefinition);
		if (messageType === "message_type_sms") {
			this.__getAndValidateSms(data); 
		} else {
			this.__getAndValidateWhatsapp(data);
		}

		if (data[this.sendTypeDefinition.id] === "batch") {
			this.__addValue(data, this.batchDefinition);
		}

		return data;
	};

	adm_process_flow_activity.prototype.__getAndValidateSms = function (data) {
		this.__addValue(data, this.campaignDefinition);
		this.__addValue(data, this.accountDefinition);
		this.__addValue(data, this.phoneDefinition);
	};

	adm_process_flow_activity.prototype.__getAndValidateWhatsapp = function (data) {
		this.__addValue(data, this.campaignDefinition);
		this.__addValue(data, this.accountDefinition);
		this.__addValue(data, this.messageIdDefinition);
		this.__addValue(data, this.languageDefinition);
		this.__addValue(data, this.phoneDefinition);

		var textData = this.textTemplate.get(true);
		if (textData.error) {
			data.error = textData.error;
			return;
		}

		data.message = data.message || {};
        data.message.template = this.template || data.message.template || {};
		data.message.template.parameters = textData.values;
		data.message.template.text = textData.template_text;
		data.message.template.id = data.messageId;
		data.message.template.language = this.language ? this.language.code : data.language;
		data.message.template.account = data.account;
		data.message.template.group = this.template.groupId;

        delete data.message.template.groupId;
        delete data.message.template.groupName;
        delete data.message.template.languages;
        delete data.message.template.status;
        delete data.message.template.params;
        delete data.message.template.available;

		data.text = textData.text;

        console.log("data", data);

		this.$get("textarea[flow_designer_text_area_message]").val(textData.text);
	};
	
	adm_process_flow_activity.prototype.__getAndValidateAsync = function(data, callback) {
		if (data.messageType === "message_type_sms") {
			this.messagesEditor.AddValue(data, this.messageId, function() {
				callback(data);
			});
		} else {
			callback(data);
		}
	};

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image;

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id;
		}

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_send_channel_message`,
			description: data.description
		});
	};

	adm_process_flow_activity.prototype.ports = function (_, node) { 

		let ports = [];

		ports.push({
			direction: "in", // in/out
			type: "option", // error/success/option
			option_label: "Input" // error/success/option
		});

		// agrego puerto único por defecto
		let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
		const portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");
		ports.push({
			direction : "out", // in/out
			type : "option", // error/success/option/none
			option_label : "<%=_T('Default output')%>", // error/success/option
			channels: "1", // 0, 1 o n
			id: portId,  // le asigno un id por defecto
			preset_value: {
				description: "",
				conditions: [],
				port_id: portId
			},
			intern_value: undefined
		});

		return ports;
	};

	adm_process_flow_activity.prototype.__cancel = function(callback) {
		if (this.isNew) {
			this.editor.CancelConnection(this.connector);
		}
		callback();
	};

	adm_process_flow_activity.prototype.__save = function(data, callback) {
		this.editor.AddOrUpdateActivity(this.node, data);
		callback(true);
	};

}());
