/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const format = inConcert.Utils.format;
	const id = "start_webcontact";
	// var templates = inConcert.templates.process_flows;

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		this.frm = editor.main.frm;

		this.campaignDefinition = {
			id: "toCampaign",
			name: "<%=_T('Campaign')%>",
			description: "<%=_T('Id of campaign to send interaction.')%>",
			//placeholder: "<%=_T('Enter campaign')%>...", 
			required: true,
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.accountDefinition = {
			id: "toAccount",
			name: "<%=_T('Account')%>",
			description: "<%=_T('Id or name of account to send interaction.')%>",
			//placeholder: "<%=_T('Enter account')%>...", 
			required: true,
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.externalIdDefinition = {
			id: "externalId",
			name: "<%=_T('Contact Id')%>",
			description: "<%=_T('Contact external id.')%>",
			//placeholder: "<%=_T('Enter contact external id')%>...", 
			required: false,
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.nameDefinition = {
			id: "name",
			name: "<%=_T('Contact Name')%>",
			description: "<%=_T('Contact name.')%>",
			//placeholder: "<%=_T('Enter contact name')%>...", 
			required: false,
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.addressesDefinition = {
			id: "addresses",
			name: "<%=_T('Contact Addresses')%>",
			description: format("<%=_T('An array of contact addresses. Example: {0}')%>",
				"{ { type = \"MAIL\", address = \"myaddress@mail.com\" }, { type = \"CELLULAR\", address = \"1234\" } }"),
			//placeholder: "<%=_T('Enter contact addresses')%>...", 
			required: false,
			variable: true,
			not_extended: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.agentDataDefinition = {
			id: "agentData",
			name: "<%=_T('Agent Data')%>",
			description: format("<%=_T('An array of data to be used by agent. Example: {0}')%>",
				"{ { name = \"visible_item\", displayName = \"my visible item\", value = \"my visible value\" }, { name = \"hidden_item\", value = \"my hidden value\", hidden = true } }"),
			//placeholder: "<%=_T('Enter agent data')%>...", 
			required: false,
			variable: true,
			not_extended: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.reportingDataDefinition = {
			id: "reportingData",
			name: "<%=_T('Reporting Data')%>",
			description: format("<%=_T('An array of data to be used in reports. Example: {0}')%>",
				"{ { name = \"my_item\", value = \"my item value\" } }"),
			//placeholder: "<%=_T('Enter reporting data')%>...", 
			required: false,
			variable: true,
			not_extended: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.reportingGroupDefinition = {
			id: "reportingGroup",
			name: "<%=_T('Reporting Group')%>",
			description: "<%=_T('Name of the reporting group. Empty if do not want to use data in reports.')%>",
			//placeholder: "<%=_T('Enter reporting group')%>...", 
			required: false,
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.resultDefinition = {
			id: "result",
			name: "<%=_T('Result')%>",
			placeholder: "<%=_T('Enter result')%>...", 
			description: "<%=_T('Variable to store state result ({ result : OK|error code, reason : string error message }).')%>",
			controlContainerClass: "position-relative",
			form_group: true
		};

		this.focusControl = this.ipDefinition;
	}
	
	inConcert.Utils.inherit(adm_process_flow_activity, inConcert.adm_process_flow_activities.base);
	
	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}
	
	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Contact Form')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Starts a contact form interaction.')%>";
	adm_process_flow_activity.prototype.group = "interaction";
	adm_process_flow_activity.prototype.image = "ico-start-webcontact.svg";
	
	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver640w flowDesignerGlobalModal botActivity_start_webcontact";
	};

	adm_process_flow_activity.prototype.GetActivityDeclaredVariables = function(data) {
		if (data.result && data.result !== "") {
			return [data.result];
		}
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() { 
		const self = this;
		const $inputs = self.$get("span[class=ic_variable_icon_container");
		self.__addAutocompleteToInput($inputs);
	};

	adm_process_flow_activity.prototype.__makeContent = function () { 
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);

		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.campaignDefinition,
							this.data[this.campaignDefinition.id]
						  ),
						  { class: "col-6" }
						),
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.accountDefinition,
							this.data[this.accountDefinition.id]
						  ),
						  { class: "col-6" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.externalIdDefinition,
							this.data[this.externalIdDefinition.id]
						  ),
						  { class: "col-6" }
						),
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.nameDefinition,
							this.data[this.nameDefinition.id]
						  ),
						  { class: "col-6" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.reportingDataDefinition,
							this.data[this.reportingDataDefinition.id]
						  ),
						  { class: "col-6" }
						),
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.addressesDefinition,
							this.data[this.addressesDefinition.id]
						  ),
						  { class: "col-6" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.reportingGroupDefinition,
							this.data[this.reportingGroupDefinition.id]
						  ),
						  { class: "col-6" }
						),
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.agentDataDefinition,
							this.data[this.agentDataDefinition.id]
						  ),
						  { class: "col-6" }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.resultDefinition,
							this.data[this.resultDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );		  
					
		return $content;
	};


	adm_process_flow_activity.prototype.__getAndValidate = function () {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		this.__addValue(data, this.campaignDefinition);
		this.__addValue(data, this.accountDefinition);
		this.__addValue(data, this.externalIdDefinition);
		this.__addValue(data, this.nameDefinition);
		this.__addValue(data, this.addressesDefinition);
		this.__addValue(data, this.agentDataDefinition);
		this.__addValue(data, this.reportingDataDefinition);
		this.__addValue(data, this.reportingGroupDefinition);
		this.__addValue(data, this.resultDefinition);
		return data;
	};
	

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id + "_" + type;
		}

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_start_webcontact`,
			description: ((data.description && data.description !== "") ? data.description : "<%=_T('Contact form')%>")
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) { 
		

		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "option", // error/success/option
			option_label : "Input" // error/success/option
		});

		// agrego puerto único por defecto
		let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
		let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");
		ports.push({
			direction : "out", // in/out
			type : "option", // error/success/option/none
			option_label : "<%=_T('Default output')%>", // error/success/option
			channels: "n", // 0, 1 o n
			id: portId,  // le asigno un id por defecto
			preset_value: undefined, 
			intern_value: undefined
		});

		return ports;
	};

}());
