/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const id = "validate_phone";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		this.frm = editor.main.frm;

		this.phoneDefinition = {
			id: "phone",
			name: "<%=_T('Phone number')%>",
			required: true,
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.countryDefinition = {
			id: "country",
			name: "<%=_T('Country')%>",
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.areaCodeDefinition = {
			id: "areaCode",
			name: "<%=_T('Area code')%>",
			not_extended: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			form_group: true
		};

		this.resultDefinition = {
			id: "result",
			name: "<%=_T('Result')%>",
			placeholder: "<%=_T('Enter result')%>...", 
			description: "<%=_T('Variable to store state result ({ result : OK|error code, reason : string error message }).')%>",
			controlContainerClass: "position-relative",
			form_group: true
		};

		this.focusControl = this.ipDefinition;
	}

	inConcert.Utils.inherit(adm_process_flow_activity, inConcert.adm_process_flow_activities.base);
	
	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}
	
	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Validate Phone')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Validate Phone')%>";
	adm_process_flow_activity.prototype.group = "interaction";
	adm_process_flow_activity.prototype.image = "ico-phone.svg";
	
	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver640w flowDesignerGlobalModal botActivity_validate_phone";
	};

	adm_process_flow_activity.prototype.GetActivityDeclaredVariables = function(data) {
		if (data.result && data.result !== "") {
			return [data.result];
		}
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() { 
		const self = this;
		const $inputs = self.$get("span[class=ic_variable_icon_container");
		self.__addAutocompleteToInput($inputs);
	};

	adm_process_flow_activity.prototype.__makeContent = function () {
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);
	  
		$content.unshift(
		  this.__makeDivFlex(
			[
			  this.__makeDivFlex(
				[
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeInputFlex(
						  this.phoneDefinition,
						  this.data[this.phoneDefinition.id]
						),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
	  
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeInputFlex(
						  this.countryDefinition,
						  this.data[this.countryDefinition.id]
						),
						{ class: "col-6" }
					  ),
					  this.__makeDivFlex(
						this.__makeInputFlex(
						  this.areaCodeDefinition,
						  this.data[this.areaCodeDefinition.id]
						),
						{ class: "col-6" }
					  ),
					],
					{ class: "row" }
				  ),
	  
				  this.__makeDivFlex(
					[
					  this.__makeDivFlex(
						this.__makeInputFlex(
						  this.resultDefinition,
						  this.data[this.resultDefinition.id]
						),
						{ class: "col-12" }
					  ),
					],
					{ class: "row" }
				  ),
				],
				{ class: "card-block" }
			  ),
			],
			{ class: "card no-card" }
		  )
		);
	  
		return $content;
	  };
	  


	adm_process_flow_activity.prototype.__getAndValidate = function () {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		this.__addValue(data, this.phoneDefinition);
		this.__addValue(data, this.areaCodeDefinition);
		this.__addValue(data, this.countryDefinition);
		this.__addValue(data, this.resultDefinition);
		return data;
	};
	

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id;
		}

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_${image}`,
			description: ((data.description && data.description !== "") ? data.description : "<%=_T('Validate Phone')%>")
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) { 
		

		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "option", // error/success/option
			option_label : "Input" // error/success/option
		});

		// agrego puerto único por defecto
		let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
		let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");
		ports.push({
			direction : "out", // in/out
			type : "option", // error/success/option/none
			option_label : "<%=_T('Success')%>", // error/success/option
			channels: "n", // 0, 1 o n
			id: portId,  // le asigno un id por defecto
			preset_value: {
				description: "", //"Error"
				conditions: [
					{ field: "_result", comparator: "~=", value: "nil" }
				],
				port_id: portId
			}
		});

		let unificar_errores = true;
		
		if (unificar_errores) {

			let existe = node?node.children.find(c => c.id.includes("_" + "Error")):undefined;
			let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_" + "Error");
			ports.push({
				direction : "out", // in/out
				type : "error", // error/success/option
				option_label : "Error", // error/success/option
				channels: "1", // 0, 1 o n
				id: portId,  // le asigno un id por defecto
				preset_value: {
					description: "", //"Error"
					conditions: [
						{ field: "_result", comparator: "==", value: "nil" }
					],
					port_id: portId
				}
			});

		} else {
			let errores_admitidos = ["Error"];
			errores_admitidos.forEach(error_type => {
				let existe = node?node.children.find(c => c.id.includes("_" + error_type)):undefined;
				let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_" + error_type);
				ports.push({
					direction : "out", // in/out
					type : "error", // error/success/option
					option_label : error_type, // error/success/option
					channels: "1", // 0, 1 o n
					id: portId,  // le asigno un id por defecto
					preset_value: {
						description: "", //error_type
						conditions: [
							{ field: data.result + ".eventname", comparator: "==", value: "\""+ error_type +"\"" }
						],
						port_id: portId
					}
				});
			});
		}

		return ports;
	};

}());
