/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	function adm_process_flow_export_classes_popup(main) {
		adm_process_flow_export_classes_popup.uber.constructor.call(this);
		this.main = main;
		this.showEditTitleButton = false;
		
		this.classesDefinition = {
			id : "Classes",
			name : "<%=_T('Classes')%>",
			description : "<%=_T('Classes to be exported.')%>",
			sort : true,
			selectAll : true,
			required : true
		};
		
		this.focusFirst = true;
	}

	inConcert.Utils.inherit( adm_process_flow_export_classes_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_export_classes_popup !== "function") {
		inConcert.adm_process_flow_export_classes_popup = adm_process_flow_export_classes_popup;
	}

	adm_process_flow_export_classes_popup.prototype.__getClassName = function() {
		return "popUp380w flowDesignerGlobalModal";
	};

	adm_process_flow_export_classes_popup.prototype.__getTitle = function() {
		return "<%=_T('Export Classes')%>";
	};

	adm_process_flow_export_classes_popup.prototype.__makeContent = function() {
		var self = this;
		self.classesDefinition.options = [];
		$.each(self.main.classes, function(_, classEditor) {
			if (classEditor.IsReadonly()) {
				return;
			}
			self.classesDefinition.options.push({
				id : classEditor.data.Id,
				name : classEditor.data.Name
			});
		});
		
		var $content = [];
		$content.push(self.__makeCheckboxList(self.classesDefinition));
		return $content;
	};

	adm_process_flow_export_classes_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.classesDefinition);
		return data;
	};

	adm_process_flow_export_classes_popup.prototype.__save = function(data, callback) {
		var self = this;
		var classes = [];
		$.each(data[self.classesDefinition.id], function(classId) {
			classes.push(classId);
		});
		self.main.ExportClasses(classes, function(status, error) {
			callback(status, error);
		});
	};

}());
