/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;
	
	function adm_process_flow_import_classes_popup(main) {
		adm_process_flow_import_classes_popup.uber.constructor.call(this);
		this.main = main;
		this.showEditTitleButton = false;
		
		var self = this;
		
		this.fileDefinition = {
			id : "File",
			name : "<%=_T('File')%>",
			description : "<%=_T('File to be imported.')%>",
			required : true,
			validate : {
				extension : {
					types : {
						json : true
					},
					message : "<%=_T('Unsupported extension file. Only json.')%>"
				}
			}
		};
		
		this.classesDefinition = {
			id : "Classes",
			name : "<%=_T('Classes')%>",
			description : "<%=_T('Classes to be exported.')%>",
			sort : true,
			selectAll : true,
			required : true
		};
	}

	inConcert.Utils.inherit( adm_process_flow_import_classes_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_import_classes_popup !== "function") {
		inConcert.adm_process_flow_import_classes_popup = adm_process_flow_import_classes_popup;
	}

	adm_process_flow_import_classes_popup.prototype.__getClassName = function() {
		// return "flowDesignerImportClassesPopup hybridDesignContainer";
		return "popUp380w flowDesignerGlobalModal flowDesignerOverlayModal";
	};

	adm_process_flow_import_classes_popup.prototype.__getTitle = function() {
		return "<%=_T('Import Classes')%>";
	};

	adm_process_flow_import_classes_popup.prototype.__makeContent = function() {
		var self = this;
		var $content = [];
		$content.push(
			/*
			self.__makeRowFlex(
				self.__makeUpload(self.fileDefinition, function(file, onReady, onProgress, onEnd) {
				self.__uploadFile(file, onReady, onProgress, onEnd);})
			)
			*/
			self.__makeDivFlex(
				[
				  self.__makeDivFlex(
					[
					  self.__makeRowFlex([
						self.__makeDivFlex(
						  [
							self.__makeRowFlex(
								self.__makeUpload(self.fileDefinition, function(file, onReady, onProgress, onEnd) {
								self.__uploadFile(file, onReady, onProgress, onEnd);})
							)
						  ],
						  { class: "form-group" }
						),
					  ]),
					],
					{ class: "card-block" }
				  ),
				],
				{ class: "card no-card flowDesignerClassesPopupImport" }
			)
		);
		return $content;
	};
	
	adm_process_flow_import_classes_popup.prototype.__makeActions = function() {
		var $actions = adm_process_flow_import_classes_popup.uber.__makeActions.call(this);
		$actions.filter("[action=save]").prop("disabled", true);
		return $actions;
	};
	
	adm_process_flow_import_classes_popup.prototype.__uploadFile = function(file, onReady, onProgress, onEnd) {
		var self = this;
		if (self.$classes) {
			self.$classes.remove();
			self.$classes = null;
		}
		self.$get("[action=save]").prop("disabled", true);
		onReady();
		var flowAPI = inConcert.app.getFlowDesignerAPI();
		flowAPI.importFlowClasses(file, function(status, data) {
			var message = "";
			if (!status) {
				switch(data && data.result) {
					case "SYSTEM_CLASS":
						message = "<%=_T('A system class has same name.')%>";
						break;
					default :
						message = "<%=_T('Error loading file.')%>";
						break;
				}
			}
			onEnd(status, message);
			if (status) {
				self.__loadClasses(data.classes || {});
			}
		}, onProgress);
	};
	
	adm_process_flow_import_classes_popup.prototype.__loadClasses = function(classes) {
		var self = this;
		if ($.isEmptyObject(classes)) {
			self.__showError("<%=_T('There are no classes to be imported.')%>");
			return;
		}
		self.classes = classes;
		self.classesDefinition.options = [];
		$.each(classes, function(_, flowClass) {
			self.classesDefinition.options.push({
				id : flowClass.data.Id,
				name : flowClass.data.Name
			});
		});
		self.$classes = self.__makeCheckboxList(self.classesDefinition);
		self.__addContent(self.$classes);
		self.$get("[action=save]").prop("disabled", false);
	};

	adm_process_flow_import_classes_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.classesDefinition);
		return data;
	};

	adm_process_flow_import_classes_popup.prototype.__save = function(data, callback) {
		var self = this;
		var classes = [];
		var overrideClasses = "";
		$.each(data[self.classesDefinition.id], function(classId) {
			var flowClass = self.classes[classId];
			//existing id with different name
			if (flowClass.existingId && flowClass.existingId !== flowClass.data.Name) {
				flowClass.data.Id = inConcert.Utils.generateGuid();
			}
			//existing name (will be overrided)
			if (flowClass.existingName) {
				flowClass.data.Id = flowClass.existingName;
				overrideClasses = overrideClasses + (overrideClasses? ", " : "") + flowClass.data.Name;
			}
			//add class
			classes.push(flowClass.data);
		});
		
		function doImport() {
			classes.sort(function(a, b) {
				return a.Name.localeCompare(b.Name);
			});
			self.main.ImportClasses(classes, function(status) {
				callback(status, status? "<%=_T('Error importing classes.')%>" : "");
			});
		}
		
		if (!overrideClasses) {
			return doImport();
		}
		$.inconcertPopup.Show(
			"<%=_T('Confirmation')%>",
			format("<%=_T('These classes already exists and will be overrided: {0}.')%>", overrideClasses),
			$.inconcertPopup.ButtonSets.BS_YESNO,
			function(response) {
				switch(response.toLowerCase()) {
					case "yes":
						return doImport();
				}
				callback(false);
			},
			undefined,
			{
				popup_id        : "conf_inconcertPopup",
				container_class : "popUp380w confirmationPopUp",
				overlay_class   : "confirmationOverlay"
			}
		);
	};

}());
