
/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if ( !this.inConcert ) {
  this.inConcert = {};
}
if (!inConcert.templates) {
	inConcert.templates = {};
}

(function () {

'use strict';

var Templates = {
	//designer
	base: "".concat(
		"<div id='flowDesignerClassesContainer' class='flowDesignerClassesContainer'>",
				"<div class='flowDesignerClassesTitle  pageHeader'>",
					"<div class='pageButtonContainer ' style=''>",
						"<button  close_button  class='butBackToDashboardArrow d-flex mr-0'>", 
							"<i class='fas fa-chevron-left mr-0'></i>",
						"</button>",
					"</div>",
					"<div class='pageTitleContainer' style=''>",
						'<i class="far fa-brackets-curly"></i>',
						'<label class="flowDesignerClassesTitleText pageTitle d-flex">',
							'<%=_T("Classes IDE")%>',
							'<span context_name class="flowDesignerName"></span>',
						'</label>',
					"</div>",
					"<div class='pageButtonContainer ml-auto' style=''>",
						"<div global_actions class='flowDesignerClassesGlobalActions'>",
						"</div>",
					"</div>",
				"</div>",		
			"<div processing class='flowDesignerClassesProcessing' hidden>",
			"</div>",
			/*"<div actions_bar class='flowDesignerClassesActionsBar'>",
				"<div editor_actions class='flowDesignerClassesEditorActions'>",
				"</div>",
				"<div global_actions class='flowDesignerClassesGlobalActions'>",
					"<div class='flowDesignerClassesCloseButton'>",
						"<button close_button class='pageButtonGeneric buttonColorWhite' title='<%=_T('Close')%>'>",
							"<%=_T('Close')%>",
						"</button>",
					"</div>",
				"</div>",
			"</div>",*/
			"<div  class='card'>",
				"<div editor_container class='flowDesignerClassesEditorContainer'>",
					"<div tool_bar class='flowDesignerClassesToolBar'>",
						"<ul tool_bar_list class='flowDesignerClassesToolbarClassesList'>",
						"</ul>",
					"</div>",
					"<div form_container class='flowDesignerClassesEditor card'>",
							"<div editor_actions class='flowDesignerClassesEditorActions'>",
							"</div>",
					"</div>",
				"</div>",
			"</div>",
		"</div>"
	),
	
	//actions bar
	action_button: "".concat(
		"<button action_button='{{ id }}' {{ #fixedButton }}fixed_button{{ /fixedButton }} class='pageButtonGeneric pageButtonNew buttonColorWhite pageButtonNoIcon flowDesignerClassesActionButton {{ id }}FlowClassesActionButton {{ #withoutText }}withoutText{{ /withoutText }}' title='{{ description }}'>",
			"{{ #withText }}{{ name }}{{ /withText }}",
		"</button>"
	),
	//tool bar
	toolbar_class: "".concat(
		"<li toolbar_class='{{ id }}' class_name='{{ name }}' class_selector='true' class='flowDesignerToolbarClass {{ #readonly }}readonlyClass{{ /readonly }} {{ #system }}systemClass{{ /system }}'>",
			"<div class_selector='true' class_selector_title class='flowDesignerToolbarClassTitle' title='{{ description }}'>",
				"<div class_selector='true' class='flowDesignerToolbarClassTitleItem' >",
					"<i class_selector='true' class='fas fa-brackets-curly mr-2'></i>",
					"{{ name }}",
				"</div>",
				"<button add_attribute='{{ id }}' class='btn buttonIconAndText'>",
					"<span class='far fa-plus'></span>",
					"<%=_T('Add attribute')%>",
				"</button>",
			"</div>",
			"<label class='flowDesignerToolbarAttributesTitle'>",
				"<%=_T('Attributes')%><%=_T(':')%>",
			"</label>",
			"<ul attributes_list class='flowDesignerToolbarAttributesList'>",
				/*"<li class='flowDesignerToolbarAddAttribute'>",
					"<button add_attribute='{{ id }}' class='pageButtonGeneric buttonColorWhite'>",
						"<i class='fal fa-plus'></i>",
						"<%=_T('Add attribute')%>",
					"</button>",
				"</li>",*/
			"</ul>",
			"<div class='flowDesignerToolbarMethodsTitle'>",
				"<label class='flowDesignerToolbarMethodsTitleLabel'>",
					"<%=_T('Methods')%><%=_T(':')%>",
				"</label>",
				"<button add_method='{{ id }}' class='btn buttonIconAndText'>",
					"<span class='far fa-plus'></span>",
					"<%=_T('Add method')%>",
				"</button>",
			"</div>",
		
			"<ul methods_list class='flowDesignerToolbarMethodsList'>",
				"<li class='flowDesignerToolbarAddAttribute'>",
					/*"<button add_method='{{ id }}' class='pageButtonGeneric buttonColorWhite'>",
						"<i class='fal fa-plus'></i>",
						"<%=_T('Add method')%>",
					"</button>",*/
				"</li>",
			"</ul>",
		"</li>"
	),
	toolbar_attribute: "".concat(
		"<li class_id ='{{ class_id }}' toolbar_attribute='{{ id }}' attribute_name='{{ name }}' class='flowDesignerToolbarAttribute' title='{{ description }}'>",
			"<i class='flowDesignerToolbarAttributeIcon'></i>",
			"{{ name }}",
		"</li>"
	),
	toolbar_method: "".concat(
		"<li class_id ='{{ class_id }}' toolbar_method='{{ id }}' {{ #method }}method_name='{{ name }}'{{ /method }} class='flowDesignerToolbarMethod' title='{{ description }}'>",
			"<i class='flowDesignerToolbarMethodIcon'></i>",
			"{{ name }}",
		"</li>"
	),
	editor_container: "".concat(
		"<div class='flowDesignerClassEditorContainer card-block {{ className }}'>",
		"</div>"
	),
	editor_description: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group'>",
					"<label class='' title='{{ description }}'>",
						"{{ name }}",
					"</label>",
					"<textarea description class='form-control'>",
						"{{ text }}",
					"</textarea>",
				"</div>",
			"</div>",
		"</div>",
		"<hr/>"
	),
	editor_examples: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 title='{{ description }}'>",
						"<strong>",
							"{{ name }}",
						"</strong>",
					"</h4>",
				"</div>",
			"</div>",
			"<div examples class='flowDesignerClassExamplesEdit'>",
			"</div>",
		"</div>",
		"<hr/>"
	),
	editor_params_container: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 title='{{ description }}'>",
						"<strong>",
							"{{ name }}",
						"</strong>",
					"</h4>",
				"</div>",
			"</div>",
		"</div>",
		"<div class='row d-flex align-items-center justify-content-start'>",
			"<div class='col-12'>",
				"<div class='flowDesignerClassParam selfParam'>",
					"<label param_label class='flowDesignerClassParameter' title='self'>",
						"self",
					"</label>",
				"</div>",
				"<ul parameters_list class='flowDesignerClassParameters'>",
				"</ul>",
				"<button parameters_add class='pageButtonGeneric buttonColorWhite' title='", "<%=_T('Add parameter')%>" , "'>",
					"<i class='far fa-plus mr-0'></i>",
				"</button>",
			"</div>",
		"</div>",
		//"<hr/>"
	),
	editor_param: "".concat(
		"<li param='{{ id }}' param_name='{{ name }}' {{ #readonly }}readonly{{ /readonly }} class='flowDesignerClassParam modeView {{ #readonly }}readonly{{ /readonly }}'>",
			"<label param_label class='flowDesignerClassParameter' title='{{ name }}'>",
				"{{ name }}",
			"</label>",
			"<button param_edit='{{ id }}' class='buttonColorGray flowDesignerClassParamEditButton' title='", "<%=_T('Edit')%>" , "'>",
				"<i class='far fa-pencil'></i>",
			"</button>",
			"<button param_delete='{{ id }}' class='buttonColorGray flowDesignerClassParamDeleteButton' title='", "<%=_T('Remove')%>" , "'>",
				"<i class='far fa-trash-alt'></i>",
			"</button>",
			"<input param_value type='text' class='flowDesignerClassParamValue'>",
			"<button param_confirm='{{ id }}' class='buttonColorGray flowDesignerClassParamConfirmButton' title='", "<%=_T('Update')%>" , "'>",
				"<i class='far fa-check-circle'></i>",
			"</button>",
			"<button param_cancel='{{ id }}' class='buttonColorGray flowDesignerClassParamCancelButton' title='", "<%=_T('Cancel')%>" , "'>",
				"<i class='far fa-minus-circle'></i>",
			"</button>",
		"</li>"
	),
	editor_code_container: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 class='flowDesignerClassCodeLabel' title='{{ description }}'>",
						"<strong>",
							"{{ name }}",
						"</strong",
					"</h4>",
				"</div>",
			"</div>",
			"<div code_block class='flowDesignerClassCode'>",
			"</div>",
		"</div>",
		//"<hr/>"
	),
	editor_value_container: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 title='{{ description }}'>",
						"<strong>",
							"{{ name }}",
						"</strong",
					"</h4>",
				"</div>",
			"</div>",
		"</div>",
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group'>",
					"<input attribute_value type='text' class='form-control'>",
				"</div>",
			"</div>",
		"</div>",
		//"<hr/>"
	)
};

	if ( !inConcert.templates.process_flow_classes ) {
		inConcert.templates.process_flow_classes = Templates;
	}
}());