/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	function adm_process_flow_configuration_popup(main, data) {
		adm_process_flow_configuration_popup.uber.constructor.call(this);
		this.main = main;
		this.data = data;
		this.showEditTitleButton = false;

		this.nameDefinition = {
			id : "Name",
			name : "<%=_T('Name')%>",
			description : "<%=_T('Process flow name.')%>",
			required : true,
			validate : {
				type : "id",
				message : "<%=_T('Only letters, numbers, dashes and dots are allowed in flow name.')%>"
			},
			not_extended : true,
			form_group: true 
		};
		
		this.descriptionDefinition = {
			id : "Description",
			name : "<%=_T('Description')%>",
			description : "<%=_T('Process flow description.')%>",
			required : true,
			not_extended : true
		};
		
		this.focusControl = this.nameDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_configuration_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_configuration_popup !== "function") {
		inConcert.adm_process_flow_configuration_popup = adm_process_flow_configuration_popup;
	}

	adm_process_flow_configuration_popup.prototype.__getClassName = function() {
		return "popUp380w flowDesignerGlobalModal flowDesignerOverlayModal";
	};

	adm_process_flow_configuration_popup.prototype.__getTitle = function() {
		return "<%=_T('Process Flow Configuration')%>";
	};

	adm_process_flow_configuration_popup.prototype.__hasCloseButton = function() {
		return false;
	};

	adm_process_flow_configuration_popup.prototype.__makeContent = function() {
		var $content = [];
		$content.push(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeRowFlex(
					  this.__makeInputFlex(
						this.nameDefinition,
						this.data[this.nameDefinition.id]
					  )
					),
					this.__makeRowFlex(
					  this.__makeInputFlex(
						this.descriptionDefinition,
						this.data[this.descriptionDefinition.id]
					  )
					),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );		  
		
		  return $content;
	};

	adm_process_flow_configuration_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.nameDefinition);
		this.__addValue(data, this.descriptionDefinition);
		return data;
	};

	adm_process_flow_configuration_popup.prototype.__save = function(data, callback) {
		this.main.UpdateProperties(data, function(status, errorCode) {
			if (status) {
				callback(true);
			}
			else {
				var error = {
					message : "<%=_T('Error validating flow.')%>"
				};
				switch(errorCode) {
					case "NAME_ALREADY_EXISTS":
						error.message = "<%=_T('Already exists a process with same name.')%>";
						error.control = "Name";
						break;
					case "FORBIDDEN":
						error.message = "<%=_T('Unable to save process flow. You dont have permission.')%>";
						break;
				}
				callback(false, error);
			}
		});
	};

}());
