
/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if ( !this.inConcert ) {
  this.inConcert = {};
}
if (!inConcert.templates) {
	inConcert.templates = {};
}

(function () {

'use strict';

var Templates = {
	//designer
	base: "".concat(
		"<div id='flowDesignerDatasourcesContainer' class='flowDesignerDatasourcesContainer'>",
			"<div class='flowDesignerDatasourcesTitle pageHeader'>",

				"<div class='pageButtonContainer ' style=''>",
					"<button close_button class='butBackToDashboardArrow d-flex mr-0'>",
						"<i class='fas fa-chevron-left mr-0'></i>",
					"</button>",
				"</div>",

				"<div class='pageTitleContainer ' >",
					'<i class="far fa-project-diagram"></i>',
					'<label class="flowDesignerDatasourcesTitleText pageTitle" >',
						'<%=_T("Datasources")%>',
					'</label>',
				"</div>",

				"<div class='pageButtonContainer ml-auto ' style=''>",
					"<div global_actions class='flowDesignerDatasourcesGlobalActions'>",
					"</div>",
				"</div>",

			"</div>",

			"<div processing class='flowDesignerDatasourcesProcessing' hidden>",
			"</div>",

			/*"<div actions_bar class='flowDesignerDatasourcesActionsBar'>",
				"<div editor_actions class='flowDesignerDatasourcesEditorActions'>",
				"</div>",
				"<div global_actions class='flowDesignerDatasourcesGlobalActions'>",
					"<div class='flowDesignerDatasourcesCloseButton'>",
						"<button close_button class='pageButtonGeneric buttonColorWhite' title='<%=_T('Close')%>'>",
							"<%=_T('Close')%>",
						"</button>",
					"</div>",
				"</div>",
			"</div>",*/
			"<div  class='card'>",
				"<div editor_container class='flowDesignerDatasourcesEditorContainer'>",
					"<div tool_bar class='flowDesignerDatasourcesToolBar'>",
						"<div class='flowDesignerDatasourcesTitleContainer'>",
							"<h5><%=_T('Datasources')%></h5>",
							"<button action_button='new_datasource' class='actionAddButton'><i class='far fa-plus'></i></button>",
						"</div>",
						"<ul tool_bar_list class='flowDesignerDatasourcesToolbarDatasourcesList'>",
						"</ul>",
					"</div>",
					"<div form_container class='flowDesignerDatasourcesEditor card hybridDesignContainer'>",
						"<div class='flowDesignerDatasourcesTitleContainer'>",
							'<h5 context_name class="flowDesignerName"></h5>',
							"<div editor_actions class='flowDesignerDatasourcesEditorActions'>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",	
		"</div>"
	),

	//actions bar
	action_button: "".concat(
		"<button action_button='{{ id }}' {{ #fixedButton }}fixed_button{{ /fixedButton }} class='pageButtonGeneric pageButtonNew buttonColorWhite pageButtonNoIcon {{ id }}FlowDatasourcesActionButton {{ #withoutText }}withoutText{{ /withoutText }}' title='{{ description }}' {{ #hidden }}hidden{{ /hidden }}>",
			"{{ #withText }}{{ name }}{{ /withText }}",
		"</button>"
	),
	//actions bar
	datasource_action: "".concat(
		"<button ds_action_button='{{ id }}' class='{{ id }}FlowDatasourcesActionButton' style='border:none' title='{{ description }}' {{ #hidden }}hidden{{ /hidden }}>",
			"<i class='{{action_icon_class}}'></i>",
		"</button>"
	),
	//tool bar
	toolbar_datasource: "".concat(
		"<li toolbar_datasource='{{ id }}' datasource_name='{{ name }}' datasource_selector='true' class='flowDesignerToolbarDatasource'>",
			"<div datasource_selector='true' datasource_selector_title class='flowDesignerToolbarDatasourceTitle' title='{{ description }}'>",
				"<div class='flowDesignerToolbarDatasourceTitleItem' >",
					"<i datasource_selector='true' datasource_icon class='far fa-database mr-2 {{ type }}DatasourceIcon' title='{{ typeLabel }}'></i>",
					"<span toolbar_ds_readonly_name>{{ name }}</span>",
					"<input toolbar_ds_edit_name type='text' value='{{ name }}' hidden>",
				"</div>",
				"<div class='flowDesignerToolbarDatasourceTitleItem' datasource_actions='true'>",
				"</div>",
			"</div>",
		"</li>"
	),
	editor_container: "".concat(
		"<div ds_editor_container='true' class='flowDesignerDatasourceEditorContainer card-block {{ className }}'>",
		"</div>"
	),
	editor_description: "".concat(
			"<div class='col-6'>",
				"<div class='form-group'>",
					"<label control_label='Description' class='' title='{{ description }}'>",
						"{{ name }}",
					"</label>",
					"<input control='Description' type='text' value='{{ text }}' class='form-control'/>",
				"</div>",
			"</div>",
	),
	editor_password: "".concat(
		"<div class='col-3'>",
			"<div class='form-group'>",
				"<label control_label='Password' class='' title='{{ description }}'>",
					"{{ name }}",
				"</label>",
				"<input type='{{type}}' value='{{ text }}' control='Password' class='form-control'/>",
				"<i class='{{icon_eye}}' dsTogglePassword='true'",
				"style='position: absolute;top: 50%; right: 22px; cursor: pointer;transform: translateY(-50%);'",
				"></i>",
			"</div>",
		"</div>",
),
	
};

	if ( !inConcert.templates.process_flow_datasources ) {
		inConcert.templates.process_flow_datasources = Templates;
	}
}());