/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;

	function adm_process_flow_duplicate_state_popup(main, data) {
		adm_process_flow_duplicate_state_popup.uber.constructor.call(this);
		this.main = main;
		this.data = data;
		
		var self = this;
		
		this.nameDefinition = {
			id : "name",
			name : "<%=_T('Name')%>",
			description : "<%=_T('State name.')%>",
			required : true,
			validate : {
				type : "id",
				message : "<%=_T('Only letters, numbers, dashes and dots are allowed in state name.')%>",
				method : function(value) {
					var stateId = self.main.GetStateFromName(value);
					if (stateId) {
						return "<%=_T('Already exists a state with same name.')%>";
					}
				}
			},
			form_group: true
		};
		this.descriptionDefinition = {
			id : "description",
			name : "<%=_T('Description')%>",
			description : "<%=_T('State description.')%>",
			required : true,
			form_group: true
		};
		
		this.focusControl = this.nameDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_duplicate_state_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_duplicate_state_popup !== "function") {
		inConcert.adm_process_flow_duplicate_state_popup = adm_process_flow_duplicate_state_popup;
	}

	adm_process_flow_duplicate_state_popup.prototype.__getClassName = function() {
		return "popUp380w flowDesignerGlobalModal flowDesignerOverlayModal";
	};

	adm_process_flow_duplicate_state_popup.prototype.__getTitle = function() {
		return format("<%=_T('Duplicate state {0}')%>", this.data.name);
	};

	adm_process_flow_duplicate_state_popup.prototype.__makeContent = function() {
		var $content = [];
		var $content = [];
		$content.push(
		this.__makeDivFlex(
			[
			  this.__makeDivFlex(
				[
					this.__makeDivFlex(
						this.__makeDivFlex(this.__makeInputFlex(this.nameDefinition, this.data[this.nameDefinition.id]),{ class: "col-12" }),{ class: "row" }
					),

					this.__makeDivFlex(
						this.__makeDivFlex(this.__makeInputFlex(this.descriptionDefinition, this.data[this.descriptionDefinition.id]),{ class: "col-12" }),{ class: "row" }
					)
				],
				{ class: "card-block" }
			  ),
			],
			{ class: "card no-card" }
		)
		);
		$content.push();
		$content.push();
		return $content;
	};

	adm_process_flow_duplicate_state_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.nameDefinition);
		this.__addValue(data, this.descriptionDefinition);
		$.each(this.data, function(k, v) {
			data[k] = data[k] || v;
		});
		return data;
	};

	adm_process_flow_duplicate_state_popup.prototype.__save = function(data, callback) {
		this.main.AddState(data);
		callback(true);
	};

}());
