/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global $, inConcert, Mustache, mxEvent, mxUtils, mxConnectionHandler, mxGraphHandler, mxConstants, mxEdgeHandler, mxEdgeStyle, mxClipboard, mxImage, mxCodec, mxGraphModel, mxEditor, mxRubberband, mxMultiplicity, mxUndoManager, mxPrintPreview, mxPoint */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;
	var templates = inConcert.templates.process_flows;

//mx default modifications

	//set default connector
	mxConnectionHandler.prototype.connectImage = 
		new mxImage("/inconcert/apps/flow_designer/images/flow_designer/ico-link.svg", 16, 16);
	
		// mxConnectionHandler.prototype.waypointsEnabled = true;

		// mxConnectionHandler.prototype.outlineConnect = true;

		// mxGraph.prototype.getAllConnectionConstraints = function(terminal, source)
		// {
		// 	if (terminal != null && terminal.shape != null)
		// 	{
		// 		if (terminal.shape.stencil != null)
		// 		{
		// 			if (terminal.shape.stencil.constraints != null)
		// 			{
		// 				return terminal.shape.stencil.constraints;
		// 			}
		// 		}
		// 		else if (terminal.shape.constraints != null)
		// 		{
		// 			return terminal.shape.constraints;
		// 		}
		// 	}
	
		// 	return null;
		// };

		// mxShape.prototype.constraints = [new mxConnectionConstraint(new mxPoint(0.25, 0), true),
		// 	new mxConnectionConstraint(new mxPoint(0.5, 0), true),
		// 	new mxConnectionConstraint(new mxPoint(0.75, 0), true),
		// 	  new mxConnectionConstraint(new mxPoint(0, 0.25), true),
		// 	  new mxConnectionConstraint(new mxPoint(0, 0.5), true),
		// 	  new mxConnectionConstraint(new mxPoint(0, 0.75), true),
		// 	new mxConnectionConstraint(new mxPoint(1, 0.25), true),
		// 	new mxConnectionConstraint(new mxPoint(1, 0.5), true),
		// 	new mxConnectionConstraint(new mxPoint(1, 0.75), true),
		// 	new mxConnectionConstraint(new mxPoint(0.25, 1), true),
		// 	new mxConnectionConstraint(new mxPoint(0.5, 1), true),
		// 	new mxConnectionConstraint(new mxPoint(0.75, 1), true)];
		
		// mxGraph.prototype.centerZoom = false;


	// Enables guides
	mxGraphHandler.prototype.guidesEnabled = true;

	// Alt disables guides
	mxGraphHandler.prototype.useGuidesForEvent = function(me) {
		return !mxEvent.isAltDown(me.getEvent());
	};

	// Defines the guides to be red (default)
	mxConstants.GUIDE_COLOR = "#FF0000";

	// Defines the guides to be 1 pixel (default)
	mxConstants.GUIDE_STROKEWIDTH = 1;

	// Enables snapping waypoints to terminals
	mxEdgeHandler.prototype.snapToTerminals = true;

	//Overrides error message
	mxUtils.alert = function(message) {
		inConcert.app.m_mainWindow.showBannerMessage({ message: message, timeout: 3000 });
	};

	// Public helper method for shared clipboard.
	mxClipboard.cellsToString = function(cells) {
		var codec = new mxCodec();
		var model = new mxGraphModel();
		var parent = model.getChildAt(model.getRoot(), 0);
		for (var i = 0; i < cells.length; i++) {
			model.add(parent, cells[i]);
		}
		return mxUtils.getXml(codec.encode(model));
	};

//end default modifications

	function adm_process_flow_editor(main, actionsBar, xml) {
		this.main = main;
		this.actionsBar = actionsBar;
		this.xml = xml;
		this.x = 0;
		this.y = 0;
	}

	if (typeof inConcert.adm_process_flow_editor !== "function") {
		inConcert.adm_process_flow_editor = adm_process_flow_editor;
	}

	adm_process_flow_editor.prototype.__getClassName = function() {
		return "";
	};

	adm_process_flow_editor.prototype.__hasUndoManager = function() {
		return false;
	};

	adm_process_flow_editor.prototype.__getNodeLabel = function(_) {
		return "";
	};

	adm_process_flow_editor.prototype.__getConnectorLabel = function(node) {
		var data = this.GetNodeData(node);
		return data && data.description || "";
	};

	adm_process_flow_editor.prototype.__getNodeTooltip = function(_) {
		return "";
	};

	adm_process_flow_editor.prototype.__getConnectorTooltip = function(_) {
		return "";
	};

	adm_process_flow_editor.prototype.__getAuxiliarNodes = function() {
		return {
			initial : true
		};
	};

	adm_process_flow_editor.prototype.__editNode = $.noop;

	adm_process_flow_editor.prototype.__loadStyles = function() {
		this.__addNodeStyle("initialNode", "ico-activity.svg");
	};

	adm_process_flow_editor.prototype.__loadDefaultDraw = function() { 
		var self = this;
		self.__editTransaction(function(parent) {
			let y = Math.round(self.main.$element("draw_container").height() / 2) - 25;

			const drawVersion = self.main.__getVersion(); 

			if (drawVersion === "2") {
				let htmlBody = Mustache.render(inConcert.templates.process_flows.initial_activity_template, {
					image: `custom_icon_initial_activity`, 
					description: "<%=_T('Start')%>"
				});
				let ports = [];
				ports.push({
					direction : "out", // in/out
					type : "success", // error/success/option
					option_label : "", // error/success/option
					channels: "1" // 1 o n
				});
	
				self.__addNode(parent, "initial", "initialNode", null, 20, y, 68, 70, htmlBody, ports); 

			} else {
				self.__addNode(parent, "initial", "initialNode", null, 20, y);
			}

		});
	};

	adm_process_flow_editor.prototype.__getTooltip = function(node) {
		if (node.id === "initial") {
			return "<%=_T('Process start')%>";
		}
		if (node.edge) {
			return this.__getConnectorTooltip(node);
		}
		return this.__getNodeTooltip(node);
	};

	adm_process_flow_editor.prototype.__getLabel = function(node) {
		if (node.id === "initial") {
			return "";
		}
		if (node.edge) {
			return this.__getConnectorLabel(node);
		}
		return this.__getNodeLabel(node);
	};

	adm_process_flow_editor.prototype.GetAndValidateData = function(notValidate) {  
		//validate
		if (!notValidate) {
			let error = null;

			let initial = this.graph && this.GetNodeById("initial");

			const drawVersion = this.main.__getVersion();

			if (drawVersion === "2" && initial.style.toString().substring(0,4) === "<div") {
				if (!initial || (!initial.edges && initial.children.length === 0)) {
					error = "<%=_T('Must have an initial connection.')%>";
				}
			} else {
				if (!initial || !initial.edges || !initial.edges.length) {
					error = "<%=_T('Must have an initial connection.')%>";
				}
			}

			if (error) {
				inConcert.app.m_mainWindow.showBannerMessage({ message: error, timeout: 5000 });
				return;
			}
		}
		//get
		return {
			xml : this.__getDrawXml(),
			model : this.__getDrawModel()
		};
	};

	adm_process_flow_editor.prototype.__makeConnectorPopup = function(connector) {
		return new inConcert.adm_process_flow_connection_popup(this, connector);
	};

	adm_process_flow_editor.prototype.__makeImagePath = function(imageName) {
		return format("/inconcert/apps/flow_designer/images/flow_designer/{0}", imageName || "defaultNode");
	};
	
	adm_process_flow_editor.prototype.__setNodeStyle = function(/*node, style*/) {
		/*var self = this;
		if (node.getStyle() === style) {
			return;
		}
		self.graph.getModel().setStyle(node, style);*/
	};

	adm_process_flow_editor.prototype.__addNodeStyle = function(id, imageName, extraProperties) {
		this.addedNods = this.addedNods || {};
		if (this.addedNods[id]) {
			return;
		}
		this.addedNods[id] = true;
		var properties = {
			"shape" : "image",
			"image" : this.__makeImagePath(imageName),
			"verticalLabelPosition" : "bottom",
			"verticalAlign" : "top"
		};
		$.each(extraProperties || {}, function(k, v) {
			properties[k] = v;
		});
		this.graph.getStylesheet().putCellStyle(id, properties);
	};

	adm_process_flow_editor.prototype.__addNode = function(parent, id, type, data, x, y, width, height, htmlBody, ports) { 
		var self = this;
		let node = null;

		function add(parent) {
			let xmlDocument = mxUtils.createXmlDocument();
			let xmlNode = xmlDocument.createElement(type);
			xmlNode.setAttribute("value", JSON.stringify(data));

			const drawVersion = self.main.__getVersion();

			if (drawVersion === "2") {
				let new_x = (self.graph.view.translate.x * -1) + 350; 
				let new_y = (self.graph.view.translate.y * -1) + 300;
	
				let ports_out_length = ports.filter(p => p.direction === "out" || p.direction === "none").length;
				
				let header_height = 40;
				let port_height = 18;
				let first_space = 12;				
				let between_space = 8;
				let last_space = 16;

				let activity_height = header_height + first_space + (port_height * ports_out_length) + (between_space * (ports_out_length - 1)) + last_space;
				
				if (id === "initial") {	
					activity_height = height;
				} else if (type === "stateNode") {
					activity_height = 80;
				} 
				else if (
						 	// type === "close_channel" || 
							type === "send_to_cc" || 
							type === "send_to_cc_contact_center" || 
							type === "send_to_cc_agent" || 
							type === "send_to_cc_campaign" || 
							type === "send_to_cc_campaign_agent" ||
							type === "send_to_cc_number" ||
							type === "writing" ||
							type === "hide_writing" ||
							type === "reporting_data" ||
							type === "start_webcontact" ||
							type === "sql" ||
							type === "logger_DEBUG" ||
							type === "logger_WARNING" ||
							type === "logger_INFO" ||
							type === "logger_ERROR" ||
							type === "answer" ||
							type === "hold" ||
							type === "unhold" ||
							type === "start_recording" ||
							type === "stop_recording" ||
							type === "set_automatic_message" ||
							type === "jump_to_process" ||
							type === "jump_to_state"
				) {
					activity_height = 84; // antes era 60
					// width = 58;
				}
				else if (type === "close_channel") {
					activity_height = 70;
					width = 68;
				}
				
				node = self.graph.insertVertex(parent, id, xmlNode, x || new_x, y || new_y, width || 204, activity_height, htmlBody?htmlBody:type);
	
				self.SetPorts(node, ports, data); 
			} else {
				node = self.graph.insertVertex(parent, id, xmlNode, x || 20, y || 200, width || 50, height || 50, type);
			}
		}

		if (parent) {
			add(parent);
		}
		else {
			self.__editTransaction(function(parent) {
				add(parent);
			});
		}
		return node;
	};

	adm_process_flow_editor.prototype.SetNodeData = function(node, data, ports) { 

		this.graph.model.setValue(node, JSON.stringify(data));

		const drawVersion = this.main.__getVersion();

		if (drawVersion === "2") {

			if (data) {
				let activity = this.main.toolbar.activities[data.type];
				let htmlBody = null;
				if (activity) {
					if (activity.prototype.htmlBody) {
						htmlBody = activity.prototype.htmlBody(data);
						this.graph.getModel().setStyle(node, htmlBody);
					}
				}
			}
			
			if (ports) {
				let ports_out_length = ports.filter(p => p.direction === "out" || p.direction === "none").length;

				let header_height = 40;
				let port_height = 18;
				let first_space = 12;				
				let between_space = 8;
				let last_space = 16;
				let activity_width = 204;

				let activity_height = header_height + first_space + (port_height * ports_out_length) + (between_space * (ports_out_length - 1)) + last_space;

				if (
					data.type === "send_to_cc" ||
					data.type === "send_to_cc_contact_center" ||
					data.type === "send_to_cc_agent" ||
					data.type === "send_to_cc_campaign" ||
					data.type === "send_to_cc_campaign_agent" ||
					data.type === "send_to_cc_number" ||
					data.type === "show_writing" ||
					data.type === "hide_writing" ||
					data.type === "reporting_data" ||
					data.type === "start_webcontact" ||
					data.type === "sql" ||
					data.type === "logger" ||
					data.type === "answer" ||
					data.type === "hold" ||
					data.type === "unhold" ||
					data.type === "start_recording" ||
					data.type === "stop_recording" ||
					data.type === "set_automatic_message" ||
					data.type === "jump_to_process" ||
					data.type === "jump_to_state") { 
					activity_height = 84;
					// activity_width = 58;
				} 

				if (data.type === "close_channel") {
					activity_height = 70;
					activity_width = 68;
				}

				// actualizo el alto del nodo
				let geo = this.graph.getModel().getGeometry(node);
				geo.height = activity_height;
				geo.width = activity_width;
				node.setGeometry(geo);
				
				this.SetPorts(node, ports, data); 
			}
		}

	};

	adm_process_flow_editor.prototype.SetPorts = function(node, ports/*, data*/) {

		var self = this;

		let header_height = 30;
		let port_height = 18;
		let first_space = 12;				
		let between_space = 8;
		
		if (ports && ports.length > 0) { 

			let ports_out_length = ports.filter(p => p.direction === "out" || p.direction === "none").length;
			let port_index = 0; 

			node.setConnectable(false);

			ports.forEach(element => {

				if (element.direction === "in") {

					let position_y = 0.45;

					// if (element.type === "error" || 
					// 		element.type === "option" || 
					// 		data.type === "show_writing" || 
					// 		data.type === "hide_writing" || 
					// 		data.type === "reporting_data" || 
					// 		data.type === "sql" || 
					// 		data.type === "logger" || 
					// 		data.type === "answer" || 
					// 		data.type === "hold" || 
					// 		data.type === "unhold" ||
					// 		data.type === "start_recording" ||
					// 		data.type === "stop_recording" ||
					// 		data.type === "set_automatic_message" ||
					// 		data.type === "jump_to_process" ||
					// 		data.type === "jump_to_state") { 
					// 	position_y = 0.23; //0.14;
					// } else 
					
					if (element.type === "error") {
						position_y = 0.23; //0.14;
					}
					else if (ports_out_length <= 1) { 
						position_y = 0.45;
					}
					
					if (
						(node && (!node.children || node.children.length === 0)) ||
						(node && node.children && node.children.length > 0 && !node.children.find(c => c.value === "PortIn"))
					) { 
						let html = "<div class='custom_port_"+ element.direction + element.type +"'><div class='custom_port_label_container'><span class='custom_port_label'>" + element.option_label + "</span></div></div>";
						let port = this.graph.insertVertex(node, null, "PortIn", 0, position_y, 12, 18, html, true);
						port.geometry.offset = new mxPoint(-8, 12);

						let style = this.graph.getModel().getStyle(port);
						let newStyle = mxUtils.setStyle(style, mxConstants.STYLE_DELETABLE,"0");
						let cs= [];
						cs[0]=port;
						this.graph.setCellStyle(newStyle,cs);
					} else if (
						(node && node.children && node.children.length > 0 && node.children.find(c => c.value === "PortIn"))
					) {

						let html = "<div class='custom_port_"+ element.direction + element.type +"'><div class='custom_port_label_container'><span class='custom_port_label'>" + element.option_label + "</span></div></div>";
						let node_for_update = node.children.find(c => c.value === "PortIn");

						if (node_for_update) {

							// aquí debo actualizar la condición por defecto del puerto
							this.graph.getModel().setStyle(node_for_update, html);
							let geo_node = this.graph.getModel().getGeometry(node_for_update);

							geo_node.y = position_y;				
							geo_node.x = 0;
							geo_node.width = 12;
							geo_node.height = 18;
							geo_node.offset = new mxPoint(-8, 12);

							node_for_update.setGeometry(geo_node);							
						}
					}

				} else {
					port_index++;

					let current_height = node.geometry.height; // - 40;
					let header_height_calculado = header_height / current_height;
					let port_height_calculado = port_height / current_height;
					let first_space_calculado = first_space / current_height;				
					let between_space_calculado = between_space / current_height;

					let position_y = header_height_calculado + first_space_calculado + ((port_height_calculado * ((port_index - 1) * 1.0))) + ((between_space_calculado * ((port_index - 1) * 1.0)));
			
					// if (data && (data.type === "show_writing" || 
					// 		data.type === "reporting_data" || 
					// 		data.type === "start_webcontact" || 
					// 		data.type === "sql" || 
					// 		data.type === "logger" || 
					// 		data.type === "answer" || 
					// 		data.type === "hold" || 
					// 		data.type === "unhold" ||
					// 		data.type === "start_recording" ||
					// 		data.type === "stop_recording" ||
					// 		data.type === "set_automatic_message" ||
					// 		data.type === "jump_to_process" ||
					// 		data.type === "jump_to_state")) { 
					// 	position_y = 0.23;
					// }

					if (node.id === "initial") {
						let html = "<div class='custom_port_"+ element.direction + "_"+ element.type +"'></div>";
						let port = this.graph.insertVertex(node, null, "PortOut_1", 1, 0.23, 14, 18, html, true);
						port.geometry.offset = new mxPoint(-8, 8);

						let style = this.graph.getModel().getStyle(port);
						let newStyle = mxUtils.setStyle(style, mxConstants.STYLE_DELETABLE,"0");
						let cs= [];
						cs[0]=port;
						this.graph.setCellStyle(newStyle,cs);
					} else {

						let html = "<div class='custom_port_"+ element.direction + "_"+ element.type +"'><div class='custom_port_label_container'><span class='custom_port_label'>" + element.option_label + "</span></div></div>";
						
						if (
							(node && (!node.children || node.children.length <= 1)) ||
							(node && node.children && node.children.length > 1 && !node.children.find(c => c.id === element.id))
						) { // valido que no haya un port con el mismo id

							let type = "PortOut_0";

							if (element.channels === "1") {
								type = "PortOut_1";
							} else if (element.channels === "n") {
								type = "PortOut_n";
							}

							let port = this.graph.insertVertex(node, element.id, type, 1, position_y, 14, 18, html, true);
							port.geometry.offset = new mxPoint(-8, 8);
							port.preset_value = element.preset_value; // agrego la condición preseteada

							if (type === "PortOut_0") {
								port.setConnectable(false);
							}

							let style = this.graph.getModel().getStyle(port);
							let newStyle = mxUtils.setStyle(style, mxConstants.STYLE_DELETABLE,"0");
							let cs= [];
							cs[0]=port;
							this.graph.setCellStyle(newStyle,cs);

						} else { // existe, debo actualizar

							if (node && node.children && node.children.length > 1) {
								let node_for_update = node.children.find(c => c.id === element.id);
								if (node_for_update) {

									// aquí debo actualizar la condición por defecto del puerto
									this.graph.getModel().setStyle(node_for_update, html);
									let geo_node = this.graph.getModel().getGeometry(node_for_update);

									geo_node.y = position_y;				
									geo_node.x = 1;
									geo_node.width = 14;
									geo_node.height = 18;
									geo_node.offset = new mxPoint(-8, 8);

									node_for_update.setGeometry(geo_node);

									node_for_update.preset_value = element.preset_value; // actualizo la condición preseteada		
									// estoy asumiendo que todos los puertos van a tener una sola salida, porque si tienen mas de una, las condiciones serán manuales
									
									if (node_for_update && node_for_update.value === "PortOut_1" && node_for_update.edges && node_for_update.edges.length === 1 && element.preset_value) { 
										this.AddOrUpdateConnection(node_for_update.edges[0], element.preset_value, true, true); // mando a actualizar la condición en la flecha
									}
								}
							}							
						}
					}
				}				
			});

			// elimino todos los children que no están vinculados a algún puerto

			if (node.id !== "initial" && node.children && node.children.length > 0) {

				let lista = [];

				node.children.forEach(element => {
					lista.push(element.id);
				});

				$.each(lista, function(_, c_id) {
					let c = self.graph.getModel().getCell(c_id);

					if (c) {
						let existe = false;
						ports.forEach(p => {
							if (c.id === p.id || c.value === "PortIn") { // valido que sea el mismo id y que el id no sea null, porque el conector in tiene ese valor de id
								existe = true;
								return;
							}
						});

						if (!existe) {
							self.graph.getModel().remove(c);
						}
					}		
				});
			}

			// actualizo la ubicación del nodo para que se refresque su vista
			self.graph.refresh();
		}
		
	};

	adm_process_flow_editor.prototype.GetNodeData = function(node) {
		if (!node) {
			return null;
		}
		try {
			var value = node.value;
			if (value && typeof value !== "string") {
				value = value.getAttribute("value");
			}
			return JSON.parse(value);
		}
		catch(e) {
			return null;
		}
	};

	adm_process_flow_editor.prototype.UpdateNodeLabel = function(node, data) {
		const drawVersion = this.main.__getVersion();
		let htmlBody = Mustache.render(inConcert.templates.process_flows.state_node_template, {
			image: `custom_icon_state`, 
			description: data.description
		});

		this.graph.model.setValue(node, htmlBody);
		if (drawVersion === "2") {
			this.graph.model.setStyle(node, htmlBody);
		}
	};

	adm_process_flow_editor.prototype.__getDrawXml = function() {
		if (!this.graph) {
			return null;
		}
		var encoder = new mxCodec();
		var node = encoder.encode(this.graph.getModel());
		let xml = mxUtils.getXml(node);
		return xml;
	};

	adm_process_flow_editor.prototype.GetNodeById = function(nodeId) {
		if (!nodeId) {
			return;
		}

		return this.graph.getModel().getCell(nodeId.replace(this.__getNodePrefix(), ""));
	};

	adm_process_flow_editor.prototype.GetTransitionByNodes = function(from, to, trace) {
		var fromNode = this.GetNodeById(from);
		var toNode = this.GetNodeById(to);
		if (!fromNode || !toNode) {
			return null;
		}
		var nodes = this.graph.getModel().getEdgesBetween(fromNode, toNode);
		if (nodes.length > 1 && trace) {
			return nodes.find(element => element.target.id === toNode.id);
		}
		return nodes && nodes.length && nodes[0] || null;
	};
	
	adm_process_flow_editor.prototype.SelectTransitionByNodes = function(from, to) {
		var transition = this.GetTransitionByNodes(from, to, false);
		if (!transition) {
			var message = "<%=_T('Transition not found.')%>";
			inConcert.app.m_mainWindow.showBannerMessage({ message: message, messageType : "Error", timeout: 5000 });
			return;
		}
		this.SelectNode(transition);
	};
	
	adm_process_flow_editor.prototype.SelectNodeById = function(nodeId) {
		var node = this.GetNodeById(nodeId);
		if (!node) {
			var message = "<%=_T('Node not found.')%>";
			inConcert.app.m_mainWindow.showBannerMessage({ message: message, messageType : "Error", timeout: 5000 });
			return;
		}
		this.SelectNode(node);
	};
	
	adm_process_flow_editor.prototype.SelectNode = function(node) {
		this.graph.getSelectionModel().clear();
		this.graph.getSelectionModel().addCell(node);
	};

	adm_process_flow_editor.prototype.DeleteNode = function(node) {
		var self = this;
		self.__editTransaction(function() {
			self.graph.getModel().remove(node);
		});
	};

	adm_process_flow_editor.prototype.__editTransaction = function(action) {
		var parent = this.graph.getDefaultParent();
		this.graph.getModel().beginUpdate();
		try
		{
			action(parent);
		}
		finally
		{
			this.graph.getModel().endUpdate();
		}
	};

	adm_process_flow_editor.prototype.__editInternalTransaction = function(action) {
		this.__undoFreeScope(() => this.__editTransaction(action));
	};

	adm_process_flow_editor.prototype.__editUpdateTransaction = function(action, internalUpdate = false) {
		if (internalUpdate) {
			this.__editInternalTransaction(action);
		} else {
			this.__editTransaction(action);
		}
	};

	adm_process_flow_editor.prototype.__undoFreeScope = function(action) {
		if (!this.undoManager) {
			return action();
		}
		const originalIndex = this.undoManager.indexOfNextAdd;
		action();
		this.__undoLastEvents(this.undoManager.indexOfNextAdd - originalIndex);
	};

	adm_process_flow_editor.prototype.__undoLastEvents = function(numberOfEvents) {
		if (numberOfEvents <= 0) {
			return;
		}
		[...Array(numberOfEvents).keys()].forEach(() => this.__undoLastEvent());
	};

	adm_process_flow_editor.prototype.__undoLastEvent = function() {
		if (!this.undoManager || this.undoManager.indexOfNextAdd === 0) {
			return;
		}


		this.undoManager.indexOfNextAdd--;
		this.undoManager.history.pop();
		this.actionsBar.UpdateButtonsState();
	};

	adm_process_flow_editor.prototype.__loadDrawFromXml = function() {
		var self = this;
		var xmlDocument = mxUtils.parseXml(self.xml);
		var decoder = new mxCodec(xmlDocument);
		var node = xmlDocument.documentElement;
		decoder.decode(node, self.graph.getModel());
		//process nodes
		self.__editInternalTransaction(function() {
			$.each(self.graph.getModel().cells, function(_, cell) {
				if (cell.edge) {
					self.__loadDrawConnectorFromXml(cell);
				}
				else if (cell.vertex && cell.id !== "initial") {
					self.__loadDrawNodeFromXml(cell);
				}
			});
		});
	};
	
	adm_process_flow_editor.prototype.__loadDrawConnectorFromXml = function(/*node*/) {
		
	};
	
	adm_process_flow_editor.prototype.__loadDrawNodeFromXml = function(/*node*/) {
		
	};

	adm_process_flow_editor.prototype.__loadDraw = function() {
		if (this.xml) {
			this.__loadDrawFromXml();
		}
		else {
			this.__loadDefaultDraw();
		}
	};
	
	adm_process_flow_editor.prototype.__onSelectionChanged = function() {
		var self = this;
		var selected = self.graph.getSelectionCells();
		if (selected.length === 0) {
			self.selectedNodes = null;
		}
		else {
			self.selectedNodes = selected;
		}
		self.actionsBar.UpdateButtonsState();
	};

	adm_process_flow_editor.prototype.__onConnection = function(connector/*, source, target*/) {

		this.__editTransition(connector);

	};

	adm_process_flow_editor.prototype.__reanimateEdge = function(node) {
		const self = this;
		let state = self.graph.view.getState(node);
		if (!node || !node.edge || !state || !state.shape) {
			return;
		}
		const color = "#39F";
		self.__editInternalTransaction(function () {
			if (node.target && 	node.target.parent && node.target.parent.value &&
				JSON.stringify(node.target.parent.value).includes("close_channel")) {
					return;
				}
			state.shape.node.getElementsByTagName("path")[0].removeAttribute("visibility");
			state.shape.node.getElementsByTagName("path")[0].setAttribute("stroke-width", "2");
			state.shape.node.getElementsByTagName("path")[0].setAttribute("stroke", color);
			state.shape.node.getElementsByTagName("path")[1].setAttribute("stroke", color);
			state.shape.node.getElementsByTagName("path")[1].setAttribute("class", "flow-animation");
			// state.shape.node.getElementsByTagName("path")[2].setAttribute("stroke", color);
		});

	};

	adm_process_flow_editor.prototype.__animateEdge = function(node, color, animate, type) {
		const self = this;
		var state = self.graph.view.getState(node);
		if (!node) {
			return;
		}


		self.__editInternalTransaction(function () {
			if (type === "transition") {
				try {
					state.shape.node.getElementsByTagName("path")[0].setAttribute("visibility", "hidden");
					state.shape.node.getElementsByTagName("path")[0].setAttribute("stroke-width", "2");
					state.shape.node.getElementsByTagName("path")[1].removeAttribute("class", "flow-animation");
					self.graph.setCellStyles("strokeColor", color, [node]);
					if (animate) { 
						self.graph.setCellStyles("strokeColor", color, [node]);
						self.graph.cellsOrdered([node]);
					}
				}
				catch(err) {}
			}  else {
				var html = self.graph.getModel().getStyle(node);
				var $content = $(`<div>${html}</div>`);
				if(type === "port") {
					$content.children().removeClass("path-port-disabled"); 
					$content.children().addClass("path-card-active-path");
				}
				else {
					try {
						if (
							html.includes("custom_close_activity") ||
							html.includes("custom_initial_activity")) {
								$content.children().removeClass("path-custom-circle-disabled");	
								$content.children().removeClass("path-card-disabled");							
						}	
						else {
							$content.children().removeClass("path-card-disabled");
							$content.children().addClass("path-card-active");
							$content.children().addClass("path-card-receiving");
						}
					}
					catch(err) {
						console.log();
					}
				}
				self.graph.getModel().setStyle(node, $content.html());
			}
		});
	};

	adm_process_flow_editor.prototype.__resetNodeAnimations = function(node) {
		const self = this;
		var state = self.graph.view.getState(node);
		if (!node) {
			return;
		}


		self.__editInternalTransaction(function () {
			if (node.edge && !JSON.stringify(node.value).includes("Port"))  {
				try {
					state.shape.node.getElementsByTagName("path")[0].setAttribute("visibility", "hidden");
					state.shape.node.getElementsByTagName("path")[1].removeAttribute("class", "flow-animation");
					//self.graph.setCellStyles("strokeColor", "#39F", [node]); // el color del path por donde paso el test_
					self.graph.setCellStyles("strokeColor", "#666", [node]); // el color del path por donde paso el test_
				}
				catch {
					console.log();
				}
			}  else {
				var html = self.graph.getModel().getStyle(node);
				var $content = $(`<div>${html}</div>`);
				if (node.value !== undefined && JSON.stringify(node.value).includes("Port")) {
					$content.children().removeClass("path-port-disabled"); 
					$content.children().removeClass("path-card-active-path"); 
				}
				else {
					try {
						if (
							html.includes("custom_close_activity") ||
							html.includes("custom_initial_activity")) {
								$content.children().removeClass("path-custom-circle-disabled");
								$content.children().removeClass("path-card-disabled");
						}
						else {
							$content.children().removeClass("path-card-disabled"); 
							$content.children().removeClass("path-card-active");
							$content.children().removeClass("path-card-receiving");
						}
					}
					catch (er) {
						console.log();
					}
				}
				self.graph.getModel().setStyle(node, $content.html());
			}
		});
	};

	adm_process_flow_editor.prototype.__setAllGray = function(node) {
		const self = this;
		var state = self.graph.view.getState(node);
		if (!node) {
			return;
		}


		self.__editInternalTransaction(function () {
			if (node.edge && !JSON.stringify(node.value).includes("Port"))  {
				try {
					state.shape.node.getElementsByTagName("path")[0].setAttribute("visibility", "hidden");
					state.shape.node.getElementsByTagName("path")[1].removeAttribute("class", "flow-animation");
					self.graph.setCellStyles("strokeColor", "#999", [node]);
				}
				catch {
					console.log();
				}
			}  else {
				var html = self.graph.getModel().getStyle(node);
				var $content = $(`<div>${html}</div>`);
				if (node.value !== undefined && JSON.stringify(node.value).includes("Port")) {
					$content.children().addClass("path-port-disabled"); 
				}
				else {
					try {
						if (
							html.includes("custom_close_activity") ||
							html.includes("custom_initial_activity")) {
								$content.children().addClass("path-custom-circle-disabled");
								$content.children().removeClass("path-card-disabled");
						}							
						else {
							$content.children().addClass("path-card-disabled"); 
						}
					}
					catch (er) {
						console.log();
					}
				}
				self.graph.getModel().setStyle(node, $content.html());
			}
		});
	};

	adm_process_flow_editor.prototype.__editTransition = function(connector) {

		const drawVersion = this.main.__getVersion();

		if (drawVersion === "2" && connector && connector.source && connector.source.preset_value && connector.source.preset_value !== "" && connector.source.preset_value !== {}) {
			this.AddOrUpdateConnection(connector, connector.source.preset_value, true, true);
		} else {
			let popup = this.__makeConnectorPopup(connector);
			popup.Show();
		}
		
	};
	
	adm_process_flow_editor.prototype.__makeMxEvents = function() {
		var self = this;

		//on selected
		self.graph.getSelectionModel().addListener(mxEvent.CHANGE, function(_) {
			self.__onSelectionChanged();
		});

		//on new connection
		self.graph.connectionHandler.addListener(mxEvent.CONNECT, function(_, evt) {
			 var edge = evt.getProperty("cell");
			 var source = self.graph.getModel().getTerminal(edge, true);
			 var target = self.graph.getModel().getTerminal(edge, false);
			 self.__onConnection(edge, source, target);
		});

		//on double click
		self.graph.addListener(mxEvent.DOUBLE_CLICK, function(_, evt) {
			if (!self.editor.graph.getModel().processing) {			
				var cell = evt.getProperty("cell");
				if (cell && cell.id !== "initial") {
					if (cell.edge) {
						console.log("transition: ", cell && cell.value ? JSON.parse(cell.value) : cell);
						self.__editTransition(cell);
					}
					else {
						self.editor.graph.getModel().processing = true;
						self.__editNode(cell);
					}
				}
				evt.consume();
			} else {
				// there is another popup opening
				evt.consume();
			}
		});

		self.graph.addListener(mxEvent.CONNECT_CELL, function(_, evt) {
			var edge = evt.getProperty("edge");
			var source = self.graph.getModel().getTerminal(edge, true);
			var target = self.graph.getModel().getTerminal(edge, false);
			self.__onConnection(edge, source, target);

		});
		
		self.main.__scrollWithArrows();
	};

	adm_process_flow_editor.prototype.__makePopupMenu = function(menu/*, cell, evt*/) {
		var self = this;
		var actions = self.actionsBar.GetEnabledActions();
		$.each(actions, function(_, action) {
			if (action.sectionBegin) {
				menu.addSeparator();
			}
			menu.addItem(action.name, null, function() {
				self.actionsBar.RunAction(action.id);
			}, null, action.id + "-icon");
		});
	};


	adm_process_flow_editor.prototype.__makeMx = function() {
		var self = this;
		var draw = self.$draw[0];

		//disable context menu in container
		mxEvent.disableContextMenu(draw);
		//create editor class
		self.editor = new mxEditor();
		//create graph class
		self.graph = self.editor.graph;
		//set container
		self.editor.setGraphContainer(draw);
		//set outline
		// new mxOutline(self.graph, outline);
		//set connectable
		self.graph.setConnectable(true);

		self.graph.setDropEnabled(false);

		// Disables drag-and-drop into non-swimlanes.
		self.graph.isValidDropTarget = function(cell/*, cells, evt*/)
		{
			return this.isSwimlane(cell);
		};
		
		// Disables drilling into non-swimlanes.
		self.graph.isValidRoot = function(cell) {
			return this.isValidDropTarget(cell);
		};

		// Does not allow selection of locked cells
		self.graph.isCellSelectable = function(cell) {
			return !this.isCellLocked(cell);
		};

		const drawVersion = self.main.__getVersion(); 

		if (drawVersion === "2") { 

			self.graph.setHtmlLabels(true);
			self.graph.setResizeContainer(false);
			self.graph.getLabel = function(cell) 
			{
				let result = "";
				
				if (this.labelsVisible && cell !== null)
				{
					
					if (cell.style && cell.style.toString().substring(0,4) === "<div") {
						result = cell.style;
					} else {
						let style = this.getCurrentCellStyle(cell);

						if (!mxUtils.getValue(style, mxConstants.STYLE_NOLABEL, false))
						{
							result = this.convertValueToString(cell);
						}
					}
				}
				
				return result;
			};
			
			let style = self.graph.getStylesheet().getDefaultVertexStyle();
			style[mxConstants.STYLE_FILLCOLOR] = "transparent";
			style[mxConstants.STYLE_STROKECOLOR] = "transparent";
			style[mxConstants.STYLE_STROKEWIDTH] = 2;
			style[mxConstants.STYLE_AUTOSIZE] = "1";
			style[mxConstants.STYLE_RESIZABLE] = "0";
			style[mxConstants.STYLE_FOLDABLE] = false;	
			self.graph.getStylesheet().putDefaultVertexStyle(style);
			self.graph.stylesheet.getDefaultVertexStyle().overflow = "fill";
		}

		//prevent detached connectors
		self.graph.setAllowDanglingEdges(false);
		self.graph.setDisconnectOnMove(false);
		//disable multiple connectors between two nodes
		self.graph.setMultigraph(false);
		self.graph.alreadyConnectedResource = "<%=_T('Nodes already connected.')%>";
		//allow loops
		self.graph.setAllowLoops(true);
		//connectors style
		let style = self.graph.getStylesheet().getDefaultEdgeStyle();
		style[mxConstants.STYLE_ROUNDED] = true;
		style[mxConstants.STYLE_EDGE] = mxEdgeStyle.OrthConnector;
		style[mxConstants.STYLE_VERTICAL_ALIGN] = "top";
		style[mxConstants.STYLE_STROKECOLOR] = "#666666";
		style[mxConstants.STYLE_STROKEWIDTH] = 1;
		style[mxConstants.DEFAULT_MARKERSIZE] = 0;
		style[mxConstants.STYLE_ENDARROW] = mxConstants.NONE;
		self.graph.stylesheet.getDefaultVertexStyle().fontColor = "#333333";
		self.graph.alternateEdgeStyle = "elbow=vertical";
		//enables rubberband selection
		new mxRubberband(self.graph);
		//add initial node restrictions
		self.graph.multiplicities.push(new mxMultiplicity(false, "initialNode", null, null, 0, 0, null,
			"<%=_T('Start node can not have incomming transitions.')%>", null));
		self.graph.multiplicities.push(new mxMultiplicity(true, "initialNode", null, null, 1, 1, null,
			"<%=_T('Start node can only have one transition.')%>", 
			"<%=_T('Start node can only have one transition.')%>"));

		self.graph.multiplicities.push(new mxMultiplicity(true, "PortIn", null, null, 0, 0, null, "<%=_T('This port only supports incoming connections.')%>", "<%=_T('This port only supports incoming connections.')%>"));

		self.graph.multiplicities.push(new mxMultiplicity(false, "PortOut_1", null, null, 0, 0, null, "<%=_T('This port only supports one outgoing connection.')%>", null));
		self.graph.multiplicities.push(new mxMultiplicity(true, "PortOut_1", null, null, 1, 1, null, "<%=_T('This port only supports one outgoing connection.')%>", "<%=_T('This port only supports one outgoing connection.')%>"));

		self.graph.multiplicities.push(new mxMultiplicity(false, "PortOut_n", null, null, 0, 0, null, "<%=_T('This port only supports outgoing connections.')%>", null));
		self.graph.multiplicities.push(new mxMultiplicity(true, "PortOut_n", null, null, 1, 99, null, "<%=_T('This port only supports outgoing connections.')%>", "<%=_T('This port only supports outgoing connections.')%>"));

		self.graph.multiplicities.push(new mxMultiplicity(false, "PortOut_0", null, null, 0, 0, null, "<%=_T('This port not supports one outgoing connection.')%>", null)); 
		self.graph.multiplicities.push(new mxMultiplicity(true, "PortOut_0", null, null, 0, 0, null, "<%=_T('This port not supports one outgoing connection.')%>", "<%=_T('This port not supports outgoing connection.')%>")); 

		
		// if (drawVersion === "2") {
		// 	// delete self.graph.getStylesheet().getDefaultEdgeStyle().endArrow; // elimina la punta de flecha de las transisiones
		// }


		//disable label edition
		self.graph.isCellEditable = function() {
			return false;
		};
		//set tooltip function
		self.graph.getTooltipForCell = function(node) {
			return self.__getTooltip(node);
		};
		//set label function
		self.graph.convertValueToString = function(node) {
			return self.__getLabel(node);
		};
		//set popup menu function
		self.graph.popupMenuHandler.factoryMethod = function(menu, cell, evt) {
			return self.__makePopupMenu(menu, cell, evt);
		};
		//make events
		self.__makeMxEvents();
		//load styles
		self.__loadStyles();
		//load draw
		self.__loadDraw();
		// self.graph.center();
		//undo manager
		if (self.__hasUndoManager()) {
			self.undoManager = new mxUndoManager();
			var listener = function(_, evt) {
				self.undoManager.undoableEditHappened(evt.getProperty("edit"));
				self.actionsBar.UpdateButtonsState();
			};
			self.graph.getModel().addListener(mxEvent.UNDO, listener);
			self.graph.getView().addListener(mxEvent.UNDO, listener);
		}

		self.main.SetRunningTest(false);
	};

	adm_process_flow_editor.prototype.createDroppedActivity = function(activity, x, y)
	{
		const self = this;
		let htmlBody = null;
		let ports = [];
		let dataStyle;
		const dropedActivity = self.main.toolbar.activities[activity];
		if (dropedActivity.prototype.htmlBody) {
			htmlBody = dropedActivity.prototype.htmlBody(null);
		}
		if (dropedActivity.prototype.ports) {
			ports = dropedActivity.prototype.ports(null, null); 
		}

		if (dropedActivity.prototype.dataStyle) {
			dataStyle = dropedActivity.prototype.dataStyle(null);
		}

		self.main.NewActivity(dropedActivity);

		return self.__addNode(null, null, activity, null, x, y, null, null, htmlBody, ports);
	};

	adm_process_flow_editor.prototype.addSidebarIcon = function(_, _1, image, activity)
	{
		const self = this;
		const funct = function(graph, evt, cell, x, y) {
			self.__editTransaction(function() {
				self.main.NewActivity(self.main.toolbar.activities[activity]);
				self.main.SetDropCoords(x,y);
			});
		};

		var img = image[0];
		var dragElt = document.createElement("div");
		dragElt.style.border = "dashed red 2px";
		dragElt.style.width = "5px";
		dragElt.style.height = "5px";

		var ds = mxUtils.makeDraggable(img, self.graph, funct, dragElt, 0, 0, true, true);
		return ds;
	};


	adm_process_flow_editor.prototype.__make = function() {
		this.$draw = $(Mustache.render(templates.draw_editor, {
			className : this.__getClassName()
		}));
		this.$outline = $(templates.draw_outline);
		this.$outline.hide();
	};

	adm_process_flow_editor.prototype.Show = function() {
		if (this.$draw) {
			this.main.$element("draw_container").append(this.$draw);
			this.main.$element("draw_container").append(this.$outline);
			this.graph.tooltipHandler.setEnabled(true);
		}
		else {
			this.__make();
			this.main.$element("draw_container").append(this.$draw);
			this.main.$element("draw_container").append(this.$outline);
			this.__makeMx();
		}
		this.actionsBar.Show(this);
	};

	adm_process_flow_editor.prototype.Close = function() {
		if (this.$draw) {
			this.$draw.remove();
			this.$outline.remove();
			this.graph.tooltipHandler.hide();
			this.graph.tooltipHandler.setEnabled(false);
		}
		this.actionsBar.Close();
	};

	adm_process_flow_editor.prototype.CountSelectedNodes = function() {
		var self = this;
		if (!self.selectedNodes) {
			return {};
		}
		var selected = {
			total : 0,
			nodes : 0,
			connectors : 0
		};
		var invalid = false;
		var auxiliarNodes = self.__getAuxiliarNodes();
		$.each(self.selectedNodes, function(_, node) {
			if (auxiliarNodes[node.id || ""]) {
				invalid = true;
				return false;
			}
			selected.total++;
			if (node.edge) {
				selected.connectors++;
			}
			else {
				selected.nodes++;
			}
		});
		return invalid? {} : selected;
	};

	adm_process_flow_editor.prototype.Zoom = function(zoom) {
		zoom = zoom || 0;
		if (this.graph) {
			if (zoom > 0) {
				this.graph.zoomIn(zoom);
			}
			else if (zoom < 0) {
				this.graph.zoomOut(zoom);
			}
			else {
				this.graph.zoomActual();
			}
		}
	};

	adm_process_flow_editor.prototype.__zoom_in = function(value) {
		this.Zoom(value || 1);
	};

	adm_process_flow_editor.prototype.__zoom_out = function(value) {
		this.Zoom(value || -1);
	};

	adm_process_flow_editor.prototype.__zoom_actual = function() {
		this.Zoom(0);
		$("#adm_flow_main_zoom_input").val("100");
	};

	adm_process_flow_editor.prototype.__set_draw_offset = function(viewingMain) {
		const runningTest = this.main.GetRunningTest();
		if (runningTest || viewingMain) {
			this.graph.view.setTranslate(0,0);
		}
		else {
			this.graph.view.setTranslate(368,0);
		}
	};
	
	adm_process_flow_editor.prototype.__zoomTo = function(zoom) {
		zoom = zoom || 0;
		if (this.graph) {
			this.graph.zoomTo(zoom);
		}
	};

	adm_process_flow_editor.prototype.Print = function(callback = $.noop) {
		if (!this.graph)
			return callback();
		const preview = new mxPrintPreview(this.graph, mxUtils.getScaleForPageCount(1, this.graph));
		const writeHead = preview.writeHead;
		preview.writeHead = function(doc, css) {
			writeHead.apply(this, arguments);
			doc.writeln(`<link rel="stylesheet" type="text/css" href="/inconcert/apps/agent/css/mxgraph.css">`);
			doc.writeln(`<link rel="stylesheet" type="text/css" href="/inconcert/lib/font-awesome/css/solid.css">`);
			doc.writeln(`<link rel="stylesheet" type="text/css" href="/inconcert/lib/font-awesome/css/regular.css">`);
			doc.writeln(`<link rel="stylesheet" type="text/css" href="/inconcert/lib/font-awesome/css/fontawesome.css">`);
		};
		preview.open();
		callback();
	};

	adm_process_flow_editor.prototype.__copyNodes = function(nodes) {
		var self = this;
		nodes  = self.graph.model.getTopmostCells(nodes);
		var clones = self.graph.cloneCells(nodes);

		$.each(clones, function(i, clone) {
			var state = self.graph.view.getState(nodes[i]);
			if (state) {
				var geo = self.graph.getCellGeometry(clone);
				if (geo && geo.relative) {
					geo.relative = false;
					geo.x = state.x / state.view.scale - state.view.translate.x;
					geo.y = state.y / state.view.scale - state.view.translate.y;
				}
			}
		});

		return mxClipboard.cellsToString(clones);
	};

	adm_process_flow_editor.prototype.__copySelectedNodes = function() {
		return this.selectedNodes? this.__copyNodes(this.selectedNodes) : null;
	};

	adm_process_flow_editor.prototype.__setCopiedNodes = function() {
		this.__copiedNodes = this.__copySelectedNodes();
	};

	adm_process_flow_editor.prototype.__getCopiedNodes = function() {
		return this.__copiedNodes;
	};

	adm_process_flow_editor.prototype.__copy = function() {
		this.__setCopiedNodes();
		this.actionsBar.UpdateButtonsState();
	};
	
	adm_process_flow_editor.prototype.CanPaste = function() {
		return !!this.__getCopiedNodes();
	};

	adm_process_flow_editor.prototype.__importXml = function(xml, dx, dy) {
		var self = this;
		dx = (dx !== null) ? dx : 0;
		dy = (dy !== null) ? dy : 0;
		var cells = [];
		try {
			var doc = mxUtils.parseXml(xml);
			var node = doc.documentElement;

			if (node !== null) {
				var model = new mxGraphModel();
				var codec = new mxCodec(node.ownerDocument);
				codec.decode(node, model);

				var childCount = model.getChildCount(model.getRoot());
				var targetChildCount = self.graph.model.getChildCount(self.graph.model.getRoot());
				// Merges existing layers and adds new layers
				self.graph.model.beginUpdate();
				try {
					var children;
					for (var i = 0; i < childCount; i++) {
						var parent = model.getChildAt(model.getRoot(), i);
						// Adds cells to existing layers if not locked
						if (targetChildCount > i) {
							// Inserts into active layer if only one layer is being pasted
							var target = (childCount === 1) ? 
								self.graph.getDefaultParent() : 
								self.graph.model.getChildAt(self.graph.model.getRoot(), i);
							if (!self.graph.isCellLocked(target)) {
								children = model.getChildren(parent);
								cells = cells.concat(self.graph.importCells(children, dx, dy, target));
							}
						}
						else {
							// Delta is non cascading, needs separate move for layers
							parent = self.graph.importCells([parent], 0, 0, self.graph.model.getRoot())[0];
							children = self.graph.model.getChildren(parent);
							self.graph.moveCells(children, dx, dy);
							cells = cells.concat(children);
						}
					}
				}
				finally {
					self.graph.model.endUpdate();
				}
			}
		}
		catch (e) {
			throw e;
		}
		return cells;
	};

	adm_process_flow_editor.prototype.__paste = function() {
		var self = this;
		var xml = self.__getCopiedNodes();
		if (!xml) {
			return;
		}

// TODO: NO se estan utilizando las variables "x" e "y", ver de eliminar.
		//var x = self.graph.container.scrollLeft / self.graph.view.scale - self.graph.view.translate.x;
		//var y = self.graph.container.scrollTop / self.graph.view.scale - self.graph.view.translate.y;

		if (xml) {
			if (self.lastPaste !== xml) {
				self.lastPaste = xml;
				self.dx = 0;
				self.dy = 0;
			}
			self.dx += self.graph.gridSize;
			self.dy += self.graph.gridSize;

			// Standard paste via control-v
			if (xml.substring(0, 14) === "<mxGraphModel>") {
				
				let cells = self.__importXml(xml, self.dx, self.dy);
				self.graph.setSelectionCells(cells);

				let correctedCellsAux = self.__correctsClonesPorts(cells , self.dx, self.dy);
				cells = correctedCellsAux.correctedCells;
		
				self.graph.scrollCellToVisible(self.graph.getSelectionCell());
			}
		}
	};

	adm_process_flow_editor.prototype.__correctsClonesPorts = function(cells, dx, dy) {
		const self = this;
		let xml;
		let correctedCells = [];

		$.each(cells, function(_, cell) {
			let newGuid = inConcert.Utils.generateGuid();
			if (cell && cell.children) {
				if (cell.children.length > 2) {
					let multiplePortsResult; 
					self.__editInternalTransaction(function() {
						multiplePortsResult = self.__correctsMultiplePortsClone(cell, dx, dy);
					});
					xml = multiplePortsResult.xml;
					correctedCells.push(multiplePortsResult.cell);
					return;
				}
				if (cell.children[1].preset_value.port_id.includes("default")) {
					newGuid = inConcert.Utils.generateGuid() + "_default";
				}
				cell.children[1].id = newGuid;
				cell.children[1].preset_value.port_id = newGuid;
			}
			correctedCells.push(cell);
		});

		return {correctedCells : correctedCells, xml: xml};
	};

	adm_process_flow_editor.prototype.__correctsMultiplePortsClone = function(cell/*, dx, dy*/) {
		const self = this;
		let xml = self.__getCopiedNodes();
		let ports = cell.children;
		if (!ports) {
			return;
		}
		$.each(ports, function(_, port) {
			let newGuid = inConcert.Utils.generateGuid();
			if (port && port.value !== "PortIn") {
				if (port.preset_value.port_id.includes("default")) {
					newGuid = inConcert.Utils.generateGuid() + "_default";
				}
				cell.value = cell.value.replace(port.preset_value.port_id, newGuid);
				port.id = newGuid;
				port.preset_value.port_id = newGuid;
			}
		});
		return { cell : cell, xml: xml };
	};

	adm_process_flow_editor.prototype.CanUndo = function() {
		return this.__hasUndoManager() && this.undoManager.canUndo();
	};

	adm_process_flow_editor.prototype.CanRedo = function() {
		return this.__hasUndoManager() && this.undoManager.canRedo();
	};

	adm_process_flow_editor.prototype.__undo = function() {
		if (!this.__hasUndoManager()) {
			return;
		}
		this.undoManager.undo();
		this.actionsBar.UpdateButtonsState();
	};

	adm_process_flow_editor.prototype.__redo = function() {
		if (!this.__hasUndoManager()) {
			return;
		}
		this.undoManager.redo();
		this.actionsBar.UpdateButtonsState();
	};

	adm_process_flow_editor.prototype.__getNodePrefix = function() {
		return "_";
	};

	adm_process_flow_editor.prototype.__connectionPortIndex = function(conn, portIndexes) {
		return (conn.data && conn.data.port_id && portIndexes[conn.data.port_id]) || null;
	};

	adm_process_flow_editor.prototype.__sortActivityPortsConnectors = function(activity) {
		if (!activity.data || !activity.data.outputs || !activity.connections) {
			return;
		}

		const portIndexes = activity.data.outputs.reduce((indexes, output, index) => {
			if (output.port_id) {
				indexes[output.port_id] = index + 1;
			}
			return indexes;
		}, {});

		activity.connections.sort((conn1, conn2) => {
			const index1 = this.__connectionPortIndex(conn1, portIndexes);
			const index2 = this.__connectionPortIndex(conn2, portIndexes);

			if (index1 && index2) {
				return index1 - index2;
			} else if (index1) {
				return -1;
			} else if (index2) {
				return 1;
			} else {
				return 0;
			}
		});
	};

	adm_process_flow_editor.prototype.__sortPortsConnectors = function(data) {
		Object.keys(data).forEach((key) => this.__sortActivityPortsConnectors(data[key]));
	};

	//makes a draw model independent that draw library
	adm_process_flow_editor.prototype.__getDrawModel = function() { 
		var self = this;
		let json = {};
		let prefix = self.__getNodePrefix();

		const drawVersion = this.main.__getVersion(); 

		if (drawVersion === "2") {
			$.each(self.graph.getModel().cells, function(_, cell) { 
				if (!cell.vertex) {
					return;
				}
				let id = cell.id === "initial"? cell.id : (prefix + cell.id);
				let current_data = self.GetNodeData(cell);
				let connections = [];

				//iterates outgoing connections
				$.each(cell.edges || {}, function(_, edge) {

					if (cell.value === "PortOut_1" || cell.value === "PortOut_n") {

						//cambio el id del contenedor porque es una actividad que usa puertos salientes

						id = cell.parent.id === "initial"? cell.parent.id : (prefix + cell.parent.id);
						current_data = self.GetNodeData(cell.parent); 

						let connections_to = prefix + edge.target.id;
						let target_node = self.GetNodeById(edge.target.id); 
						
						if (target_node && target_node.value === "PortIn") {
							connections_to = prefix + target_node.parent.id;
						}

						connections.push({
							data : self.GetNodeData(edge),
							to : connections_to
						});

					} else {
	
						//la flecha no es un puerto

						let target_node = self.GetNodeById(edge.target.id);
						
						if (target_node && target_node.value === "PortIn") {

							connections.push({
								data : self.GetNodeData(edge),
								to : prefix + target_node.parent.id
							});

						} else {
							if (edge.source.id !== cell.id) {
								return;
							}
		
							connections.push({
								data : self.GetNodeData(edge),
								to : prefix + edge.target.id
							});
						}
					}
				});

				let new_Connections = connections;
				
				if (json !== {} && json[id] !== undefined) {
					let old_json = JSON.parse(JSON.stringify(json[id])); 
					new_Connections = connections.concat(old_json.connections);
				}
				
				json[id] = {
					data : current_data,
					connections : new_Connections
				};
			});

			self.__sortPortsConnectors(json);

			return json;

		} else {
			$.each(self.graph.getModel().cells, function(_, cell) {
				if (!cell.vertex) {
					return;
				}
				let id = cell.id === "initial"? cell.id : (prefix + cell.id);
				let data = self.GetNodeData(cell);
				let connections = [];
				//iterates outgoing connections
				$.each(cell.edges || {}, function(_, edge) {
					if (edge.source.id !== cell.id) {
						return;
					}
					connections.push({
						data : self.GetNodeData(edge),
						to : prefix + edge.target.id
					});
				});
				json[id] = {
					data : data,
					connections : connections
				};
			});
			return json;
		}

	};

	adm_process_flow_editor.prototype.CancelConnection = function(node) {
		this.DeleteNode(node);
		if (this.__hasUndoManager()) {
			//clear add and delete events
			//this is fixed manually so maybe an update could break it
			this.undoManager.indexOfNextAdd--;
			this.undoManager.history.pop();
			this.undoManager.indexOfNextAdd--;
			this.undoManager.history.pop();
			this.actionsBar.UpdateButtonsState();
		}
	};

	adm_process_flow_editor.prototype.AddOrUpdateConnection = function(node, data, isNew/*, isPreset*/) {
		this.SetNodeData(node, data);
		if (isNew && this.__hasUndoManager()) {
			//clear update event and add value to create event
			//this is fixed manually so maybe an update could break it
			this.undoManager.indexOfNextAdd--;
			let updateEvent = this.undoManager.history.pop();
			let createEvent = this.undoManager.history[this.undoManager.history.length - 1];
			if (createEvent) {
				createEvent.changes[0].value = updateEvent.changes[0].value;
			}
		}
	};
	
	adm_process_flow_editor.prototype.__makeTemplateMessageOptionsCache = function() {
		return new inConcert.Cache(
			function(fetchData, callback) {
				fetchData.campaign.loadTemplateMessageOptions(fetchData.account, fetchData.page, true,
					function(data, error) {
						callback(data, error);
					}
				);
			},
			function(fetchData) {
				return fetchData.campaign.Id + ":" + fetchData.account + (fetchData.page? (":" + fetchData.page) : "");
			},
			60
		);
	};
	
	adm_process_flow_editor.prototype.GetAccountTemplateMessageOptions = function(campaignId, account, page, callback) {
		const self = this;
		if (!this.templateMessageOptionsCache) {
			this.templateMessageOptionsCache = this.__makeTemplateMessageOptionsCache();
		}
		const forceReload = false;
		inConcert.app.getVccCampaign(campaignId, forceReload, function(success, campaign) {
			if (!success) {
				// TODO:mostrar error.
				return;
			}
			self.templateMessageOptionsCache.get({
				campaign: campaign,
				account : account,
				page    : page
			}, 
			function(options, error) {
				callback(options, error);
			});
		});
	};

	adm_process_flow_editor.prototype.loadAllVccCampaigns = function(callback = $.noop) {
		const forceReload = false;
		inConcert.app.getVccCampaigns(forceReload, function(success, campaigns) {
			if (!success) {
				//TODO: mostrar error.
				return;
			}
			let accounts = [];
			$.each(campaigns, function(_, campaign) {
				$.each(campaign.accounts, function(_, account) {
					if (account.state === "1" && campaign.hasAccountTemplateMessageOptions(account)) {
						accounts.push({
							campaign : campaign.Id,
							id       : account.id,
							name     : campaign.getAccountName(account),
							language : account.language
						});
					}
				});
			});
			callback(accounts);
		});
	};

	adm_process_flow_editor.prototype.__getActiveAccounts = function () {
		const forceReload = false;
		let accounts = [];
		inConcert.app.getVccCampaigns(forceReload, function(success, campaigns) {
			if (!success) {
				return;
			}
			$.each(campaigns, function(_, campaign) {
				$.each(campaign.accounts, function(_, account) {
					if (account.state === "1") {
						accounts.push({
							id       : account.id,
							name     : campaign.getAccountName(account),
							type     : account.proxyType
						});
					}
				});
			});
		});
		return accounts;
	};

	adm_process_flow_editor.prototype.__onWheelZoom = function(up) {
		if (!this.graph) {
			return;
		}
		let zoomInputValue = parseInt($("#adm_flow_main_zoom_input").val());
		const WHEEL_ZOOM_FACTOR = 1.1;
		const factor = up ? WHEEL_ZOOM_FACTOR : (1 / WHEEL_ZOOM_FACTOR);
		if (up) {
			$("#adm_flow_main_zoom_input").val(zoomInputValue + 10);
		} else {
			$("#adm_flow_main_zoom_input").val(zoomInputValue - 10);
		}
		this.graph.zoom(factor);

		// this.graph.center(true, true, mouseCoords.x, mouseCoords.y);
	};

	adm_process_flow_editor.prototype.GetTemplateMessageOptions = function(callback = $.noop) {
		const self = this;
		this.loadAllVccCampaigns(function(accounts) {
			(function loadOptions(index) {
				if (index === accounts.length) {
					return callback(accounts);
				}
				let account = accounts[index];
				self.GetAccountTemplateMessageOptions(account.campaign, account.id, account.page, function(options) {
					if (!options) {
						return callback(false);
					}
					account.options = options;
					loadOptions(index + 1);
				});
			})(0);
		});
	};
}());
