/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
//message types
	
	function adm_process_flow_messages_type_mail(parent) {
		adm_process_flow_messages_type_mail.uber.constructor.call(this, parent);
		
		var self = this;
		
		this.actionDefinition = {
			id : "action",
			name : "<%=_T('Action')%>",
			description : "<%=_T('Mail action.')%>",
			required : true,
			not_extended : true,
			options : [
				{
					id : "reply",
					name : "<%=_T('Reply')%>"
				},
				{
					id : "reply_all",
					name : "<%=_T('Reply to All')%>"
				},
				{
					id : "forward",
					name : "<%=_T('Forward')%>"
				}
			],
			change : function() {
				self.__changeAction();
			},
            form_group: true
		};
		
		this.toDefinition = {
			id : "to",
			name : "<%=_T('To')%>",
			description : "<%=_T('Mail to (you can use {{ }} to enter variables).')%>",
			required : true,
			variable: true,
            brackets: true,
            variableIconClass: "ic_variable_icon enabled_disabled far fa-at",
            spanClass: "ic_variable_icon_container",
            without_label: true,
			not_extended : true,
			enabled_disabled : {
				description : "<%=_T('Set custom mail to.')%>",
				value : "default",
				text : "<%=_T('To')%>",
			},
            form_group: true,
            span: true
		};
		
		this.ccDefinition = {
			id : "cc",
			name : "<%=_T('Cc')%>",
			description : "<%=_T('Mail cc list (you can use {{ }} to enter variables).')%>",
			variable: true,
            brackets: true,
            required : false,
            variableIconClass: "ic_variable_icon enabled_disabled far fa-at",
            spanClass: "ic_variable_icon_container",
            without_label: true,
			not_extended : true,
			enabled_disabled : {
				description : "<%=_T('Set custom mail cc.')%>",
				value : "",
				text : "<%=_T('Cc')%>",
			},
            form_group: true,
            span: true
		};
		
		this.bccDefinition = {
			id : "bcc",
			name : "<%=_T('Bcc')%>",
			description : "<%=_T('Mail bcc (you can use {{ }} to enter variables).')%>",
			variable: true,
            brackets: true,
            required : false,
            variableIconClass: "ic_variable_icon enabled_disabled far fa-at",
            spanClass: "ic_variable_icon_container",
            without_label: true,
			not_extended : true,
			enabled_disabled : {
				description : "<%=_T('Set custom mail bcc.')%>",
				value : "",
				text : "<%=_T('Bcc')%>",
			},
            form_group: true,
            span: true
		};
		
		this.subjectDefinition = {
			id : "subject",
			name : "<%=_T('Subject')%>",
			description : "<%=_T('Mail subject (you can use {{ }} to enter variables).')%>",
			required : true,
			variable: true,
            brackets: true,
            variableIconClass: "ic_variable_icon enabled_disabled far fa-at",
            spanClass: "ic_variable_icon_container",
            without_label: true,
			enabled_disabled : {
				description : "<%=_T('Set custom subject.')%>",
				value : "default",
				text : "<%=_T('Subject')%>",
			},
            form_group: true,
            span: true
		};
		
		this.bodyDefinition = {
			id : "body",
			name : "<%=_T('Body')%>",
            variableIconClass: "d-none",
			description : "<%=_T('Mail body (you can use {{ }} to enter variables).')%>",
			without_label : true,
			required : true,
			not_extended : true,
			variable: true,
            brackets: true,
            //form_group: true
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_mail, inConcert.adm_process_flow_messages_type.base.base );

	adm_process_flow_messages_type_mail.prototype.name = "<%=_T('Mail')%>";
	adm_process_flow_messages_type_mail.prototype.description = "<%=_T('EMail message.')%>";

	adm_process_flow_messages_type_mail.prototype.GetMigrationRepositoryFiles = function(_, _1, data) {
		return (data.message && data.message.attachments || []).map(function(attachment) {
			return {
				id : attachment.id
			};
		});
	};

	adm_process_flow_messages_type_mail.prototype.Make = function(data) {
		var self = this;
		var activity = self.parent.activity;
		var $content = [];
		
        $content.push(
            activity.__makeDivFlex(
              [
                activity.__makeDivFlex(activity.__makeComboFlex(self.actionDefinition,data[self.actionDefinition.id]),{ class: "col-6" }),
                activity.__makeDivFlex(activity.__makeInputFlex(self.toDefinition, data[self.toDefinition.id] !== undefined? 
					data[self.toDefinition.id] : self.toDefinition.enabled_disabled.value),{ class: "col-6" })
              ],{ class: "row align-items-end" }
            )
        );

        $content.push(
            activity.__makeDivFlex(
              [
                activity.__makeDivFlex(activity.__makeInputFlex(self.ccDefinition, data[self.ccDefinition.id] !== undefined? 
					data[self.ccDefinition.id] : self.ccDefinition.enabled_disabled.value),{ class: "col-6" }),
                activity.__makeDivFlex(activity.__makeInputFlex(self.bccDefinition, data[self.bccDefinition.id] !== undefined? 
					data[self.bccDefinition.id] : self.bccDefinition.enabled_disabled.value),{ class: "col-6" })
              ],{ class: "row align-items-end" }
            )
        );

        $content.push(
            activity.__makeDivFlex(
              [
                activity.__makeDivFlex(activity.__makeInputFlex(self.subjectDefinition, data[self.subjectDefinition.id] !== undefined? 
                    data[self.subjectDefinition.id] : self.subjectDefinition.enabled_disabled.value),{ class: "col-12" })
              ],{ class: "row" }
            )
        );

        $content.push(
            activity.__makeDivFlex(
              [
                activity.__makeDivFlex(activity.__makeRowMailEditor(activity.__makeTextarea(self.bodyDefinition, data[self.bodyDefinition.id])),{ class: "col-12" })
              ],{ class: "row" }
            )
        );

		$.each(data.body || [], function(_, body) {
			if (body.type === "text/html") {
				self.currentBody = body.content;
			}
		});

		return $content;
	};

	adm_process_flow_messages_type_mail.prototype.AfterAppendBody = function() {
		var self = this;
		var activity = self.parent.activity;
		var owner = {
			show_status_message : function(message, _, timeout) {
				activity.__showError(message, null, timeout);
			},
			is_readonly : function() {
				return false;
			}
		};
		self.html_editor = new inConcert.MailManagement({
			owner: owner,
			auto_init: true,
			ids: {
				body     : activity.__getControlGuid(self.bodyDefinition),
				container: activity.__getControlContainerGuid(self.bodyDefinition)
			},
			callbacks: {
				loadVariables: function(sorted, callback = $.noop) {
					inConcert.app.loadVariablesForFlowDesigner(sorted, function (success, variables) {
						if (!success) {
							throw("Unable to load FlowDesigner Variables");
						}
						let custom_variables = inConcert.Utils.cloneArray(variables);
						$.each(custom_variables, (_, variable) => {
							if(!(/\{{2}.*\}{2}/g.test(variable.id)))
								variable.id = "{" + variable.id + "}";
						  });
						callback(success, custom_variables);
					})
				}
			}
		});

		if (self.currentBody) {
			self.html_editor.set(self.currentBody);
		}

		self.__changeAction();
	};

	adm_process_flow_messages_type_mail.prototype.__changeAction = function() {
		var activity = this.parent.activity;
		var action = activity.__getValue(this.actionDefinition);
		this.__changeTo(action);
		this.__changeCc(action);
		this.__changeBcc(action);
		this.__changeSubject(action);
	};
	
	adm_process_flow_messages_type_mail.prototype.__changeTo = function(action) {
		var activity = this.parent.activity;
		action = action || activity.__getValue(this.actionDefinition);
		if (action === "forward") {
			activity.__hideEnabledDisabledControl(this.toDefinition);
		}
		else {
			activity.__showEnabledDisabledControl(this.toDefinition);
		}
	};
	
	adm_process_flow_messages_type_mail.prototype.__changeCc = function(action) {
		var activity = this.parent.activity;
		action = action || activity.__getValue(this.actionDefinition);
		if (action !== "reply_all") {
			activity.__hideEnabledDisabledControl(this.ccDefinition);
		}
		else {
			activity.__showEnabledDisabledControl(this.ccDefinition);
		}
	};
	
	adm_process_flow_messages_type_mail.prototype.__changeBcc = function(action) {
		var activity = this.parent.activity;
		action = action || activity.__getValue(this.actionDefinition);
		if (action !== "reply_all") {
			activity.__hideEnabledDisabledControl(this.bccDefinition);
		}
		else {
			activity.__showEnabledDisabledControl(this.bccDefinition);
		}
	};
	
	adm_process_flow_messages_type_mail.prototype.__changeSubject = function(action) {
		var activity = this.parent.activity;
		action = action || activity.__getValue(this.actionDefinition);
		if (action === "forward") {
			this.subjectDefinition.enabled_disabled.text = "<%=_T('Fw: Last mail subject')%>";
		}
		else {
			this.subjectDefinition.enabled_disabled.text = "<%=_T('Re: Last mail subject')%>";
		}
		activity.__showEnabledDisabledControl(this.subjectDefinition);
	};
	
	adm_process_flow_messages_type_mail.prototype.AddValueAsync = function(data, callback) {
		var self = this;
		var activity = self.parent.activity;
		activity.__addValue(data, self.subjectDefinition);
		activity.__addValue(data, self.bccDefinition);
		activity.__addValue(data, self.ccDefinition);
		activity.__addValue(data, self.toDefinition);
		activity.__addValue(data, self.actionDefinition);
		self.__addBody(data, function() {
			callback();
		});
	};
	
	adm_process_flow_messages_type_mail.prototype.__addBody = function(data, callback) {
		var self = this;
		self.html_editor.start_upload_images(function(status) {
			if (!status) {
				data.error = {
					message : "<%=_T('Error uploading embeed images.')%>", 
					control : self.bodyDefinition.id 
				};
				return callback();
			}
			self.html_editor.validate(function(validationResult) {
				if (!validationResult.success) {
					data.error = {
						message : validationResult.message || "<%=_T('Must enter a message body.')%>", 
						control : self.bodyDefinition.id 
					};
					return callback();
				}
				//add body
				var body = self.html_editor.get_body_parts();
				data.body = [body[0]];
				
				//add brackets
				if (self.bodyDefinition.brackets) {	
					let body_content = data.body[0].content;
					let bracketsValue =  self.parent.activity.__getBracketsValue(body_content);
					data.body[0]["__brackets_content"] = bracketsValue;
				}
				
				//add attachments
				data.attachments = [];
				var attachmentImages = self.html_editor.get_repository_images_list();
				$.each(attachmentImages, function(_, image) {
					data.attachments.push(image);
				});
				//return
				callback();
			});
		});
	};
	
	if (!inConcert.adm_process_flow_messages_type.mail) {
		inConcert.adm_process_flow_messages_type.mail = {
			mail : adm_process_flow_messages_type_mail
		};
	}
	
	if (!inConcert.adm_process_flow_messages_type.mail_sorted) {
		inConcert.adm_process_flow_messages_type.mail_sorted = [
			"mail"
		];
	}
	
//button types
	
	if (!inConcert.adm_process_flow_messages_button.mail) {
		inConcert.adm_process_flow_messages_button.mail = {
			list : inConcert.adm_process_flow_messages_button.base.base,
			gallery : inConcert.adm_process_flow_messages_button.base.base
		};
	}
	
//quick replies
	
	if (!inConcert.adm_process_flow_messages_quickreply.mail) {
		inConcert.adm_process_flow_messages_quickreply.mail = inConcert.adm_process_flow_messages_quickreply.base;
	}
	
//clase

	function adm_process_flow_messages(activity) {
		adm_process_flow_messages.uber.constructor.call(this, activity);
	}

	inConcert.Utils.inherit( adm_process_flow_messages, inConcert.adm_process_flow_messages.base );

	if (typeof inConcert.adm_process_flow_messages.mail !== "function") {
		inConcert.adm_process_flow_messages.mail = adm_process_flow_messages;
	}

	adm_process_flow_messages.prototype.__maxQuickreplies = function() {
		return 0;
	};

	adm_process_flow_messages.prototype.__hasWriting = function() {
		return false;
	};

}());
