/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	function adm_process_flow_state_popup(main, data) {
		adm_process_flow_state_popup.uber.constructor.call(this);
		this.main = main;
		this.isNew = !data;
		this.data = data || {};
		
		var self = this;
		
		this.nameDefinition = {
			id : "name",
			name : "<%=_T('Name')%>",
			description : "<%=_T('State name.')%>",
			placeholder : "<%=_T('Enter name')%>",
			required : true,
			validate : {
				type : "id",
				message : "<%=_T('Only letters, numbers, dashes and dots are allowed in state name.')%>",
				method : function(value) {
					var stateId = self.main.GetStateFromName(value);
					if (stateId && stateId !== self.data.id) {
						return "<%=_T('Already exists a state with same name.')%>";
					}
				}
			},
            form_group: true
		};
		this.descriptionDefinition = {
			id : "description",
			name : "<%=_T('Description')%>",
			description : "<%=_T('State description.')%>",
			placeholder : "<%=_T('Enter description')%>",
			required : true,
            form_group: true
		};
		
		this.focusControl = this.nameDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_state_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_state_popup !== "function") {
		inConcert.adm_process_flow_state_popup = adm_process_flow_state_popup;
	}

	adm_process_flow_state_popup.prototype.__getClassName = function() {
		return "popUp520w flowDesignerGlobalModal tabsPopOver flowDesignerOverlayModal";
	};

	adm_process_flow_state_popup.prototype.__getTitle = function() {
        if (this.isNew)
			return "<%=_T('New State')%>";
		else
			return (this.data.name !== undefined) ? this.data.name: "<%=_T('New State')%>";	  
	};

	adm_process_flow_state_popup.prototype.__makeContent = function() { 
		let $content = [];
		$content.push(
			this.__makeDivFlex(
				[
				  this.__makeDivFlex(
					[
						this.__makeDivFlex(
							this.__makeDivFlex(this.__makeInputFlex(this.nameDefinition, this.data[this.nameDefinition.id]),{ class: "col-12" }),{ class: "row" }
						)
					],
					{ class: "card-block" }
				  ),
				],
				{ class: "card no-card" }
			  )
        );
		return $content;
	};

	adm_process_flow_state_popup.prototype.__hasCloseButton = function() {
		return false;
	};

	adm_process_flow_state_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.nameDefinition);
		data.description = data[this.nameDefinition.id];
		//this.__addValue(data, this.descriptionDefinition);
		return data;
	};

	adm_process_flow_state_popup.prototype.__save = function(data, callback) {
		if (this.isNew) {
			this.main.AddState(data);
		}
		else {
			this.main.UpdateState(this.data.id, data);
		}
		callback(true);
	};

}());
