/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
 strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if (!this.inConcert) {
	this.inConcert = {};
}
if (!inConcert.templates) {
	inConcert.templates = {};
}

(function () {

	'use strict';

	const format = inConcert.Utils.format;

const Templates = {
	//admin popups

	div_popup : "".concat(
		"<div parent {{ persoTags }} {{ #id }}id='{{ id }}'{{ /id }} {{ #control }}control='{{ control }}'{{ /control }} {{ #class }}class='{{ class }}'{{ /class }} {{ #style }}style='{{ style }}'{{ /style }}>",
			"{{ #children }}{{ children }}{{ /children }}",
		"</div>",	
	),
	label_popup : "".concat(
		"<label parent {{ persoTags }} {{ #id }}id='{{ id }}'{{ /id }} {{ #controlLabel }}control_label='{{ controlLabel }}'{{ /controlLabel }} {{ #for }}for='{{ for }}'{{ /for }} {{ #class }}class='{{ class }}'{{ /class }}>",
			"{{ #children }}{{ children }}{{ /children }}",
		"</label>"
	),
	span_popup : "".concat(
		"<span {{ #class }}class='{{ class }}'{{ /class }}>",
			"{{ #content }}{{ content }}{{ /content }}",
        "</span>"
	),
	input_popup : "".concat(
		"<input {{ #id }}id='{{ id }}'{{ /id }} {{ #control }}control='{{ control }}'{{ /control }} {{ #class }}class='{{ class }}'{{ /class }} {{ #type }}type='{{ type }}'{{ /type }} {{ #name }}name='{{ name }}'{{ /name }} {{ #value }}value='{{ value }}'{{ /value }} {{ #placeholder }}placeholder='<%=_T('{{ placeholder }}')%>'{{ /placeholder }}/>"
	),	
	icon_popup : "".concat(
		"<i {{ persoTags }} {{ #validation }}validation='{{ validation }}'{{ /validation }} {{ #id }}id='{{ id }}'{{ /id }} {{ #class }}class='{{ class }}'{{ /class }} {{ #title }}title='{{ title }}'{{ /title }} {{ hidden }}></i>"
	),
	button_popup: "".concat(
		"<button parent {{ #id }}id='{{ id }}'{{ /id }}  {{ #action }}action='{{ action }}'{{ /action }} {{ #class }}class='{{ class }}'{{ /class }} {{ #type }}type='{{ type }}'{{ /type }}>",
			"{{ #content }}<%=_T('{{ content }}')%>{{ /content }}",
		"</button>"
	),

	select_popup: "".concat(
		"<select {{ #id }}id='{{ id }}'{{ /id }} {{ #control }}control='{{ control }}'{{ /control }} {{ #class }}class='{{ class }}'{{ /class }}>", 
			"{{ options_list }}",
		"</select>"
	),

	new_popup : "".concat(
		'<div class="internalPopUpContainer processFlowPopup formPopUp popUp380w">',
			'<div class="internalPopUpOverlay"></div>',
			'<div class="internalPopUp">',
				// title
				'<div class="internalPopUpTitle">',
					'<span><%=_T("New Workflow")%></span>',
					// '<button id="adm_form_process_flow_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
				'</div>',

				//
				'<div class="internalPopUpMiddle pageFormContainer">',
					// mensaje de error
					'<div id="adm_form_process_flow_new_message" class="genericFormMessagesContainer messageError" style="display:none;"></div>',

					// check input
					'<div class="card no-card">',
						'<div class="card-block">',
							'<div class="row">',
								'<div class="col-12">',
									'<div class="form-group">',
										//Importar desde archivo
										'<div class="form-check">',
											'<label for="adm_form_process_flow_import" class="form-check-label form-check-label-title">',
												'<input id="adm_form_process_flow_import" class="form-check-input" type="checkbox">',
												'<%=_T("Import flow")%>',
											'</label>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					//Selección de archivo de importación
					// if check:checked
					'<div class="card no-card pt-2" id="adm_form_process_flow_import_file_container" style="display:none;">',
						'<div class="card-block">',
							'<div class="row">',
								'<div class="col-12 d-flex">',
									'<div class="form-group flex-grow-1 position-relative">',
											'<label for="adm_form_process_flow_import_file" class="required"> <%=_T("File uploaded")%><%=_T(":")%></label>',
											'<input id="adm_form_process_flow_import_file" class="form-control formFieldUpload" type="text" readonly />',
											'<i id="adm_form_process_flow_import_file_validation" class="formFieldValidation formFieldError" hidden></i>',
											"<label id='adm_form_process_flow_import_file_upload_percentage' class='uploadFilePercentage' hidden >100%</label>",
									'</div>',
									'<div class="form-group d-flex align-items-end">',
										'<button class="pageButtonGeneric buttonColorWhite">',
											// '<i class="far fa-upload mr-2"></i>',
											'<%=_T("Upload File")%>',
											'<input id="adm_form_process_flow_import_file_upload" type="file" hidden="" accept=".json">',
										'</button>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
					'<hr/>',

					// text inputs
					'<div class="card no-card">',
						
						'<div class="card-block">',
							'<div class="row">',
								'<div class="col-12">',
									'<div class="form-group">',
										'<label for="adm_form_process_flow_type" class="required"> <%=_T("Type")%><%=_T(":")%></label>',
										'<select id="adm_form_process_flow_type" class="form-control"></select>',
										'<i id="adm_form_process_flow_type_validator" class="formFieldValidation formFieldError" hidden></i>',
									'</div>',
								'</div>',
							'</div>',
							'<div class="row">',
								'<div class="col-12">',
									'<div class="form-group">',
										'<label for="adm_form_process_flow_name" class="required"> <%=_T("Name")%><%=_T(":")%></label>',
										'<input id="adm_form_process_flow_name" class="form-control" type="text" placeholder="', '<%=_T("Enter name")%>...', '" />',
										'<i id="adm_form_process_flow_name_validation" class="formFieldValidation formFieldError" hidden></i>',
									'</div>',
								'</div>',
							'</div>',
							'<div class="row">',
								'<div class="col-12">',
									'<div class="form-group">',
										'<label for="adm_form_process_flow_description" class="required"> <%=_T("Description")%><%=_T(":")%></label>',
										'<input id="adm_form_process_flow_description" class="form-control" type="text" placeholder="', '<%=_T("Enter description")%>...', '" />',
										'<i id="adm_form_process_flow_description_validation" class="formFieldValidation formFieldError" hidden></i>',
									'</div>',
								'</div>',
							'</div>',
							'<div class="row" style="display:none;">',
								'<div class="col-12">',
									'<div class="form-group">',
										'<input id="adm_form_process_flow_version" class="form-control" type="number" step=".0" placeholder="', '<%=_T("Enter version")%>...', '" />',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',

				// MODAL FOOTER BUTTONS
				'<div class="internalPopUpButtons">',
					"<button id='adm_form_process_flow_cancel' class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>",
					"<button id='adm_form_process_flow_open' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
				'</div>',
			'</div>',
		'</div>'
	),
	clone_popup : "".concat(
		"<div class='internalPopUpContainer processFlowPopup formPopUp popUp380w'>",
			"<div class='internalPopUpOverlay'></div>",
			"<div class='internalPopUp'>",

				// title
				'<div class="internalPopUpTitle">',
					'<span><%=_T("Clone process flow")%></span>',
					// '<button id="adm_form_process_flow_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
				'</div>',

				'<div class="internalPopUpMiddle pageFormContainer">',
					// mensaje de error
					'<div id="adm_form_process_flow_new_message" class="genericFormMessagesContainer messageError" style="display:none;"></div>',

					// text inputs
					'<div class="card no-card">',
						'<div class="card-block">',
							'<div class="row">',
								'<div class="col-12">',
									'<div class="form-group">',
										'<label for="adm_form_process_flow_name" class="required"> <%=_T("Name")%><%=_T(":")%></label>',
										'<input id="adm_form_process_flow_name" class="form-control" type="text" placeholder="', '<%=_T("Enter name")%>...', '" />',
										'<i id="adm_form_process_flow_name_validation" class="formFieldValidation formFieldError" hidden></i>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',

				// MODAL FOOTER BUTTONS
				'<div class="internalPopUpButtons">',
					"<button id='adm_form_process_flow_cancel' class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>",
					"<button id='adm_form_process_flow_open' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
				'</div>',

			"</div>",
		"</div>"
	),
	//designer
	flow_base: "".concat(
		"<div id='flowDesignerContainer' class='flowDesignerContainer {{ type }}Flow'>",
			"<div processing class='flowDesignerProcessing' hidden>",
			"</div>",
			"<div editor_container class='flowDesignerEditorContainer'>",
				// Drawing 
				"<div draw_container id='flowDesignerDrawContainer' class='flowDesignerDrawContainer'>",
				"</div>",

				// Acciones barra superior
				"<div flow_title_and_actions_bar class='flowDesignerFloatBar d-flex flex-row'>",
					"<button close_button class='pageButtonGeneric buttonBackLight iconOnlyBtn'><i class='fas fa-chevron-left'></i></button>",
					"<div flow_title class='flowDesignerTitle flex-grow-1' title='{{ description }}'>",
						'<label flow_name class="flowDesignerTitleType">',
							'{{ translated_type }}',
						'</label>',
						'<label flow_name class="flowDesignerTitleText">',
							'{{ name }}',
						'</label>',
					"</div>",
					//"<button class='pageButtonGeneric buttonColorWhite iconOnlyBtn ml-auto'><i class='far fa-search'></i></button>",
					"<div class='dropdown dropdown-light'>",
						"<button flow_dropdown_actions class='buttonToggle buttonToggleOutlined' id='dropdownMenuButtonProcessFlow' data-toggle='dropdown' aria-haspopup='true' aria-expanded='false'><i class='far fa-ellipsis-v'></i></button>",
						"<div global_actions class='dropdown-menu dropdown-menu-right flowDesignerGlobalActions' aria-labelledby='dropdownMenuButtonProcessFlow'>",
						"</div>",
					"</div>",
					"<button id='flowDesignerShowEventTrace' show_event_trace class='pageButtonGeneric flowDesignerBotsTestActionButton'>",
						"<%=_T('Start Test')%>",
					"</button>",
					"<button flow_save action_button='save' class='pageButtonGeneric buttonColorBlue'><%=_T('Save')%></button>",
					// "<button expand_button class='pageButtonGeneric buttonColorWhite iconOnlyBtn'><i class='far fa-expand'></i></button>",
				"</div>",
				// Tabs principal y de actividades_
				"<header navigation_bar_container id='adm_flow_header' class='flowDesignerNavigationBar'>",
					// "<div navigation_bar id='navigation_bar' class='flowDesignerNavBarTabsContainer'>",
					// "</div>",
					"<nav id='adm_flow_navigation_bar' role='navigation' class='flowDesignerNavBarTabsContainer okayNav'>",
						"<ul navigation_bar_items>",
							// "<li class='flowDesignerNavigationTab {{ className }}'><a href='#'>Home</a></li>",
							// "<li class='flowDesignerNavigationTab {{ className }}'><a href='#'>Shop</a></li>",
							// "<li class='flowDesignerNavigationTab {{ className }}'><a href='#'>Blog</a></li>",
							// "<li class='flowDesignerNavigationTab {{ className }}'><a href='#'>Services</a></li>",
							// "<li class='flowDesignerNavigationTab {{ className }}'><a href='#'>Contacts</a></li>",
							// "<li class='flowDesignerNavigationTab {{ className }}'><a href='#'>About us</a></li>",
							// "<li class='flowDesignerNavigationTab {{ className }}'><a href='#'>Testimonials</a></li>",
						"</ul>",
					"</nav>",
				"</header>",
				"<div class='flowDesignerActionsBarContainer'>",
					// Menu de actividades_
					"<div tool_bar id='flowDesignerToolBar' class='flowDesignerToolBar' hidden>",
						"<div tool_bar_title tool_bar_toggle class='flowDesignerToolBarTitle'>",
							"<label>",
								"<%=_T('Activities')%>",
							"</label>",
							"<i tool_bar_toggle class='flowDesignerButtonIcon far fa-chevron-up'></i>",
						"</div>",
						"<ul tool_bar_list class='flowDesignerToolbarCategoriesList'>",
						"</ul>",
					"</div>",
					"<div actions_bar class='flowDesignerActionsBar'>",
						// "<div editor_actions class='flowDesignerEditorActions'></div>",
						"<div class='flowDesignerEditorActions'>",
							"<button new_state action_button='new_state' class='pageButtonGeneric buttonColorOrange pageButtonNew ml-0' hide>",
								"<i class='fal fa-plus'></i><%=_T('New State')%></button>",
							"<div undo_redo class='flowDesignerGroupActions'>",
								"<button undo action_button='undo' class='pageButtonGeneric buttonColorWhite iconOnlyBtn' title='<%=_T('Undo (Ctrl + Z).')%>'>",
									"<i class='far fa-undo'></i></button>",
								"<button redo action_button='redo' class='pageButtonGeneric buttonColorWhite iconOnlyBtn' title='<%=_T('Redo (Ctrl + Y).')%>'>",
									"<i class='far fa-redo'></i></button>",
							"</div>",
							"<div class='flowDesignerGroupActions'>",
								"<button zoom_out action_button='zoom_out' class='pageButtonGeneric buttonColorWhite iconOnlyBtn' title='<%=_T('Zoom out')%>'>",
									"<i class='far fa-minus'></i></button>",
								"<div action_zoom_input class='zoomInputContainer'>",
									"<input adm_flow_main_zoom_input id='adm_flow_main_zoom_input' value='100' class='form-control zoomInput' type='text' />",
									"<span class='zoomInputUnit'>%</span>",
								"</div>",
								"<button zoom_in action_button='zoom_in' class='pageButtonGeneric buttonColorWhite iconOnlyBtn' title='<%=_T('Zoom in')%>'>",
									"<i class='far fa-plus'></i></button>",
								"<button zoom_actual action_button='zoom_actual' class='pageButtonGeneric buttonColorWhite iconOnlyBtn' title='<%=_T('Restore Zoom')%>'>",
									"<i class='far fa-compress-alt'></i></button>",
							"</div>",
						"</div>",
						// "<div global_actions class='flowDesignerGlobalActions'>",
						// 	"<div class='flowDesignerCloseButton'>",
						// 		"<button close_button class='buttonColorGray flowDesignerActionButton'>",
						// 			"<%=_T('Close')%>",
						// 		"</button>",
						// 	"</div>",
						// "</div>",
					"</div>",
					"<div disclaimer id='flowDesignerScrollInstructonsDisclaimer' class='inlineMessagesContainer messageInfo inlineMessageDismissable'><span><strong><%=_T('To scroll through the canvas')%>:&nbsp;</strong><%=_T('click the right mouse button and hold it down.')%></span> <a close_message id ='flowDesignerCloseScrollInstructonsDisclaimer' class='genericMessagesClose'></a></div>",
				"</div>",
				"<div trace_container class='flowDesignerTraceContainer' style='display:none'>",
				"</div>",
				"<div event_trace_container class='flowDesignerTraceContainer' style='display:none'>",
				"</div>",
				"<div bottom_bar class='flowDesignerBottomBarContainer'>",
					"<button show_trace id='flowDesignerShowTrace' class='pageButtonGeneric buttonColorWhite flowDesignerTraceButtonText flowDesignerShowTraceButton'>",
						"<%=_T('Execution Trace')%>",
						"<i class='fas fa-chevron-down'></i>",
					"</button>",
					// "<button id='show_event_trace' show_event_trace class='pageButtonGeneric buttonColorOrange flowDesignerBotsTestActionButton'>",
					// 	"<%=_T('Start Test')%>",
					// "</button>",
				"</div>",
			"</div>",
		"</div>"
	),
	//draw
	draw_editor: "".concat(
		// "<div draw_editor_wrapper>",
			"<div draw_editor class='flowDesignerEditor {{ className }}'>",
			"</div>",
		// "</div>"
	),
	draw_chat_test: "".concat(
		"<div draw_chat_test id='draw_chat_test' class='flowDesignerChatPreview' style='display:none;z-index: 12;'>",
			"<button chat_test_iframe_close id='chat_test_iframe_close' class='btn flowDesignerChatCloseButton'><i class='far fa-times'></i></button>",
			// "<iframe id='chat_test_iframe_frame' name='chat_test_iframe' class='' src=''>",
			// "</iframe>",
		"</div>",
	),
	draw_outline: "".concat(
		"<div draw_outline class='flowDesignerEditorOutline'>",
		"</div>"
	),
	//actions bar - actions dropdown
	action_button: "".concat(
		"<div action_button='{{ id }}' class='dropdown-item flowDesignerActionButton {{ id }}FlowActionButton {{ #withoutText }}withoutText{{ /withoutText }}' title='{{ description }}'>",
			"{{ #withText }}{{ name }}{{ /withText }}",
		"</div>"
	),
	//navigation bar
	navigation_tab: "".concat(
		// "<div tab navigation_tab='{{ id }}' tab_name='{{ name }}' class='flowDesignerNavigationTab {{ className }}' title='{{ description }}'>",
		// 	"<span>{{ name }}</span>",
		// 	// "<div close_tab class='closeBtn'><i class='far fa-times'></i></div>",
		// "</div>"
		"<li tab navigation_tab='{{ id }}' tab_name='{{ name }}' class='flowDesignerNavigationTab {{ className }}' title='{{ description }}'>",
				"<span>{{ name }}</span>",
		"</li>"
	),
	//navigation bar - scrollButton [left/right]
	navigation_tab_scroll: "".concat(
		"<button scroll_{{ direction }} class='flowDesignerNavigationTab scrollDirection' title='{{ direction }}'>",
			"<i class='flowDesignerButtonIcon far fa-chevron-{{ direction }}'></i>",
		"</button>"
	),
	//tool bar
	toolbar_category: "".concat(
		"<li toolbar_category='{{ id }}' category_selector='true' class='flowDesignerToolbarCategory'>",
			"<div category_selector='true' category_selector_title class='flowDesignerToolbarCategoryTitle'>",
				// "<i category_selector='true' class='flowDesignerToolbarCategoryIcon toolbar-category-icon-{{ id }}'></i>",
				"<span category_selector='true'>{{ name }}</span>",
				"<i category_selector='true' class='far fa-chevron-down'></i>",
			"</div>",
			"<ul activities_list class='flowDesignerToolbarActivitiesList'>",
			"</ul>",
		"</li>"
	),
	toolbar_activity: "".concat(
		"<li toolbar_activity='{{ id }}' class='flowDesignerToolbarActivity' title='{{ description }}'>",
			"<i class='flowDesignerButtonIcon flowDesignerToolbarActivityIcon toolbar-activity-icon-{{ id }}'></i>",
			"<span>{{ name }}</span>",
			// "<img drag_activity='{{ id }}' class='flowDesignerToolbarActivityIconGrip' width='24' height='24' src='/inconcert/apps/flow_designer/images/flow_designer/ic-icon-drag-drop.svg' />",
		"</li>"
	),
	//popups
	popup_container: "".concat(
		'<div id="{{ id }}" class="internalPopUpContainer formPopUp flowDesignerPopUpContainer {{ className }}">',
			'<div class="internalPopUpOverlay"></div>',
			
			"{{ #showEditTitleButton }}",
			'<div id="flow_designer_internal_popup_draggable" draggable="true" class="internalPopUp">',
			"{{ /showEditTitleButton }}",
			
			"{{ ^showEditTitleButton }}",
			'<div id="flow_designer_internal_popup_draggable" class="internalPopUp">',
			"{{ /showEditTitleButton }}",

				'<div self_overlay class="inconcertPopupWindowOverlay popupSelfOverlay" style="display:none;"></div>',
				'<div id="flow_designer_internal_popup_title" class="internalPopUpTitle">',
					"<label activity_description class='flowDesignerPopupTitleText'>",
                    "{{ #showEditTitleButton }}",
                        "{{ newOrEdit }}",
                    "{{ /showEditTitleButton }}",
						"<activityTitle id='activity_title'>{{ title }}</activityTitle>",
					"</label>",
					"{{ #showEditTitleButton }}",
					"<div activity_description_edit class='form-group activityDescriptionEdit' style='display: none;'>",
						"<div class='d-flex flex-grow-1'>",
							"<input activity_desctiption_input id='activity_description_input' control='description' class='form-control' type='text' placeholder='<%=_T('Enter description')%>...'/>",
							"<i validation='description' id='flow_designer_activity_description_validation' class='formFieldValidation formFieldError' hidden></i>",
						"</div>",
						"<button id='flow_designer_activity_description_edit_save' class='pageButtonGeneric buttonColorWhite iconOnlyBtn save align-self-end ml-1' title='<%=_T('Save')%>'><i class='far fa-check-circle'></i></button>",
						"<button id='flow_designer_activity_description_edit_cancel' class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end ml-1' title='<%=_T('Cancel')%>'><i class='far fa-times-circle'></i></button>",
					"</div>",
					
					"<button id='flow_designer_activity_description_edit' class='pageButtonGeneric buttonColorTransparent iconOnlyBtn align-self-end ml-2' title='<%=_T('Edit')%>'><i class='far fa-pencil'></i></button>",
					"{{ /showEditTitleButton }}",
					'<button close_button_icon class="internalPopUpCloseButton flowDesignerButtonIcon"><i class="far fa-times"></i></button>',
				'</div>',
				'<div loading class="flowDesignerPopupLoading" style="display:none;"></div>',
				'<div internalPopUpMiddle class="internalPopUpMiddle pageFormContainer flowDesignerPopupContent ">',
					'<div message_container class="genericFormMessagesContainer messageError" style="display:none;">',
						'<label message_text></label>',
					'</div>',
					// '<div card class="card">', 
						// '<div content class="card-block">',
					'<div content id="popup_content">',
					'</div>',
					// '</div>',
				'</div>',
				'<div actions class="internalPopUpButtons justify-content-end">', 
					'<button close_button class="pageButtonGeneric flowDesignerPopupCloseButton buttonColorBlack" type="button">',
						'<%=_T("Close")%>',
					'</button>',
				'</div>',
			'</div>',
		'</div>'
	),
	popup_action_classesIde: "".concat(
		// '<div class="auxContainerButtons">',
			'<button action="classes_ide" class="pageButtonGeneric buttonColorWhite" type="button">',
				'<%=_T("Create/Edit Classes")%>',
			'</button>'
		// '</div>'
	),
	popup_action_datasourcesIde: "".concat(
		// '<div class="auxContainerButtons">',
			'<button action="datasources_ide" class="pageButtonGeneric buttonColorWhite" type="button">',
				'<%=_T("Create/Edit Datasources")%>',
			'</button>'
		// '</div>'
	),
	popup_actions: "".concat( 
		"{{ #hasCloseButton }}",
			'<button id="action_cancel" action="cancel" class="pageButtonGeneric buttonColorWhite" type="button">',
				'<%=_T("Cancel")%>',
			'</button>',
		"{{ /hasCloseButton }}",
		'<button id="action_save" action="save" class="pageButtonGeneric buttonColorBlue" type="button">',
			'<%=_T("Confirm")%>',
		'</button>'
	),
	popup_row: "".concat(
		"<div form_row class='formRow' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
	),
	popup_control: "".concat(
		"<div id='container_{{ guid }}' ",
			"class='",
				"{{ #form_group }} form-group {{ /form_group }} {{ #controlContainerClass }} {{ controlContainerClass }} {{ /controlContainerClass }}",
				"{{ #formData }} formData {{ /formData }} {{ control_type }}Control ",
				// "{{ id }}FlowDesignerPopupFormData",
				// "{{ #extended }} formDataExt {{ /extended }}",
				// "{{ #inverse_order }}inverseOrder {{ /inverse_order }}",
				// "{{ #disclaimer }}formDataLong {{ /disclaimer }}",
				// // "{{ #without_label }}withoutLabel{{ /without_label }} ",
				"{{ #brackets }} withBrackets {{ /brackets }}",
				"{{ #variable }} withVariable {{ /variable }}",
				// "{{ #enabled_disabled }} withEnabledDisabled {{ /enabled_disabled }}",
				// "{{ #controlFieldClass }} {{ controlFieldClass }} {{ /controlFieldClass }}",
			"' title='{{ description }}' ",
			"{{ #hidden }}hidden hidden_control='true'{{ /hidden }}",
		">",
			"{{ #with_label }}",
				"<label control_label='{{ id }}' for='{{ guid }}' class='{{ #labelClass }}{{ labelClass }}{{ /labelClass }} {{ #required }}formLabel-rq{{ /required }}'>",
					"{{ name }}{{ #with_dots }}<%=_T(':')%>{{ /with_dots }}",
					"{{ #help_info }}",
						"<i class='fa fa-question-circle' title='{{ description }}'></i>",
					"{{ /help_info }}",
				"</label>",
			"{{ /with_label }}",
			"{{ #enabled_disabled }}",
                "<div class='formEnabledDisabledCheckboxContainer'>",
                    "<label control_label='to' for='{{id}}_enabled_disabled' class='{{ #required }}formLabel-rq{{ /required }} readonly'>{{ text }}:</label>",
                    "<div class='form-check formEnabledDisabledCheckbox'>",
                        "<label for='{{id}}' control_label='link' class='form-check-label form-check-label-title'>",
                            "<input control_enabled_disabled='true' id='{{id}}_enabled_disabled' control='{{ id }}_enabled_disabled' class='form-check-input' type='checkbox'>",
                        "</label>",
                    "</div>",
                "</div>",
			"{{ /enabled_disabled }}",
			"{{ #span }}",
				"<span {{ #spanClass }}class='{{ spanClass }}'{{ /spanClass }}>",
			"{{ /span }}",    
			"{{ #envolving_div }}",
				"<div id='{{ guid }}' {{ #envolving_div_persoTags }}{{ envolving_div_persoTags }}{{ /envolving_div_persoTags }} {{ #envolving_div_class }}class='{{ envolving_div_class }}'{{ /envolving_div_class }} {{ #envolving_div_hidden }}hidden{{ /envolving_div_hidden }}>",
			"{{ /envolving_div }}",	
			"{{ #envolving_label }}",
				"<label control_label='{{ id }}' for='{{ guid }}' class='{{ #envolving_label_class }}{{ envolving_label_class }}{{ /envolving_label_class }} {{ #required }}formLabel-rq{{ /required }}'>",
			"{{ /envolving_label }}",
			"{{ #label_aux }}",
				"<label control_label='{{ id }}' {{ #label_aux_class }}class='{{ label_aux_class }}'{{ /label_aux_class }}>",
					"{{ label_aux_content }}",
				"</label>",
			"{{ /label_aux }}",
					"{{{ control }}}",
            "{{ #variable }}",
                "<i variable_icon class='{{ #variableIconClass }}{{ variableIconClass }}{{ /variableIconClass }}' title='",
                "<%=_T('Enter a variable or an expression')%>", "' ></i>",
            "{{ /variable }}",
			"{{ #envolving_label }}",
					"{{ name }}",
					// "{{ #with_dots }}<%=_T(':')%>{{ /with_dots }}",
				"</label>",
			"{{ /envolving_label }}",
            "{{ #brackets }}",
                "<i brackets_icon class='formFieldBracketsIcon' title='",
                "<%=_T('You can use {{ }} to enter variables')%>", "' ></i>",
            "{{ /brackets }}",
			"{{ #span }}",
				"</span>",
			"{{ /span }}",
				"<i validation='{{ id }}' class='formFieldValidation formFieldError' hidden ></i>",
			"{{ #text_aux }}",
			"{{ #envolving_div }}",
				"</div>",
			"{{ /envolving_div }}",
				"<label class='formTextAux'>",
					"{{ text_aux }}",
				"</label>",
			"{{ /text_aux }}",
			"{{ #disclaimer }}",
				"<div disclaimer class='inlineMessagesContainer messageInfo'>",
					"{{ disclaimer }}",
				"</div>",
			"{{ /disclaimer }}",
		"</div>"
	),
	popup_control_text: "".concat(
		"<input id='{{ guid }}' control='{{ id }}' class='form-control' type='text' {{ #placeholder }}placeholder='{{ placeholder }}'{{ /placeholder }} {{ #maxLength }}maxlength='{{ maxLength }}'{{ /maxLength }} />" //formField
	),
	popup_control_password: "".concat(
		"<input id='{{ guid }}' control='{{ id }}' class='form-control formFieldPassword' type='password' autocomplete='new-password' {{ #placeholder }}placeholder='{{ placeholder }}'{{ /placeholder }} {{ #maxLength }}maxlength='{{ maxLength }}'{{ /maxLength }} />"//formField
	),
	popup_control_textarea: "".concat(
		"<textarea id='{{ guid }}' control='{{ id }}' class='formTextarea {{ #emojipicker }}emojipickerTextarea{{ /emojipicker }}' {{ #placeholder }}placeholder='{{ placeholder }}'{{ /placeholder }} {{ #maxLength }}maxlength='{{ maxLength }}'{{ /maxLength }} >",
		"</textarea>",
	),
	popup_control_textarea_flex: "".concat(
		"<textarea {{ persoTags }} id='{{ guid }}' control='{{ id }}' rows='10' class='form-control {{ #emojipicker }}emojipickerTextarea{{ /emojipicker }} {{ #bottom_button }}withBottomButton{{ /bottom_button }} {{ #variable }}withVariable{{ /variable }}' {{ #placeholder }}placeholder='{{ placeholder }}'{{ /placeholder }} {{ #maxLength }}maxlength='{{ maxLength }}'{{ /maxLength }} >",
		"</textarea>",
		// "<button id='autocompleteVaribale'  {{ #action }}action='{{ action }}'{{ /action }} {{ #class }}class='{{ class }}'{{ /class }} {{ #type }}type='{{ type }}'{{ /type }}>",
		// 	"Autocomplete",
		// "</button>"
    ),
	popup_control_check: "".concat(
		"<input id='{{ guid }}' control='{{ id }}' {{ #checkBoxClass }}class='{{ checkBoxClass }}'{{ /checkBoxClass }} type='checkbox' />"
	),
	popup_control_radiobutton: "".concat(
		"<input id='{{ guid }}' control='{{ id }}' name='{{ group }}' class='formRadioButton' type='radio' />"
	),
	popup_control_combo: "".concat(
		"<select id='{{ guid }}' control='{{ id }}' class='form-control'>", //formCombo
			"{{{ options_list }}}",
		"</select>"
	),
	popup_control_upload: "".concat(
		"<div class='d-flex align-items-end'>",
		"<input id='{{ guid }}' control='{{ id }}' upload_control class='form-control formFieldUpload' type='text' readonly />",
		"<button upload_button='{{ id }}' class='pageButtonGeneric buttonColorWhite'>",
			// "<i class='far fa-upload mr-2'></i>",
			"<input upload_input='{{ id }}' type='file' hidden='' accept='{{ types }}'>",
			"<%=_T('Upload')%>",
		"</button></div>",
		"<label upload_percentage='{{ id }}' class='uploadFilePercentage' hidden >100%</label>"
	),
	popup_control_upload_geo: "".concat( 
		"<input id='{{ guid }}' control='{{ id }}' upload_control class='formField formFieldUpload' type='text' readonly hidden/>",
		"<div upload_button='{{ id }}' class='pageButtonGeneric buttonColorWhite butFormUploadFile'>",
			"<%=_T('Upload')%>",
			"<input upload_input='{{ id }}' type='file' hidden='' accept='{{ types }}'>",
		"</div>",
		"<label upload_percentage='{{ id }}' class='uploadFilePercentage' hidden >100%</label>"
	),
	popup_control_check_item: "".concat( 
		"<div class='flowDesignerCheckListItem' title='{{ description }}'>",
			"<div class='form-check'>",
				"<label for='{{ guid }}' class='form-check-label form-check-label-title'>",
					"<input checkbox_item id='{{ guid }}' control='{{ id }}' class='form-check-input' type='checkbox' />",
					"{{ name }}",
				"</label>",
			"</div>",
			"<i validation='{{ id }}' class='formFieldValidation formFieldError' hidden ></i>",
		"</div>"
	),
	popup_control_check_item_flex: "".concat( 
		"<div class='flowDesignerCheckListItem' title='{{ description }}'>",
			"<input id='{{ guid }}' control='{{ id }}' class='formCheckbox' type='checkbox' />",
			"<label for='{{ guid }}' class='formLabel'>",
				"{{ name }}",
			"</label>",
			"<i validation='{{ id }}' class='formFieldValidation formFieldError' hidden ></i>",
		"</div>"
	),
	popup_control_checklist: "".concat( 
		"<div class='card no-card'>",
			"<div class='card-block'>",
				"<div class='row'>",
					"<div class='col-12'>",
						"<h5><%=_T('{{ subtitle }}')%></h5>",
						"<div control='{{ id }}' checklist class='flowDesignerCheckList form-group mb-0 mt-0'>",
							"{{ #selectAll }}",
							"<div class='flowDesignerCheckListItem' title='{{ description }}'>",
								"<div class='form-check'>",
									"<label for='{{ guid }}' class='form-check-label form-check-label-title'>",
										"<input select_all name='select_all' id='{{ guid }}' class='form-check-input' type='checkbox' />",
										// "{{ name }}",
										"<strong><%=_T('Select all')%></strong>",
									"</label>",
								"</div>	",
								"<i validation='{{ id }}' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
							"{{ /selectAll }}",
						"</div>",
					"</div>",
				"</div>",
			"</div>",	
		"</div>"
	),
	popup_control_radiobutton_item: "".concat(
		"<div class='form-radiobutton'>",
			"<label for='{{ id }}' class='form-radiobutton-label'>",
				"<input type='radio' control='{{ id }}' name='{{ group }}' value='hold' id='{{ id }}' class='form-radiobutton-input'>",
				"<span>{{ name }}</span>",
			"</label>",
		"</div>"
	),						

	popup_control_radiobuttonlist: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group d-flex flex-wrap' control='{{ id }}' radiobuttonlist>", //control="writing" missing?
				"</div>",
			"</div>",
		"</div>",

	),

	//conditions
	conditions_container: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='formDragListContainer flowDesignerOutputRulesDragListContainer'>",
					"<label><%=_T('Result')%>:</label>",
					"<ul conditions class='flowDesignerOutputRulesList formList ui-sortable'>",
					"</ul>",
				"</div>",
			"</div>",
		"</div>",
	),
	condition: "".concat( 
		"<li condition class='d-flex align-items-center'>",
			"<div class='form-group mb-0 d-flex flex-grow-1'>",
				"<div drag class='flowDesignerConditionDrag'>",
					"<i class='fas fa-grip-vertical'></i>",
				"</div>",
				"<select logic class='form-control'>",
					"<option value=''></option>",
					"<option value='and'>and</option>",
					"<option value='or'>or</option>",
				"</select>",
				"<select begin_parenths class='form-control'>",
					"<option value=''></option>",
					"<option value='('>(</option>",
					"<option value='(('>((</option>",
					"<option value='((('>(((</option>",
					"<option value='(((('>((((</option>",
				"</select>",
				"<input field flow_designer_variable_input placeholder='<%=_T('Create or select variable')%>' class='form-control flex-grow-1'>",
				"<select comparator class='form-control'>",
					"<option value=''></option>",
					"<option value='&#61;&#61;'>&#61;&#61;</option>",
					"<option value='&#126;&#61;'>&#126;&#61;</option>",
					"<option value='&#60;'>&#60;</option>",
					"<option value='&#62;'>&#62;</option>",
					"<option value='&#60;&#61;'>&#60;&#61;</option>",
					"<option value='&#62;&#61;'>&#62;&#61;</option>",
				"</select>",
				"<input field_value flow_designer_variable_input placeholder='<%=_T('Variable/Value')%>' class='form-control flex-grow-1'>",
				"<select end_parenths class='form-control'>",
					"<option value=''></option>",
					"<option value=')'>)</option>",
					"<option value='))'>))</option>",
					"<option value=')))'>)))</option>",
					"<option value='))))'>))))</option>",
				"</select>",
				"<button add class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Add')%>'>",
					"<i class='far fa-plus'></i>",
				"</button>",
				"<button remove class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Delete')%>'>",
					"<i class='far fa-trash-alt'></i>",
				"</button>",
			"</div>",
		"</li>"
	),
	
	//variables
	variables_container: "".concat(
		"<div class='card no-card sticky-top'>",
			"<div class='card-block'>",
				"<div class='card-header'>",
					"<h5><%=_T('Variables')%></h5>",
					"<button add class='btn buttonIconAndText'><span class='far fa-plus'></span><%=_T('Add variable')%></button>",
				"</div>",
			"</div>",
		"</div>",
		"<div class='card no-card'>",
			"<div class='card-block'>",
				"<div class='row'>",
					"<div class='col-12'>",
						"<div class='formDragListContainer flowDesignerVariablesContainer'>",
							"<ul variables class='flowDesignerVariablesList formList ui-sortable'>",
							"</ul>",
						"</div>",
					"</div>",
				"</div>",	
			"</div>",
		"</div>"
	),
	variable: "".concat( 
		"<li variable class='flowDesignerVariable d-flex align-items-start'>",
			//"<i validation class='formFieldValidation formFieldError' hidden=''></i>",
			"<div class='form-group mb-0'>",
				"<div drag class='flowDesignerVariableDrag' title='<%=_T('Sort')%>'>",
					"<i class='fas fa-grip-vertical'></i>",
				"</div>",
			"</div>",
			"<div class='flowDesignerVariableFormContainer'>",
				"<div class='d-flex flex-row'>",
					"<div class='form-group flex-grow-1 w-100'>",
							"<input name type='text' class='form-control flowDesignerVariableNameField'>",
							"<i variable_name class='formFieldValidation formFieldError' hidden></i>",
					"</div>",
					"<div class='form-group flex-grow-1 w-100'>",
						"<select value_type class='form-control flowDesignerVariableTypeField'>",
							"{{{ options }}}",
						"</select>",
					"</div>",
					"<div class='form-group flex-grow-1 mr-0'>",
						"<button remove id='flow_designer_output_rule_delete_1' class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Delete')%>'>",
							"<i class='far fa-trash-alt'></i>",
						"</button>",
					"</div>",
				"</div>",

				"<div value_container class='flowDesignerVariableValueContainer'>",
				"</div>",
			"</div> ",
		"</li>"
	),
	variable_expression: "".concat(
		"<div class='form-group flex-grow-1 mr-0'>",
			"<span class='ic_variable_icon_container'>",
				"<i variable_icon class='ic_variable_icon far fa-at' title='Ingresar una variable o una expresión'></i>",
				"<textarea expression_value flow_designer_textarea_variable class='form-control' title='<%=_T('Enter a variable or an expression')%>'></textarea>",
				"<i expression_value_validation class='formFieldValidation formFieldError' hidden></i>",
			"</span>",
		"</div>",
	),

	variable_object: "".concat(
		"<ul object class='flowDesignerVariableSubList formList ui-sortable'>",
		"</ul>",
	),
	
	variable_object_entry: "".concat( 
		"<li object_entry class='flowDesignerVariableSublistEntry d-flex align-items-start'>",
			"<div drag class='flowDesignerVariableDrag' title='<%=_T('Sort')%>'>",
				"<i class='fas fa-grip-vertical'></i>",
			"</div>",
			"<div class='flowDesignerVariableSubListFormContainer'>",
				"<div class='form-group flex-grow-1 mr-0'>",
					"<input entry_name type='text' class='form-control flowDesignerVariableObjectEntryKeyField'>",
					"<i entry_name_validation class='formFieldValidation formFieldError' hidden></i>",
				"</div>",
				"<div class='form-group flex-grow-1 mr-0'>",
					"<span class='ic_variable_icon_container'>",
						"<i variable_icon class='ic_variable_icon far fa-at' title='Ingresar una variable o una expresión'></i>",
						"<textarea entry_value flow_designer_textarea_variable class='form-control' title='<%=_T('Enter a variable or an expression')%>'></textarea>",
						"<i entry_validation class='formFieldValidation formFieldError' hidden></i>",
					"</span>",
				"</div>",
			"</div>",
			"<div class='form-group flowDesignerVariableSubListButtonsContainer'>",
				"<button entry_add class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Add')%>'>",
					"<i class='far fa-plus'></i>",
				"</button>",
				"<button entry_remove class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Delete')%>'>",
					"<i class='far fa-trash-alt'></i>",
				"</button>",
			"</div>",
		"</li>"		
	),
	variable_array: "".concat(
		"<ul array class='flowDesignerVariableSubList formList ui-sortable'>",
		"</ul>"
	),
	variable_array_entry: "".concat( 
		"<li array_entry class='flowDesignerVariableSublistEntry d-flex align-items-start'>",
			"<div drag class='flowDesignerVariableDrag' title='<%=_T('Sort')%>'>",
				"<i class='fas fa-grip-vertical'></i>",
			"</div>",
			"<div class='flowDesignerVariableSubListFormContainer'>",
				"<div class='form-group flex-grow-1 mr-0'>",
					"<textarea entry_value class='form-control flowDesignerVariableArrayEntryValueField' title='Valor.'></textarea>",
					"<i entry_validation class='formFieldValidation formFieldError' hidden></i>",
				"</div>",
			"</div>",
			"<div class='form-group flowDesignerVariableSubListButtonsContainer'>",
				"<button entry_add class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Add')%>'>",
					"<i class='far fa-plus'></i>",
				"</button>",
				"<button entry_remove class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Delete')%>'>",
					"<i class='far fa-trash-alt'></i>",
				"</button>",
			"</div>",
		"</li>",
	),

	// CONFIGURADOR DE VARIABLES
	variable_config_markup: "".concat(
        "<div class='card no-card sticky-top'>",
            "<div class='card-block'>",
                "<div class='card-header d-flex justify-content-between'>",
                    "<h5><%=_T('Configure variables')%></h5>",
                    "<button add_new_output class='btn buttonIconAndText'><span class='far fa-plus'></span><%=_T('Add output')%></button>",
                "</div>",
                "<div class='row'>",
                    "<div class='col-12'>",
                        "<p class='flowDesignerFormSubtitles'><%=_T('The evaluation of port conditions are sequential.')%></p>",
                    "</div>",
                "</div>",
                "<div class='row'>",
                    "<div class='col-12'>",
                        "<ul id='condition_links' condition_links class='list-unstyled list-inline flowDesignerChipsList'>",
                            "<li condition_link id='default_output' class='list-inline-item flowDesignerContentChip disabled'>Default</li>",
                        "</ul>",
                    "</div>",
                "</div>",
            "</div>",
        "</div>",
        "<div card class='card no-card '>",
            "<div div_variables class='card-block'>",
            "</div>",
        "</div>",
	),

	variable_output: "".concat(
		"<div output output_{{condition_id}} id={{condition_id}} class='row'>",
			"<div class='col-12 inputConditionNameContainer' output_id id={{condition_id}}>",
				"<div class='form-group d-flex flex-row'>",
					"<input output_name id='flow_designer_add_output_name_{{condition_id}}' class='form-control mt-0' type='text' placeholder='* <%=_T('Enter the output port name')%>' />",
					"<button output_remove id='{{condition_id}}' flow_designer_delete_output_{{condition_id}} class='pageButtonGeneric buttonColorWhite align-self-end ml-2' title='<%=_T('Delete Output')%>'>",
						"<%=_T('Delete Output')%>",
					"</button>",
				"</div>",
			"</div>", 
			"<div class='col-12'>",
				"<div id='condition_list_{{condition_id}}' class='formDragListContainer flowDesignerOutputRulesDragListContainer'>",
					"<ul condition_list id='flowDesignerRules' class='flowDesignerOutputRulesList formList ui-sortable'>",
					"</ul>",
				"</div>",
			"</div>",
		"</div>",
	),

	variable_condition: "".concat(
		"<li condition id={{conditionId}} class='d-flex align-items-center'>",	
			"<div class='form-group mb-0'>",
				// "<button sort_button class='pageButtonGeneric buttonColorWhite iconOnlyBtn mr-2' title='<%=_T('Sort')%>'>",
				// 	"<i class='fas fa-grip-vertical'></i>",
				// "</button>",
				"<div drag class='flowDesignerConditionDrag'>",
					"<i class='fas fa-grip-vertical'></i>",
				"</div>",
			"</div>",
			"<div condition_output id={{conditionId}} class='form-group mb-0 d-flex flex-grow-1 flex-wrap'>",
				"<select logic id='flow_designer_output_rule_parameter' class='form-control'>",
					"<option value=''></option>",
					"<option value='and'>and</option>",
					"<option value='or'>or</option>",
				"</select>",
				"<select begin_parenths id='flow_designer_output_rule_parenthesis_open' class='form-control'>",
					"<option value=''></option>",
					"<option value='('>(</option>",
					"<option value='(('>((</option>",
					"<option value='((('>(((</option>",
					"<option value='(((('>((((</option>",
				"</select>",
				"<input field_name flow_designer_variable_input id='flow_designer_output_rule_create_variable' placeholder='<%=_T('Create or select variable')%>' class='form-control flex-grow-1'>",
				"<select comparator id='flow_designer_output_rule_operator' class='form-control'>",
					"<option value=''></option>",
					"<option value='&#61;&#61;'>&#61;&#61;</option>",
					"<option value='&#126;&#61;'>&#126;&#61;</option>",
					"<option value='&#60;'>&#60;</option>",
					"<option value='&#62;'>&#62;</option>",
					"<option value='&#60;&#61;'>&#60;&#61;</option>",
					"<option value='&#62;&#61;'>&#62;&#61;</option>",
				"</select>",
				"<input field_value flow_designer_variable_input id='flow_designer_output_rule_variable_value' placeholder='<%=_T('Variable/Value')%>' class='form-control flex-grow-1'>",
				"<select end_parenths id='flow_designer_output_rule_parenthesis_close' class='form-control'>",
					"<option value=''></option>",
					"<option value=')'>)</option>",
					"<option value='))'>))</option>",
					"<option value=')))'>)))</option>",
					"<option value='))))'>))))</option>",
				"</select>",			
				"<button add id='flow_designer_output_rule_add' class='pageButtonGeneric buttonColorWhite iconOnlyBtn ' title='<%=_T('Add')%>'>",
					"<i class='far fa-plus'></i>",
				"</button>",
				"<button remove id='flow_designer_output_rule_delete' class='pageButtonGeneric buttonColorWhite iconOnlyBtn ' title='<%=_T('Delete')%>'>",
					"<i class='far fa-trash-alt'></i>",
				"</button>",
			"</div>",
		"</li>",
	),

	// FORMULARIOS TEST BOT

	add_variable_markup: "".concat(
		"<div add_variables_message_container id='flowDesignerAddVariablesMessageContainer' class='card card-block flowDesignerCardModal' style='z-index: 12;'>",
			"<div class='card-header pb-0'>",
				"<h5><%=_T('Variables')%></h5>",
				"<button cancel_test class='flowDesignerTraceButton flowDesignerButtonIcon buttonColorGray flowDesignerTraceMinimize'>",
					"<i class='far fa-times'></i>",
				"</button>",
			"</div>",
			"<div class='card-body'>",
				"<p><%=_T('If you want to ask for data before starting the chat, we recommend to create a new form to customize the bot response.')%>",
				"<br><%=_T('By example: ask for name, e-mail, etc.')%></p>",
				"<p><strong><%=_T('Do you want to add a variable?')%></strong></p>",
				"<div class='form-group mb-0'>",
					"<div class='form-check'>",
						"<label for='flow_designer_variables_not_show' class='form-check-label form-check-label-title'>",
							"<input id='flow_designer_variables_not_show' class='form-check-input' type='checkbox'>",
							"<%=_T('Do not show this message again')%>",
						"</label>",
					"</div>",
				"</div>",
			"</div>",
			"<div class='card-footer'>",
				"<button add_variable class='pageButtonGeneric buttonColorWhite'>",
					"<%=_T('Add variable')%>",
				"</button>",
				"<button no_start_test id='flowDesignerNoStartTest' class='pageButtonGeneric buttonColorBlue'>",
					"<%=_T('No, Start Test')%>",
				"</button>",
			"</div>",
		"</div>"
	),

	add_variable_form: "".concat(
		"<div create_variables_form id='create_variables_form' class='card card-block flowDesignerCardModal flowDesignerFormModal' style='z-index: 12;'>",
			"<div class='card-header'>", 
				"<h5><%=_T('Create Variables')%></h5>", 
				"<button add_new_variable class='btn buttonIconAndText align-self-start'>",
					"<span class='far fa-plus'>",
					"</span>",
					"<%=_T('Add variable')%>",
				"</button>",
			"</div>",
	
			"<div add_variable_cards class='card-body'>",
			"</div>",

			"<div class='card-footer'>",
				"<button cancel_variable class='pageButtonGeneric buttonColorWhite'>",
					"<%=_T('Cancel')%>",
				"</button>",
				"<button save_variable class='pageButtonGeneric buttonColorBlue'>",
					"<%=_T('Save')%>",
				"</button>",
			"</div>",
		"</div>"
	),

	new_variable_card: "".concat(
		"<div id='variable_card_{{count}}'>",
			"<div class='row'>",
				"<div class='col-12 d-flex flex-row'>",
					"<div class='form-group flex-grow-1'>",
						"<label for='flow_designer_test_var_type_{{count}}' class='required'><%=_T('Variable type')%><%=_T(':')%></label>",
						"<select select_variable_type_{{count}} varialbeNumber='{{count}}' id='flow_designer_test_var_type_{{count}}' class='form-control'>",
						"</select>",
						"<i id='flow_designer_test_var_type_{{count}}_validation' class='formFieldValidation formFieldError' hidden></i>",
					"</div>",
					"<div class='form-group d-flex align-items-end'>",
						"<button id='flow_designer_test_delete_var_{{count}}' class='pageButtonGeneric buttonColorWhite iconOnlyBtn' title='<%=_T('Delete')%>' >",
							"<i class='far fa-trash-alt'></i>",
						"</button>",
					"</div>",
				"</div>",
			"</div>",

			"<div id='flow_designer_test_row_var_custom_name_{{count}}' class='row' style='display: none;'>",
				"<div class='col-12'>",
					"<div class='form-group'>",
						"<label for='flow_designer_test_var_custom_name_{{count}}' class='required'><%=_T('Variable name')%><%=_T(':')%></label>",
						"<input id='flow_designer_test_var_custom_name_{{count}}' class='form-control' type='text' placeholder='<%=_T('Enter the name')%>...' />",
						"<i id='flow_designer_test_var_custom_name_{{count}}_validation' class='formFieldValidation formFieldError' hidden></i>",
					"</div>",
				"</div>",
			"</div>",

			"<div class='row'>",
				"<div class='col-12'>",
					"<div class='form-group'>",
						"<label for='flow_designer_test_var_custom_value_{{count}}' class='required'><%=_T('Value')%><%=_T(':')%></label>",
						"<input id='flow_designer_test_var_custom_value_{{count}}' class='form-control' type='text' placeholder='<%=_T('Enter the value')%>...' />",
						"<i id='flow_designer_test_var_custom_value_{{count}}_validation' class='formFieldValidation formFieldError' hidden></i>",
					"</div>",
				"</div>",
			"</div>",
			"<hr />",
		"</div>",	
	),

	add_variable_start_test: "".concat(
		"<div test_variables_form class='card card-block flowDesignerCardModal flowDesignerFormModal' style='z-index: 12;'>",
			"<div class='card-header'>", 
				"<h5><%=_T('Variables')%></h5>", 
				"<button edit_variables class='btn buttonIconAndText'>",
					"<%=_T('Edit Variables')%>",
				"</button>",
			"</div>",
			"<div class='card-body'>",
				// Variable - 1
				"<div class='row'>",
					"<div class='col-12'>",
						"<div class='form-group'>",
							"<label for='flow_designer_test_var_value_1' class='required'>Nombre<%=_T(':')%></label>",
							"<input disabled id='flow_designer_test_var_value_1' class='form-control' type='text' placeholder='<%=_T('Enter the value')%>...' value='Mauricio'/>",
						"</div>",
					"</div>",
				"</div>",
				// Variable - 2
				"<div class='row'>",
					"<div class='col-12'>",
						"<div class='form-group'>",
							"<label for='flow_designer_test_var_value_2' class='required'>Número de Cliente<%=_T(':')%></label>",
							"<input disabled id='flow_designer_test_var_value_2' class='form-control' type='text' placeholder='<%=_T('Enter the value')%>...' value='Mauricio'/>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",
			"<div class='card-footer'>",
				"<button test_start_variable id='flowDesignerTestStartVariable' class='pageButtonGeneric buttonColorOrange'>",
					"<%=_T('Test')%>",
				"</button>",
			"</div>",
		"</div>"
	),

	// FIN FORMULARIOS TEST BOT

	//reporting data
	
	report_fields: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group mb-0'>",
					"<label control_label='' for='{{ id }}'><%=_T('Fields')%><%=_T(':')%></label>",
				"</div>",
			"</div>",
			"<div class='col-12'>",
				"<ul fields class='flowDesignerReportFieldsList formList'>",
				"</ul>",
			"</div>",
			"<div class='col-12'>",
				"<p class='flowDesignerFormCaption'><%=_T('Fields just for reporting do not require an application')%></p>",
			"</div>",
		"</div>",
	),
	report_field: "".concat(
		"<li field class='flowDesignerReportField'>",
			"<div class='flowDesignerReportFieldName'>",
				"<label class='flowDesignerReportFieldNameLabel'>",
					"<%=_T('Name')%>:",
				"</label>",
				"<input field_name type='text' class='formField flowDesignerReportFieldNameControl'>",
			"</div>",
			"<div class='flowDesignerReportFieldValue'>",
				"<label class='flowDesignerReportFieldValueLabel'>",
					"<%=_T('Value')%>:",
				"</label>",
				"<input field_value type='text' class='formField flowDesignerReportFieldValueControl'>",
				"<i variable_icon class='formFieldVariableIcon' title='",
					"<%=_T('Enter a variable or an expression')%>", "' ></i>",
			"</div>",
			"{{ #hidden }}",
				"<div class='flowDesignerReportFieldHidden', title='",
					"<%=_T('Hidden in agent context view')%>",
				"'>",
					"<input id='{{ guid }}_field_hidden' class='formCheckbox flowDesignerReportFieldHiddenControl' type='checkbox' field_hidden >",
					"<label for='{{ guid }}_field_hidden' class='flowDesignerReportFieldHiddenLabel'>",
						"<%=_T('Hidden')%>",
					"</label>",
				"</div>",
			"{{ /hidden }}",
			'<button remove class="flowDesignerReportFieldRemove buttonColorLightblue">',
				'-',
			'</button>',
			'<button add class="flowDesignerReportFieldAdd buttonColorLightblue">',
				'+',
			'</button>',
			"<i validation class='formFieldValidation formFieldError' hidden ></i>",
		"</li>"
	),
	//qna maker - metadata
	// qna_maker_metadata: "".concat(
	// 	"<div class='formRow flowDesignerQnAMetadataFieldsContainer'>",
	// 		"<label class='formLabel flowDesignerQnAMetadatatFieldsTitle'>",
	// 			"<%=_T('Metadata Filter')%><%=_T(':')%>",
	// 		"</label>",
	// 		"<ul fields class='flowDesignerQnAMetadataFieldsList'></ul>",
	// 		"<div class='' title='<%=_T([[Strict Filter Operation with OR (checked), or with AND (unchecked).]])%>'>",
	// 			"<div class='formData formDataExt'>",
	// 				"<label for='adm_flow_qna_maker_metadata_operation_type' class='formLabel'>",
	// 					"<%=_T('Filter With OR')%>", "<%=_T(':')%>",
	// 				"</label>",
	// 				"<input id='adm_flow_qna_maker_metadata_operation_type' class='formCheckbox' type='checkbox' />",
	// 			"</div>",
	// 		"</div>",
	// 	"</div>"
	// ),
	qna_maker_metadata: "".concat(
		"<div class='row'>",
            "<div class='col-12'>",
				"<div class='form-group mb-0'>",	
					"<label>",
						"<%=_T('Metadata Filter')%><%=_T(':')%>",
					"</label>",
				"</div>",
				"<div class='flowDesignerQnAMetadataFieldsContainer'>",
					"<ul fields class='flowDesignerQnAMetadataFieldsList formList'></ul>",
				"</div>",
			"</div>",
		"</div>",

		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group'>",
					"<div class='form-check'>",			
						"<label for='adm_flow_qna_maker_metadata_operation_type' class='form-check-label form-check-label-title'>",
							"<input id='adm_flow_qna_maker_metadata_operation_type' class='form-check-input' type='checkbox' />",
							"<%=_T('Filter With OR')%>",
						"</label>",
					"</div>",
				"</div>",
			"</div>",
		"</div>"
	),
	// qna_maker_metadata_filter_field: "".concat( 
	// 	"<li field class='flowDesignerQnAMetadataField'>",
	// 		"<div class='flowDesignerQnAMetadataFieldName'>",
	// 			"<label class='flowDesignerQnAMetadataFieldNameLabel'><%=_T([[Name]])%><%=_T([[:]])%></label>",
	// 			"<input field_name type='text' class='form-control flowDesignerReportFieldNameControl'>",
	// 		"</div>",
	// 		"<div class='flowDesignerQnAMetadataFieldValue'>",
	// 			"<label class='flowDesignerQnAMetadataFieldValueLabel'><%=_T([[Value]])%><%=_T([[:]])%></label>",
	// 			"<input field_value type='text' class='form-control flowDesignerQnAMetadataFieldValueControl'>",
	// 			"<i variable_icon class='formFieldVariableIcon' title='<%=_T([[Enter a variable or an expression]])%>'></i>",
	// 		"</div>",
	// 		'<button add class="flowDesignerQnAMetadataFieldAdd buttonColorLightblue">+</button>',
	// 		'<button remove class="flowDesignerQnAMetadataFieldRemove buttonColorLightblue">-</button>',
	// 		"<i validation class='formFieldValidation formFieldError' hidden ></i>",
	// 	"</li>"
	// ),
	qna_maker_metadata_filter_field: "".concat( 
		"<li field class='flowDesignerQnAMetadataFieldNew d-flex align-items-center'>",
			"<div class='form-group mb-0 flex-grow-1'>",
				"<label><%=_T([[Name]])%><%=_T([[:]])%></label>",
				"<input field_name type='text' class='form-control' placeholder='<%=_T('Enter name')%>...'>",
			"</div>",
			"<div class='form-group mb-0 flex-grow-1'>",
				"<label><%=_T([[Value]])%><%=_T([[:]])%></label>",
				"<input field_value type='text' class='form-control flowDesignerQnAMetadataFieldValueControl' placeholder='<%=_T('Enter value')%>...'>",
			"</div>",
			"<div class='form-group mb-0 mr-0 d-flex'>",
				"<button add class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end flow_designer_icon_btn' title='<%=_T('Add')%>'>",
					"<i class='far fa-plus'></i>",
				"</button>",
				"<button remove class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end flow_designer_icon_btn' title='<%=_T('Delete')%>'>",
					"<i class='far fa-trash-alt'></i>",
				"</button>",
			"</div>",
			"<i validation class='formFieldValidation formFieldError' hidden style='display:none'></i>",
		"</li>"
	),
	code_block_tabs: "".concat(
		'<ul class="nav nav-tabs" id="tabs-codeBlock" role="tablist">',
            '<li class="nav-item">',
                '<a class="nav-link active" id="codeBlock-tab" data-toggle="tab" href="#codeBlock" role="tab" aria-controls="codeBlock" aria-selected="true"><%=_T("Edit code block")%></a>',
            '</li>',
            '<li class="nav-item">',
                '<a class="nav-link" id="transitions-tab" data-toggle="tab" href="#transitions" role="tab" aria-controls="transitions" aria-selected="false"><%=_T("Edit transitions")%></a>',
            '</li>',				   
        '</ul>',

        '<div class="tab-content" id="tabContent-codeBlock">',
            '<div class="tab-pane code-pane fade show active" id="codeBlock" role="tabpanel" aria-labelledby="codeBlock-tab"></div>',
            '<div class="tab-pane fade" id="transitions" role="tabpanel" aria-labelledby="transitions-tab"></div>',						
        '</div>'		  
	),
	code_block_content: "".concat(
        "<div class='card no-card'>",
            "<div class='card-block d-flex'>",
                "<div content class='ic-modal-main-content flex-grow-1 collapsed'>",
                "</div>",
            "</div>",
        "</div>"
    ),
    code_block: "".concat(
        // "<div class='row'>",
        //     "<div class='col-12'>",
                "<div class='flowDesignerCodeBlockContainer'>",
                    "<div code_block class='flowDesignerCodeBlock'>",
                    "</div>",
                "</div>",
        //     "</div>",
        // "</div>",
    ),
	code_block_transitions: "".concat(
        "<div class='card no-card'>",
            "<div class='card-block'>",
                "<div class='card-header d-flex justify-content-between'>",
                    "<h5><%=_T('Output ports')%></h5>",
                    "<button add_new_output class='btn buttonIconAndText'><span class='far fa-plus'></span><%=_T('Add output')%></button>",
                "</div>",
                "<div class='row'>",
                    "<div class='col-12'>",
                        "<p class='flowDesignerFormSubtitles'><%=_T('The evaluation of port conditions are sequential.')%></p>",
                    "</div>",
                "</div>",
                "<div class='row'>",
                    "<div class='col-12'>",
                        "<ul id='condition_links' condition_links class='list-unstyled list-inline flowDesignerChipsList'>",
                            "<li condition_link id='default_output' class='list-inline-item flowDesignerContentChip disabled'>Default</li>",
                        "</ul>",
                    "</div>",
                "</div>",
            "</div>",
        "</div>",
        "<div card class='card no-card scrollable-card'>",
            "<div div_variables class='card-block'>",
            "</div>",
        "</div>"
	),
    code_block_transition_output: "".concat(
        '<div output activity_output_{{id}} id={{id}} class="row flowDesignerOutputContainer">',
            '<div class="col-12 flowDesignerOutputDescription" output_id id={{id}}>',
                '<div class="form-group d-flex flex-row">',
                    '<input output_name id="flow_designer_add_output_name_{{id}}" class="form-control mt-0" type="text" placeholder="<%=_T("Enter the output port name")%>" />',
                    '<button output_remove id="{{id}}" flow_designer_delete_output_{{id}} class="pageButtonGeneric buttonColorBlue align-self-end ml-3" title="<%=_T("Delete Output")%>">',
                        '<%=_T("Delete Output")%>',
                    '</button>',
                '</div>',
            '</div>',
            '<div class="col-12 flowDesignerOutputConditions">',
                '<div id="condition_list_{{id}}" class="formDragListContainer flowDesignerOutputRulesDragListContainer">',
                    '<ul condition_list id="flowDesignerRules" class="flowDesignerOutputRulesList formList ui-sortable">',                        
                    '</ul>',   
                '</div>',
            '</div>',
        '</div>',
	),
    code_block_transition_output_condition: "".concat(
        '<li condition id="{{id}}" class="d-flex align-items-center">',
            '<div class="form-group mb-0">',
                '<div drag class="flowDesignerConditionDrag">',
                    '<i class="fas fa-grip-vertical"></i>',
                '</div>',
            '</div>',
            '<div condition_output id={{id}} class="form-group mb-0 d-flex flex-grow-1 flex-wrap">',
                '<select logic id="flow_designer_output_rule_parameter" class="form-control">',
                    '<option value=""></option>',
                    '<option value="and"><%=_T("and")%></option>',
                    '<option value="or"><%=_T("or")%></option>',
                '</select>',
                '<select begin_parenths id="flow_designer_output_rule_parenthesis_open" class="form-control">',
                    "<option value=''></option>",
                    "<option value='('>(</option>",
                    "<option value='(('>((</option>",
                    "<option value='((('>(((</option>",
                    "<option value='(((('>((((</option>",
                '</select>',
                '<input field_name flow_designer_variable_input id="flow_designer_output_rule_create_variable" placeholder="<%=_T("Create or select variable")%>" class="form-control flex-grow-1">',
                '<select comparator id="flow_designer_output_rule_operator" class="form-control">',
                    "<option value=''></option>",
					"<option value='&#61;&#61;'>&#61;&#61;</option>",
					"<option value='&#126;&#61;'>&#126;&#61;</option>",
					"<option value='&#60;'>&#60;</option>",
					"<option value='&#62;'>&#62;</option>",
					"<option value='&#60;&#61;'>&#60;&#61;</option>",
					"<option value='&#62;&#61;'>&#62;&#61;</option>",
                '</select>',
                '<input field_value flow_designer_variable_input id="flow_designer_output_rule_variable_value" placeholder="<%=_T("Variable/Value")%>" class="form-control flex-grow-1">',
                '<select end_parenths id="flow_designer_output_rule_parenthesis_close" class="form-control">',
                    "<option value=''></option>",
					"<option value=')'>)</option>",
					"<option value='))'>))</option>",
					"<option value=')))'>)))</option>",
					"<option value='))))'>))))</option>",
                '</select>',
                '<button add id="flow_designer_output_rule_add" class="pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end ml-2" title="<%=_T("Add")%>">',
                    '<i class="far fa-plus"></i>',
                '</button>',
                '<button remove id="flow_designer_output_rule_delete" class="pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end ml-2" title="<%=_T("Delete")%>">',
                    '<i class="far fa-trash-alt"></i>',
                '</button>',
            '</div>',                                  
        '</li>',
	),
	classes_tree: "".concat(
        "<div tree_container class='ic-modal-collapsible-content collapsed'>",
            '<button tree_toggle class="btn flowDesignerTreeToggleBtn"><i class="fas fa-chevron-left"></i><%=_T("Classes")%></button>',
            "<div tree_title class='flowDesignerClassesTreeTitle'>",
                "<label class='flowDesignerClassesTreeTitleLabelNew'>",
                    "<%=_T('Classes')%>",
                "</label>",			        
            "</div>",
            "<ul tree class='flowDesignerClassesTreeNew'>",
            "</ul>",
        "</div>"
    ),
    classes_tree_class: "".concat(
        "<li tree_class='{{ id }}' class_selector='true' class='flowDesignerClassesTreeClassNew'>",
            "<div class_selector='true' class_selector_title class='flowDesignerClassesTreeClassTitleNew' title='{{ description }}'>",
                "<span view_class_name='{{ id }}'>{{ name }}</span>",
                "<button view_class='{{ id }}' class='flowDesignerClassesTreeClassViewButtonNew flowDesignerButtonIcon buttonColorTransparent' type='button'><i class='far fa-info-circle'></i></button>",
                "<button snippet_class='{{ id }}' class='flowDesignerClassesTreeClassSnippetButtonNew flowDesignerButtonIcon buttonColorTransparent' type='button'><i class='far fa-plus-circle'></i></button>",
                "<i class_selector='true' class='flowDesignerButtonIcon far fa-chevron-down'></i>",
            "</div>",
            "<label attributes_label class='flowDesignerClassesTreeAttributesTitleNew'>",
                "<%=_T('Attributes')%><%=_T(':')%>",
            "</label>",
            "<ul attributes_list class='flowDesignerClassesTreeAttributesListNew'></ul>",
            "<label class='flowDesignerClassesTreeMethodsTitleNew'>",
                "<%=_T('Methods')%><%=_T(':')%>",
            "</label>",
            "<ul methods_list class='flowDesignerClassesTreeMethodsListNew'></ul>",
        "</li>"
    ),
    classes_tree_attribute: "".concat(
        "<li class_id ='{{ class_id }}' tree_attribute='{{ id }}' class='flowDesignerClassesTreeAttributeNew' title='{{ description }}'>",
            //"<i class='flowDesignerClassesTreeAttributeIcon'></i>",
            "<span>{{ name }}</span>",
            '<button class_id ="{{ class_id }}" view_attribute="{{ id }}" class="flowDesignerClassesTreeAttributeViewButtonNew flowDesignerButtonIcon buttonColorTransparent" type="button">',
                "<i class='far fa-info-circle'></i>",
            '</button>',
            '<button class_id ="{{ class_id }}" snippet_attribute="{{ id }}" class="flowDesignerClassesTreeAttributeSnippetButtonNew flowDesignerButtonIcon buttonColorTransparent" type="button">',
                "<i class='far fa-plus-circle'></i>",
            '</button>',
        "</li>"
    ),
    classes_tree_method: "".concat(
        "<li class_id ='{{ class_id }}' tree_method='{{ id }}' class='flowDesignerClassesTreeMethodNew' title='{{ description }}'>",
                //"<i class='flowDesignerClassesTreeMethodIcon'></i>",
                "<span>{{ name }}</span>",
            '<button class_id ="{{ class_id }}" view_method="{{ id }}" class="flowDesignerClassesTreeMethodViewButtonNew flowDesignerButtonIcon buttonColorTransparent" type="button">',
                "<i class='far fa-info-circle'></i>",
            '</button>',
            '<button class_id ="{{ class_id }}" snippet_method="{{ id }}" class="flowDesignerClassesTreeMethodSnippetButtonNew flowDesignerButtonIcon buttonColorTransparent" type="button">',
                "<i class='far fa-plus-circle'></i>",
            '</button>',
        "</li>"
    ),
    classes_tree_view_description: "".concat(
        '<div class="row">',
            '<div class="col-12">',
                '<p><strong><%=_T("Description")%><%=_T(":")%></strong> {{ text }}</p>',
            '</div>',
        '</div>',
    ),
    classes_tree_view_examples: "".concat(
        '<div class="row">',
            '<div class="col-12">',
                '<p class="flowDesignerCodeBlockLabel"><%=_T("Examples")%></p>',
                '<div class="flowDesignerCodeBlockContainer">',
                    '<div code_block class="flowDesignerCodeBlock flowDesignerClassesTreeViewExamples ace_editor ace-tm">',
                    '</div>',
                '</div>',
            '</div>',
        '</div>'
    ),
    classes_tree_view_code: "".concat(
        '<div class="row">',
            '<div class="col-12">',
                '<p class="flowDesignerCodeBlockLabel"><%=_T("Code")%></p>',
                '<div class="flowDesignerCodeBlockContainer">',
                    '<div code_block class="flowDesignerCodeBlock flowDesignerClassesTreeViewCode ace_editor ace-tm">',
                    '</div>',
                '</div>',
            '</div>',
        '</div>',
    ),
    classes_tree_view_value: "".concat(
        '<div class="row">',
            '<div class="col-12">',
                '<p><strong><%=_T("Value")%><%=_T(":")%></strong> {{ text }}</p>',
            '</div>',
        '</div>',
    ),
	//trace
	trace: "".concat(
		"<div class='flowDesignerTraceTitle'>",
			"<div class='flowDesignerTraceInteractionsAux'>",
				"<label class='flowDesignerTraceTitleLabel'>",
				 	"<%=_T('Select Conversation')%>",
				"</label>",
				"<select trace_interactions id='flowDesignerTraceInteractions' class='form-control flowDesignerTraceInteractions' title='", "<%=_T('Conversation')%>", "'>",
				"</select>",
			"</div>",
			"<div class='d-flex flex-row align-items-center'>",
				"<label class='flowDesignerTraceTitleLabel'>",
					"<%=_T('Filter Results By:')%>",
				"</label>",
				"<select trace_loglevel id='flowDesignerTraceLogLevel' class='form-control flowDesignerTraceLogLevel' title='", "<%=_T('Log level')%>", "'>",
				"</select>",
				"<select trace_states id='flowDesignerTraceStates' class='form-control' title='", "<%=_T('State')%>", "'>",
				"</select>",
					"<input trace_text id='flowDesignerTraceText' type='text' class='form-control flowDesignerTraceFindText' title='", "<%=_T('Filter by text')%>", "'>",
				"</select>",
				"<div class='flowDesignerTraceActionsAux'>",
					"<button trace_refresh id='flowDesignerTraceRefresh' class='flowDesignerTraceButton flowDesignerButtonIcon buttonColorGray flowDesignerTraceRefresh'>",
						// "REFRESH_ICON", // se borra, solo va tooltip
						"<i class='far fa-sync'></i>",
					"</button>",
					"<button trace_download id='flowDesignerTraceDownload' class='flowDesignerTraceButton flowDesignerButtonIcon buttonColorGray flowDesignerTraceDownload' >",
						// "DOWNLOAD_ICON", // se borra, solo va tooltip
						"<i class='far fa-arrow-to-bottom'></i>",
					"</button>",
					"<button trace_minimize id='flowDesignerTraceMinimize' class='flowDesignerTraceButton flowDesignerButtonIcon buttonColorGray flowDesignerTraceMinimize' >",
						"<i class='far fa-times'></i>",
						// "MINIMIZE_ICON", // se borra, solo va tooltip
					"</button>",
				"</div>",
			"</div>",
		"</div>",
		"<div trace_list class='flowDesignerTraceList'></div>",
		"<div trace_loading class='flowDesignerTraceLoading' style='display:none'></div>"
	),
	trace_item: "".concat(
		"<div trace_item='{{ index }}' trace_level='{{ level }}' trace_state='{{ state }}' class='flowDesignerTraceItem {{ className }}'>",
			"<label date_part class='flowDesignerTraceItemDate' title='{{ date }}'>",
				"{{ date }}",
			"</label>",
			"<label state_part class='flowDesignerTraceItemState' title='{{ state }}'>",
				"{{ state }}",
			"</label>",
			"<label text_part class='flowDesignerTraceItemText' title='{{ text }}'>",
				"{{ text }}",
			"</label>",
		"</div>"
	),
	/*messages_container: "".concat(
        //"<div class='row'>" + 
        //    "<div class='col-12'>" + 
                "<div messages_container class='flowDesignerMessagesMessageContainer'>",
                    "<div class='formFieldset'>",
                        "<div class='formRow'>",
                            "<div class='formData formDataExt'>",
                                //"<label class='formLabel formLabel-rq' title='{{ description }}'>",
                                //	"{{ name }}:",
                                //"</label>",
                                "<div messages_types class='flowDesignerMessageTypeCheckList'>",
                                "</div>",
                            "</div>",
                        "</div>",
                        "<div messages_data class='flowDesignerMessagesDataContainer'>",
                            "<div empty_row='true' class='formRow'>",
                                "<div class='formData formDataExt'></div>",
                            "</div>",
                        "</div>",
                    "</div>",
                "</div>" ,
            //"</div>",
        //"</div>"
	),*/
	messages_type: "".concat(
		"<div message_type_container class='flowDesignerMessageTypeItem flowDesignerMessagesType {{ id }}Message' title='{{ description }}'>",
		"<input id='{{ guid }}' message_type='{{ id }}' name='flowDesignerMessagesType' class='formRadioButton' type='radio'>",
		"<label for='{{ guid }}' class='formLabel'>",
		"{{ name }}",
		"</label>",
		"</div>"
	),
	messages_attachment_upload: "".concat(
		"<div attachment_upload class='flowDesignerMessagesAttachmentUpload' hidden>",
		"<%=_T('Drag & drop or select a file')%>",
		"</div>",
	),
	messages_attachment_shared_file_selector: "".concat(
		// "<div class='col-8 align-self-end'>",
        //     "<div class='form-group' id='container_{{ id }}'>",
                "<div attachment_shared_file_selector_container class='flowDesignerMessagesAttachmentSharedFileSelectorContainer' hidden>",
                    "<button attachment_shared_file_selector class='pageButtonGeneric buttonColorWhite'>",
                        "<%=_T('Select a file')%>",
                    "</button>",
                "</div>",
        //     "</div>",
		// "</div>",
	),
	messages_attachment_preview: "".concat(
		"<div attachment_preview='url' class='col-12 flowDesignerMessagesAttachmentPreview' hidden></div>",
		"<div attachment_preview='shared_file' class='col-12 flowDesignerMessagesAttachmentPreview' hidden></div>",
		"<div attachment_preview='repository' class='col-12 flowDesignerMessagesAttachmentPreview' hidden></div>",
	),
	messages_template: "".concat(
		"<div template_sources class='w-100'>",
		"</div>",
		"<div template_data class='w-100'>",
		"</div>"
	),
	messages_template_source: "".concat(
		"<div class='flowDesignerMessagesTemplateSource {{ id }}Template' title='{{ description }}'>",
		"<input id='{{ guid }}' template_source='{{ id }}' name='flowDesignerMessagesTemplateSource' class='formRadioButton flowDesignerMessagesTemplateSourceRadio' type='radio'>",
		"<label for='{{ guid }}' class='formLabel'>",
		"{{ name }}",
		"</label>",
		"</div>"
	),
	messages_template_text_container: "".concat(
		"<div id='messages_template_text_container'>",			
		"</div>"
	),
    messages_template_header_text: "".concat(
		"<div class='col-12'>",
            "<div class='form-group' style='display:none;'>",
                "<label class='formLabel'>",
                    "<%=_T('Header')%>:",
                "</label>",
                "<div id='flowDesignerMessagesTemplateHeaderText' class='flowDesignerMessagesTemplateText form-control'>",                           
                "</div>",
            "</div>",
        "</div>"
	),
    messages_template_text: "".concat(
		`<div class="col-12">
            <div class="form-group">
                <span class="ic_message_container textarea position-relative">
                    <span class="ic_variable_icon_container">
                        <div id="flowDesignerMessagesTemplateText" class="flowDesignerMessagesTemplateText form-control">                           
                        </div>
                        <i variable_icon class="ic_variable_icon far fa-at" title="Ingresar una variable o una expresión"></i>
                    </span>
                </span>
            </div>
        </div>`
	),
	messages_template_geo: "".concat(
		"<div class='formRow flowDesignerMessagesTemplateRow'>",
		"<div id='flowDesignerMessagesTemplateGeo' class='flowDesignerMessagesTemplateGeo'>",
		"</div>",
		"<i class='flowDesignerMessagesTemplateGeoBracketsIcon' title='{{ description }}'",
		'<%=_T("You can use {{ }} to enter variables in template items.")%>',
		"'></i>",
		"</div>"
	),
	messages_geo_fixed_options: "".concat(
		"<div class='flowDesignerListListFixedOptionsContainer'>",
		"<div fixed_list class='flowDesignerGeoListFixedOptions'>",
		"</div>",
		"<div add_option_container class='flowDesignerGeoListFixedAddOptionContainer'>",
		'<button add_option class="flowDesignerPopupButton buttonColorBlack" type="button">',
		'<%=_T("Add Item")%>',
		'</button>',
		"</div>",
		"</div>"
	),
	messages_geo_fixed_option: "".concat(
		"<div geo_item='{{ guid }}' class='flowDesignerMessagesTemplateGeoItem'>",
		'<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
		'<label message_text>',
		'</label>',
		'</div>',
		"<div geo_item_form class='flowDesignerMessagesTemplateGeoItemForm'>",
		"</div>",
		'<button geo_item_remove class="flowDesignerMessageCloseButton buttonColorLightblue" type="button">',
		"<i class='fa fa-close'></i>",
		'</button>',
		"</div>"
	),
	messages_geo: "".concat(
		"<div global_options class='flowDesignerGeoGlobalOptions'></div>",
		"<div list_options_type='fixed' class='flowDesignerGeoListFixed'></div>",
	),
	messages_geo_types_container: "".concat(
		"<div list_types class='flowDesignerGeoListTypes'>",
		"<div class='formDataExt'>",
		"<label class='formLabel'>",
		'<%=_T("Take elements from:")%>',
		"</label>",
		"</div>",
		"</div>"
	),
	messages_geo_type: "".concat(
		"<input id='{{ guid }}' geo_type='{{ id }}' name='flowDesignerMessagesTemplateGeoType' class='formRadioButton' type='radio' title='{{ description }}'>",
		"<label for='{{ guid }}' class='formLabel formInternalLabel' title='{{ description }}'>",
		"{{ name }}",
		"</label>"
	),
	messages_add_shared_files: "".concat(
		"<div class='col-12' id='{{ control_id }}_neww_container_btns' control_messageid='{{ control_id }}'>" +
			// "<div class='col-12'>" +
				"<div class='card-header {{ #justifyContentHeader }}{{ justifyContentHeader }}{{ /justifyContentHeader }}'>" +
					"{{ #hasTitle }}" +
					"<h5>{{ title }}</h5>" +
					"{{ /hasTitle }}" +
					"<div class='dropdown'>" +                            
						"<button ctrl_type='new_shared_file' control_messageid='{{ control_id }}' class='btn buttonIconAndText dropdown-toggle' type='button' id='dropdownAddComponent' aria-haspopup='true' aria-expanded='false'>" +
							"<span class='far fa-plus'></span><%=_T('Add Component')%>" +
						"</button>" +
						/*"<div class='dropdown-menu' aria-labelledby='dropdownAddComponent'>" +
							"<a add_file_type_archive class='dropdown-item' href='#'><%=_T('Archive')%></a>" +
							"<a add_file_type_variable class='dropdown-item' href='#'><%=_T('Variable')%></a>" +
						"</div>" +*/
					"</div>" +
				"</div>" +
			// "</div>" +
		"</div>" +	
		// "<div class='row'>" +					 
			"<div class='col-12'>" +
				"<div disclaimer class='inlineMessagesContainer messageInfo' id='{{ control_id }}not_results_found'></div>" +
				"<table id='{{ control_id }}list' cellpadding='0' cellspacing='0' border='0' class='viewGrid mt-0 mb-2 viewGridSharedFiles'>" +
					"<thead thead='true' class='viewGridHeader'></thead>" +
					"<tbody tbody='true' class='viewGridBody'></tbody>" +
				"</table>" +
				// El markup correspondiente a la tabla se genera dentro de la clase 'flow_designer_form_paginator.js'
				"<div id='{{ control_id }}grid_container' style='display: none;'></div>" +
				"<div class='mb-2' id='{{ control_id }}paginator'></div>" +
			// "</div>" +
		"</div>"
	),
	messages_hyperlink_button: "".concat(
        "<div class='flowDesignerMessagesHyperlinkContainer'>",
            "<div messages_hyperlink_form class='flowDesignerMessagesTemplateButtonHyperLinkForm' style='display: none;'>",
            "</div>",
            "<button hyperlink_button type='button' class='flowDesignerButtonsMenu buttonColorTransparent btnHyperlink' title='<%=_T('Add Hiperlink')%>'>",
                "<i class='far fa-link'></i>",
            "</button>",
        "</div>",
    ),
    messages_hyperlink: "".concat(
        "<div class='flowDesignerMessagesTemplateHyperLink'>",
            "<div hiperlink_edit class='flowDesignerMessagesTemplateHiperLinkEdit'>",
                "<div class='flowDesignerMessagesTemplateQuickreplyEditTitle'><%=_T('Add Hiperlink')%></div>", 
                '<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
                    '<label message_text>',
                    '</label>',
                '</div>',
                "<div hyperlink_edit_form class='flowDesignerMessagesTemplateHyperlinkEditForm'>",
                "</div>",
                "<div class='InternalpopOverButtons justify-content-center'>", 
                    '<button hyperlink_action="cancel" class="pageButtonGeneric buttonColorWhite" type="button">',
                        '<%=_T("Cancel")%>',
                    '</button>',
                    '<button hyperlink_action="save" class="pageButtonGeneric buttonColorBlue" type="button">',
                        '<%=_T("Confirm")%>',
                    '</button>',					
                "</div>",
            "</div>",
        "</div>"
    ),
    messages_button: "".concat(
        "<div template_button='{{ guid }}' class='flowDesignerMessagesTemplateButton'>",
            "<div button_view class='flowDesignerMessagesTemplateButtonView buttonTypeweb_url'>",
                "<label button_title class='flowDesignerMessagesTemplateButtonTitle'>",
                "</label>",
                "<label button_subtitle class='flowDesignerMessagesTemplateButtonSubtitle'>",
                "</label>",
                '<button button_action="delete" class="btn flowDesignerMessagesTemplateButtonViewDelete" type="button">',
                    '<i class="far fa-times"></i>',
                '</button>',
            "</div>",
            "<div button_edit class='flowDesignerMessagesTemplateButtonEdit'>",
                "<div class='flowDesignerMessagesTemplateQuickreplyEditTitle'>{{title}}</div>", 
                /*'<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
                    '<label message_text>',
                    '</label>',
                '</div>',*/
                "<div button_edit_form class='flowDesignerMessagesTemplateButtonEditForm'>",
                    "<div class='row'>",
                        "<div class='col-12'>",
                            "<div class='form-group'>",
                                "<label control_label='buttonTypeMain' class='required'>",
                                    "<%=_T('Button type:')%>",
                                "</label>",
                                "<div button_types class='flowDesignerMessagesTemplateButtonTypes'>",
                                "</div>",
                            "</div>",
                        "</div>",
                    "</div>",
                "</div>",
                "<div class='InternalpopOverButtons justify-content-center'>", 
                    '<button button_action="cancel" class="pageButtonGeneric buttonColorWhite" type="button">',
                        '<%=_T("Cancel")%>',
                    '</button>',
                    '<button button_action="save" class="pageButtonGeneric buttonColorBlue" type="button">',
                        '<%=_T("Confirm")%>',
                    '</button>',					
                "</div>",
            "</div>",
        "</div>"
    ),
    messages_button_interactive_reply: "".concat(
        "<div template_button='{{ guid }}' class='flowDesignerMessagesTemplateButton'>",
            "<div button_view class='flowDesignerMessagesTemplateQuickreplyView quickreplyTypetext'>",
                "<label button_title class='flowDesignerMessagesTemplateQuickreplyTitle'>",
                "</label>",
                '<button button_action="delete" class="btn flowDesignerMessagesTemplateQuickreplyDelete" type="button">',
                    '<i class="far fa-times"></i>',
                '</button>',
            "</div>",
            "<div button_edit class='flowDesignerMessagesTemplateButtonEdit'>",
                "<div class='flowDesignerMessagesTemplateQuickreplyEditTitle'><%=_T('Add Button')%></div>", 
                "<div button_edit_form class='flowDesignerMessagesTemplateButtonEditForm'>",
                    "<div class='row'>",
                        "<div class='col-12'>",
                            "<div class='form-group'>",
                                "<label control_label='buttonTypeMain' class='required'>",
                                    "<%=_T('Button type:')%>",
                                "</label>",
                                "<div button_types class='flowDesignerMessagesTemplateButtonTypes'>",
                                "</div>",
                            "</div>",
                        "</div>",
                    "</div>",
                "</div>",
                "<div class='InternalpopOverButtons justify-content-center'>", 
                    '<button button_action="cancel" class="pageButtonGeneric buttonColorWhite" type="button">',
                        '<%=_T("Cancel")%>',
                    '</button>',
                    '<button button_action="save" class="pageButtonGeneric buttonColorBlue" type="button">',
                        '<%=_T("Confirm")%>',
                    '</button>',					
                "</div>",
            "</div>",
        "</div>"
    ),
    messages_button_type: "".concat(
        "<div class='flowDesignerMessagesTemplateButtonType {{ id }}ButtonType' title='{{ description }}'>",
        "<input id='{{ guid }}' button_type='{{ id }}' name='flowDesignerMessagesTemplateButtonType' class='formRadioButton' type='radio'>",
        "<label for='{{ guid }}' class='formLabel'>",
        "{{ name }}",
        "</label>",
        "</div>"
    ),
    messages_buttons_list: "".concat(
        "<div class='flowDesignerMessagesButtonsListContainerFlex'>",
            "<div class='flowDesignerMessagesButtonsContainerFlex'>",
                "<div buttons_list class='flowDesignerMessagesButtonsListFlex ui-sortable'>",
                "</div>",
                '<button add_button class="btn buttonIconAndText buttonSmall" type="button">', 
                    "<span class='far fa-plus'>",
                    "</span>",
                    '{{ add_title }}',
                '</button>',
            "</div>",
        "</div>"
    ),
    messages_buttons_list_interactive: "".concat(
        "<div class='flowDesignerMessagesTemplateGalleryItemForm'>",
            "<div class='flowDesignerMessagesButtonsContainerFlex'>",
                "<div buttons_list class='flowDesignerMessagesButtonsListFlex ui-sortable'>",
                "</div>",
                '<button add_button class="btn buttonIconAndText buttonSmall" type="button">', 
                    "<span class='far fa-plus'>",
                    "</span>",
                    '{{ add_title }}',
                '</button>',
            "</div>",
        "</div>"
    ),
    messages_buttons_list_whatsapp: "".concat(
        "<div form_row class='col-12'>",
            "<div class='flowDesignerMessagesQuickrepliesListContainer'>",
                "<div quickreplies_title class='card-header pb-small'>",
                    "<h5><%=_T('Buttons')%></h5>",
                "</div>",
                "<div buttons_list class='flowDesignerMessagesQuickrepliesList'>",
                "</div>",
                "<div class='card-header'>",
                    "<button add_button class='btn buttonIconAndText'><span class='far fa-plus'></span><%=_T('Add button')%></button>",
                "</div>",
                "<div class='row'>",
                    "<div class='col-12'>",
                        "<div disclaimer class='inlineMessagesContainer messageInfo'>",
                            "<%=_T('Buttons text restrictions - Formatted text is not allowed (example *yes*) - Maximum 20 characters')%>",
                        "</div>",
                    "</div>",
                "</div>",
            "</div>",
        "</div>"
    ),
messages_buttons_list_inferior: "".concat(
    `<div class='flowDesignerMessagesButtonsListContainerFlex'>
        <div class='flowDesignerMessagesButtonsContainerFlex'>
            <div buttons_list class='flowDesignerMessagesButtonsListFlex ui-sortable'>
            </div>
            <button add_button class="btn buttonIconAndText buttonSmall" type="button"> 
                <span class='far fa-plus'>
                </span>
                {{ add_title }}
            </button>
        </div>
    </div>`,
),
messages_text_length: "".concat(
    "<p id='message_available_length_{{ id }}' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_wsp_header_text_length: "".concat(
    "<p id='messages_wsp_header_text_length' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_wsp_body_text_length: "".concat(
    "<p id='messages_wsp_body_text_length' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_wsp_footer_text_length: "".concat(
    "<p id='messages_wsp_footer_text_length' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_wsp_list_header_text_length: "".concat(
    "<p id='messages_wsp_list_header_text_length' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_wsp_list_body_text_length: "".concat(
    "<p id='messages_wsp_list_body_text_length' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_wsp_list_footer_text_length: "".concat(
    "<p id='messages_wsp_list_footer_text_length' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_wsp_list_button_text_length: "".concat(
    "<p id='messages_wsp_list_button_text_length' class='flowDesignerMessagesTextLength'>",
        "{{ available_length }} <%=_T('characters')%> | <strong><%=_T('Message')%></strong>",
    "</p>",
),
messages_quickreply: "".concat(
    "<div template_quickreply='{{ guid }}' class='flowDesignerMessagesTemplateQuickreply'>",
        "<div quickreply_view class='flowDesignerMessagesTemplateQuickreplyView'>",
            "<label quickreply_title class='flowDesignerMessagesTemplateQuickreplyTitle'>",
            "</label>",
            '<button quickreply_action="delete" class="btn flowDesignerMessagesTemplateQuickreplyDelete" type="button">',
                '<i class="far fa-times"></i>',
            '</button>',
        "</div>",
        "<div quickreply_edit class='flowDesignerMessagesTemplateQuickreplyEdit'>",
            "<div class='flowDesignerMessagesTemplateQuickreplyEditTitle'><%=_T('Quick replies')%></div>",
            '<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
                '<label message_text>',
                '</label>',
            '</div>',
            "<div quickreply_edit_form class='flowDesignerMessagesTemplateQuickreplyEditForm'>",
                "<div class='formRow'>",
                    "<div class='formData formDataExt'>",
                        "<label class='formLabel'>",
                            "<%=_T('Reply type:')%>",
                        "</label>",
                        "<div quickreply_types class='flowDesignerMessagesTemplateQuickreplyTypes'>",
                        "</div>",
                    "</div>",
                "</div>",
            "</div>",
            "<div class='InternalpopOverButtons justify-content-end'>", 
                '<button quickreply_action="cancel" class="pageButtonGeneric buttonColorWhite" type="button">',
                    '<%=_T("Cancel")%>',
                '</button>',
                '<button quickreply_action="save" class="pageButtonGeneric buttonColorBlue" type="button">',
                    '<%=_T("Ok")%>',
                '</button>',					
            "</div>",
        "</div>", 
    "</div>"
),

    messages_quickreply_type: "".concat(
        "<div class='flowDesignerMessagesTemplateQuickreplyType {{ id }}QuickreplyType' title='{{ description }}'>",
        "<input id='{{ guid }}' quickreply_type='{{ id }}' name='flowDesignerMessagesTemplateQuickreplyType' class='formRadioButton flowDesignerMessagesTemplateQuickreplyTypeRadio' type='radio'>",
        "<label for='{{ guid }}' class='formLabel'>",
        "{{ name }}",
        "</label>",
        "</div>"
    ),
    messages_quickreplies_list: "".concat(
        "<div class='flowDesignerMessagesQuickrepliesListContainer'>",
            "<div quickreplies_title class='card-header pb-small w-100'>",
                "<h5><%=_T('Quick replies')%></h5>",
            "</div>",
            "<div quickreplies_list class='flowDesignerMessagesQuickrepliesList'>",
            "</div>",
            '<button add_quickreply class="btn buttonIconAndText" type="button">',
                "<span class='far fa-plus'>",
                "</span>",
                '<%=_T("Add Quickreply")%>',
            '</button>',
        "</div>"
    ),
    messages_gallery: "".concat(
        "<div class='col-12'>",
            "<div class='flowDesignerGalleryContainer'>",
                "<div global_options class='flowDesignerGalleryGlobalOptions'>",
                "</div>",
                "<div list_type='variable' class='flowDesignerGalleryListVariable'>",
                "</div>",
                "<div list_type='fixed' class='flowDesignerGalleryListFixed'>",
                "</div>",
            "</div>",
        "</div>"
    ),
	messages_gallery_types_container: "".concat(
		"<div list_types class='flowDesignerGalleryListTypes col-6'>",
            "<div class='form-group' radiobuttonlist=''>",
                "<label class='required'><%=_T('Take elements from:')%></label>",
                "<div messages_gallery_container class='d-flex flex-row'>",
                "</div>",
            "</div>",
		"</div>"
	),
	messages_gallery_type: "".concat( 
		"<div id='gallery_checkbox_type_{{ id }}_container' class='form-radiobutton mt-0'>",
            "<label id='{{ guid }}' for='gallery_checkbox_type_{{ id }}' class='form-radiobutton-label'>",
                "<input type='radio' name='flowDesignerMessagesTemplateGalleryType' gallery_type='{{ id }}' id='gallery_checkbox_type_{{ id }}' class='gallery_checkbox_type_{{ id }} form-radiobutton-input'>",
                "<span>{{ name }}</span>",
            "</label>",
        "</div>",
	),
	messages_gallery_fixed_options: "".concat(
		"<div class='flowDesignerGalleryListFixedOptionsContainer'>",
			"<div fixed_list class='flowDesignerGalleryListFixedOptions'>",
			"</div>",
			"<div add_option_container class='flowDesignerGalleryListFixedAddOptionContainer'>",
                '<button add_option class="btn buttonIconAndText buttonSmall" type="button">', 
                    "<span class='far fa-plus'>",
                    "</span>",
                    '<%=_T("Add Item")%>',
                '</button>',
			"</div>",
		"</div>"
	),
	messages_gallery_fixed_option: "".concat(
		"<div gallery_item='{{ guid }}' class='flowDesignerMessagesTemplateGalleryItem'>",
			'<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
				'<label message_text>',
				'</label>',
			'</div>',
			"<div gallery_item_form class='flowDesignerMessagesTemplateGalleryItemForm'>",
			"</div>",
			'<button gallery_item_remove class="flowDesignerMessageCloseButton" type="button">',
				"<i class='far fa-times'></i>",
			'</button>',
		"</div>"
	),
	messages_list: "".concat(
		"<div class='col-12'>",
            "<div class='flowDesignerGalleryContainer flowDesignerGalleryTypeList'>",
                "<div global_options class='flowDesignerGalleryGlobalOptions'>",
                "</div>",
                "<div list_options_type='variable' class='flowDesignerGalleryListVariable'>",
                "</div>",
                "<div list_options_type='fixed' class='flowDesignerGalleryListFixed'>",
                "</div>",
                //"<div bottom_buttons_list class='flowDesignerListBottomButtons'></div>",
            "</div>",
        "</div>",
	),
	messages_list_types_container: "".concat( 
		"<div list_types class='flowDesignerGalleryListTypes col-6'>",
            "<div class='form-group' radiobuttonlist=''>",
                "<label class='required'><%=_T('Take elements from:')%></label>",
                "<div messages_list_container class='d-flex flex-row'>",
                "</div>",
            "</div>",
		"</div>"
	),
	messages_list_type: "".concat( 
		"<div id='list_checkbox_type_{{ id }}_container' class='form-radiobutton mt-0'>",
            "<label id='{{ guid }}' for='list_checkbox_type_{{ id }}' class='form-radiobutton-label'>",
                "<input type='radio' name='flowDesignerMessagesTemplateListType' list_type='{{ id }}' id='list_checkbox_type_{{ id }}' class='list_checkbox_type_{{ id }} form-radiobutton-input'>",
                "<span>{{ name }}</span>",
            "</label>",
        "</div>",
	),
	messages_list_fixed_options: "".concat(
		`<div class='flowDesignerGalleryListFixedOptionsContainer'>
			<div fixed_list class='flowDesignerGalleryListFixedOptions'></div>
            <div class="d-flex flex-row align-items-center flowDesignerGalleryListFixedBottomContainer">
                <div add_option_container class='flowDesignerGalleryListFixedAddOptionContainer'>
                    <button add_option class="btn buttonIconAndText buttonSmall" type="button">
                        <span class='far fa-plus'>
                        </span>
                        <%=_T([[Add Item]])%>
                    </button>
                </div>
                <div bottom_buttons_list class="flowDesignerListBottomButtons">                    
                </div>
            </div>
		</div>`,
	),
	messages_list_fixed_option: "".concat(
		"<div list_item='{{ guid }}' class='flowDesignerMessagesTemplateGalleryItem'>",
			'<button list_item_remove class="flowDesignerMessagesTemplateListItemRemove" type="button">',
            "<i class='far fa-times'></i>",
			'</button>',
			'<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
				'<label message_text>',
				'</label>',
			'</div>',
			"<div list_item_form class='flowDesignerMessagesTemplateListItemForm'>",
			"</div>",
		"</div>"
	),
	messages_reply_buttons: "".concat(
        "<div class='col-12'>",            
        "</div>"
    ),
	messages_reply_buttons_types_container: "".concat(
		"<div list_types class='flowDesignerReplyButtonsListTypes col-6'>",
            "<div class='form-group' radiobuttonlist=''>",
                "<label class='required'><%=_T('Take elements from:')%></label>",
                "<div messages_reply_buttons_container class='d-flex flex-row'>",
                "</div>",
            "</div>",
		"</div>"
	),
	messages_reply_buttons_type: "".concat( 
		"<div id='reply_buttons_checkbox_type_{{ id }}_container' class='form-radiobutton mt-0'>",
            "<label id='{{ guid }}' for='reply_buttons_checkbox_type_{{ id }}' class='form-radiobutton-label'>",
                "<input type='radio' name='flowDesignerMessagesTemplateReplyButtonsType' reply_buttons_type='{{ id }}' id='reply_buttons_checkbox_type_{{ id }}' class='reply_buttons_checkbox_type_{{ id }} form-radiobutton-input'>",
                "<span>{{ name }}</span>",
            "</label>",
        "</div>",
	),
	messages_reply_buttons_fixed_options: "".concat(
		"<div class='flowDesignerReplyButtonsListFixedOptionsContainer'>",
			"<div fixed_list class='flowDesignerReplyButtonsListFixedOptions'>",
			"</div>",
			"<div add_option_container class='flowDesignerReplyButtonsListFixedAddOptionContainer'>",
                '<button add_option class="btn buttonIconAndText buttonSmall" type="button">', 
                    "<span class='far fa-plus'>",
                    "</span>",
                    '<%=_T("Add Item")%>',
                '</button>',
			"</div>",
		"</div>"
	),
	messages_reply_buttons_fixed_option: "".concat(
		"<div reply_buttons_item='{{ guid }}' class='flowDesignerMessagesTemplateReplyButtonsItem'>",
			'<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
				'<label message_text>',
				'</label>',
			'</div>',
			"<div reply_buttons_item_form class='flowDesignerMessagesTemplateReplyButtonsItemForm'>",
			"</div>",
			'<button reply_buttons_item_remove class="flowDesignerMessageCloseButton" type="button">',
				"<i class='far fa-times'></i>",
			'</button>',
		"</div>"
	),
    messages_list_messages: "".concat(
        "<div class='col-12'>",            
            "<div class='card-header'>",
                "<h5><%=_T('Set up list')%></h5>",
            "</div>",
        "</div>",
        "<div class='col-12'>",
            "<div class='flowDesignerGalleryContainer flowDesignerGalleryTypeList'>",
                "<div list_type='fixed' class='flowDesignerGalleryListVariable'>",
                "</div>",
            "</div>",
            "<div disclaimer class='inlineMessagesContainer messageInfo'>",
			    "<%=_T('Buttons text restrictions - Formatted text is not allowed (example *yes*) - Maximum 20 characters')%>",
		    "</div>",
        "</div>"
    ),
	messages_list_messages_types_container: "".concat(
		"<div list_types class='flowDesignerListMessagesListTypes col-6'>",
            "<div class='form-group' radiobuttonlist=''>",
                "<label class='required'><%=_T('Take elements from:')%></label>",
                "<div messages_list_messages_container class='d-flex flex-row'>",
                "</div>",
            "</div>",
		"</div>"
	),
	messages_list_messages_type: "".concat( 
		"<div id='list_messages_checkbox_type_{{ id }}_container' class='form-radiobutton mt-0'>",
            "<label id='{{ guid }}' for='list_messages_checkbox_type_{{ id }}' class='form-radiobutton-label'>",
                "<input type='radio' name='flowDesignerMessagesTemplateListMessagesType' list_messages_type='{{ id }}' id='list_messages_checkbox_type_{{ id }}' class='list_messages_checkbox_type_{{ id }} form-radiobutton-input'>",
                "<span>{{ name }}</span>",
            "</label>",
        "</div>",
	),
	messages_list_messages_fixed_options: "".concat(
		"<div class='flowDesignerGalleryListFixedOptionsContainer'>",
			"<div fixed_list class='flowDesignerGalleryListFixedOptions'>",
			"</div>",
			"<div class='d-flex flex-row flowDesignerGalleryListFixedBottomContainer'>",
                "<div add_option_container class='flowDesignerGalleryListFixedAddOptionContainer'>",
                    '<button add_option class="btn buttonIconAndText buttonSmall" type="button">', 
                        "<span class='far fa-plus'>",
                        "</span>",
                        '<%=_T("Add Section")%>',
                    '</button>',
                "</div>",
			"</div>",
		"</div>"
	),
	messages_list_messages_fixed_option: "".concat(
		"<div list_messages_item='{{ guid }}' class='flowDesignerMessagesTemplateGallerySectionContainer'>",
			"<div list_messages_item_form class='flowDesignerMessagesTemplateGallerySectionTitle'>",
                "<div drag_section class='flowDesignerDragButton'><i class='fas fa-grip-vertical'></i></div>",
			"</div>",
		"</div>"
	),
    messages_list_messages_fixed_option_delete_button: "".concat(
		"<button list_messages_item_remove class='flowDesignerButtonIcon buttonColorTransparent far fa-trash-alt'></button>",
	),
	messages_menu_types_container: "".concat(
		"<div class='card-header justify-content-start'>",
			'<h5><%=_T("Take elements from:")%></h5>',
			"<div list_types class='form-group d-flex'>",
			"</div>",
		"</div>"
	),
	messages_menu_type: "".concat(
		"<div class='form-radiobutton'>",
			"<label for='{{ guid }}' class='form-radiobutton-label' title='{{ description }}'>",
				"<input id='{{ guid }}' menu_type='{{ id }}' name='flowDesignerMessagesTemplateMenuType' class='form-radiobutton-input' type='radio' title='{{ description }}'>",
				"<span>{{ name }}</span>",
			"</label>",
		"</div>"
	),
	messages_menu_options: "".concat(
		"<div menu_options_container class='flowDesignerMessagesMenuOptionsContainer'>",
		// "<label class='flowDesignerMessagesMenuOptionsTitle'>",
		// "<%=_T('Options')%><%=_T(':')%>",
		"</label>",
		"<ul menu_options class='flowDesignerMessagesMenuOptionsList'></ul>",
		"</div>",
	),
	
	messages_menu_option: "".concat(
		"<li menu_option class='flowDesignerMessagesMenuOption'>",
			"<div menu_option_selector class='flowDesignerMessagesMenuOptionSelector'></div>",
			"<div menu_option_form class='flowDesignerMessagesMenuOptionForm'>",
			"<div menu_option_value></div>",
			"<div menu_option_recognize class='flowDesignerMessagesMenuOptionRecognize'></div>",
			"<div menu_option_shared_files_enabled></div>",
			"<div menu_option_shared_files_ctrls style='display:none;'>",
			"<div menu_option_type class='flowDesignerMessagesMenuOptionType'></div>",
			"<div menu_option_message class='flowDesignerMessagesMenuOptionMessage row'></div>",
			"<i validation class='formFieldValidation formFieldError' hidden ></i>",
		"</li>"
	),
	send_and_wait_validation: "".concat(
		'<div class="row" id="adm_flow_validation_custom_disclaimer" {{ #hidden }} style="display: none;" {{ /hidden }}>',
            '<div class="col-12">',
                '<div disclaimer class="inlineMessagesContainer messageInfo"></div>',
            '</div>',
        '</div>'
	),
	embeed_message: "".concat(
        "<div class='row'>" + 
            "<div class='col-12'>" + 
				"{{ #checkboxInput }}" +
                "<div class='form-group'>",
                    "<div class='form-check'>",
                        "<label control_label='voicemail' for='{{id}}_voicemail' class='form-check-label form-check-label-title'>",
                            "<input embeed_message_toggle id='{{id}}_voicemail' class='form-check-input' control='voicemail' type='checkbox'>",
                            "{{ title }}",
                        "</label>",
                    "</div>",
                "</div>",
				"{{ /checkboxInput }}" +
            "</div>",
        "</div>",
        "<div class='row'>" + 
            "<div class='col-12'>" + 
                "<div embeed_message_type ='flowDesignerMessagesEmbeedMessageType'></div>",
            "</div>",
        "</div>",
        
        "<div>" +                  
            "<div embeed_message embeed_message_toggled class='flowDesignerMessagesEmbeedMessage row' ></div>",            
        "</div>",   

        "{{ #disclaimer }}",
            "<div class='row'>",
                "<div class='col-12'>",
                    "<div disclaimer class='inlineMessagesContainer messageInfo'>{{ disclaimer }}</div>",
                "</div>",
            "</div>",                
        "{{ /disclaimer }}",
	),
	popup_form_subtitle: "".concat(
		"<h2 form_subtitle='{{ id }}' class='formSubTitle'>",
			"<label class='subTitleText'>{{ name }}</label>",
			"{{ #description }}",
				'<label class="subTitleHelp">',
					'{{ description }}',
				'</label>',
			"{{ /description }}",
		"</h2>"
	),
	messages_tabs: "".concat( 
        '<ul class="nav nav-tabs" id="tabs-message" role="tablist">',
            '<li class="nav-item">',
                '<a class="nav-link active" id="message-tab" data-toggle="tab" href="#message" role="tab" aria-controls="message" aria-selected="true"><%=_T("Message")%></a>',
            '</li>',
            '<li class="nav-item">',
                '<a class="nav-link" id="configuration-tab" data-toggle="tab" href="#configuration" role="tab" aria-controls="configuration" aria-selected="false"><%=_T("Configuration")%></a>',
            '</li>',
            '<li class="nav-item">',
                '<a class="nav-link" id="outputs-tab" data-toggle="tab" href="#outputs" role="tab" aria-controls="outputs" aria-selected="false"><%=_T("Outputs")%></a>',
            '</li>',
        '</ul>',

        '<div class="tab-content" id="tabContent-send-and-wait">',
            '<div class="tab-pane fade show active" id="message" role="tabpanel" aria-labelledby="message-tab"></div>',
            '<div class="tab-pane fade" id="configuration" role="tabpanel" aria-labelledby="configuration-tab"></div>',
            '<div class="tab-pane fade" id="outputs" role="tabpanel" aria-labelledby="outputs-tab"></div>',
        '</div>'
	),
	luis_tabs: "".concat(
		'<ul class="nav nav-tabs" id="tabs-message" role="tablist">',
            '<li class="nav-item">',
                '<a class="nav-link active" id="message-tab" data-toggle="tab" href="#message" role="tab" aria-controls="message" aria-selected="true"><%=_T("Configuration")%></a>',
            '</li>',
            '<li class="nav-item">',
                '<a class="nav-link" id="configuration-tab" data-toggle="tab" href="#configuration" role="tab" aria-controls="configuration" aria-selected="false"><%=_T("Outputs")%></a>',
            '</li>',
        '</ul>',

        '<div class="tab-content" id="tabContent-nlu">',
			'<div class="tab-pane fade show active" id="message" role="tabpanel" aria-labelledby="configuration-tab"></div>',
            '<div class="tab-pane fade" id="configuration" role="tabpanel" aria-labelledby="message-tab"></div>',
        '</div>',
	),
	cognitive_services_card_header: "".concat(
        `<div id="cognitive_services_card_header" class="card-header">
            <h5><%=_T([[Set Cognitive services]])%></h5>
        </div>`
    ),    
	manage_process_field: "".concat( 
		"<li field class='flowDesignerReportFieldNew d-flex align-items-center'>",
			"<div class='flowDesignerReportFieldApplicationNew form-group mb-0 flex-grow-1'>",
				"<label>",
					"<%=_T('Application')%>:",
				"</label>",
				"<select field_application id='{{ guid }}' control='{{ id }}' class='form-control'>",
					"{{{ options_list }}}",
				"</select>",
			"</div>",
			"<div class='flowDesignerReportFieldNameNew form-group mb-0 flex-grow-1'>",
				"<label>",
					"<%=_T('Name')%>:",
				"</label>",
				"<input field_name type='text' class='form-control'>",
				"{{ #hidden }}",
				"<select field_name_property id='{{ guid }}' control='{{ id }}' class='form-control' hidden>",
					"{{{ options_list }}}",
				"</select>",
				"{{ /hidden }}",
			"</div>",
			"<div class='flowDesignerReportFieldValueNew form-group mb-0 flex-grow-1'>",
				"<label>",
					"<%=_T('Value')%>:",
				"</label>",
				"<span class='ic_variable_icon_container'>",
					"<i variable_icon class='ic_variable_icon far fa-at' title='",
						"<%=_T('Enter a variable or an expression')%>", "' ></i>",
					"<input field_value type='text' class='form-control'>",
				"</span>",
			"</div>",
			"<div class='form-group justify-content-between mb-0' title='{{ description }}'>",
				"<div class='form-check'>",
					"<label for='{{ guid }}_agent' class='form-check-label form-check-label-title'>",
						"<input field_sendToAgent id='{{ guid }}_agent' control='{{ id }}' class='form-check-input' type='checkbox' />",
						"<%=_T('Agent')%>",
					"</label>",
				"</div>",
				"<div class='form-check'>",
					"<label for='{{ guid }}_field_hidden' class='form-check-label form-check-label-title'>",
						"<input id='{{ guid }}_field_hidden' class='form-check-input' type='checkbox' field_hidden >",
						"<%=_T('Hidden')%>",
					"</label>",
				"</div>",
			"</div>",
			"<div class='form-group justify-content-between mb-0'>",
				"<div class='form-check'>",
					"<label for='{{ guid }}_report' class='form-check-label form-check-label-title'>",
						"<input field_sendToReport id='{{ guid }}_report' control='{{ id }}' class='form-check-input' type='checkbox' />",
						"<%=_T('Report')%>",
					"</label>",
				"</div>",
				"<div class='form-check'>",
					"<label for='{{ guid }}_searchable' class='form-check-label form-check-label-title'>",
						"<input field_searchable id='{{ guid }}_searchable' control='{{ id }}' class='form-check-input' type='checkbox' />",
						"<%=_T('Searchable')%>",
					"</label>",
				"</div>",
			"</div>",

			"<div class='flowDesignerReportFieldTypeNew form-group mb-0'>",
				"<label>",
					"<%=_T('Type')%>:",
				"</label>",
				"<select field_type id='{{ guid }}' control='{{ id }}' class='form-control'>",
					"{{{ options_list }}}",
				"</select>",
			"</div>",
			"<div class='form-group mb-0 mr-0 d-flex'>",
				"<button add class='pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn align-self-end' title='<%=_T('Add')%>'>",
					"<i class='far fa-plus'></i>",
				"</button>",
				"<button remove class='pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn align-self-end' title='<%=_T('Delete')%>''>",
					"<i class='far fa-trash-alt'></i>",
				"</button>",
			"</div>",
				"<i validation class='formFieldValidation formFieldError' style='display: none;' hidden ></i>",
		"</li>"
	),
	button_add: "".concat(
		'<button add class="flowDesignerConditionAdd buttonColorLightblue" type="button">',
			'+',
		'</button>'
	),
	//helpdesk
	helpdesk_main_content: "".concat(
		'<div content class="row">',
		'</div>'
	),
	helpdesk_api_doc_content: "".concat(
		'<div api_doc_content class="col-6 col-md-5">',
			"<div helpdesk_request class='form-group'>",
				"<p><%=_T('Request example')%></p>",
				"<textarea text_request class='form-control form-control-dark' readonly></textarea>",
			"</div>",
			"<div helpdesk_response class='form-group'>",
				"<p><%=_T('Response')%></p>",
				"<textarea text_response class='form-control form-control-dark' readonly></textarea>",
			"</div>",
		'</div>'
	),

	helpdesk_fields: "".concat(
		"<div class='card-header'>",
			"<h5><%=_T('Fields')%></h5>",
		"</div>",
		"<div class='flowDesignerQnAMetadataFieldsContainer flowDesignerHelpDeskFieldsContainer'>",
			"<ul fields class='flowDesignerQnAMetadataFieldsList flowDesignerHelpDeskFieldsListNew formList'>",
			"</ul>",
		"</div>",
		// "<div id='{{ guid }}' class='form-group position-relative'>",
		// 	"<label control_label='result' for='{{ id }}'><%=_T('Result')%><%=_T(':')%></label>",
		// 	"<input id='{{ id }}' control='result' class='form-control' type='text' placeholder='<%=_T('Enter result')%>...'/>",
		// 	"<i validation='result' class='formFieldValidation formFieldError' hidden></i>",
		// "</div>"   
	),
	
	helpdesk_field: "".concat(
		"<li field class='flowDesignerQnAMetadataFieldNew d-flex align-items-center'>",
			"<div class='form-group mb-0 flex-grow-1'>",
				"<label>",
					"<%=_T('Name')%>:",
				"</label>",
				"<input field_name type='text' class='form-control' disabled>",
			"</div>",
			"<div class='form-group mb-0'>",
				"<div class='form-check mt-0'>",
					"<label class='form-check-label form-check-label-title'>",
						"<input field_required class='form-check-input' type='checkbox' placeholder='<%=_T('Enter name')%>...' disabled>",
						"<%=_T('Required')%>",
					"</label>",
				"</div>",
			"</div>",
			"<div class='form-group mb-0 flex-grow-1'>",
				"<label>",
					"<%=_T('Type')%>:",
				"</label>",
				"<input field_type type='text' class='form-control' placeholder=<%=_T('Enter type')%>...' disabled>",
			"</div>",
			"<div class='form-group mb-0 mr-0 flex-grow-1 position-relative'>",
				"<label class='required'><%=_T('Value')%><%=_T(':')%></label>",
				"<span class='ic_variable_icon_container'>",
					"<i variable_icon class='ic_variable_icon far fa-at' title='<%=_T('Enter a variable or an expression resulting in an integer number')%>' ></i>",
					"<input id='{{id}}_value' field_value class='form-control' type='text' placeholder=''/>",
				"</span>",
			"</div>",
			"<i validation class='formFieldValidation formFieldError' hidden style='display:none'></i>",
		"</li>"
	),
	//entity recognizers
	entity_recognizer_fields: "".concat(
        "<div id='flowDesignerEntityRecognizerFieldsContainerTitle' class='card-header pt-small'>",
            "<h5><%=_T('Partial Recognitions')%></h5>",
        "</div>",
	),

	//HSM Buttons
	messages_hsm_button: "".concat(
        "<div template_button='{{ guid }}' class='flowDesignerMessagesTemplateQuickreply'>",
        "<div button_view class='flowDesignerMessagesTemplateQuickreplyView'>",
            "<label button_title class='flowDesignerMessagesTemplateQuickreplyTitle'>",
            "</label>",
        "</div>",
        "<div button_edit class='flowDesignerMessagesTemplateQuickreplyEdit'>",
            "<div class='flowDesignerMessagesTemplateQuickreplyEditTitle'><%=_T('Quick reply buttons')%></div>",
            "<div button_edit_form class='flowDesignerMessagesTemplateQuickreplyEditForm'>",
            "</div>",
            "<div class='InternalpopOverButtons justify-content-end'>", 
                '<button button_action="cancel" class="pageButtonGeneric buttonColorWhite" type="button">',
                    '<%=_T("Cancel")%>',
                '</button>',
                '<button button_action="save" class="pageButtonGeneric buttonColorBlue" type="button">',
                    '<%=_T("Ok")%>',
                '</button>',					
            "</div>",
        "</div>", 
    "</div>"
	),
	messages_hsm_buttons_list: "".concat(
		"<div class='flowDesignerMessagesHsmButtonsListContainer' style='display:none;'>",
            "<div hsm_buttons_title class='card-header pb-small w-100'>",
                "<h5><%=_T('Quick replies')%></h5>",
            "</div>",
            "<div hsm_buttons_list class='flowDesignerMessagesQuickrepliesList'>",
            "</div>",
        "</div>"
	),
	activity_template: "".concat(
		"<div class='custom_activity'>",
		"<div class='custom_header'>",
		"<div class='{{image}}'></div>",
		"<span class='custom_title'>{{description}}</span>",
		"</div>",
		"</div>",
		"<div class='custom_body'></div>"
	),
	initial_activity_template: "".concat(
		"<div class='custom_initial_activity'>",
		"<div class='custom_initial_body'>",
		"<div class='{{image}}'></div>",
		"<span class='custom_title'>{{description}}</span>",
		"</div>",
		"</div>"
	),
	close_activity_template: "".concat(
		"<div class='custom_close_activity'>",
		"<div class='custom_close_body'>",
		"<div class='{{image}}'></div>",
		"<span class='custom_title'>{{description}}</span>",
		"</div>",
		// "<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	writing_activity_template: "".concat(
		"<div class='custom_writing_activity'>",
		"<div class='custom_writing_body'>",
		"<div class='{{image}}'></div>",
		"</div>",
		"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	transfer_activity_template: "".concat(
		"<div class='custom_transfer_activity'>",
		"<div class='custom_transfer_body'>",
		"<div class='{{image}}'></div>",
		"</div>",
		"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	reporting_data_activity_template: "".concat(
		"<div class='custom_reporting_data_activity'>",
		"<div class='custom_reporting_data_body'>",
		"<div class='{{image}}'></div>",
		"</div>",
		"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	start_webcontact_activity_template: "".concat(
		"<div class='custom_start_webcontact_activity'>",
		"<div class='custom_start_webcontact_body'>",
		"<div class='{{image}}'></div>",
		"</div>",
		"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	sql_activity_template: "".concat(
		"<div class='custom_sql_activity'>",
			"<div class='custom_sql_body'>",
			"<div class='{{image}}'></div>",
			"</div>",
			"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	logger_activity_template: "".concat(
		"<div class='custom_logger_activity'>",
			"<div class='custom_logger_body'>",
			"<div class='{{image}}'></div>",
			"</div>",
			"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	answer_activity_template: "".concat(
		"<div class='custom_answer_activity'>",
			"<div class='custom_answer_body'>",
			"<div class='{{image}}'></div>",
			"</div>",
			"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	hold_activity_template: "".concat(
		"<div class='custom_hold_activity'>",
			"<div class='custom_hold_body'>",
			"<div class='{{image}}'></div>",
			"</div>",
			"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	start_recording_activity_template: "".concat(
		"<div class='custom_start_recording_activity'>",
			"<div class='custom_start_recording_body'>",
			"<div class='{{image}}'></div>",
			"</div>",
			"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	set_automatic_message_activity_template: "".concat(
		"<div class='custom_set_automatic_message_activity'>",
			"<div class='custom_set_automatic_message_body'>",
			"<div class='{{image}}'></div>",
			"</div>",
			"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	jump_to_process_activity_template: "".concat(
		"<div class='custom_jump_to_process_activity'>",
			"<div class='custom_jump_to_process_body'>",
			"<div class='{{image}}'></div>",
			"</div>",
			"<span class='custom_description'>{{description}}</span>",
		"</div>"
	),
	jump_to_state_activity_template: "".concat( 
		// <!-- internalPopUpContainer formPopUp flowDesignerPopUpContainer popOver380w flowDesignerGlobalModal botActivity_jump_to_state -->
		"<div class='internalPopUpTitle'>",
			"<label activity_description class='flowDesignerPopupTitleText'>{{Title Description}}</label>",
			"<div activity_description_edit class='form-group activityDescriptionEdit' style='display: none;'>",
				"<div class='d-flex flex-grow-1'>",
					"<input id='{{id}}_activity_description' control='description' class='form-control' type='text' placeholder='<%=_T('Enter description')%>...'/>",
					"<i validation='description' id='flow_designer_activity_description_validation' class='formFieldValidation formFieldError' hidden></i>",
				"</div>",
				"<button id='flow_designer_activity_description_edit_save' class='pageButtonGeneric buttonColorWhite iconOnlyBtn save align-self-end ml-1' title='<%=_T('Save')%>'><i class='far fa-check-circle'></i></button>",
				"<button id='flow_designer_activity_description_edit_cancel' class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end ml-1' title='<%=_T('Cancel')%>'><i class='far fa-times-circle'></i></button>",
			"</div>",
			// "<button id='flow_designer_activity_description_edit' class='pageButtonGeneric buttonColorTransparent iconOnlyBtn align-self-end ml-2' title='<%=_T('Cancel')%>'><i class='far fa-pencil'></i></button>",
		"</div>",
		"<div class='internalPopUpMiddle pageFormContainer flowDesignerPopupContent'>",
			"<div message_container class='genericFormMessagesContainer messageError' style='display:none;'>",
				"<label message_text></label>",
			"</div>",
			"<div class='card'>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-12'>",
							"<div class='form-group form-input-and-check'>",
								"<div class='form-input-container'>",
									"<label control_label='state' for='{{id}}_state' class='required'><%=_T('State')%><%=_T(':')%></label>",
									"<select id='{{id}}_state' control='state' class='form-control'>",
										"<option value='state_3' >Principal</option>",
										"<option value='state_1' >Ventas</option>",
									"</select>",
									"<i validation='state' class='formFieldValidation formFieldError' hidden></i>",
								"</div>",
								"<div class='form-check'>",
									"<label control_label='backToState' for='{{id}}_backToState' class='form-check-label form-check-label-title'>",
										"<input id='{{id}}_backToState' class='form-check-input' control='backToState' type='checkbox'>",
										"<%=_T('Back To State')%>",
									"</label>",
								"</div>",
							"</div>",
						"</div>",
						
					"</div>",
				"</div>",
			"</div>",
		"</div>",
		"<div class='internalPopUpButtons justify-content-end'>",
			"<button action='cancel' class='pageButtonGeneric buttonColorWhite' type='button'><%=_T('Cancel')%></button>",
			"<button disabled action='save' class='pageButtonGeneric buttonColorBlue' type='button'><%=_T('Confirm')%></button>",
		"</div>",
	),
	state_node_template: "".concat( 
		"<div class='custom_state'>",
			"<div class='custom_header'>",
			"<div class='{{image}}'></div>",
			"<span class='custom_title'>{{description}}</span>",
			"</div>",
		"</div>",
		"<div class='custom_body'></div>"
	),
	execute_luis_metadata: "".concat( 
			"<div class='card no-card'>",
				"<div class='card-block'>",
					// <!-- Aca va markup de listado de pills de opciones de salidas -->
					"<div class='card-header pb-small'>",
						"<h5><%=_T('Available options')%>:</h5>",
					"</div>",
					"<div class='row' id='rd_luis_intent_selector'>",
						"<div class='col-12' ic-role='list-container' id='intents_list_container'>",
							"<div class='form-drag-main-container'>",
								"<ul id='rd_luis_available_intents_list' ic-role='intents-available' class='formDragListContainerNew intentsList formList ui-sortable'>",
									"<li ic-role='template' ic-data-bind='intent' style='display:none'>",
										"<p>{name}</p>",
									"</li>",
								"</ul>",
							"</div>",
						"</div>",
					"</div>",
					"<div class='card-header'>",
						"<h5><%=_T('Add output')%></h5>",
						"<button add_new_port class='btn buttonIconAndText'><span class='far fa-plus'></span><%=_T('Add output')%></button>",
					"</div>",
				"</div>",
			"</div>",
			"<div class='card no-card scrollable-card' id='rd_luis_intent_selector_receiver'>",
				"<div class='card-block'>",
					"<div id='output_list' ic-role='list-receiver' fields >",
					"</div>",
					"<div disclaimer class='inlineMessagesContainer messageInfo inlineMessageDismissable'><%=_T('Drag and drop intents to use in the port')%></div>",
				"</div>",
			"</div>",
	),
	execute_luis_metadata_intent_field: "".concat(
		"<div template_intent='{{ guid }}' field class='flowDesignerOutputPortsContainer'>",
			"<div class='row'>",
				"<div class='col-12 flowDesignerOutputDescription'>",
					"<div class='form-group d-flex flex-row'>",
						"<input field_name class='form-control mt-0' type='text'>",
						"<button remove class='pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn'>",
							"<i class='far fa-trash-alt'></i>",
						"</button>",
					"</div>",
				"</div>",
				"<div class='col-12 flowDesignerOutputPortsList'>",
					"<ul ic-data-bind='intents' template_intent='{{ guid }}' class='portsList intentsList formList ui-sortable ui-intents-receive'>",
						"<li ic-role='template' ic-data-bind='intent' style='display:none'>",
							"<p>{name}</p>",
						"</li>",
					"</ul>",
				"</div>",
			"</div>",
		"</div>",
	),
	execute_luis_scoring: "".concat( 
		"<div class='card-header pb-0'>",
			"<h5>",
				"<%=_T('Admitted scoring')%>",
			"</h5>",
		"</div>",
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group'>",
					"<div class='scoringCodeSizeContainer'>",
						"<span class='ui-slider-scoring-value'></span>",
						"<div control='global_scoring' id='adm_flow_execute_luis_metadata_operation_global_scoring' class='scoringCodeSize ui-slider ui-corner-all ui-slider-horizontal ui-widget ui-widget-content'>",	
							//"<div control='global_scoring_handle' class='ui-slider-handle ui-corner-all ui-state-default' tabindex='0' style='left: 50%;'></div>",	
							// "<div class='ui-slider-range ui-corner-all ui-widget-header ui-slider-range-min' style='width: 50%;'></div>",	
						"</div>",	
						"<input type='text' control='luis_scoring' class='ui-slider-scoring-input-value' hidden=''>",	
					"</div>",
				"</div>",
			"</div>",
		"</div>"
	),
	validation_custom_disclaimer: "".concat( 
        `<div class="row flowDesignerSendAndWaitValidation">
            <div class="col-12">
                <div class="inlineMessagesContainer messageInfo"><%=_T([[Use the message variable to check that the received message is valid. Return true or false. Example: return message.text == test]])%></div>
                <div class="flowDesignerCodeBlockContainer">
                    <div validation_code class="flowDesignerCodeBlock flowDesignerSendAndWaitValidationContent ace_editor ace-tm">
                    </div>
                </div>
            </div>
        </div>`
    ),
	menu_outputs: "".concat(
        
        "<div class='card no-card'>",
            "<div class='card-block'>",
                "<div class='card-header pb-small'>",
                    "<h5><%=_T('Available options')%>:</h5>",
                    "<button add_new_output class='btn buttonIconAndText'><span class='far fa-plus'></span><%=_T('Add option')%></button>",
                "</div>",
                "<div messages_output_option_form class='flowDesignerMessagesTemplateButtonHyperLinkForm' style='display: none;'></div>",
                "<div class='row' id='rd_menu_output_selector'>",
                    "<div class='col-12' ic-role='list-container' id='intents_list_container'>",
                        "<div class='form-drag-main-container'>",
                            "<ul id='rd_menu_available_option_list' ic-role='options-available' class='formDragListContainerNew intentsList formList ui-sortable'>",
                                "<li ic-role='template' ic-data-bind='option' style='display:none'>",
                                    "<p>{name}</p>",
                                "</li>",
                                "<li ic-role='template-qr' ic-data-bind='option' style='display:none' class='quickreply_option' draggable='false'>",
                                    "<p>{name}</p>",
                                "</li>",
                            "</ul>",
                        "</div>",
                    "</div>",
                "</div>",
                "<div class='card-header'>",
                    "<h5><%=_T('Outputs')%></h5>",
                    "<button add_new_port class='btn buttonIconAndText'><span class='far fa-plus'></span><%=_T('Add output')%></button>",
                "</div>",
            "</div>",
        "</div>",
        
        "<div class='card no-card scrollable-card'>",
            "<div class='card-block' id='rd_menu_option_selector_receiver'>",
                "<ul ic-role='list-receiver' output_fields class='flowDesignerMenuMetadataFieldsList'>",
                "</ul>",
				"<div class='row'>",
                    "<div class='col-12'>",
                        "<div disclaimer class='inlineMessagesContainer messageInfo inlineMessageDismissable'><%=_T([[Drag & Drop the items to be used at each port]])%> <a close_message class='genericMessagesClose'></a></div>",
                    "</div>",
                "</div>",
            "</div>",
        "</div>",
	),
	menu_outputs_field: "".concat(            
        "<li template_option='{{ guid }}' output_field class='flowDesignerOutputPortsContainer'>",
            "<div class='row'>",
                "<div class='col-12 flowDesignerOutputDescription'>",
                    "<div class='form-group d-flex flex-row'>",
                        "<input field_name class='form-control mt-0 {{ #isQuickReply }}hidden_control{{ /isQuickReply }}' type='text' placeholder='{{ placeholder }}'>",
                        "<label field_name_label type='text' {{ #isQuickReply }}visible{{ /isQuickReply }} style='display: none;' class='formField flowDesignerReportFieldNameControlLabel'></label>",
                        "<label class='quickReplyToolTip' {{ #isQuickReply }}visible{{ /isQuickReply }} title='<%=_T('The name of the output ports correspond to the quick responses configured previously')%>' style='display: none;'><i class='far fa-question-circle'></i></label>",
                        "<button remove class='pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn'>",
                            "<i class='far fa-trash-alt'></i>",
                        "</button>",
                    "</div>",
                "</div>",

                "<div class='col-12 flowDesignerOutputPortsList form-drag-main-container'>",
                    "<div class='formDragListContainer'>",
                        "<ul ic-data-bind='options' class='portsList intentsList formList ui-sortable ui-options-receive'>",
                            "<li ic-role='template' ic-data-bind='option' style='display:none'>",
                                "<p>{name}</p>",
                            "</li>",
                            "<li ic-role='template-qr' ic-data-bind='option' class='quickreply_option' draggable='false' style='display:none'>",
                                "<p>{name}</p>",
                            "</li>",
                        "</ul>",
                    "</div>",
                "</div>",

            "</div>",
            "<i validation class='formFieldValidation formFieldError' hidden ></i>",
        "</li>",
    ),
    menu_outputs_scoring: "".concat( 
        `<div id='luis_scoring_slider_title' class="card-header pb-0">
            <h5><%=_T([[Confidence scoring]])%></h5>
        </div>
        <div id='luis_scoring_slider_control' class="row">
            <div class="col-12">
                <div class="form-group">
                    <div class="scoringCodeSizeContainer">
                        <span class="ui-slider-scoring-value">50%</span>
                        <div control="global_scoring" id="adm_flow_execute_luis_metadata_operation_global_scoring" class="scoringCodeSize ui-slider ui-corner-all ui-slider-horizontal ui-widget ui-widget-content">
                        </div>
                        <input type="text" control="luis_scoring" class="ui-slider-scoring-input-value" hidden></div>
                </div>
            </div>
        </div>`
    ),
	menu_outputs_gpt_temperature: "".concat(
        `<div id='gpt_temperature_title' class="pb-0">
            <h5><%=_T([[GPT Temperature]])%></h5>
        </div>
        <div id='gpt_temperature_slider_control' class="row">
            <div class="col-12">
                <div class="form-group">
                    <div class="scoringCodeSizeContainer">
                        <span class="ui-slider-scoring-value">0.25</span>
                        <div control="global_scoring" id="adm_flow_execute_luis_metadata_operation_global_scoring" class="scoringCodeSize ui-slider ui-corner-all ui-slider-horizontal ui-widget ui-widget-content">
                        </div>
                        <input type="text" control="gpt_temperature" class="ui-slider-scoring-input-value" hidden></div>
                </div>
            </div>
        </div>`
    ),
    messages_output: "".concat(
        "<div class='flowDesignerMessagesTemplateHyperLink'>",
			"<div hiperlink_edit class='flowDesignerMessagesTemplateHiperLinkEdit'>",

            "<div class='flowDesignerMessagesTemplateQuickreplyEditTitle'><%=_T('Add option')%></div>", 

			'<div message_container class="genericFormMessagesContainer messageError flowDesignerButtonMessage" style="display:none;">',
			'<label message_text>',
			'</label>',
			'</div>',
			"<div hyperlink_edit_form class='flowDesignerMessagesTemplateHyperlinkEditForm'>",

				"</div>",

                "<div class='InternalpopOverButtons justify-content-end'>", 
                    '<button hyperlink_action="cancel" class="pageButtonGeneric buttonColorWhite" type="button">',
                        '<%=_T("Cancel")%>',
                    '</button>',
                    '<button hyperlink_action="save" class="pageButtonGeneric buttonColorBlue" type="button">',
						'<%=_T("Confirm")%>',
					'</button>',					
				"</div>",
			"</div>",
		"</div>"
	),

	button_icon_and_text_popup: "".concat(
		"<button {{ persoTags }} id='{{ guid }}' control='{{ id }}' class='btn buttonIconAndText' {{ #style }}style='{{ style }}'{{ /style }}>",
			"<span class='far fa-plus'></span>",
			"{{ #content }}<%=_T('{{ content }}')%>{{ /content }}",
		"</button>"
	),

	add_contact_attribute_list: "".concat(
        "<div id='flowDesignerMessagesQuickrepliesListContainerId' class='flowDesignerMessagesQuickrepliesListContainer mb-0' {{ #style }}style='{{ style }}'{{ /style }} >",
			"<div class='card-header'>",
                "<button add_phone class='btn buttonIconAndText'>",
					"<span class='far fa-plus'></span>",
					"<%=_T('Add Phone')%>",
				"</button>",
           	"</div>",

			"<div class='card-header'>",
                "<button add_contact_attributes class='btn buttonIconAndText'>",
					"<span class='far fa-plus'></span>",
					"<%=_T('Add contact attribute')%>",
				"</button>",
           	"</div>",

			"<div contactattributes_title class='card-header pb-small'>",
			   "<h5><%=_T('Contact attributes')%></h5>",
		   	"</div>",

			"<div contactattributes_list class='flowDesignerMessagesQuickrepliesList ui-sortable'>",
			"</div>",
        "</div>"
    ),

	add_contact_attribute_template: "".concat(
		"<div template_quickreply='{{ guid }}' class='flowDesignerMessagesTemplateQuickreply' contactattr_name='Atributo 1'>",
			"<div contactattr_view class='flowDesignerMessagesTemplateQuickreplyView quickreplyTypetext'>",
				"<label contactattr_title class='flowDesignerMessagesTemplateQuickreplyTitle'>Atributo 1</label>",
				"<button contactattr_action='delete' class='btn flowDesignerMessagesTemplateQuickreplyDelete' type='button'><i class='far fa-times'></i></button>",
			"</div>",
			"<div contactattr_edit class='flowDesignerMessagesTemplateQuickreplyEdit'>",
				"<div class='flowDesignerMessagesTemplateQuickreplyEditTitle'><%=_T('Add contact attribute')%></div>",
				"<div message_container class='genericFormMessagesContainer messageError flowDesignerButtonMessage' style='display: none;'><label message_text></label></div>",
				"<div contactattr_edit_form class='flowDesignerMessagesTemplateQuickreplyEditForm'>",
					"<div form_row class='row'>",
						"<div form_row class='col-12'>",
							"<div id='container_{{ guid }}' class='form-group'>",
								"<label control_label='contactattr_type' for='{{ guid }}' class='required'><%=_T('Type')%>:</label>",
								"<select id='{{ guid }}' control='contactattr_type' class='form-control' />",
									"<option value='text'><%=_T('Text')%></option>",
									"<option value='simple'><%=_T('Simple')%></option>",
									"<option value='date'><%=_T('Date')%></option>",
									"<option value='number'><%=_T('Number')%></option>",
								"</select>",
								"<i validation='contactattr_type' class='formFieldValidation formFieldError' hidden style='display: none;'></i>",
							"</div>",
						"</div>",
					"</div>",
					"<div form_row class='row'>",
						"<div form_row class='col-12'>",
							"<div id='container_{{ guid }}' class='form-group'>",
								"<label control_label='contactattr_name' for='{{ guid }}' class='required'><%=_T('Name')%>:</label>",
								"<input id='{{ guid }}' control='contactattr_name' class='form-control' type='text'  />",
								"<i validation='contactattr_name' class='formFieldValidation formFieldError' hidden style='display: none;'></i>",
							"</div>",
						"</div>",
					"</div>",
					"<div form_row class='row'>",
						"<div form_row class='col-12'>",
							"<div id='container_{{ guid }}' class='form-group'>",
								"<label control_label='contactattr_value' for='{{ guid }}' class='required'><%=_T('Value')%>:</label>",
								"<span class='ic_variable_icon_container'>",
									"<input id='{{ guid }}' control='contactattr_value' control='contactattr_value' class='form-control' type='text'>",
									"<i variable_icon='' class='ic_variable_icon far fa-at' title='<%=_T('Enter a variable or an expression')%>'></i>",
								"</span>",
								// "<input id='{{ guid }}' control='contactattr_value' class='form-control' type='text' />",
								"<i validation='contactattr_value' class='formFieldValidation formFieldError' hidden style='display: none;'></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
				"<div class='InternalpopOverButtons justify-content-end'>",
					"<button contactattr_action='cancel' class='pageButtonGeneric buttonColorWhite' type='button'>Cancelar</button><button contactattr_action='save' class='pageButtonGeneric buttonColorBlue' type='button'>Ok</button>",
				"</div>",
			"</div>",
		"</div>",
	),
	
	dialer_batch_priority_type_radiobuttons: "".concat( 
		"<div priorityRadioButtons class='form-group' style='display:none;'>",
			"<label class='required'><%=_T('Select type of priority')%>:</label>",
			"<div class='d-flex flex-row flex-wrap' control='priority_type' radiobuttonlist=''>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_absolute' class='form-radiobutton-label'>",
						"<input type='radio' control='priority_type_absolute' name='priority_type' value='priority_absolute' id='{{ guid }}_absolute' class='form-radiobutton-input'>",
						"<span><%=_T('Absolute priority')%></span>",
					"</label>",
				"</div>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_relative' class='form-radiobutton-label'>",
						"<input type='radio' control='priority_type_relative' name='priority_type' value='priority_relative' id='{{ guid }}_relative' class='form-radiobutton-input'>",
						"<span><%=_T('Relative priority')%></span>",
					"</label>",
				"</div>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_incremental' class='form-radiobutton-label'>",
						"<input type='radio' control='priority_type_incremental' name='priority_type' value='incremental' id='{{ guid }}_incremental' class='form-radiobutton-input'>",
						"<span><%=_T('Incremental number')%></span>",
					"</label>",
				"</div>",
			"</div>",
		"</div>"
	),

	dialer_batch_scoring_slider: "".concat( 	
		"<div class='scoringCodeSizeContainer priorityRelativeSlider'>",
			"<div control='priority_relativeNumber' id='{{ guid }}' class='scoringCodeSize ui-slider ui-corner-all ui-slider-horizontal ui-widget ui-widget-content'>",
				
				"<div control='priority_relativeNumber_handle' class='ui-slider-handle ui-corner-all ui-state-default' tabindex='0' style='left: 50%;'></div>",
				
				"<div class='ui-slider-range ui-corner-all ui-widget-header ui-slider-range-min' ></div>",
				
			"</div>",
			"<input type='text' control='priority_relativeNumber_input' class='ui-slider-scoring-input-value' hidden=''>",
			"<ul class='scoringCodeSizeContainer_list_labels'>",
				"<li>-100</li>",
				"<li>-90</li>",
				"<li>-80</li>",
				"<li>-70</li>",
				"<li>-60</li>",
				"<li>-50</li>",
				"<li>-40</li>",
				"<li>-30</li>",
				"<li>-20</li>",
				"<li>-10</li>",
				"<li>0</li>",
				"<li>10</li>",
				"<li>20</li>",
				"<li>30</li>",
				"<li>40</li>",
				"<li>50</li>",
				"<li>60</li>",
				"<li>70</li>",
				"<li>80</li>",
				"<li>90</li>",
				"<li>100</li>",
			"</ul>",
		"</div>"
	),

	sms_whatsapp_radiobuttons: "".concat( 
		"<div smsWhatsapp class='form-group'>",
			"<div class='d-flex flex-row flex-wrap' control='message_type' radiobuttonlist=''>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_sms' class='form-radiobutton-label'>",
						"<input type='radio' control='message_type_sms' name='message_type' value='message_type_sms' id='{{ guid }}_sms' class='form-radiobutton-input'>",
						"<span><%=_T('SMS')%></span>",
					"</label>",
				"</div>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_whatsapp' class='form-radiobutton-label'>",
						"<input type='radio' control='message_type_whatsapp' name='message_type' value='message_type_whatsapp' id='{{ guid }}_whatsapp' class='form-radiobutton-input'>",
						"<span><%=_T('Whatsapp')%></span>",
					"</label>",
				"</div>",
			"</div>",
		"</div>"
	),

	knowledge_fusion_max_character_radiobuttons: "".concat(
		"<div maxCharacters style='display: none;' class='form-group'>",
			"<div class='d-flex flex-row flex-wrap' control='max_characters' radiobuttonlist=''>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_standard' class='form-radiobutton-label'>",
						"<input type='radio' control='max_characters_standard' name='max_characters' value='max_characters_standard' id='{{ guid }}_standard' class='form-radiobutton-input'>",
						"<span><%=_T('Standard')%>: 75 <%=_T('words')%></span>",
					"</label>",
				"</div>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_short' class='form-radiobutton-label'>",
						"<input type='radio' control='max_characters_short' name='max_characters' value='max_characters_short' id='{{ guid }}_short' class='form-radiobutton-input'>",
						"<span><%=_T('Short')%>: 15 <%=_T('words')%></span>",
					"</label>",
				"</div>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_long' class='form-radiobutton-label'>",
						"<input type='radio' control='max_characters_long' name='max_characters' value='max_characters_long' id='{{ guid }}_long' class='form-radiobutton-input'>",
						"<span><%=_T('Long')%>: 150 <%=_T('words')%></span>",
					"</label>",
				"</div>",
				"<div class='form-radiobutton'>",
					"<label for='{{ guid }}_custom' class='form-radiobutton-label'>",
						"<input type='radio' control='max_characters_custom' name='max_characters' value='max_characters_custom' id='{{ guid }}_custom' class='form-radiobutton-input'>",
						"<span><%=_T('Custom')%></span>",
					"</label>",
				"</div>",
			"</div>",
		"</div>"
	),

	knowledge_fusion_lorem_ipsum_words: "".concat(
		"<div loremIpsumDiv class='form-group mb-0'>",
			"<p class='flowDesignerFormCaption'><%=_T('Referencia ilustrativa de la cantidad de palabras:')%></p>",
			"<p loremIpsumWords></p>",
		"</div>"
	),

	popup_remove_button: "".concat(
		"<button remove id='{{ id }}' class='pageButtonGeneric buttonColorWhite iconOnlyBtn align-self-end' title='<%=_T('Delete')%>'>",
		"<i class='far fa-trash-alt'></i>"
	),

	popup_disclaimer_flex: "".concat(
        "<div disclaimer_flex class='inlineMessagesContainer messageInfo' {{ #hidden }} style='display:none;' {{ /hidden }}>{{ message }}</div>",
	),

	popup_div_flex: "".concat( 
		"<div form_row {{ #idAux }}id='{{ idAux }}'{{ /idAux }} {{ #persoTags }}{{ persoTags }}{{ /persoTags }} {{ #class }}class='{{ class }}'{{ /class }} {{ #style }} style='{{ style }}' {{ /style }}{{ #hidden }}hidden{{ /hidden }} >",
			"{{ #content }}{{ content }}{{ /content }}",
		"</div>"
	),
	popup_row_flex: "".concat( 
		"<div class='row' {{ #hidden }}hidden{{ /hidden }}>",
			"<div form_row {{ #class }}class='{{ class }}'{{ /class }}>",
			"</div>",	
		"</div>"
	),
	
	popup_row_50: "".concat( 
		"<div form_row class='formRow50' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
	),
	popup_row_49: "".concat( 
		"<div form_row class='formRow49' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
	),
	popup_row_33: "".concat( 
		"<div form_row class='formRow33' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
	),
	popup_row_34: "".concat( 
		"<div form_row class='formRow34' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
	),
	popup_row_flex2: "".concat( 
		"<div form_row class='formRowFlex2' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
    ),
	popup_row_group: "".concat(
		"<div form_row class='formRowGroup' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
	),
	popup_row_group_checkboxs: "".concat(
		"<div form_row class='formRowGroupCheckboxsContainer formDataNFD'>",
			"<label class='formLabelNFD'>{{ title }}:</label>",
			"<div ic-role='form-row' class='formRowGroupCheckboxs' {{ #hidden }}hidden{{ /hidden }}>",
			"</div>",
		"</div>"
	),
	popup_row_mail_editor: "".concat( 
		"<div form_row class='form-group formGroupMailEditor' {{ #hidden }}hidden{{ /hidden }}>",
		"</div>"
	),
	popup_control_text_flex: "".concat( 
		"<input id='{{ guid }}' control='{{ id }}' class='form-control' type='text' {{ #placeholder }}placeholder='{{ placeholder }}'{{ /placeholder }} {{ #maxLength }}maxlength='{{ maxLength }}'{{ /maxLength }} />",
	),
	popup_control_combo_flex: "".concat( 
		"<select id='{{ guid }}' control='{{ id }}' class='form-control' {{ #multiple }} multiple {{ /multiple }} name='{{ selectName }}'>",
			"{{{ options_list }}}",
		"</select>"
	),

	popup_separator: "".concat(
		"<hr>"
	),
	tab_element: "".concat( 
		"<li tab_id={{ id }} class='nav-item'>",
			"<a class='nav-link active' id='configuration-tab' data-toggle='tab' href='#configuration' role='tab' aria-controls='configuration' aria-selected='true'>",
				"<%=_T('Configuration')%>",
			"</a>",
		"</li>"
	),
	//TEMPLATES
	template_overview_item: "".concat(
		"<div class='process_flow_template_overview_item_container'>",
			"<div class='process_flow_template_overview_item_icon'>",
			"<img src='{{icon.icon_64}}'/>",
			"</div>",
			"<div class='process_flow_template_overview_item_body'>",
			"<div class='process_flow_template_overview_item_title'>",
			"{{name}}",
			"</div>",
			"<div class='process_flow_template_overview_item_description'>",
			"{{description}}",
			"</div>",
			"<button id='process_flow_template_overview_{{category}}_{{id}}_button' class='pageButtonGeneric buttonColorBlue'>" + "<%=_T('Configure')%>" + "</button>",
			"</div>",
        "</div>"
    ),
    template_overview_category: "".concat(
        "<div class='process_flow_template_overview_category_container'>",
        // "<div class='process_flow_template_overview_category_header'>",
        // "<div class='process_flow_template_overview_category_icon'>",
        // "<img src='{{icon.icon_24}}'/>",
        // "</div>",
        // "<div class='process_flow_template_overview_category_title'>",
        // "{{name}}",
        // "</div>",
        // "</div>",
        "<div id='{{id}}_templates_container' class='process_flow_template_overview_category_templates_parent'>",
        "</div>",
        "</div>"
    ),
    template_list_no_result: "".concat(
        "<span><%=_T('Not found.')%></span>"
    ),
    template_list_lock: "".concat(
        "<div class='adm_for_process_flow_wizard_step_loading'><span><%=_T('Loading...')%></span></div>"
    ),
    template_package_item: "".concat(
        "<div id='process_flow_template_package_{{category}}_{{id}}' class='process_flow_template_package'>",
        "<span>{{lang}}</span>",
        "</div>"
    ),
    template_wizard_template_popup: "".concat(
        '<div class="internalPopUpContainer processFlowPopup formPopUp popUp520w">',
        '<div class="internalPopUpOverlay"></div>',
        '<div class="internalPopUp">',
        // title
        '<div class="internalPopUpTitle">',
        '<span><%=_T("Downloading template")%></span>',
        //'<button style="display:none" id="adm_form_process_flow_wizard_cancel" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
        '</div>',

        '<div id="adm_for_process_flow_wizard_steps_container" class="internalPopUpMiddle pageFormContainer">',
		'<div class="card no-card">',
		'<div class="card-block">',
			// mensaje de error
			'<div id="adm_form_process_flow_new_message" class="genericFormMessagesContainer messageError" style="display:none;"></div>',
			'<div class="adm_for_process_flow_wizard_step_loading_animation"></div>',
		'</div>',
		'</div>',
        '</div>',
        // MODAL FOOTER BUTTONS
        '<div id="adm_for_process_flow_wizard_steps_actions" style="display:none" class="internalPopUpButtons">',
        "<button id='adm_for_process_flow_wizard_steps_cancel' class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>",
		"<button id='adm_for_process_flow_wizard_steps_retry' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Retry')%>" + "</button>",
        '</div>',
        '</div>',
        '</div>'
    ),
    template_wizard_template_popup_step: "".concat(
        '<div id="adm_form_process_flow_wizard_step_{{action}}">',
        '<p>{{description}}</p>',
        '<div id="adm_form_process_flow_wizard_step_error_{{action}}" class="genericFormMessagesContainer messageError" style="display:none;"></div>',
        '<div id="adm_form_process_flow_wizard_step_form_{{action}}" class="" style="display:none;"></div>',
        '</div>'
    ),
    template_wizard_template_popup_step_form_publish_luis_app: "".concat(
        '<div class="row">',
        '<div class="col-6">',
        '<div class="form-group">',
        '<label for="adm_form_process_flow_wizard_step_form_publish_luis_endpoint" class="required"><%=_T("Endpoint Key")%><%=_T(":")%></label>',

        '<select id="adm_form_process_flow_wizard_step_form_publish_luis_endpoint" class="form-control"></select>',
        '<i id="adm_form_process_flow_wizard_step_form_publish_luis_endpoint_validation" class="formFieldValidation formFieldError" hidden></i>',
        '</div>',
        '</div>',
        '<div class="col-6">',
        '<div class="form-group">',
        '<label for="adm_form_process_flow_wizard_step_form_publish_luis_timezone" class="required"><%=_T("Timezone")%><%=_T(":")%></label>',
        '<select id="adm_form_process_flow_wizard_step_form_publish_luis_timezone" class="form-control"></select>',
        '<i id="adm_form_process_flow_wizard_step_form_publish_luis_timezone_validation" class="formFieldValidation formFieldError" hidden></i>',
        '</div>',
        '</div>',
        '</div>',

        '<div class="row">',
        '<div class="form-group">',
        '<div class="form-check">',
        '<label for="adm_form_process_flow_wizard_step_form_publish_luis_verbose" class="form-check-label">',
        '<input id="adm_form_process_flow_wizard_step_form_publish_luis_verbose" class="form-check-input" type="checkbox" checked="true" />',
        '<%=_T("Add Verbose Flag")%>',
        '</label>',
        '</div>',
        '</div>',
        '</div>',
        '<div id="adm_form_process_flow_wizard_step_form_publish_luis_confirm_container" class="internalPopUpButtons">',
        "<button id='adm_form_process_flow_wizard_step_form_publish_luis_confirm' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
        '</div>',

    ),
    template_wizard_template_popup_step_form_create_KB: "".concat(
        '<div class="row">',
        '<div class="col-6">',
        '<div class="form-group">',
        '<label for="adm_form_process_flow_wizard_step_form_create_KB_name" class="required"><%=_T("Name")%><%=_T(":")%></label>',

        '<input id="adm_form_process_flow_wizard_step_form_create_KB_name" type="text" class="form-control required" placeholder="<%=_T("Enter name")%>..."></input>',
        '<i id="adm_form_process_flow_wizard_step_form_create_KB_name_validation" class="formFieldValidation formFieldError" hidden></i>',
        '</div>',
        '</div>',
        '</div>',
        '<div id="adm_form_process_flow_wizard_step_form_create_KB_confirm_container" class="internalPopUpButtons">',
        "<button id='adm_form_process_flow_wizard_step_form_create_KB_confirm' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
        '</div>'

    ),
    template_wizard_template_popup_step_form_publish_qna: "".concat(
		'<div class="row">',
		'<div class="col-11 mx-auto px-1">',
		'<hr class=""/>',
        '</div>',
		'</div>',
        '<div class="row">',
		'<div class="col-12">',
        '<div class="form-group">',
        '<div class="form-check">',
        '<label for="template_wizard_template_popup_step_form_publish_qna_check" class="form-check-label">',
        '<input id="template_wizard_template_popup_step_form_publish_qna_check" class="form-check-input" type="checkbox" checked="true" />',
        '<%=_T("Publish QnA after install")%>',
        '</label>',
        '</div>',
        '</div>',
        '</div>',
		'</div>',
        '<div id="template_wizard_template_popup_step_form_publish_qna_confirm_container" class="internalPopUpButtons">',
        "<button id='template_wizard_template_popup_step_form_publish_qna_confirm' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
        '</div>'

    ),
    generator_base: "".concat(`
        <div id="flowGeneratorContainer" class="pageContainer skinOCCNew">
            <div class="pageHeader">
                <div class="pageTitleContainer">
                    <i id="conf_flow_designer_view_item_img" class="far fa-robot"></i>
                    <label id="flow_designer_view_title" class="pageTitle"><%=_T("New Workflow")%></label>
                </div>
                <button from_scratch id="flow_designer_view_button_new" class="pageButtonGeneric buttonColorOrange pageButtonNew adm_form_process_flow_generator_header_button adm_form_process_flow_generator_header_button_from_scratch"  type="button" hidden="" value="from Scratch"><%=_T("Create from Scratch")%></button>
                <button close_button id="view_button_datasources" class="pageButtonGeneric pageButtonNew buttonColorWhite adm_form_process_flow_generator_header_button" type="button" hidden="" value="Cancel"><%=_T("Cancel")%></button>
            </div>
            <div id="flow_designer_view_generator_page_content" class="pageContent">
            </div>
        </div>
        `
    ),
    generator_content: "".concat(`
        <div class="row adm_form_process_flow_generator_header">
			<div id="adm_form_process_flow_generator_filter_container" class="pageViewFilter frmPaginatorFilter adm_form_process_flow_generator_search">
                <input id="adm_form_process_flow_generator_filter_text" class="filterField" type="text" placeholder="<%=_T("Search")%><%=_T("...")%>" value="">
                <button id="adm_form_process_flow_generator_filter_cancel_button" class="buttonToggle reset" type="button" style="display:none;">
                    <i class="far fa-times"></i>
                </button>
                <button id="adm_form_process_flow_generator_filter_button" class="buttonToggle buttonToggleOutlined search" type="button">
                    <i class="far fa-search"></i>
                </button>
            </div>
            <div class="form-group adm_form_process_flow_generator_form_group_inline">
                <label for="adm_form_process_flow_generator_type"> <%=_T("Type")%><%=_T(":")%></label>
                <select id="adm_form_process_flow_generator_type" class="form-control"></select>
                <i id="adm_form_process_flow_generator_type_validator" class="formFieldValidation formFieldError" hidden></i>
            </div>
            <div class="form-group adm_form_process_flow_generator_form_group_inline">
                <label for="adm_form_process_flow_generator_category"> <%=_T("Category")%><%=_T(":")%></label>
                <select id="adm_form_process_flow_generator_category" class="form-control"></select>
                <i id="adm_form_process_flow_generator_category_validator" class="formFieldValidation formFieldError" hidden></i>
            </div>
            <div class="form-group adm_form_process_flow_generator_form_group_inline">
                <label for="adm_form_process_flow_generator_orderby"> <%=_T("Order By")%><%=_T(":")%></label>
                <select id="adm_form_process_flow_generator_orderby" class="form-control"></select>
                <i id="adm_form_process_flow_generator_orderby_validator" class="formFieldValidation formFieldError" hidden></i>
            </div>
        </div>
        <div id="adm_form_process_flow_generator_catalog">
            
        </div>
        <div id="flow_designer_view_generator_paginator_container" class="pg-main-container">
            
        </div>
	`),
    generator_pagination_content: "".concat(`
        <div class="pg-buttons-container">
            <a id="flow_designer_view_paginator_prev" class="pg-button pg-button-prev pg-button-disabled"></a>
            <a  class="pg-button pg-button-page pg-button-current" page-number="{{offset}}">{{offset}}</a>
            <a id="flow_designer_view_paginator_next" class="pg-button pg-button-next pg-button-disabled"></a>
        </div>
        <div class="pg-display-text">
            <span>{{offset}} <%=_T("From")%> {{pages}}</span>
        </div>
	`),
    template_wizard_popup_configuration: "".concat(
			'<div class="internalPopUpContainer processFlowPopup formPopUp popUp380w">',
			'<div class="internalPopUpOverlay"></div>',
			'<div class="internalPopUp">',
			// title
			'<div class="internalPopUpTitle">',
			'<span><%=_T("New Workflow")%></span>',
			// '<button id="adm_form_process_flow_cancel_times" class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
			'</div>',

			//
			'<div class="internalPopUpMiddle pageFormContainer">',
			// mensaje de error
			'<div id="adm_form_process_flow_new_message" class="genericFormMessagesContainer messageError" style="display:none;"></div>',

			// text inputs
			'<div class="card no-card">',
			'<div class="card-block">',
			'<div class="row">',
			'<div class="col-12">',
			'<div class="form-group">',
			'<label for="adm_form_process_flow_name" class="required"> <%=_T("Name")%><%=_T(":")%></label>',
			'<input id="adm_form_process_flow_name" class="form-control" type="text" placeholder="', '<%=_T("Enter name")%>...', '" />',
			'<i id="adm_form_process_flow_name_validation" class="formFieldValidation formFieldError" hidden></i>',
			'</div>',
			'</div>',
			'</div>',
			'<div class="row">',
			'<div class="col-12">',
			'<div class="form-group">',
			'<label for="adm_form_process_flow_description" class="required"> <%=_T("Description")%><%=_T(":")%></label>',
			'<input id="adm_form_process_flow_description" class="form-control" type="text" placeholder="', '<%=_T("Enter description")%>...', '" />',
			'<i id="adm_form_process_flow_description_validation" class="formFieldValidation formFieldError" hidden></i>',
			'</div>',
			'</div>',
			'</div>',
			'<div class="row">',
			'<div class="col-12">',
			'<div class="form-group">',
			'<label for="adm_form_process_flow_package" class="required"> <%=_T("Language")%><%=_T(":")%></label>',
			'<select id="adm_form_process_flow_package" class="form-control"></select>',
			'<i id="adm_form_process_flow_package_validation" class="formFieldValidation formFieldError" hidden></i>',
			'</div>',
			'</div>',
			'</div>',
			'</div>',
			'</div>',
			'</div>',

			// MODAL FOOTER BUTTONS
			'<div class="internalPopUpButtons">',
			"<button id='adm_form_process_flow_cancel' class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>",
			"<button id='adm_form_process_flow_open' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
			'</div>',
			'</div>',
			'</div>'),
		
		http_restfull_tabs:`
			<ul class="nav nav-tabs" id="tabs-restfull" role="tablist">
                <li class="nav-item">
                    <a class="nav-link active" id="flow_designer_http_api_restfull_request_tab-link" data-toggle="tab" href="#flow_designer_http_api_restfull_request_tab" role="tab" aria-controls="flow_designer_http_api_restfull_request_tab" aria-selected="true"><%=_T([[Request]])%></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="flow_designer_http_api_restfull_response_tab-link" data-toggle="tab" href="#flow_designer_http_api_restfull_response_tab" role="tab" aria-controls="flow_designer_http_api_restfull_response_tab" aria-selected="false"><%=_T([[Response]])%></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" id="flow_designer_http_api_restfull_ports_tab-link" data-toggle="tab" href="#flow_designer_http_api_restfull_ports_tab" role="tab" aria-controls="flow_designer_http_api_restfull_ports_tab" aria-selected="false"><%=_T([[Outputs]])%></a>
                </li>
            </ul>

            <div class="tab-content" id="tabContent-restfull">
                <div class="tab-pane fade show active" id="flow_designer_http_api_restfull_request_tab" role="tabpanel" aria-labelledby="flow_designer_http_api_restfull_request_tab-link"></div>
                <div class="tab-pane fade" id="flow_designer_http_api_restfull_response_tab" role="tabpanel" aria-labelledby="flow_designer_http_api_restfull_response_tab-link"></div>
                <div class="tab-pane fade" id="flow_designer_http_api_restfull_ports_tab" role="tabpanel" aria-labelledby="flow_designer_http_api_restfull_ports_tab-link"></div>
            </div>`
		,
		http_restfull_metadata_input: `
			<div field  class="card no-card">
				<div class="card-block">
					<div class="row">
						<div class="col-12">
							<div class="card-header d-flex justify-content-between">
								<h5><%=_T([[General configuration]])%></h5>
							</div>
						</div>
						<div class="col-4">
							<div class="form-group">
								<label for="flow_designer_http_restful_method_type" class="required"><%=_T([[Method Type:]])%></label>
								<select field_method id="flow_designer_http_restful_method_type" class="form-control">
								</select>
							</div>
						</div>
						<div class="col-8">
							<div class="form-group">
								<label for="flow_designer_http_restful_port" class="required"><%=_T([[Define port (URL / Key)]])%><%=_T([[:]])%></label>
								<input field_url id="flow_designer_http_restful_port" class="form-control" type="text" placeholder="" />
							</div>
						</div>
					</div>
				</div>
			</div>`
		,
		http_restfull_tab_ports: `
			<div class="card no-card">
				<div class="card-block">
					<div class="row">
						<div class="col-12">
							<div class="form-group">
								<label for="flow_designer_httpRestfull_status_result_field" class="required"><%=_T([[Variable for response status]])%><%=_T([[:]])%></label>
								<input status_field type='text' id='flow_designer_httpRestfull_status_result_field' class='form-control flex-grow-1'>
							</div>
						</div>
					</div>
					<div class="card-header">
						<h5><%=_T([[Output ports]])%></h5>
						<button add_new_port class="btn buttonIconAndText"><span class="far fa-plus"></span><%=_T([[Add output]])%></button>
					</div>
				</div>
			</div>
			<div class="card no-card scrollable-card">
				<div class="card-block">
					<div ports_container>
					</div>
					<div class="row">
						<div class="col-12">
							<div disclaimer class="inlineMessagesContainer messageInfo inlineMessageDismissable"><%=_T([[Drag & Drop the items to be used at each port]])%> <a close_message class="genericMessagesClose"></a></div>
							<div class="inlineMessagesContainer messageWarning mb-0"><%=_T([[Unspecified states will be routed to the default error output]])%></div>
						</div>
					</div>
				</div>
			</div>`
		,
		http_restfull_port_field: `
			<div field ic-restfull-port-id="{{id}}" class="flowDesignerOutputPortsContainer">
				<div class="row">
					<div class="col-12 flowDesignerOutputDescription">
						<div class="form-group d-flex flex-row">
							<input field_name class="form-control mt-0" type="text">
							<button delete class="pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn">
								<i class="far fa-trash-alt"></i>
							</button>
						</div>
					</div>
					<div class="col-12 flowDesignerOutputPortsList">
						<div class="formDragListContainer">
							<ul status_list class='portsList formList ui-sortable'>										
							</ul>
							<button add class="btn buttonIconAndText">
								<span class="far fa-plus m-0"></span>
							</button>
						</div>
					</div>
				</div>
			</div>`
		,
		http_restfull_port_status: `
			<li template class='flowDesignerOutputPortsListItem'>
				<div class='form-group mb-0'>
					<input field_status type='number' min='100' max='599' class='formField flowDesignerRestfullPortStatusInput'>
				</div>
				<button delete_status class="flowDesignerButtonIcon flowDesignerRestfullPortStatusDeleteButton" title="<%=_T([[Delete]])%>">
					<i class="far fa-times"></i>
				</button>
			</li>`
		,
		http_restfull_metadata_request_header: `
			<div new_request_header class="row add_new_request_header">
				<div class="col-4">
					<div class="form-group">
						<label for="flow_designer_req_header_name_1" class="required"><%=_T([[Header]])%><%=_T([[:]])%></label>
						<select select_header id="flow_designer_req_header_name_1" class="form-control">
						</select>
						<input input_custom_header id="flow_designer_req_header_custom_name" placeholder="<%=_T([[Enter value]])%>" class="form-control flex-grow-1" style="display:none">
					</div>
				</div>
				<div class="col-8 d-flex flex-row">
					<div class="form-group d-flex align-items-end">
						<span class="flow_designer_input_span">=</span>
					</div>
					<div class="form-group flex-grow-1">
						<label for="flow_designer_req_header_name_value_1" class="required"><%=_T([[Value]])%><%=_T([[:]])%></label>
						<input input_header id="flow_designer_req_header_name_value_1" placeholder="<%=_T([[Enter value]])%>" class="form-control flex-grow-1">
					</div>
					<div class="form-group d-flex align-items-end">
						<button delete_header id="flow_designer_req_header_delete_1" class="pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn align-self-end" title="<%=_T([[Delete]])%>">
							<i class="far fa-trash-alt"></i>
						</button>
					</div>
				</div>
			</div>`
		,
		http_restfull_metadata_query_parameters: `
			<div new_query_parameters class="row add_new_query_parameters">
				<div class="col-4">
					<div class="form-group">
						<label for="flow_designer_query_parameter_name_1" class="required"><%=_T([[Parameter]])%><%=_T([[: ]])%></label>
						<input input_parameters id="flow_designer_query_parameter_name_value_1" placeholder="<%=_T([[Enter Parameter]])%>" class="form-control flex-grow-1">
					</div>
				</div>
				<div class="col-8 d-flex flex-row">
					<div class="form-group d-flex align-items-end">
						<span class="flow_designer_input_span">=</span>
					</div> 
					<div class="form-group flex-grow-1">
						<label for="flow_designer_query_parameter_name_value_1" class="required"><%=_T([[Value]])%><%=_T([[:]])%></label>
						<input input1_parameters id="flow_designer_query_parameter_name_value_1" placeholder="<%=_T([[Enter value]])%>" class="form-control flex-grow-1">
					</div>
					<div class="form-group d-flex align-items-end">
						<button delete_parameters id="flow_designer_query_parameter_delete_1" class="pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn align-self-end" title="<%=_T([[Delete]])%>">
							<i class="far fa-trash-alt"></i>
						</button>
					</div>
				</div>
			</div>`
		,
		http_restfull_metadata_mapping_parameters: "".concat(
			'<div new_mapping_parameter class="row add_new_mapping_parameters">',
				'<div class="col-4">',
					'<div class="form-group">',
						'<label for="flow_designer_mapping_parameter_variable" class="required"><%=_T([[Variable]])%><%=_T([[: ]])%></label>',
						'<input input_variable id="flow_designer_mapping_parameter_variable" placeholder="<%=_T([[Enter Variable]])%>" class="form-control flex-grow-1">',
					'</div>',
				'</div>',
				'<div class="col-8 d-flex flex-row">',
					'<div class="form-group d-flex align-items-end">',
						'<span class="flow_designer_input_span">=</span>',
					'</div> ',
					'<div class="form-group flex-grow-1">',
						'<label for="flow_designer_mapping_parameter_path" class="required"><%=_T([[Path]])%><%=_T([[:]])%></label>',
						'<input input_path id="flow_designer_mapping_parameter_path" placeholder="<%=_T([[Enter value]])%>" class="form-control flex-grow-1" disabled>',
					'</div>',
					'<div class="form-group d-flex align-items-end">',
						'<button delete_parameters id="flow_designer_mapping_parameter_delete_1" class="pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn align-self-end" title="<%=_T([[Delete]])%>">',
							'<i class="far fa-trash-alt"></i>',
						'</button>',
					'</div>',
				'</div>',
			'</div>',
		),
		http_restfull_request_card: `
			<div class="card no-card scrollable-card">
				<div class="card-block">
					<hr>
					<div class="row clase">
						<div class="col-12">
							<div class="card-header d-flex justify-content-between">
								<h5><%=_T([[Request headers]])%>
								</h5>
								<button add_new_request_header class="btn buttonIconAndText"><span class="far fa-plus"></span><%=_T([[Add header]])%></button>
							</div>
						</div>
					</div>
					<hr>
					<div class="row">
						<div class="col-12">
							<div class="card-header d-flex justify-content-between">
								<h5><%=_T([[Query parameters]])%>
								</h5>
								<button add_new_query_parameters class="btn buttonIconAndText"><span class="far fa-plus"></span><%=_T([[Add parameter]])%></button>
							</div>
						</div>
					</div>
					<hr body_parameters_separator style="display:none">
					<div body_parameters_container style="display:none">
						
						<div class="card-header d-flex justify-content-between">
							<h5><%=_T([[Request Body]])%>
							</h5>

							<div class="form-group mb-0 flex-row" flow_designer_http_api_body_request_type_radio_set>
								<div class="form-radiobutton">
									<label for="flow_designer_http_api_body_request_text_type_radio" class="form-radiobutton-label">
										<input type="radio" id="flow_designer_http_api_body_request_text_type_radio" name="Type" value="text" checked class="form-radiobutton-input">
										<span><%=_T([[Text]])%></span>
									</label>
								</div>
								<div class="form-radiobutton">
									<label for="flow_designer_http_api_body_request_form_type_radio" class="form-radiobutton-label mr-0">
										<input type="radio" id="flow_designer_http_api_body_request_form_type_radio" name="Type" value="form" checked class="form-radiobutton-input">
										<span><%=_T([[Form]])%></span>
									</label>
								</div>
							</div>
						</div>

						<div body_parameters_type_form_btn class="card-header d-none">
							<button add_new_body_parameter class="btn buttonIconAndText"><span class="far fa-plus"></span><%=_T([[Add parameter]])%></button>
						</div>

						<div class="row">
							<div class="col-12">
								<div id="select_content_type_body_parameters_container" class="form-group">
									<label for="flow_designer_activity_restfull_body_parameters_type"><%=_T([[Body Format]])%><%=_T([[:]])%></label>
									<select select_content_type_body_parameters id="flow_designer_activity_restfull_body_parameters_type" class="form-control">
										<option>json</option>
										<option>xml/html</option>
										<option>plain</option>
									</select>
								</div>
								<div id="flow_designer_add_http_api_body_request_parameters_container" class="flowDesignerClassesTreeViewCode flowDesignerCodeBlock ace_editor ace-tm">
								</div>
								<div id="flow_designer_add_http_api_code_block_container" class="flowDesignerCodeBlockContainer">
									<div code_block class="flowDesignerCodeBlock mb-0 flowDesignerClassesTreeViewCode ace_editor ace-tm">
									</div>
								</div>

							</div>
						</div>
					</div>
					
				</div>
			</div>`
		,
		http_restfull_response_card: `
			<div class="card no-card">
				<div class="card-block" >
					<div class="card-header d-flex justify-content-between">
						<h5><%=_T([[Map response with variables]])%></h5>
						<button class="btn buttonIconAndText"></button>
						<div class="dropdown">
							<button class="btn buttonIconAndText dropdown-toggle" type="button" id="dropdownAddAnswer" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
								<span class="far fa-plus"></span><%=_T([[Update mapping]])%>
							</button>
							<div class="dropdown-menu" aria-labelledby="dropdownAddAnswer">
								<a add_answer_http_response class="dropdown-item" ><%=_T([[Using HTTP response]])%></a>
								<a add_answer_json_example class="dropdown-item"><%=_T([[Using JSON example]])%></a>
								<a add_answer_manually class="dropdown-item" ><%=_T([[Enter manually]])%></a>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="card no-card scrollable-card">
				<div response_mapping_parameters class="card-block" >
				</div>
			</div>`
		,
		http_restfull_metadata: `
			<div class='formRow flowDesignerrHttpRestfullMetadataFieldsContainer'>
				<div fields>
				</div>
			</div>`
		,
		http_restfull_authorization_request_popup: `
			<div id="flowDesignerPopup_req" class="internalPopUpContainer formPopUp flowDesignerPopUpContainer flowDesignerPopupRestfulHTTP popUp520w" >
			<div class="internalPopUpOverlay"></div>
			<div class="internalPopUp">
				<div class="internalPopUpTitle">
					<label> <%=_T([[Map response with variables using real http response]])%> </label>
				</div>
				<div message_container class="genericFormMessagesContainer messageError" style="display:none">
					<label message_text></label>
				</div>
				<div class="internalPopUpMiddle pageFormContainer flowDesignerPopupContent flowDesignerRestfulHTTP infoConfigModal">
					<div class="card no-card">
						<div class="card-block">
							<div class="row">
								<div class="col-12">
									<p><%=_T([[It’s required to make an HTTP request to visualize the API response and permit mapping local variables]])%></p>
								</div>
							</div>
							
							<div class="row">
								<div class="col-12">
									<h5><%=_T([[General Configuration]])%></h5>
									<p class="ic-text-description"><strong><%=_T([[Method]])%>:</strong> {{method}}</p>
									<p class="ic-text-description"><strong><%=_T([[URL]])%>:</strong> {{url}}</p>
								</div>
							</div>
							<div variable_inputs_container>
							</div>
						</div>
					</div>
				</div>
		
				<div class="internalPopUpButtons justify-content-end">
					<button id="btn_cancel" class="pageButtonGeneric buttonColorWhite" type="button">
						<%=_T([[Cancel]])%>
					</button>
					<button id="btn_openPopupResponse" action="" class="pageButtonGeneric buttonColorBlue" type="button">
						<%=_T([[Make Request]])%>
					</button>
				</div>
		
			</div>
		</div>
		`,
		http_restfull_authorization_variable_input: `
			<div http_restfull_authorization_variable class="row">
				<div class="col-4">
					<div class="form-group">
						<label for="flow_designer_http_request_authorization_variable_key" class="required"><%=_T([[Parameter]])%><%=_T([[: ]])%></label>
						<input input_authorization_variable_key id="flow_designer_http_request_authorization_variable_key" placeholder="<%=_T([[Enter Parameter]])%>" disabled="true" class="form-control flex-grow-1">
					</div>
				</div>
				<div class="col-8 d-flex flex-row">
					<div class="form-group d-flex align-items-end">
						<span class="flow_designer_input_span">=</span>
					</div> 
					<div class="form-group flex-grow-1">
						<label for="flow_designer_http_request_authorization_variable_value" class="required"><%=_T([[Value]])%><%=_T([[:]])%></label>
						<input input_authorization_variable_value id="flow_designer_http_request_authorization_variable_value" placeholder="<%=_T([[Enter value]])%>" class="form-control flex-grow-1">
					</div>
				</div>
			</div>
		`,
		http_restfull_bodyRequest_form_type_variable_input: `
			<div http_restfull_request_body_form_type_variable class="row">
				<div class="col-4">
					<div class="form-group">
						<label for="flow_designer_http_request_request_body_form_type_variable_key" class="required"><%=_T([[Parameter]])%><%=_T([[: ]])%></label>
						<input input_request_body_form_type_variable_key id="flow_designer_http_request_request_body_form_type_variable_key" placeholder="<%=_T([[Enter Parameter]])%>" class="form-control flex-grow-1">
					</div>
				</div>
				<div class="col-8 d-flex flex-row">
					<div class="form-group d-flex align-items-end">
						<span class="flow_designer_input_span">=</span>
					</div> 
					<div class="form-group flex-grow-1">
						<label for="flow_designer_http_request_request_body_form_type_variable_value" class="required"><%=_T([[Value]])%><%=_T([[:]])%></label>
						<input input_request_body_form_type_variable_value id="flow_designer_http_request_request_body_form_type_variable_value" placeholder="<%=_T([[Enter value]])%>" class="form-control flex-grow-1">
					</div>
					<div class="form-group d-flex align-items-end">
						<button delete_parameter class="pageButtonGeneric buttonColorWhite iconOnlyBtn flow_designer_icon_btn align-self-end" title="<%=_T([[Delete]])%>">
							<i class="far fa-trash-alt"></i>
						</button>
					</div>
				</div>
			</div>`
		,
		http_restfull_preview_mapping_popup: `
		<div id="flowDesignerPopup_preview_mapping" class="internalPopUpContainer popUp520w formPopUp flowDesignerPopupRestful" >
			<div class="internalPopUpOverlay"></div>
			<div class="internalPopUp">		
				<div class="internalPopUpTitle">
					<label> <%=_T([[Mapping preview]])%> </label>				
				</div>
				<div class="internalPopUpMiddle pageFormContainer flowDesignerPopupContent flowDesignerRestfulHTTP infoConfigModal codeBlockModal">
					<div class="card no-card">
						<div class="card-block">
							<div class="row">
								<div class="col-12">
									<div id="flow_designer_add_http_api_code_block_container" class='flowDesignerCodeBlockContainer'>
										<div code_block class='flowDesignerCodeBlock mb-0 ace_editor ace-tm'>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="internalPopUpButtons justify-content-end">
					<button id="btn_AcceptPreview" action="" class="pageButtonGeneric buttonColorBlue" type="button">
						<%=_T([[Accept]])%>
					</button>
				</div>	
			</div>
		</div>
		`,
		http_restfull_manual_json_popup:`
		<div id="flowDesignerPopup_manual_JSON" class="internalPopUpContainer formPopUp flowDesignerPopUpContainer flowDesignerPopupRestfulHTTP popUp520w" >
		<div class="internalPopUpOverlay"></div>
		<div class="internalPopUp">		
			<div class="internalPopUpTitle">
				<label> <%=_T([[JSON Response Example]])%> </label>			
			</div>
			<div message_container class="genericFormMessagesContainer messageError" style="display:none">
				<label message_text></label>
			</div>
			<div class="internalPopUpMiddle pageFormContainer flowDesignerPopupContent flowDesignerRestfulHTTP infoConfigModal codeBlockModal">
				<div class="card no-card">
					<div class="card-block">
						<div class="row">
							<div class="col-12">
								<div id="flow_designer_add_http_api_code_block_container" class='flowDesignerCodeBlockContainer'>
									<div code_block class='flowDesignerCodeBlock mb-0 ace_editor ace-tm'>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
				<div class="internalPopUpButtons justify-content-end">
					<button id="btn_cancel_response" class="pageButtonGeneric buttonColorWhite" type="button">
						<%=_T([[Cancel]])%>
					</button>
					<button id="btn_AcceptJSONResponse" action="" class="pageButtonGeneric buttonColorBlue" type="button">
						<%=_T([[Accept]])%>
					</button>
				</div>
			</div>
		</div>
		`,
		http_restfull_response_popup: `
		<div id="flowDesignerPopup_response" class="internalPopUpContainer popUp520w formPopUp flowDesignerPopupRestful" >
		<div class="internalPopUpOverlay"></div>
		<div class="internalPopUp">		
			<div class="internalPopUpTitle">
				<label> <%=_T([[Map response with variables using HTTP response]])%> </label>
				
			</div>
			<div class="internalPopUpMiddle pageFormContainer flowDesignerPopupContent flowDesignerRestfulHTTP infoConfigModal codeBlockModal">
				<div class="card no-card">
					<div class="card-block">
						<div class="row">
							<div class="col-12">
								<p><%=_T([[Select the data that you want extract to variables]])%>.</p>
								<div code_block id="flow_designer_add_http_api_code_block_container" class='flowDesignerMappingCodeContainer'>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
				<div class="internalPopUpButtons justify-content-end">
					<button id="btn_cancel_response" class="pageButtonGeneric buttonColorWhite" type="button">
						<%=_T([[Cancel]])%>
					</button>
					<button id="btn_previewResult" action="" class="pageButtonGeneric buttonColorBlue" type="button">
						<%=_T([[Preview]])%>
					</button>
					<button id="btn_selectMapping" action="" class="pageButtonGeneric buttonColorBlue" type="button">
						<%=_T([[Select Mapping]])%>
					</button>
				</div>
		
			</div>
		</div>
		<div id="flowDesignerPop_response_waiting" class="internalWaitingContainer" hidden>
			<div waiting_message="true" class="internalWaitingMessage"></div>
			<div class="internalWaitingAnimation">
				<i class="internalWaitingAnimationIcon"></i>
			</div>
		</div>
		`,
		http_restfull_response_mapping_checkbox: `
			<div class='activity-restfull-request-mapping' map_element_{{uuid}}>
				<div class='row'>
					<div class='form-check form-check-only'>
						<label for='' class='form-check-label form-check-label-title'>
							<input check_element_{{uuid}} id='' class='form-check-input' type='checkbox'>
						</label>
					</div>
					<button collapse_button_{{uuid}} class='activity-restfull-request-mapping collapse-button'></button>
					<p class='activity-restfull-request-mapping'>{{key}} = <span value_assignation_{{uuid}} class='activity-restfull-request-mapping-value'>{{value}}</span></p>
				</div>
				<div child_container_{{uuid}} class='activity-restfull-request-mapping child-container'></div>
				
			</div>`,
		activity_error_screen: `
			<div class='flowDesignerActivityErrorScreen' >
				<i class='far fa-info-circle'></i>
				<label class='title'>
					{{ title }}
				</label>
				<label class='message'>
					{{ message }}
				</label>
			</div>`
	};

	if (!inConcert.templates.process_flows) {
		inConcert.templates.process_flows = Templates;
	}
}());

