module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource
local m_modelName = "SampleUser"

function GetName ()
	return m_modelName
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetDataSource ()
	if not m_datasource then
		local model = require "apps.integrations.model"
		model.BuildModels(true)
	end
	return m_datasource
end

function Get (vcc, simpleId, keyspace, columns)
	simpleId = simpleId:lower()
	local user       = utils.GetAllColumns({
		keyspace     = keyspace or "Integrations",
		columnFamily = m_modelName,
		key          = utils.AppendVcc(simpleId, vcc),
		columns      = columns
	}) or {}
	return user
end

function Save (vcc, user, keyspace)
	utils.SaveRows {
		keyspace =  keyspace or "Integrations",
		columnFamily = m_modelName,
		rows = {
			[utils.AppendVcc(user.Id, vcc)] = user
		}
	}
	local closeKeyspace = false
	if not keyspace then
		keyspace = utils.GetDatasource():CassandraConnection("Integrations")
		closeKeyspace = true
	end
	if closeKeyspace then
		keyspace:Close()
	end
end

function List (keyspace)
	return utils.GetAllColumns {
		keyspace = keyspace or "Integrations",
		columnFamily = m_modelName,
		startKey = "",
		endKey = ""
	} or {}
end

function Remove (key, keyspace)
	utils.RemoveColumns {
		keyspace = keyspace or "Integrations",
		columnFamily = m_modelName,
		rows = {key}
	}
end