/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global $, inConcert */

/*
	Esta clase es instanciada y utilizada desde la configuracion de PROVISIONING-VCC-BASIC.
	La misma debe exponer el nombre de la misma (ej: inConcert.prov_form_vccs_widget_example)

	Los metodos requeridos son:
		get
			Tiene que retornar un objeto con la Config del Widget.
			Esta configuracion quedara almacenada en el VCC.
		set
			Recibe un objeto con la configuracion del Widget que se ha almacenado en el VCC.
		get_validation_def
			Debe retornar un Array con las validaciones que se realizaran en el formulario del VCC.
			A estas validaciones las realiza el VCC.
			Los items Array deben seguir la estructura esperada en los formularios del VCC.
		set_events
			Se invoca cuando la clase que configura el VCC instancia la clase e inicia sus eventos.
			Sirve para que internamente se realicen bindeo de eventos segun los controles de configuracion del Widget.
		ready
			Se invoca cuando la instancia del Frm de provisioning ha termiando.
			Aca se podran realizar diferentes tareas que se necesiten.

*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	//"use strict";

	const FORMAT = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// sample
	function widget_sample (params = {})
	{
		this.params = params;
		this.owner = params.owner;
		this.init();
	}

	/*
		Este nombre de coincidir con el valor del atributo "jsClassName" que se ha ingresado en la definicion del Widget en el archivo:
			\apps\integrations\widgets\sample\definitions.lua
		
		Ejemplo del archivo "definitions.lua"
		..
		..
			jsClassName = cosmo.fill([[inConcert.prov_form_vccs_widget_$WIDGET_DIRECTORY]], params) 
		..
		..
	*/
	if ( typeof inConcert.prov_form_vccs_widget_sample !== "function" ) {
		inConcert.prov_form_vccs_widget_sample = widget_sample;
	}

	widget_sample.prototype.init = function()
	{
		this.load_data();
	};

	widget_sample.prototype.load_data = function()
	{
		// TODO: Implementar si es necesario!!!
	};

	widget_sample.prototype.clean_up = function()
	{
		$("#prov_form_vcc_basic_sample_widget_integration_value1").val("");
	};

	// Funcion requerida ....
	widget_sample.prototype.get = function()
	{
		let info = {
			value1: $("#prov_form_vcc_basic_sample_widget_integration_value1").val()
		};
		return info;
	};

	widget_sample.prototype.on_validation_error = function(/*type, message_error*/)
	{
		// TODO: Implementar si es necesario!!!
		//window.alert("widget_sample.prototype.on_validation_error " + type + " " + message_error);
	};

	// Funcion requerida ....
	widget_sample.prototype.set = function(info)
	{
		if (!info) {
			return;
		}
		$("#prov_form_vcc_basic_sample_widget_integration_value1").val(info.value1);
	};

	// Funcion requerida ....
	widget_sample.prototype.get_validation_def = function()
	{
		const self = this;

		const can_validate = function () {
			return true;
		};

		return [
			{
				control_id: "prov_form_vcc_basic_sample_widget_integration_value1",
				can_validate: can_validate,
				messages: {
					custom: {
						type : "custom",
						valid: function() {
							let response = {
								success: true
							};

							const $val =  $("#prov_form_vcc_basic_sample_widget_integration_value1");
							let val = $val.val();
							if (val === "") {
								return response;
							}
							val = parseInt(val, 10);

							if (val !== 15 && val !== 44) {
								response.success = false;
								response.message = FORMAT("<%=_T('Custom Validation Error. Allowed values {0} and {1}.')%>", 15, 44);
							}

							return response;
						}
					}
				},
				on_callback_error: function(type, message_error) {
					self.on_validation_error(type, message_error);
				}
			}
		];
	};

	// Funcion requerida ....
	widget_sample.prototype.set_events = function()
	{
		//TODO: Implementar
	};

	// Funcion requerida ....
	widget_sample.prototype.ready = function()
	{
		let is_new_vcc = this.owner.frm.is_new;
		if (is_new_vcc) {
			this.clean_up();
		}
	};

}());

