local orbit = require("orbit")
require "inconcert.orbit.application"
require "inconcert.translators"
local jsonEncoder = require "LuaOrm.Serializers.Json"
local LuaConfigurationControl = require "LuaConfigurationControl"


local m_appLocation = select(2, ...)

assert(m_appLocation, "should be running under inconcertWebHandler")

module(..., package.seeall, orbit.new, inconcert.orbit.application.Decorate)

_M.model = nil

local htmlRender = require"inconcert.render".new("monitoring", {
	model = nil
})
local configControl

-- funcion que es llamada cuando el webserver se inicializa.
function Initialize()
	LogInfo("Starting application 'monitoring'.")
	return true
end


-- translate

local function makeTextTranslator ()
	local translator = inconcert.translators.supervisor -- TODO ver esto
	return function(...)
		return translator:Text(...)
	end, i18nlib.LCID[translator.language]
end

--scripts
function render_script (web, name, versionCode, languageCode)
	if (languageCode ~= "") then
		name = name .. "." .. versionCode
	else
		languageCode = versionCode
	end
	inconcert.authUser = { languageNumber = tonumber(languageCode) }
	local _T, _L = makeTextTranslator()
	local env = 
		{_T = _T,
		_L = _L,
		m_utils = utils
	}
	return htmlRender:ScriptLp("scripts/" .. name .. ".js", web, env)
end

function serve_file(app_module, cache)
	return function (web)
		local filename = string.sub(web.path_info, 2, #web.path_info)
		LogInfo("Serving file: %s", m_appLocation.."/"..filename)
		if not cache then
			app_module.response.DontCache(web)
		end
		return _M:serve_static(web, m_appLocation.."/"..filename)
	end
end

-----------------------
--  init controllers (api/routes)
local function GetControllers ()
	local controllerDir = m_appLocation .. "/controllers"
	local controllers = {}
	LogInfo("MONITORING: GetControllers " .. controllerDir )
	for file in lfs.dir(controllerDir) do
		if file ~= "." and file ~= ".." then
			local f = controllerDir..'/'..file
			local attr = lfs.attributes (f)
			if attr.mode ~= "directory" then
				local controllerName = string.match(file, [[(.+).lua]])
				if controllerName then
					controllers[controllerName] = { url = controllerName }
				end
			end
		end
	end
	return controllers
end

for key, controllerDef in pairs(GetControllers()) do
	--requires y mapeo funciones
	local controller = relativeRequire("controllers." .. key, ...)
	controller.MapUris(_M, htmlRender, "/" .. controllerDef.url, "/apps/monitoring")
end
_M:dispatch_get(render_script, "/scripts/([^.]+)%.([^.]+)%.?([^.]*)%.js")

