module(..., package.seeall)

local utils = require "shared.apps.utils"
local PM = require("provisioningmanager")
local m_datasource

function GetName ()
	return "Packages"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function Get (packageId, ksProv)
	LogDebug("[outbound_engine:models.packages.Get] Retrieving PACKAGE: '%s'.", packageId)
	local releaseConn = false
	if not ksProv then
		ksProv = utils.GetDatasource():CassandraConnection("Provisioning")
		releaseConn = true
	end
	local success, currentPackage = pcall(PM.GetPackage, ksProv, packageId)
	if releaseConn then
		ksProv:Close()
	end
	if not success or utils.TableIsEmpty(currentPackage) then
		local errMsg = "PACKAGE DOES NOT EXIST"
		--LogWarning("[outbound_engine:models.packages.Get] Error retrieving PACKAGE '%s'. PACKAGE does not exist.'", packageId)
		return false, errMsg
	end
	currentPackage.Id = currentPackage.Id or packageId
	return true, currentPackage
end
