module(..., package.seeall)
local utils = require "shared.apps.utils"
local m_datasource


function GetName ()
	return "OutboundProcessesFiltersBatches"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetFilter (vcc, filterId, keyspace)
	assert(vcc)
	assert(filterId)
	vcc = vcc:lower()
	filterId = filterId:lower()
	local filter = utils.GetAllColumns {
		keyspace = keyspace or "OutboundEngine",
		columnFamily = "OutboundProcessesFiltersBatches",
		key = vcc,
		columns = {filterId} or {}
	} or {}
	--LogDebug("2-----------> oe.models.GetFilter -vcc: '%s', filterId: '%s' filters: %s", vcc, filterId, utils.JSON_Encode(filter))
	return filter
end

function LoadFilters (vcc, keyspace)
	assert(vcc)
	vcc = vcc:lower()
	local filters = utils.GetAllColumns {
		keyspace = keyspace or "OutboundEngine",
		columnFamily = "OutboundProcessesFiltersBatches",
		key = vcc
	} or {}
	--LogDebug("1-----------> oe.models.LoadFilters -vcc: '%s' filters: %s", vcc, utils.JSON_Encode(filters))
	return filters
end

function SaveFilter (vcc, filter, keyspace)
	assert(vcc)
	assert(filter)
	assert(filter.id)
	vcc = vcc:lower()
	local filterId = filter.id:lower()
	local rows = {}
	rows[vcc] = {
		[filterId] = filter
	}
	--LogDebug("-----------> oe.models.SaveFilter - filter: %s", utils.JSON_Encode(filter))
	utils.SaveRows {
		keyspace = keyspace or "OutboundEngine",
		columnFamily = "OutboundProcessesFiltersBatches",
		rows = rows
	}
	return true, {}
end

function DeleteFilter (vcc, filterId, keyspace)
	assert(vcc)
	assert(filterId)
	vcc = vcc:lower()
	filterId = filterId:lower()
	utils.RemoveColumns {
		keyspace = keyspace or "OutboundEngine",
		columnFamily = "OutboundProcessesFiltersBatches",
		rows = {
			[vcc] = {filterId}
		}
	}
	return true, {}
end
