/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const FORMAT = inConcert.Utils.format;
	const _T = inConcert.i18n.getString;
	let m_telephone_codes = null;

	//---------------------------------------------------------------------
	// form imports format class
	function popup_outbound_engine_imports_format(params)
	{
		this.frm = params.frm;
		this.list_field_types_by_value = null;
		this.list_reserverd_words = null;
		this.list_areas_by_country = null;
		this.current_import_format = null;
		this.form_paginator_mapped_fields = null;
		this.edited_mapped_field = null;
		this.m_mustExecuteGoBackToGridAfterSaved = false;
		this.__new_grids();

		this.basic_codes = {
			BCD_ID: 0,
			BCD_VCC: 1,
			BCD_NAME: 2,
			BCD_CATEGORY: 3,
			BCD_CAMPAIGN: 4,
			BCD_ACCOUNT_OFFICER: 5,
			BCD_ACCOUNT_GROUP: 6
		};

		this.extended_codes = {
			ECD_PHONEDATA: 7,
			ECD_ADDRESS: 8,
			ECD_MAIL: 9,
			ECD_CUSTOMVALUE: 10,
			ECD_NAMEVALUE: 11,
			ECD_SCHEDULE: 12,
			ECD_SKILL: 14
		};

		m_telephone_codes = inConcert.app.getInstanceTelephonyCodes();
		return true;
	}

	popup_outbound_engine_imports_format.prototype.initialize = function()
	{
		this.__set_events();
		//--------------------------------------------------------
		const $import_container = $("#out_form_import_container");
		const $import_ctrls_for_vcc_teli6 = $import_container.find("[for-vcc='teli6']");
		const $import_ctrls_for_vcc_allegro = $import_container.find("[for-vcc='allegro']");
		//
		const $map_fields_container = $("#out_form_import_edit_field_map_popup");
		const $map_fields_ctrls_for_vcc_teli6 = $map_fields_container.find("[for-vcc='teli6']");
		const $map_fields_ctrls_for_vcc_allegro = $map_fields_container.find("[for-vcc='allegro']");
		if (inConcert.app.has_allegro_integration()) {
			$import_ctrls_for_vcc_teli6.remove();
			$import_ctrls_for_vcc_allegro.show();
			//
			$map_fields_ctrls_for_vcc_teli6.remove();
			$map_fields_ctrls_for_vcc_allegro.show();
		}
		else {
			$import_ctrls_for_vcc_allegro.remove();
			$import_ctrls_for_vcc_teli6.show();
			//
			$map_fields_ctrls_for_vcc_allegro.remove();
			$map_fields_ctrls_for_vcc_teli6.show();
		}
		//--------------------------------------------------------
	};

	popup_outbound_engine_imports_format.prototype.__set_events = function()
	{
		const self = this;

		const $create = $("#out_form_import_edit_field_map_popup_create");
		$create.off("click")
			.on("click", function() {
				self.__save();
			});

		const $close = $("#out_form_import_edit_field_map_popup_close");
		$close.off("change")
			.on("click", function() {
				self.hide();
			});

		const $multiple_rows_selector = $("#out_form_import_edit_field_map_popup_multiple_rows_selector");
		$multiple_rows_selector.off("change")
			.on("change", function() {
				self.__toggle_csv_header();
			});

		const $field_type = $("#out_form_import_edit_field_map_area_field_type");
		$field_type.off("change")
			.on("change", function() {
				self.__on_field_type_changed();
			});

		const $address_country = $("#out_form_import_edit_field_map_area_address_country");
		$address_country.off("change")
			.on("change", function() {
				let country = $(this).val();
				self.__fill_address_areas(country);
			});

		const $phone_country = $("#out_form_import_edit_field_map_area_phone_country");
		$phone_country.off("change")
			.on("change", function() {
				let country = $(this).val();
				self.__fill_phone_areas(country);
			});

		const $is_serchable = $("#out_form_import_edit_field_map_area_name_value_is_serchable");
		$is_serchable.off("change")
			.on("change", function() {
				self.__toggle_namevalue_searchable_type();
			});

		if (!inConcert.app.has_allegro_integration()) {
			const $skill_mode = $("#out_form_import_edit_field_map_area_skill_required_mode");
			$skill_mode.off("change")
				.on("change", function() {
					let skill_mode = $(this).val();
					self.__on_changed_skill_mode(skill_mode);
				});
		}

		// eventos de la grilla con paginado
		this.form_paginator_mapped_fields.set_events();
	};

	popup_outbound_engine_imports_format.prototype.__on_changed_skill_mode = function(skill_mode)
	{
		const $get_value_from = $("#out_form_import_edit_field_map_area_skill_required_column");
		if (skill_mode === "" || skill_mode === "SORT") {
			this.frm.disable_control($get_value_from, true);
		}
		else if (skill_mode === "PREFERRED" || skill_mode === "REQUIRED") {
			this.frm.disable_control($get_value_from, false);
		}
		else {
			throw("popup_outbound_engine_imports_format.prototype.__on_changed_skill_mode - unrecognized value: " + skill_mode);
		}
	};

	popup_outbound_engine_imports_format.prototype.__toggle_namevalue_searchable_type = function()
	{
		const $is_serchable = $("#out_form_import_edit_field_map_area_name_value_is_serchable");
		let is_serchable = $is_serchable.prop("checked");
		const $is_serchable_data_container = $("#out_form_import_edit_field_map_area_name_value_is_serchable_data_container");
		$is_serchable_data_container[is_serchable ? "show" : "hide"]();
	};

	popup_outbound_engine_imports_format.prototype.__show = function()
	{
		var $edit_field_map_popup = $("#out_form_import_edit_field_map_popup");
		$edit_field_map_popup.show();
		$("body").removeClass("popupDisplay").addClass("popupDisplay");
	};

	popup_outbound_engine_imports_format.prototype.hide = function()
	{
		this.current_import_format = null;
		this.edited_mapped_field = null;
		this.__hide_messages(); // oculto todos los errores de los campos
		this.form_paginator_mapped_fields.hide_popup();
		var $edit_field_map_popup = $("#out_form_import_edit_field_map_popup");
		$edit_field_map_popup.hide();
		$("body").removeClass("popupDisplay");
	};

	popup_outbound_engine_imports_format.prototype.__get_field_type_value = function()
	{
		var $field_type = $("#out_form_import_edit_field_map_area_field_type");
		var field_type = $field_type.val();
		if (field_type === "") {
			return null;
		}
		return parseInt(field_type, 10) - 1;
	};

	popup_outbound_engine_imports_format.prototype.__on_field_type_changed = function()
	{
		var $map_area = $("#out_form_import_edit_field_map_area");
		$map_area.find("[data]").hide();

		var field_type = this.__get_field_type_value();
		if (field_type === null || field_type < 0 || field_type > 14) {
			return;
		}

		switch (field_type) {
			case this.extended_codes.ECD_PHONEDATA:
				$map_area.find("[data='phone']").show();
			break;
			case this.extended_codes.ECD_ADDRESS:
				$map_area.find("[data='address']").show();
			break;
			case this.extended_codes.ECD_MAIL:
				$map_area.find("[data='email']").show();
			break;
			case this.extended_codes.ECD_NAMEVALUE:
				$map_area.find("[data='name_value']").show();
			break;
			case this.extended_codes.ECD_CUSTOMVALUE:
				$map_area.find("[data='custom_field']").show();
			break;
			case this.extended_codes.ECD_SCHEDULE:
				$map_area.find("[data='scheduled']").show();
			break;
			case this.extended_codes.ECD_SKILL:
				$map_area.find("[data='skill']").show();
			break;
			default:
				//es un tipo basico,
				if (field_type >= 0) {
					$map_area.find("[data='basic']").show();
				}
		}
	};

	popup_outbound_engine_imports_format.prototype.__toggle_csv_header = function()
	{
		var $csv_header_container = $("#out_form_import_edit_field_map_popup_multiple_rows_csv_header_container");
		var $multiple_rows_selector = $("#out_form_import_edit_field_map_popup_multiple_rows_selector");

		if ($multiple_rows_selector.prop("checked")) {
			$csv_header_container.show();
		}
		else {
			$csv_header_container.hide();
		}
	};

	popup_outbound_engine_imports_format.prototype.new_format = function()
	{
		$("#out_form_import_edit_field_map_popup_create").text("<%=_T('Create')%>");

		var $map_id = $("#out_form_import_edit_field_map_popup_id");
		this.frm.disable_control($map_id, false, true);
		$map_id.val("");
		$("#out_form_import_edit_field_map_popup_multiple_rows_selector").prop("checked", false).trigger("change");
		$("#out_form_import_edit_field_map_popup_name").val("");

		this.__fill_csv_header_controls();

		var $csv_header_container = $("#out_form_import_edit_field_map_popup_multiple_rows_csv_header_container");
		$.each($csv_header_container.find("[csv_header]"), function(_, header) {
			var $header = $(header);
			$header.prop("checked", false);
		});

		this.form_paginator_mapped_fields.initialize();
		this.__show();

		window.setTimeout(function() {
			$map_id.focus();
		}, 200);
	};

	popup_outbound_engine_imports_format.prototype.edit_format = function(format_id)
	{
		const self = this;

		var $multiple_rows_selector = $("#out_form_import_edit_field_map_popup_multiple_rows_selector");
		var $map_id = $("#out_form_import_edit_field_map_popup_id");
		var $name = $("#out_form_import_edit_field_map_popup_name");

		var edit = function(import_format)
		{
			$("#out_form_import_edit_field_map_popup_create").text("<%=_T('Update')%>");

			self.frm.disable_control($map_id, true);
			$map_id.val(import_format.Id);
			$name.val(import_format.Description).focus();

			var $csv_header_container = $("#out_form_import_edit_field_map_popup_multiple_rows_csv_header_container");
			$.each($csv_header_container.find("[csv_header]"), function(_, header) {
				var $header = $(header);
				$header.prop("checked", false);
			});

			if ((import_format.ContactImportFormatKeys || []).length === 0) {
				$multiple_rows_selector.prop("checked", false).trigger("change");
			}
			else {
				$multiple_rows_selector.prop("checked", true).trigger("change");
				$.each(import_format.ContactImportFormatKeys, function(_, header) {
					var chk_id = self.__make_header_dom_id(header.KeyField);
					var $header = $("#" + chk_id);
					if ($header.length > 0) {
						$header.prop("checked", true);
					}
				});
			}

			self.form_paginator_mapped_fields.initialize();
			self.__show();
			window.setTimeout(function() {
				$name.focus();
			}, 200);
		};

		this.frm.show_waiting(FORMAT("<%=_T('Please wait, Retrieving {0} Import Format')%>", format_id));
		this.__fill_csv_header_controls();

		var outbound_engine_api = inConcert.app.getOutboundEngineAPI();

		outbound_engine_api.importFormatGet({formatId: format_id},
			function(success, import_format) {
				if (success) {
					self.current_import_format = import_format;
					edit(import_format);
				}
				else {
					var msg = "<%=_T('Error Retrieving {0} Import Format.')%>";
					var type = "Error";
					self.frm.show_status_message(FORMAT(msg, format_id), type, 5000);
				}
				self.frm.hide_waiting();
			}
		);
	};

	popup_outbound_engine_imports_format.prototype.__get = function()
	{
		const self = this;

		var get_import_format_keys = function()
		{
			var contact_import_format_keys = [];

			var $multiple_rows_selector = $("#out_form_import_edit_field_map_popup_multiple_rows_selector");
			if (!$multiple_rows_selector.prop("checked")) {
				return contact_import_format_keys;
			}

			var $csv_header_container = $("#out_form_import_edit_field_map_popup_multiple_rows_csv_header_container");

			$.each($csv_header_container.find("[csv_header]"), function(_, header)
			{
				var $header = $(header);
				if ($header.prop("checked")) {
					var key = $header.attr("csv_header");
					contact_import_format_keys.push({
						KeyField: key
					});
				}
			});

			return contact_import_format_keys;
		};

		var get_mapped_fields = function()
		{
			var mapped_fields = self.form_paginator_mapped_fields.get_items();
			return mapped_fields;
		};

		var is_new = !this.current_import_format;
		var import_format = {
			__IsNew: is_new,
			Id: $("#out_form_import_edit_field_map_popup_id").val(),
			Description: $("#out_form_import_edit_field_map_popup_name").val(),
			ContactImportFormatFields: get_mapped_fields(),
			ContactImportFormatKeys: get_import_format_keys()
		};

		return import_format;
	};

	popup_outbound_engine_imports_format.prototype.__hide_messages = function()
	{
		var $err_msg_container = $("#out_form_import_edit_field_map_popup_message");
		this.frm.hide_messages(undefined, undefined, $err_msg_container); // oculto todos los errores de los campos
		this.form_paginator_mapped_fields.hide_popup_msg();
	};

	popup_outbound_engine_imports_format.prototype.__validate = function()
	{
		const self = this;

		var result = {success: false, import_format: null, err: null};
		var $err_msg_container = $("#out_form_import_edit_field_map_popup_message");
		this.__hide_messages(); // oculto todos los errores de los campos

		var validate_field = function($ctrl, type, msg) {
			return self.frm.validate_field($ctrl, type, msg, undefined, undefined, undefined, $err_msg_container);
		};

		// Id
		var $map_id = $("#out_form_import_edit_field_map_popup_id");
		if (!validate_field($map_id, "required", "<%=_T('Format Name is required.')%>")) {
			return result;
		}
		if (!validate_field($map_id, "id", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Format Name.')%>")) {
			return result;
		}

		// Description
		var $map_desc = $("#out_form_import_edit_field_map_popup_name");
		if (!validate_field($map_desc, "required", "<%=_T('Format Description is required.')%>")) {
			return result;
		}

		// Key fields - Si ha seleccionado el check "multiple rows", tiene que haber seleccionado al menos un "key field".
		//
		var $multiple_rows_selector = $("#out_form_import_edit_field_map_popup_multiple_rows_selector");
		if ($multiple_rows_selector.prop("checked")) {
			var has_selected_key_fields = false;
			var $csv_header_container = $("#out_form_import_edit_field_map_popup_multiple_rows_csv_header_container");

			$.each($csv_header_container.find("[csv_header]"), function(_, header) {
				var $header = $(header);
				if ($header.prop("checked")) {
					has_selected_key_fields = true;
					return false; //break
				}
			});
			// esto es un lenga lenga, que lo hace es validar requerido sobre un txt oculto, que se carga su valor dependiendo de 
			// que existan checkboxes de key fields seleccionados.
			var $hidden_ctrl = $("#out_form_import_edit_field_map_popup_multiple_rows_keys_selector");
			if (!has_selected_key_fields) {
				$hidden_ctrl.val("");
			}
			else {
				$hidden_ctrl.val("ALGO");
			}

			if (!validate_field($hidden_ctrl, "required", "<%=_T('Please select at least one Key Field.')%>")) {
				return result;
			}
		}
		// Grid Mapped fields
		if (!this.form_paginator_mapped_fields.start_validation().success) {
			return result;
		}

		// is ok
		result.success = true;
		result.import_format =  this.__get();

		return result;
	};

	popup_outbound_engine_imports_format.prototype.__validate_mapped_fields = function()
	{
		const self = this;
		let is_ok = false;
		let mapped_fields = this.form_paginator_mapped_fields.get_items();

		$.each(mapped_fields || [], function(_, field) {
			if (field.Type === self.basic_codes.BCD_NAME) {
				is_ok = true;
				return false; //break
			}
		});

		return is_ok;
	};

	popup_outbound_engine_imports_format.prototype.__on_saved = function(import_format)
	{
		var is_new = !this.current_import_format;
		this.frm.on_saved_import_format(is_new, import_format);
	};

	popup_outbound_engine_imports_format.prototype.__save = function()
	{
		const self = this;

		const response = this.__validate();
		if (!response.success) {
			// TODO: message error
			return;
		}

		const import_format = response.import_format;
		let message = FORMAT("<%=_T('Please wait, Saving {0} Import Format')%>", import_format.Id);
		const $waiting_container = $("#out_form_import_edit_field_map_popup_waiting");
		this.frm.show_waiting(message, $waiting_container);

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.importFormatSave(
			import_format,
			function(success, err)
			{
				let msg, type;
				if (success) {
					msg = "<%=_T('Successfully Saved {0} Import Format.')%>";
					type = "Info";
					window.setTimeout(function() {
						self.__on_saved(import_format);
						self.hide();
						self.frm.show_status_message(FORMAT(msg, import_format.Id), type, 5000);
						self.frm.hide_waiting();
					}, 1000);
				}
				else {
					let err_type = err;
					if (typeof err === "object") {
						if (inConcert.app.has_allegro_integration()) {
							if (typeof err.err === "object") {
								err_type = (err.err.result || "").toUpperCase();
							}
						}
						else {
							err_type = (err.type || "").toUpperCase();
						}
					}
					const $err_msg_container = $("#out_form_import_edit_field_map_popup_message");
					type = "Error";
					if ("ALREADY_EXIST" === err_type) {
						msg = "<%=_T('Import format Name is already in use.')%>";
						msg = FORMAT(msg, import_format.Id);
						const $map_id = $("#out_form_import_edit_field_map_popup_id");
						self.frm.show_validation_error($map_id, msg, undefined, undefined, undefined, $err_msg_container);
					}
					else if ("NAME VALUE SEARCHABLE - EXCEEDED MAX ALLOWED" === err_type) {
						msg = "<%=_T('Only {0} searchable name-value fields of type {1} are allowed.')%>";
						const searcheable_data_type = {
							["DATE"]   : "<%=_T('Date')%>"  ,
							["NUMERIC"]: "<%=_T('Number')%>",
							["TEXT"]   : "<%=_T('Text')%>"  
						};
						const display_data_type = searcheable_data_type[err.info.searchableDataType] || err.info.searchableDataType;
						msg = FORMAT(msg, err.info.maxAllowed, display_data_type);
						self.frm.show_status_message(msg, type, 5000, undefined, undefined, $err_msg_container);
					}
					else {
						msg = "<%=_T('Error Saving {0} Import Format.')%>";
						msg = FORMAT(msg, import_format.Id);
						self.frm.show_status_message(msg, type, 5000, undefined, undefined, $err_msg_container);
					}
					self.frm.hide_waiting();
				}
			}
		);
	};

	popup_outbound_engine_imports_format.prototype.make_requests_list = function()
	{
		const self = this;

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		let requests = [
			// Field Types
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsFieldsTypes(success);
				},
				success: function(list) {
					self.__fill_field_types(list);
				}
			},
			// Scheduled Format
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsScheduledFormat(success);
				},
				success: function(list) {
					self.__fill_scheduled_format(list);
				}
			},
			// Destinations
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsDestinations(success);
				},
				success: function(list) {
					self.__fill_destinations(list);
				}
			},
			// Mail Destinations
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsMailDestinations(success);
				},
				success: function(list) {
					self.__fill_mail_destinations(list);
				}
			},
			// Address Destinations
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsAddressDestinations(success);
				},
				success: function(list) {
					self.__fill_address_destinations(list);
				}
			},
			// Custom Columns
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsCustomColumns(success);
				},
				success: function(list) {
					self.__fill_custom_columns(list);
				}
			},
			// Reserved Words
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsReservedWords(success);
				},
				success: function(list) {
					self.__fill_reserved_words(list);
				}
			},
			// Skills
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadSkills(success);
				},
				success: function(list) {
					self.__fill_skills(list);
				}
			},
			// TimeZones
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadTimeZones(success);
				},
				success: function(list) {
					self.__fill_timezones(list);
				}
			}
		];

		if (inConcert.app.has_allegro_integration()) {
			// Imports Countries
			requests.push({
				request_function: function(success) {
					return outbound_engine_api.systemLoadImportsCountries(success);
				},
				success: function(list) {
					self.__fill_import_countries(list);
				}
			});
			// System Countries
			requests.push({
				request_function: function(success) {
					return outbound_engine_api.systemLoadCountries(success);
				},
				success: function(list) {
					self.__fill_countries(list);
				}
			});
			// Areas
			requests.push({
				request_function: function(success) {
					return outbound_engine_api.systemLoadAreas(success);
				},
				success: function(list) {
					self.__categorize_areas_by_country(list);
				}
			});
		}
		else {
			// Imports & System Countries
			requests.push({
				request_function: function(success) {
					return m_telephone_codes.loadCountries(success);
				},
				success: function(list) {
					self.__fill_countries(list);
				}
			});
			// name values searchable data type
			this.__fill_namevalue_searchable_data_type();
			// fill skills required mode
			this.__fill_skills_required_mode();
		}

		return requests;
	};

	popup_outbound_engine_imports_format.prototype.__make_header_dom_id = function(header)
	{
		return "out_csv_header_selector_" + header.toLowerCase();
	};

	popup_outbound_engine_imports_format.prototype.__fill_namevalue_searchable_data_type = function()
	{
		const $combo = $("#out_form_import_edit_field_map_area_name_value_is_serchable_data_type");
		let list = [
			{Id: "DATE"   , Name: "<%=_T('Date')%>"  },
			{Id: "NUMERIC", Name: "<%=_T('Number')%>"},
			{Id: "TEXT"   , Name: "<%=_T('Text')%>"  }
		];
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Id" /* attr_id */, "Name" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_skills_required_mode = function()
	{
		const $combo = $("#out_form_import_edit_field_map_area_skill_required_mode");
		let list = [
			{Id: "SORT"     , Name: "<%=_T('Sort')%>"     , Tooltip: "<%=_T([[Sort     : just to sort the agents and take the best free one.]])%>"},
			{Id: "PREFERRED", Name: "<%=_T('Preferred')%>", Tooltip: "<%=_T([[Required : it is required, if there is no agent, the contact is bounced with No skill agents cause.]])%>"},
			{Id: "REQUIRED" , Name: "<%=_T('Required')%>" , Tooltip: "<%=_T([[Preferred: if there is no agent, the contact keeps retrying for 2 * attention time. After that time it bounces with No skill agents cause.]])%>"}
		];
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Id" /* attr_id */, "Name" /* attr_name */, true /* sorted */, null, null, null, null, "Tooltip");
	};

	popup_outbound_engine_imports_format.prototype.__fill_csv_header_controls = function()
	{
		const self = this;

		var $csv_header = $("#out_form_import_edit_field_map_popup_multiple_rows_csv_header");
		$csv_header.html("");

		var csv_header = this.frm.get_csv_header();
		if (!csv_header) {
			var msg = "<%=_T('CSV header does not exist.')%>";
			var type = "Error";
			this.frm.show_status_message(msg, type, 5000);
			return;
		}

		var $row = null;
		var added_in_row = 0;

		$.each(csv_header, function(_, header)
		{
			added_in_row++;
			if (added_in_row === 1) {
				$row = null;
				$row = $("<div class='formRow'></div>");
			}
			else {
				added_in_row = 0;
			}

			var chk_id = self.__make_header_dom_id(header);
			var $field = $(
				"<div class='col-2'>" +
					"<div class='form-group'>" +
						"<div class='form-check mt-4'>" +
							"<label for='" + chk_id + "' class='form-check-label text-uppercase'>" +
								"<input id='" + chk_id + "' class='form-check-input' type='checkbox' csv_header='" + header + "' />" +
								header + 
							"</label>" +
						"</div>" +
					"</div>" +
				"</div>"
			);

			$csv_header.append($field);
		});

		var get_id = function(_, name) {
			return name;
		};
		var get_name = function(_, name) {
			return name;
		};

		// basic columns
		var $combo = $("#out_form_import_edit_field_map_area_basic_columns");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// email address
		$combo = $("#out_form_import_edit_field_map_area_email_address");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// address column
		$combo = $("#out_form_import_edit_field_map_area_address_column");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// name value column
		$combo = $("#out_form_import_edit_field_map_area_name_value_column");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// phone data number
		$combo = $("#out_form_import_edit_field_map_area_phone_number");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// phone data extension
		$combo = $("#out_form_import_edit_field_map_area_phone_ext");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// phone data zip
		$combo = $("#out_form_import_edit_field_map_area_phone_zip");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// custom column
		$combo = $("#out_form_import_edit_field_map_area_custom_column");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// scheduled column
		$combo = $("#out_form_import_edit_field_map_area_scheduled_column");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// skill column
		$combo = $("#out_form_import_edit_field_map_area_skill_column");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);

		// skill required column
		$combo = $("#out_form_import_edit_field_map_area_skill_required_column");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, csv_header, get_id /* attr_id */, get_name /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_field_types = function(list)
	{
		const self = this;

		//cargo el contenido del combo
		var cbo_list = {};
		this.list_field_types_by_value = {};

		$.each(list, function(_, field_type)
		{
			var field_number = parseInt(field_type.Value, 10);
			self.list_field_types_by_value[field_number] = field_type.DisplayName;
			var id = field_number + 1;
			cbo_list[id] = {
				id: id,
				name: field_type.DisplayName
			};
		});

		var $combo = $("#out_form_import_edit_field_map_area_field_type");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, cbo_list, "id" /* attr_id */, "name" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_scheduled_format = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_scheduled_format");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Value" /* attr_id */, "DisplayName" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_import_countries = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_phone_country");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, null /* attr_id */, "DisplayName" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_destinations = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_phone_type");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Name" /* attr_id */, "DisplayName" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_mail_destinations = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_email_type");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Name" /* attr_id */, "DisplayName" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_address_destinations = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_address_type");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Name" /* attr_id */, "DisplayName" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_custom_columns = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_custom_field");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Name" /* attr_id */, "DisplayName" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_reserved_words = function(list)
	{
		const self = this;
		this.list_reserverd_words = {};
		$.each(list, function(_, word) {
			self.list_reserverd_words[word.Value.toUpperCase()] = true;
		});
	};

	popup_outbound_engine_imports_format.prototype.__fill_skills = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_skill_type");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Name" /* attr_id */, "Name" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_timezones = function(list)
	{
		var $combo = $("#out_form_import_edit_field_map_area_scheduled_timezone");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "Id" /* attr_id */, "FormattedTimeZone" /* attr_name */, true /* sorted */);
	};

	popup_outbound_engine_imports_format.prototype.__fill_countries = function(countries)
	{
		const self = this;
		let $address_country = $("#out_form_import_edit_field_map_area_address_country");
		let $phone_country = $("#out_form_import_edit_field_map_area_phone_country");

		if (inConcert.app.has_allegro_integration()) {
			// allegro vcc
			this.frm.fill_combo($address_country, false /* is_blank_first_item */, countries, "ID" /* attr_id */, "DisplayName" /* attr_name */, false /* sorted */);
			this.frm.fill_combo($phone_country, false /* is_blank_first_item */, countries, "ID" /* attr_id */, "Name" /* attr_name */, false /* sorted */);
			return;
		}
		// vcc tel nativa
		const build_sorted_countries = function(countries_map)
		{
			if ($.isArray(self.sorted_countries)) {
				return self.sorted_countries;
			}
			self.sorted_countries = [];
			$.each(countries_map, function(country_id, country) {
				country_id = (country_id || "").toUpperCase() === "GLOBAL" ? "0" : country_id;
				self.sorted_countries.push({code: country_id, name: _T(country.name)});
			});
			return inConcert.Utils.sortArray(self.sorted_countries, "name");
		};
		let sorted_countries = build_sorted_countries(countries);

		const fill = function($combo) {
			$combo.html("");
			self.frm.combo_add_value($combo, "", "", true);
			$.each(sorted_countries, function(_, country) {
				self.frm.combo_add_value($combo, country.code, country.name, false);
			});
		};

		fill($address_country);
		fill($phone_country);
	};

	popup_outbound_engine_imports_format.prototype.__fill_address_areas = function(country)
	{
		const $area = $("#out_form_import_edit_field_map_area_address_area");
		this.__fill_areas(country, $area);
	};

	popup_outbound_engine_imports_format.prototype.__fill_phone_areas = function(country)
	{
		const $area = $("#out_form_import_edit_field_map_area_phone_area");
		this.__fill_areas(country, $area);
	};

	popup_outbound_engine_imports_format.prototype.__fill_areas = function(country, $area)
	{
		this.frm.disable_control($area, false);
		if (inConcert.app.has_allegro_integration()) {
			// allegro vcc
			let areas = this.__get_areas_by_country(country);
			if (!areas) {
				$area.html("");
				this.frm.disable_control($area, true);
				return;
			}
			this.frm.fill_combo($area, true /* is_blank_first_item */, areas, "ID" /* attr_id */, "Name" /* attr_name */, true /* sorted */);
			return;
		}
		// vcc tel nativa
		let areas = m_telephone_codes.getAreasByCode(country);
		if (!areas || (country || "").toUpperCase() === "GLOBAL") {
			$area.html("");
			this.frm.disable_control($area, true);
			return;
		}
		const attr_name = "name";
		const attr_id = "code";
		/*
			En la lista de "areas" hay que manejar diferente al primer elemento "blank" del combo.
			Esto porque en TODOS los combos que utilizamos el elemento "blank" tiene como "value" del <option> el valor "" (vacio).
			Esto funciona bien en todos lados, menos con los "code areas", ya que aca existe un elemento con Id "" que es el "Fixed Lines".
			Esto hace que el combo tenga 2 items con el mismo Id, y aqui el error.
			Para solucionar esto, al elemento "blank" de este combo le ingresamos una palabra clave "__BLANK" que se asignara en el atributo "value" del <option>
		*/
		let is_blank_first_item = function() {
			return {
				id: "", //id: "__BLANK",
				name: ""
			};
		};
		if (parseInt(country, 10) === 598) {
			// el caso de Uruguay no puede quedar un item vacio "" ya que en "fixed lines" su id es un item en blanco y estariamos duplicando el id.
			is_blank_first_item = false;
		}
		this.frm.fill_combo($area, is_blank_first_item, areas, attr_id, attr_name);
	};

	popup_outbound_engine_imports_format.prototype.__categorize_areas_by_country = function(list)
	{
		const self = this;
		this.list_areas_by_country = {};
		$.each(list, function(_, area) {
			self.list_areas_by_country[area.CountryID] = self.list_areas_by_country[area.CountryID] || [];
			self.list_areas_by_country[area.CountryID].push(area);
		});
	};

	popup_outbound_engine_imports_format.prototype.__get_areas_by_country = function(country)
	{
		if (!this.list_areas_by_country) {
			return;
		}
		return this.list_areas_by_country[country];
	};

	popup_outbound_engine_imports_format.prototype.__get_filed_type_value = function(field_number)
	{
		field_number = parseInt(field_number, 10);
		if (isNaN(field_number)) {
			return "";
		}
		if (!this.list_field_types_by_value || !this.list_field_types_by_value[field_number]) {
			return field_number;
		}
		return this.list_field_types_by_value[field_number];
	};

	popup_outbound_engine_imports_format.prototype.__new_grids = function()
	{
		const self = this;

		this.form_paginator_mapped_fields = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_IMPORT_MAPPED_FIELDS",
			owner: this,
			frm: this.frm,
			display_name: "Name",
			rows_per_page: 500,
			show_at_least: 499,
			without_paginator: true,
			ids: {
				grid: "out_form_import_edit_field_map_popup_list",
				paginator: "out_form_import_edit_field_map_popup_paginator",
				not_results_found: "out_form_import_edit_field_map_popup_not_results_found",
				container_new_btn: "out_form_import_edit_field_map_popup_list_container",
				new_item: "out_form_import_edit_field_map_popup_new",
				//popup
				popup: "out_form_import_edit_field_map_area",
				popup_msg: "out_form_import_edit_field_map_area_message",
				popup_create: "out_form_import_edit_field_map_area_create",
				popup_create_and_continue: "out_form_import_edit_field_map_area_create_and_continue",
				popup_title: "out_form_import_edit_field_map_area_title",
				popup_close: "out_form_import_edit_field_map_area_close",
				popup_input_id: "out_form_import_edit_field_map_area_name"
			},
			strings: {
				not_results_found         : "<%=_T('No Mapped Fields found. Please add field.')%>",
				can_remove                : "<%=_T('Do you want to delete Mapped Fields: {0} ?')%>",
				button_create             : "<%=_T('Confirm')%>",
				button_create_and_continue: "<%=_T('Confirm & continue')%>"
			},
			columns: [
				{id: "_number"  , name: "", type: "counter"},
				{id: "Type"     , name: "<%=_T('Field Type')%>", get_value: function(item) {
					return self.get_grid_value(item, "Type");
				}},
				{id: "Name"     , name: "<%=_T('Get Data From Column')%>"},
				{id: "_action", name: "",
					system_action: { edit: true, erase: true }
				}
			],
			callbacks: {
				on_closed_popup: function() {
					const $save_map = $("#out_form_import_edit_field_map_popup_create");
					const $close_popup = $("#out_form_import_edit_field_map_popup_close");
					$save_map.prop("disabled", false);
					$close_popup.prop("disabled", false);
					// visulizo la grilla luego de cerrar el popup
					$("#out_form_import_edit_field_map_popup_grid_container").show();
				},
				save: function(callback) {
					self.__add_or_update_mapped_field(callback);
				},
				edit: function(row) {
					self.__on_edit_mapped_field(row);
				},
				load_items: function(_, callback = $.noop) {
					let list = self.__filter_format_fields();
					callback(true, list);
				}
			},
			validate: {
				get_message_container: function() {
					return $("#out_form_import_edit_field_map_popup_message");
				},
				required_msg: "<%=_T('The field type NAME is required in the mapping field.')%>",
				required: function() {
					return self.__validate_mapped_fields();
				}
			}
		});
	};

	popup_outbound_engine_imports_format.prototype.__filter_format_fields = function()
	{
		var csv_header = this.frm.get_csv_header();
		var must_add = function(format_field) {
			if (!csv_header) {
				return false;
			}
			var name = format_field.Name;
			if (typeof(name) !== "string") {
				return false;
			}
			for (var i = 0; i < csv_header.length; i++) {
				if (csv_header[i].match(new RegExp(name, "i"))) {
					return true;
				}
			}
			return false;
		};

		var current_import_fields = (this.current_import_format && this.current_import_format.ContactImportFormatFields) ? this.current_import_format.ContactImportFormatFields : [];
		var filtered_format_fields = [];

		$.each(current_import_fields, function(_, format_field) {
			if (must_add(format_field)) {
				filtered_format_fields.push(format_field);
			}
		});

		var not_added = current_import_fields.length - filtered_format_fields.length;
		if (not_added > 0) {
		// Si el CSV no tiene todos los campos del current import format, se visualiza mensaje el mensaje de advertencia correspondiente.
			var $err_msg_container = $("#out_form_import_edit_field_map_popup_message");
			var msg = FORMAT("<%=_T('{0} fields were not present in the current file header and were removed.')%>", not_added);
			var $grid = $("#out_form_import_edit_field_map_popup_list");
			this.frm.show_validation_error($grid, msg, undefined, undefined, undefined, $err_msg_container);
		}

		return filtered_format_fields;
	};

	popup_outbound_engine_imports_format.prototype.__cleanup_mapped_field_ctrls = function()
	{
		var $field_type = $("#out_form_import_edit_field_map_area_field_type");
		$field_type.val("").trigger("change");
		var must_select_blank_item = true;
		this.frm.disable_control($field_type, false, true, undefined, undefined, must_select_blank_item);

		// BASCI DATA
		$("#out_form_import_edit_field_map_area_basic_columns").val("");

		// ECD_PHONEDATA:
		$("#out_form_import_edit_field_map_area_phone_number").val("");
		$("#out_form_import_edit_field_map_area_phone_ext").val("");
		$("#out_form_import_edit_field_map_area_phone_zip").val("");
		$("#out_form_import_edit_field_map_area_phone_type").val("");
		$("#out_form_import_edit_field_map_area_phone_country").val(0).trigger("change");
		$("#out_form_import_edit_field_map_area_phone_area").val("");
		// ECD_PHONEDATA->Channels
		if (!inConcert.app.has_allegro_integration()) {
			const $phone_channels = $("#out_form_import_edit_field_map_phone_channels");
			$phone_channels.find("[address_phone_channel]").prop("checked", false);
			let default_channel = "CALL";
			$phone_channels.find(`[address_phone_channel='${default_channel}']`).prop("checked", true);
		}
	
		//ECD_ADDRESS
		$("#out_form_import_edit_field_map_area_address_column").val("");
		$("#out_form_import_edit_field_map_area_address_type").val("");
		$("#out_form_import_edit_field_map_area_address_country").val(0).trigger("change");
		$("#out_form_import_edit_field_map_area_address_area").val("");

		//ECD_MAIL
		$("#out_form_import_edit_field_map_area_email_address").val("");
		$("#out_form_import_edit_field_map_area_email_type").val("");

		//ECD_NAMEVALUE
		$("#out_form_import_edit_field_map_area_name_value_column").val("");
		$("#out_form_import_edit_field_map_area_name_value_field").val("");
		$("#out_form_import_edit_field_map_area_name_value_allow_dup").prop("checked", false);
		if (!inConcert.app.has_allegro_integration()) {
			// NAMEVALUE SEARCHABLE
			$("#out_form_import_edit_field_map_area_name_value_is_serchable").prop("checked", false).trigger("change");
			$("#out_form_import_edit_field_map_area_name_value_is_serchable_data_type").val("");
			// SKILL MODE
			$("#out_form_import_edit_field_map_area_skill_required_mode").val("").trigger("change");
		}

		//ECD_CUSTOMVALUE
		$("#out_form_import_edit_field_map_area_custom_column").val("");
		$("#out_form_import_edit_field_map_area_custom_field").val("");

		//ECD_SCHEDULE
		$("#out_form_import_edit_field_map_area_scheduled_column").val("");
		$("#out_form_import_edit_field_map_area_scheduled_format").val("");
		$("#out_form_import_edit_field_map_area_scheduled_timezone").val("");

		//ECD_SKILL
		$("#out_form_import_edit_field_map_area_skill_column").val("");
		$("#out_form_import_edit_field_map_area_skill_type").val("");
		$("#out_form_import_edit_field_map_area_skill_required_column").val("");
	};

	popup_outbound_engine_imports_format.prototype.__on_edit_mapped_field = function(mapped_field)
	{
		this.__cleanup_mapped_field_ctrls();

		const $save_map = $("#out_form_import_edit_field_map_popup_create");
		const $close_popup = $("#out_form_import_edit_field_map_popup_close");
		$save_map.prop("disabled", true);
		$close_popup.prop("disabled", true);
		// oculto la grilla luego de abrir el popup
		$("#out_form_import_edit_field_map_popup_grid_container").hide();

		if (!mapped_field) {
		// Nuevo mapeo de campos
			this.edited_mapped_field = null;
			return;
		}

		// Edicion de mapeo de campos.
		this.edited_mapped_field = mapped_field;

		var $field_type = $("#out_form_import_edit_field_map_area_field_type");
		this.frm.disable_control($field_type, true);
		$field_type.val(mapped_field.Type + 1).trigger("change");

		switch (mapped_field.Type)
		{
			case this.extended_codes.ECD_PHONEDATA:
				$("#out_form_import_edit_field_map_area_phone_number").val(mapped_field.Name);
				let phoneCountry = parseInt(mapped_field.PhoneCountry, 10);
				if (inConcert.app.has_allegro_integration()) {
					$("#out_form_import_edit_field_map_area_phone_ext").val(mapped_field.PhoneExtensionColumn);
					$("#out_form_import_edit_field_map_area_phone_zip").val(mapped_field.PhoneZIPColumn);
				}
				$("#out_form_import_edit_field_map_area_phone_type").val(mapped_field.ContactAddressType);
				// si valor del mapped_field = 0, al combo se le asigna '' (vacio) ya que no funciona correctamente el valor 0 como clave de un combo.
				$("#out_form_import_edit_field_map_area_phone_country").val(phoneCountry).trigger("change");
				if (mapped_field.PhoneArea !== null) {
					$("#out_form_import_edit_field_map_area_phone_area").val(mapped_field.PhoneArea);
				}
				// Channels
				if (!inConcert.app.has_allegro_integration()) {
					const $phone_channels = $("#out_form_import_edit_field_map_phone_channels");
					$phone_channels.find("[address_phone_channel]").prop("checked", false);
					(mapped_field.Channels || []).forEach(channel => {
						channel = channel.toUpperCase();
						const $channel = $phone_channels.find(`[address_phone_channel='${channel}']`);
						$channel.prop("checked", true);
					});
				}

			break;
			case this.extended_codes.ECD_ADDRESS:
				$("#out_form_import_edit_field_map_area_address_column").val(mapped_field.Name);
				$("#out_form_import_edit_field_map_area_address_type").val(mapped_field.ContactAddressType);
				// si valor del mapped_field = 0, al combo se le asigna '' (vacio) ya que no funciona correctamente el valor 0 como clave de un combo.
				let addressCountry = parseInt(mapped_field.AddressCountry, 10);
				$("#out_form_import_edit_field_map_area_address_country").val(addressCountry).trigger("change");
				if (mapped_field.AddressArea !== null) {
					$("#out_form_import_edit_field_map_area_address_area").val(mapped_field.AddressArea);
				}

			break;
			case this.extended_codes.ECD_MAIL:
				$("#out_form_import_edit_field_map_area_email_address").val(mapped_field.Name);
				$("#out_form_import_edit_field_map_area_email_type").val(mapped_field.ContactAddressType);

			break;
			case this.extended_codes.ECD_NAMEVALUE:
				$("#out_form_import_edit_field_map_area_name_value_column").val(mapped_field.Name);
				$("#out_form_import_edit_field_map_area_name_value_field").val(mapped_field.MappedField);
				$("#out_form_import_edit_field_map_area_name_value_allow_dup").prop("checked", mapped_field.MappedFieldAllowsDuplicates === 1);
				if (!inConcert.app.has_allegro_integration()) {
					// name value serchable data type
					$("#out_form_import_edit_field_map_area_name_value_is_serchable").prop("checked", mapped_field.IsSearchable).trigger("change");
					$("#out_form_import_edit_field_map_area_name_value_is_serchable_data_type").val(mapped_field.SearchableDataType || "");
				}

			break;
			case this.extended_codes.ECD_CUSTOMVALUE:
				$("#out_form_import_edit_field_map_area_custom_column").val(mapped_field.Name);
				$("#out_form_import_edit_field_map_area_custom_field").val(mapped_field.MappedField);

			break;
			case this.extended_codes.ECD_SCHEDULE:
				$("#out_form_import_edit_field_map_area_scheduled_column").val(mapped_field.Name);
				if (inConcert.app.has_allegro_integration()) {
					$("#out_form_import_edit_field_map_area_scheduled_format").val(mapped_field.ScheduledFormat);
					$("#out_form_import_edit_field_map_area_scheduled_timezone").val(mapped_field.ScheduledTimezone);
				}

			break;
			case this.extended_codes.ECD_SKILL: 
				$("#out_form_import_edit_field_map_area_skill_column").val(mapped_field.Name);
				$("#out_form_import_edit_field_map_area_skill_type").val(mapped_field.SkillType);
				$("#out_form_import_edit_field_map_area_skill_required_column").val(mapped_field.SkillReqColumn);
				if (!inConcert.app.has_allegro_integration()) {
					// SKILL MODE
					$("#out_form_import_edit_field_map_area_skill_required_mode").val(mapped_field.Mode || "REQUIRED").trigger("change");
				}

			break;
			default:
				$("#out_form_import_edit_field_map_area_basic_columns").val(mapped_field.Name);
		}
	};

	popup_outbound_engine_imports_format.prototype.__get_mapped_field = function()
	{
		let field_type = this.__get_field_type_value();

		if (field_type === null || field_type < 0 || field_type > 14) {
			return null;
		}
		let mapped_field = {
			Type: field_type,
			Status: "ENABLED"
		};

		switch (field_type) {
			case this.extended_codes.ECD_PHONEDATA:
				//la columna de donde sale el numero de telefono
				mapped_field.Name = $("#out_form_import_edit_field_map_area_phone_number").val();
				// address Type
				mapped_field.ContactAddressType = $("#out_form_import_edit_field_map_area_phone_type").val();

				//country
				let phoneCountry = $("#out_form_import_edit_field_map_area_phone_country").val();
				// si valor del combo country es = '' (largo 0 'cero') se le asigna el valor 0.
				//	esto es asi porque a los combo no se le puede poner valor 0 como id de un item. Y esto da error con el item global settings ya que este tiene el id 0 'cero'.
				mapped_field.PhoneCountry = (phoneCountry && phoneCountry.length === 0 ? 0 : parseInt(phoneCountry, 10));
				//area code
				let phoneArea = $("#out_form_import_edit_field_map_area_phone_area").val();
				// si valor del combo area es = '' (largo 0 'cero') se le asigna el valor null
				//	esto es asi porque a los combo no se le puede poner valor 0 como id de un item.
				mapped_field.PhoneArea = phoneArea === 0 ? null : phoneArea;

				if (inConcert.app.has_allegro_integration()) {
				// vcc allegro
					//puedo tener columna seteada para la extension
					mapped_field.PhoneExtensionColumn = $("#out_form_import_edit_field_map_area_phone_ext").val();
					//idem para zipphone
					mapped_field.PhoneZIPColumn = $("#out_form_import_edit_field_map_area_phone_zip").val();
				}
				else {
				// vcc Teli6
					// Channels
					mapped_field.Channels = [];
					const $address_phone_channel_selectors = $("#out_form_import_edit_field_map_phone_channels").find("[address_phone_channel]");
					$.each($address_phone_channel_selectors, function(_, channel) {
						const $channel = $(channel);
						if ($channel.prop("checked")) {
							mapped_field.Channels.push($channel.attr("address_phone_channel"));
						}
					});
				}
			break;
			case this.extended_codes.ECD_ADDRESS:
				//la columna de donde sale la direccion
				mapped_field.Name = $("#out_form_import_edit_field_map_area_address_column").val();
				//country y area code
				let addressCountry =  $("#out_form_import_edit_field_map_area_address_country").val();
				// si valor del combo country es = '' (largo 0 'cero') se le asigna el valor 0.
				//	esto es asi porque a los combo no se le puede poner valor 0 como id de un item. Y esto da error con el item global settings ya que este tiene el id 0 'cero'.
				mapped_field.AddressCountry = (addressCountry && addressCountry.length === 0 ? 0 : parseInt(addressCountry, 10));
				let addressArea = parseInt($("#out_form_import_edit_field_map_area_address_area").val(), 10);
				// si valor del combo area es = '' (largo 0 'cero') se le asigna el valor null
				//	esto es asi porque a los combo no se le puede poner valor 0 como id de un item.
				mapped_field.AddressArea = addressArea === 0 ? null : addressArea;
				mapped_field.ContactAddressType = $("#out_form_import_edit_field_map_area_address_type").val();

			break;
			case this.extended_codes.ECD_MAIL:
				//la columna de donde sale el mail
				mapped_field.Name = $("#out_form_import_edit_field_map_area_email_address").val();
				mapped_field.ContactAddressType = $("#out_form_import_edit_field_map_area_email_type").val();
			break;
			case this.extended_codes.ECD_NAMEVALUE:
				//la columna de donde sale el nombre del campo dinamico a mapear
				mapped_field.Name = $("#out_form_import_edit_field_map_area_name_value_column").val();
				mapped_field.MappedField = $("#out_form_import_edit_field_map_area_name_value_field").val();
				mapped_field.MappedFieldAllowsDuplicates = $("#out_form_import_edit_field_map_area_name_value_allow_dup").prop("checked") ? 1 : 0;
				if (!inConcert.app.has_allegro_integration()) {
					mapped_field.IsSearchable = $("#out_form_import_edit_field_map_area_name_value_is_serchable").prop("checked");
					if (mapped_field.IsSearchable) {
						mapped_field.SearchableDataType = $("#out_form_import_edit_field_map_area_name_value_is_serchable_data_type").val();
					}
				}
			break;
			case this.extended_codes.ECD_CUSTOMVALUE:
				mapped_field.Name = $("#out_form_import_edit_field_map_area_custom_column").val();
				mapped_field.MappedField = $("#out_form_import_edit_field_map_area_custom_field").val();
			break;
			case this.extended_codes.ECD_SCHEDULE:
				//la columna de donde sale la fecha de scheduleado
				mapped_field.Name = $("#out_form_import_edit_field_map_area_scheduled_column").val();
				if (inConcert.app.has_allegro_integration()) {
					mapped_field.ScheduledFormat = $("#out_form_import_edit_field_map_area_scheduled_format").val();
					mapped_field.ScheduledTimezone = $("#out_form_import_edit_field_map_area_scheduled_timezone").val();
				}
			break;
			case this.extended_codes.ECD_SKILL:
				mapped_field.Name = $("#out_form_import_edit_field_map_area_skill_column").val();
				mapped_field.SkillType = $("#out_form_import_edit_field_map_area_skill_type").val();
				mapped_field.SkillReqColumn = $("#out_form_import_edit_field_map_area_skill_required_column").val();
				if (!inConcert.app.has_allegro_integration()) {
					// SKILL MODE
					mapped_field.Mode = $("#out_form_import_edit_field_map_area_skill_required_mode").val();
				}
			break;
			default:
				//es un tipo basico
				mapped_field.Name = $("#out_form_import_edit_field_map_area_basic_columns").val();
		}

		// el Id es algo interno que necesita la grilla "conf_form_paginator" para actualizar la informacion
		if (this.edited_mapped_field) {
			mapped_field.id = this.edited_mapped_field.id;
		}

		return mapped_field;
	};

	popup_outbound_engine_imports_format.prototype.__is_basic_code = function(code)
	{
		code = parseInt(code, 10);
		var is_basic_code = (code <= 6 && code >= 0);
		return is_basic_code;
	};

	popup_outbound_engine_imports_format.prototype.__is_reserved_word = function(word)
	{
		if (typeof(word) !== "string") {
			return false;
		}
		if (!this.list_reserverd_words) {
			return false;
		}
		word = word.toUpperCase();
		var is_reserved_word = this.list_reserverd_words[word];
		return is_reserved_word;
	};

	popup_outbound_engine_imports_format.prototype.__validate_mapped_field = function(mapped_field, current_mapped_fields)
	{
		const self = this;

		let response = {success: true, msg: null, type: null};


		this.__hide_messages(); // oculto todos los errores de los campos
		const validate_field = function($ctrl, type, msg) {
			return self.frm.validate_field($ctrl, type, msg);
		};

		if (!mapped_field) {
			response.success = false;
			response.type = "Error";
			response.msg = "<%=_T('Unable to add mapped field.')%>";
			return response;
		}

		// Field Type
		const $field_type = $("#out_form_import_edit_field_map_area_field_type");
		if (!validate_field($field_type, "required")) {
			response.success = false;
			response.type = "Error";
			response.msg = "<%=_T('Field type is required.')%>";
			return response;
		}

		switch (mapped_field.Type) {
			case this.extended_codes.ECD_PHONEDATA:
				// phone number
				const $phone_number = $("#out_form_import_edit_field_map_area_phone_number");
				if (!validate_field($phone_number, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Phone number is required.')%>";
					return response;
				}
				// phone type
				const $phone_type = $("#out_form_import_edit_field_map_area_phone_type");
				if (!validate_field($phone_type, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Phone type is required.')%>";
					return response;
				}
				// phone country
				const $phone_country = $("#out_form_import_edit_field_map_area_phone_country");
				if (!validate_field($phone_country, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Phone country is required.')%>";
					return response;
				}
				if (!inConcert.app.has_allegro_integration()) {
					// channels
					const $address_phone_channels_selected = $("#out_form_import_edit_field_map_phone_channels").find("[address_phone_channel]:checked");
					if ($address_phone_channels_selected.length < 1) {
						response.success = false;
						response.type = "Error";
						response.msg = "<%=_T('You must select at least one channel.')%>";
						return response;
					}
				}
			break;
			case this.extended_codes.ECD_ADDRESS:
				// address column
				const $address_column = $("#out_form_import_edit_field_map_area_address_column");
				if (!validate_field($address_column, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Address column is required.')%>";
					return response;
				}
				// addresss type
				const $address_type = $("#out_form_import_edit_field_map_area_address_type");
				if (!validate_field($address_type, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Address type is required.')%>";
					return response;
				}
				// addresss country
				const $address_country = $("#out_form_import_edit_field_map_area_address_country");
				if (!validate_field($address_country, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Address country is required.')%>";
					return response;
				}

			break;
			case this.extended_codes.ECD_MAIL:
				// email address column
				const $email_address = $("#out_form_import_edit_field_map_area_email_address");
				if (!validate_field($email_address, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Email address column is required.')%>";
					return response;
				}

				// email type
				const $email_type = $("#out_form_import_edit_field_map_area_email_type");
				if (!validate_field($email_type, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Email type column is required.')%>";
					return response;
				}
			break;
			case this.extended_codes.ECD_NAMEVALUE:
				// name value column
				const $name_value_column = $("#out_form_import_edit_field_map_area_name_value_column");
				if (!validate_field($name_value_column, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Name value column is required.')%>";
					return response;
				}

				// name value field
				const $name_value_field = $("#out_form_import_edit_field_map_area_name_value_field");
				if (!validate_field($name_value_field, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Name value field is required.')%>";
					return response;
				}
				const is_reserved_word = this.__is_reserved_word($name_value_field.val());
				if (is_reserved_word) {
					this.frm.show_validation_error($name_value_field);
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('This is a system reserved field name, please choose another one.')%>";
					return response;
				}
				if (!inConcert.app.has_allegro_integration()) {
					// name value searchable data type
					if (mapped_field.IsSearchable) {
						const $is_serchable_data_type = $("#out_form_import_edit_field_map_area_name_value_is_serchable_data_type");
						if (!validate_field($is_serchable_data_type, "required")) {
							response.success = false;
							response.type = "Error";
							response.msg = "<%=_T('Name value field searchable data type is required.')%>";
							return response;
						}
					}
				}

			break;
			case this.extended_codes.ECD_CUSTOMVALUE:
				// custom value column
				const $custom_column = $("#out_form_import_edit_field_map_area_custom_column");
				if (!validate_field($custom_column, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Custom value column is required.')%>";
					return response;
				}
				// custom value field
				const $custom_field = $("#out_form_import_edit_field_map_area_custom_field");
				if (!validate_field($custom_field, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Custom value field is required.')%>";
					return response;
				}

			break;
			case this.extended_codes.ECD_SCHEDULE:
				// scheduled column
				const $scheduled_column = $("#out_form_import_edit_field_map_area_scheduled_column");
				if (!validate_field($scheduled_column, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Scheduled column field is required.')%>";
					return response;
				}
				if (inConcert.app.has_allegro_integration()) {
					// scheduled format
					const $scheduled_format = $("#out_form_import_edit_field_map_area_scheduled_format");
					if (!validate_field($scheduled_format, "required")) {
						response.success = false;
						response.type = "Error";
						response.msg = "<%=_T('Scheduled format field is required.')%>";
						return response;
					}
					// scheduled timezone
					const $scheduled_timezone = $("#out_form_import_edit_field_map_area_scheduled_timezone");
					if (!validate_field($scheduled_timezone, "required")) {
						response.success = false;
						response.type = "Error";
						response.msg = "<%=_T('Scheduled timezone field is required.')%>";
						return response;
					}
				}

			break;
			case this.extended_codes.ECD_SKILL:
				// skill type
				const $skill_type = $("#out_form_import_edit_field_map_area_skill_type");
				if (!validate_field($skill_type, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Skill type field is required.')%>";
					return response;
				}
				// skill column
				const $skill_column = $("#out_form_import_edit_field_map_area_skill_column");
				if (!validate_field($skill_column, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Skill column field is required.')%>";
					return response;
				}
				// skill mode
				if (!inConcert.app.has_allegro_integration()) {
					const $skill_mode = $("#out_form_import_edit_field_map_area_skill_required_mode");
					if (!validate_field($skill_mode, "required")) {
						response.success = false;
						response.type = "Error";
						response.msg = "<%=_T('Skill mode field is required.')%>";
						return response;
					}
				}
			break;
			default:
				// Id
				const $basic_columns = $("#out_form_import_edit_field_map_area_basic_columns");
				if (!validate_field($basic_columns, "required")) {
					response.success = false;
					response.type = "Error";
					response.msg = "<%=_T('Use column is required.')%>";
					return response;
				}
		}
		// valida que no se agreguen repetidos en la grilla
		$.each(current_mapped_fields, function(_, currend_field) {
			if (currend_field.Type === mapped_field.Type && currend_field.id !== mapped_field.id) {
				if (self.__is_basic_code(mapped_field.Type)) {
					response.success = false;
					response.type = "Error";
					const type_name  = self.__get_filed_type_value(mapped_field.Type);
					response.msg = FORMAT("<%=_T('Field Type {0} already mapped')%>", type_name);
					return false; // break
				}
				if (currend_field.Name === mapped_field.Name) {
					response.success = false;
					response.type = "Error";
					response.msg = FORMAT("<%=_T('Column {0} already mapped to this field type')%>", mapped_field.Name);
					return false; // break
				}
			}
		});
		// ok
		return response;
	};

	popup_outbound_engine_imports_format.prototype.__add_or_update_mapped_field = function(callback = $.noop)
	{
		const current_mapped_fields = this.form_paginator_mapped_fields.get_items();
		const mapped_field = this.__get_mapped_field();
		const response = this.__validate_mapped_field(mapped_field, current_mapped_fields);
		if (!response.success) {
			callback(false, null, response);
			return;
		}
		this.__cleanup_mapped_field_ctrls();
		callback(true, mapped_field);
	};

	popup_outbound_engine_imports_format.prototype.get_grid_value = function(item, field_id)
	{
		var value = {
			original_value: "",
			value         : "",
			search_value  : ""
		};

		var item_value = item[field_id];
		if (item_value === undefined) {
			item_value = "";
		}

		value.original_value = item_value;
		value.value = item_value;
		value.search_value = item_value;

		// XXXXXXXXXXXXXXXXXXXXXXXX
		if (field_id === "Type") {
			item_value = this.__get_filed_type_value(item_value);
			value.value = item_value;
			value.search_value = item_value;
		}

		return value;
	};

	//---------------------------------------------------------------------
	// form imports class
	function form_outbound_engine_imports(params)
	{
		const self = this;
		let success = form_outbound_engine_imports.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title = "<%=_T('New Import')%>";
		this.update_title = "<%=_T('Update Importation {0}')%>";//Update Outbound Processes {0}
		this.view_title = "<%=_T('View Imports {0}')%>";
		this.tagline = "<%=_T('Tagline form Import!!!')%>";

		this.html_file_name = "/inconcert/apps/outbound_engine/imports/frm/render/";
		this.get_uri =        "/inconcert/apps/outbound_engine/imports/get/";

		this.popup_imports_format = new popup_outbound_engine_imports_format({frm: this});
		this.form_paginator_past = null;
		this.__new_grids();

		this.csv_header = null;
		this.list_formats = [];

		this.import_started_timestamp = null;
		this.is_uploaded_file = false;

		this.blacklists_mng_instance = null;

		this.upload_instance = new inConcert.RepositoryUpload({
			container_id: "out_form_import_upload",
			must_validate_max_size: false,
			availables_extensions: {
				"csv": true
			},
			show_status_message_fn: function(message, type, time_ms) {
				self.show_status_message(message, type, time_ms);
			},
			on_uploading_fn: function(success, data) {
				self.on_uploading_fn(success, data);
			},
			on_uploaded_fn: function(success, data, callback) {
				self.on_uploaded(success, data, callback);
			},
			can_upload_file_fn: function(callback) {
				callback = callback || $.noop;
				self.can_upload_file(callback);
			}
		});

		return true;
	}

	inConcert.Utils.inherit(form_outbound_engine_imports, inConcert.conf_form);

	if (typeof inConcert.form_outbound_engine_imports !== "function") {
		inConcert.form_outbound_engine_imports = form_outbound_engine_imports;
	}

	form_outbound_engine_imports.prototype.initialize = function()
	{
		this.upload_instance.initialize();
		this.popup_imports_format.initialize();
		this.initialize_blacklists_mng();
		this.is_uploaded_file = false;
		this.csv_header = null;
	};

	form_outbound_engine_imports.prototype.dispose = function()
	{
		form_outbound_engine_imports.uber.dispose.call(this); //invokes the base class method
		this.upload_instance.dispose();
		this.is_uploaded_file = false;
		this.csv_header = null;
		this.m_mustExecuteGoBackToGridAfterSaved = false;
	};

	form_outbound_engine_imports.prototype.get = function()
	{
		const duplicate_check = $("#out_form_import_duplicate_check").val();
		const duplicate_solver = $("#out_form_import_duplicte_solver").val();

		let importation =  {
			IsUpdate        : this.is_new ? false: true,
			ID              : $("#out_form_import_id").val(),
			DBProvider      : $("#out_form_import_data_provider").val(),
			Format          : $("#out_form_import_field_map").val(),
			DuplicateCheck  : duplicate_check || "None",
			DuplicateSolver : duplicate_solver || "",
			IsVipImport     : $("#out_form_import_vip_import").prop("checked"),
			AreClientsImport: $("#out_form_import_are_client_import").prop("checked"),
			FileInfo        :  this.upload_instance.get_info_uploaded_files()
		};
		if (importation.DuplicateCheck.toLowerCase() === "none") {
			importation.DuplicateCheck = "Key";
		}
		if (importation.DuplicateSolver.length === 0 || importation.DuplicateSolver.toLowerCase() === "none") {
			importation.DuplicateSolver = "KeepNew";
		}
		if (!inConcert.app.has_allegro_integration()) {
			importation.Blacklists = this.blacklists_mng_instance.get();
		}
		return importation;
	};

	form_outbound_engine_imports.prototype.set = function(success, importation)
	{
		this.form_paginator_past.initialize();
		if (!success) {
			return;
		}
		$("#out_form_import_id").val(importation.ID);
		$("#out_form_import_data_provider").val(importation.DBProvider);
	};

	form_outbound_engine_imports.prototype.can_upload_file = function(callback =  $.noop)
	{
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.hasSomeImportationRunning(function(success, response)
		{
			let err;
			if (!success) {
				err = "<%=_T('Unable to Upload File.')%>";
				callback(false, err);
				return;
			}
			if (response.isRunning) {
				err = "<%=_T('Unable to Upload File. Exists another importation in process. please try again later.')%>";
				callback(false, err);
				return;
			}
			callback(true);
		});
	};

	form_outbound_engine_imports.prototype.on_uploading_fn = function()
	{
		this.disable_footer_buttons(true);
	};

	form_outbound_engine_imports.prototype.on_uploaded = function(success, data, callback)
	{
		callback = callback || $.noop;
		const self = this;

		this.disable_footer_buttons(false);

		if (!success) {
			this.disable_mapping_info(true);
			callback();
		}
		else {
			var outbound_engine_api = inConcert.app.getOutboundEngineAPI();
			outbound_engine_api.importGetUploadedCSVHeader({fileId: data.fileId}, function(success, csv_header)
			{
				if (success) {
					self.csv_header = csv_header;
				}
				else {
					self.show_status_message("<%=_T('Unable retrieving uploaded File Info')%>", "Error", 5000);
				}
			});
			this.disable_mapping_info(false);
			callback();
		}
	};

	form_outbound_engine_imports.prototype.__new_grids = function()
	{
		const self = this;

		if (inConcert.app.has_allegro_integration()) {
			// Instancia de la grilla para VCC CON Integracion con Allegro.
			this.form_paginator_past = new inConcert.conf_form_paginator({
				paginator_name: "OUTBOUND_IMPORT_PAST",
				owner: this,
				frm: this,
				row_id: "Update#",
				display_name: "Date",
				rows_per_page: 10,
				show_at_least: 9,
				ids: {
					grid: "out_form_import_past_list",
					paginator: "out_form_import_past_paginator",
					not_results_found: "out_form_import_past_not_results_found",
				},
				strings: {
					not_results_found: "<%=_T('No Past found.')%>"
				},
				columns: [
					{id: "_number"        , name: "", type: "counter"         },
					{id: "Date"           , name: "<%=_T('Date')%>",
						type: "date", date_config: {utc: false, type_date: "full", format_date: "ymd", separator_date: "-"}
					},
					{id: "ImportUser"     , name: "<%=_T('User')%>"           },
					{id: "ValidContacts"  , name: "<%=_T('Valid')%>"          },
					{id: "NewContacts"    , name: "<%=_T('New')%>"            },
					{id: "UpdatedContacts", name: "<%=_T('Updated')%>"        },
					{id: "InvalidContacts", name: "<%=_T('Invalid')%>"        },
					{id: "FailedContats"  , name: "<%=_T('Failed Contacts')%>"},
					{id: "_action", name: "",
						is_enabled: function(action_id, importation) {
							if (action_id === "download") {
								if (!importation || !importation.AvailableInvalidContactsFile) {
									return 0;
								}
								if (importation.AvailableInvalidContactsFile === "AVAILABLE_INVALID_CONTACTS_FILE") {
									return 1;
								}
							}
							return 0;
						},
						custom_action: {
							download: {
								//name: "<%=_T('Download')%>",
								execute: function($row /*, $owner*/)
								{
									var importation = $row.data("row_data");
									self.__download_failed_contacts(importation);
								},
								class_name: "far fa-download"
							}
						}
					}
				]
			});
			// me voy
			return;
		}
		// Instancia de la grilla para VCC SIN Integracion con Allegro.
		this.form_paginator_past = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_IMPORT_PAST",
			owner: this,
			frm: this,
			row_id: "DetailId",
			display_name: "Date",
			rows_per_page: 10,
			show_at_least: 9,
			ids: {
				grid: "out_form_import_past_list",
				paginator: "out_form_import_past_paginator",
				not_results_found: "out_form_import_past_not_results_found",
			},
			strings: {
				not_results_found: "<%=_T('No Past found.')%>"
			},
			columns: [
				{id: "_number"        , name: "", type: "counter"         },
				{
					id       : "StartDate",
					name     : "<%=_T('Date')%>",
					type     : "timestampSec",
					date_config: {utc: false, type_date: "full", format_date: "ymd", separator_date: "-"}
				},
				{id: "UserId"  , name: "<%=_T('User')%>"           },
				{id: "Added"   , name: "<%=_T('New')%>"            },
				{id: "Updated" , name: "<%=_T('Updated')%>"        },
				{id: "Errors"  , name: "<%=_T('Invalid')%>"        },
				{id: "Warnings", name: "<%=_T('Alerts')%>"         },
				{id: "_action" , name: "",
					is_enabled: function(action_id, importation = {}) {
						if (action_id === "download") {
							const { Warnings: warn = 0, Errors: err = 0 } = importation;
							if (warn > 0 || err > 0) {
								return 1;
							}
						}
						return 0;
					},
					custom_action: {
						download: {
							//name: "<%=_T('Download')%>",
							execute: function($row /*, $owner*/) {
								var importation = $row.data("row_data");
								self.__download_failed_contacts(importation);
							},
							class_name: "far fa-download"
						}
					}
				}
			]
		});
	};

	form_outbound_engine_imports.prototype.__download_failed_contacts = function(importation)
	{
		const self = this;
		if (!importation) {
			return;
		}
		let info = {};
		if (inConcert.app.has_allegro_integration()) {
			if (importation.AvailableInvalidContactsFile !== "AVAILABLE_INVALID_CONTACTS_FILE") {
				return;
			}
			info.ImportId = importation.ImportId;
			info.ImportDetailId = importation["Update#"];
		}
		else {
			if ((importation.Errors || 0) === 0 && (importation.Warnings || 0) === 0) {
				return;
			}
			info.ImportId = importation.ImportId;
			info.ImportDetailId = importation.DetailId;
		}
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.importDownloadFailedContacts(info, function(success/*, err*/) {
			if (!success) {
				self.show_status_message( "<%=_T('Unable to Download Failed Contacts.')%>", "Error", 5000 );
			}
		});
	};

	/*
		Retorna los datos de la grilla de Importaciones anteriores.
	*/
	form_outbound_engine_imports.prototype.load_items = function(_, callback = $.noop)
	{
		let importation = this.get_entity_instance();
		let list;
		if (inConcert.app.has_allegro_integration()) {
			list = importation.ContactImportDetails;
		}
		else {
			list = importation.Detail;
		}
		callback(true, list);
	};

	form_outbound_engine_imports.prototype.load_data = function(callback_complete_requests)
	{
		const self = this;

		var outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		this.requests = [
			{
				request_function: function(success) {
					return outbound_engine_api.importFormatsLoadAll(success);
				},
				success: function(list) {
					self.list_formats = list;
					self.__fill_formats(list);
				}
			}
		];

		var format_requests = this.popup_imports_format.make_requests_list();

		this.requests = this.requests.concat(format_requests);

		form_outbound_engine_imports.uber.load_data.call( this, callback_complete_requests ); //invokes the base class method
	};

	form_outbound_engine_imports.prototype.__fill_formats = function(list)
	{
		const $combo = $("#out_form_import_field_map");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "Id" /* attr_id */, "Id" /* attr_name */, true /* sorted */);
	};

	form_outbound_engine_imports.prototype.__fill_duplicate_check = function(list)
	{
		var $combo = $("#out_form_import_duplicate_check");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "description" /* attr_name */);
	};

	form_outbound_engine_imports.prototype.__fill_duplication_solver = function(list)
	{
		var $combo = $("#out_form_import_duplicte_solver");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "description" /* attr_name */);
	};

	form_outbound_engine_imports.prototype.__fill_format_check_and_solvers = function(f)
	{
		let check_options = 0;
		let none_deleted = false;
		let checks_list = {};
		const is_allegro = inConcert.app.has_allegro_integration();

		checks_list.None = {id: "None", description: "<%=_T('None')%>"};
		//los tipos de check de duplicates permitidos son segun los campos que tenga mapeados el formato(no puedo detectar por nombre si no hay nombre!)
		if (f) {
			let hashAdd = {};
			for (var i = 0; i < f.ContactImportFormatFields.length; i++) {
				var mappedField = f.ContactImportFormatFields[i];
				if (hashAdd[mappedField.Type] === true) {
					continue;
				}
				hashAdd[mappedField.Type] = true;
				switch (mappedField.Type) {
					//ID
					case 0:
						checks_list.Key = {id: "Key", description: "<%=_T('By contact id')%>"};
						delete checks_list.None;
						check_options++;
						none_deleted = true;
						break;
					//EXTERNAL ID
					case 1:
						if (!is_allegro) {
							checks_list.ExternalID = {id: "ExternalID", description: "<%=_T('By external id')%>"};
							delete checks_list.None;
							check_options++;
							none_deleted = true;
						}
						break;
					//NAME
					case 2:
						//name se supone que esta siempre!
						break;
					//PHONE
					case 7:
						checks_list.Phone     = {id: "Phone"    , description: "<%=_T('By contact phone')%>" };
						checks_list.NamePhone = {id: "NamePhone", description: "<%=_T('By phone and name')%>"};
						check_options++;
						break;
				}
			}
		}

		this.__fill_duplicate_check(checks_list);
		const $duplicate_check = $("#out_form_import_duplicate_check");
		this.disable_control($duplicate_check, true);

		let solvers_list = {};

		//los solvers son siempre los mismos sin importar el tipo de deteccion de duplicates
		if (check_options === 0) {
			$duplicate_check.val("None");
			solvers_list.KeepNew = {id: "KeepNew", description: ""};
			this.__fill_duplication_solver(solvers_list);
		} 
		else {
			this.disable_control($duplicate_check, false, true /* is_required */);
			solvers_list.KeepNew        = {id: "KeepNew"       , description: "<%=_T('Replace with new')%>"     };
			solvers_list.KeepOld        = {id: "KeepOld"       , description: "<%=_T('Keep current contact')%>" };
			solvers_list.AppendNewToOld = {id: "AppendNewToOld", description: "<%=_T('Append new to current')%>"};
			solvers_list.AppendOldToNew = {id: "AppendOldToNew", description: "<%=_T('Append current to new')%>"};
		}

		this.__fill_duplication_solver(solvers_list);

		const importation = this.get_entity_instance();
		if (importation) {
			if (importation.DuplicateCheck && importation.DuplicateCheck.length > 0) {
				if (importation.DuplicateCheck.toLowerCase() !== "none" || !none_deleted) {
					$duplicate_check.val(importation.DuplicateCheck);
				}
			}
			if (importation.DuplicateSolver && importation.DuplicateSolver.length > 0) {
				const $duplicate_solver = $("#out_form_import_duplicte_solver");
				$duplicate_solver.val(importation.DuplicateSolver);
			}
		}
	};

	form_outbound_engine_imports.prototype.set_events = function()
	{
		const self = this;

		var $new_field_map = $("#out_form_import_new_field_map");
		$new_field_map
			.off("click")
			.on("click", function()
			{
				self.__show_new_field_map_popup();
			});

		var $edit_field_map = $("#out_form_import_edit_field_map");
		$edit_field_map
			.off("click")
			.on("click", function()
			{
				self.__show_edit_field_map_popup();
			});

		var $field_map = $("#out_form_import_field_map");
		$field_map
			.off("change")
			.on("change", function()
			{
				$new_field_map.prop("disabled", false);
				var format_id = $field_map.val();
				if (format_id === "") {
					$edit_field_map.prop("disabled", true);
					self.__fill_format_check_and_solvers(null);
				}
				else {
					$edit_field_map.prop("disabled", false);
					$.each(self.list_formats, function(_, f) {
						if (f.Id === format_id) {
							self.__fill_format_check_and_solvers(f);
							return false; // break
						}
					});
				}
			});

		var $duplicate_solver = $("#out_form_import_duplicte_solver");

		var $duplicate_check = $("#out_form_import_duplicate_check");
		$duplicate_check
			.off("change")
			.on("change", function() {
				var check_id = $duplicate_check.val().toLowerCase();
				var is_none = check_id === "none" || check_id === "";
				var is_required = false;
				if (is_none) {
					$duplicate_solver.val("");
				}
				else {
					is_required = true;
				}
				self.disable_control($duplicate_solver, is_none, is_required);
			});

		var $alert = $("#out_form_import_alert");
		var $client_import = $("#out_form_import_are_client_import");
		var on_changed_client_import = function()
		{
			if ($client_import.prop("checked")) {
				$alert.text("<%=_T([[Please be warned, these contacts will be called on any telesales campaign overriding government do not call lists. Double check you have a business relationship with these people if you wan't to avoid legal fees that may apply.]])%>");
				$alert.show();
			}
			else {
				$alert.text("");
				$alert.hide();
			}
		};

		$client_import
			.off("change")
			.on("change", function() {
				on_changed_client_import();
			});

		var $vip_import = $("#out_form_import_vip_import");
		$vip_import
			.off("change")
			.on("change", function() {
				if ($(this).prop("checked")) {
					$client_import.prop("checked", false);
					self.disable_control($client_import, true);
				}
				else {
					self.disable_control($client_import, false);
				}
				on_changed_client_import();
			});

		// eventos de la grilla con paginado
		this.form_paginator_past.set_events();
	};

	form_outbound_engine_imports.prototype.__show_new_field_map_popup = function()
	{
		this.popup_imports_format.new_format();
	};

	form_outbound_engine_imports.prototype.__show_edit_field_map_popup = function()
	{
		var format_id = $("#out_form_import_field_map").val();
		this.popup_imports_format.edit_format(format_id);
	};

	form_outbound_engine_imports.prototype.get_csv_header = function()
	{
		return this.csv_header;
	};

	form_outbound_engine_imports.prototype.ready = function()
	{
		var $id = $("#out_form_import_id");
		var $provider = $("#out_form_import_data_provider");
		var $past_list_container = $("#out_form_import_past_list_container");
		if ( this.is_new ) {
			this.readonly_control($id, false /* disabled */, true /* is_required */);
			this.readonly_control($provider, false /* disabled */, true /* is_required */);
			$id.focus();
			$past_list_container.hide();
		}
		else {
			this.readonly_control($id, true /* disabled */ );
			this.readonly_control($provider, true /* disabled */);
			//$("#" + this.upload_file_btn_id).focus();
			$past_list_container.show();
		}

		this.disable_mapping_info(true);

		form_outbound_engine_imports.uber.ready.call(this); //invokes the base class method
	};

	form_outbound_engine_imports.prototype.__update_buttons = function()
	{
		var $save = this.$get_dom_element_by_id("form_button_save");
		var $save_and_continue = this.$get_dom_element_by_id("form_button_save_and_continue");
		$save.attr("value", "<%=_T('Start')%>");
		$save_and_continue.hide();
	};

	form_outbound_engine_imports.prototype.ready_for_update = function()
	{
		form_outbound_engine_imports.uber.ready_for_update.call( this ); //invokes the base class method
		this.__update_buttons();
	};

	form_outbound_engine_imports.prototype.ready_for_save = function()
	{
		form_outbound_engine_imports.uber.ready_for_save.call( this ); //invokes the base class method
		this.__update_buttons();
	};

	form_outbound_engine_imports.prototype.disable_mapping_info = function(disabled)
	{
		var $field_map = $("#out_form_import_field_map");
		var $vip_import = $("#out_form_import_vip_import");
		var $client_import = $("#out_form_import_are_client_import");
		var $edit_field_map = $("#out_form_import_edit_field_map");
		var $new_field_map = $("#out_form_import_new_field_map");

		if (disabled) {
			this.disable_control($field_map, true /* disabled */);
			this.disable_control($vip_import, true /* disabled */);
			this.disable_control($client_import, true /* disabled */);
			$edit_field_map.prop("disabled", true);
			$new_field_map.prop("disabled", true);
		}
		else {
			this.disable_control($field_map, false /* disabled */, true /* is_required */);
			this.disable_control($vip_import, false /* disabled */);
			this.disable_control($client_import, false /* disabled */);
			$edit_field_map.prop("disabled", true);
			$new_field_map.prop("disabled", false);
		}

		var $duplicate_check = $("#out_form_import_duplicate_check");
		var $duplicate_solver = $("#out_form_import_duplicte_solver");
		this.disable_control($duplicate_check, true /* disabled */);
		this.disable_control($duplicate_solver, true /* disabled */);
	};

	form_outbound_engine_imports.prototype.get_validation_def = function()
	{
		const self = this;

		var upload_file_btn_id = this.upload_instance.get_dom_upload_file_btn_id();

		var $duplicate_check = $("#out_form_import_duplicate_check");
		var $duplicate_solver = $("#out_form_import_duplicte_solver");

		var definitions = [
			{
				control_id: "out_form_import_id",
				messages: {
					required: "<%=_T('Please enter the Importation Name.')%>",
					id      : "<%=_T('Only letters, numbers, dashes and dots are allowed in the Importation Name.')%>"
				}
			},
			{
				control_id: "out_form_import_data_provider",
				messages: {
					required: "<%=_T('Please enter the Importation Data Provider.')%>"
				}
			},
			{
				control_id: upload_file_btn_id,
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							var response = {
								success: true
							};
							var uploaded_file = self.upload_instance.get_info_uploaded_files();
							if (!uploaded_file) {
								response.success = false;
								response.message = "<%=_T('You must Upload a Contacts file.')%>";
								return response;
							}
							return response;
						}
					}
				}
			},
			{
				control_id: "out_form_import_field_map",
				messages: {
					required: "<%=_T('Please select Field Mapping.')%>"
				}
			},
			{
				control_id: "out_form_import_duplicate_check",
				messages: {
					required: "<%=_T('Please select Check For Duplicates.')%>"
				}
			},
			{
				control_id: "out_form_import_duplicte_solver",
				messages: {
					custom: {
						type: "custom",
						valid: function() {
							var response = {
								success: true
							};
							var duplicate_check = $duplicate_check.val();
							if (duplicate_check && duplicate_check.trim().length !== 0 && duplicate_check !== "None") {
								if ($duplicate_solver.val().trim().length === 0) {
									response.success = false;
									response.message = "<%=_T('Please select On Duplicate Found.')%>";
									return response;
								}
							}
							return response;
						}
					}
				}
			}
		];
		return definitions;
	};

	form_outbound_engine_imports.prototype.save_execute = function(after_save, importation /*, hash_id */)
	{
		const self = this;

		const is_allegro = inConcert.app.has_allegro_integration();

		this.show_waiting( "<%=_T('Please wait, Starting Importation....')%>" );

		let timeout_hnd = null;
		const clear_timeout = function () {
			if (timeout_hnd) {
				window.clearTimeout(timeout_hnd);
				timeout_hnd = null;
			}
		};

		this.m_mustExecuteGoBackToGridAfterSaved = true;
		// Funcion que regresa a la vista cuando el upload se ha realizado correctamente y el start se encuentra en progreso o ha finalizado.
		const go_back_grid = function(msg) {
			clear_timeout();
			self.import_started_timestamp = new Date();
			self.hide_waiting();
			if (msg) self.show_status_message(msg, "Info", 5000);
			const not_show_grid_message = true;
			self.on_saved(true, importation, after_save, null, null, not_show_grid_message);
		};

		const timemout_ms = 5000;
		const must_shown_import_err = function() {
			// Para mostrar el error valida que el tiempo transcurrido desde que comenzó la importacion, haya superado el tiempo del timeout.
			// Es decir que haya comenzado de forma asincrónica y que haya regresado a la vista, a partir de ese momento el error ya no debería visualizarse.
			if (!self.import_started_timestamp) {
				return true;
			}
			let now = new Date();
			let elapsed_time_ms = now.getTime() - self.import_started_timestamp.getTime();
			return timemout_ms > elapsed_time_ms;
		};

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		const import_start = function()
		{
			clear_timeout();
			// Si el upload de file y sus validaciones no han dado error, regreso a la vista.
			//  El regreso se realiza en un timeout, ya que la importacion comienza a correr en el server de 5.5 y puedo durar varios minutos.
			//  Y suponemos que si pasaron N segundos la misma ha comenzado correctamente.
			const backFn = function() {
				// Si se ha realizado correctamente el upload de un server al otro, debo limpiar la informacion de los uploads de la instancia de los upload.
				//self.upload_instance.destroy_data();
				after_save = !self.is_new ? "SAVE_AND_REFRESH_VIEW" : after_save;
				go_back_grid();
			};
			if (is_allegro) {
				timeout_hnd = window.setTimeout(backFn, timemout_ms);
			}
			else {
				backFn();
			}

			outbound_engine_api.importStart(importation, function(success, response)
			{
				if (success) {
					if (!is_allegro) {
						// Si se ha realizado correctamente el upload de un server al otro, debo limpiar la informacion de los uploads de la instancia de los upload.
						self.upload_instance.destroy_data();
						after_save = !self.is_new ? "SAVE_AND_REFRESH_VIEW" : after_save;
						let msg = "<%=_T('The importation has been successful.')%>";
						go_back_grid(msg);
					}
					return;
				}
				if (is_allegro) {
					if (!must_shown_import_err()) {
						return;
					}
				}
				clear_timeout();
				self.hide_waiting();
				let err = response;
				let current_err;
				// allegro
				try {current_err = JSON.parse(err.err);} catch(e) {}
				let code_error;
				if (current_err) {
					code_error = parseInt(current_err.result, 10);
				}
				else {
					// tel i6
					code_error = err.code;
				}
				let msg = "<%=_T('Unable to Import.')%>";
				switch(code_error) {
					case -1:
						//importation failed/not started
						msg = "<%=_T('Importation failed to start, please contact system administration')%>";
						break;

					case -100:
						//error in format definition
						msg = "<%=_T('The selected format does not match the file headers')%>";
						break;

					case -104:
						//...
						msg = FORMAT("<%=_T('The import must not exceed {0} contacts. The current import contains {1} contacts.')%>", err.maximumNumberRowsInImport, err.currentRows);
						break;

					case -105:
						//...
						msg = "<%=_T('The CSV file you uploaded has been deleted. You must upload it again.')%>";
						break;

					case -106:
						//...
						if (typeof err.result === "object") {
							if (err.result.status === "BREAK IMPORT") {
								msg = FORMAT("<%=_T('The import has been aborted. The first {0} contacts have been unsuccessful.')%>", err.result.MAXIMUM_FIRST_FAILED_CONTACTS_FOR_BREAK_IMPORT);
							}
						}
						break;

					case -107:
						//...
						msg = "<%=_T('Unable to complete action. There is another importation in progress.')%>";
							break;

					case -200:
						//the file wasn't correctly uploaded
						msg = "<%=_T('The file was not correctly uploaded')%>";
						break;

					case -300:
						//format not found
						msg = "<%=_T('The format definition was not found on the database.')%>";
						break;

					case -400:
						//format not found
						msg = "<%=_T('Error opening file.')%>";
						if (current_err.message) {
							msg += current_err.message;
						}
						break;

					case -500:
						//Exists another importation in process
						msg = "<%=_T('Exists another importation in process. please try again later.')%>";
						break;

					case "UNABLE TO CREATE IMPORTATION - ALREADY EXIST":
						// La importacion con este nombre ya existe.
						self.m_mustExecuteGoBackToGridAfterSaved = false;
						msg = "<%=_T('Importation Name is already in use.')%>";
						self.show_validation_error($("#out_form_import_id"), msg);
						return;
				}

				if (is_allegro) {
					// si es allegro muestro el error en el formulario
					self.show_status_message_in_view(msg, "Error", 5000);
				}
				else {
					// si es tel nativa, muestra el error luego de refrescar la vista, en ambos lugares (formulario y vista)
					self.dashboard.view.refresh(null, function() {
						window.setTimeout(() => {
							self.show_status_message_in_both(msg, "Error", 5000);
						});
					});
				}
			});
		};

		if (this.is_uploaded_file) {
			// El archivo fue subido previamente hacia 5.5, entonces ejecuto la importacion.
			import_start();
			return;
		}

		// a - Primero realizo el Upload del archivo desde el server de i6 hacia el server de 5.5.
		outbound_engine_api.importUploadContactsFile(importation, function(success, response)
		{
			if (success) {
				self.is_uploaded_file = true;
				// Despues de subir el archivo tengo que comenzar la importacion.
				import_start();
			}
			else {
				self.hide_waiting();
				let err = response;
				let current_err;
				try { current_err = JSON.parse(err.err); }
				catch(e) {}
				let code_error;
				if (current_err) {
					code_error = parseInt(current_err.result, 10);
				}
				if (code_error === -10) {
					self.show_validation_error($("#out_form_import_id"), "<%=_T('Importation Name is already in use.')%>");
				}
				else if (code_error === -500) {
					self.show_validation_error($("#out_form_import_id"), "<%=_T('Exists another importation in process. please try again later.')%>");
				}
				else {
					self.show_status_message("<%=_T('Unable to Upload File.')%>", "Error", 5000);
				}
			}
		});
	};

	form_outbound_engine_imports.prototype.on_saved = function(success, importation, after_save, err, callback, not_show_grid_message)
	{
		const self = this;
		// Un timeout para que el mensaje del frm se visualice por un tiempo determinado antes de ser invocada la funcion
		window.setTimeout(function() {
			if (self.m_mustExecuteGoBackToGridAfterSaved) {
				self.upload_instance.destroy_data();
				form_outbound_engine_imports.uber.on_saved.call(self, success, importation, after_save, err, callback, not_show_grid_message); //invokes the base class method
			}
		}, 3000);
	};

	form_outbound_engine_imports.prototype.on_saved_import_format = function(is_new, import_format)
	{
		this.list_formats = this.list_formats || [];
		const $field_map = $("#out_form_import_field_map");
		if (is_new) {
			this.combo_add_value($field_map, import_format.Id, import_format.Id, true);
			this.list_formats.push(import_format);
		}
		else {
			this.list_formats.every((f, i) => {
				if (f.Id.toLowerCase() === import_format.Id.toLowerCase()) {
					this.list_formats[i] = import_format;
					return false;
				}
				return true;
			});
		}
		$field_map.trigger("change");
	};

	// -- blacklists managements
	form_outbound_engine_imports.prototype.has_blacklists = function()
	{
		if (inConcert.app.has_allegro_integration()) {
			return false;
		}
		return true;
	};

	form_outbound_engine_imports.prototype.initialize_blacklists_mng = function()
	{
		if (!this.has_blacklists()) {
			return;
		}
		const prefix_id = "out_form_import_blacklists_mng";
		const parameters = {
			type        : "CALL"              ,
			addressType : "PHONE"             ,
			parent      : this                ,
			frm         : this                ,
			container_id: `${prefix_id}_panel`,
			prefix_id   : prefix_id           //,
			//help        : "mensaje personalizado"
		};
		this.blacklists_mng_instance = new inConcert.conf_form_blacklists(parameters);
		this.blacklists_mng_instance.initialize();
	};
}());
