/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, -W014, esversion: 11 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	const FORMAT = inConcert.Utils.format;

	//---------------------------------------------------------------------
	/**
	Class BatchInfoPopup.
	*/
	function BatchInfoPopup (params)
	{
		BatchInfoPopup.uber.constructor.call( this );
		this.clickEventName = this.clickEventName + "_batch_filter";
		this.ownerId = "out_batch_info_popup_container";
		this.waitingId = this.ownerId + "_waitign_id";
		this.messageId = this.ownerId + "_message_id";
		this.closeMessageId = this.ownerId + "_close_message_id";
		this.batchId = this.ownerId + "_batch_id";
		this.statusContainerId = this.ownerId + "_status_container_id";
		this.statusListId = this.ownerId + "_status_list_id";
		this.closeId = this.ownerId + "_close";
		this.params = params;
		this.canReposition = true;
	}

	inConcert.Utils.inherit(BatchInfoPopup, inConcert.PopupWindow);

	/*******************************************************************
	 * Metodo que crea el markup contenedor de la ventana
	 */
	BatchInfoPopup.prototype.createMarkup = function() {
		$("#" + this.ownerId).remove();
		//create the markup everytime
		const $node = $("".concat(
			"<div id='" + this.ownerId + "' class='systemPopWindow windowContactStatusBatches windowContainer' style='display:none'>",
				"<div id='", this.waitingId, "' class='windowWaitingContainer' hidden>",
					"<div message='true' class='windowWaitingMessage'></div>",
					"<div class='windowWaitingAnimation'></div>",
					"<div class='windowWaitingOverlay'></div>",
				"</div>",
				"<div class='windowTop'>",
					"<div class='windowTitle'>", "<%=_T('Contacts Status')%>", "</div>",
				"</div>",
				"<div id='", this.messageId, "' class='windowContainerMessages messageError' style='display:none' hidden>",
					"<a id='", this.closeMessageId, "' class='windowMessagesClose' href='javascript:void(0);'>", "<%=_T('Close')%>", "</a>",
					"<div class='windowMessagesText'>",
						"<label class='windowMessagesTextAux'></label>",
					"</div>",
				"</div>",
				"<div class='windowMiddle' style='display:none'>",
					"<div class=''></div>",
				"</div>",
				"<div class='windowMiddle'>",
					"<div class='card-block'>",
						"<div class='row'>",
							"<div class='col-12'>",
							"<div class='form-group'>",
								"<label for='", this.batchId, "' class=''>", "<%=_T('Batch Name')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.batchId, "' class='form-control formField-ds' type='text' disabled='true' />",
							"</div>",
							"</div>",
						"</div>",
					"</div>",
					"<div id='", this.statusContainerId, "' hidden class='viewGridBody'>",
						"<table id='", this.statusListId, "' border='0' cellspacing='0' class='nestedTable'>",
							"<tr>",
								"<th>", "<%=_T('Contact State')%>", "</th>",
								"<th align='right'>", "<%=_T('Total')%>", "</th>",
							"</tr>",
						"</table>",
						"<div class='inlineMessagesContainer messageInfo mt-3' style='display:none;'>",
							"<%=_T('Message ??.')%>" ,
						"</div>",
					"</div>",
				"</div>",
				"<div class='windowBottom d-flex justify-content-end'>",
					"<button id='", this.closeId, "' class='pageButtonGeneric buttonColorWhite'>",
						"<%=_T('Close')%>",
					"</button>",
				"</div>",
			"</div>"));
		$("body").append($node);
		return $node;
	};

	/*******************************************************************
	 *
	 */
	BatchInfoPopup.prototype.initialize = function()
	{
		this.data.container = this.createMarkup();
		this.setEvents();
	};

	BatchInfoPopup.prototype.show_waiting = function()
	{
		let message = "<%=_T('Loading, wait moment please')%>";
		const $waiting = $("#"  + this.waitingId);
		$waiting.find("[message='true']").text(message);
		$waiting.show();
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	BatchInfoPopup.prototype.hide_waiting = function()
	{
		$("#" + this.waitingId).hide();
		this.setPosition();
	};

	BatchInfoPopup.prototype.show_status_message = function(text, type, closeDisabled, timeout_ms )
	{
		const $message = $("#" + this.messageId);
		$message.removeClass().addClass("windowContainerMessages").addClass("message" + type);
		$message.show().find(".windowMessagesTextAux").text(text);
		if (timeout_ms) {
			window.setTimeout(function() {
				$message.hide();
			}, timeout_ms);
		}
		const $messageClose = $("#" + this.closeMessageId);
		if (closeDisabled) {
			$messageClose.hide();
		}
		else {
			$messageClose.show();
		}
	};

	/*******************************************************************
	* funcion que oculta mensaje
	*/
	BatchInfoPopup.prototype.hide_status_message = function() {
		const $message = $("#" + this.messageId);
		$message.hide();
	};

	BatchInfoPopup.prototype.make_contacts_status = function(contacts_status)
	{
		const $container = $("#" + this.statusContainerId);
		if (!contacts_status || contacts_status.length === 0) {
			$container.hide();
			this.show_status_message("<%=_T('There are no contact statuses.')%>", "Info", true);
			return;
		}
		let summary_statuses_def = this.owner_object.frm_batches.get_summary_statuses_def();
		const $contacts_list = $("#" + this.statusListId);
		$.each(contacts_status, function(status_id, total) {
			let status_def = summary_statuses_def[status_id];
			let status_name = status_def ? status_def.label : status_id;
			const $contact_status = $("<tr><td>" + status_name + "</td><td align='right'>" + total + "</td></tr>");
			$contacts_list.append($contact_status);
		});
		$container.show();
	};

	BatchInfoPopup.prototype.ready = function()
	{
		const self = this;

		let processId = this.params.processId;
		let batch = this.params.batch;
		let batchName = batch.configuration ? batch.configuration.name : "";
		$("#" + this.batchId).val(batchName);

		this.show_waiting();

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.processLoadBatchContactStatus(
			{processId: processId, batchId: batchName},
			function(success, contacts_status) {
				// pequeno waiting para dar feedback
				window.setTimeout(function() {
					if (success) {
						self.make_contacts_status(contacts_status);
					}
					else {
						$("#" + self.statusListId).hide();
						self.show_status_message("<%=_T('Error loading contacts statuses.')%>", "Error", true);
					}
					self.hide_waiting();
				}, 500);
			}
		);
	};

	BatchInfoPopup.prototype.close = function(params) {
		this.data.container.remove();
		this.finalize(params);
	};

	/*******************************************************************
	 * Metodo que setea eventos de los controles
	 */
	BatchInfoPopup.prototype.setEvents = function()
	{
		const self = this;
		const $filter_id =  $("#" + this.filterId);
		//---------------
		$("#" + this.saveId)
			.unbind("click")
			.click(function() {
				let filter_id = $filter_id.val();
				self.parent_save(filter_id, function(success) {
					if (!success) {
						$filter_id.focus();
						return;
					}
					self.close();
				});
			});
		//---------------
		$("#" + this.closeId).unbind("click").click(function() {
			self.close();
		});
	};

	//---------------------------------------------------------------------
	//
	function ChannelAccountConfig (params)
	{
		this.frm = params.frm;
		this.tab_container_id = params.tab_container_id;
		this.prefix = params.tab_container_id;
		this.callbacks = params.callbacks;
		this.m_currentConfig = null;
		this.m_isReady = false;
		this.m_engineType = [
			{id: "AUTOMATIC"  , name: "<%=_T('AUTOMATIC')%>"  , alsoAvailable: ["PREDICTIVE-AUTOMATIC" , "PROGRESSIVE-AUTOMATIC" ]},
			{id: "PREDICTIVE" , name: "<%=_T('PREDICTIVE')%>" , alsoAvailable: ["PREDICTIVE-AUTOMATIC" , "PROGRESSIVE-PREDICTIVE"]},
			{id: "PROGRESSIVE", name: "<%=_T('PROGRESSIVE')%>", alsoAvailable: ["PROGRESSIVE-AUTOMATIC", "PROGRESSIVE-PREDICTIVE"]}
		];
		this.initialize();
	}

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.createMarkup = function() {
		const $config = $(`
		<!-- (DISPONIBLE: SIEMPRE)-->
			<div class="row">
				<div class="col-6">
					<div class="row">
						<div class="col-12">
							<div class="form-group">
								<label for="${this.prefix}_account" class="required"><%=_T([[Account]])%><%=_T([[:]])%></label>
								<select id="${this.prefix}_account" class="form-control"></select>
								<i id="${this.prefix}_account_validation" class="formFieldValidation formFieldError" hidden></i>
							</div>
						</div>
					</div>
					<div class="row">
						<!-- (DISPONIBLE: SOLO PROGRESIVO)-->
						<!-- PROGRESIVO -->
						<div class="col-12" available_for="PROGRESSIVE" style="display:none;">
							<div class="d-flex form-group">
								<div class="form-check">
									<label for="${this.prefix}_has_preview" class="form-check-label form-check-label-title required">
										<input id="${this.prefix}_has_preview" class="form-check-input" type="checkbox" />
										<%=_T([[Has Preview]])%>
									</label>
								</div>
								<div class="form-check">
									<label for="${this.prefix}_hangup_on_answering_machine" class="form-check-label form-check-label-title">
										<input id="${this.prefix}_hangup_on_answering_machine" class="form-check-input" type="checkbox" />
										<%=_T([[Hang Up On Answering Machine]])%>
									</label>
								</div>
							</div>
						</div>
					</div>
					<!-- (DISPONIBLE: SOLO PREDICTIVO)-->
					<div class="row">
						<div class="col-6" available_for="PREDICTIVE" style="display:none;">
							<div class="form-group">
								<label for="${this.prefix}_abandoned_process"><%=_T([[Abandonded Process]])%><%=_T([[:]])%></label>
								<select id="${this.prefix}_abandoned_process" class="form-control" custom-required="never-required"></select>
							</div>
						</div>
						<div class="col-6" available_for="PREDICTIVE" style="display:none;">
							<div class="form-group">
								<label for="${this.prefix}_desired_abandoned_rate" class="required"><%=_T([[Abandoned rate]])%><%=_T([[:]])%></label>
								<input id="${this.prefix}_desired_abandoned_rate" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>" />
								<i id="${this.prefix}_desired_abandoned_rate_validation" class="formFieldValidation formFieldError" hidden></i>
							</div>
						</div>
					</div>
					<!-- (DISPONIBLE: SOLO AUTOMATICO)-->
					<div class="row">
						<div class="col-12" available_for="AUTOMATIC" style="display:none;">
							<div class="form-group">
								<label for="${this.prefix}_process" class="required"><%=_T([[Process]])%><%=_T([[:]])%></label>
								<select id="${this.prefix}_process" class="form-control"></select>
								<i id="${this.prefix}_process_validation" class="formFieldValidation formFieldError" hidden></i>
							</div>
						</div>
					</div>
					<!-- (DISPONIBLE: PREDICTIVO & AUTOMATICO)-->
					<div class="row">
						<div class="col-12" available_for="PREDICTIVE-AUTOMATIC" style="display:none;">
							<div class="form-group">
								<label for="${this.prefix}_answering_machine_process"><%=_T([[Answering Machine Process]])%><%=_T([[:]])%></label>
								<select id="${this.prefix}_answering_machine_process" class="form-control" custom-required="never-required"></select>
								<i id="${this.prefix}_answering_machine_process_validation" class="formFieldValidation formFieldError" hidden></i>
							</div>
						</div>
					</div>
					<!-- (DISPONIBLE: SOLO PREDICTIVO)-->
					<div class="row">
						<div class="col-12" available_for="PREDICTIVE" style="display:none;">
							<div class="form-group">
								<label for="${this.prefix}_contact_rate_factor" class="pl-0"><%=_T([[Contact Rate Factor]])%><%=_T([[:]])%></label>
								<div class="messengerCodeSizeContainer scoringCodeSizeContainer_new">
									<div id="${this.prefix}_contact_rate_factor" class="messengerCodeSize scoringCodeSize_new"
										control="code_size"
										slider="true"
										slider-range="min"
										slider-min-value="0"
										slider-max-value="100"
										slider-step="5"
										slider-initial-value="50"
										slider-initial-state="enabled"
										slider-display-value-id="${this.prefix}_contact_rate_factor_display_value"
										slider-display-value-remaining-id="${this.prefix}_contact_rate_factor_display_value_remaining"
										slider-display-value-format="{0} %"
									>
										<div control="code_size_handle" class="ui-slider-handle"></div>
									</div>
									<span id="${this.prefix}_contact_rate_factor_display_value" class="ui-slider-pixels-value ui-slider-scoring-value"></span>
									<span id="${this.prefix}_contact_rate_factor_display_value_remaining" class="ui-slider-pixels-value_rest ui-slider-scoring-value ui-slider-scoring-value-rest"></span>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="col-6">
					<div class="row">
						<div class="col-12">
							<div class="form-group">
								<label for="${this.prefix}_engine_type" class="required"><%=_T([[Engine type]])%><%=_T([[:]])%></label>
								<select id="${this.prefix}_engine_type" class="form-control"></select>
								<i id="${this.prefix}_engine_type_validation" class="formFieldValidation formFieldError" hidden></i>
							</div>
						</div>
					</div>
					<!-- (DISPONIBLE: SOLO PREDICTIVO)-->
					<div class="row">
						<div class="col-6" available_for="PREDICTIVE" style="display:none;">
							<div class="form-group">
								<label for="${this.prefix}_service_level" class="required"><%=_T([[Service Level]])%><%=_T([[:]])%></label>
								<input id="${this.prefix}_service_level" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>" />
								<i id="${this.prefix}_service_level_validation" class="formFieldValidation formFieldError" hidden></i>
							</div>
						</div>
						<div class="col-6" available_for="PREDICTIVE" style="display:none;">
							<div class="form-group">
								<div class="form-check mt-3">
									<label for="${this.prefix}_strict_service_level" class="form-check-label form-check-label-title">
										<input id="${this.prefix}_strict_service_level" class="form-check-input" type="checkbox" />
										<%=_T([[Strict Service]])%>
									</label>
								</div>
							</div>
						</div>
					</div>
					<!-- (DISPONIBLE: PREDICTIVO & AUTOMATICO)-->
					<div class="row" available_for="PREDICTIVE-AUTOMATIC" style="display:none;">
						<div class="col-6">
							<div class="form-group">
								<div class="form-check form-switch">
									<label for="${this.prefix}_enable_manual_correction" class="form-check-label form-check-label-title">
										<input id="${this.prefix}_enable_manual_correction" class="form-check-input" type="checkbox" />
										<span></span>
										<%=_T([[Enable Manual Rate]])%>
										<i class="fa fa-question-circle" title="<%=_T('By enabling the manual rate, the predictive statistic calculations are discarded. For example: if a value of 2 is manually assigned, each available agent will make 2 calls.')%>"></i>
									</label>
								</div>
							</div>
						</div>
						<div id="${this.prefix}_manual_correction_section" class="col-6" style="display:none;">
							<div class="form-group">
								<label for="${this.prefix}_manual_correction" class="required"><%=_T([[Manual Rate]])%><%=_T([[:]])%></label>
								<input id="${this.prefix}_manual_correction" class="form-control" type="text" placeholder="<%=_T([[Enter value]])%>" />
								<i id="${this.prefix}_manual_correction_validation" class="formFieldValidation formFieldError" hidden></i>
							</div>
						</div>
					</div>
				</div>
			</div>
			<!-- (DISPONIBLE: PROGRESIVO & PREDICTIVE)-->
			<div class="row" available_for="PROGRESSIVE-PREDICTIVE" style="display:none;">
				<!-- PROGRESIVO Y PREDICTIVO -->
			</div>
			<!-- (DISPONIBLE: PROGRESIVO & AUTOMATICO)-->
			<div class="row" available_for="PROGRESSIVE-AUTOMATIC" style="display:none;">
				<!-- PROGRESIVO Y AUTOMATICO -->
			</div>
		</div>
		`);

		const $tab_container = $("#" + this.tab_container_id);
		$tab_container.html($config);
	};

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.loadInfo = function() {
		const self = this;

		// engine
		const $engineType = $(`#${this.prefix}_engine_type`);
		this.frm.fill_combo($engineType, true /* is_blank_first_item */, this.m_engineType, "id" /* attr_id */, "name" /* attr_name */, true /*sorted*/);

		// procesos
		const flowsCombos = [
			$(`#${this.prefix}_abandoned_process`),
			$(`#${this.prefix}_answering_machine_process`),
			$(`#${this.prefix}_process`)
		];
		const flowAPI = inConcert.app.getFlowDesignerAPI();
		flowAPI.loadFlowsByType({
				proxyType: this.m_proxyType.id
			},
			function(success, flows) {
				if (!success) {
					self.frm.show_status_message(FORMAT("<%=_T('Error Retrieving Flows By Type {0}.')%>", self.m_proxyType.name), "Error", false);
					return;
				}
				// cargo el combo flows options
				flowsCombos.forEach($combo => self.frm.fill_combo(
					$combo, /* cbo flows options       */
					true,   /* add blank first element */
					flows,  /* list                    */
					"Id",   /* attr id                 */
					"Name", /* attr name               */
					true    /* sorted                  */
				));
				// Como la los request son asincronicos, el "set" se debe de realizar despues de culminado los request.
				// sel valor de "set" ha quedado previamente almacenado en this.m_currentConfig
				self.m_isReady = true;
				self.set();
			}
		);
	};

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.initialize = function() {
		this.createMarkup();
		this.initialize_ctrls();
		this.loadInfo();
		this.setEvents();
	};

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.initialize_ctrls = function() {
		const dom_container_id = this.tab_container_id;
		this.frm.create_sliders(dom_container_id);
	};

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.setEvents = function() {
		const self = this;
		// engine type
		const $engineType = $(`#${this.prefix}_engine_type`);
		$engineType.off("change")
			.on("change", function() {
				self.onChangeEngineType();
			});
		// manual correction
		const $enableManualRate = $(`#${this.prefix}_enable_manual_correction`);
		$enableManualRate.off("change")
			.on("change", function() {
				const isEnabled = $(this).prop("checked");
				self.onEnableManualRateType(isEnabled);
			});
	};

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.loadDynamicInfo = function(_, accounts) {
		const $account = $(`#${this.prefix}_account`);
		this.frm.fill_combo($account, true /* is_blank_first_item */, accounts, "id" /* attr_id */, "name" /* attr_name */, true /*sorted*/);
	};

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.onChangeEngineType = function() {
		const $tab_container = $("#" + this.tab_container_id);
		$tab_container.find(`[available_for]`).hide();
		const $engineType = $(`#${this.prefix}_engine_type`);
		const selectedEngineType = this.frm.combo_get_selected_item_data($engineType);
		if (selectedEngineType) {
			$tab_container.find(`[available_for='${selectedEngineType.id}']`).show();
			(selectedEngineType.alsoAvailable || []).forEach(item => {
				$tab_container.find(`[available_for='${item}']`).show();
			});
		}
	};

	/*******************************************************************
	 *
	 */
	 ChannelAccountConfig.prototype.onEnableManualRateType = function(isEnabled) {
		$(`#${this.prefix}_manual_correction_section`)[isEnabled ? "show" : "hide"]();
		const isRequired = isEnabled;
		const keepValue = true;
		const $manualRate = $(`#${this.prefix}_manual_correction`);
		this.frm.disable_control($manualRate, !isEnabled, isRequired, true, keepValue);
	};

	/*******************************************************************
	 *
	 */
	ChannelAccountConfig.prototype.disableTabCtrls = function(isDisabled) {
		const self = this;
		const $tab_container = $("#" + this.tab_container_id);
		const $ctrls = $tab_container.find(".form-control, .form-check-input");
		$.each($ctrls, function( _, ctrl) {
			const $ctrl = $(ctrl);
			const isRequired = !isDisabled;
			const keepValue = true;
			self.frm.disable_control($ctrl, isDisabled, isRequired, true, keepValue);
		});
		if (!isDisabled) {
			//
			const answeringMachineProcess = $(`#${this.prefix}_answering_machine_process`).val();
			if ((answeringMachineProcess || "").length === 0) {
				const $enableManualCorrection =$(`#${this.prefix}_enable_manual_correction`);
				const isEnabledManualRate = $enableManualCorrection.prop("checked");
				if (!isEnabledManualRate) {
					const $manualRate =$(`#${this.prefix}_manual_correction`);
					this.frm.disable_control($manualRate, true, true, true, true);
				}
			}
		}
	};

	/*******************************************************************
	 *
	 */
	 ChannelAccountConfig.prototype.get = function() {
		let accountId = $(`#${this.prefix}_account`).val();
		if (!accountId) {
			return false;
		}
		const config = {
			account   : accountId,
			engineType: $(`#${this.prefix}_engine_type`).val()
		};
		if (config.engineType === "PROGRESSIVE") {
			config.hasPreview = $(`#${this.prefix}_has_preview`).prop("checked");
			config.hangupOnAnsweringMachine = $(`#${this.prefix}_hangup_on_answering_machine`).prop("checked");
		}
		if (config.engineType === "AUTOMATIC") {
			config.process = $(`#${this.prefix}_process`).val();
		}
		if (config.engineType === "PREDICTIVE") {
			config.serviceLevel = parseInt($(`#${this.prefix}_service_level`).val(), 10);
			config.strictServiceLevel = $(`#${this.prefix}_strict_service_level`).prop("checked");
			const abandonedProcess = $(`#${this.prefix}_abandoned_process`).val();
			if (abandonedProcess.length > 0) {
				config.abandonedProcess = abandonedProcess;
			}
			config.desiredAbandonRate = $(`#${this.prefix}_desired_abandoned_rate`).val() / 100;
			const $slider = $(`#${this.prefix}_contact_rate_factor`);
			config.historicalContactRateFactor = $slider.slider("value") / 100;
		}
		// los que van tanto para AUTOMATIC como PREDICTIVE
		if (config.engineType === "AUTOMATIC" || config.engineType === "PREDICTIVE") {
			const answeringMachineProcess = $(`#${this.prefix}_answering_machine_process`).val();
			if (answeringMachineProcess.length > 0) {
				config.answeringMachineProcess = answeringMachineProcess;
			}
			const isEnabledManualRate = $(`#${this.prefix}_enable_manual_correction`).prop("checked");
			if (isEnabledManualRate) {
				config.correctionManualRate = parseInt($(`#${this.prefix}_manual_correction`).val(), 10);
			}
			else {
				config.correctionManualRate = null;
			}
		}
		return config;
	};

	/*******************************************************************
	 *
	 */
	 ChannelAccountConfig.prototype.set = function(config) {
		// me quedo con el valor config en m_currentConfig, hasta que la clase este ready, es decir que hayan cumlinando los request contra el server.
		this.m_currentConfig = config || this.m_currentConfig;
		if (!this.m_currentConfig) {
			return;
		}
		if (!this.isReady()) {
			return;
		}
		$(`#${this.prefix}_account`).val(this.m_currentConfig.account);
		$(`#${this.prefix}_engine_type`).val(this.m_currentConfig.engineType).trigger("change");
		//
		if (this.m_currentConfig.engineType === "PROGRESSIVE") {
			$(`#${this.prefix}_has_preview`).prop("checked", this.m_currentConfig.hasPreview || false);
			$(`#${this.prefix}_hangup_on_answering_machine`).prop("checked", this.m_currentConfig.hangupOnAnsweringMachine);
		}
		if (this.m_currentConfig.engineType === "AUTOMATIC") {
			$(`#${this.prefix}_process`).val(this.m_currentConfig.process);
		}
		if (this.m_currentConfig.engineType === "PREDICTIVE") {
			$(`#${this.prefix}_service_level`).val(this.m_currentConfig.serviceLevel);
			$(`#${this.prefix}_strict_service_level`).prop("checked", this.m_currentConfig.strictServiceLevel);
			const abandonedProcess = this.m_currentConfig.abandonedProcess;
			const $abandonedProcess = $(`#${this.prefix}_abandoned_process`);
			if ((abandonedProcess || "").length > 0) {
				$abandonedProcess.val(abandonedProcess);
			}
			// desired abandoned rate
			let desiredAbandonRate = this.m_currentConfig.desiredAbandonRate || 0;
			desiredAbandonRate = parseInt(desiredAbandonRate * 100, 10);
			$(`#${this.prefix}_desired_abandoned_rate`).val(desiredAbandonRate);
			// contact rate factor
			let historicalContactRateFactor = this.m_currentConfig.historicalContactRateFactor;
			if (!historicalContactRateFactor && historicalContactRateFactor !== 0) {
				historicalContactRateFactor = 0.5;
			}
			historicalContactRateFactor = parseInt(historicalContactRateFactor * 100, 10);
			const $slider = $(`#${this.prefix}_contact_rate_factor`);
			$slider.slider("value", historicalContactRateFactor);
		}
		// los que van tanto para AUTOMATIC como PREDICTIVE
		if (this.m_currentConfig.engineType === "AUTOMATIC" || this.m_currentConfig.engineType === "PREDICTIVE") {
			const answeringMachineProcess = this.m_currentConfig.answeringMachineProcess;
			const $answeringMachineProcess = $(`#${this.prefix}_answering_machine_process`);
			if ((answeringMachineProcess || "").length > 0) {
				$answeringMachineProcess.val(answeringMachineProcess);
			}
			$answeringMachineProcess.trigger("change");
			// manual rate
			const correctionManualRate = this.m_currentConfig.correctionManualRate ? this.m_currentConfig.correctionManualRate : "";
			let isEnabledManualRate = false;
			if (correctionManualRate) {
				isEnabledManualRate = true;
			}
			$(`#${this.prefix}_enable_manual_correction`).prop("checked", isEnabledManualRate).trigger("change");
			$(`#${this.prefix}_manual_correction`).val(correctionManualRate);
		}
	};

	/*******************************************************************
	 *
	 */
	 ChannelAccountConfig.prototype.on_validation_error = function() {
		this.callbacks.on_validation_error(this.m_proxyType.id);
	 };

	/*******************************************************************
	 *
	 */
	 ChannelAccountConfig.prototype.get_validation_def = function() {
		const self = this;
		let config = this.get();
		if (!config) {
			return;
		}

		const on_validation_error = function() {
			self.on_validation_error();
		};

		let channelLabel = FORMAT("<%=_T('Channel: {0}.')%>", this.m_proxyType.name);
		const make_message_by_channel = function(msg) {
			return `${msg} ${channelLabel}`;
		};

		let definitions = [
			{
				control_id: `${this.prefix}_engine_type`,
				messages: {
					required: make_message_by_channel("<%=_T('Please select the Engine Type.')%>")
				},
				on_error: on_validation_error
			}
		];
		if (config.engineType === "PROGRESSIVE") {
			// en PROGRESSIVE se valida solo lo basico.
			return definitions;
		}
		if (config.engineType === "AUTOMATIC") {
			definitions.push({
				control_id: `${this.prefix}_process`,
				messages: {
					required: make_message_by_channel("<%=_T('Please select the Process.')%>")
				},
				on_error: on_validation_error
			});
		}
		if (config.engineType === "PREDICTIVE") {
			definitions.push({
				control_id: `${this.prefix}_desired_abandoned_rate`,
				messages: {
					required: make_message_by_channel("<%=_T('Please enter the Desired Abandoned Rate.')%>"),
					range: {
						type   : "range",
						between: {from: 0, to: 100},
						message: make_message_by_channel("<%=_T('Desired Abandoned Rate is out of range. Please enter a value between {0} and {1}.')%>")
					}
				},
				on_error: on_validation_error
			});
			definitions.push({
				control_id: `${this.prefix}_service_level`,
				messages: {
					required: make_message_by_channel("<%=_T('Please enter the Service Level.')%>"),
					range: {
						type   : "range",
						between: {from: 1, to: 10},
						message: make_message_by_channel("<%=_T('Service Level is out of range. Please enter a value between {0} and {1}.')%>")
					}
				},
				on_error: on_validation_error
			});
		}
		// los que van tanto para AUTOMATIC como PREDICTIVE
		let isEnabledManualRate = $(`#${this.prefix}_enable_manual_correction`).prop("checked");
		if (isEnabledManualRate)
		{
			const max_proc_manual_rate = inConcert.app.get_vcc_max_proc_manual_rate();
			const string_msg_error     = (max_proc_manual_rate === 1) ? "<%=_T('Manual Rate is out of range. The max value is 1.')%>" : "<%=_T('Manual Rate is out of range. Please enter a value between {0} and {1}.')%>";

			definitions.push({
				control_id: `${this.prefix}_manual_correction`,
				messages: {
					required: make_message_by_channel("<%=_T('Please enter the Manual Rate.')%>"),
					range: {
						type   : "range",
						between: {from: 1, to: max_proc_manual_rate},
						message: make_message_by_channel(string_msg_error)
					}
				},
				on_error: on_validation_error
			});
		}

		return definitions;
	};

	/*******************************************************************
	 *
	 */
	 ChannelAccountConfig.prototype.isReady = function() {
		return this.m_isReady;
	};

	//---------------------------------------------------------------------
	// CALL CHANNEL
	function CallChannelAccountConfig (params) {
		this.m_proxyType = {id: "CALL", name: "<%=_T('Call')%>"};
		CallChannelAccountConfig.uber.constructor.call(this, params);
	}
	inConcert.Utils.inherit(CallChannelAccountConfig, ChannelAccountConfig);

	//---------------------------------------------------------------------
	// MAIL CHANNEL
	function MailChannelAccountConfig (params) {
		this.m_proxyType = {id: "MAIL", name: "<%=_T('E-mail')%>"};
		MailChannelAccountConfig.uber.constructor.call(this, params);
	}
	inConcert.Utils.inherit(MailChannelAccountConfig, ChannelAccountConfig);

	//---------------------------------------------------------------------
	// SMS CHANNEL
	function SmsChannelAccountConfig (params) {
		this.m_proxyType = {id: "SMS", name: "<%=_T('SMS')%>"};
		SmsChannelAccountConfig.uber.constructor.call(this, params);
	}
	inConcert.Utils.inherit(SmsChannelAccountConfig, ChannelAccountConfig);

	//---------------------------------------------------------------------
	// WHATSAPP CHANNEL
	function WhatsAppChannelAccountConfig (params) {
		this.m_proxyType = {id: "WHATSAPP", name: "<%=_T('WhatsApp')%>"};
		WhatsAppChannelAccountConfig.uber.constructor.call(this, params);
	}
	inConcert.Utils.inherit(WhatsAppChannelAccountConfig, ChannelAccountConfig);

	//---------------------------------------------------------------------
	// form process class
	function form_outbound_engine_processes(params)
	{
		let success = form_outbound_engine_processes.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		this.new_title = "<%=_T('New Outbound Processes')%>";
		this.update_title = "<%=_T('Update Outbound Processes {0}')%>";
		this.view_title = "<%=_T('View Outbound Processes {0}')%>";
		this.tagline = "<%=_T('Tagline form Outbound Processes!!!')%>";
		this.html_file_name = "/inconcert/apps/outbound_engine/processes/frm/render/";
		this.get_uri =        "/inconcert/apps/outbound_engine/processes/get/";
		this.include_save_and_continue = false;
		// (Tab Principal) Instancia de la clase de TABs
		this.main_tabs = new inConcert.conf_form_tab({
			parent        : this,
			frm           : this.frm,
			container_id  : "out_form_process_tabs",
			must_intialize: false,
			tabs_list   : {
				config: {
					id              : "config",
					name            : "<%=_T('Configuration')%>",
					tab_container_id: "out_form_process_tab_config_container",
					selected        : true
				},
				batches: {
					id              : "batches",
					name            : "<%=_T('Batches')%>",
					tab_container_id: "out_form_process_tab_batches_container",
					initial_state   : "disabled"
				}
			}
		});
		/*
			Canales que soportan Dialer

			TODO: Para habilitar mas canales salientes en el OE, hay que cambiar a true el atributo "enabled", o agregar mas canales a la lista e implementarlos.
				Tambien hay que habilitar en el controller "system.lua" en la funcion "__LoadCampaignsAndAccountsByChannels"
		*/
		this.m_supportedChannels = {
			CALL: {
				id              : "CALL",
				name            : "<i class='formTabsMenuItemStepIcon buttons-icons-telephone'></i><%=_T('Call')%>",
				tab_container_id: "out_form_process_channels_tab_call_container",
				selected        : true,
				enabled         : true,
				content_class   : CallChannelAccountConfig,
				contentInstance: null
			},
			MAIL: {
				id              : "MAIL",
				name            : "<i class='formTabsMenuItemStepIcon buttons-icons-mail-closed'></i><%=_T('E-mail')%>",
				tab_container_id: "out_form_process_channels_tab_mail_container",
				enabled         : false,
				content_class   : MailChannelAccountConfig,
				contentInstance: null
			},
			SMS: {
				id              : "SMS",
				name            : "<i class='formTabsMenuItemStepIcon buttons-icons-sms'></i><%=_T('SMS')%>",
				tab_container_id: "out_form_process_channels_tab_sms_container",
				enabled         : false,
				content_class   : SmsChannelAccountConfig,
				contentInstance: null
			},
			WHATSAPP: {
				id              : "WHATSAPP",
				name            : "<i class='formTabsMenuItemStepIcon buttons-icons-whatsapp'></i><%=_T('WhatsApp')%>",
				tab_container_id: "out_form_process_channels_tab_whatsapp_container",
				enabled         : false,
				content_class   : WhatsAppChannelAccountConfig,
				contentInstance: null
			}
		};
		// (Tab Channels) Instancia de la clase de TABs
		this.tabsChannels = new inConcert.conf_form_tab({
			parent        : this,
			frm           : this.frm,
			container_id  : "out_form_process_channels_tabs",
			must_intialize: false,
			tabs_list     : this.m_supportedChannels
		});
		this.__entity_id = "id";
		this.form_paginator_rules = null;
		this.form_paginator_batches = null;
		this.count_pending_grid = 0;
		this.__new_grids();
		this.frm_rules = new inConcert.form_outbound_engine_processes_rules({
			frm: this
		});
		this.frm_batches = new inConcert.form_outbound_engine_processes_batches({
			frm: this
		});
		// flag "initialized" utilizado para que no quede en loop el frm cuando se esta creando un nuevo "process",
		//  esto sucede asi, porque se tuvo que sobreescribir la funcion "ready_for_save".
		this.initialized = false;
		this.batch_info_popup = null;

		return true;
	}

	inConcert.Utils.inherit(form_outbound_engine_processes, inConcert.conf_form);

	if (typeof inConcert.form_outbound_engine_processes !== "function") {
		inConcert.form_outbound_engine_processes = form_outbound_engine_processes;
	}

	form_outbound_engine_processes.prototype.initialize = function() {
		const self = this;
		// main tabs
		this.main_tabs.initialize();
		this.main_tabs.show_tabs_container();
		// channels tabs
		this.tabsChannels.initialize();
		this.tabsChannels.show_tabs_container();
		// oculto los tabs que corresponden a canales que aun no soportamos.
		for (let channel_id in this.m_supportedChannels) {
			if (this.m_supportedChannels.hasOwnProperty(channel_id)) {
				let config = this.m_supportedChannels[channel_id];
				if (config.enabled) {
					config.contentInstance = new config.content_class({
						frm: this,
						tab_container_id: config.tab_container_id,
						callbacks: {
							on_validation_error: function(channelId) {
								self.tabsChannels.switch_tab(channelId);
							}
						}
					});
				}
				else {
					this.tabsChannels.hide_tab(channel_id);
				}
			}
		}
		//
		this.enable_disable_all_tabs(false);
	};

	form_outbound_engine_processes.prototype.enable_disable_all_tabs = function(isEnabled) {
		this.tabsChannels.enable_disable_all_tabs(isEnabled);
		for (let channel_id in this.m_supportedChannels) {
			if (this.m_supportedChannels.hasOwnProperty(channel_id)) {
				let config = this.m_supportedChannels[channel_id];
				if (config.contentInstance) {
					config.contentInstance.disableTabCtrls(!isEnabled);
				}
			}
		}
	};

	form_outbound_engine_processes.prototype.dispose = function() {
		this.initialized = false;
	};

	form_outbound_engine_processes.prototype.get = function()
	{
		let process =  {
			id           : $("#out_form_process_id").val(),
			configuration: {
				maxContactRetriesDay: parseInt($("#out_form_process_max_retries_per_day").val(), 10),
				maxContactRetries   : parseInt($("#out_form_process_max_retries_per_contact").val(), 10),
				campaign            : $("#out_form_process_campaign").val(),
				channels            : this.__get_channels(),
				...this.__get_sort_contacts()
			},
			rules: this.__get_rules()
		};
		return process;
	};

	form_outbound_engine_processes.prototype.__get_sort_contacts = function()
	{
		if (!$("#out_form_sort_contacts").is(":checked")){
			return {};
		}
		return {
			sortContacts: {
				type: $("#out_form_sort_contacts_type").val(),
				name: $("#out_form_sort_contacts_name").val(),
				direction: $("#out_form_sort_contacts_direction").val(),
			}
		};
	};

	form_outbound_engine_processes.prototype.__get_rules = function()
	{
		let rules = this.form_paginator_rules.get_items();
		return rules;
	};

	form_outbound_engine_processes.prototype.__get_channels = function()
	{
		let channelsConfig = {};
		for (let channeId in this.m_supportedChannels) {
			if (this.m_supportedChannels.hasOwnProperty(channeId)) {
				let config = this.m_supportedChannels[channeId];
				if (config.enabled && config.contentInstance) {
					let channelConfig = config.contentInstance.get();
					if (channelConfig) {
						channelsConfig[channeId] = channelConfig;
					}
				}
			}
		}
		return channelsConfig;
	};

	form_outbound_engine_processes.prototype.__set_channels = function(channelsConfig)
	{
		if (!channelsConfig) {
			return;
		}
		for (let channeId in this.m_supportedChannels) {
			if (this.m_supportedChannels.hasOwnProperty(channeId)) {
				let config = this.m_supportedChannels[channeId];
				if (config.enabled && config.contentInstance) {
					let channelConfig = channelsConfig[channeId];
					config.contentInstance.set(channelConfig);
				}
			}
		}
	};

	form_outbound_engine_processes.prototype.set = function(success, process)
	{
		if (this.initialized) {
			return;
		}
		this.form_paginator_rules.initialize();
		this.form_paginator_batches.initialize();
		this.frm_batches.load_information();
		if (!success) {
			return;
		}
		this.fill_combo_campaigns();
		const configuration = process.configuration || {};
		const process_id = inConcert.app.get_id(process.id || "");
		const $id = $("#out_form_process_id");
		$id.val(process_id);
		$("#out_form_process_max_retries_per_day").val(configuration.maxContactRetriesDay || "");
		$("#out_form_process_max_retries_per_contact").val(configuration.maxContactRetries || "");
		$("#out_form_process_campaign").val(configuration.campaign || "");
		this.__set_sort_contacts(configuration.sortContacts || {});
		this.__on_changed_campaign(configuration.campaign);
		this.__set_channels(configuration.channels);
		const dom_container_id = "out_form_process_batches_popup";
		this.create_spinners(dom_container_id);
	};

	form_outbound_engine_processes.prototype.__set_sort_contacts = function(sortContacts = {})
	{
		$("#out_form_sort_contacts").prop("checked", !!sortContacts.type).trigger("change");
		$("#out_form_sort_contacts_type").val(sortContacts.type || "");
		$("#out_form_sort_contacts_name").val(sortContacts.name || "");
		$("#out_form_sort_contacts_direction").val(sortContacts.direction || "");
	};

	form_outbound_engine_processes.prototype.show_status_message = function(message, type, timeout_ms, scrolling, show_custom_button, $custom_message_container, callbacks, wrap_classes)
	{
		wrap_classes = "genericFormMessagesAboveTabs";
		form_outbound_engine_processes.uber.show_status_message.call(this, message, type, timeout_ms, scrolling, show_custom_button, $custom_message_container, callbacks, wrap_classes);
	};

	form_outbound_engine_processes.prototype.__new_grids = function()
	{
		const self = this;

		this.count_pending_grid = 0;

		this.form_paginator_rules = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_RULES",
			owner: this,
			frm: this,
			row_id: "id",
			display_name: "name",
			rows_per_page: 500,
			show_at_least: 499,
			without_paginator: true,
			sortable: true,
			loading_waiting_msg: "<%=_T('Please wait, loading Rules ... ')%>",
			ids: {
				grid: "out_form_process_rules_list",
				paginator: "out_form_process_rules_paginator",
				not_results_found: "out_form_process_rules_not_results_found"
			},
			strings: {
				not_results_found: "<%=_T('No rules found')%>",
				can_remove : "<%=_T('Do you want to delete Rule: {0} ?')%>"
			},
			columns: [
				{id: "_number"    , name: "", type: "counter"     },
				{id: "name"       , name: "<%=_T('Name')%>"       },
				{id: "description", name: "<%=_T('Description')%>"},
				{id: "_action", name: "",
					system_action: {edit: true, erase: true}
				}
			],
			callbacks: {
				edit: function(rule) {
					self.on_edit_rule_popup(rule);
				},
				load_items: function(page, callback) {
					//console.log("5 - grid load_items -> form_paginator_rules");
					self.count_pending_grid = self.count_pending_grid + 1;
					self.load_rules(page, callback);
				},
				on_loaded_items: function(callback) {
					self.__on_loaded_grid(callback);
				}
			}
		});

		const getBatchGridColumns = ()=> {
			let gridColumns = [
				{id: "_number"    , name: "", type: "counter" },
				{id: "name", name: "<%=_T('Name')%>", get_value: function(item) {
					return self.get_grid_batch_value(item, "Name");
				}},
				{id: "startDate", name: "<%=_T('Valid From')%>",
					get_value: function(item) {
						return self.get_grid_batch_value(item, "startDate");
					}
				},
				{id: "endDate", name: "<%=_T('Valid Until')%>",
					get_value: function(item) {
						return self.get_grid_batch_value(item, "endDate");
					}
				},
				{id: "percentage"       , name: "% " + "<%=_T('Percentage')%>", get_value: function(item) {
					return self.get_grid_batch_value(item, "Percentage");
				}},
				{id: "basePriority"       , name: "<%=_T('Base Priority')%>", get_value: function(item) {
					return self.get_grid_batch_value(item, "basePriority");
				}},
				{id: "batchPriority"       , name: "<%=_T('Batch Priority')%>", get_value: function(item) {
					return self.get_grid_batch_value(item, "batchPriority");
				}},
				{id: "state", name: "<%=_T('Status')%>", get_value: function(item) {
					return self.get_grid_batch_value(item, "State");
				}},
				{id: "migrated", name: "<%=_T('Migrated')%>", type: "boolean", get_value: function(item) {
						return self.get_grid_batch_value(item, "Migrated");
					},
					get_tooltip: function({Allegro}) {
						if (!Allegro) {
							return "<%=_T('New batch. Not migrated from Allegro.')%>";
						}
						return Allegro.isMigratedContacts
							 ? "<%=_T('Contacts were migrated and added to the batch from Allegro.')%>"
							 : "<%=_T('Contacts have not been migrated from Allegro.')%>";
					}
				},
				{id: "_rigth_actions", type: "actions", name: "", 
					system_action: {edit: true, erase: true},
					custom_action: {
						INFO: {
							name: "<%=_T('Contacts statuses information')%>",
							execute: function($row, $owner) {
								let batch = self.form_paginator_batches.get_row_data($row);
								self.__open_batch_info_popup($owner, batch);
							},
							class_name: "buttons-icons-information icon-chart",
							action_separator: true
						},
						CANCEL: {
							name: "<%=_T('Cancel')%>",
							execute: function($row) {
								let batch = self.form_paginator_batches.get_row_data($row);
								self.__run_batch_action({
									action: "CANCEL",
									batch : batch
								});
							},
							class_name: "buttons-icons-cancel icon-stop"
						},
						PAUSE: {
							name: "<%=_T('Pause')%>",
							execute: function($row) {
								let batch = self.form_paginator_batches.get_row_data($row);
								self.__run_batch_action({
									action: "PAUSE",
									batch : batch
								});
							},
							class_name: "buttons-icons-voz-hold"
						},
						RESUME: {
							name: "<%=_T('Resume')%>",
							execute: function($row) {
								let batch = self.form_paginator_batches.get_row_data($row);
								self.__run_batch_action({
									action: "RESUME",
									batch : batch
								});
							},
							class_name: "buttons-icons-start"
						}
					},
					is_enabled: function(action_id, batch) {
						return self.__grd_batches_row_status_actions(action_id, batch);
					}
				}
			];

			// la columna migracion se visualiza unicamente para los VCC de Allegro que han sido migrados a Nativo.
			const migrationInfo = inConcert.app.allegroVccMigrationInfo();
			if ("IS MIGRATED ALLEGRO VCC" !== migrationInfo.result) {
				gridColumns = gridColumns.filter(column => {
					return column.id !== "migrated";
				});
			}

			return gridColumns;
		};

		this.form_paginator_batches = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_BATCHES",
			owner: this,
			frm: this,
			row_id: "id",
			display_name: function(item) {
				return self.get_grid_batch_value(item, "Name").value;
			},
			rows_per_page: 10,
			show_at_least: 9,
			without_paginator: false,
			loading_waiting_msg: "<%=_T('Please wait, loading Batches ...')%>",
			ids: {
				grid: "out_form_process_batches_list",
				paginator: "out_form_process_batches_paginator",
				not_results_found: "out_form_process_batches_not_results_found",
				//popup
				popup       : "out_form_process_batches_popup",
				popup_msg   : "out_form_process_batches_popup_message",
				popup_create: "out_form_process_batches_popup_create",
				popup_title : "out_form_process_batches_popup_title",
				popup_close : "out_form_process_batches_popup_close"
			},
			strings: {
				not_results_found: "<%=_T('No Batches found.')%>",
				can_remove       : "<%=_T('Do you want to delete Batch {0} ?')%>",
				title_update     : "<%=_T('Update Batch')%>"
			},
			columns: getBatchGridColumns(),
			callbacks: {
				save: function(callback) {
					self.__update_batch(callback);
				},
				edit: function(batch) {
					self.on_edit_batch(batch);
				},
				on_closed_popup: function() {
					self.current_batch = null;
				},
				remove: function(batch, callback) {
					self.__run_batch_action({
						action  : "DELETE",
						batch   : batch,
						callback: callback
					});
				},
				load_items: function(page, callback) {
					//console.log("6 - grid load_items -> form_paginator_batches");
					self.count_pending_grid = self.count_pending_grid + 1;
					self.load_batches(page, callback);
				},
				on_loaded_items: function(callback) {
					self.__on_loaded_grid(callback);
				}
			}
		});
	};

	form_outbound_engine_processes.prototype.load_rules = function(_, callback)
	{
		let process = this.get_entity_instance() || {};
		callback(true, process.rules);
	};

	form_outbound_engine_processes.prototype.load_batches = function(_, callback)
	{
		const process = this.get_entity_instance() || {};
		const sortedBatches = inConcert.Utils.sortArray(process.batches || [], null, null,
			function(batch) {
				if (!batch.configuration) {
					return "";
				}
				return batch.configuration.name;
			}
		);
		callback(true, sortedBatches);
		this.form_paginator_batches.set_events();
	};

	form_outbound_engine_processes.prototype.__can_change_batch_period = function()
	{
		return true;
	};

	form_outbound_engine_processes.prototype.on_edit_batch = function(batch)
	{
		this.current_batch = batch;

		const configuration = batch.configuration || {};
		this.create_datepickers("out_form_process_batches_popup");
		// start date
		let startDate = configuration.startDate || "";
		this.datepicker_set_date($("#out_form_process_batches_popup_valid_from"), startDate || "");
		// end date
		let endDate = configuration.endDate || "";
		this.datepicker_set_date($("#out_form_process_batches_popup_valid_until"), endDate || "");
		// period
		const $period_enabled = $("#out_form_process_batches_popup_period_enabled");
		$period_enabled.prop("checked", false);
		this.__disabled_period_ctrls(true);
		if (this.__can_change_batch_period()) {
			$period_enabled.show();
		}
		else {
			$period_enabled.hide();
		}
		// priority
		$("#out_form_process_batches_popup_priority_base").val(configuration.basePriority || "");
		$("#out_form_process_batches_popup_priority_batch").val(configuration.batchPriority || "");
		const $priority_enabled = $("#out_form_process_batches_popup_priority_enabled");
		$priority_enabled.prop("checked", false).trigger("change");
		if (this.__can_change_batch_increase_values()) {
			this.disable_control($priority_enabled, false);
		}
		else {
			this.disable_control($priority_enabled, true);
		}
		// percentage value
		$("#out_form_process_batches_popup_percentage_value").val(configuration.percentage || "");
		const $percentage_value_enabled = $("#out_form_process_batches_popup_change_percentage_value_enabled");
		$percentage_value_enabled.prop("checked", false).trigger("change");
		if (this.__can_change_batch_percentage_values()) {
			this.disable_control($percentage_value_enabled, false);
		}
		else {
			this.disable_control($percentage_value_enabled, true);
		}
	};

	form_outbound_engine_processes.prototype.__can_change_batch_percentage_values = function()
	{
		return this.__can_change_batch_increase_values();
	};

	form_outbound_engine_processes.prototype.__can_change_batch_increase_values = function()
	{
		return true;
	};

	form_outbound_engine_processes.prototype.__update_batch = function(callback)
	{
		const self = this;

		const has_change_priority = $("#out_form_process_batches_popup_priority_enabled").prop("checked");
		const must_change_percentage = $("#out_form_process_batches_popup_change_percentage_value_enabled").prop("checked");
		const change_period = $("#out_form_process_batches_popup_period_enabled").prop("checked");

		// period values
		const $valid_from = $("#out_form_process_batches_popup_valid_from");
		let start_date = $valid_from.val();
		const $valid_until = $("#out_form_process_batches_popup_valid_until");
		let end_date = $valid_until.val();

		// prioridades
		const $priority_base = $("#out_form_process_batches_popup_priority_base");
		const $priority_batch = $("#out_form_process_batches_popup_priority_batch");
		let priority_base = $priority_base.val();
		let priority_batch = $priority_batch.val();

		// porcentajes
		const $percentage = $("#out_form_process_batches_popup_percentage_value");
		let percentage_value = $percentage.val();

		// funcion que realiza validaciones
		const validate = function() {
			self.form_paginator_batches.hide_popup_msg();
			let result = {
				success: false,
				type   : "Error",
				msg    : "",
				$ctrl  : undefined
			};
			// 1- validacion de periodos
			if (change_period) {
				self.datepicker_validate_date_and_range($valid_from, result);
				if (!result.success) {
					return result;
				}
			}
			// 2. prioridades
			if (has_change_priority) {
				// base
				let result = inConcert.Utils.validate(priority_base, "required");
				if (!result.success) {
					result.msg = "<%=_T('Base priority is required.')%>";
					result.$ctrl = $priority_base;
					return result;
				}
				// batch
				result = inConcert.Utils.validate(priority_batch, "required");
				if (!result.success) {
					result.msg = "<%=_T('Batch priority is required.')%>";
					result.$ctrl = $priority_batch;
					return result;
				}
			}
			// 3. validacion de porcentajes
			if (must_change_percentage) {
				// porcentaje
				let result = inConcert.Utils.validate(percentage_value, "required");
				if (!result.success) {
					result.msg = "<%=_T('Percentage is required.')%>";
					result.$ctrl = $percentage;
					return result;
				}
			}
			// success
			result.success = true;
			return result;
		};

		const validation_result = validate();
		if (!validation_result.success) {
			self.mark_ctrl_error(validation_result.$ctrl);
			callback(false, undefined, validation_result);
			return;
		}

		const has_change_period = function() {
			if (!change_period || !self.current_batch.configuration) {
				return false;
			}
			return self.current_batch.configuration.startDate !== start_date || self.current_batch.configuration.endDate !== end_date;
		}();

		let action_data = {
			action  : "UPDATE",
			batch   : this.current_batch,
			callback: function() {
				callback(true, self.current_batch);
			}
		};

		if (must_change_percentage) {
			action_data.percentage = parseInt(percentage_value, 10);
		}
		if (has_change_priority) {
			action_data.basePriority = parseInt(priority_base, 10);
			action_data.batchPriority = parseInt(priority_batch, 10);
		}
		if (has_change_period) {
			action_data.startDate = start_date;
			action_data.endDate = end_date;
		}

		this.__run_batch_action(action_data);
	};

	form_outbound_engine_processes.prototype.__disabled_period_ctrls = function(disabled)
	{
		const is_required = !disabled;
		const keep_value = true;
		// from
		const $from = $("#out_form_process_batches_popup_valid_from");
		this.disable_control($from, disabled, is_required, undefined, keep_value);
		// until
		const $until = $("#out_form_process_batches_popup_valid_until");
		this.disable_control($until, disabled, false, undefined, keep_value);
		//
		if (disabled) {
			$until.removeAttr("placeholder");
		}
		else {
			$until.attr("placeholder", "YYYY-MM-DD");
		}
		this.__enabled_disabled_update_batch();
	};

	form_outbound_engine_processes.prototype.__enabled_disabled_update_batch = function()
	{
		const $period_enabled = $("#out_form_process_batches_popup_period_enabled");
		const $priority_enabled = $("#out_form_process_batches_popup_priority_enabled");
		const $percentage_enabled = $("#out_form_process_batches_popup_change_percentage_value_enabled");
		const disabled = !$period_enabled.prop("checked") && !$priority_enabled.prop("checked") && !$percentage_enabled.prop("checked");
		const $update = $("#out_form_process_batches_popup_create");
		$update.prop("disabled", disabled);
	};

	/*
		Batch statuses:
			atributo "state":
				ACTIVE
				EXPIRED
				FUTURE
			atributo "actionState"
				CREATING
				UPDATING
				DELETING
	*/
	form_outbound_engine_processes.prototype.__grd_batches_row_status_actions = function(action_id, batch)
	{
		const contactsStatuses = batch.contactsStatuses || {};
		action_id = (action_id || action_id).toUpperCase();
		const state = (batch.state || "NONE").toUpperCase();
		const actionState = (batch.actionState || "NONE").toUpperCase();

		if (actionState === "CREATING" || actionState === "UPDATING" || actionState === "DELETING") {
			return 0;
		}
		if (action_id === "INFO") {
			return 1;
		}
		if (state === "EXPIRED") {
			if (action_id === "EDIT") {
				return 1;
			}
			if (action_id === "DELETE") {
				return 1;
			}
		}
		else if (state === "ACTIVE" || state === "FUTURE") {
			let buttons_status = this.__get_batch_actions_statuses(contactsStatuses);
			if (action_id === "CANCEL") {
				return buttons_status.cancel ? 1 : 0;
			}
			else if (action_id === "PAUSE") {
				return buttons_status.pause ? 1 : 0;
			}
			else if (action_id === "RESUME") {
				return buttons_status.resume ? 1 : 0;
			}
			else if (action_id === "EDIT") {
				// Siempre va enabled, ya que en este frm se pueden realizar varias acciones (cambiar periodos, incrementar los valores a los contactos, y los porcentajes)
				return 1;
			}
			else if (action_id === "DELETE") {
				return 1;
			}
		}
		return 0; // si esta en 0 lo veo inhabilitado y si esta en -1 no lo veo
	};

	/*
	*/
	form_outbound_engine_processes.prototype.__get_batch_actions_statuses = function(contacts_statuses)
	{
		let statuses = {
			ACTIVE: 0, CANCELED: 0, CONTACTED: 0, PAUSED: 0, PENDING: 0, SCHEDULED: 0, OTHERS: 0
		};

		$.each(contacts_statuses || {}, function(status, total) {
			status = status.toUpperCase();
			total = parseInt(total, 10);
			if (statuses.hasOwnProperty(status)) {
				statuses[status] = total;
			}
			else {
				statuses.OTHERS = total;
			}
		});

		let enabled_actions = {cancel: false, pause: false, resume: false, edit: false};

		// cancel button
		if (statuses.ACTIVE > 0 || statuses.SCHEDULED > 0 || statuses.PAUSED > 0 || statuses.PENDING > 0) {
			enabled_actions.cancel = true;
		}
		// pause button
		if (statuses.ACTIVE > 0 || statuses.SCHEDULED > 0 || statuses.PENDING > 0) {
			enabled_actions.pause = true;
		}
		// resume button
		if (statuses.PAUSED > 0) {
			enabled_actions.resume = true;
		}
		// edit button
		if (statuses.ACTIVE > 0 || statuses.SCHEDULED > 0 || statuses.PAUSED > 0 || statuses.PENDING > 0) {
			enabled_actions.edit = true;
		}

		return enabled_actions;
	};

	form_outbound_engine_processes.prototype.__run_batch_action = function(params)
	{
		const self = this;

		const callback = function(success, response) {
			if (success) {
				self.show_status_message("<%=_T('Action completed successfully!')%>", "Info", 5000);
				if (params.action === "CANCEL" || params.action === "PAUSE" || params.action === "RESUME" || params.action === "INCREASERETRIES" || params.action === "CHANGEPERCENTAGE") {
					params.batch.contactsStatuses = response.contactsStatuses || params.batch.contactsStatuses;
					self.form_paginator_batches.update_row(params.batch);
				}
				else if (params.action === "UPDATE") {
					params.batch = response;
					self.form_paginator_batches.update_row(params.batch);
				}
			}
			else {
				let message;
				let errType = response && typeof(response.reason) === "string" ? response.reason.toUpperCase() : "DEFAULT ERROR";
				if (errType === "PROCESS IS RUNNING") {
					message = "<%=_T('Unable to execute the batch operation, the process is running.')%>";
				}
				else if (errType === "ADMIN_ACTIONS_RUNNING") {
					message = "<%=_T('Unable to execute the batch action. Process has admin actions running.')%>";
				}
				else if (errType === "NETWORK_ERROR") {
					message = "<%=_T('Unable to execute the batch action. Unknown network error.')%>";
				}
				else if (errType === "PERCENTAGE_INVALID") {
					message = "<%=_T('The total percentage of active batches in the process cannot exceed 100%.')%>";
				}
				message = message || "<%=_T('Unable to execute the batch operation, please contact your administrator.')%>";
				self.show_status_message(message, "Error", 5000);
			}
			self.hide_waiting();
			(params.callback || $.noop)(success, response);
		};

		this.show_waiting("<%=_T('Please wait, Executing Action....')%>");

		let process = this.get_entity_instance() || {};
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();

		let data = {
			batchId  : params.batch.configuration.name,
			processId: process.id
		};

		switch(params.action) {
			case "UPDATE":
				data.configuration = {
					basePriority : params.basePriority,
					batchPriority: params.batchPriority,
					startDate    : params.startDate,
					endDate      : params.endDate,
					percentage   : params.percentage
				};
				outbound_engine_api.processUpdateBatch(data,
					function(success, response) {
						// pequeno waiting para dar feedback
						window.setTimeout(function() {
							callback(success, response);
						}, 500);
					}
				);
				return;
			case "DELETE":
				outbound_engine_api.processDeleteBatch(data,
					function(success, response) {
						// pequeno waiting para dar feedback
						window.setTimeout(function() {
							callback(success, response);
						}, 500);
					}
				);
				return;
			case "CANCEL":
				outbound_engine_api.processCancelBatch(data,
					function(success, response) {
						// pequeno waiting para dar feedback
						window.setTimeout(function() {
							callback(success, response);
						}, 500);
					}
				);
				return;
			case "PAUSE":
				outbound_engine_api.processPauseBatch(data,
					function(success, response) {
						// pequeno waiting para dar feedback
						window.setTimeout(function() {
							callback(success, response);
						}, 500);
					}
				);
				return;
			case "RESUME":
				outbound_engine_api.processResumeBatch(data,
					function(success, response) {
						// pequeno waiting para dar feedback
						window.setTimeout(function() {
							callback(success, response);
						}, 500);
					}
				);
				return;
		}
		// accion NO soportada
		throw("form_outbound_engine_processes.prototype.__run_batch_action-> Unrecognized action " + params.action);
	};

	form_outbound_engine_processes.prototype.get_grid_batch_value = function(item, field_id)
	{
		let value = {
			original_value: "",
			value         : "",
			search_value  : ""
		};

		let item_value = item[field_id] || "";
		if (item_value === undefined) {
			return value;
		}

		value.original_value = item_value;
		value.value = item_value;
		value.search_value = item_value;

		if (field_id === "Name") {
			if (item.configuration) {
				value.original_value = item.configuration.name;
				value.value = value.original_value;
				value.search_value = value.original_value;
			}
		}
		else if (field_id === "Percentage") {
			if (item.configuration) {
				value.original_value = item.configuration.percentage;
				value.value = value.original_value;
				value.search_value = value.original_value;
				item_value = item_value || 0;
				if (value.value !== "") {
					value.value = typeof(value.value) === "number" ? value.value.toString() : value.value;
					value.value = value.value + " %";
				}
			}
		}
		else if (field_id === "startDate") {
			if (item.configuration) {
				value.original_value = item.configuration.startDate;
				value.value = value.original_value;
				value.search_value = value.original_value;
			}
		}
		else if (field_id === "endDate") {
			if (item.configuration) {
				value.original_value = item.configuration.endDate;
				value.value = value.original_value;
				value.search_value = value.original_value;
			}
		}
		else if (field_id === "basePriority") {
			if (item.configuration) {
				value.original_value = item.configuration.basePriority;
				value.value = value.original_value;
				value.search_value = value.original_value;
			}
		}
		else if (field_id === "batchPriority") {
			if (item.configuration) {
				value.original_value = item.configuration.batchPriority;
				value.value = value.original_value;
				value.search_value = value.original_value;
			}
		}
		else if (field_id === "State") {
			const statuses = {
				ACTIVE  :"<%=_T('Active')%>",
				CREATING:"<%=_T('Creating')%>",
				DELETING:"<%=_T('Deleting')%>",
				EXPIRED :"<%=_T('Expired')%>",
				FUTURE  :"<%=_T('Future')%>",
				UPDATING:"<%=_T('Updating')%>"
			};
			const translated_state = statuses[(item.state || "").toUpperCase()] || "<%=_T('Unrecognized')%>";
			value.original_value = item.state;
			value.value = translated_state;
			value.search_value = value.original_value;
		}
		else if (field_id === "Migrated") {
			if (item.Allegro) {
				value.original_value = item.Allegro;
				value.value = item.Allegro.isMigratedContacts || false;
				value.search_value = value.original_value;
			}
		}

		return value;
	};

	/*
		Esta funcion se invoca cada vez que termina la carga de una grilla, para verificar si no queda ninguna pending.
		Cuando no queden pending, ahí invoca a la funcion local para dejar listo el frm para ser utilizado.
	*/
	form_outbound_engine_processes.prototype.__on_loaded_grid = function(callback = $.noop)
	{
		const self = this;
		this.count_pending_grid = this.count_pending_grid - 1;
		// console.log("form_outbound_engine_processes.prototype.__on_loaded_grid " + this.count_pending_grid);
		if (this.count_pending_grid <= 0) {
			window.setTimeout(function() {
				self.__ready_for_save();
			});
		}
		callback();
	};

	form_outbound_engine_processes.prototype.load_data = function(callback_complete_requests)
	{
		const self = this;

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		this.requests = [
			{
				request_function: function(success) {
					return outbound_engine_api.systemRulesLoadChannels(success);
				},
				success: function(list) {
					self.set_channels(list);
				}
			},
			{
				request_function: function(success) {
					return outbound_engine_api.systemRulesSystemActions(success);
				},
				success: function(list) {
					self.set_system_actions(list);
				}
			},
			{
				request_function: function(success) {
					return outbound_engine_api.systemLoadCampaignsAccountsByChannels(success);
				},
				success: function(list) {
					self.m_campaignAccountsByChannels = list;
				}
			}
		];

		this.frm_rules.attach_load_request(this.requests);
		form_outbound_engine_processes.uber.load_data.call(this, callback_complete_requests); //invokes the base class method
	};

	form_outbound_engine_processes.prototype.set_channels = function(channels)
	{
		this.m_channels = channels;
		this.frm_rules.set_channels(channels);
	};

	form_outbound_engine_processes.prototype.set_system_actions = function(system_actions)
	{
		this.m_system_actions = system_actions;
		this.frm_rules.set_system_actions(system_actions);
	};

	form_outbound_engine_processes.prototype.fill_combo_campaigns = function()
	{
		const self = this;
		let current_process_id = this.is_new ? null : inConcert.app.get_id(this.get_entity_instance().id).toLowerCase();
		const filter_campaigns = function() {
			let filtered_campaigns = {};
			for (let campaign_id in self.m_campaignAccountsByChannels) {
				if (self.m_campaignAccountsByChannels.hasOwnProperty(campaign_id)) {
					let campaign = self.m_campaignAccountsByChannels[campaign_id];
					if (!campaign.ProcessId) {
						filtered_campaigns[campaign_id] = campaign;
					}
					else {
						if (current_process_id === campaign.ProcessId.toLowerCase()) {
							filtered_campaigns[campaign_id] = campaign;
						}
					}
				}
			}
			return filtered_campaigns;
		};
		this.m_campaignAccountsByChannels = filter_campaigns();
		const $combo = $("#out_form_process_campaign");
		this.fill_combo($combo, true /* is_blank_first_item */, this.m_campaignAccountsByChannels, "Id" /* attr_id */, "Name" /* attr_name */);
	};

	form_outbound_engine_processes.prototype.__get_channel_instance = function(channel_id)
	{
		if (!this.m_supportedChannels[channel_id]) {
			return;
		}
		return this.m_supportedChannels[channel_id].contentInstance;
	};

	form_outbound_engine_processes.prototype.__on_changed_campaign = function(campaign_id)
	{
		let accountsByChannels = this.m_campaignAccountsByChannels[campaign_id];
		this.enable_disable_all_tabs(false);
		if (!accountsByChannels) {
			// TODO: Hacer algo.
			return;
		}
		let first_enabled_tab_id;
		for (let channel_id in this.m_supportedChannels) {
			if (this.m_supportedChannels.hasOwnProperty(channel_id)) {
				let config = this.m_supportedChannels[channel_id];
				if (config.enabled) {
					let accounts = accountsByChannels.channels[channel_id];
					if ((accounts || []).length > 0) {
						this.tabsChannels.enable_tab(channel_id);
						first_enabled_tab_id = first_enabled_tab_id ? first_enabled_tab_id : channel_id;
						let instance = this.__get_channel_instance(channel_id);
						if (instance) {
							instance.loadDynamicInfo(channel_id, accounts);
							instance.disableTabCtrls(false);
						}
					}
				}
			}
		}
		if (first_enabled_tab_id) {
			this.tabsChannels.switch_tab(first_enabled_tab_id);
		}
	};

	form_outbound_engine_processes.prototype.__disabled_priority_ctrls = function(disabled)
	{
		const keep_value = true;
		const is_required = !disabled;
		const $priority_base = $("#out_form_process_batches_popup_priority_base");
		this.disable_control($priority_base, disabled, is_required, undefined, keep_value);
		const $priority_batch = $("#out_form_process_batches_popup_priority_batch");
		this.disable_control($priority_batch, disabled, is_required, undefined, keep_value);
		this.__enabled_disabled_update_batch();
	};

	form_outbound_engine_processes.prototype.__disabled_percentage_ctrls = function(disabled)
	{
		const keep_value = true;
		const is_required = !disabled;
		const $percentage = $("#out_form_process_batches_popup_percentage_value");
		this.disable_control($percentage, disabled, is_required, undefined, keep_value);
		this.__enabled_disabled_update_batch();
	};

	form_outbound_engine_processes.prototype.set_events = function()
	{
//		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();

		const self = this;

		// eventos de la grilla con paginado
		this.form_paginator_rules.set_events();
		this.frm_rules.set_events();
		this.frm_batches.set_events();

		$("#out_form_process_rules_new")
			.off("click")
			.on("click", function() {
				self.__new_rule();
			});

		$("#out_form_process_batches_management")
			.off("click")
			.on("click", function() {
				self.__new_batch();
			});

		$("#out_form_process_campaign")
			.off("change")
			.on("change", function() {
				let campaign_id = $(this).val();
				self.__on_changed_campaign(campaign_id);
			});

		// Eventos del popup de la grilla de edicion de batchmanagement (increase retries, etc)
		//
		$("#out_form_process_batches_popup_period_enabled")
			.off("change")
			.on("change", function() {
				let disabled = !$(this).prop("checked");
				self.__disabled_period_ctrls(disabled);
			});

		$("#out_form_process_batches_popup_priority_enabled")
			.off("change")
			.on("change", function() {
				let disabled = !$(this).prop("checked");
				self.__disabled_priority_ctrls(disabled);
			});

		$("#out_form_process_batches_popup_change_percentage_value_enabled")
			.off("change")
			.on("change", function() {
				let disabled = !$(this).prop("checked");
				self.__disabled_percentage_ctrls(disabled);
			});

		$("#out_form_sort_contacts")
			.off("change")
			.on("change", function() {
				$("#out_form_sort_contacts_fields").toggle($(this).is(":checked"));
			})
			.trigger("change");
	};

	form_outbound_engine_processes.prototype.ready = function()
	{
		form_outbound_engine_processes.uber.ready.call(this); //invokes the base class method
	};

	/*
		Est funcion se invoca cuando ha finalizado la carga de cada grilla del frm, asi el frm queda listo para ser utilizado.
		La misma termina invocando a la funcion "ready_for_save" de la clase base de formularios "conf_form".
		En esa clase de procesos la funcion "ready_for_save" (**) queda empty, para que la misma no se ejecute hasta que sea haya completado la carga de las grillas.
	*/
	form_outbound_engine_processes.prototype.__ready_for_save = function()
	{
		form_outbound_engine_processes.uber.ready_for_save.call(this); //invokes the base class method
	};

	/*
		(**) Dejamos a la funcion empty asi no se ejecuta la misma hasta que la carga de las grillas se haya completado.
	*/
	form_outbound_engine_processes.prototype.ready_for_save = function()
	{
		if (this.is_new) {
			this.__ready_for_save();
		}
	};

	form_outbound_engine_processes.prototype.ready_for_create = function()
	{
		form_outbound_engine_processes.uber.ready_for_create.call( this ); //invokes the base class method
		//$("#out_form_process_batches_list_container").hide();
		this.set(true, {});
		this.initialized = true;
		this.frm_rules.ready_for_create();
		this.frm_batches.ready_for_create();
		const $id = $("#out_form_process_id");
		this.readonly_control($id, false, true);
	};

	form_outbound_engine_processes.prototype.ready_for_update = function()
	{
		form_outbound_engine_processes.uber.ready_for_update.call( this ); //invokes the base class method
		this.frm_rules.ready_for_update();
		this.frm_batches.ready_for_update();
		this.main_tabs.enable_tab("batches");
		const $id = $("#out_form_process_id");
		this.readonly_control($id, true);
	};

	form_outbound_engine_processes.prototype.get_validation_def_by_channels = function()
	{
		const self = this;
		let definitions = [
			// valido que al menos exista una cuenta seleccionada en al menos un canal
			{
				control_id: "out_form_process_channels",
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							let response = {
								success: true
							};
							let channels = self.__get_channels();
							if (Object.keys(channels).length === 0) {
								response.success = false;
								response.message = "<%=_T('Please, you must assign an account to at least one channel.')%>";
							}
							return response;
						}
					}
				}
			}
		];
		// validaciones por cada canal
		for (let channel_id in this.m_supportedChannels) {
			if (this.m_supportedChannels.hasOwnProperty(channel_id)) {
				let config = this.m_supportedChannels[channel_id];
				if (config.enabled && config.contentInstance) {
					let channel_definition = config.contentInstance.get_validation_def();
					if (channel_definition) {
						definitions = definitions.concat(channel_definition);
					}
				}
			}
		}
		return definitions;
	};

	form_outbound_engine_processes.prototype.get_validation_def = function()
	{
		const self = this;

		let definitions = [
			{
				control_id: "out_form_process_id",
				messages: {
					required: "<%=_T('Please enter the Process Name.')%>",
					id      : "<%=_T('Only letters, numbers, dashes and dots are allowed in the Process Name.')%>"
				}
			},
			{
				control_id: "out_form_process_campaign",
				messages: {
					required: "<%=_T('Please select the Campaign.')%>"
				}
			},
			{
				control_id: "out_form_process_max_retries_per_day",
				messages: {
					required: "<%=_T('Please select the Max Retries Per Day.')%>",
					digits  : "<%=_T([[Max Retries Per Day value must be a number]])%>",
					range: {
						type   : "range",
						between: {from: 1, to: 100},
						message: "<%=_T('Max Retries Per Day is out of range. Please enter a value between {0} and {1}.')%>"
					}
				}
			},
			{
				control_id: "out_form_process_max_retries_per_contact",
				messages: {
					required: "<%=_T('Please select the Max Retries Per Contact.')%>",
					digits  : "<%=_T([[Max Retries Per Contact value must be a number]])%>",
					range: {
						type   : "range",
						between: {from: 1, to: 100},
						message: "<%=_T('Max Retries Per Contact is out of range. Please enter a value between {0} and {1}.')%>"
					}
				}
			},
			...this.__get_validation_def_sort_contacts()
		];

		// channels
		let definitions_by_channels = this.get_validation_def_by_channels();
		definitions = definitions.concat(definitions_by_channels);

		// rules
		definitions.push({
			control_id: "out_form_process_rules_list",
			messages: {
				custom: {
					type:  "custom",
					valid: function() {
						let response = {
							success: true
						};
						let rules = self.__get_rules();
						if (rules.length === 0) {
							response.success = false;
							response.message = "<%=_T('Please Add Rules.')%>";
						}
						return response;
					}
				}
			}
		});
		return definitions;
	};

	form_outbound_engine_processes.prototype.__get_validation_def_sort_contacts = function()
	{
		const canValidate = () => $("#out_form_sort_contacts").is(":checked");
		return [
			{
				control_id: "out_form_sort_contacts_type",
				can_validate: canValidate,
				messages: {
					required: "<%=_T('Please select a sort field type.')%>"
				}
			},
			{
				control_id: "out_form_sort_contacts_name",
				can_validate: canValidate,
				messages: {
					required: "<%=_T('Please select a sort field name.')%>",
					id      : "<%=_T('Only letters, numbers, dashes and dots are allowed in sort field name.')%>"
				}
			},
			{
				control_id: "out_form_sort_contacts_direction",
				can_validate: canValidate,
				messages: {
					required: "<%=_T('Please select a sort direction.')%>"
				}
			},
		];
	};

	form_outbound_engine_processes.prototype.__sort_contacts_changed = function(oldSort, newSort)
	{
		const notOldSort = !oldSort;
		const notNewSort = !newSort;
		if (notOldSort && notNewSort) {
			return false;
		}
		return notOldSort !== notNewSort
			|| oldSort.type !== newSort.type
			|| oldSort.name !== newSort.name
			|| oldSort.direction !== newSort.direction;
	};

	form_outbound_engine_processes.prototype.__confirm_save_sort_contacts = async function(oldProcess, newProcess)
	{
		if (!oldProcess) {
			return true;
		}
		const oldSort = oldProcess.configuration?.sortContacts || null;
		const newSort = newProcess.configuration?.sortContacts || null;
		if (!this.__sort_contacts_changed(oldSort, newSort)) {
			return true;
		}
		const result = await $.inconcertPopup.ShowAndReceiveResponse(
			"<%=_T('Sort contacts changed')%>",
			"<%=_T('There are changes in sort contacts criteria. Process will be temporarily disabled meanwhile changes are processed.')%>",
			$.inconcertPopup.ButtonSets.BS_OKCANCEL,
			undefined,
			{
				popup_id        : "conf_inconcertPopup",
				container_class : "confirmationPopUp",
				overlay_class   : "confirmationOverlay"
			}
		);
		return result === "Ok";
	};

	form_outbound_engine_processes.prototype.confirm_save = async function(newProcess)
	{
		const oldProcess = this.get_entity_instance();
		return await this.__confirm_save_sort_contacts(oldProcess, newProcess);
	};

	form_outbound_engine_processes.prototype.save_execute = async function(after_save, process /*, hash_id */)
	{
		if (!await this.confirm_save(process)) {
			this.on_saved(false, process, after_save, "skip_message");
			this.hide_waiting();
			return;
		}

		const self = this;
		this.show_waiting( "<%=_T('Please wait, Saving Process....')%>" );
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.processSave(process, function(success, response) {
			let err;
			if (success) {
				//self.show_status_message( "<%=_T('Successfully Saved Process.')%>", "Info", 5000 );
				self.hide_waiting();
				after_save = "SAVE_AND_NOT_EXIT_AND_REFRESH_VIEW";
			}
			else {
				err = response;
				//self.show_status_message( "<%=_T('Unable to Save Process.')%>", "Error", 5000 );
				self.hide_waiting();
			}
			self.on_saved(success, process, after_save, err);
		});
	};

	form_outbound_engine_processes.prototype.__get_server_error_description = function(err)
	{
		let response = { is_custom_message: true, message: undefined, result: err.result };
		
		switch (err.type) {
			case "PROCESS ALREADY EXIST":
				response.is_custom_message = true;
				response.message = FORMAT("<%=_T('Unable to update Process. Outbound process {0} already exist.')%>", err.processId);
			break;
			case "PROCESS IS RUNNING":
				response.is_custom_message = true;
				response.message = FORMAT("<%=_T('Unable to update Process. Outbound process {0} is running.')%>", err.processId);
			break;
			case "UNABLE TO CREATE PROCESS - CAMPAIGN IS ASSIGNED IN ANOTHER PROCESS":
				response.is_custom_message = true;
				response.message = FORMAT("<%=_T('Unable to create Process. Campaign {0} is assigned in another outbound process {1}.')%>", err.campaignId, err.otherProcessId);
			break;
			case "UNABLE TO UPDATE PROCESS - CAMPAIGN DOES NOT EXIST":
				response.is_custom_message = true;
				response.message = FORMAT("<%=_T('Unable to create Process {0}. Campaign {1} does not exist.')%>", err.processId, err.campaignId);
			break;
			case "UNABLE TO UPDATE PROCESS - CAMPAIGN HAS NOT ACCOUNTS":
				response.is_custom_message = true;
				response.message = FORMAT("<%=_T('Unable to create Process {0}. Campaign {1} has not accounts.')%>", err.processId, err.campaignId);
			break;
			case "UNABLE TO UPDATE PROCESS - ACCOUNT DOES NOT EXIST":
				response.is_custom_message = true;
				response.message = FORMAT("<%=_T('Unable to create Process {0}. Account {1} does not exist in campaign {2}.')%>", err.processId, err.accountId, err.campaignId);
			break;
			case "UNABLE TO UPDATE PROCESS - ACCOUNT IS INVALID":
				response.is_custom_message = true;
				if (err.accountErrType === "INVALID ACCOUNT") {
					response.message = FORMAT("<%=_T('Unable to create Process {0}. Invalid Account.')%>", err.processId, err.accountId, err.campaignId);
				}
				else if (err.accountErrType === "ACCOUNT IS DISABLED") {
					response.message = FORMAT("<%=_T('Unable to create Process {0}. Account {1} is deactivated in campaign {2}.')%>", err.processId, err.accountId, err.campaignId);
				}
				else if (err.accountErrType === "ACCOUNT HAS NOT PACKAGES") {
					response.message = FORMAT("<%=_T('Unable to create Process {0}. Account {1} of campaign {2} has not packages.')%>", err.processId, err.accountId, err.campaignId);
				}
				else if (err.accountErrType === "ACCOUNT HAS NOT OUTBOUND PACKAGES") {
					response.message = FORMAT("<%=_T('Unable to create Process {0}. Account {1} of campaign {2} has not outbound packages.')%>", err.processId, err.accountId, err.campaignId);
				}
				else {
					response.is_custom_message = false;
					response.message = err.type;
				}
			break;
			case "UNABLE TO UPDATE PROCESS - CAMPAIGN IS ASSIGNED IN ANOTHER PROCESS":
				response.is_custom_message = true;
				response.message = FORMAT("<%=_T('Unable to update Process. Campaign {0} is assigned in another outbound process {1}.')%>", err.campaignId, err.otherProcessId);
			break;
			case "UNABLE TO UPDATE PROCESS - CAN NOT CHANGE CAMPAIGN IF PROCESS IS RUNNING":
				response.is_custom_message = true;
				response.message = "<%=_T('Unable to update Process. Can not change campaign if process is running.')%>";
			break;
			default:
				response.is_custom_message = false;
				response.message = err.type;
		}
		return response;
	};

	form_outbound_engine_processes.prototype.err_save_messages = function(err)
	{
		if (typeof err !== "object") {
			form_outbound_engine_processes.uber.err_save_messages.call(this, err, false /* custom message*/); //invokes the base class method
			return;
		}
		
		let response = this.__get_server_error_description(err);

		form_outbound_engine_processes.uber.err_save_messages.call( this, response.message? response.message: response, response.is_custom_message ); //invokes the base class method
	};

	form_outbound_engine_processes.prototype.__hide_rules_section = function()
	{
	//	$("body").removeClass("popupDisplay");
	//	$("#out_form_process_schedule_section").hide();
	};

	form_outbound_engine_processes.prototype.__show_rules_section = function()
	{
		let sub_title = this.frm_rules.is_new_rule() ? "<%=_T('New Rule')%>" : "<%=_T('Edit Rule')%>";
		this.set_sub_title(sub_title);
		this.dashboard.$get_dom_element_by_id("form_buttons_actions").hide();
		$("#out_form_process_section").hide();
		$("#out_form_process_batches_section").hide();
		this.__hide_rules_section();
		$("#out_form_process_rules_section").show();
	};

	form_outbound_engine_processes.prototype.__new_rule = function()
	{
		this.frm_rules.set({});
		this.__show_rules_section();
	};

	form_outbound_engine_processes.prototype.__edit_rule = function(rule)
	{
		this.frm_rules.set(rule);
		this.__show_rules_section();
	};

	form_outbound_engine_processes.prototype.__new_batch = function()
	{
		this.__show_batches_section();
	};

	form_outbound_engine_processes.prototype.__show_batches_section = function()
	{
		this.frm_batches.initialize_ctrls();
		let sub_title = "<%=_T('Batches Management')%>";
		this.set_sub_title(sub_title);
		this.dashboard.$get_dom_element_by_id("form_buttons_actions").hide();
		$("#out_form_process_rules_section").hide();
		$("#out_form_process_section").hide();
		this.__hide_rules_section();
		$("#out_form_process_batches_section").show();
		this.$get_dom_element_by_id("form_back_btn_container").show();
	};

	form_outbound_engine_processes.prototype.show_process_section = function(callback = $.noop)
	{
		this.set_sub_title(); // lo deja empty al sub titulo
		this.form_paginator_rules.cleanup_edited_row();
		//this.frm_batches.dispose();
		$("#out_form_process_rules_section").hide();
		$("#out_form_process_batches_section").hide();
		this.__hide_rules_section();
		$("#out_form_process_section").show();
		this.dashboard.$get_dom_element_by_id("form_buttons_actions").show();
		callback();
	};

	form_outbound_engine_processes.prototype.on_edit_rule_popup = function(rule)
	{
		this.__edit_rule(rule);
	};

	form_outbound_engine_processes.prototype.add_update_rule = function(rule, callback = $.noop)
	{
		this.form_paginator_rules.add_or_update_row(rule);
		this.show_process_section();
		let message;
		if (this.frm_rules.is_new_rule()) {
			message = "<%=_T('Added Rule to Process.')%>";
		}
		else {
			message = "<%=_T('Updated Rule.')%>";
		}
		this.show_status_message(message, "Info", 5000);
		callback();
	};

	form_outbound_engine_processes.prototype.__open_batch_info_popup = function($btn_parent, batch)
	{
		if (this.batch_info_popup) {
			this.batch_info_popup.close();
			this.batch_info_popup = null;
		}
		let process = this.get_entity_instance();
		this.batch_info_popup = new BatchInfoPopup({processId: process.id, batch: batch});
		this.batch_info_popup.show({
			parentNode  : $btn_parent,
			owner_object: this
		});
	};
}());
