/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	//
	function outbound_engine_exportation_column_types_def() {}

	if (typeof inConcert.outbound_engine_exportation_column_types_def !== "function") {
		inConcert.outbound_engine_exportation_column_types_def = outbound_engine_exportation_column_types_def;
	}

	// esta funcion lee la defincion basica de los groupos (menos namevalue)
	outbound_engine_exportation_column_types_def.prototype.GetGroupDefinition = function(groupId)
	{
		var groupsDefinitions = {
			basicgroup: {
				group: "basic",
				translateGroup: '<%=_T("Basic")%>',
				readonlyExtraData: true,
				readonlyFieldName: true,
				editableFieldId: "",
				checkboxSelectedGroupId: "chkAllBasic",
				markUpIdErrorGroup: "errorBasicGroup"
			},
			subgroup_basic_attempts: {
				group: "subgroup_basic_attempts",
				translateGroup: '<%=_T("Attempts Number")%>',
				readonlyExtraData: true,
				readonlyFieldName: true,
				extraDataColumnName: "BasicAttemptsData",
				editableFieldId: "",
				checkboxSelectedGroupId: "chkAllSubGroupBasicAttempts",
				markUpIdErrorGroup: "errorAttemptsGroup"
			},
			phonegroup: {
				group: "phone",
				translateGroup: '<%=_T("Phone")%>',
				readonlyExtraData: false,
				readonlyFieldName: true,
				extraDataColumnName: "PhoneImportColumnName",
				extraDataFieldId: "PhoneExtraData",
				editableFieldId: "",
				checkboxSelectedGroupId: "chkAllPhone",
				markUpIdErrorGroup: "errorPhoneGroup"
			},
			batchgroup: {
				group: "batch",
				translateGroup: '<%=_T("Batch")%>',
				readonlyExtraData: true,
				readonlyFieldName: true,
				editableFieldId: "",
				checkboxSelectedGroupId: "chkAllBatch",
				markUpIdErrorGroup: "errorBatchGroup"
			},
			contactgroup: {
				group: "contact",
				translateGroup: '<%=_T("Contact Attempts")%>',
				readonlyExtraData: true,
				readonlyFieldName: true,
				editableFieldId: "",
				checkboxSelectedGroupId: "chkAllContact",
				markUpIdErrorGroup: "errorContactGroup"
			}
		};
		return groupsDefinitions[groupId];
	};

	//setea el column number y name a cada columna
	outbound_engine_exportation_column_types_def.prototype.SettingColumnNumberId = function(columnsTypes)
	{
		//basico
		columnsTypes.MULTIROW_INDEX.columnNumberType = 0;
		columnsTypes.MULTIROW_INDEX.columnNameType = "MULTIROW_INDEX";
		columnsTypes.CONTACT_NAME.columnNumberType = 1;
		columnsTypes.CONTACT_NAME.columnNameType = "CONTACT_NAME";
		columnsTypes.CONTACT_CATEGORY.columnNumberType = 2;
		columnsTypes.CONTACT_CATEGORY.columnNameType = "CONTACT_CATEGORY";
		columnsTypes.CONTACT_CAMPAIGN.columnNumberType = 3;
		columnsTypes.CONTACT_CAMPAIGN.columnNameType = "CONTACT_CAMPAIGN";
		columnsTypes.CONTACT_ACCOUNT_OFFICER.columnNumberType = 4;
		columnsTypes.CONTACT_ACCOUNT_OFFICER.columnNameType = "CONTACT_ACCOUNT_OFFICER";
		columnsTypes.CONTACT_ACCOUNT_GROUP.columnNumberType = 5;
		columnsTypes.CONTACT_ACCOUNT_GROUP.columnNameType = "CONTACT_ACCOUNT_GROUP";
		columnsTypes.CONTACT_LAST_MANAGEMENT_RESULT.columnNumberType = 60;
		columnsTypes.CONTACT_LAST_MANAGEMENT_RESULT.columnNameType = "CONTACT_LAST_MANAGEMENT_RESULT";
		columnsTypes.CONTACT_IS_CLIENT.columnNumberType = 6;
		columnsTypes.CONTACT_IS_CLIENT.columnNameType = "CONTACT_IS_CLIENT";
		columnsTypes.CONTACT_IS_VIP.columnNumberType = 7;
		columnsTypes.CONTACT_IS_VIP.columnNameType = "CONTACT_IS_VIP";
		columnsTypes.CONTACT_LAST_UPDATE.columnNumberType = 8;
		columnsTypes.CONTACT_LAST_UPDATE.columnNameType = "CONTACT_LAST_UPDATE";
		columnsTypes.CONTACT_BATCHS_INCLUDING.columnNumberType = 9;
		columnsTypes.CONTACT_BATCHS_INCLUDING.columnNameType = "CONTACT_BATCHS_INCLUDING";
		//especiales del grupo basico
		columnsTypes.CONTACT_TOTAL_ATTEMPTS.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS.columnNameType = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS.extraData = "";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ABANDONED.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ABANDONED.columnNameType = "CONTACT_TOTAL_ATTEMPTS_ABANDONED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ABANDONED.extraData = "ABANDONED";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ANSW_MACH.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ANSW_MACH.columnNameType = "CONTACT_TOTAL_ATTEMPTS_ANSW_MACH";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ANSW_MACH.extraData = "ANSWERING_MACHINE";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER.columnNameType = "CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER.extraData = "BLACKLISTED_NUMBER";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BUSY.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BUSY.columnNameType = "CONTACT_TOTAL_ATTEMPTS_BUSY";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BUSY.extraData = "BUSY";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED.columnNameType = "CONTACT_TOTAL_ATTEMPTS_REJECTED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED.extraData = "CALL_REJECTED";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT.columnNameType = "CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT.extraData = "CALL_REJECTED_BY_ENDPOINT";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT.columnNameType = "CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT.extraData = "CANT_ROUTE_TO_ENDPOINT";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN.columnNameType = "CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN.extraData = "CAUSE_UNKNOWN";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR.columnNameType = "CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR.extraData = "CONFIG_ERROR";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONGESTION.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONGESTION.columnNameType = "CONTACT_TOTAL_ATTEMPTS_CONGESTION";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONGESTION.extraData = "CONGESTION";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONNECTED.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONNECTED.columnNameType = "CONTACT_TOTAL_ATTEMPTS_CONNECTED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONNECTED.extraData = "CONNECTED";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT.columnNameType = "CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT.extraData = "DEAD_CONTACT";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_FAX.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_FAX.columnNameType = "CONTACT_TOTAL_ATTEMPTS_FAX";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_FAX.extraData = "FAX";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_HAND_FAILED.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_HAND_FAILED.columnNameType = "CONTACT_TOTAL_ATTEMPTS_HAND_FAILED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_HAND_FAILED.extraData = "HANDSHAKING_FAILED";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS.columnNameType = "CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS.extraData = "IN_PROGRESS";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT.columnNameType = "CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT.extraData = "INDIRECT_CONTACT";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET.columnNameType = "CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET.extraData = "INVALID_USE_NETWORK";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_LINK_DOWN.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_LINK_DOWN.columnNameType = "CONTACT_TOTAL_ATTEMPTS_LINK_DOWN";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_LINK_DOWN.extraData = "LINK_DOWN";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NET_ERR.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NET_ERR.columnNameType = "CONTACT_TOTAL_ATTEMPTS_NET_ERR";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NET_ERR.extraData = "NETWORK_ERROR";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NO_ANS.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NO_ANS.columnNameType = "CONTACT_TOTAL_ATTEMPTS_NO_ANS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NO_ANS.extraData = "NO_ANSWER";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND.columnNameType = "CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND.extraData = "NORMAL_CALL_END";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED.columnNameType = "CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED.extraData = "NUMBER_CHANGED";
		//-
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_PROT_ERR.columnNumberType = 10;
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_PROT_ERR.columnNameType = "CONTACT_TOTAL_ATTEMPTS_PROT_ERR";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_PROT_ERR.extraData = "PROTOCOL_ERROR";

		//grupo phone
		columnsTypes.PHONE.columnNumberType = 11;
		columnsTypes.PHONE.columnNameType = "PHONE";
		columnsTypes.PHONE_DESTINATION.columnNumberType = 12;
		columnsTypes.PHONE_DESTINATION.columnNameType = "PHONE_DESTINATION";
		columnsTypes.PHONE_COUNTRY.columnNumberType = 13;
		columnsTypes.PHONE_COUNTRY.columnNameType = "PHONE_COUNTRY";
		columnsTypes.PHONE_AREA.columnNumberType = 14;
		columnsTypes.PHONE_AREA.columnNameType = "PHONE_AREA";
		columnsTypes.PHONE_NUMBER.columnNumberType = 15;
		columnsTypes.PHONE_NUMBER.columnNameType = "PHONE_NUMBER";
		columnsTypes.PHONE_EXTENSION.columnNumberType = 16;
		columnsTypes.PHONE_EXTENSION.columnNameType = "PHONE_EXTENSION";
		columnsTypes.PHONE_STATUS.columnNumberType = 17;
		columnsTypes.PHONE_STATUS.columnNameType = "PHONE_STATUS";
		//batch
		columnsTypes.BATCH_ID.columnNumberType = 19;
		columnsTypes.BATCH_ID.columnNameType = "BATCH_ID";
		columnsTypes.BATCH_CAMPAIGN.columnNumberType = 20;
		columnsTypes.BATCH_CAMPAIGN.columnNameType = "BATCH_CAMPAIGN";
		columnsTypes.BATCH_OUTBOUND_PROCESS.columnNumberType = 21;
		columnsTypes.BATCH_OUTBOUND_PROCESS.columnNameType = "BATCH_OUTBOUND_PROCESS";
		columnsTypes.BATCH_CHANNEL_TYPE.columnNumberType = 22;
		columnsTypes.BATCH_CHANNEL_TYPE.columnNameType = "BATCH_CHANNEL_TYPE";
		columnsTypes.BATCH_PRIORITY.columnNumberType = 23;
		columnsTypes.BATCH_PRIORITY.columnNameType = "BATCH_PRIORITY";
		columnsTypes.BATCH_RESERVED_AGENT.columnNumberType = 24;
		columnsTypes.BATCH_RESERVED_AGENT.columnNameType = "BATCH_RESERVED_AGENT";
		columnsTypes.BATCH_LAST_CONTACT_ATTEMPT_DATE.columnNumberType = 25;
		columnsTypes.BATCH_LAST_CONTACT_ATTEMPT_DATE.columnNameType = "BATCH_LAST_CONTACT_ATTEMPT_DATE";
		columnsTypes.BATCH_LAST_DESTINATION.columnNumberType = 26;
		columnsTypes.BATCH_LAST_DESTINATION.columnNameType = "BATCH_LAST_DESTINATION";
		columnsTypes.BATCH_LAST_ADDRESS.columnNumberType = 27;
		columnsTypes.BATCH_LAST_ADDRESS.columnNameType = "BATCH_LAST_ADDRESS";
		columnsTypes.BATCH_LAST_INTERACTION.columnNumberType = 28;
		columnsTypes.BATCH_LAST_INTERACTION.columnNameType = "BATCH_LAST_INTERACTION";
		columnsTypes.BATCH_LAST_RESULT.columnNumberType = 29;
		columnsTypes.BATCH_LAST_RESULT.columnNameType = "BATCH_LAST_RESULT";
		columnsTypes.BATCH_LAST_SUCCESSFUL_CONTACT_DATE.columnNumberType = 30;
		columnsTypes.BATCH_LAST_SUCCESSFUL_CONTACT_DATE.columnNameType = "BATCH_LAST_SUCCESSFUL_CONTACT_DATE";
		columnsTypes.BATCH_NEXT_CONTACT_ATTEMPT_DATE.columnNumberType = 31;
		columnsTypes.BATCH_NEXT_CONTACT_ATTEMPT_DATE.columnNameType = "BATCH_NEXT_CONTACT_ATTEMPT_DATE";
		columnsTypes.BATCH_NEXT_DESTINATION.columnNumberType = 32;
		columnsTypes.BATCH_NEXT_DESTINATION.columnNameType = "BATCH_NEXT_DESTINATION";
		columnsTypes.BATCH_NEXT_ADDRESS.columnNumberType = 33;
		columnsTypes.BATCH_NEXT_ADDRESS.columnNameType = "BATCH_NEXT_ADDRESS";
		columnsTypes.BATCH_STATUS.columnNumberType = 34;
		columnsTypes.BATCH_STATUS.columnNameType = "BATCH_STATUS";
		columnsTypes.BATCH_CAUSE.columnNumberType = 35;
		columnsTypes.BATCH_CAUSE.columnNameType = "BATCH_CAUSE";
			//grupo contact
		columnsTypes.CONTACT_ATTEMPT_INTERACTION.columnNumberType = 36;
		columnsTypes.CONTACT_ATTEMPT_INTERACTION.columnNameType = "CONTACT_ATTEMPT_INTERACTION";
		columnsTypes.CONTACT_ATTEMPT_DESTINATION.columnNumberType = 37;
		columnsTypes.CONTACT_ATTEMPT_DESTINATION.columnNameType = "CONTACT_ATTEMPT_DESTINATION";
		columnsTypes.CONTACT_ATTEMPT_ADDRESS.columnNumberType = 38;
		columnsTypes.CONTACT_ATTEMPT_ADDRESS.columnNameType = "CONTACT_ATTEMPT_ADDRESS";
		columnsTypes.CONTACT_ATTEMPT_DATE.columnNumberType = 39;
		columnsTypes.CONTACT_ATTEMPT_DATE.columnNameType = "CONTACT_ATTEMPT_DATE";
		columnsTypes.CONTACT_ATTEMPT_DIALING_TIME.columnNumberType = 40;
		columnsTypes.CONTACT_ATTEMPT_DIALING_TIME.columnNameType = "CONTACT_ATTEMPT_DIALING_TIME";
		columnsTypes.CONTACT_ATTEMPT_RESULT.columnNumberType = 41;
		columnsTypes.CONTACT_ATTEMPT_RESULT.columnNameType = "CONTACT_ATTEMPT_RESULT";
		columnsTypes.CONTACT_ATTEMPT_TECH_RESULT.columnNumberType = 42;
		columnsTypes.CONTACT_ATTEMPT_TECH_RESULT.columnNameType = "CONTACT_ATTEMPT_TECH_RESULT";
		columnsTypes.CONTACT_ATTEMPT_AGENT.columnNumberType = 43;
		columnsTypes.CONTACT_ATTEMPT_AGENT.columnNameType = "CONTACT_ATTEMPT_AGENT";
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TO_AGENT_TIME.columnNumberType = 44;
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TO_AGENT_TIME.columnNameType = "CONTACT_ATTEMPT_TRANSFER_TO_AGENT_TIME";
		columnsTypes.CONTACT_ATTEMPT_CONVERSATION_TIME.columnNumberType = 45;
		columnsTypes.CONTACT_ATTEMPT_CONVERSATION_TIME.columnNameType = "CONTACT_ATTEMPT_CONVERSATION_TIME";
		columnsTypes.CONTACT_ATTEMPT_WAIT_TIME.columnNumberType = 46;
		columnsTypes.CONTACT_ATTEMPT_WAIT_TIME.columnNameType = "CONTACT_ATTEMPT_WAIT_TIME";
		columnsTypes.CONTACT_ATTEMPT_WRAPUP_TIME.columnNumberType = 47;
		columnsTypes.CONTACT_ATTEMPT_WRAPUP_TIME.columnNameType = "CONTACT_ATTEMPT_WRAPUP_TIME";
		columnsTypes.CONTACT_ATTEMPT_DESERTION_TIME.columnNumberType = 48;
		columnsTypes.CONTACT_ATTEMPT_DESERTION_TIME.columnNameType = "CONTACT_ATTEMPT_DESERTION_TIME";
		columnsTypes.CONTACT_ATTEMPT_HOLD_TIME.columnNumberType = 49;
		columnsTypes.CONTACT_ATTEMPT_HOLD_TIME.columnNameType = "CONTACT_ATTEMPT_HOLD_TIME";
		columnsTypes.CONTACT_ATTEMPT_DURATION_TIME.columnNumberType = 50;
		columnsTypes.CONTACT_ATTEMPT_DURATION_TIME.columnNameType = "CONTACT_ATTEMPT_DURATION_TIME";
		columnsTypes.CONTACT_ATTEMPT_ANSWER_TIME.columnNumberType = 51;
		columnsTypes.CONTACT_ATTEMPT_ANSWER_TIME.columnNameType = "CONTACT_ATTEMPT_ANSWER_TIME";
		columnsTypes.CONTACT_ATTEMPT_CONTROL_AGENT_TIME.columnNumberType = 52;
		columnsTypes.CONTACT_ATTEMPT_CONTROL_AGENT_TIME.columnNameType = "CONTACT_ATTEMPT_CONTROL_AGENT_TIME";
		columnsTypes.CONTACT_ATTEMPT_IVR_TIME.columnNumberType = 53;
		columnsTypes.CONTACT_ATTEMPT_IVR_TIME.columnNameType = "CONTACT_ATTEMPT_IVR_TIME";
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TIME.columnNumberType = 54;
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TIME.columnNameType = "CONTACT_ATTEMPT_TRANSFER_TIME";
		columnsTypes.CONTACT_ATTEMPT_REQUEUED_TIME.columnNumberType = 55;
		columnsTypes.CONTACT_ATTEMPT_REQUEUED_TIME.columnNameType = "CONTACT_ATTEMPT_REQUEUED_TIME";
		columnsTypes.CONTACT_ATTEMPT_RINGING_TIME.columnNumberType = 56;
		columnsTypes.CONTACT_ATTEMPT_RINGING_TIME.columnNameType = "CONTACT_ATTEMPT_RINGING_TIME";
		columnsTypes.CONTACT_ATTEMPT_RING_BACK_TIME.columnNumberType = 57;
		columnsTypes.CONTACT_ATTEMPT_RING_BACK_TIME.columnNameType = "CONTACT_ATTEMPT_RING_BACK_TIME";
		columnsTypes.CONTACT_ATTEMPT_STATUS_CHANGE.columnNumberType = 58;
		columnsTypes.CONTACT_ATTEMPT_STATUS_CHANGE.columnNameType = "CONTACT_ATTEMPT_STATUS_CHANGE";
		columnsTypes.CONTACT_ATTEMPT_NEXT_ATTEMPT.columnNumberType = 59;
		columnsTypes.CONTACT_ATTEMPT_NEXT_ATTEMPT.columnNameType = "CONTACT_ATTEMPT_NEXT_ATTEMPT";

		return columnsTypes;
	};

	// setea el id a los controles editables
	outbound_engine_exportation_column_types_def.prototype.SettingEditableControls = function(columnsTypes)
	{
		//basico
		columnsTypes.MULTIROW_INDEX.editableFieldId = "MULTIROW_INDEX";
		columnsTypes.CONTACT_NAME.editableFieldId = "CONTACT_NAME";
		columnsTypes.CONTACT_CATEGORY.editableFieldId = "CONTACT_CATEGORY";
		columnsTypes.CONTACT_CAMPAIGN.editableFieldId = "CONTACT_CAMPAIGN";
		columnsTypes.CONTACT_ACCOUNT_OFFICER.editableFieldId = "CONTACT_ACCOUNT_OFFICER";
		columnsTypes.CONTACT_ACCOUNT_GROUP.editableFieldId = "CONTACT_ACCOUNT_GROUP";
		columnsTypes.CONTACT_LAST_MANAGEMENT_RESULT.editableFieldId = "CONTACT_LAST_MANAGEMENT_RESULT";
		columnsTypes.CONTACT_IS_CLIENT.editableFieldId = "CONTACT_IS_CLIENT";
		columnsTypes.CONTACT_IS_VIP.editableFieldId = "CONTACT_IS_VIP";
		columnsTypes.CONTACT_LAST_UPDATE.editableFieldId = "CONTACT_LAST_UPDATE";
		columnsTypes.CONTACT_BATCHS_INCLUDING.editableFieldId = "CONTACT_BATCHS_INCLUDING";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS.editableFieldId = "CONTACT_TOTAL_ATTEMPTS";
		//especiales del grupo basico
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ABANDONED.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_ABANDONED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ANSW_MACH.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_ANSW_MACH";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BUSY.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_BUSY";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_REJECTED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONGESTION.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_CONGESTION";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONNECTED.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_CONNECTED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_FAX.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_FAX";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_HAND_FAILED.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_HAND_FAILED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_LINK_DOWN.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_LINK_DOWN";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NET_ERR.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_NET_ERR";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NO_ANS.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_NO_ANS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_PROT_ERR.editableFieldId = "CONTACT_TOTAL_ATTEMPTS_PROT_ERR";

		//grupo phone
		columnsTypes.PHONE.editableFieldId = "PHONE";
		columnsTypes.PHONE_DESTINATION.editableFieldId = "PHONE_DESTINATION";
		columnsTypes.PHONE_COUNTRY.editableFieldId = "PHONE_COUNTRY";
		columnsTypes.PHONE_AREA.editableFieldId = "PHONE_AREA";
		columnsTypes.PHONE_NUMBER.editableFieldId = "PHONE_NUMBER";
		columnsTypes.PHONE_EXTENSION.editableFieldId = "PHONE_EXTENSION";
		columnsTypes.PHONE_STATUS.editableFieldId = "PHONE_STATUS";
		//batch
		columnsTypes.BATCH_ID.editableFieldId = "BATCH_ID";
		columnsTypes.BATCH_CAMPAIGN.editableFieldId = "BATCH_CAMPAIGN";
		columnsTypes.BATCH_OUTBOUND_PROCESS.editableFieldId = "BATCH_OUTBOUND_PROCESS";
		columnsTypes.BATCH_CHANNEL_TYPE.editableFieldId = "BATCH_CHANNEL_TYPE";
		columnsTypes.BATCH_PRIORITY.editableFieldId = "BATCH_PRIORITY";
		columnsTypes.BATCH_RESERVED_AGENT.editableFieldId = "BATCH_RESERVED_AGENT";
		columnsTypes.BATCH_LAST_CONTACT_ATTEMPT_DATE.editableFieldId = "BATCH_LAST_CONTACT_ATTEMPT_DATE";
		columnsTypes.BATCH_LAST_DESTINATION.editableFieldId = "BATCH_LAST_DESTINATION";
		columnsTypes.BATCH_LAST_ADDRESS.editableFieldId = "BATCH_LAST_ADDRESS";
		columnsTypes.BATCH_LAST_INTERACTION.editableFieldId = "BATCH_LAST_INTERACTION";
		columnsTypes.BATCH_LAST_RESULT.editableFieldId = "BATCH_LAST_RESULT";
		columnsTypes.BATCH_LAST_SUCCESSFUL_CONTACT_DATE.editableFieldId = "BATCH_LAST_SUCCESSFUL_CONTACT_DATE";
		columnsTypes.BATCH_NEXT_CONTACT_ATTEMPT_DATE.editableFieldId = "BATCH_NEXT_CONTACT_ATTEMPT_DATE";
		columnsTypes.BATCH_NEXT_DESTINATION.editableFieldId = "BATCH_NEXT_DESTINATION";
		columnsTypes.BATCH_NEXT_ADDRESS.editableFieldId = "BATCH_NEXT_ADDRESS";
		columnsTypes.BATCH_STATUS.editableFieldId = "BATCH_STATUS";
		columnsTypes.BATCH_CAUSE.editableFieldId = "BATCH_CAUSE";
			//grupo contact
		columnsTypes.CONTACT_ATTEMPT_INTERACTION.editableFieldId = "CONTACT_ATTEMPT_INTERACTION";
		columnsTypes.CONTACT_ATTEMPT_DESTINATION.editableFieldId = "CONTACT_ATTEMPT_DESTINATION";
		columnsTypes.CONTACT_ATTEMPT_ADDRESS.editableFieldId = "CONTACT_ATTEMPT_ADDRESS";
		columnsTypes.CONTACT_ATTEMPT_DATE.editableFieldId = "CONTACT_ATTEMPT_DATE";
		columnsTypes.CONTACT_ATTEMPT_DIALING_TIME.editableFieldId = "CONTACT_ATTEMPT_DIALING_TIME";
		columnsTypes.CONTACT_ATTEMPT_RESULT.editableFieldId = "CONTACT_ATTEMPT_RESULT";
		columnsTypes.CONTACT_ATTEMPT_TECH_RESULT.editableFieldId = "CONTACT_ATTEMPT_TECH_RESULT";
		columnsTypes.CONTACT_ATTEMPT_AGENT.editableFieldId = "CONTACT_ATTEMPT_AGENT";
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TO_AGENT_TIME.editableFieldId = "CONTACT_ATTEMPT_TRANSFER_TO_AGENT_TIME";
		columnsTypes.CONTACT_ATTEMPT_CONVERSATION_TIME.editableFieldId = "CONTACT_ATTEMPT_CONVERSATION_TIME";
		columnsTypes.CONTACT_ATTEMPT_WAIT_TIME.editableFieldId = "CONTACT_ATTEMPT_WAIT_TIME";
		columnsTypes.CONTACT_ATTEMPT_WRAPUP_TIME.editableFieldId = "CONTACT_ATTEMPT_WRAPUP_TIME";
		columnsTypes.CONTACT_ATTEMPT_DESERTION_TIME.editableFieldId = "CONTACT_ATTEMPT_DESERTION_TIME";
		columnsTypes.CONTACT_ATTEMPT_HOLD_TIME.editableFieldId = "CONTACT_ATTEMPT_HOLD_TIME";
		columnsTypes.CONTACT_ATTEMPT_DURATION_TIME.editableFieldId = "CONTACT_ATTEMPT_DURATION_TIME";
		columnsTypes.CONTACT_ATTEMPT_ANSWER_TIME.editableFieldId = "CONTACT_ATTEMPT_ANSWER_TIME";
		columnsTypes.CONTACT_ATTEMPT_CONTROL_AGENT_TIME.editableFieldId = "CONTACT_ATTEMPT_CONTROL_AGENT_TIME";
		columnsTypes.CONTACT_ATTEMPT_IVR_TIME.editableFieldId = "CONTACT_ATTEMPT_IVR_TIME";
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TIME.editableFieldId = "CONTACT_ATTEMPT_TRANSFER_TIME";
		columnsTypes.CONTACT_ATTEMPT_REQUEUED_TIME.editableFieldId = "CONTACT_ATTEMPT_REQUEUED_TIME";
		columnsTypes.CONTACT_ATTEMPT_RINGING_TIME.editableFieldId = "CONTACT_ATTEMPT_RINGING_TIME";
		columnsTypes.CONTACT_ATTEMPT_RING_BACK_TIME.editableFieldId = "CONTACT_ATTEMPT_RING_BACK_TIME";
		columnsTypes.CONTACT_ATTEMPT_STATUS_CHANGE.editableFieldId = "CONTACT_ATTEMPT_STATUS_CHANGE";
		columnsTypes.CONTACT_ATTEMPT_NEXT_ATTEMPT.editableFieldId = "CONTACT_ATTEMPT_NEXT_ATTEMPT";

		return columnsTypes;
	};

	// setea el texto sugerido para cada columna.
	outbound_engine_exportation_column_types_def.prototype.SettingSuggestedColumnName = function(columnsTypes)
	{
		//basico
		columnsTypes.MULTIROW_INDEX.suggestedColumnName = '<%=_T("Multi Row")%>';
		columnsTypes.CONTACT_NAME.suggestedColumnName = '<%=_T("Contact Name")%>';
		columnsTypes.CONTACT_CATEGORY.suggestedColumnName = '<%=_T("Category")%>';
		columnsTypes.CONTACT_CAMPAIGN.suggestedColumnName = '<%=_T("Campaign")%>';
		columnsTypes.CONTACT_ACCOUNT_OFFICER.suggestedColumnName = '<%=_T("Account Officer")%>';
		columnsTypes.CONTACT_ACCOUNT_GROUP.suggestedColumnName = '<%=_T("Account Group")%>';
		columnsTypes.CONTACT_LAST_MANAGEMENT_RESULT.suggestedColumnName = '<%=_T("Management Result")%>';
		columnsTypes.CONTACT_IS_CLIENT.suggestedColumnName = '<%=_T("Is Client")%>';
		columnsTypes.CONTACT_IS_VIP.suggestedColumnName = '<%=_T("Is VIP")%>';
		columnsTypes.CONTACT_LAST_UPDATE.suggestedColumnName = '<%=_T("Last Update")%>';
		columnsTypes.CONTACT_BATCHS_INCLUDING.suggestedColumnName = '<%=_T("Batchs Including")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS.suggestedColumnName = '<%=_T("Total Attempts")%>';
		//especiales del grupo basico
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ABANDONED.suggestedColumnName = '<%=_T("Abandoned")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ANSW_MACH.suggestedColumnName = '<%=_T("Answering Machine")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER.suggestedColumnName = '<%=_T("Blacklisted Number")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BUSY.suggestedColumnName = '<%=_T("Busy")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED.suggestedColumnName = '<%=_T("Rejected")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT.suggestedColumnName = '<%=_T("Rejected by Endpoint")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT.suggestedColumnName = "<%=_T([[Can't Route to Endpoint]])%>";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN.suggestedColumnName = '<%=_T("Cause Unknown")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR.suggestedColumnName = '<%=_T("Config Error")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONGESTION.suggestedColumnName = '<%=_T("Congestion")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONNECTED.suggestedColumnName = '<%=_T("Connected")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT.suggestedColumnName = '<%=_T("Dead Contact")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_FAX.suggestedColumnName = '<%=_T("Fax")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_HAND_FAILED.suggestedColumnName = '<%=_T("Hand Failed")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS.suggestedColumnName = '<%=_T("In Progress")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT.suggestedColumnName = '<%=_T("Indirect Contact")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET.suggestedColumnName = '<%=_T("Invalid Use Network")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_LINK_DOWN.suggestedColumnName = '<%=_T("Link Down")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NET_ERR.suggestedColumnName = '<%=_T("Network Error")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NO_ANS.suggestedColumnName = '<%=_T("No Answer")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND.suggestedColumnName = '<%=_T("Normal CallEnd")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED.suggestedColumnName = '<%=_T("Number Changed")%>';
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_PROT_ERR.suggestedColumnName = '<%=_T("Protocol Error")%>';

		//grupo phone
		columnsTypes.PHONE.suggestedColumnName = '<%=_T("Phone")%>';
		columnsTypes.PHONE_DESTINATION.suggestedColumnName = '<%=_T("Phone Destination")%>';
		columnsTypes.PHONE_COUNTRY.suggestedColumnName = '<%=_T("Phone Country")%>';
		columnsTypes.PHONE_AREA.suggestedColumnName = '<%=_T("Phone Area Code")%>';
		columnsTypes.PHONE_NUMBER.suggestedColumnName = '<%=_T("Phone Number")%>';
		columnsTypes.PHONE_EXTENSION.suggestedColumnName = '<%=_T("Phone Extension")%>';
		columnsTypes.PHONE_STATUS.suggestedColumnName = '<%=_T("Phone Status")%>';
		//batch
		columnsTypes.BATCH_ID.suggestedColumnName = '<%=_T("Batch Id")%>';
		columnsTypes.BATCH_CAMPAIGN.suggestedColumnName = '<%=_T("Campaign Batch")%>';
		columnsTypes.BATCH_OUTBOUND_PROCESS.suggestedColumnName = '<%=_T("Outbound Process Batch")%>';
		columnsTypes.BATCH_CHANNEL_TYPE.suggestedColumnName = '<%=_T("Batch Channel Type")%>';
		columnsTypes.BATCH_PRIORITY.suggestedColumnName = '<%=_T("Priority Batch")%>';
		columnsTypes.BATCH_RESERVED_AGENT.suggestedColumnName = '<%=_T("Batch Reserverd Agent")%>';
		columnsTypes.BATCH_LAST_CONTACT_ATTEMPT_DATE.suggestedColumnName = '<%=_T("Last Contact Attempt Date Batch")%>';
		columnsTypes.BATCH_LAST_DESTINATION.suggestedColumnName = '<%=_T("Last Destination Batch")%>';
		columnsTypes.BATCH_LAST_ADDRESS.suggestedColumnName = '<%=_T("Last Address Batch")%>';
		columnsTypes.BATCH_LAST_INTERACTION.suggestedColumnName = '<%=_T("Last Interaction Batch")%>';
		columnsTypes.BATCH_LAST_RESULT.suggestedColumnName = '<%=_T("Last Result Batch")%>';
		columnsTypes.BATCH_LAST_SUCCESSFUL_CONTACT_DATE.suggestedColumnName = '<%=_T("Last Successfully Contact Date Batch")%>';
		columnsTypes.BATCH_NEXT_CONTACT_ATTEMPT_DATE.suggestedColumnName = '<%=_T("Next Contact Attempt Date Batch")%>';
		columnsTypes.BATCH_NEXT_DESTINATION.suggestedColumnName = '<%=_T("Next Destination Batch")%>';
		columnsTypes.BATCH_NEXT_ADDRESS.suggestedColumnName = '<%=_T("Next Address Batch")%>';
		columnsTypes.BATCH_STATUS.suggestedColumnName = '<%=_T("Batch Status")%>';
		columnsTypes.BATCH_CAUSE.suggestedColumnName = '<%=_T("Batch Cause")%>';
			//grupo contact
		columnsTypes.CONTACT_ATTEMPT_INTERACTION.suggestedColumnName = '<%=_T("Contact Attempt Interaction")%>';
		columnsTypes.CONTACT_ATTEMPT_DESTINATION.suggestedColumnName = '<%=_T("Contact Attempt Destination")%>';
		columnsTypes.CONTACT_ATTEMPT_ADDRESS.suggestedColumnName = '<%=_T("Contact Attempt Address")%>';
		columnsTypes.CONTACT_ATTEMPT_DATE.suggestedColumnName = '<%=_T("Contact Attempt Date")%>';
		columnsTypes.CONTACT_ATTEMPT_DIALING_TIME.suggestedColumnName = '<%=_T("Contact Attempt Dialing Time")%>';
		columnsTypes.CONTACT_ATTEMPT_RESULT.suggestedColumnName = '<%=_T("Contact Attempt Result")%>';
		columnsTypes.CONTACT_ATTEMPT_TECH_RESULT.suggestedColumnName = '<%=_T("Contact Attempt Tech Result")%>';
		columnsTypes.CONTACT_ATTEMPT_AGENT.suggestedColumnName = '<%=_T("Contact Attempt Agent")%>';
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TO_AGENT_TIME.suggestedColumnName = '<%=_T("Contact Attempt Transfer To Agent Time")%>';
		columnsTypes.CONTACT_ATTEMPT_CONVERSATION_TIME.suggestedColumnName = '<%=_T("Contact Attempt Conversation Time")%>';
		columnsTypes.CONTACT_ATTEMPT_WAIT_TIME.suggestedColumnName = '<%=_T("Contact Attempt Wait Time")%>';
		columnsTypes.CONTACT_ATTEMPT_WRAPUP_TIME.suggestedColumnName = '<%=_T("Contact Attempt Wrapup Time")%>';
		columnsTypes.CONTACT_ATTEMPT_DESERTION_TIME.suggestedColumnName = '<%=_T("Contact Attempt Desertion Time")%>';
		columnsTypes.CONTACT_ATTEMPT_HOLD_TIME.suggestedColumnName = '<%=_T("Contact Attempt Hold Time")%>';
		columnsTypes.CONTACT_ATTEMPT_DURATION_TIME.suggestedColumnName = '<%=_T("Contact Attempt Duration Time")%>';
		columnsTypes.CONTACT_ATTEMPT_ANSWER_TIME.suggestedColumnName = '<%=_T("Contact Attempt Answer Time")%>';
		columnsTypes.CONTACT_ATTEMPT_CONTROL_AGENT_TIME.suggestedColumnName = '<%=_T("Contact Attempt Control Agent Time")%>';
		columnsTypes.CONTACT_ATTEMPT_IVR_TIME.suggestedColumnName = '<%=_T("Contact Attempt IVR Time")%>';
		columnsTypes.CONTACT_ATTEMPT_TRANSFER_TIME.suggestedColumnName = '<%=_T("Contact Attempt Transfer Time")%>';
		columnsTypes.CONTACT_ATTEMPT_REQUEUED_TIME.suggestedColumnName = '<%=_T("Contact Attempt Requeued Time")%>';
		columnsTypes.CONTACT_ATTEMPT_RINGING_TIME.suggestedColumnName = '<%=_T("Contact Attempt Ringing Time")%>';
		columnsTypes.CONTACT_ATTEMPT_RING_BACK_TIME.suggestedColumnName = '<%=_T("Contact Attempt Ring Back Time")%>';
		columnsTypes.CONTACT_ATTEMPT_STATUS_CHANGE.suggestedColumnName = '<%=_T("Contact Attempt Status Change")%>';
		columnsTypes.CONTACT_ATTEMPT_NEXT_ATTEMPT.suggestedColumnName = '<%=_T("Contact Attempt Next Attempt")%>';

		return columnsTypes;
	};

	// setea las columnas especiales
	outbound_engine_exportation_column_types_def.prototype.SettingSpecialData = function(columnsTypes)
	{
		//basico
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ABANDONED.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_ANSW_MACH.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_BUSY.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONGESTION.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_CONNECTED.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_FAX.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_HAND_FAILED.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_LINK_DOWN.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NET_ERR.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NO_ANS.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED.columnId = "CONTACT_TOTAL_ATTEMPTS";
		columnsTypes.CONTACT_TOTAL_ATTEMPTS_PROT_ERR.columnId = "CONTACT_TOTAL_ATTEMPTS";

		return columnsTypes;
	};

	// inicializa las colummnas
	outbound_engine_exportation_column_types_def.prototype.GetColumnsTypesDefinitions = function()
	{
		var columnsTypes = {
			//grupo basico
			MULTIROW_INDEX: this.GetGroupDefinition("basicgroup"),
			CONTACT_NAME: this.GetGroupDefinition("basicgroup"),
			CONTACT_CATEGORY: this.GetGroupDefinition("basicgroup"),
			CONTACT_CAMPAIGN: this.GetGroupDefinition("basicgroup"),
			CONTACT_ACCOUNT_OFFICER: this.GetGroupDefinition("basicgroup"),
			CONTACT_ACCOUNT_GROUP: this.GetGroupDefinition("basicgroup"),
			CONTACT_LAST_MANAGEMENT_RESULT: this.GetGroupDefinition("basicgroup"),
			CONTACT_IS_CLIENT: this.GetGroupDefinition("basicgroup"),
			CONTACT_IS_VIP: this.GetGroupDefinition("basicgroup"),
			CONTACT_LAST_UPDATE: this.GetGroupDefinition("basicgroup"),
			CONTACT_BATCHS_INCLUDING: this.GetGroupDefinition("basicgroup"),
			// ESPECIALES DEL GRUPO BASICO (sub grupo attemts)
			CONTACT_TOTAL_ATTEMPTS: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_ABANDONED: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_ANSW_MACH: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_BLACK_NUMBER: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_BUSY: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_REJECTED: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_REJECTED_ENDPOINT: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_CANT_ROUTE_ENDPOINT: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_CAUSE_UNKNOWN: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_CONFIG_ERROR: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_CONGESTION: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_CONNECTED: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_DEAD_CONTACT: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_FAX: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_HAND_FAILED: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_IN_PROGRESS: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_INDIRECT_CONTACT: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_INVALID_USE_NET: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_LINK_DOWN: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_NET_ERR: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_NO_ANS: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_NORMAL_CALLEND: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_NUM_CHANGED: this.GetGroupDefinition("subgroup_basic_attempts"),
			CONTACT_TOTAL_ATTEMPTS_PROT_ERR: this.GetGroupDefinition("subgroup_basic_attempts"),

			//grupo phone
			PHONE: this.GetGroupDefinition("phonegroup"),
			PHONE_DESTINATION: this.GetGroupDefinition("phonegroup"),
			PHONE_COUNTRY: this.GetGroupDefinition("phonegroup"),
			PHONE_AREA: this.GetGroupDefinition("phonegroup"),
			PHONE_NUMBER: this.GetGroupDefinition("phonegroup"),
			PHONE_EXTENSION: this.GetGroupDefinition("phonegroup"),
			PHONE_STATUS: this.GetGroupDefinition("phonegroup"),
			//grupo name value
			NAME_VALUE: {
				group: "namevalue",
				translateGroup: '<%=_T("Name Value")%>',
				columnId: "NAME_VALUE",
				columnNumberType: 18,
				readonlyExtraData: true,
				readonlyFieldName: false,
				extraDataColumnName: 'NameValueFieldName',
				editableFieldId: 'NAME_VALUE_ID',
				editableColumnId: 'NAME_VALUE_NAME',
				markUpIdErrorGroup: "errorNameValueGroup"
			},
			NAME_VALUE1: {
				group: "namevalue",
				translateGroup: '<%=_T("Name Value")%>',
				columnId: "NAME_VALUE",
				columnNumberType: 18,
				readonlyExtraData: true,
				readonlyFieldName: false,
				extraDataColumnName: 'NameValueFieldName',
				editableFieldId: 'NAME_VALUE_ID1',
				editableColumnId: 'NAME_VALUE_NAME1',
				markUpIdErrorGroup: "errorNameValueGroup"
			},
			//grupo skill
			SKILL: {
				group: "skill",
				translateGroup: '<%=_T("Skill")%>',
				columnId: "SKILL",
				columnNumberType: 61,
				readonlyExtraData: true,
				readonlyFieldName: false,
				extraDataColumnName: 'SkillFieldName',
				editableFieldId: 'SKILL_ID',
				editableColumnId: 'SKILL_NAME',
				markUpIdErrorGroup: "errorSkillGroup"
			},
			SKILL1: {
				group: "skill",
				translateGroup: '<%=_T("Skill")%>',
				columnId: "SKILL",
				columnNumberType: 61,
				readonlyExtraData: true,
				readonlyFieldName: false,
				extraDataColumnName: 'SkillFieldName',
				editableFieldId: 'SKILL_ID1',
				editableColumnId: 'SKILL_NAME1',
				markUpIdErrorGroup: "errorSkillGroup"
			},
			//grupo batch
			BATCH_ID: this.GetGroupDefinition("batchgroup"),
			BATCH_CAMPAIGN: this.GetGroupDefinition("batchgroup"),
			BATCH_OUTBOUND_PROCESS: this.GetGroupDefinition("batchgroup"),
			BATCH_CHANNEL_TYPE: this.GetGroupDefinition("batchgroup"),
			BATCH_PRIORITY: this.GetGroupDefinition("batchgroup"),
			BATCH_RESERVED_AGENT: this.GetGroupDefinition("batchgroup"),
			BATCH_LAST_CONTACT_ATTEMPT_DATE: this.GetGroupDefinition("batchgroup"),
			BATCH_LAST_DESTINATION: this.GetGroupDefinition("batchgroup"),
			BATCH_LAST_ADDRESS: this.GetGroupDefinition("batchgroup"),
			BATCH_LAST_INTERACTION: this.GetGroupDefinition("batchgroup"),
			BATCH_LAST_RESULT: this.GetGroupDefinition("batchgroup"),
			BATCH_LAST_SUCCESSFUL_CONTACT_DATE: this.GetGroupDefinition("batchgroup"),
			BATCH_NEXT_CONTACT_ATTEMPT_DATE: this.GetGroupDefinition("batchgroup"),
			BATCH_NEXT_DESTINATION: this.GetGroupDefinition("batchgroup"),
			BATCH_NEXT_ADDRESS: this.GetGroupDefinition("batchgroup"),
			BATCH_STATUS: this.GetGroupDefinition("batchgroup"),
			BATCH_CAUSE: this.GetGroupDefinition("batchgroup"),
			//grupo contact
			CONTACT_ATTEMPT_INTERACTION: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_DESTINATION: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_ADDRESS: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_DATE: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_DIALING_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_RESULT: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_TECH_RESULT: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_AGENT: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_TRANSFER_TO_AGENT_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_CONVERSATION_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_WAIT_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_WRAPUP_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_DESERTION_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_HOLD_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_DURATION_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_ANSWER_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_CONTROL_AGENT_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_IVR_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_TRANSFER_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_REQUEUED_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_RINGING_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_RING_BACK_TIME: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_STATUS_CHANGE: this.GetGroupDefinition("contactgroup"),
			CONTACT_ATTEMPT_NEXT_ATTEMPT: this.GetGroupDefinition("contactgroup")
		};

		// setea el id de la columna, es el numero que corresponde con el enum
		columnsTypes = this.SettingColumnNumberId(columnsTypes);
		//id de los controles labels y textobx editables
		columnsTypes = this.SettingEditableControls(columnsTypes);
		// nombre de columna sugerido
		columnsTypes = this.SettingSuggestedColumnName(columnsTypes);
		// seteo datos especiales a columna y/grupos especiales
		columnsTypes = this.SettingSpecialData(columnsTypes);

		return columnsTypes;

	};

	// obtiene la definicion de una columna espeficia
	outbound_engine_exportation_column_types_def.prototype.GetColumnDefinition = function(columnTypes, columnId)
	{
		return columnTypes[columnId];
	};

	outbound_engine_exportation_column_types_def.prototype.GetHashBasicEspecialColumns = function(columns)
	{
		var hashEspecialColumns = {};
		for (var columnId in columns) {
			if (columns.hasOwnProperty(columnId)) {
				var columnDefinition = columns[columnId];
				if (columnDefinition.group !== "subgroup_basic_attempts") {
					continue;
				}
				hashEspecialColumns[columnDefinition.extraData] = columnDefinition;
			}
		}
		return hashEspecialColumns;
	};

	// genera un grupo dinamico (phone)
	outbound_engine_exportation_column_types_def.prototype.BuildDynamicGroup = function(actualColumnTypes, groupId, index)
	{
		var destinationColumns = {};
		var basicColumnTypes = this.GetColumnsTypesDefinitions();
		for (let columnId in basicColumnTypes) {
			if (basicColumnTypes.hasOwnProperty(columnId)) {
				if (basicColumnTypes[columnId].group.toLowerCase() !== groupId.toLowerCase()) {
					continue;
				}
				var newColumnId = columnId + index;
				destinationColumns[newColumnId] = this.GetColumnDefinition(basicColumnTypes, columnId);
				destinationColumns[newColumnId].editableFieldId = destinationColumns[newColumnId].editableFieldId + index;
				destinationColumns[newColumnId].extraDataFieldId = destinationColumns[newColumnId].extraDataFieldId + index;
				destinationColumns[newColumnId].suggestedColumnName = destinationColumns[newColumnId].suggestedColumnName + index;
				destinationColumns[newColumnId].checkboxSelectedGroupId = destinationColumns[newColumnId].checkboxSelectedGroupId + index;
			}
		}
		for (let columnId in destinationColumns) {
			if (destinationColumns.hasOwnProperty(columnId)) {
				actualColumnTypes[columnId] = destinationColumns[columnId];
			}
		}
		return actualColumnTypes;
	};


// genera un grupo dinamico (skills)
	outbound_engine_exportation_column_types_def.prototype.BuildDynamicSkillGroup = function(actualColumnTypes, columnId, index) {
		var newColumnId = columnId + (index - 1);
		actualColumnTypes[newColumnId] = this.GetColumnDefinition(this.GetColumnsTypesDefinitions(), columnId);
		actualColumnTypes[newColumnId].editableFieldId = 'SKILL_ID' + (index - 1);
		actualColumnTypes[newColumnId].editableColumnId = 'SKILL_NAME' + (index - 1);
		newColumnId = columnId + index;
		actualColumnTypes[newColumnId] = this.GetColumnDefinition(this.GetColumnsTypesDefinitions(), columnId);
		actualColumnTypes[newColumnId].editableFieldId = 'SKILL_ID' + index;
		actualColumnTypes[newColumnId].editableColumnId = 'SKILL_NAME' + index;

		return actualColumnTypes;
	};

// genera un grupo dinamico (namevalue)
	outbound_engine_exportation_column_types_def.prototype.BuildDynamicNameValueGroup = function(actualColumnTypes, columnId, index) {
		var newColumnId = columnId + (index - 1);
		actualColumnTypes[newColumnId] = this.GetColumnDefinition(this.GetColumnsTypesDefinitions(), columnId);
		actualColumnTypes[newColumnId].editableFieldId = 'NAME_VALUE_ID' + (index - 1);
		actualColumnTypes[newColumnId].editableColumnId = 'NAME_VALUE_NAME' + (index - 1);
		newColumnId = columnId + index;
		actualColumnTypes[newColumnId] = this.GetColumnDefinition(this.GetColumnsTypesDefinitions(), columnId);
		actualColumnTypes[newColumnId].editableFieldId = 'NAME_VALUE_ID' + index;
		actualColumnTypes[newColumnId].editableColumnId = 'NAME_VALUE_NAME' + index;

		return actualColumnTypes;
	};

}());
