--
-- lua test_create_batch.lua  -P pr_campdialermanual -B campdialermanual_Batch1 -I importmanual4
--

local args = require('pl.lapp') [[

i6 New User parameters generation:
  -P,--processId (string)
  -B,--batchId (string)
  -I,--importId (string) 
]]

local outboundEngine = require "lua_outboundengineclient"
local json = require "json"

local vcc = "vcc1"
local processIdName = args.processId
local batchIdName = args.batchId
local importIdName = args.importId 
local m_client
local function GetClient()
    if not m_client then
        m_client = outboundEngine.LuaOutboundEngineClient("MiniClusterUbuntu", "webhandler")
    end
    return m_client
end

GetClient()
m_client:AddKnownOutboundEngine("192.168.4.11", "9033")

local result

result =       m_client:DestroyBatch(json.encode({ processId = processIdName .. "@" .. vcc, batchId = batchIdName .. ":" .. processIdName .. "@" .. vcc }))
print('RESULT: ', json.encode(result))
--if true then return end

local info = json.encode({
	processId = processIdName .. "@" .. vcc,
	configuration = {
		name = batchIdName,
		batchPriority = 1,
		basePriority = 100,
		-- startDate = "2022-05-10",
		-- endDate = "2022-05-10",
		-- percentage = ,
		-- scheduleDate (solo create y add, aplica solo para los contactos agregados en ese momento)
		-- agent (idem)
		--engineType (idem)
	},
	scope = {
		conditions = {
			type = "must",
			conditions = {
				{
					type = "term",
					name = "ImportId",
					value = importIdName,
				}
			}
		}
	}
})
print('POST DATA: ', info)
result = m_client:CreateBatch(info)
print('RESULT: ', json.encode(result))
