module(..., package.seeall)

local utils = require "shared.apps.utils"

local m_datasource

function GetName ()
	return "Environment"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetDataSource ()
	if not m_datasource then
		local model = require "apps.provisioning.model"
		model.BuildModels(true)
	end
	return m_datasource
end

function GetInstalationID (keyspace)
	local closeKeyspace = false
	if not keyspace then
		keyspace = utils.GetDatasource():CassandraConnection("Provisioning")
		closeKeyspace = true
	end
	local installation = utils.GetAllColumns {
		keyspace = keyspace or "Provisioning",
		columnFamily = "SystemConfiguration",
		startKey     = "INSTALLATION_ID",
		endKey       = "",
		columnCount = 50000
	} or {}

	if closeKeyspace then
		keyspace:Close()
	end

	if utils.TableIsEmpty(installation) then
		return nil
	end

	return installation["INSTALLATION_ID"]
end

function GetHotfixes (keyspace)
	local closeKeyspace = false
	if not keyspace then
		keyspace = utils.GetDatasource():CassandraConnection("Agent")
		closeKeyspace = true
	end
	local Hotfixes = utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "Hotfixes",
		startKey     = "",
		endKey       = "",
		columnCount = 50000
	} or {}

	if closeKeyspace then
		keyspace:Close()
	end

	if utils.TableIsEmpty(Hotfixes) then
		return nil
	end

	return Hotfixes
end