module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

--[[
]]--
function GetName ()
	return "Users"
end

--[[
]]--
function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

--[[
]]--
function GetDataSource ()
	if not m_datasource then
		local model = require "apps.provisioning.model"
		model.BuildModels(true)
	end
	return m_datasource
end

--[[------------------------------------------------------------------------------------------
	USERS
----------------------------------------------------------------------------------------------]]--

--[[
]]--
function GetUser (vcc, simpleId, ksAgent, columns)
	simpleId = simpleId:lower()
	local user       = utils.GetAllColumns({
		keyspace     = ksAgent or "Agent",
		columnFamily = "Users",
		key          = utils.AppendVcc(simpleId, vcc),
		columns      = columns
	}) or {}
	return user
end

--[[------------------------------------------------------------------------------------------
	SUPER USERS
----------------------------------------------------------------------------------------------]]--

--[[
]]--
function GetVCCSuperUsers (vcc, withFullData, ksAgent, columns)
	local superUsers = utils.GetAllColumns {
		keyspace = ksAgent or "Agent",
		columnFamily = "VCCSuperUsers",
		key = vcc,
		columnCount = 50000
	} or {}
	if not withFullData then
		return superUsers
	end
	local superUsersWithFullData = {}
	for superUserId, superUser in pairs(superUsers) do
		--LogDebug("superUserId: %s", superUserId)
		local user = GetUser(vcc, superUserId, ksAgent, columns)
		if not utils.TableIsEmpty(user) then
			superUsersWithFullData[superUserId] = user
		end
	end
	return superUsersWithFullData
end

--[[
]]--
function GetSuperUser (vcc, simpleId, ksAgent, columns, withFullData)
	assert(vcc)
	assert(simpleId)
	--simpleId = simpleId:lower()
	local superUsers = GetVCCSuperUsers(vcc, false, ksAgent, columns)
	return superUsers[simpleId]
end
