/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// Dialing Schema Management
	function ProvisioningDialingSchemaMng(params)
	{
		if (!params) {
			throw("ProvisioningDialingSchemaMng - 'params' is required");
		}
		if (!params.owner) {
			throw("ProvisioningDialingSchemaMng - 'params.owner' is required");
		}
		if (!params.prefix) {
			throw("ProvisioningDialingSchemaMng - 'params.prefix' is required");
		}
		if (!params.container_id) {
			throw("ProvisioningDialingSchemaMng - 'params.container_id' is required");
		}
		this.owner = params.owner;
		this.owner_name = params.owner_name || "";
		this.prefix = params.prefix + "_";
		this.container_id = params.container_id;

		return true;
	}

	if (typeof inConcert.ProvisioningDialingSchemaMng !== "function") {
		inConcert.ProvisioningDialingSchemaMng = ProvisioningDialingSchemaMng;
	}

	ProvisioningDialingSchemaMng.prototype.initialize = function()
	{
		this.__make_popup_html();
	};


	ProvisioningDialingSchemaMng.prototype.__make_popup_html = function()
	{
		let html = '' +
		'<div class="card-header d-flex flex-row justify-content-between align-items-center">' +
			'<h5 class="mb-0"><%=_T([[Add custom dialing scheme]])%> <span class="fa fa-question-circle" title="<%=_T([[The default configuration when nothing is defined is as follows]])%>:&#013;  &#013; <%=_T([[Local]])%>: {NUMBER} &#013; <%=_T([[Nation-Wide]])%>: {AREA}{NUMBER} &#013; <%=_T([[Global]])%>: +{COUNTRY}{AREA}{NUMBER}"></span></h5>' +
			'<div class="form-check form-switch">' +
				'<label for="' + this.prefix + 'schema_enabled" class="form-check-label form-check-label-title">' +
					'<input id="' + this.prefix + 'schema_enabled" class="form-check-input" type="checkbox"/>' +
					'<span></span>' +
					// '<%=_T([[Add custom dialing scheme]])%>' +
				'</label>' +
			'</div>' +
		'</div>' +
		'<div id="' + this.prefix + 'schema_config_container" style="display:none;" class="w-100">' +
			'<div class="card-block">' +
				'<div class="row">' +
					'<div class="col-3">' +
						'<div class="form-group">' +
							'<label for="' + this.prefix + 'schema_local_call" class=""><%=_T([[Local Calls]])%><%=_T([[:]])%><span class="fa fa-question-circle" title="DIALLOCAL: <%=_T([[Destination number to dial when the country and area codes of the destination match the country and area codes of the agent.]])%> &#013;&#013; <%=_T([[Format to type in the field]])%>: &#013; {NUMBER}"></span></label>' +
							'<input id="' + this.prefix + 'schema_local_call" class="form-control" type="text" disabled placeholder="{NUMBER}"/>' +
							'<i id="' + this.prefix + 'schema_local_call_validation" class="formFieldValidation formFieldError" hidden></i>' +
						'</div>' +
					'</div>' +
					'<div class="col-3">' +
						'<div class="form-group">' +
							'<label for="' + this.prefix + 'schema_nation_wide_call" class=""><%=_T([[Nation-Wide Calls]])%><%=_T([[:]])%><span class="fa fa-question-circle" title="DIALSAMECOUNTRY: ' + "<%=_T([[Area and destination numbers to dial when the destination country code matches the agent country code.]])%>" + ' &#013;  &#013; <%=_T([[Format to type in the field]])%>: &#013; {AREA}{NUMBER}"></span></label>' +
							'<input id="' + this.prefix + 'schema_nation_wide_call" class="form-control" type="text" disabled placeholder="{AREA}{NUMBER}"/>' +
							'<i id="' + this.prefix + 'schema_nation_wide_call_validation" class="formFieldValidation formFieldError" hidden></i>' +
						'</div>' +
					'</div>' +
					'<div class="col-3">' +
						'<div class="form-group">' +
							'<label for="' + this.prefix + 'schema_global_call" class=""><%=_T([[Global Calls]])%><%=_T([[:]])%><span class="fa fa-question-circle" title="DIALGLOBAL: <%=_T([[Country, area and destination numbers to be dialed when destination country and area codes do not match agent country and area codes.]])%> &#013; &#013; <%=_T([[Format to type in the field]])%>: &#013; +{COUNTRY}{AREA}{NUMBER}"></span></label>' +
							'<input id="' + this.prefix + 'schema_global_call" class="form-control" type="text" disabled placeholder="+{COUNTRY}{AREA}{NUMBER}" />' +
							'<i id="' + this.prefix + 'schema_global_call_validation" class="formFieldValidation formFieldError" hidden></i>' +
						'</div>' +
					'</div>' +
					'<div class="col-12">' +
						'<div class="inlineMessagesContainer messageInfo mb-0 d-flex flex-row"><strong class="inlineMessagesContainerTitle"><%=_T([[Help]])%></strong> <span><%=_T([[Variables must be enclosed in brackets.]])%> <strong><%=_T([[Example]])%>: {NUMBER}.</strong> <%=_T([[You can also indicate the position number where the number starts by using the modifier (:).]])%> <strong><%=_T([[Example: {COUNTRY:1}]])%></strong></div></span>' +
					'</div>'
				'</div>' +
			'</div>' +
		'</div>' ;
	// '<div class="card-block">' +
	// 	'<div class="row">' +
	// 		'<div id="' + this.prefix + 'schema_example_container" class="col-8" style="display:none;">' +
	// 			'<div class="card no-card">' +
	// 				'<div class="card-header">' +
	// 					'<h5><%=_T([[Available variables]])%></h5>' +
	// 				'</div>' +
	// 				'<div class="card-block">' +
	// 					'<ul class="dialing-schemas-variables-list">' +
	// 						'<li>' +
	// 							'<strong><%=_T([[country]])%></strong><%=_T([[:]])%><span> <%=_T([[Destination country code]])%></span>' +
	// 						'</li>' +
	// 						'<li>' +
	// 							'<strong><%=_T([[area]])%></strong><%=_T([[:]])%><span> <%=_T([[Destination area code]])%></span>' +
	// 						'</li>' +
	// 						'<li>' +
	// 							'<strong><%=_T([[number]])%></strong><%=_T([[:]])%><span> <%=_T([[Destination number without country nor area code]])%></span>' +
	// 						'</li>' +
	// 						'<li>' +
	// 							'<strong><%=_T([[dialLocal]])%></strong><%=_T([[:]])%><span> <%=_T([[Destination number to dial when the country and area codes of the destination match the country and area codes of the agent.]])%></span>' +
	// 						'</li>' +
	// 						'<li>' +
	// 							'<strong><%=_T([[dialSameCountry]])%></strong><%=_T([[:]])%><span><%=_T([[Area and destination numbers to dial when the destination country code matches the agent's country code.]])%></span>' +
	// 						'</li>' +
	// 						'<li>' +
	// 							'<strong><%=_T([[dialGlobal]])%></strong><%=_T([[:]])%><span><%=_T([[Country, area and destination numbers to be dialed when destination country and area codes do not match agent country and area codes.]])%></span>' +
	// 						'</li>' +
	// 					'</ul>' +
	// 					'<ul class="dialing-schemas-variables-list">' +
	// 						'<li>' +
	// 							'<strong><%=_T([[Local calls (dailLocal)]])%></strong><%=_T([[:]])%><span> <%=_T([[number to dial when destination country code and area code match agent country and area code.]])%></span>' +
	// 						'</li>' +
	// 						'<li>' +
	// 							'<strong><%=_T([[Nationwide Call (dialSameCountry)]])%></strong><%=_T([[:]])%><span> <%=_T([[number to dial when destination country code matches agent country code.]])%></span>' +
	// 						'</li>' +
	// 						'<li>' +
	// 							'<strong><%=_T([[Global Calls]])%></strong><%=_T([[:]])%><span> <%=_T([[GLOBAL_HELP]])%></span>' +
	// 						'</li>' +
	// 					'</ul>' +
	// 					'<ul class="dialing-schemas-variables-disclaimer-list">' +
	// 						'<li><i class="fa fa-info"></i><%=_T([[Variables must be enclosed in brackets.]])%><%=_T([[:]])%><strong><%=_T([[{var_name}]])%></strong><li>' +
	// 						'<li><i class="fa fa-info"></i><%=_T([[You can also indicate the position number where the number starts by using the modifier (:).]])%> <strong>(:)</strong> <%=_T([[Example: {COUNTRY:1}]])%><li>' +
	// 						'<li><i class="fa fa-info"></i> <%=_T([[The default configuration when nothing is defined is as follows]])%>, <strong><%=_T([["{number}"]])%></strong> <span> <%=_T([[Local Calls]])%> </span>, <strong><%=_T([["{area}{number}"]])%></strong> <span> <%=_T([[Nation-Wide Calls]])%> </span>, <strong><%=_T([["+{country}{area}{number}"]])%></strong> <span> <%=_T([[Global Calls]])%><li>' +
	// 					'</ul>' +
						
	// 				'</div>' +
	// 			'</div>' +
	// 		'</div>' +
	// 	'</div>' +
	// '</div>'

		const $container = $("#" + this.container_id);
		$container.html(html);
	};

	ProvisioningDialingSchemaMng.prototype.dispose = function()
	{
		//TODO: implementar, si es necesario
	};

	ProvisioningDialingSchemaMng.prototype.get = function(entity)
	{
		if (!entity) {
			return;
		}
		// schema
		if (!$("#" + this.prefix + "schema_enabled").prop("checked")) {
			return;
		}
		let local_call = $("#" + this.prefix + "schema_local_call").val().trim();
		if (local_call.length > 0) {
			entity.dialingSchemaLocal = local_call;
		}
		let nation_wide_call = $("#" + this.prefix + "schema_nation_wide_call").val().trim();
		if (nation_wide_call.length > 0) {
			entity.dialingSchemaSameCountry = nation_wide_call;
		}
		let global_call = $("#" + this.prefix + "schema_global_call").val().trim();
		if (global_call.length > 0) {
			entity.dialingSchemaGlobal = global_call;
		}
	};

	ProvisioningDialingSchemaMng.prototype.set = function(entity)
	{
		if (!entity) {
			return;
		}
		if (entity.dialingSchemaLocal || entity.dialingSchemaGlobal || entity.dialingSchemaSameCountry) {
			$("#" + this.prefix + "schema_enabled").prop("checked", true);
			$("#" + this.prefix + "schema_local_call").val(entity.dialingSchemaLocal || "");
			$("#" + this.prefix + "schema_nation_wide_call").val(entity.dialingSchemaSameCountry || "");
			$("#" + this.prefix + "schema_global_call").val(entity.dialingSchemaGlobal || "");
		}
	};

	ProvisioningDialingSchemaMng.prototype.empty_controls = function()
	{
		$("#" + this.prefix + "schema_enabled").prop("checked", false).trigger("change");
		$("#" + this.prefix + "schema_local_call").val("");
		$("#" + this.prefix + "schema_nation_wide_call").val("");
		$("#" + this.prefix + "schema_global_call").val("");
	};

	ProvisioningDialingSchemaMng.prototype.set_events = function()
	{
		const self = this;

		const $config_container = $("#" + this.prefix + "schema_config_container");
		// const $example_container = $("#" + this.prefix + "schema_example_container");
		const $local_call = $("#" + this.prefix + "schema_local_call");
		const $nation_wide_call = $("#" + this.prefix + "schema_nation_wide_call");
		const $global_call = $("#" + this.prefix + "schema_global_call");

		$("#" + this.prefix + "schema_enabled")
			.off("change")
			.on("change", function() {
				const checked = $(this).prop("checked");
				if (checked) {
					$config_container.show();
					// $example_container.show();
					self.owner.disable_control($local_call, false);
					self.owner.disable_control($nation_wide_call, false);
					self.owner.disable_control($global_call, false);
				}
				else {
					$config_container.hide();
					// $example_container.hide();
					self.owner.disable_control($local_call, true);
					self.owner.disable_control($nation_wide_call, true);
					self.owner.disable_control($global_call, true);
				}
			}
		);
	};

	ProvisioningDialingSchemaMng.prototype.toggle_ctrls = function()
	{
		$("#" + this.prefix + "schema_enabled").trigger("change");
	};
}());
