/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form carriers class
	function form_provisioning_carriers(params)
	{
		const success = form_provisioning_carriers.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title = "<%=_T('New Carrier')%>";
		this.update_title = "<%=_T('Update Carrier {0}')%>";
		this.view_title = "<%=_T('View Carrier {0}')%>";
		this.tagline = "<%=_T('Tagline form Carrier!!!')%>";

		this.html_file_name = "/inconcert/apps/provisioning/carriers/frm/render/";
		this.save_uri =       "/inconcert/apps/provisioning/carriers/save/";
		this.get_uri =        "/inconcert/apps/provisioning/carriers/get/";

		this.schema_mng = new inConcert.ProvisioningDialingSchemaMng({
			owner       : this,
			owner_name  : "<%=_T('Carrier')%>",
			prefix      : "prov_form_carrier",
			container_id: "prov_form_carrier_schema_panel"
		});

		return true;
	}

	inConcert.Utils.inherit(form_provisioning_carriers, inConcert.conf_form);

	if (typeof inConcert.form_provisioning_carriers !== "function") {
		inConcert.form_provisioning_carriers = form_provisioning_carriers;
	}

	form_provisioning_carriers.prototype.initialize = function()
	{
		this.schema_mng.initialize();
	};

	form_provisioning_carriers.prototype.get = function()
	{
		let carrier = {
			id         : $("#prov_form_carrier_name").val(),
			description: $("#prov_form_carrier_desc").val(),
			prefix     : $("#prov_form_carrier_prefix").val()
		};
		// schema
		this.schema_mng.get(carrier);

		const action = this.dashboard.get_current_action_obj();
		const id = action.view.row_id;
		if (!this.is_new) {
			carrier[id] = this.$current_row.attr("row_id");
		}
		return carrier;
	};

	form_provisioning_carriers.prototype.set = function(success, carrier)
	{
		if (!success) {
			return;
		}
		$("#prov_form_carrier_name").val(carrier.id);
		$("#prov_form_carrier_desc").val(carrier.description);
		$("#prov_form_carrier_prefix").val(carrier.prefix);
		// schema
		this.schema_mng.set(carrier);
	};

	form_provisioning_carriers.prototype.empty_controls = function()
	{
		$("#prov_form_carrier_name").val("").focus();
		$("#prov_form_carrier_desc").val("");
		$("#prov_form_carrier_prefix").val("");
		// schema
		this.schema_mng.empty_controls();
	};

	form_provisioning_carriers.prototype.err_save_messages = function(err, is_custom_message)
	{
		form_provisioning_carriers.uber.err_save_messages.call(this, err, is_custom_message); //invokes the base class method
		if (typeof err !== "object") {
			return;
		}
		if (err.result === "MUST_HAVE_A_NAME" || err.result === "MUST_HAVE_UNIQUE_NAME" || err.result === "OVERFLOW_NAME") {
			$("#prov_form_carrier_name").focus();
		}
		else if (err.result === "MUST_HAVE_A_DESCRIPTION") {
			$("#prov_form_carrier_desc").focus();
		}
	};

	form_provisioning_carriers.prototype.get_validation_def = function()
	{
		const definitions = [
			{
				control_id: "prov_form_carrier_name",
				messages: {
					required: "<%=_T('Please enter the carrier Name.')%>",
					id:       "<%=_T('Only letters, numbers, dashes and dots are allowed in the carrier Name.')%>"
				}
			},
			{
				control_id: "prov_form_carrier_desc",
				messages: {
					required: "<%=_T('Please enter the carrier Description.')%>"
				}
			}
		];
		return definitions;
	};

	form_provisioning_carriers.prototype.ready = function()
	{
		form_provisioning_carriers.uber.ready.call(this); //invokes the base class method
		const $id = $("#prov_form_carrier_name");

		if (this.is_new) {
			this.readonly_control($id, false /* disabled */ , true /* is_required */);
			$id.focus();
		}
		else {
			this.readonly_control($id, true /* disabled */);
			$("#prov_form_carrier_desc").focus();
		}
	};

	form_provisioning_carriers.prototype.set_events = function()
	{
		form_provisioning_carriers.uber.set_events.call(this); //invokes the base class method
		// schema
		this.schema_mng.set_events();
	};

	form_provisioning_carriers.prototype.ready_for_update = function()
	{
		form_provisioning_carriers.uber.ready_for_update.call(this);
		// schema
		this.schema_mng.toggle_ctrls();
	};
}());