/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//const FORMAT = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// form dids class
	function form_provisioning_dids(params)
	{
		const success = form_provisioning_dids.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title      = "<%=_T('New DID')%>";
		this.update_title   = "<%=_T('Update DID {0}')%>";
		this.view_title     = "<%=_T('View DID {0}')%>";
		this.tagline        = "<%=_T('Tagline form DID!!!')%>";

		this.html_file_name = "/inconcert/apps/provisioning/dids/frm/render/";
		this.save_uri       = "/inconcert/apps/provisioning/dids/save/";
		this.get_uri        = "/inconcert/apps/provisioning/dids/get/";

		return true;
	}

	inConcert.Utils.inherit(form_provisioning_dids, inConcert.conf_form);

	if (typeof inConcert.form_provisioning_dids !== "function") {
		inConcert.form_provisioning_dids = form_provisioning_dids;
	}

	form_provisioning_dids.prototype.is_enabled_inbound_did_config = function()
	{
		return $("#prov_form_did_inbound_enabled").prop("checked");
	};

	form_provisioning_dids.prototype.get = function()
	{
		let did = {
			Id: $("#prov_form_did_id").val(),
			carrier: $("#prov_form_did_carrier").val()
		};

		const enabled = this.is_enabled_inbound_did_config();
		if (enabled) {
			did.DNIS = $("#prov_form_did_inbound_dnis").val();
			const is_single_trunk = $("#prov_form_did_inbound_trunk_type").val() === "single";
			if (is_single_trunk) {
				did.trunk = $("#prov_form_did_inbound_trunk_single").val();
			}
			else {
				did.trunkGroup = $("#prov_form_did_inbound_trunk_group").val();
			}
		}

		const action = this.dashboard.get_current_action_obj();
		const id = action.view.row_id;
		if (!this.is_new) {
			did[id] = this.$current_row.attr("row_id");
		}
		return did;
	};

	form_provisioning_dids.prototype.set = function(success, did)
	{
		if (!success) {
			return;
		}
		$("#prov_form_did_id").val(did.Id);
		$("#prov_form_did_carrier").val(did.carrier);
		this.on_change_carrier();

		if (did.DNIS) {
			$("#prov_form_did_inbound_enabled").prop("checked", true);
			$("#prov_form_did_inbound_dnis").val(did.DNIS);

			const trunk_type = did.trunk ? "single" : "group";
			$("#prov_form_did_inbound_trunk_type").val(trunk_type);

			const $trunk_single = $("#prov_form_did_inbound_trunk_single");
			const $trunk_group = $("#prov_form_did_inbound_trunk_group");

			if (trunk_type === "single") {
				$trunk_single.val(did.trunk);
				$trunk_group.val("");
			}
			else {
				$trunk_group.val(did.trunkGroup);
				$trunk_single.val("");
			}
			this.toggle_inbound_trunk_ctrls();
		}

		this.toggle_inbound_ctrls();
	};

	form_provisioning_dids.prototype.empty_controls = function()
	{
		$("#prov_form_did_id").val("").focus();
		$("#prov_form_did_carrier").val("");
		this.on_change_carrier();
		$("#prov_form_did_inbound_enabled").prop("checked", false).trigger("change");
		$("#prov_form_did_inbound_dnis").val("");
		$("#prov_form_did_inbound_trunk_type").val("");
		$("#prov_form_did_inbound_trunk_single").val("");
		$("#prov_form_did_inbound_trunk_group").val("");
		this.toggle_inbound_ctrls();
	};

	form_provisioning_dids.prototype.err_save_messages = function(err, is_custom_message)
	{
		var get_error_description = function(err_type)
		{
			is_custom_message = true;
			var message;
			switch (err_type)
			{
				case "DID MUST SPECIFY A CARRIER":
					message = "<%=_T('DID must specify a carrier.')%>";
				break;

				case "CARRIER DOES NOT EXIST":
					message = "<%=_T('Carrier does not exist.')%>";
				break;

				case "A DID WITH DNIS MUST BE ASSOCIATED WITH A TRUNK OR A TRUNK GROUP":
					message = "<%=_T('A DID with DNIS must be associated with a trunk or a trunk group.')%>";
				break;

				case "TRUNK DOES NOT EXIST":
					message = "<%=_T('Trunk does not exist.')%>";
				break;

				case "DID WAS ASSOCIATED WITH CARRIER WHILE ITS TRUNK IS FROM CARRIER":
					message = "<%=_T('DID was associated with carrier, while its trunk is from carrier.')%>";
				break;

				case "A DID MUST BE ASSOCIATED WITH EITHER A TRUNK OR A TRUNK GROUP, BUT NOT BOTH":
					message = "<%=_T('A DID must be associated with either a trunk or a trunk group, but not both.')%>";
				break;

				case "TRUNK GROUP DOES NOT EXIST":
					message = "<%=_T('Trunk group does not exist.')%>";
				break;

				case "DID WAS ASSOCIATED WITH CARRIER WHILE ITS TRUNK GROUP IS FROM CARRIER":
					message = "<%=_T('DID was associated with carrier, while its trunk group is from carrier.')%>";
				break;

				case "DID WAS ASSOCIATED WITH PACKAGE WHICH NEEDS A DNIS, SO UPDATE WITHOUT DNIS IS NOT POSSIBLE":
					message = "<%=_T('DID was associated with package, which needs a DNIS, so update without DNIS is not possible.')%>";
				break;

				case "DID WAS ASSOCIATED WITH PACKAGE BUT NEW DNIS IS ALREADY ASSOCIATED WITH PACKAGE":
					message = "<%=_T('DID was associated with package, but new DNIS is already associated with package.')%>";
				break;

				case "DID CANNOT CHANGE CARRIER, BECAUSE IT'S ASSOCIATED WITH PACKAGE WHICH NEEDS THIS DID TO BELONG TO CARRIER TO SET THE RIGHT CALLERID":
					message = "<%=_T([[DID cannot change carrier, because it\'s associated with package, which needs this DID to belong to carrier to set the right CallerID.]])%>";
				break;

				default:
					is_custom_message = false;
					message = "<%=_T('Server error!!')%>";
			}
			return message;
		};

		switch (typeof err)
		{
			case "object":
				var error_type = err.result.toUpperCase();
				if (error_type === "MUST_HAVE_A_NAME" || error_type === "MUST_HAVE_UNIQUE_NAME") {
					$("#prov_form_did_id").focus();
				}
				else {
					err = get_error_description(error_type, err.raw_error);
				}
			break;

			case "string":
				err = get_error_description(err.toUpperCase());
			break;
		}

		form_provisioning_dids.uber.err_save_messages.call(this, err, is_custom_message);  //invokes the base class method
	};

	form_provisioning_dids.prototype.get_validation_def = function()
	{
		const self = this;

		const definitions = [
			{
				control_id: "prov_form_did_id",
				messages: {
					required: "<%=_T('Please enter the DID.')%>"
				}
			},
			{
				control_id: "prov_form_did_carrier",
				messages: {
					required: "<%=_T('Please select Carrier.')%>"
				}
			},
			{
				control_id: "prov_form_did_inbound_dnis",
				can_validate: function() {
					return self.is_enabled_inbound_did_config();
				},
				messages: {
					required: "<%=_T('Please enter the Inbound DNIS.')%>"
				}
			},
			{
				control_id: "prov_form_did_inbound_trunk_type",
				can_validate: function() {
					return self.is_enabled_inbound_did_config();
				},
				messages: {
					required: "<%=_T('Please select Trunk Type.')%>"
				}
			},
			{
				control_id: "prov_form_did_inbound_trunk_single",
				can_validate: function() {
					if (!self.is_enabled_inbound_did_config()) {
						return false;
					}
					const trunk_type = $("#prov_form_did_inbound_trunk_type").val();
					if (trunk_type === "single") {
						return true;
					}
					return false;
				},
				messages: {
					required: "<%=_T('Please select Trunk Single.')%>"
				}
			},
			{
				control_id: "prov_form_did_inbound_trunk_group",
				can_validate: function() {
					if (!self.is_enabled_inbound_did_config()) {
						return false;
					}
					const trunk_type = $("#prov_form_did_inbound_trunk_type").val();
					if (trunk_type === "group") {
						return true;
					}
					return false;
				},
				messages: {
					required: "<%=_T('Please select Trunk Group.')%>"
				}
			}
		];
		return definitions;
	};

	form_provisioning_dids.prototype.ready = function()
	{
		form_provisioning_dids.uber.ready.call(this); //invokes the base class method
		const $id = $("#prov_form_did_id");

		if (this.is_new) {
			this.readonly_control($id, false /* disabled */ , true /* is_required */);
			this.toggle_inbound_ctrls();
			$id.focus();
		}
		else {
			this.readonly_control($id, true /* disabled */);
			$("#prov_form_did_id").focus();
		}
	};

	form_provisioning_dids.prototype.toggle_inbound_ctrls = function()
	{
		const $inbound_config = $("#prov_form_did_inbound_config");
		const $dnis = $("#prov_form_did_inbound_dnis");
		const $trunk_type = $("#prov_form_did_inbound_trunk_type");

		const enabled = this.is_enabled_inbound_did_config();
		if (enabled) {
			$inbound_config.show();
			this.disable_control($dnis, false, true);
			this.disable_control($trunk_type, false, true);
		}
		else {
			$inbound_config.hide();
			this.disable_control($dnis, true);
			this.disable_control($trunk_type, true);
		}
		$trunk_type.trigger("change");
	};

	form_provisioning_dids.prototype.toggle_inbound_trunk_ctrls = function()
	{
		const $trunk_single_container = $("#prov_form_did_inbound_trunk_single_container");
		const $trunk_group_container = $("#prov_form_did_inbound_trunk_group_container");

		$trunk_single_container.hide();
		$trunk_group_container.hide();

		const trunk_type = $("#prov_form_did_inbound_trunk_type").val();
		if (trunk_type === "single") {
			$trunk_single_container.show();
		}
		else if (trunk_type === "group") {
			$trunk_group_container.show();
		}
	};

	form_provisioning_dids.prototype.on_change_carrier = function()
	{
		const carrier = ($("#prov_form_did_carrier").val()|| "").toLowerCase();

		// Fitrar los trunks
		let trunks_of_carrier = [];
		let trunks = this.__get_trunks();

		for (let id in trunks) {
			if (trunks.hasOwnProperty(id)) {
				let trunk = trunks[id];
				if (carrier !== "" && carrier === (trunk.carrier || "").toLowerCase()) {
					trunks_of_carrier.push(trunk);
				}
			}
		}
		this.__fill_trunks(trunks_of_carrier);

		// Fitrar los trunks gruops
		let trunks_grups_of_carrier = [];
		let trunks_group = this.__get_trunks_groups();

		for (let id in trunks_group) {
			if (trunks_group.hasOwnProperty(id)) {
				let trunk = trunks_group[id];
				if (carrier !== "" && carrier === (trunk.carrier || "").toLowerCase()) {
					trunks_grups_of_carrier.push(trunk);
				}
			}
		}
		this.__fill_trunks_groups(trunks_grups_of_carrier);
	};

	form_provisioning_dids.prototype.__set_trunks = function(list = [])
	{
		this.m_trunks_list = list;
	};

	form_provisioning_dids.prototype.__set_trunks_groups = function(list = [])
	{
		this.m_trunks_groups_list = list;
	};

	form_provisioning_dids.prototype.__get_trunks = function()
	{
		return this.m_trunks_list;
	};

	form_provisioning_dids.prototype.__get_trunks_groups = function()
	{
		return this.m_trunks_groups_list;
	};
	
	form_provisioning_dids.prototype.set_events = function()
	{
		form_provisioning_dids.uber.set_events.call(this); //invokes the base class method
		const self = this;

		$("#prov_form_did_carrier")
			.off("change")
			.on("change", function() {
				self.on_change_carrier();
			});

		$("#prov_form_did_inbound_enabled")
			.off("change")
			.on("change", function() {
				self.toggle_inbound_ctrls();
			});

		$("#prov_form_did_inbound_trunk_type")
			.off("change")
			.on("change", function() {
				self.toggle_inbound_trunk_ctrls();
			});
	};

	form_provisioning_dids.prototype.ready_for_update = function()
	{
		form_provisioning_dids.uber.ready_for_update.call(this);
	};

	form_provisioning_dids.prototype.load_data = function(callback_complete_requests)
	{
		const self = this;
		const provisioning_api = inConcert.app.getProvisioningAPI();

		this.__fill_inbound_trunk_type([
			{id: "single", desc: "<%=_T('Single')%>"},
			{id: "group" , desc: "<%=_T('Group')%>" }
		]);

		this.requests = [
			// Carriers
			{
				request_function: function(success) {
					return provisioning_api.carriersLoadAll(success);
				},
				success: function(list) {
					self.__fill_carriers(list);
				}
			},
			// Trunks
			{
				request_function: function(success) {
					return provisioning_api.trunksLoadAll(success);
				},
				success: function(list) {
					self.__set_trunks(list);
				}
			},
			// Trunks Groups
			{
				request_function: function(success) {
					return provisioning_api.trunksGroupsLoadAll(success);
				},
				success: function(list) {
					self.__set_trunks_groups(list);
				}
			}
		];

		form_provisioning_dids.uber.load_data.call(this, callback_complete_requests); //invokes the base class method
	};

	form_provisioning_dids.prototype.__fill_carriers = function(list)
	{
		const $combo = $("#prov_form_did_carrier");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "id" /* attr_name */, true /* sorted */, undefined /*can_add_item*/, "carrier", /* data_id */);
	};

	form_provisioning_dids.prototype.__fill_inbound_trunk_type = function(list)
	{
		const $combo = $("#prov_form_did_inbound_trunk_type");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "desc" /* attr_name */, false /* sorted */, undefined /*can_add_item*/, "trunk_type", /* data_id */);
	};

	form_provisioning_dids.prototype.__fill_trunks = function(list)
	{
		const $combo = $("#prov_form_did_inbound_trunk_single");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "id" /* attr_name */, true /* sorted */, undefined /*can_add_item*/, "carrier", /* data_id */);
	};

	form_provisioning_dids.prototype.__fill_trunks_groups = function(list)
	{
		const $combo = $("#prov_form_did_inbound_trunk_group");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "id" /* attr_name */, true /* sorted */, undefined /*can_add_item*/, "carrier", /* data_id */);
	};

}());