/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form hosts class
	function form_provisioning_hosts(params)
	{
		const success = form_provisioning_hosts.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title = "<%=_T('New Host')%>";
		this.update_title = "<%=_T('Update Host {0}')%>";
		this.view_title = "<%=_T('View Host {0}')%>";
		this.tagline = "<%=_T('Tagline form Host!!!')%>";

		this.html_file_name = "/inconcert/apps/provisioning/hosts/frm/render/";
		this.save_uri =       "/inconcert/apps/provisioning/hosts/save/";
		this.get_uri =        "/inconcert/apps/provisioning/hosts/get/";

		return true;
	}

	inConcert.Utils.inherit(form_provisioning_hosts, inConcert.conf_form);

	if (typeof inConcert.form_provisioning_hosts !== "function") {
		inConcert.form_provisioning_hosts = form_provisioning_hosts;
	}

	form_provisioning_hosts.prototype.get = function()
	{
		let host = {
			hostId      : $("#prov_form_host_id").val(),
			description : $("#prov_form_host_desc").val(),
			sipServer   : $("#prov_form_host_private_ip").val(),
			rtmpServer  : $("#prov_form_host_public_ip").val(),
			telProxyPort: $("#prov_form_host_port").val()
		};
		const action = this.dashboard.get_current_action_obj();
		const id = action.view.row_id;
		if (!this.is_new) {
			host[id] = this.$current_row.attr("row_id");
		}
		return host;
	};

	form_provisioning_hosts.prototype.set = function(success, host)
	{
		if (!success) {
			return;
		}
		$("#prov_form_host_id").val(host.hostId);
		$("#prov_form_host_desc").val(host.description);
		$("#prov_form_host_private_ip").val(host.sipServer);
		$("#prov_form_host_public_ip").val(host.rtmpServer);
		$("#prov_form_host_port").val(host.telProxyPort);
	};

	form_provisioning_hosts.prototype.empty_controls = function()
	{
		$("#prov_form_host_id").val("").focus();
		$("#prov_form_host_desc").val("");
		$("#prov_form_host_private_ip").val("");
		$("#prov_form_host_public_ip").val("");
		$("#prov_form_host_port").val("");
	};

	form_provisioning_hosts.prototype.err_save_messages = function(err, is_custom_message)
	{
		var get_error_description = function(err_type/*, raw_data = {}*/)
		{
			is_custom_message = true;
			let message;
			switch (err_type)
			{
			// provisioning manager errors
				// ... TODO: Implementar si es necesario, es decir si en la rocka provisioningmanager si realiza alguna validacion con codigo de error.
				//
			// app provisioning errors
				case "MUST_HAVE_A_NAME":
				// el mensaje de error es el por defecto de la clase base de conf_form.
					$("#prov_form_host_id").focus();
				break;

				case "MUST_HAVE_UNIQUE_NAME":
				// el mensaje de error es el por defecto de la clase base de conf_form.
					$("#prov_form_peer_name").focus();
				break;

				case "MUST_HAVE_A_DESCRIPTION":
				// el mensaje de error es el por defecto de la clase base de conf_form.
					$("#prov_form_host_desc").focus();
				break;

				case "HOST_ID_IS_REQUIRED":
					message = "<%=_T('Host Id is required.')%>";
				break;

				case "PRIVATE_IP_IS_REQUIRED":
					message = "<%=_T('Public Subdomain for Telephony is required.')%>";
				break;

				case "PUBLIC_IP_IS_REQUIRED":
					message = "<%=_T('Public IP is required.')%>";
				break;

				case "TEL_PROXY_PORT_IS_REQUIRED":
					message = "<%=_T('Telephony Port is required.')%>";
				break;

				default:
					is_custom_message = false;
					message = "<%=_T('Server error!!')%>";
			}
			return message;
		};

		switch (typeof err) {
			case "object":
				const error_type = err.result.toUpperCase();
				err = get_error_description(error_type, err.rawData);
			break;

			case "string":
				err = get_error_description(err.toUpperCase());
			break;
		}

		form_provisioning_hosts.uber.err_save_messages.call(this, err, is_custom_message); //invokes the base class method
	};

	form_provisioning_hosts.prototype.get_validation_def = function()
	{
		const definitions = [
			{
				control_id: "prov_form_host_id",
				messages: {
					required: "<%=_T('Please enter the Host Name.')%>",
					id:       "<%=_T('Only letters, numbers, dashes and dots are allowed in the Host Name.')%>"
				}
			},
			{
				control_id: "prov_form_host_desc",
				messages: {
					required: "<%=_T('Please enter Description.')%>"
				}
			},
			{
				control_id: "prov_form_host_private_ip",
				messages: {
					required: "<%=_T('Please enter Host Private IP.')%>"
				}
			},
			{
				control_id: "prov_form_host_public_ip",
				messages: {
					required: "<%=_T('Please enter Host Public Subdomain for Telephony.')%>"
				}
			},
			{
				control_id: "prov_form_host_port",
				messages: {
					required: "<%=_T('Telephony Port is required.')%>",
					range: {
						type   : "range",
						between: {from: 0, to: 65535},
						message: "<%=_T('Telephony Port allowed values between {0} to {1}.')%>"
					}
				}
			}
		];
		return definitions;
	};

	form_provisioning_hosts.prototype.ready = function()
	{
		form_provisioning_hosts.uber.ready.call(this); //invokes the base class method
		const $id = $("#prov_form_host_id");

		if (this.is_new) {
			this.readonly_control($id, false /* disabled */, true /* is_required */);
			$id.focus();
		}
		else {
			this.readonly_control($id, true /* disabled */);
			$("#prov_form_host_desc").focus();
		}
	};
}());