/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form peers class
	function form_provisioning_peers(params)
	{
		const success = form_provisioning_peers.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title      = "<%=_T('New IP Phone')%>";
		this.update_title   = "<%=_T('Update IP Phone {0}')%>";
		this.view_title     = "<%=_T('View IP Phone {0}')%>";
		this.tagline        = "<%=_T('Tagline form Peer!!!')%>";

		this.html_file_name = "/inconcert/apps/provisioning/peers/frm/render/";
		this.save_uri       = "/inconcert/apps/provisioning/peers/save/";
		this.get_uri        = "/inconcert/apps/provisioning/peers/get/";

		this.peers_mng = new inConcert.ProvisioningPeersMng({
			frm                        : this,
			prefix                     : "prov_form_peer",
			container_id               : "prov_form_peer_all_data_panel",
			must_update_owner_frm_title: true
		});

		return true;
	}

	inConcert.Utils.inherit(form_provisioning_peers, inConcert.conf_form);

	if (typeof inConcert.form_provisioning_peers !== "function") {
		inConcert.form_provisioning_peers = form_provisioning_peers;
	}

	form_provisioning_peers.prototype.initialize = function()
	{
		this.peers_mng.initialize();
	};

	form_provisioning_peers.prototype.dispose = function()
	{
		this.peers_mng.m_frm_type = null;
		form_provisioning_peers.uber.dispose.call(this); //invokes the base class method
	};

	form_provisioning_peers.prototype.apply_initial_config = function()
	{
		const $save_and_continue = this.$get_dom_element_by_id("form_button_save_and_continue");
		$save_and_continue.hide();
		this.peers_mng.only_modified();
	};

	form_provisioning_peers.prototype.get = function()
	{
		return this.peers_mng.get();
	};

	form_provisioning_peers.prototype.set = function(success, peer)
	{
		this.peers_mng.set(success, peer);
	};

	form_provisioning_peers.prototype.empty_controls = function()
	{
		this.peers_mng.empty_controls();
	};

	form_provisioning_peers.prototype.load_data = function(callback_complete_requests)
	{
		this.requests = this.peers_mng.load_data();
		form_provisioning_peers.uber.load_data.call(this, callback_complete_requests); //invokes the base class method
	};

	form_provisioning_peers.prototype.err_save_messages = function(err, is_custom_message)
	{
		let resp = this.peers_mng.err_save_messages(err, is_custom_message);
		form_provisioning_peers.uber.err_save_messages.call(this, resp.err, resp.is_custom_message); //invokes the base class method
	};

	form_provisioning_peers.prototype.get_validation_def = function()
	{
		return this.peers_mng.get_validation_def();
	};

	form_provisioning_peers.prototype.ready = function()
	{
		form_provisioning_peers.uber.ready.call(this); //invokes the base class method
		this.peers_mng.only_modified();
	};

	form_provisioning_peers.prototype.set_events = function()
	{
		form_provisioning_peers.uber.set_events.call(this); //invokes the base class method
		this.peers_mng.set_events();
	};

	form_provisioning_peers.prototype.save_execute = function(after_save, entity)
	{
		const self = this;
		let is_new = this.is_creating();

		const callback = function(success, response, action_after_save)
		{
			after_save = action_after_save || "SAVE_WITHOUT_ACTION"; // accion de "conf_form"
			let err = !success ? response: undefined;

			self.on_saved(success, entity, after_save, err);

			if (success && response) {
				if (is_new) {
					if (response.code === "ALL PEERS ADDED") {
						self.close();
						self.dashboard.view.refresh();
						self.dashboard.view.show_status_message("<%=_T('All IP Phones have been successfully added.')%>", "Info", 5000);
					}
					else if (response.code === "PARTIAL ADDED PEERS") {
						let detail;
						let not_added = response.rawData ? response.rawData.notAdded : [];
						for (let i = 0; i < not_added.length; i++) {
							let peer = not_added[i];
							detail = detail || "";
							if (detail) {
								detail = detail + ", ";
							}
							detail = detail + peer;
						}
						self.show_popup_message({
							messages: {
								title  : "<%=_T('Not all IP Phones have been added.')%>",
								message: "<%=_T('The IP Phones that could not be added are')%>" + "<%=_T(':')%>",
								detail : detail,
								type   : "warn"
							},
							close_action: "CLOSE FORM AND REFRESH VIEW"
						});
					}
				}
				else {
					if (response.code === "ALL PEERS UPDATED") {
						self.close();
						self.dashboard.view.refresh();
						self.dashboard.view.show_status_message("<%=_T('All IP Phones have been successfully updated.')%>", "Info", 5000);
					}
					else if (response.code === "PARTIAL UPDATED PEERS") {
						let detail;
						let not_updated = response.rawData ? response.rawData.notUpdated : [];
						for (let i = 0; i < not_updated.length; i++) {
							let peer = not_updated[i];
							detail = detail || "";
							if (detail) {
								detail = detail + ", ";
							}
							detail = detail + peer;
						}
						self.show_popup_message({
							messages: {
								title  : "<%=_T('Not all IP Phones have been updated.')%>",
								message: "<%=_T('The IP Phones that could not be updated are')%>" + "<%=_T(':')%>",
								detail : detail,
								type   : "warn"
							},
							close_action: "CLOSE FORM AND REFRESH VIEW"
						});
					}
				}
			}
		};

		this.peers_mng.save_execute(entity, null, callback);
	};

	form_provisioning_peers.prototype.edit_range = function(view)
	{
		this.peers_mng.m_frm_type = "RANGE-UPDATE";
		view.edit_first_row();
	};
}());