/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form ttsasrEngines class
	function form_provisioning_ttsasrengines(params)
	{
		const success = form_provisioning_ttsasrengines.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		
				// Instancia de la clase los TABs
		this.main_tabs = new inConcert.conf_form_tab({
			parent        : this,
			frm           : this.frm,
			container_id  : "prov_form_ttsasrengine_tabs",
			must_intialize: false,
			tabs_list   : {
				general: {
					id              : "general",
					name            : "<%=_T('General')%>",
					tab_container_id: "prov_form_ttsasrengine_general_container",
					selected        : true
				},
				profiles: {
					id              : "profiles",
					name            : "<%=_T('Profiles')%>",
					tab_container_id: "prov_form_ttsasrengine_profiles_container"
				}
			}
		});

		this.new_title = "<%=_T('New TTS/ASR Engine')%>";
		this.update_title = "<%=_T('Update TTS/ASR Engine {0}')%>";
		this.view_title = "<%=_T('View TTS/ASR Engine {0}')%>";
		this.tagline = "<%=_T('Tagline for TTS/ASR Engine!!!')%>";

		this.html_file_name = "/inconcert/apps/provisioning/ttsasrengines/frm/render/";
		this.save_uri =       "/inconcert/apps/provisioning/ttsasrengines/save/";
		this.get_uri =        "/inconcert/apps/provisioning/ttsasrengines/get/";
		
		this.sorted_providers = null;
		this.sorted_provider_types = null;
		this.sorted_used_ttsasrprofiles = null;
		this.sorted_sip_transports = [{"id":"", "name":""}, {"id":"tcp", "name":"tcp"}, {"id":"udp", "name":"udp"}];
		this.sorted_versions = [{"id":"", "name":""}, {"id":"1", "name":"1"}, {"id":"2", "name":"2"}];
		this.sorted_rtcp_bye = [{"id":"", "name":""}, {"id":"0", "name":"0 - disable rtcp bye"}, {"id":"1", "name": "1 - send rtcp bye at the end of session"}, {"id": "2", "name": "2 - send rtcp bye also at the end of each talkspurt"}];

		this.profiles_mng = new inConcert.ProvisioningTtsAsrEngineprofilesMng({
			owner       : this,
			prefix      : "prov_form_ttsasr_engine_profiles",
			container_id: "prov_form_ttsasr_engine_profiles_panel"
		});
		
		return true;
	}

	inConcert.Utils.inherit(form_provisioning_ttsasrengines, inConcert.conf_form);

	if (typeof inConcert.form_provisioning_ttsasrengines !== "function") {
		inConcert.form_provisioning_ttsasrengines = form_provisioning_ttsasrengines;
	}

	form_provisioning_ttsasrengines.prototype.initialize = function()
	{
		this.profiles_mng.initialize();
	};

	form_provisioning_ttsasrengines.prototype.get = function()
	{
		let ttsasrengine = {
			ttsAsrEngineId        : $("#prov_form_ttsasr_engine_id").val(),
			description           : $("#prov_form_ttsasr_engine_desc").val(),
			enabled               : $("#prov_form_ttsasr_engine_enabled").prop("checked") ? "1" : "0",
			general               : {},
			profiles              : this.profiles_mng.get()
		};
		
		const action = this.dashboard.get_current_action_obj();
		const id = action.view.row_id;
		if (!this.is_new) {
			ttsasrengine[id] = this.$current_row.attr("row_id");
		}
		
		//Save general Engine type dependant data
		$("[id^=prov_form_" + ttsasrengine.ttsAsrEngineId + "_]").each(function(index) {
			if($( this ).attr("name") && $( this ).val()){
				let attrName = $( this ).attr("name");
				let attrValue = undefined;
				if($( this ).is(':checkbox')) {
					attrValue = $( this ).prop("checked") ? "1" : "0";
				}
				else {
					attrValue = $( this ).val();
				}
				ttsasrengine["general"][attrName] = attrValue;
				ttsasrengine["general"]["id"] = "general";
				//Para el caso particular de UniMRCP, en la seccion general hay que guardar dos keys con un valor vacio, para que el modulo no falle al cargar
				if(ttsasrengine.ttsAsrEngineId === "unimrcp") {
					ttsasrengine["general"]["default-tts-profile"] = "";
					ttsasrengine["general"]["default-asr-profile"] = "";
				}
			}
		});
		
		return ttsasrengine;
	};

	form_provisioning_ttsasrengines.prototype.set = function(success, ttsasrengine)
	{
		if (!success) {
			return;
		}
		$("#prov_form_ttsasr_engine_id").val(ttsasrengine.ttsAsrEngineId);
		$("#prov_form_ttsasr_engine_desc").val(ttsasrengine.description);
		$("#prov_form_ttsasr_engine_enabled").prop("checked", ttsasrengine.enabled === "1");
		
		//Load general Engine type dependant data
		for (var prop in ttsasrengine.general) {
			console.log(prop + ': ' + ttsasrengine.general[prop]);

			$("[id^=prov_form_" + ttsasrengine.ttsAsrEngineId + "_]").each(function(index) {
				if($( this ).attr("name") === prop){
					if($( this ).is(':checkbox')) {
						$( this ).prop("checked", ttsasrengine.general[prop] === "1");
					}
					else {
						$( this ).val(ttsasrengine.general[prop]);
					}
				}
			});
		}
		
		this.profiles_mng.set(ttsasrengine);
		
		this.showEnginesControls(ttsasrengine.ttsAsrEngineId);
		
		//Disable availability checkbox if this engine is being used by some vcc
		if(this.used_ttsasrengines && this.used_ttsasrengines[ttsasrengine.ttsAsrEngineId]) {
			this.readonly_control($("#prov_form_ttsasr_engine_enabled"), true);
		}
	};

	form_provisioning_ttsasrengines.prototype.empty_controls = function()
	{
		$("#prov_form_ttsasr_engine_id").val("");
		$("#prov_form_ttsasr_engine_desc").val("").focus();
	};

	form_provisioning_ttsasrengines.prototype.load_data = function(callback_complete_requests)
	{
		const self = this;
		const provisioning_api = inConcert.app.getProvisioningAPI();
		
		self.currentEngine = self.$current_row && self.$current_row.attr("row_id") || "";
		
		this.requests = [
			// LogLevels
			{
				request_function: function(success) {
					return provisioning_api.ttsasrEnginesLoadUniMRCPLogLevels(success);
				},
				success: function(list) {
					self.__fill_loglevels(list);
				}
			},
			// Providers
			{
				request_function: function(success) {
					return provisioning_api.ttsasrDataLoadProviders(success);
				},
				success: function(providers) {
					self.__fill_providers(providers);
				}
			},
			// Provider types
			{
				request_function: function(success) {
					return provisioning_api.ttsasrDataLoadProviderTypes(success);
				},
				success: function(provider_types) {
					self.__fill_provider_types(provider_types);
				}
			},
			// Used Engines
			{
				request_function: function(success) {
					return provisioning_api.ListTtsAsrEnginesInUse(success);
				},
				success: function(list) {
					self.used_ttsasrengines = list;
				}
			},
			// Used Profiles
			{
				request_function: function(success) {
					return provisioning_api.LoadUsedTtsAsrProfiles(self.currentEngine, success);
				},
				success: function(list) {
					self.__fill_used_ttsasrprofiles(list);
				}
			}
		];
		
		this.__fill_sip_transports();
		this.__fill_versions();
		this.__fill_rtcp_bye();
		form_provisioning_ttsasrengines.uber.load_data.call(this, callback_complete_requests); //invokes the base class method
	};
	
	form_provisioning_ttsasrengines.prototype.__fill_loglevels = function(list)
	{
		const $combo = $("#prov_form_unimrcp_log_level");
		this.fill_combo($combo, true /* is_blank_first_item */, list, "" /* attr_id */, "" /* attr_name */, true /* sorted */, undefined /*can_add_item*/, "" /* data_id */, false /* id_is_case_sensitive */);
	};

	form_provisioning_ttsasrengines.prototype.__fill_versions = function()
	{
		this.profiles_mng.fill_versions();
	};

	form_provisioning_ttsasrengines.prototype.__fill_providers = function(providers)
	{
		const self = this;

		var build_sorted_providers = function( providers_map ) {
			if ($.isArray(self.sorted_providers)) {
				return self.sorted_providers;
			}
			self.sorted_providers = [];
			$.each(providers_map, function(provider_number, provider) {
				self.sorted_providers.push({id: provider.id, name: provider.name, grammars: provider.grammars, voices: provider.voices, recognitionLanguages: provider.recognitionLanguages});
			});
			return inConcert.Utils.sortArray(self.sorted_providers, "name");
		};

		build_sorted_providers( providers );

		this.profiles_mng.fill_providers();
	};

	form_provisioning_ttsasrengines.prototype.__fill_provider_types = function(provider_types)
	{
		const self = this;

		var build_sorted_provider_types = function( provider_types_map ) {
			if ($.isArray(self.sorted_provider_types)) {
				return self.sorted_provider_types;
			}
			self.sorted_provider_types = [];
			$.each(provider_types_map, function(provider_type_number, provider_type) {
				self.sorted_provider_types.push({id: provider_type.id, name: provider_type.name});
			});
			return inConcert.Utils.sortArray(self.sorted_providers, "name");
		};

		build_sorted_provider_types( provider_types );

		this.profiles_mng.fill_provider_types();
	};

	form_provisioning_ttsasrengines.prototype.__fill_sip_transports = function()
	{
		this.profiles_mng.fill_sip_transports();
	};

	form_provisioning_ttsasrengines.prototype.__fill_rtcp_bye = function()
	{
		this.profiles_mng.fill_rtcp_bye();
	};

	form_provisioning_ttsasrengines.prototype.__fill_used_ttsasrprofiles = function(used_ttsasrprofiles)
	{
		this.sorted_used_ttsasrprofiles = used_ttsasrprofiles;
	};
	
	form_provisioning_ttsasrengines.prototype.err_save_messages = function(err, is_custom_message)
	{
		var get_error_description = function(err_type/*, raw_data = {}*/)
		{
			is_custom_message = true;
			let message;
			switch (err_type)
			{
			// provisioning manager errors
				// ... TODO: Implementar si es necesario, es decir si en la rocka provisioningmanager si realiza alguna validacion con codigo de error.
				//
			// app provisioning errors
				case "MUST_HAVE_A_NAME":
				// el mensaje de error es el por defecto de la clase base de conf_form.
					$("#prov_form_ttsasr_engine_id").focus();
				break;

				case "MUST_HAVE_UNIQUE_NAME":
					message = "<%=_T('TTS/ASR Engine already exists.')%>";
					$("#prov_form_ttsasr_engine_id").focus();
				break;

				case "MUST_HAVE_A_DESCRIPTION":
				// el mensaje de error es el por defecto de la clase base de conf_form.
					$("#prov_form_ttsasr_engine_desc").focus();
				break;

				case "TTSASR_ENGINE_ID_IS_REQUIRED":
					message = "<%=_T('TTS/ASR Engine Id is required.')%>";
					$("#prov_form_ttsasr_engine_id").focus();
				break;

				case "CANNOT_DISABLE_ENGINE_WHILE_IN_USE_BY_VCC":
					message = "<%=_T('Can not disable engine in use.')%>";
					$("#prov_form_ttsasr_engine_enabled").focus();
				break;

				case "LOG_LEVEL_INVALID":
					message = "<%=_T('Log Level invalid')%>";
					$("#prov_form_unimrcp_log_level").focus();
				break;

				case "COULD_NOT_GET_PROFILES_IN_USE":
					message = "<%=_T('Could not get profiles in use.')%>";
				break;

				case "CAN_NOT_DELETE_PROFILES_IN_USE":
					message = "<%=_T('Can not delete profiles in use.')%>";
				break;

				default:
					is_custom_message = false;
					message = "<%=_T('Server error!!')%>";
			}
			return message;
		};

		switch (typeof err) {
			case "object":
				const error_type = err.result.toUpperCase();
				err = get_error_description(error_type, err.rawData);
			break;

			case "string":
				err = get_error_description(err.toUpperCase());
			break;
		}

		form_provisioning_ttsasrengines.uber.err_save_messages.call(this, err, is_custom_message); //invokes the base class method
	};

	form_provisioning_ttsasrengines.prototype.get_validation_def = function()
	{
		const self = this;
		
		var on_general_error = function() {
			self.main_tabs.switch_tab("general");
		};

		var on_profiles_error = function() {
			self.main_tabs.switch_tab("profiles");
		};
		
		const definitions = [
			{
				control_id: "prov_form_ttsasr_engine_desc",
				messages: {
					required: "<%=_T('Please enter Description.')%>"
				}
			},
			{
				control_id: "prov_form_unimrcp_max_connection_count",
				messages: {
					range: {
						type   : "range",
						between: {from: 1, to: 100000000},
						message: "<%=_T('Max Connection Count allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: "prov_form_unimrcp_max_shared_count",
				messages: {
					range: {
						type   : "range",
						between: {from: 1, to: 100000000},
						message: "<%=_T('Max Shared Count allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: "prov_form_unimrcp_request_timeout",
				messages: {
					range: {
						type   : "range",
						between: {from: 1000, to: 30000},
						message: "<%=_T('Request Timeout (msec) allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: "prov_form_unimrcp_speech_channel_timeout",
				messages: {
					range: {
						type   : "range",
						between: {from: 1000, to: 30000},
						message: "<%=_T('Speech Channel Timeout (msec) allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: "prov_form_unimrcp_rx_buffer_size",
				messages: {
					range: {
						type   : "range",
						between: {from: 1024, to: 4096},
						message: "<%=_T('Rx Buffer Size (bytes) allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: "prov_form_unimrcp_tx_buffer_size",
				messages: {
					range: {
						type   : "range",
						between: {from: 1024, to: 4096},
						message: "<%=_T('Tx Buffer Size (bytes) allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: this.profiles_mng.get_grid_dom_id(),
				messages: {
					custom: {
						type : "custom",
						valid: function() {
							if(!($("#prov_form_ttsasr_engine_enabled").prop("checked"))) {
								return { success : true };
							}
							return self.profiles_mng.start_grid_validation();
						}
					}
				}
			}
		];
		return definitions;
	};
	
	form_provisioning_ttsasrengines.prototype.ready = function()
	{
		var self = this;
		form_provisioning_ttsasrengines.uber.ready.call(this); //invokes the base class method
		const $id = $("#prov_form_ttsasr_engine_id");
		
		this.readonly_control($id, true /* disabled */);
		$("#prov_form_ttsasr_engine_desc").focus();

		this.main_tabs.initialize();
		this.main_tabs.show_tabs_container();
	};

	form_provisioning_ttsasrengines.prototype.set_events = function()
	{
		const self = this;
		form_provisioning_ttsasrengines.uber.set_events.call(this); //invokes the base class method
		$("#prov_form_ttsasr_engine_enabled")
			.off("change")
			.on("change", function() {
				self.showEnginesControls(self.currentEngine);
			});
		// profilers
		this.profiles_mng.set_events();
	};
	
	form_provisioning_ttsasrengines.prototype.showEnginesControls = function(engineType)
	{
		const $engineDataControlsContainer = $("#prov_form_ttsasrengine_general_data");
		const engineEnabled = $("#prov_form_ttsasr_engine_enabled").prop("checked");
		//Hide all engine dependant controls
		$("[enginetype]").hide();
		//Show this engine dependant controls
		if(engineType) {
			const $engineDataControls = $("#prov_form_ttsasrengine_general_data").find("[enginetype='" + engineType + "']");
			$engineDataControlsContainer.toggle(engineEnabled && $engineDataControls.length > 0);
			$engineDataControls.toggle(engineEnabled && $engineDataControls.length > 0);
		}
		if(engineEnabled) {
			this.main_tabs.enable_tab("profiles");
		}
		else {
			this.main_tabs.disable_tab("profiles");
		}
	};

	form_provisioning_ttsasrengines.prototype.get_providers = function()
	{
		return this.sorted_providers;
	};

	form_provisioning_ttsasrengines.prototype.get_provider_types = function()
	{
		return this.sorted_provider_types;
	};
}());