/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

//	"use strict";

	const FORMAT = inConcert.Utils.format;
 
	//---------------------------------------------------------------------
	// form vcc class - cognitive services section
	function prov_form_vccs_cognitive_services( params )
	{
		const self = this;
		const success = prov_form_vccs_cognitive_services.uber.constructor.call( this, params );
		if (!success) {
			return;
		}

		this.view_action_id = "view_vccs";  // view action id de permisos
		this.save_action_id  = {create: "save_vcc", update: "save_vcc"}; // save action id de permisos
		this.erase_action_id = null; // delete action id de permisos

		// Instancia de la clase los TABs
		this.main_tabs = new inConcert.conf_form_tab({
			parent        : this,
			frm           : this.frm,
			container_id  : "prov_form_vcc_cognitive_tabs",
			must_intialize: false,
			tabs_list   : {
				bot: {
					id              : "bot",
					name            : "<%=_T('NLU')%>",
					tab_container_id: "prov_form_vcc_cognitive_bot_tab_container",
					selected        : true,
					on_show         : function() {
						self.on_show_tab("bot");
					}
				},
				qna: {
					id              : "QNA",
					name            : "<%=_T('QNA MAKER')%>",
					tab_container_id: "prov_form_vcc_cognitive_qna_tab_container",
					on_show         : function() {
						self.on_show_tab("qna");
					}
				},
				llm: {
					id              : "LLM",
					name            : "<%=_T('LLM Models')%>",
					tab_container_id: "prov_form_vcc_cognitive_llm_tab_container",
					on_show         : function() {
						self.on_show_tab("llm");
					}
				}
			}
		});

		this.m_grid_bot_unimported_luis_apps = null;

		this.llm_profiles_mng = new inConcert.ProvisioningLlmprofilesMng({
			owner       : this,
			prefix      : "prov_form_llm_profiles",
			container_id: "prov_form_llm_profiles_panel"
		});

		return true;
	}

	inConcert.Utils.inherit(prov_form_vccs_cognitive_services, inConcert.conf_form_section);

	if ( typeof inConcert.prov_form_vccs_cognitive_services !== "function" ) {
		inConcert.prov_form_vccs_cognitive_services = prov_form_vccs_cognitive_services;
	}

	prov_form_vccs_cognitive_services.prototype.dispose = function()
	{
		prov_form_vccs_cognitive_services.uber.dispose.call(this); //invokes the base class method
	};

	prov_form_vccs_cognitive_services.prototype.fill_bot_types = function()
	{
		const bot_type_list = [
			{id: "LUIS", description: "<%=_T('LUIS')%>"},
			{id: "RASA", description: "<%=_T('RASA')%>"}
		];
		const $bot_type = $("#prov_form_vcc_cognitive_bot_type");
		const is_blank_first_item = false;
		const attr_id = "id";
		const attr_name = "description";
		this.fill_combo($bot_type, is_blank_first_item, bot_type_list, attr_id, attr_name);
	};

	prov_form_vccs_cognitive_services.prototype.fill_demo_types = function()
	{
		const demo_type_list = [
			{id: "DEFAULT", description: "<%=_T('Default')%>"},
			{id: "CUSTOM" , description: "<%=_T('Custom')%>" }
		];
		const $demo_type = $("#prov_form_vcc_cognitive_luis_demo_type");
		const is_blank_first_item = false;
		const attr_id = "id";
		const attr_name = "description";
		this.fill_combo($demo_type, is_blank_first_item, demo_type_list, attr_id, attr_name);
	};

	prov_form_vccs_cognitive_services.prototype.set = function(vcc)
	{
		let bot_info = vcc.BotInfo || {"Type": "LUIS"};
		$("#prov_form_vcc_cognitive_bot_type").val(bot_info.Type);

		// BOT Config
		const is_enabled_bot = typeof(bot_info.Enabled) === "boolean" ? bot_info.Enabled : (vcc.Luis ? true : false);
		$("#prov_form_vcc_cognitive_bot_enabled").prop("checked", is_enabled_bot).trigger("change");

		this.toggle_luis_azure_ctrls();
		this.toggle_luis_tenants_ctrls();
		this.toggle_language_studio_ctrls();
		this.toggle_qna_ctrls();
        this.toggle_qna_v2_ctrls(); // fede

		// LUIS Config
		if (vcc.Luis) {
			// Luis Demo
			if (vcc.Luis.Demo && vcc.Luis.Demo.Enabled) {
				$("#prov_form_vcc_cognitive_luis_demo_enabled").prop("checked", true);
				let demo_type = "DEFAULT";
				let demo_subscription_key = "";
				if (vcc.Luis.Demo.IsCustom) {
					demo_type = "CUSTOM";
					demo_subscription_key = vcc.Luis.Demo.DemoSubscription.subscriptionKey;
				}
				$("#prov_form_vcc_cognitive_luis_demo_type").val(demo_type); //.trigger("change");
				$("#prov_form_vcc_cognitive_luis_demo_key").val(demo_subscription_key);
			}
			// Luis Account (azure & subscriptions)
			if (vcc.Luis.Account) {
				$("#prov_form_vcc_cognitive_luis_account_configure").prop("checked", vcc.Luis.Account.IsCustom || false);
				let azure_account = vcc.Luis.Account.Azure;
				if (azure_account) {
					$("#prov_form_vcc_cognitive_luis_account_azure_subscription_id").val(azure_account.AzureSubscriptionId);
					$("#prov_form_vcc_cognitive_luis_account_azure_resource_group").val(azure_account.ResourceGroup);
					$("#prov_form_vcc_cognitive_luis_account_azure_account_name").val(azure_account.AccountName);
				}
				let azure_subscriptions = vcc.Luis.Account.Subscriptions;
				if (azure_subscriptions) {
					let index = 0;
					for (let id in azure_subscriptions) {
						if (azure_subscriptions.hasOwnProperty(id)) {
							let azure_subscription = azure_subscriptions[id];
							index++;
							$("#prov_form_vcc_cognitive_luis_account_subscription_key_" + index).val(azure_subscription.subscriptionKey);
							$("#prov_form_vcc_cognitive_luis_account_subscription_name_" + index).val(azure_subscription.subscriptionName);
						}
					}
				}
			}
			// Luis Tenant
			if (vcc.Luis.Tenant && vcc.Luis.Tenant.AzureAccounts) {
				let azure_account = vcc.Luis.Tenant.AzureAccounts[Object.keys(vcc.Luis.Tenant.AzureAccounts)[0]];
				if (azure_account) {
					const is_custom_tenant = vcc.Luis.Tenant.IsCustom ? true : false;
					let tenant_id = "", client_id = "", client_secret = "", resource = "";
					if (is_custom_tenant) {
						tenant_id = azure_account.tenant_id;
						client_id = azure_account.client_id;
						client_secret = azure_account.client_secret;
						resource = azure_account.resource;
					}
					$("#prov_form_vcc_cognitive_luis_tenant_configure").prop("checked", is_custom_tenant);
					$("#prov_form_vcc_cognitive_luis_tenant_id").val(tenant_id) ;
					$("#prov_form_vcc_cognitive_luis_tenant_secret_client_id").val(client_id);
					$("#prov_form_vcc_cognitive_luis_tenant_secret_name").val(client_secret) ;
					$("#prov_form_vcc_cognitive_luis_tenant_resource_name").val(resource);
				}
			}

			// Luis LanguageStudio

			if (vcc.Luis.AzureLanguageStudio && vcc.Luis.AzureLanguageStudio.resource_name !== "" && vcc.Luis.AzureLanguageStudio.resource_name !== undefined) {

				let resource_name = "", azure_subscription_id = "", subscription_key_1 = "", subscription_key_2 = "";
				resource_name = vcc.Luis.AzureLanguageStudio.resource_name;
				azure_subscription_id = vcc.Luis.AzureLanguageStudio.azure_subscription_id;
				subscription_key_1 = vcc.Luis.AzureLanguageStudio.subscription_key_1;
				subscription_key_2 = vcc.Luis.AzureLanguageStudio.subscription_key_2;

				$("#prov_form_vcc_cognitive_language_studio_configure").prop("checked", true);
				$("#prov_form_vcc_cognitive_language_studio_resource_name").val(resource_name);
				$("#prov_form_vcc_cognitive_language_studio_azure_subscription_id").val(azure_subscription_id);
				$("#prov_form_vcc_cognitive_language_studio_subscription_key_1").val(subscription_key_1);
				$("#prov_form_vcc_cognitive_language_studio_subscription_key_2").val(subscription_key_2);

			} else {

				$("#prov_form_vcc_cognitive_language_studio_configure").prop("checked", false);
				$("#prov_form_vcc_cognitive_language_studio_resource_name").val(undefined);
				$("#prov_form_vcc_cognitive_language_studio_azure_subscription_id").val(undefined);
				$("#prov_form_vcc_cognitive_language_studio_subscription_key_1").val(undefined);
				$("#prov_form_vcc_cognitive_language_studio_subscription_key_2").val(undefined);
			}
		}

		// QnA Maker
		if (vcc.QnAMaker && vcc.QnAMaker.SubscriptionsKeys) {
			let subscription = vcc.QnAMaker.SubscriptionsKeys[Object.keys(vcc.QnAMaker.SubscriptionsKeys)[0]];
			if (subscription) {
				$("#prov_form_vcc_cognitive_qna_configure").prop("checked", true);
				$("#prov_form_vcc_cognitive_qna_subscription_key_value").val(subscription.subscriptionKey) ;
				$("#prov_form_vcc_cognitive_qna_subscription_key_name").val(subscription.subscriptionName);
			}
		}

        // QnA Maker V2 fede
		if (vcc.QnAMakerV2 && vcc.QnAMakerV2.SubscriptionsKeys) {
			let subscription = vcc.QnAMakerV2.SubscriptionsKeys[Object.keys(vcc.QnAMakerV2.SubscriptionsKeys)[0]];
			if (subscription) {
				$("#prov_form_vcc_cognitive_qna_v2_configure").prop("checked", true);
				$("#prov_form_vcc_cognitive_qna_v2_subscription_api_key").val(subscription.subscriptionKey) ;
				$("#prov_form_vcc_cognitive_qna_v2_subscription_base_uri").val(subscription.subscriptionName);
			}
		}

		this.llm_profiles_mng.set(vcc.LlmProfiles);
	};

	prov_form_vccs_cognitive_services.prototype.toggle_bot_type = function()
	{
		// luis container
		const $bot_luis_container = $("#prov_form_vcc_cognitive_luis_container");
		// rasa container
		const $bot_rasa_container = $("#prov_form_vcc_cognitive_rasa_container");
		// bot enabled
		const is_enabled_bot = $("#prov_form_vcc_cognitive_bot_enabled").prop("checked");

		if (!is_enabled_bot) {
			$bot_luis_container.hide();
			$bot_rasa_container.hide();
			return;
		}

		// bot type
		const bot_type = $("#prov_form_vcc_cognitive_bot_type").val();

		if (bot_type === "LUIS") {
			$bot_rasa_container.hide();
			$bot_luis_container.show();
		}
		else {
			this.toggle_rasa_enabled();
			$bot_luis_container.hide();
			$bot_rasa_container.show();
		}
	};

	prov_form_vccs_cognitive_services.prototype.toggle_bot_enabled = function()
	{
		const is_enabled_bot = $("#prov_form_vcc_cognitive_bot_enabled").prop("checked");
		const $bot_type = $("#prov_form_vcc_cognitive_bot_type");
		this.frm.readonly_control($bot_type, !is_enabled_bot);
		$bot_type.trigger("change");
	};

	prov_form_vccs_cognitive_services.prototype.toggle_rasa_enabled = function()
	{
		// bot type
		const bot_type = $("#prov_form_vcc_cognitive_bot_type").val();
		// bot enabled
		const is_enabled_bot = $("#prov_form_vcc_cognitive_bot_enabled").prop("checked");
		// rasa import luis apps section
		const $rasa_import_luis_apps_section = $("#prov_form_vcc_cognitive_rasa_import_luis_apps_section");
		// el total de apps de LUIS que se pueden exportar
		const total_unimported_luis_apps = this.m_grid_bot_unimported_luis_apps.count_rows();
		// se visualiza la grilla de apps de LUIS disponibles a exportar, unicamente si ha activado la config de RASA (chk) y si al menos tiene una app de LUIS que no se ha importado a RASA.
		if (is_enabled_bot && bot_type === "RASA" && total_unimported_luis_apps > 0) {
			$rasa_import_luis_apps_section.show();
		}
		else {
			$rasa_import_luis_apps_section.hide();
		}
	};

	prov_form_vccs_cognitive_services.prototype.toggle_luis_demo_enabled = function()
	{
		const is_required = false;
		// demo enabled
		const is_enabled_demo = $("#prov_form_vcc_cognitive_luis_demo_enabled").prop("checked");
		// demo type
		const $demo_type = $("#prov_form_vcc_cognitive_luis_demo_type");
		this.frm.disable_control($demo_type, !is_enabled_demo, is_required);
		$demo_type.trigger("change");
	};

	prov_form_vccs_cognitive_services.prototype.toggle_luis_demo_custom_enabled = function()
	{
		const is_required = true;
		// demo enabled
		const is_enabled_demo = $("#prov_form_vcc_cognitive_luis_demo_enabled").prop("checked");
		// demo type
		const $demo_type = $("#prov_form_vcc_cognitive_luis_demo_type");
		const demo_type = $demo_type.val();
		const is_enabled_custom_demo = is_enabled_demo && demo_type === "CUSTOM";
		// demo subscription key
		const $demo_key = $("#prov_form_vcc_cognitive_luis_demo_key");
		this.frm.disable_control($demo_key, !is_enabled_custom_demo, is_required);
	};

	prov_form_vccs_cognitive_services.prototype.set_events = function() {
		const self = this;
		prov_form_vccs_cognitive_services.uber.set_events.call(this); //invokes the base class method

		// BOT Enabled
		$("#prov_form_vcc_cognitive_bot_enabled")
			.off("change")
			.on("change", function() {
				self.toggle_bot_enabled();
			});

		// BOT type
		$("#prov_form_vcc_cognitive_bot_type")
			.off("change")
			.on("change", function() {
				self.toggle_bot_type();
			});

		// LUIS
		//

		// luis demo enabled
		$("#prov_form_vcc_cognitive_luis_demo_enabled")
			.off("change")
			.on("change", function() {
				self.toggle_luis_demo_enabled();
			});

		// luis demo type
		$("#prov_form_vcc_cognitive_luis_demo_type")
			.off("change")
			.on("change", function() {
				self.toggle_luis_demo_custom_enabled();
			});

		$("#prov_form_vcc_cognitive_luis_account_configure")
			.off("click")
			.on("click", function() {
				self.toggle_luis_azure_ctrls();
			});

		$("#prov_form_vcc_cognitive_luis_tenant_configure")
			.off("click")
			.on("click", function() {
				self.toggle_luis_tenants_ctrls();
			});

		$("#prov_form_vcc_cognitive_language_studio_configure")
			.off("click")
			.on("click", function() {
				self.toggle_language_studio_ctrls();
			});

		// QNA
		//
		$("#prov_form_vcc_cognitive_qna_configure")
			.off("click")
			.on("click", function() {
				self.toggle_qna_ctrls();
			});
        
        // QNA V2 fede
		//
		$("#prov_form_vcc_cognitive_qna_v2_configure")
            .off("click")
            .on("click", function() {
                self.toggle_qna_v2_ctrls();
            });

		this.llm_profiles_mng.set_events();
	};

	prov_form_vccs_cognitive_services.prototype.toggle_luis_azure_ctrls = function()
	{
		const self = this;
		const is_enabled = $("#prov_form_vcc_cognitive_luis_account_configure").prop("checked");
		// AZURE account ctrls
		const $azure_account_ctrls = $("#prov_form_vcc_cognitive_luis_account_azure_panel").find("[config_type='azure_account']");
		$.each($azure_account_ctrls, function(_, ctrl) {
			const $ctrl = $(ctrl);
			self.disable_control($ctrl, !is_enabled, true);
		});
		// AZURE subscriptions ctrls
		const $azure_subscriptions_ctrls = $("#prov_form_vcc_cognitive_luis_account_subscription_panel").find("[config_type='azure_subscription']");
		$.each($azure_subscriptions_ctrls, function(_, ctrl) {
			const $ctrl = $(ctrl);
			let is_required = true;
			if ($ctrl.attr("is_optional")) {
				is_required = false;
			}
			self.disable_control($ctrl, !is_enabled, is_required);
		});
	};

	prov_form_vccs_cognitive_services.prototype.toggle_luis_tenants_ctrls = function()
	{
		const self = this;
		const is_enabled = $("#prov_form_vcc_cognitive_luis_tenant_configure").prop("checked");
		// TENANT ctrls
		const $tenant_ctrls = $("#prov_form_vcc_cognitive_luis_tenant_config_panel").find("[config_type='tenant']");
		$.each($tenant_ctrls, function(_, ctrl) {
			const $ctrl = $(ctrl);
			self.disable_control($ctrl, !is_enabled, true);
		});
	};

	prov_form_vccs_cognitive_services.prototype.toggle_language_studio_ctrls = function()
	{
		const self = this;
		const is_enabled = $("#prov_form_vcc_cognitive_language_studio_configure").prop("checked");
		// TENANT ctrls
		const $language_studio_ctrls = $("#prov_form_vcc_cognitive_language_studio_config_panel").find("[config_type='language_studio']");
		$.each($language_studio_ctrls, function(_, ctrl) {
			const $ctrl = $(ctrl);
			self.disable_control($ctrl, !is_enabled, true);
		});
	};

	prov_form_vccs_cognitive_services.prototype.toggle_qna_ctrls = function()
	{
		const self = this;
		const is_enabled = $("#prov_form_vcc_cognitive_qna_configure").prop("checked");
		// QNA ctrls
		const $tenant_ctrls = $("#prov_form_vcc_cognitive_qna_panel").find("[config_type='qna']");
		$.each($tenant_ctrls, function(_, ctrl) {
			const $ctrl = $(ctrl);
			self.disable_control($ctrl, !is_enabled, true);
		});
	};

    prov_form_vccs_cognitive_services.prototype.toggle_qna_v2_ctrls = function() // fede
	{
		const self = this;
		const is_enabled = $("#prov_form_vcc_cognitive_qna_v2_configure").prop("checked");
		// QNA ctrls
		const $tenant_ctrls = $("#prov_form_vcc_cognitive_qna_v2_panel").find("[config_type='qna_v2']");
		$.each($tenant_ctrls, function(_, ctrl) {
			const $ctrl = $(ctrl);
			self.disable_control($ctrl, !is_enabled, true);
		});
	};

	prov_form_vccs_cognitive_services.prototype.attach_load_request = function(/*request*/)
	{
		this.fill_bot_types();
		this.fill_demo_types();
	};

	prov_form_vccs_cognitive_services.prototype.editable = function()
	{
		prov_form_vccs_cognitive_services.uber.editable.call( this );
		this.frm.editable_buttons();

		this.toggle_luis_azure_ctrls();
		this.toggle_luis_tenants_ctrls();
		this.toggle_language_studio_ctrls();
		this.toggle_qna_ctrls();
		this.toggle_qna_v2_ctrls(); // fede

		this.main_tabs.initialize();
		this.main_tabs.show_tabs_container();
	};

	prov_form_vccs_cognitive_services.prototype.readonly = function()
	{
		prov_form_vccs_cognitive_services.uber.readonly.call( this );
		this.frm.readonly_buttons();
		this.main_tabs.initialize();
		this.main_tabs.show_tabs_container();
	};

	prov_form_vccs_cognitive_services.prototype.on_show = function()
	{
		prov_form_vccs_cognitive_services.uber.on_show.call(this, {show: false});
	};

	prov_form_vccs_cognitive_services.prototype.only_modified = function()
	{
		// luis demo enabled
		const $luis_demo_enabled = $("#prov_form_vcc_cognitive_luis_demo_enabled");
		// luis demo type
		const $luis_demo_type = $("#prov_form_vcc_cognitive_luis_demo_type");
		if (this.frm.is_new) {
			$luis_demo_type.val("DEFAULT").trigger("change");
		}
		// luis demo
		$luis_demo_enabled.trigger("change");
		// combo bot enable/disable
		$("#prov_form_vcc_cognitive_bot_enabled").trigger("change");
		// checkbox bot type (luis/rasa)
		this.toggle_bot_enabled();
	};

	prov_form_vccs_cognitive_services.prototype.ready = function()
	{
		this.only_modified();
		if (!this.frm.is_new) {
			this.bot_rasa_load_luis_unimported_apps();
		}
	};

	prov_form_vccs_cognitive_services.prototype.init = function()
	{
		this.__bot_init_grid_unimported_luis_apps();
		this.llm_profiles_mng.initialize();
	};

	prov_form_vccs_cognitive_services.prototype.__bot_init_grid_unimported_luis_apps = function()
	{
		const self = this;

		this.m_grid_bot_unimported_luis_apps = new inConcert.conf_form_paginator({
			owner: this,
			frm: this.frm,
			auto_initialize: true,
			row_id: "id",
			display_name: "id",
			rows_per_page: 2000,
			show_at_least: 1999,
			paginator_type: "ALL_ROWS_CLIENT_SIDE",
			without_paginator: true,
			loading_waiting_msg: "<%=_T('Please wait, Loading LUIS Unimported Apps to RASA ...')%>",
			ids: {
				paginator: "prov_form_vcc_cognitive_rasa_luis_apps_paginator",
				grid: "prov_form_vcc_cognitive_rasa_luis_apps_list",
				not_results_found: "prov_form_vcc_cognitive_rasa_luis_apps_not_results_found"
			},
			strings: {
				not_results_found: "<%=_T('No applications unimported from LUIS were found.')%>"
			},
			columns: [
				{id: "_number"    , name: "", type: "counter"     },
				{id: "name"       , name: "<%=_T('Name')%>"       },
				{id: "id"         , name: "<%=_T('App Id')%>"     },
				{id: "description", name: "<%=_T('Description')%>"},
				{
					id: "_action",
					name: "",
					system_action: {},
					custom_action: {
						reassign_intent: {
							name: "<%=_T('Import')%>",
							execute: function($row/*, $owner*/)
							{
								const luis_app = $row.data("row_data");
								let message = FORMAT("<%=_T('You want to import the application {0} from LUIS to RASA')%>", luis_app.id);
								self.confirm(message, function(success) {
									if (success) {
										self.bot_import_luis_app_to_rasa(luis_app.id, function(success) {
											if (success) {
												self.m_grid_bot_unimported_luis_apps.remove(luis_app, $row);
											}
										});
									}
								});
							},
							class_name: "buttons-icons-import-bot"
						}
					}
				}
			],
			callbacks: {}
		});
	};

	prov_form_vccs_cognitive_services.prototype.fill_grid_unimported_luis_apps = function(list = [])
	{
		this.m_grid_bot_unimported_luis_apps.fill_rows($.noop, list);
		this.toggle_rasa_enabled();
	};

	prov_form_vccs_cognitive_services.prototype.nlu_update_vcc = function(callback = $.noop)
	{
		const self = this;

		let bot_type = $("#prov_form_vcc_cognitive_bot_type").val();
		let vcc = this.frm.get_entity_instance();
		let current_bot_type = vcc.BotInfo ? (vcc.BotInfo.Type || "").toUpperCase() : "";

		const nlu_update_vcc = function() {
			let bot = bot_type || current_bot_type;
			if (bot === "LUIS") {
				self.luis_update_vcc(callback);
			}
			else if (bot === "RASA") {
				self.rasa_update_vcc(callback);
			}
			else {
				throw("prov_form_vccs_cognitive_services.prototype.nlu_update_vcc - Unrecognized NLU Type " + bot_type);
			}
		};

		if (current_bot_type === "" || !bot_type || current_bot_type === bot_type.toUpperCase()) {
			nlu_update_vcc();
			return;
		}

		let message = FORMAT("<%=_T('If making this change, all {0} applications will no longer be available in the Contact Center.')%>", current_bot_type);
		this.confirm(message, function(success) {
			if (!success) {
				callback(false);
				return;
			}
			nlu_update_vcc();
		});
	};

	prov_form_vccs_cognitive_services.prototype.bot_rasa_load_luis_unimported_apps = function()
	{
		const self = this;
	
		this.show_waiting("<%=_T('Please wait, Loading LUIS Unimported Apps to RASA ...')%>");
		// REQUEST --
		let data = {
			vcc: this.frm.get_entity_id()
		};
		const provisioning_api = inConcert.app.getProvisioningAPI();
		provisioning_api.rasaLoadUnimportedLuisApps(data,
			function(success, response)
			{
				self.hide_waiting();
				if (success) {
					self.fill_grid_unimported_luis_apps(response);
				}
				else {
					let err = response;
					let message, msg_type;
					let err_type = (err.result || {}).type;
					if (err_type === "UNABLE TO IMPORT - LUIS APP DOES NOT EXIST") {
						message = "<%=_T('Error Importing LUIS App to RASA. LUIS App does not exist.')%>";
					}
					else if (err_type === "UNABLE TO IMPORT - LUIS APP ALREADY IMPORTED") {
						message = "<%=_T('Error Importing LUIS App to RASA. LUIS App already imported')%>";
					}
					else {
						message = "<%=_T('Error Importing LUIS App to RASA.')%>";
					}
					msg_type = "Error";
					self.show_status_message(message, msg_type, 5000);
				}
			}
		);
	};

	prov_form_vccs_cognitive_services.prototype.bot_import_luis_app_to_rasa = function(luis_app_id, callback = $.noop)
	{
		const self = this;
	
		if (!luis_app_id) {
			callback(false);
			return;
		}

		this.show_waiting(FORMAT("<%=_T('Please wait, Importing LUIS App {0} to RASA ...')%>", luis_app_id));
		// REQUEST --
		let data = {
			vcc      : this.frm.get_entity_id(),
			luisAppId: luis_app_id
		};
		const provisioning_api = inConcert.app.getProvisioningAPI();
		provisioning_api.rasaImportLuisApp(data,
			function(success/*, err*/)
			{
				self.hide_waiting();
				if (success) {
					let message = "<%=_T('LUIS App has been successfully Importing to RASA.')%>";
					let msg_type = "Info";
					self.show_status_message(message, msg_type, 5000);
					callback(true);
					return;
				}
				let msg_type = "Error";
				let message = "<%=_T('Error Importing LUIS App to RASA.')%>";
				self.show_status_message(message, msg_type, 5000);
				callback(false);
			}
		);
	};

	prov_form_vccs_cognitive_services.prototype.rasa_update_vcc = function(callback = $.noop)
	{
		const self = this;

		// RASA Config
		let data = {
			vcc    : this.frm.get_entity_id(),
			Enabled: $("#prov_form_vcc_cognitive_bot_enabled").prop("checked")
		};

		this.show_waiting("<%=_T('Please wait, Updating RASA Information ...')%>");

		let vcc = this.frm.get_entity_instance();

		// REQUEST --
		const provisioning_api = inConcert.app.getProvisioningAPI();
		// Se ejecuta en un pequeno timeout ya que la ejecucion puede ser muy rapida!! asi tenemos feedback
		window.setTimeout(function() {
			provisioning_api.rasaUpdateVCC(data,
				function(success/*, err*/) {
					let message, msg_type;
					if (success) {
						message = "<%=_T('RASA has been successfully updated.')%>";
						msg_type = "Info";
						if (vcc) {
							vcc.BotInfo = vcc.BotInfo || {};
							vcc.BotInfo.Type = "RASA";
						}
						self.frm.set_entity_instance(vcc);
					}
					else {
						self.hide_waiting();
						message = "<%=_T('Error updating RASA.')%>";
						msg_type = "Error";
						self.show_status_message(message, msg_type, 5000);
					}
					// invoco al callback para que continue o no con los Requests encadenados
					callback(success, {
						msg_type: msg_type,
						message : message
					});
				}
			);
		}, 500);
	};

	prov_form_vccs_cognitive_services.prototype.luis_update_vcc = function(callback = $.noop)
	{
		const self = this;

		const show_error = function(message) {
			self.show_status_message(message, "Error", 5000);
			callback(false);
		};

		// DEMO ---
		let data = {
			vcc    : this.frm.get_entity_id(),
			Enabled: $("#prov_form_vcc_cognitive_bot_enabled").prop("checked"),
			demo   : {
				enabled: $("#prov_form_vcc_cognitive_luis_demo_enabled").prop("checked")
			}
		};
		// custom demo subscription key
		if (data.demo.enabled) {
			const luis_demo_type = $("#prov_form_vcc_cognitive_luis_demo_type").val();
			if (luis_demo_type === "CUSTOM") {
				const $luis_demo_key = $("#prov_form_vcc_cognitive_luis_demo_key");
				if (!this.validate_field($luis_demo_key, "required")) {
					return show_error("<%=_T('Demo Subscription Id is required for Luis.')%>");
				}
				data.demo.subscriptionKey = $luis_demo_key.val();
			}
		}

		// ACCOUNT (AZURE & SUBSCRIPTIONS) ----
		if ($("#prov_form_vcc_cognitive_luis_account_configure").prop("checked")) {
			// validate azure
			const $account_azure_subscription_id = $("#prov_form_vcc_cognitive_luis_account_azure_subscription_id");
			if (!this.validate_field($account_azure_subscription_id, "required")) {
				const message = "<%=_T('Azure Account Subscription Id is required for Luis.')%>";
				return show_error(message);
			}
			const $account_azure_resource_group = $("#prov_form_vcc_cognitive_luis_account_azure_resource_group");
			if (!this.validate_field($account_azure_resource_group, "required")) {
				const message = "<%=_T('Azure Account Resource Group is required for Luis.')%>";
				return show_error(message);
			}
			const $account_azure_account_name = $("#prov_form_vcc_cognitive_luis_account_azure_account_name");
			if (!this.validate_field($account_azure_account_name, "required")) {
				const message = "<%=_T('Azure Account Name is required for Luis.')%>";
				return show_error(message);
			}
			// validate subscrition
			const $subscription_key_1 = $("#prov_form_vcc_cognitive_luis_account_subscription_key_1");
			if (!this.validate_field($subscription_key_1, "required")) {
				const message = "<%=_T('Subscription Key is required for Luis.')%>";
				return show_error(message);
			}
			const $subscription_name_1 = $("#prov_form_vcc_cognitive_luis_account_subscription_name_1");
			if (!this.validate_field($subscription_name_1, "required")) {
				const message = "<%=_T('Subscription Name is required for Luis.')%>";
				return show_error(message);
			}

			// asigno datos
			data.account = {
				azure: {
					AzureSubscriptionId: $account_azure_subscription_id.val(),
					ResourceGroup      : $account_azure_resource_group.val(),
					AccountName        : $account_azure_account_name.val(),
				},
				subscriptions: [
					// requerida
					{
						subscriptionKey : $subscription_key_1.val(),
						subscriptionName: $subscription_name_1.val(),
						//subscriptionRegion: "subscriptionRegion"
					}
				]
			};

			// subscription optionals
			const subscription_key_2 = $("#prov_form_vcc_cognitive_luis_account_subscription_key_2").val();
			const subscription_name_2 = $("#prov_form_vcc_cognitive_luis_account_subscription_name_2").val();
			if (subscription_key_2.trim().length > 0 && subscription_name_2.trim().length > 0) {
				data.account.subscriptions.push({
					subscriptionKey : subscription_key_2,
					subscriptionName: subscription_name_2
				});
			}
		}

		// TENANT ----
		if ($("#prov_form_vcc_cognitive_luis_tenant_configure").prop("checked")) {
			// validate
			const $tenant_id = $("#prov_form_vcc_cognitive_luis_tenant_id");
			if (!this.validate_field($tenant_id, "required")) {
				const message = "<%=_T('Tenant Id is required for Luis.')%>";
				return show_error(message);
			}
	
			const $secret_client_id = $("#prov_form_vcc_cognitive_luis_tenant_secret_client_id");
			if (!this.validate_field($secret_client_id, "required")) {
				const message = "<%=_T('Secret Client Id is required for Luis.')%>";
				return show_error(message);
			}
	
			const $secret_name = $("#prov_form_vcc_cognitive_luis_tenant_secret_name");
			if (!this.validate_field($secret_name, "required")) {
				const message = "<%=_T('Secret Name is required for Luis.')%>";
				return show_error(message);
			}
			const $resource_name = $("#prov_form_vcc_cognitive_luis_tenant_resource_name");
			if (!this.validate_field($resource_name, "required")) {
				const message = "<%=_T('Resource Name is required for Luis.')%>";
				return show_error(message);
			}
			// asigno datos
			data.tenantInfo = {
				tenant_id: $tenant_id.val(),
				client_id: $secret_client_id.val(),
				client_secret: $secret_name.val(),
				resource: $resource_name.val()
			};
		}

		// LanguageStudio
		if ($("#prov_form_vcc_cognitive_language_studio_configure").prop("checked")) {
			// validate
			const $resource_name = $("#prov_form_vcc_cognitive_language_studio_resource_name");
			if (!this.validate_field($resource_name, "required")) {
				const message = "<%=_T('Resource Name is required for Language Studio.')%>";
				return show_error(message);
			}
	
			const $azure_subscription_id = $("#prov_form_vcc_cognitive_language_studio_azure_subscription_id");
			if (!this.validate_field($azure_subscription_id, "required")) {
				const message = "<%=_T('Azure Subscription Id is required for Language Studio.')%>";
				return show_error(message);
			}
	
			const $subscription_key_1 = $("#prov_form_vcc_cognitive_language_studio_subscription_key_1");
			if (!this.validate_field($subscription_key_1, "required")) {
				const message = "<%=_T('Subscription Key 1 is required for Language Studio.')%>";
				return show_error(message);
			}

			const $subscription_key_2 = $("#prov_form_vcc_cognitive_language_studio_subscription_key_2");
			if (!this.validate_field($subscription_key_2, "required")) {
				const message = "<%=_T('Subscription Key 2 is required for Language Studio.')%>";
				return show_error(message);
			}

			/*const $api_version = $("#prov_form_vcc_cognitive_language_studio_api_version");
			if (!this.validate_field($api_version, "required")) {
				const message = "<%=_T('Api Version is required for Language Studio.')%>";
				return show_error(message);
			}*/

			// asigno datos
			data.languageStudioInfo = {
				resource_name: $resource_name.val(),
				azure_subscription_id: $azure_subscription_id.val(),
				subscription_key_1: $subscription_key_1.val(),
				subscription_key_2: $subscription_key_2.val() //,
				//api_version: $api_version.val()
			};
		}

		this.show_waiting("<%=_T('Please wait, Updating LUIS Information  ...')%>");

		let vcc = this.frm.get_entity_instance();

		// REQUEST --
		const provisioning_api = inConcert.app.getProvisioningAPI();
		// Se ejecuta en un pequeno timeout ya que la ejecucion puede ser muy rapida!! asi tenemos feedback
		window.setTimeout(function() {
			provisioning_api.luisUpdateVCC(data,
				function(success, err) {
					let message, msg_type;
					if (success) {
						message = "<%=_T('LUIS has been successfully updated.')%>";
						msg_type = "Info";
						 if (vcc) {
							vcc.BotInfo = vcc.BotInfo || {};
							vcc.BotInfo.Type = "LUIS";
						 }
						 self.frm.set_entity_instance(vcc);
					}
					else {
						self.hide_waiting();
						message = "<%=_T('Error updating LUIS.')%>";
						if (typeof err === "object") {
							if (typeof err.result === "object") {
								if (err.result.reason === "YOUR AZURE ACCOUNT INFORMATION IS INVALID") {
									message = "<%=_T('The LUIS Azure account information is invalid.')%>";
								}
							}
						}
						msg_type = "Error";
						self.show_status_message(message, msg_type, 5000);
					}
					// invoco al callback para que continue o no con los Requests encadenados
					callback(success, {
						msg_type: msg_type,
						message : message
					});
				}
			);
		}, 500);
	};

	prov_form_vccs_cognitive_services.prototype.llm_update_vcc = function(callback = $.noop)
	{
		const self = this;

		let data = {
			vcc    : this.frm.get_entity_id(),
			LlmProfiles: this.llm_profiles_mng.get()
		};

		// REQUEST --
		const provisioning_api = inConcert.app.getProvisioningAPI();
		
		window.setTimeout(function() {
			provisioning_api.llmUpdateVCC(data,
				function(success, err) {
					let message, msg_type;
					if (success) {
						message = "<%=_T('Llm models has been successfully updated.')%>";
						msg_type = "Info";
					}
					else {
						self.hide_waiting();
						message = "<%=_T('Error updating LLM.')%>";
						if (typeof err === "object") {
							if (typeof err.result === "object") {
								if (err.result.reason === "YOUR AZURE ACCOUNT INFORMATION IS INVALID") {
									message = "<%=_T('The LLM information is invalid.')%>";
								}
							}
						}
						msg_type = "Error";
						self.show_status_message(message, msg_type, 5000);
					}
					
					callback(success, {
						msg_type: msg_type,
						message : message
					});
				}
			);
		}, 500);
	};

	prov_form_vccs_cognitive_services.prototype.qna_update_vcc = function(callback = $.noop)
	{
		const self = this;

		const show_error = function(message) {
			self.show_status_message(message, "Error", 5000);
			callback(false);
		};

		const data = {
			vcc: this.frm.get_entity_id()
		};

		if ($("#prov_form_vcc_cognitive_qna_configure").prop("checked")) {
			// validate
			const $subscription_key_value = $("#prov_form_vcc_cognitive_qna_subscription_key_value");
			if (!this.validate_field($subscription_key_value, "required")) {
				const message = "<%=_T('Subscription Key Value is required for QnA Maker.')%>";
				return show_error(message);
			}
			const $subscription_key_name = $("#prov_form_vcc_cognitive_qna_subscription_key_name");
			if (!this.validate_field($subscription_key_name, "required")) {
				const message = "<%=_T('Subscription Key Name is required for QnA Maker.')%>";
				return show_error(message);
			}
			// asigno datos
			data.subscriptions = [{
				subscriptionKey : $subscription_key_value.val(),
				subscriptionName: $subscription_key_name.val(),
			}];
		}

        if ($("#prov_form_vcc_cognitive_qna_v2_configure").prop("checked")) {
			// validate
			const $subscription_key_value_v2 = $("#prov_form_vcc_cognitive_qna_v2_subscription_api_key");
			if (!this.validate_field($subscription_key_value_v2, "required")) {
				const message = "<%=_T('Subscription Key Value is required for QnA Maker.')%>";
				return show_error(message);
			}
			const $subscription_key_name_v2 = $("#prov_form_vcc_cognitive_qna_v2_subscription_base_uri");
			if (!this.validate_field($subscription_key_name_v2, "required")) {
				const message = "<%=_T('Subscription Key Name is required for QnA Maker.')%>";
				return show_error(message);
			}
			// asigno datos
			data.subscriptionsV2 = [{
				subscriptionKey : $subscription_key_value_v2.val(),
				subscriptionName: $subscription_key_name_v2.val(),
			}];
		}

		this.show_waiting("<%=_T('Please wait, Updating QnA Maker Information  ...')%>");

		const provisioning_api = inConcert.app.getProvisioningAPI();
		// Se ejecuta en un pequeno timeout ya que la ejecucion puede ser muy rapida!! asi tenemos feedback
		window.setTimeout(function() {
			provisioning_api.qnaUpdateVCC(data,
				function(success, err)
				{
					let message, msg_type;
					if (success) {
						message = "<%=_T('QnA Maker has been successfully updated.')%>";
						msg_type = "Info";
					}
					else {
						self.hide_waiting();
						if (err.result === "VCC HAS REACHED THE MAXIMUM SUBSCRITIONS ALLOWED") {
							// No es un error, ya que la accion 
							return;
						}
						message = "<%=_T('Error updating QnA Maker.')%>";
						msg_type = "Error";
						self.show_status_message(message, msg_type, 5000);
					}
					// invoco al callback para que continue o no con los Requests encadenados
					callback(success, {
						msg_type: msg_type,
						message : message
					});
				}
			);
		}, 500);
	};

	prov_form_vccs_cognitive_services.prototype.on_show_tab = function(/*tab_id*/)
	{
		//TODO: hacer algo si llega a ser necesario!!
	};

	/*
		Funcion que realiza un Requests (encadenados) por cada entidad/TAB.
		Los va encolando a los Request y ejecutando en la medida que el Request anterior de Ok.
	*/
	prov_form_vccs_cognitive_services.prototype.start_update_all_tabs = function()
	{
		const self = this;

		this.hide_messages();

		// 1 - realizo validaciones client side y luego ejecuto el request contra los NLU (Tab - NLU)
		this.nlu_update_vcc(function(success/*, info_nlu*/) { // fede
			if (!success) {
				self.main_tabs.switch_tab("bot");
				return;
			}
			// 2 - realizo validaciones y actualizacion contra QnA
			self.qna_update_vcc(function(success/*, info_qna*/) {
				if (!success) {
					self.main_tabs.switch_tab("QNA");
					return;
				}
				// 3 - realizo validaciones y actualizacion contra LLM
                self.llm_update_vcc(function(success/*, info_qna*/) {
                    if (!success) {
                        self.main_tabs.switch_tab("LLM");
                        return;
                    }
                    let message = "<%=_T('Cognitive Services of VCC has been successfully updated.')%>";
                    let msg_type = "Info";
                    self.show_status_message(message, msg_type, 5000);                
                });
			});
		});
	};

	prov_form_vccs_cognitive_services.prototype.save_execute = function()
	{
		this.start_update_all_tabs();
	};

}());
