local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "agents",
    name = "Agents Realtime By Campaign",
    description = "Agent states summary by campaign",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("CampaignId"),
    },
    columns = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("CampaignId"),
        monitoringUtils.GetField("LoggedAgents"),
        monitoringUtils.GetField("ActiveAgents"),
        monitoringUtils.GetField("FreeAgents"),
        monitoringUtils.GetField("NoAcdAgents"),
        monitoringUtils.GetField("BreakAgents"),
        monitoringUtils.GetField("AttendingAgents"),
        monitoringUtils.GetField("WrapupAgents"),
        monitoringUtils.GetField("AttendingWrapupAgents"),
        monitoringUtils.GetField("ReservedAgents"),
        monitoringUtils.GetField("OtherAgents"),
    },
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunSupervisorAgentsSummaryByCampaign(m_definition, request, _T)
end

function GetDetails(itemId)
    return { result = "FAIL", reason = "Not supported" }
end
