local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Contact Results",
    description = "Results of every contact try",
    filters = {
        monitoringUtils.GetField("Vcc", { required = true }),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("ImportId"),
        monitoringUtils.GetField("BatchId"),
        monitoringUtils.GetField("Contact"),
        monitoringUtils.GetField("OutboundContactState"),
        monitoringUtils.GetField("OutboundContactStateCause"),
        monitoringUtils.GetField("InteractionId"),
    },
    columns = {
        monitoringUtils.GetField("InteractionId"),
        monitoringUtils.GetField("DialerContactId"),
        monitoringUtils.GetField("ContactName"),
        monitoringUtils.GetField("ExternalId"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("ImportId"),
        monitoringUtils.GetField("BatchId"),
        monitoringUtils.GetField("StartDate"),
        monitoringUtils.GetField("EndDate"),
        monitoringUtils.GetField("OutboundContactState"),
        monitoringUtils.GetField("OutboundContactStateCause"),
        monitoringUtils.GetField("Agent"),
        monitoringUtils.GetField("EngineType"),
        monitoringUtils.GetField("Address"),
        monitoringUtils.GetField("Channel"),
        monitoringUtils.GetField("Kind"),
        monitoringUtils.GetField("Retries", { id = "TotalRetries" }),
        monitoringUtils.GetField("InteractionCode"),
        monitoringUtils.GetField("LowLevelCode"),
        monitoringUtils.GetField("ManagementResult"),
        monitoringUtils.GetField("IsGoal"),
        monitoringUtils.GetField("RingingTime"),
        monitoringUtils.GetField("WaitingTime"),
        monitoringUtils.GetField("AmdTime"),
        monitoringUtils.GetField("NextAddress"),
        monitoringUtils.GetField("ScheduleDate"),
    },
    downloadDetails = true,
    hasSize = true,
    order = {
        type = "columns",
        default = "StartDate",
    },
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunSearchOutboundContactResults(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetContactResultDetails(itemId)
end
