local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Contact Priority",
    description = "Number of contacts per process, import id, batch id and priority",
    filters = {
        monitoringUtils.GetField("Vcc", { required = true }),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("ImportId"),
        monitoringUtils.GetField("BatchId"),
        monitoringUtils.GetField("ExcludeWithoutAddress"),
    },
    columns = {
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("ImportId"),
        monitoringUtils.GetField("BatchId"),
        monitoringUtils.GetField("BatchPriority", { batchColumn = true }),
        monitoringUtils.GetField("Priority"),
        monitoringUtils.GetField("OutboundContactState"),
        monitoringUtils.GetField("OutboundContactStateCause"),
        monitoringUtils.GetField("Number"),
    }
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    local result = monitoringUtils.RunSummaryOutboundContacts(
        monitoringUtils.DefinitionWithout(m_definition, "batchColumn"), request, _T)
    if result.result ~= "OK" then return result end

    return monitoringUtils.AppendBatchFields(result, m_definition, _T)
end

function GetDetails(itemId)
    return { result = "FAIL", reason = "Not supported" }
end
