local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "interactions",
    name = "Interactions",
    description = "Details of interactions",
    filters = {},
    columns = {
        monitoringUtils.GetField("InteractionId", { id = "id" }),
        monitoringUtils.GetField("Channel", { id = "type" }),
        monitoringUtils.GetField("Direction", { id = "initiative" }),
        monitoringUtils.GetField("Campaign", { id = "campaign" }),
        monitoringUtils.GetField("Account", { id = "account" }),
        monitoringUtils.GetField("AttentionLevel", { id = "attention_level" }),
        monitoringUtils.GetField("StartDate", { id = "start_timestamp" }),
        monitoringUtils.GetField("InteractionStateDate", { id = "state_timestamp" }),
        monitoringUtils.GetField("LastEventDate", { id = "last_event_timestamp" }),
        monitoringUtils.GetField("InteractionState", { id = "state" }),
        monitoringUtils.GetField("InteractionAgents", { id = "agents" }),
        monitoringUtils.GetField("ContactId", { id = "contact" }),
        monitoringUtils.GetField("ContactName", { id = "contact_name" }),
        monitoringUtils.GetField("Address", { id = "contact_address" }),
        monitoringUtils.GetField("ManagementResult", { id = "disposition_code" }),
    },
    downloadDetails = true,
    hasSize = true,
    order = {
        type = "columns",
        default = "start_timestamp",
    },
}
table.insert(m_definition.filters, monitoringUtils.GetField("Vcc", { required = true }))
table.insert(m_definition.filters, monitoringUtils.GetField("Channel", { id = "type" }))
table.insert(m_definition.filters, monitoringUtils.GetField("Direction", { id = "initiative" }))
table.insert(m_definition.filters, monitoringUtils.GetField("Campaign", { id = "campaign" }))
table.insert(m_definition.filters, monitoringUtils.GetField("Account", { id = "account" }))
table.insert(m_definition.filters, monitoringUtils.GetField("AttentionLevel", { id = "attention_level" }))
table.insert(m_definition.filters, monitoringUtils.GetField("InteractionState", { id = "state" }))
table.insert(m_definition.filters, monitoringUtils.GetField("InteractionAgents",
    { id = "agents", type = "string", name = "Agent" }))
table.insert(m_definition.filters, monitoringUtils.GetField("InteractionContact"))
table.insert(m_definition.filters, monitoringUtils.GetField("InteractionId", { id = "id" }))
table.insert(m_definition.filters, monitoringUtils.GetField("InteractionContent"))

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunSearchInteractions(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetInteractionDetails(itemId)
end
