local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Process Contacts Status",
    description = "Summary of contacts current status",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
    },
    columns = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("CampaignId"),
        monitoringUtils.GetField("LoadedContacts"),
        monitoringUtils.GetField("EffectiveContacts"),
        monitoringUtils.GetField("EffectiveContactsPercentage"),
        monitoringUtils.GetField("RemainingContacts"),
        monitoringUtils.GetField("RemainingContactsPercentage"),
        monitoringUtils.GetField("ScheduledNextHour"),
        monitoringUtils.GetField("UnhandledContacts"),
        monitoringUtils.GetField("UnhandledContactsPercentage"),
        monitoringUtils.GetField("ScheduledContacts"),
        monitoringUtils.GetField("ScheduledContactsPercentage"),
        monitoringUtils.GetField("DelayedScheduled"),
        monitoringUtils.GetField("CanceledContacts"),
        monitoringUtils.GetField("CanceledContactsPercentage"),
        monitoringUtils.GetField("PausedContacts"),
    },
    downloadDetails = true,
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunAnalyticsCampaignsListView(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetAnalyticsCampaignsDetailsView(itemId, "process")
end
