local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Process Predictive Monitor",
    description = "Predictive algorithm monitor",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("Slice"),
    },
    columns = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("CampaignId"),
        monitoringUtils.GetField("EngineType"),
        monitoringUtils.GetField("DesiredAbandonRate"),
        monitoringUtils.GetField("AlghoritmAbandonRate"),
        monitoringUtils.GetField("AlghoritmAbandonRateDeviation"),
        monitoringUtils.GetField("AlghoritmContactRate"),
        monitoringUtils.GetField("AlghoritmCorrectionRatio"),
        monitoringUtils.GetField("CorrectionManualRate"),
        monitoringUtils.GetField("AttendingAgents"),
        monitoringUtils.GetField("WrapupAgents"),
        monitoringUtils.GetField("OtherAgents"),
        monitoringUtils.GetField("ContactRate", { bySlice = true }),
        monitoringUtils.GetField("AbandonRate", { bySlice = true }),
        monitoringUtils.GetField("AbandonedByTimeoutRate", { bySlice = true }),
        monitoringUtils.GetField("AbandonedByAgentRate", { bySlice = true }),
        monitoringUtils.GetField("BadServiceLevelRate", { bySlice = true }),
    },
    downloadDetails = true,
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunAnalyticsCampaignsListView(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetAnalyticsCampaignsDetailsView(itemId, "process")
end
