local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Process Realtime",
    description = "Realtime dialer indicators",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
    },
    columns = {},
    downloadDetails = true,
}

table.insert(m_definition.columns, monitoringUtils.GetField("Vcc"))
table.insert(m_definition.columns, monitoringUtils.GetField("OutboundProcessId"))
table.insert(m_definition.columns, monitoringUtils.GetField("CampaignId"))
table.insert(m_definition.columns, monitoringUtils.GetField("RunningContacts"))
table.insert(m_definition.columns, monitoringUtils.GetField("ProcessFlowInteractions"))
table.insert(m_definition.columns, monitoringUtils.GetField("WaitingInteractions"))
table.insert(m_definition.columns, monitoringUtils.GetField("PreviewInteractions"))
table.insert(m_definition.columns, monitoringUtils.GetField("TakenInteractions"))
table.insert(m_definition.columns, monitoringUtils.GetField("WrapupInteractions"))
table.insert(m_definition.columns, monitoringUtils.GetField("TakenWrapupInteractions"))

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunAnalyticsCampaignsListView(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetAnalyticsCampaignsDetailsView(itemId, "process")
end
