local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Process Status",
    description = "Status for every outbound engine processes",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
    },
    columns = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("CampaignId"),
        monitoringUtils.GetField("OutboundProcessState"),
        monitoringUtils.GetField("OutboundProcessStateCause"),
        monitoringUtils.GetField("EngineType"),
    },
    downloadDetails = true,
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunAnalyticsCampaignsListView(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetAnalyticsCampaignsDetailsView(itemId, "process")
end
