local m_models = require("apps.social_networks.model"):GetModels()
module(..., package.seeall, inconcert.orbit.application.Decorate)
local utils = require "shared.apps.utils"
m_htmlRender = nil

function MapUris(m, htmlRender, prefix)

	local LogRequest = require("apps.agent.requestFilters").LogRequest

	--TODO: hacer el control de permisos pertinente
	m:dispatch_get(utils.JsonReply..LogRequest..ConfigGet, prefix.."/get/")
	m:dispatch_post(utils.JsonValidatorReply..LogRequest..ConfigSave, prefix.."/save/")

	m_htmlRender = htmlRender
end

function ConfigGet (web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = inconcert.authUser.userName.."@"..vcc

	LogInfo("[Social Networks] - Getting Social Networks config for member: %s ", userId)

	local config = m_models.Configuration.Get(userId)

	if next(config) then
		return config
	end
	return {}
end

function ConfigSave (web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = inconcert.authUser.userName.."@"..vcc
	local config = web.request.configuration

	if not config then
		return json.encode { result = "INVALID_REQUEST", reason = "ConfigSave - Social Networks configuration not provided."}
	end

	LogInfo("[Social Networks] - Saving Social Networks config for member: '%s' configuration: '%s' ", userId, config)

	local result = m_models.Configuration.Save(userId, config)
	if result ~= "" then
		return { result = result }
	end

	return { result = "OK" }
end
