/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsData) {
	inConcert.snPostsData = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function PostsData () {}

	inConcert.Utils.inherit(PostsData, inConcert.snPostsData.base);
	if (typeof inConcert.snPostsData.instagram !== "function") {
		inConcert.snPostsData.instagram = PostsData;
	}

	PostsData.prototype.GetText = function(data, quoted) {
		data = data || {};
		return data.text || "";
	};

	PostsData.prototype.GetContent = function(data, quoted) {
		data = data || {};
		var result = {
			text : this.GetText(data, quoted),
			multimedia : []
		};
		(function processMessage(message) {
			switch(message.media_type) {
				case "IMAGE":
					result.multimedia.push({
						type : "image",
						image : message.media_url
					});
					break;
				case "VIDEO":
					result.multimedia.push({
						type : "video",
						image : message.thumbnail_url,
						link : message.media_url
					});
					break;
				case "CAROUSEL_ALBUM":
					$.each(message.children || [], function(_, child) {
						processMessage(child);
					});
					break;
			}
		})(data);
		return result;
	};

}());