/*jshint quotmark:false*/
/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsData) {
	inConcert.snPostsData = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var format = inConcert.Utils.format;

	function PostsData ()
	{
		
	}
	
	inConcert.Utils.inherit(PostsData, inConcert.snPostsData.base);
	if (typeof inConcert.snPostsData.twitter !== "function") {
		inConcert.snPostsData.twitter = PostsData;
	}
	
	PostsData.prototype.GetScreenName = function(data) {
		return data && data.user && data.user.screen_name || "";
	};
	
	PostsData.prototype.GetText = function(data, quoted) {
		data = data || {};
		if (quoted) {
			return data.quoted_status && data.quoted_status.text || "";
		}
		return data.text || "";
	};
	
	PostsData.prototype.GetContent = function(data, quoted) {
		data = data || {};
		var result = {
			text : this.GetText(data, quoted),
			multimedia : []
		};
		
		var text_a = result.text.split("");
		
		function validateIndexes(indexes) {
			return $.isArray(indexes) && indexes.length === 2 && indexes[1] <= text_a.length;
		}
		
		function replaceText(indexes, html) {
			text_a[indexes[0]] = html;
			for (var i = indexes[0] + 1; i < indexes[1]; i++) {
				text_a[i] = "";
			}
		}
		
		if (quoted) {
			data = data.quoted_status || {};
		}
		
		result.user = {
			name : data.user? format("{0} (@{1})", data.user.name, data.user.screen_name) : "",
			avatar : data.user? data.user.profile_image_url : ""
		};
		result.date = inConcert.Utils.formatDate(new Date(data.created_at));
		
		var entities = data.entities || {};
		
		//mentions
		$.each(entities.user_mentions || [], function(_, mention) {
			if (!mention.screen_name || !validateIndexes(mention.indices)) {
				return;
			}
			var mentionHtml = format("<a class='mention' title='{0}' mention_user_id='{1}'>{2}</a>",
				mention.name || mention.screen_name, 
				mention.id_str || "undefined", 
				"@" + mention.screen_name);
			replaceText(mention.indices, mentionHtml);
		});
		//hashtags
		$.each(entities.hashtags || [], function(_, hashtag) {
			if (!hashtag.text || !validateIndexes(hashtag.indices)) {
				return;
			}
			var hashtagHtml = format("<a class='hashtag' title='{0}'>{1}</a>",
				hashtag.text,
				"#" + hashtag.text);
			replaceText(hashtag.indices, hashtagHtml);
		});
		//urls
		$.each(entities.urls || [], function(_, url) {
			if (!url.url || !validateIndexes(url.indices)) {
				return;
			}
			//check if is mention url
			if (data.quoted_status && data.quoted_status_id_str && url.expanded_url && 
					url.expanded_url.indexOf(data.quoted_status_id_str) >= 0
			) {
				replaceText(url.indices, "");
				return;
			}

			var urlHtml = format("<a class='url' title='{0}' href='{1}' target='_blank'>{2}</a>",
				url.expanded_url || url.url,
				url.expanded_url || url.url,
				url.display_url || url.url);
			replaceText(url.indices, urlHtml);
		});
		//media
		$.each(entities.media || [], function(_, media) {
			if (!media.url || !validateIndexes(media.indices)) {
				return;
			}
			//si no hay url del medio no lo puedo mostrar. Dejo la url.
			var mediaHtml = "";
			var url = media.media_url_https || media.media_url;
			if (!url || media.type !== "photo") {
				mediaHtml = format("<a class='urlTag' title='{0}' href='{1}' target='_blank'>{2}</a>",
				media.expanded_url || media.url,
				media.expanded_url || media.url,
				media.display_url || media.url);
			}
			else {
				switch(media.type) {
					//images
					case "photo":
						result.multimedia.push({
							type : "image",
							image : url,
							link : media.expanded_url || url
						});
						break;
				}
			}
			replaceText(media.indices, mediaHtml);
		});
		result.processedText = "";
		$.each(text_a, function(_, textPart) {
			result.processedText += textPart;
		});
		if (!quoted && data.quoted_status) {
			result.quoted = this.GetContent(data, true);
		}
		return result;
	};

}());