/*jshint quotmark:false*/
/*global $, inConcert, instgrm*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var format = inConcert.Utils.format;

	var actions = $.extend({}, inConcert.snPostsActions.base, {
		EDIT		: null,
		RESCHEDULE	: null,
		DELETE		: null
	});
	if (!inConcert.snPostsActions.instagram) {
		inConcert.snPostsActions.instagram = actions;
		$.each(actions, function(actionId, action) {
			inConcert.snPostsActions.all[actionId] = inConcert.snPostsActions.all[actionId] || action;
		});
	}

	function InstagramPost (rawData)
	{
		InstagramPost.uber.constructor.call(this, rawData);
	}

	inConcert.Utils.inherit(InstagramPost, inConcert.snPosts.base);
	if (typeof inConcert.snPosts.instagram !== "function") {
		inConcert.snPosts.instagram = InstagramPost;
	}
	
	InstagramPost.prototype.GetAccountName = function() {
		var campaign = inConcert.app.getCampaign(this.campaign);
		if (campaign) {
			var account  = campaign.getAccount(this.account);
			if (account) {
				var pages = account.pagesNames;
				if (typeof pages === "string") {
					pages = JSON.parse(pages);
				}
				if (pages[this.page]) {
					return this.page;
				}
			}
		}
		return InstagramPost.uber.GetAccountName.call(this);
	};
	
	InstagramPost.prototype.LoadApi = function(callback = $.noop) {
		let check = function() {
			return window.hasOwnProperty("instgrm") && instgrm.Embeds && true || false;
		};
		inConcert.Utils.loadJsResource("//www.instagram.com/embed.js", check, function(status) {
			callback(status);
		}, "instagramWidgetsScript");
	};
	
	InstagramPost.prototype.GetEmbedHtml = function(callback, properties) {
		let self = this;
		self.LoadApi(function(status) {
			if (!status) {
				return callback(null);
			}
			properties = properties || {};
			if (!self.data.permalink) {
				return callback(null);
			}
			
			inConcert.app.getSNPostsManager().GetInstagramPost(self.campaign, self.account, self.data.permalink, callback);
			
		});
	};

}());