/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsReschedule) {
	inConcert.snPostsReschedule = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function ReschedulePopup (post)
	{
		ReschedulePopup.uber.constructor.call(this, post);
	}
	
	inConcert.Utils.inherit(ReschedulePopup, inConcert.snPostsReschedule.base);
	if (typeof inConcert.snPostsReschedule.facebook !== "function") {
		inConcert.snPostsReschedule.facebook = ReschedulePopup;
	}
	
	ReschedulePopup.prototype.__getClassName = function() {
		return "fbPost";
	};
	
	ReschedulePopup.prototype.__getScheduleDateLimits = function() {
		var now = new Date();
		var limits = {
			min : this.__makeDateLimit({
				up : true,
				unity : "minutes",
				value: 10
			}, now),
			max : this.__makeDateLimit({
				up : true,
				unity : "months",
				value: 6
			}, now)
		};
		limits["default"] = new Date(Math.max(limits.min, this.__getOriginalScheduleDate()));
		return limits;
	};
	
	ReschedulePopup.prototype.__makeData = function() {
		var date = this.__getScheduledDate();
		if (!this.__validateDatetime(date, this.__getScheduleDateLimits())) {
			this.Message("<%=_T('Scheduled date must be bigger than 10 minutes and less than 6 months.')%>", "error");
			return;
		}
		return {
			scheduled_publish_time : "" + Math.floor(date.getTime() / 1000)
		};
	};

}());