/*jshint quotmark:false*/
/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var format = inConcert.Utils.format;

	var actions = $.extend({}, inConcert.snPostsActions.base, {
		EDIT		: null,
		RESCHEDULE	: null
	});
	if (!inConcert.snPostsActions.twitter) {
		inConcert.snPostsActions.twitter = actions;
		$.each(actions, function(actionId, action) {
			inConcert.snPostsActions.all[actionId] = inConcert.snPostsActions.all[actionId] || action;
		});
	}

	function TwitterPost (rawData)
	{
		TwitterPost.uber.constructor.call(this, rawData);
	}

	inConcert.Utils.inherit(TwitterPost, inConcert.snPosts.base);
	if (typeof inConcert.snPosts.twitter !== "function") {
		inConcert.snPosts.twitter = TwitterPost;
	}
	
	TwitterPost.prototype.GetCharactersLimit = function() {
		return 280;
	};
	
	TwitterPost.prototype.__getScreenName = function() {
		var campaign = inConcert.app.getCampaign(this.campaign);
		if (campaign) {
			var account  = campaign.getAccount(this.account);
			if (account && account.screen_name) {
				return account.screen_name;
			}
		}
		return inConcert.app.getSNPostsManager().GetDataProcessor("TWITTER").GetScreenName(this.data);
	};
	
	TwitterPost.prototype.GetAccountName = function() {
		return this.__getScreenName() || TwitterPost.uber.GetAccountName.call(this);
	};
	
	TwitterPost.prototype.LoadApi = function(callback = $.noop) {
		let check = function() {
			return window.hasOwnProperty("twttr") && twttr.widgets && true || false;
		};
		inConcert.Utils.loadJsResource("//platform.twitter.com/widgets.js", check, function(status) {
			callback(status);
		}, "twitterWidgetsScript");
	};
	
	TwitterPost.prototype.GetEmbedHtml = function(callback, properties) {
		let self = this;
		self.LoadApi(function(status) {
			if (!status) {
				return callback(null);
			}
			properties = properties || {};
			let url = format("https://api.twitter.com/1.1/statuses/oembed.json?id={0}&hide_thread=true&omit_script=true&maxwidth=370",
					self.id);
			inConcert.invoke({
				url: url,
				type: "GET",
				dataType: "jsonp",
				contentType: "application/json",
				timeout: 1500,
				success: function(response) {
					callback(response);
				},
				error: function(_, error) {
					callback(null);
				}
			});
		});
	};

}());