/*jshint quotmark:false*/
/*global $, twttr, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snStatistics) {
	inConcert.snStatistics = {};
}
if (!inConcert.snStatistics.post) {
	inConcert.snStatistics.post = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var definition = [
		{
			id : "interactions",
			name : "<%=_T('Interactions')%>",
			description : "<%=_T('Number of interactions created related to this post.')%>"
		}/*,
		{
			id : "impressions",
			name : "<%=_T('Impressions')%>",
			description : "<%=_T('Number of times people saw post.')%>"
		},
		{
			id : "engagements",
			name : "<%=_T('Engagements')%>",
			description : "<%=_T('Number of times users interacted with post (clicks, replies, retweets, mentions and favorites).')%>"
		},
		{
			id : "likes",
			name : "<%=_T('Likes')%>",
			description : "<%=_T('Number of post likes.')%>"
		},
		{
			id : "replies",
			name : "<%=_T('Replies')%>",
			description : "<%=_T('Number of post replies.')%>"
		},
		{
			id : "retweets",
			name : "<%=_T('Retweets')%>",
			description : "<%=_T('Number of times post was retweeted (not quoted).')%>"
		},
		{
			id : "clicks",
			name : "<%=_T('Clicks')%>",
			description : "<%=_T('Number of post clicks.')%>",
			total : "clicks",
			hide_empty : true,
			items : [
				{
					id : "url_clicks",
					name : "<%=_T('Url clicks')%>",
					description : "<%=_T('Number of times post link was clicked.')%>",
					color : "#D62728"
				}
			],
			another : {
				id : "another_clicks",
				name : "<%=_T('Another clicks')%>",
				description : "<%=_T('Another post clicks.')%>",
				color : "#E8A032"
			}
		}*/
	];

	function Statistics (rawData)
	{
		var slices = [];
		if (!rawData.post.IsClosed() && !rawData.post.IsDeleted()) {
			slices.push(inConcert.snStatisticsSlices.today);
			slices.push(inConcert.snStatisticsSlices.yesterday);
		}
		slices.push(inConcert.snStatisticsSlices.last7days);
		slices.push(inConcert.snStatisticsSlices.last28days);
		slices.push(inConcert.snStatisticsSlices.total);
		Statistics.uber.constructor.call(this, definition, slices, inConcert.snStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.snStatistics.post.base);
	if (typeof inConcert.snStatistics.post.twitter !== "function") {
		inConcert.snStatistics.post.twitter = Statistics;
	}
	
	Statistics.prototype.GetClassName = function() {
		return "twPost";
	};
	
	Statistics.prototype.GetContent = function(callback) {
		callback = callback || $.noop;
		var self = this;
		if (self.post.IsDeleted()) {
			return Statistics.uber.GetContent.call(self, callback);
		}
		self.post.GetEmbedHtml(function(response) {
			if (!response || !response.html) {
				return Statistics.uber.GetContent.call(self, callback);
			}
			var $html = $("<div class='embedTweetContainer'></div>");
			$html.append(response.html);
			callback({
				$html : $html
			});
		});
	};
	
	Statistics.prototype.AfterUiLoad = function(callback = $.noop) {
		this.post.LoadApi(function(status) {
			if (status) {
				twttr.widgets.load();
			}
			callback();
		});
	};
	
	Statistics.prototype.GetNewPostText = function() {
		return "<%=_T('New')%>";
	};

}());