/*jshint quotmark:false*/
/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snStatistics) {
	inConcert.snStatistics = {};
}
if (!inConcert.snStatistics.post) {
	inConcert.snStatistics.post = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var definition = [
		{
			id : "interactions",
			name : "<%=_T('Interactions')%>",
			description : "<%=_T('Number of interactions created related to this post.')%>"
		}
	];

	function Statistics (rawData)
	{
		var slices = [];
		if (!rawData.post.IsClosed() && !rawData.post.IsDeleted()) {
			slices.push(inConcert.snStatisticsSlices.today);
			slices.push(inConcert.snStatisticsSlices.yesterday);
		}
		slices.push(inConcert.snStatisticsSlices.last7days);
		slices.push(inConcert.snStatisticsSlices.last28days);
		slices.push(inConcert.snStatisticsSlices.total);
		Statistics.uber.constructor.call(this, definition, slices, inConcert.snStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.snStatistics.post.base);
	if (typeof inConcert.snStatistics.post.youtube !== "function") {
		inConcert.snStatistics.post.youtube = Statistics;
	}
	
	Statistics.prototype.GetClassName = function() {
		return "youtubePost";
	};
	
	Statistics.prototype.GetContent = function(callback) {
		callback = callback || $.noop;
		var self = this;
		if (self.post.IsDeleted()) {
			return Statistics.uber.GetContent.call(self, callback);
		}
		self.post.GetEmbedHtml(function(response) {
			if (!response || !response.html) {
				return Statistics.uber.GetContent.call(self, callback);
			}
			var $html = $("<div class='embedYoutubeContainer'></div>");
			$html.append(response.html);
			callback({
				$html : $html
			});
		});
	};
	
	Statistics.prototype.AfterUiLoad = function(callback) {
		callback = callback || $.noop;
		callback();
	};
	
	Statistics.prototype.GetNewPostText = function() {
		return "<%=_T('New Video')%>";
	};
	
	Statistics.prototype.CanCreateNewPost = function() {
		return false;
	};

}());