/*jshint quotmark:false*/
/*global $, inConcert, Mustache*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var templates = inConcert.templates.social_networks;

	function StatisticsPreview (parent)
	{
		StatisticsPreview.uber.constructor.call(this, parent);
	}
	
	inConcert.Utils.inherit(StatisticsPreview, inConcert.snStatisticsUi.base);
	if (!inConcert.snStatisticsUi.preview) {
		inConcert.snStatisticsUi.preview = StatisticsPreview;
	}
	
	StatisticsPreview.prototype.Show = function(callback) {
		callback = callback || $.noop;
		var self = this;
		self.__make(function($body) {
			$("#snStats")
				.html("")
				.append($body);
			self.__afterLoad(callback);
		});
	};
	
	StatisticsPreview.prototype.Reload = function(callback) {
		this.Show(callback);
	};
	
	StatisticsPreview.prototype.__getViewName = function() {
		return "statistics_preview";
	};
	
	StatisticsPreview.prototype.__getPieChartSize = function() {
		return 100;
	};
	
	StatisticsPreview.prototype.__getLineChartSize = function() {
		return {
			width: 90,//150
			height: 35
		};
	};
	
	StatisticsPreview.prototype.__getBarsChartSize = function() {
		return {
			width: 288,
			height: 80
		};
	};
	
	StatisticsPreview.prototype.__makeBody = function(callback) {
		callback = callback || $.noop;
		var self = this;
		var $body = $(Mustache.render(templates.statistics_preview, {
			name : this.parent.GetAccountName(),
			new_post : this.parent.GetNewPostText()
		}));
		self.__makeContent($body, function() {
			self.__makeNewPost($body);
			self.__closeStatsDetails($body);
			$body.find("button[view_details]").click(function() {
				self.parent.ShowPopup();
			});
			callback($body);
		});
	};

}());