local m_models = require("apps.supervisor.model"):GetModels()
module(..., package.seeall, inconcert.orbit.application.Decorate)
local utils = require "shared.apps.utils"
m_htmlRender = nil


--local permissions = require "apps.supervisor.permissions"

function MapUris(module, prefix, htmlRender)

	local LogRequest = require("apps.agent.requestFilters").LogRequest

	--TODO: hacer el control de permisos pertinente
	module:dispatch_get(utils.JsonReply..LogRequest..ConfigGet, prefix.."/get/")
	module:dispatch_post(utils.JsonValidatorReply..LogRequest..ConfigSave, prefix.."/save/")

	m_htmlRender = htmlRender
end

function ConfigGet (web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = inconcert.authUser.userName.."@"..vcc

	LogInfo("[Supervisor] - Getting Supervisor config for member: %s ", userId)

	local config = m_models.Configuration.Get(userId)

	if next(config) then
		return config
	end
	return {}
end

function ConfigSave (web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = inconcert.authUser.userName.."@"..vcc
	local config = web.request.configuration

	if not config then
		return json.encode { result = "INVALID_REQUEST", reason = "ConfigSave - Supervisor configuration not provided."}
	end

	LogInfo("[Supervisor] - Saving Supervisor config for member: '%s' configuration: '%s' ", userId, config)

	local result = m_models.Configuration.Save(userId, config)
	if result ~= "" then
		return { result = result }
	end

	return { result = "OK" }
end
