local m_models = require("apps.supervisor.model"):GetModels()
module(..., package.seeall, inconcert.orbit.application.Decorate)
local utils = require "shared.apps.utils"
local authFilter = (require "authfilter")("agent")
local permissions = require "shared.permissions.permissions"
local agentNotifications = require("apps.agent.agentNotifications")
m_htmlRender = nil

function MapUris(module, prefix, htmlRender)

	local LogRequest = require("apps.agent.requestFilters").LogRequest

	module:dispatch_post( utils.JsonValidatorReply .. LogRequest .. permissions:CheckCampaignPermission( "supervisor", "sup_broadcast", BroadcastMessage ), prefix .. "/broadcast_message/" )

	m_htmlRender = htmlRender
end

function BroadcastMessage (web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = inconcert.authUser.userName.."@"..vcc

	local message = web.request.message
	local users = web.request.users

	if type(message) ~= "string" then
		web.status = 400
		return {result = "INVALID_REQUEST", reason = "Missing or invalid field 'message' in request"}
	end

	if type(users) ~= "table" then
		web.status = 400
		return {result = "INVALID_REQUEST", reason = "Missing or invalid field 'users' in request"}
	end

	LogInfo("Broadcasting message '%s' from '%s' to '%s' members", message, userId, #users)

	local result = agentNotifications.NotifyAgents({
		scope = "agent",
		eventType = "supervisor_broadcast",
		agents = users,
		pollerMessage = {
			supervisor = inconcert.authUser.userName,
			message = message
		},
		serverMessage = {
			supervisor = inconcert.authUser.userName,
			message = message
		}
	}, keyspace)

	return { 
		result = "OK", 
		messagesSent = result.pollerCount 
	}
end
