local m_models = require("apps.supervisor.model"):GetModels()
module(..., package.seeall, inconcert.orbit.application.Decorate)
local utils = require "shared.apps.utils"
m_htmlRender = nil

function MapUris(module, prefix, htmlRender)
	local LogRequest = require("apps.agent.requestFilters").LogRequest
	--TODO: hacer el control de permisos pertinente
	module:dispatch_get(utils.JsonReply..LogRequest..GetWorkgroups, prefix.."/get/")
	m_htmlRender = htmlRender
end

function GetWorkgroupsData (vcc, keyspace)
	local closeKeyspace
	if not keyspace then
		keyspace = utils.GetDatasource():CassandraConnection( "Agent" )
		closeKeyspace = true
	end
	
	local allWorkgroups = m_models.Workgroups.GetWorkgroups(vcc, nil, keyspace)
	local supervisorWorkgroups = m_models.Users.GetSupervisorWorkgroups(vcc, inconcert.authUser.userName, keyspace)
	if closeKeyspace then
		keyspace:Close()
	end

	for campaignName, workgroups in pairs(supervisorWorkgroups) do
		for workgroupName in pairs(workgroups) do
			if allWorkgroups[workgroupName] then
				workgroups[workgroupName] = allWorkgroups[workgroupName]
			else
				workgroups[workgroupName] = nil
				LogWarning("Workgroup %s not found", workgroupName)
			end
		end
	end

	return supervisorWorkgroups
end

function GetWorkgroups(web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = inconcert.authUser.userName.."@"..vcc

	--LogInfo("Getting workgroups for member: %s ", userId)
	return GetWorkgroupsData(vcc, keyspace)
end
