/*jslint nomen:false, regexp: false*/
/*jshint nomen:false, unused:true, undef: true, newcap:true, strict:false, smarttabs:true */
/*global $, inConcert */

/*
3rd party apps integration.
*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!this.inConcert) {
    this.inConcert = {};
}

(function () {

	var _T = inConcert.i18n.getString;
	var format = inConcert.Utils.format;

	/*-------------------------------------------------
	 * Class Tweety Windows
	 */
	function TweetyWindow ( options )
	{
		this.conf      = options.conf;
	}

	TweetyWindow.prototype.load = function ()
	{
		var uri = this.navigateTo( this.conf.uri, this.conf.parameters );
		this.popup_window = window.open( uri, this.conf.instance_id );
	};

	TweetyWindow.prototype.navigateTo = function( uri, parameters ) {
		var uri_parameters = "";
		$.each(parameters, function(name, value)
		{
			uri_parameters += uri_parameters.length > 0 ? "&" : "";
			uri_parameters += name + "=" + encodeURIComponent( value );
		});

		uri += uri_parameters.length > 0 ? ("?" + uri_parameters) : "";
		return uri;
	};

	TweetyWindow.prototype.onNewProject = function (success, info)
	{
		if ( success ) {
			this.conf.project_id = info.id;
		}
		this.conf.on_new_project(success, info);
	};

	TweetyWindow.prototype.onClose = function()
	{
		if ( this.conf && this.conf.on_close_window ) {
			this.conf.on_close_window( this.conf.instance_id );
		}
	};

	TweetyWindow.prototype.close = function ()
	{
		if ( this.popup_window ) {
			this.popup_window.close();
		}
	};

	if(typeof inConcert.TweetyWindow !== "object") {
		//integration manager is a singleton so it's published already initialized
		//(everyone should see the same registered application list)
		inConcert.TweetyWindow = TweetyWindow;
	}
}());
