

let initialized = false;
let index = 1;
let intervals = {},
    timeouts = {};

let intervalId = null;
function postMessageHandler(e) {
    if (e.data && e.data.bmlibTimers) {
        e.stopPropagation();

        var now = new Date().getTime();
        for (const [ind, obj] of Object.entries(timeouts)) {
            var targetTime = obj[1];
            if (now >= targetTime) {
                obj[0]();
                delete timeouts[ind];
            }
        };
        for (const [ind, obj] of Object.entries(intervals)) {
            var startTime = obj[1];
            var func = obj[0];
            var ms = obj[2];

            if (now >= startTime + ms) {
                func();
                obj[1] = new Date().getTime();
            }
        }

    }
}


function initialize() {

    window.addEventListener("message", postMessageHandler, true);
    intervalId = window.setInterval(() => {
        window.postMessage({ bmlibTimers: true,clientSilde:true }, "*");
    }, 100);
    initialized = true;
}
export function setInterval(func, ms) {
    if (!initialized) {
        initialize();
    }
    intervals[index] = [func, new Date().getTime(), ms];
    return index++;

}

export function setTimeout(func, ms) {
    if (!initialized) {
        initialize();
    }
    timeouts[index] = [func, new Date().getTime() + ms];
    return index++;
}
export function clearInterval(ind) {
    if (intervals[ind]) {
        delete intervals[ind]
    }
}
export function clearTimeout(ind) {
    if (timeouts[ind]) {
        delete timeouts[ind]
    }
}

export function browser () {
    let agent = window.navigator.userAgent.toLowerCase();
    switch (true) {
        case agent.indexOf("edge") > -1: return "edge";
        case agent.indexOf("edg/") > -1: return "chromium based edge"; // Match also / to avoid matching for the older Edge
        case agent.indexOf("opr") > -1 && !!window.opr: return "opera";
        case agent.indexOf("chrome") > -1 && !!window.chrome: return "chrome";
        case agent.indexOf("trident") > -1: return "ie";
        case agent.indexOf("firefox") > -1: return "firefox";
        case agent.indexOf("safari") > -1: return "safari";
        default: return "other";
    }
}