const path = require('path');

module.exports = {
  entry: './src/iccbmlib.js',
  module: {
    rules: [
      {
        test: /\.(js|jsx)$/,
        exclude: /node_modules/,
        use: ['babel-loader'],
      },
        {
          test: /\.css$/i,
          use: ["style-loader", "css-loader"]
        },
        {
          test: /\.(png|svg|jpg|jpeg|gif)$/i,
          type: 'asset/inline',
        },
    ],
  },
  resolve: {
    extensions: ['*', '.js', '.jsx'],
  },
  mode: 'production',
  devtool: 'source-map',
  optimization: {
     minimize: true
  },
  output: {

    path: path.resolve(__dirname, '../..'),
    filename: 'iccbmlib-min.js',
    library: "iccbmlib"
  },
  
};

