module(..., package.seeall)


local mySql = mySql or {}

mySql.makeConnectionData = function(datasource)
	local connectionData = {
		{ Driver = "/usr/lib/inconcert_odbc/libmyodbc.so" },
		{ MULTI_HOST = 1 },
		{ Server = datasource.Server },
		{ Uid = datasource.Username },
		{ Pwd = datasource.Password },
		{ Database = datasource.Database }
	}
	if datasource.Port then
		table.insert(connectionData, { Port = datasource.Port })
	end
	return connectionData
end

mySql.escapeValue = function(value)
	local dataType = type(value)
	if dataType == "string" then
		value = value:gsub("'", "\\'")
	end
	return value
end

function Init()
	return mySql
end